!***************************************************************************************************
! Copyright 1987, D. Bilitza, 2007 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE IGRF(XXX,YYY,ZZZ,BXXX,BYYY,BZZZ)           
C-------------------------------------------------------------------
C CALCULATES EARTH MAGNETIC FIELD FROM SPHERICAL HARMONICS MODEL
C REF: G. KLUGE, EUROPEAN SPACE OPERATIONS CENTRE, INTERNAL NOTE 61, 
C      1970.
C--------------------------------------------------------------------
C CHANGES (D. BILITZA, NOV 87):
C   - FIELD COEFFICIENTS IN BINARY DATA FILES INSTEAD OF BLOCK DATA
C   - CALCULATES DIPOL MOMENT
C--------------------------------------------------------------------
C  INPUT:  ENTRY POINT FELDG
C	 	GLAT  GEODETIC LATITUDE IN DEGREES (NORTH)
C         	GLON  GEODETIC LONGITUDE IN DEGREES (EAST)
C         	ALT   ALTITUDE IN KM ABOVE SEA LEVEL
C
C	   ENTRY POINT FELDC
C		V(3)  CARTESIAN COORDINATES IN EARTH RADII (6371.2 KM)
C			X-AXIS POINTING TO EQUATOR AT 0 LONGITUDE
C			Y-AXIS POINTING TO EQUATOR AT 90 LONG.
C			Z-AXIS POINTING TO NORTH POLE
C
C	   COMMON BLANK AND ENTRY POINT FELDI ARE NEEDED WHEN USED
C	     IN CONNECTION WITH L-CALCULATION PROGRAM SHELLG.
C	
C	   COMMON /MODEL/ AND /GENER/
C		UMR     = ATAN(1.0)*4./180.   <DEGREE>*UMR=<RADIANT>
C		ERA	EARTH RADIUS FOR NORMALIZATION OF CARTESIAN 
C			COORDINATES (6371.2 KM)
C		AQUAD, BQUAD   SQUARE OF MAJOR AND MINOR HALF AXIS FOR 
C			EARTH ELLIPSOID AS RECOMMENDED BY INTERNATIONAL 
C			ASTRONOMICAL UNION (6378.160, 6356.775 KM).
C		NMAX    MAXIMUM ORDER OF SPHERICAL HARMONICS
C		TIME	YEAR (DECIMAL: 1973.5) FOR WHICH MAGNETIC 
C			FIELD IS TO BE CALCULATED
C		G(M)	NORMALIZED FIELD COEFFICIENTS (SEE FELDCOF)
C			M=NMAX*(NMAX+2)
C------------------------------------------------------------------------
C  OUTPUT: BABS   MAGNETIC FIELD STRENGTH IN GAUSS
C	   BNORTH, BEAST, BDOWN   COMPONENTS OF THE FIELD WITH RESPECT
C		  TO THE LOCAL GEODETIC COORDINATE SYSTEM, WITH AXIS
C		  POINTING IN THE TANGENTIAL PLANE TO THE NORTH, EAST
C		  AND DOWNWARD.   
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER*4         NMAX,IHMAX,LAST,I,K,IH,M,IMAX,IL
      REAL*8            XXX,YYY,ZZZ
      REAL*8            BXXX,BYYY,BZZZ
      REAL*8            F,RQ,X,Y,Z,S,T
      REAL*8  		XI(3),H(144)
      REAL*8            G(144)
      COMMON/MODEL/	G  
C
C-- IS RECORDS ENTRY POINT
C
C*****ENTRY POINT  FELDG  TO BE USED WITH GEODETIC CO-ORDINATES         
      RQ=1.D0/(XXX*XXX+YYY*YYY+ZZZ*ZZZ) 
      XI(1)=XXX*RQ                                                      
      XI(2)=YYY*RQ                                                      
      XI(3)=ZZZ*RQ
C
      NMAX = 10                                                      
      IHMAX=NMAX*NMAX+1                                                 
      LAST=IHMAX+NMAX+NMAX                                              
      IMAX=NMAX+NMAX-1                                                  
      DO 8 I=IHMAX,LAST                                                 
8     H(I)=G(I)                                                         
      DO 6 K=1,3,2                                                      
      I=IMAX                                                            
      IH=IHMAX                                                          
1     IL=IH-I                                                           
      F=2.D0/((I-K+2)*1.D0)                                                 
      X=XI(1)*F                                                         
      Y=XI(2)*F                                                         
      Z=XI(3)*(F+F)                                                     
      I=I-2                                                             
      IF(I-1)5,4,2                                                      
2     DO 3 M=3,I,2                                                      
      H(IL+M+1)=G(IL+M+1)+Z*H(IH+M+1)+X*(H(IH+M+3)-H(IH+M-1))           
     A                               -Y*(H(IH+M+2)+H(IH+M-2))           
3     H(IL+M)=G(IL+M)+Z*H(IH+M)+X*(H(IH+M+2)-H(IH+M-2))                 
     A                         +Y*(H(IH+M+3)+H(IH+M-1))                 
4     H(IL+2)=G(IL+2)+Z*H(IH+2)+X*H(IH+4)-Y*(H(IH+3)+H(IH))             
      H(IL+1)=G(IL+1)+Z*H(IH+1)+Y*H(IH+4)+X*(H(IH+3)-H(IH))             
5     H(IL)=G(IL)+Z*H(IH)+2.*(X*H(IH+1)+Y*H(IH+2))                      
      IH=IL                                                             
      IF(I.GE.K)GOTO1                                                   
6     CONTINUE                                                          
      S=.5D0*H(1)+2.D0*(H(2)*XI(3)+H(3)*XI(1)+H(4)*XI(2))                   
      T=(RQ+RQ)*SQRT(RQ)                                                
      BXXX=T*(H(3)-S*XXX)                                               
      BYYY=T*(H(4)-S*YYY)                                               
      BZZZ=T*(H(2)-S*ZZZ)                                               
      RETURN                                                            
      END                                                               
C

!***************************************************************************************************
! Copyright 2007,2009 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
!***************************************************************************************************
! CREATION: S. Bourdarie - ONERA-DESP
!
! FILE CONTENT:
!               SUBROUTINE coord_trans1: Generic coordinate transformation from one Earth or Heliospheric coordinate
!                                        system to another one
!               SUBROUTINE coord_trans_vec1: Generic coordinate transformation from one Earth or Heliospheric coordinate
!                                        system to another one (handle up to
!                                        ntime_max positions)
!
!***************************************************************************************************
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE PNM80
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009. Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C  Form the matrix of precession/nutation for a given date, IAU 1976
C  precession model, IAU 1980 nutation model.
C
C The matrix operates in the sense V(date) = RMATPN * V(J2000),
C     where the p-vector V(date) is with respect to the true
C     equatorial triad of date DATE1+DATE2 and the p-vector
C     V(J2000) is with respect to the mean equatorial triad of
C     epoch J2000.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PNM80 ( DATE1, DATE2, RMATPN )

      IMPLICIT NONE

      REAL*8 DATE1, DATE2, RMATPN(3,3)
      REAL*8 RMATP(3,3), RMATN(3,3)

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Precession matrix, J2000 to date.
      CALL PMAT76 ( DATE1, DATE2, RMATP )

*  Nutation matrix.
      CALL NUTM80 ( DATE1, DATE2, RMATN )

*  Combine the matrices:  PN = N x P.
      CALL RXR ( RMATN, RMATP, RMATPN )

      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE PMAT76
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C  Precession matrix from J2000 to a specified date, IAU 1976 model.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PMAT76 ( DATE1, DATE2, RMATP )

      IMPLICIT NONE

      DOUBLE PRECISION DATE1, DATE2, RMATP(3,3)

*  Reference epoch (J2000), JD
      REAL*8 DJ00
      PARAMETER ( DJ00 = 2451545D0 )

      REAL*8 ZETA, Z, THETA, WMAT(3,3)

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Precession Euler angles, J2000 to specified date.
      CALL PREC76 ( DJ00, 0D0, DATE1, DATE2, ZETA, Z, THETA )

*  Form the rotation matrix.
      CALL IR ( WMAT )
      CALL RZ ( -ZETA, WMAT )
      CALL RY ( THETA, WMAT )
      CALL RZ ( -Z, WMAT )
      CALL CR ( WMAT, RMATP )


      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE IR
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 and
C     INTEGER by INTEGER*4 by S. Bourdarie
C
C  Initialize an r-matrix to the identity matrix.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE IR ( R )
      IMPLICIT NONE

      REAL*8 R(3,3)

      INTEGER*4 I

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      CALL ZR ( R )
      DO 1 I=1,3
         R(I,I) = 1D0
 1    CONTINUE
      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE ZR
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 and
C     INTEGER by INTEGER*4 by S. Bourdarie
C
C  Initialize an r-matrix to the null matrix.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ZR ( R )
      IMPLICIT NONE

      REAL*8  R(3,3)

      INTEGER*4 I, J

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      DO 2 J=1,3
         DO 1 I=1,3
            R(I,J) = 0.D0
 1       CONTINUE
 2    CONTINUE
      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE RZ
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
CRotate an r-matrix about the z-axis.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RZ ( PSI, R )
      IMPLICIT NONE

      REAL*8 PSI, R(3,3)

      REAL*8 S, C, A(3,3), W(3,3)

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Matrix representing new rotation.
      S = SIN(PSI)
      C = COS(PSI)
      CALL IR ( A )
      A(1,1) = C
      A(2,1) = -S
      A(1,2) = S
      A(2,2) = C

*  Rotate.
      CALL RXR ( A, R, W )

*  Return result.
      CALL CR ( W, R )
      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE RY
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C  Rotate an r-matrix about the y-axis.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RY ( THETA, R )

      IMPLICIT NONE
      REAL*8 THETA, R(3,3)

      REAL*8 S, C, A(3,3), W(3,3)

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Matrix representing new rotation.
      S = SIN(THETA)
      C = COS(THETA)
      CALL IR ( A )
      A(1,1) = C
      A(3,1) = S
      A(1,3) = -S
      A(3,3) = C

*  Rotate.
      CALL RXR ( A, R, W )

*  Return result.
      CALL CR ( W, R )
      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE RY
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C  Rotate an r-matrix about the x-axis.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RX ( PHI, R )
      IMPLICIT NONE

      REAL*8 PHI, R(3,3)

      REAL*8 S, C, A(3,3), W(3,3)

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Matrix representing new rotation.
      S = SIN(PHI)
      C = COS(PHI)
      CALL IR ( A )
      A(2,2) = C
      A(3,2) = -S
      A(2,3) = S
      A(3,3) = C

*  Rotate.
      CALL RXR ( A, R, W )

*  Return result.
      CALL CR ( W, R )

      end


C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE RXR
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C     Multiply two r-matrices.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RXR ( A, B, ATB )
      IMPLICIT NONE

      REAL*8 A(3,3), B(3,3), ATB(3,3)

      INTEGER*4 I, J, K
      REAL*8 W, WM(3,3)

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      DO 3 I=1,3
         DO 2 J=1,3
            W = 0D0
            DO 1 K=1,3
               W = W + A(I,K)*B(K,J)
 1          CONTINUE
            WM(I,J) = W
 2       CONTINUE
 3    CONTINUE
      CALL CR ( WM, ATB )
      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE CR
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The changes to original routine are:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C     Subroutine CR and CP have been combined together
C
C     Copy an r-matrix.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CR ( R, C )
      IMPLICIT NONE

      REAL*8 R(3,3), C(3,3)

      INTEGER*4 I,J

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      DO 1 I=1,3
         DO J=1,3
           C(I,J)=R(I,J)
         ENDDO
 1    CONTINUE
      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE PREC76
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PREC76 ( EP01, EP02, EP11, EP12, ZETA, Z, THETA )
*+
*-----------------------------------------------------------------------

      IMPLICIT NONE

      REAL*8 EP01, EP02, EP11, EP12, ZETA, Z, THETA

*  Arcseconds to radians
      REAL*8 DAS2R
      PARAMETER ( DAS2R = 4.848136811095359935899141D-6 )

*  Reference epoch (J2000), JD
      REAL*8 DJ00
      PARAMETER ( DJ00 = 2451545D0 )

*  Days per Julian century
      REAL*8 DJC
      PARAMETER ( DJC = 36525D0 )

      REAL*8 T0, T, TAS2R, W


*  Interval between fundamental epoch J2000.0 and beginning epoch (JC).
      T0 = ( ( EP01-DJ00 ) + EP02 ) / DJC

*  Interval over which precession required (JC).
      T = ( ( EP11-EP01 ) + ( EP12-EP02 ) ) / DJC

*  Euler angles.
      TAS2R = T * DAS2R
      W = 2306.2181D0 + (
     :       1.39656D0
     :     - 0.000139D0 * T0 ) * T0

      ZETA = ( W + ( ( 0.30188D0
     :               - 0.000344D0 * T0 )
     :               + 0.017998D0 * T ) * T ) * TAS2R

      Z = ( W + ( ( 1.09468D0
     :            + 0.000066D0 * T0 )
     :            + 0.018203D0 * T ) * T ) * TAS2R

      THETA = ( ( 2004.3109D0 + (
     :             - 0.85330D0
     :             - 0.000217D0 * T0 ) * T0 ) + ( (
     :             - 0.42665D0
     :             - 0.000217D0 * T0 )
     :             - 0.041833D0 * T ) * T ) * TAS2R
      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE NUTM80
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C   Form the matrix of nutation for a given date, IAU 1980 model.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUTM80 ( DATE1, DATE2, RMATN )

      IMPLICIT NONE

      REAL*8 DATE1, DATE2, RMATN(3,3)

      REAL*8 DPSI, DEPS, EPSA
      REAL*8 OBL80

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Nutation components and mean obliquity.
      CALL NUT80 ( DATE1, DATE2, DPSI, DEPS )
      EPSA = OBL80 ( DATE1, DATE2 )

*  Build the rotation matrix.
      CALL NUMAT ( EPSA, DPSI, DEPS, RMATN )

      end
c
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE NUTM80
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C     Nutation, IAU 1980 model.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUT80 ( DATE1, DATE2, DPSI, DEPS )
      IMPLICIT NONE

      real*8 DATE1, DATE2, DPSI, DEPS

*  Arcseconds to radians
      real*8 DAS2R
      PARAMETER ( DAS2R = 4.848136811095359935899141D-6 )

*  2Pi
      real*8 D2PI
      PARAMETER ( D2PI = 6.283185307179586476925287D0 )

*  Units of 0.1 milliarcsecond to radians
      real*8 U2R
      PARAMETER ( U2R = DAS2R/1D4 )

*  Reference epoch (J2000), JD
      real*8 DJ00
      PARAMETER ( DJ00 = 2451545D0 )

*  Days per Julian century
      real*8 DJC
      PARAMETER ( DJC = 36525D0 )

      real*8 T, EL, ELP, F, D, OM, DP, DE, ARG, S, C
      INTEGER*4 I, J

      real*8 ANPM


*  ------------------------------------------------
*  Table of multiples of arguments and coefficients
*  ------------------------------------------------
*
*  The coefficient values are in 0.1 mas units and the rates of change
*  are in mas per Julian millennium.

      REAL X(9,106)

*                Multiple of            Longitude        Obliquity
*           L    L'   F    D  Omega   coeff. of sin    coeff. of cos
*                                         1       t        1     t

      DATA ((X(I,J),I=1,9),J=1,10) /
     :      0.,  0.,  0.,  0.,  1., -171996., -1742.,  92025.,  89.,
     :      0.,  0.,  0.,  0.,  2.,    2062.,     2.,   -895.,   5.,
     :     -2.,  0.,  2.,  0.,  1.,      46.,     0.,    -24.,   0.,
     :      2.,  0., -2.,  0.,  0.,      11.,     0.,      0.,   0.,
     :     -2.,  0.,  2.,  0.,  2.,      -3.,     0.,      1.,   0.,
     :      1., -1.,  0., -1.,  0.,      -3.,     0.,      0.,   0.,
     :      0., -2.,  2., -2.,  1.,      -2.,     0.,      1.,   0.,
     :      2.,  0., -2.,  0.,  1.,       1.,     0.,      0.,   0.,
     :      0.,  0.,  2., -2.,  2.,  -13187.,   -16.,   5736., -31.,
     :      0.,  1.,  0.,  0.,  0.,    1426.,   -34.,     54.,  -1. /
      DATA ((X(I,J),I=1,9),J=11,20) /
     :      0.,  1.,  2., -2.,  2.,    -517.,    12.,    224.,  -6.,
     :      0., -1.,  2., -2.,  2.,     217.,    -5.,    -95.,   3.,
     :      0.,  0.,  2., -2.,  1.,     129.,     1.,    -70.,   0.,
     :      2.,  0.,  0., -2.,  0.,      48.,     0.,      1.,   0.,
     :      0.,  0.,  2., -2.,  0.,     -22.,     0.,      0.,   0.,
     :      0.,  2.,  0.,  0.,  0.,      17.,    -1.,      0.,   0.,
     :      0.,  1.,  0.,  0.,  1.,     -15.,     0.,      9.,   0.,
     :      0.,  2.,  2., -2.,  2.,     -16.,     1.,      7.,   0.,
     :      0., -1.,  0.,  0.,  1.,     -12.,     0.,      6.,   0.,
     :     -2.,  0.,  0.,  2.,  1.,      -6.,     0.,      3.,   0. /
      DATA ((X(I,J),I=1,9),J=21,30) /
     :      0., -1.,  2., -2.,  1.,      -5.,     0.,      3.,   0.,
     :      2.,  0.,  0., -2.,  1.,       4.,     0.,     -2.,   0.,
     :      0.,  1.,  2., -2.,  1.,       4.,     0.,     -2.,   0.,
     :      1.,  0.,  0., -1.,  0.,      -4.,     0.,      0.,   0.,
     :      2.,  1.,  0., -2.,  0.,       1.,     0.,      0.,   0.,
     :      0.,  0., -2.,  2.,  1.,       1.,     0.,      0.,   0.,
     :      0.,  1., -2.,  2.,  0.,      -1.,     0.,      0.,   0.,
     :      0.,  1.,  0.,  0.,  2.,       1.,     0.,      0.,   0.,
     :     -1.,  0.,  0.,  1.,  1.,       1.,     0.,      0.,   0.,
     :      0.,  1.,  2., -2.,  0.,      -1.,     0.,      0.,   0. /
      DATA ((X(I,J),I=1,9),J=31,40) /
     :      0.,  0.,  2.,  0.,  2.,   -2274.,    -2.,    977.,  -5.,
     :      1.,  0.,  0.,  0.,  0.,     712.,     1.,     -7.,   0.,
     :      0.,  0.,  2.,  0.,  1.,    -386.,    -4.,    200.,   0.,
     :      1.,  0.,  2.,  0.,  2.,    -301.,     0.,    129.,  -1.,
     :      1.,  0.,  0., -2.,  0.,    -158.,     0.,     -1.,   0.,
     :     -1.,  0.,  2.,  0.,  2.,     123.,     0.,    -53.,   0.,
     :      0.,  0.,  0.,  2.,  0.,      63.,     0.,     -2.,   0.,
     :      1.,  0.,  0.,  0.,  1.,      63.,     1.,    -33.,   0.,
     :     -1.,  0.,  0.,  0.,  1.,     -58.,    -1.,     32.,   0.,
     :     -1.,  0.,  2.,  2.,  2.,     -59.,     0.,     26.,   0./
      DATA ((X(I,J),I=1,9),J=41,50) /
     :      1.,  0.,  2.,  0.,  1.,     -51.,     0.,     27.,   0.,
     :      0.,  0.,  2.,  2.,  2.,     -38.,     0.,     16.,   0.,
     :      2.,  0.,  0.,  0.,  0.,      29.,     0.,     -1.,   0.,
     :      1.,  0.,  2., -2.,  2.,      29.,     0.,    -12.,   0.,
     :      2.,  0.,  2.,  0.,  2.,     -31.,     0.,     13.,   0.,
     :      0.,  0.,  2.,  0.,  0.,      26.,     0.,     -1.,   0.,
     :     -1.,  0.,  2.,  0.,  1.,      21.,     0.,    -10.,   0.,
     :     -1.,  0.,  0.,  2.,  1.,      16.,     0.,     -8.,   0.,
     :      1.,  0.,  0., -2.,  1.,     -13.,     0.,      7.,   0.,
     :     -1.,  0.,  2.,  2.,  1.,     -10.,     0.,      5.,   0. /
      DATA ((X(I,J),I=1,9),J=51,60) /
     :      1.,  1.,  0., -2.,  0.,      -7.,     0.,      0.,   0.,
     :      0.,  1.,  2.,  0.,  2.,       7.,     0.,     -3.,   0.,
     :      0., -1.,  2.,  0.,  2.,      -7.,     0.,      3.,   0.,
     :      1.,  0.,  2.,  2.,  2.,      -8.,     0.,      3.,   0.,
     :      1.,  0.,  0.,  2.,  0.,       6.,     0.,      0.,   0.,
     :      2.,  0.,  2., -2.,  2.,       6.,     0.,     -3.,   0.,
     :      0.,  0.,  0.,  2.,  1.,      -6.,     0.,      3.,   0.,
     :      0.,  0.,  2.,  2.,  1.,      -7.,     0.,      3.,   0.,
     :      1.,  0.,  2., -2.,  1.,       6.,     0.,     -3.,   0.,
     :      0.,  0.,  0., -2.,  1.,      -5.,     0.,      3.,   0. /
      DATA ((X(I,J),I=1,9),J=61,70) /
     :      1., -1.,  0.,  0.,  0.,       5.,     0.,      0.,   0.,
     :      2.,  0.,  2.,  0.,  1.,      -5.,     0.,      3.,   0.,
     :      0.,  1.,  0., -2.,  0.,      -4.,     0.,      0.,   0.,
     :      1.,  0., -2.,  0.,  0.,       4.,     0.,      0.,   0.,
     :      0.,  0.,  0.,  1.,  0.,      -4.,     0.,      0.,   0.,
     :      1.,  1.,  0.,  0.,  0.,      -3.,     0.,      0.,   0.,
     :      1.,  0.,  2.,  0.,  0.,       3.,     0.,      0.,   0.,
     :      1., -1.,  2.,  0.,  2.,      -3.,     0.,      1.,   0.,
     :     -1., -1.,  2.,  2.,  2.,      -3.,     0.,      1.,   0.,
     :     -2.,  0.,  0.,  0.,  1.,      -2.,     0.,      1.,   0. /
      DATA ((X(I,J),I=1,9),J=71,80) /
     :      3.,  0.,  2.,  0.,  2.,      -3.,     0.,      1.,   0.,
     :      0., -1.,  2.,  2.,  2.,      -3.,     0.,      1.,   0.,
     :      1.,  1.,  2.,  0.,  2.,       2.,     0.,     -1.,   0.,
     :     -1.,  0.,  2., -2.,  1.,      -2.,     0.,      1.,   0.,
     :      2.,  0.,  0.,  0.,  1.,       2.,     0.,     -1.,   0.,
     :      1.,  0.,  0.,  0.,  2.,      -2.,     0.,      1.,   0.,
     :      3.,  0.,  0.,  0.,  0.,       2.,     0.,      0.,   0.,
     :      0.,  0.,  2.,  1.,  2.,       2.,     0.,     -1.,   0.,
     :     -1.,  0.,  0.,  0.,  2.,       1.,     0.,     -1.,   0.,
     :      1.,  0.,  0., -4.,  0.,      -1.,     0.,      0.,   0. /
      DATA ((X(I,J),I=1,9),J=81,90) /
     :     -2.,  0.,  2.,  2.,  2.,       1.,     0.,     -1.,   0.,
     :     -1.,  0.,  2.,  4.,  2.,      -2.,     0.,      1.,   0.,
     :      2.,  0.,  0., -4.,  0.,      -1.,     0.,      0.,   0.,
     :      1.,  1.,  2., -2.,  2.,       1.,     0.,     -1.,   0.,
     :      1.,  0.,  2.,  2.,  1.,      -1.,     0.,      1.,   0.,
     :     -2.,  0.,  2.,  4.,  2.,      -1.,     0.,      1.,   0.,
     :     -1.,  0.,  4.,  0.,  2.,       1.,     0.,      0.,   0.,
     :      1., -1.,  0., -2.,  0.,       1.,     0.,      0.,   0.,
     :      2.,  0.,  2., -2.,  1.,       1.,     0.,     -1.,   0.,
     :      2.,  0.,  2.,  2.,  2.,      -1.,     0.,      0.,   0. /
      DATA ((X(I,J),I=1,9),J=91,100) /
     :      1.,  0.,  0.,  2.,  1.,      -1.,     0.,      0.,   0.,
     :      0.,  0.,  4., -2.,  2.,       1.,     0.,      0.,   0.,
     :      3.,  0.,  2., -2.,  2.,       1.,     0.,      0.,   0.,
     :      1.,  0.,  2., -2.,  0.,      -1.,     0.,      0.,   0.,
     :      0.,  1.,  2.,  0.,  1.,       1.,     0.,      0.,   0.,
     :     -1., -1.,  0.,  2.,  1.,       1.,     0.,      0.,   0.,
     :      0.,  0., -2.,  0.,  1.,      -1.,     0.,      0.,   0.,
     :      0.,  0.,  2., -1.,  2.,      -1.,     0.,      0.,   0.,
     :      0.,  1.,  0.,  2.,  0.,      -1.,     0.,      0.,   0.,
     :      1.,  0., -2., -2.,  0.,      -1.,     0.,      0.,   0. /
      DATA ((X(I,J),I=1,9),J=101,106) /
     :      0., -1.,  2.,  0.,  1.,      -1.,     0.,      0.,   0.,
     :      1.,  1.,  0., -2.,  1.,      -1.,     0.,      0.,   0.,
     :      1.,  0., -2.,  2.,  0.,      -1.,     0.,      0.,   0.,
     :      2.,  0.,  0.,  2.,  0.,       1.,     0.,      0.,   0.,
     :      0.,  0.,  2.,  4.,  2.,      -1.,     0.,      0.,   0.,
     :      0.,  1.,  0.,  1.,  0.,       1.,     0.,      0.,   0. /

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Interval between fundamental epoch J2000.0 and given date (JC).
      T = ( ( DATE1-DJ00 ) + DATE2 ) / DJC

*
*  FUNDAMENTAL ARGUMENTS in the FK5 reference system
*

*  Mean longitude of the Moon minus mean longitude of the Moon's
*  perigee.
      EL = ANPM ( ( 485866.733D0 + ( 715922.633D0 +
     :                  ( 31.310D0 + 0.064D0 * T ) * T ) * T ) * DAS2R
     :                + MOD(1325D0*T, 1D0) * D2PI )

*  Mean longitude of the Sun minus mean longitude of the Sun's perigee.
      ELP = ANPM ( ( 1287099.804D0 + ( 1292581.224D0 +
     :                   ( -0.577D0 -0.012D0 * T ) * T ) * T ) * DAS2R
     :                 + MOD(99D0*T, 1D0) * D2PI )

*  Mean longitude of the Moon minus mean longitude of the Moon's node.
      F = ANPM ( ( 335778.877D0 + ( 295263.137D0 +
     :                 ( -13.257D0 + 0.011D0 * T ) * T ) * T ) * DAS2R
     :               + MOD(1342D0*T, 1D0) * D2PI )

*  Mean elongation of the Moon from the Sun.
      D = ANPM ( ( 1072261.307D0 + ( 1105601.328D0 +
     :                 ( -6.891D0 + 0.019D0 * T ) * T ) * T ) * DAS2R
     :               + MOD(1236D0*T, 1D0) * D2PI )

*  Longitude of the mean ascending node of the lunar orbit on the
*  ecliptic, measured from the mean equinox of date.
      OM = ANPM( ( 450160.280D0 + ( -482890.539D0 +
     :                 ( 7.455D0 + 0.008D0 * T ) * T ) * T ) * DAS2R
     :               + MOD( -5D0*T, 1D0) * D2PI )

*  ---------------
*  Nutation series
*  ---------------

*  Change time argument from centuries to millennia.
      T = T / 10D0

*  Initialize nutation components.
      DP = 0D0
      DE = 0D0

*  Sum the nutation terms, ending with the biggest.
      DO 1 J=106,1,-1

*     Form argument for current term.
         ARG = DBLE(X(1,J)) * EL
     :       + DBLE(X(2,J)) * ELP
     :       + DBLE(X(3,J)) * F
     :       + DBLE(X(4,J)) * D
     :       + DBLE(X(5,J)) * OM

*     Accumulate current nutation term.
         S = DBLE(X(6,J)) + DBLE(X(7,J)) * T
         C = DBLE(X(8,J)) + DBLE(X(9,J)) * T
         IF ( S .NE. 0D0 ) DP = DP + S * SIN(ARG)
         IF ( C .NE. 0D0 ) DE = DE + C * COS(ARG)

*     Next term.
 1    CONTINUE

*  Convert results from 0.1 mas units to radians.
      DPSI = DP * U2R
      DEPS = DE * U2R

      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Function ANPM
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C     Normalize angle into the range -pi <= A < +pi.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 FUNCTION ANPM ( A )
      IMPLICIT NONE

      REAL*8 A

*  Pi
      REAL*8 DPI
      PARAMETER ( DPI = 3.141592653589793238462643D0 )

*  2Pi
      REAL*8 D2PI
      PARAMETER ( D2PI = 6.283185307179586476925287D0 )

      REAL*8 W

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      W = MOD(A,D2PI)
      IF ( ABS(W) .GE. DPI ) W = W - SIGN(D2PI,A)
      ANPM = W

      END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Function OBL80
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C     Mean obliquity of the ecliptic, IAU 1980 model.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 FUNCTION OBL80 ( DATE1, DATE2 )

      IMPLICIT NONE

      DOUBLE PRECISION DATE1, DATE2

*  Arcseconds to radians
      REAL*8 DAS2R
      PARAMETER ( DAS2R = 4.848136811095359935899141D-6 )

*  Reference epoch (J2000), JD
      REAL*8 DJ00
      PARAMETER ( DJ00 = 2451545D0 )

*  Days per Julian century
      REAL*8 DJC
      PARAMETER ( DJC = 36525D0 )

      REAL*8 T

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Interval between fundamental epoch J2000.0 and given date (JC).
      T = ( ( DATE1-DJ00 ) + DATE2 ) / DJC

*  Mean obliquity of date.
      OBL80 = DAS2R * ( 84381.448D0 +
     :                      ( -46.8150D0 +
     :                       ( -0.00059D0 +
     :                          0.001813D0 * T ) * T ) * T )

      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Subroutine NUMAT
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The only change to original routine is:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C
C     Form the matrix of nutation.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUMAT ( EPSA, DPSI, DEPS, RMATN )

      IMPLICIT NONE

      REAL*8 EPSA, DPSI, DEPS, RMATN(3,3)

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Build the rotation matrix.
      CALL IR ( RMATN )
      CALL RX ( EPSA, RMATN )
      CALL RZ ( -DPSI, RMATN )
      CALL RX ( -(EPSA+DEPS), RMATN )

      end


C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Function EQEQ94
C      This routine has been extracted from the SOFA software
C      (Standards of Fundamental Astronomy, http://www.iau-sofa.rl.ac.uk/ ).
C      by S. Bourdarie in July 2009.Therefore it does not itself
*        constitute software provided by and/or endorsed by SOFA.
C
C      The changes to original routine are:
C     DOUBLE PRECISION changed to REAL*8 by S. Bourdarie
C     Routine ANP has been included in this one by S. Bourdarie
C
C  Equation of the equinoxes, IAU 1994 model.
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 FUNCTION EQEQ94 ( DATE1, DATE2 )

      IMPLICIT NONE

      REAL*8 DATE1, DATE2

*  Arcseconds to radians
      REAL*8 DAS2R
      PARAMETER ( DAS2R = 4.848136811095359935899141D-6 )

*  2Pi
      REAL*8 D2PI
      PARAMETER (D2PI = 6.283185307179586476925287D0)

*  Reference epoch (J2000), JD
      REAL*8 DJ00
      PARAMETER ( DJ00 = 2451545D0 )

*  Days per Julian century
      REAL*8 DJC
      PARAMETER ( DJC = 36525D0 )

      REAL*8 T, OM, DPSI, DEPS, EPS0
      REAL*8 ANPM, OBL80
      REAL*8 W

* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*  Interval between fundamental epoch J2000.0 and given date (JC).
      T = ( ( DATE1-DJ00 ) + DATE2 ) / DJC

*  Longitude of the mean ascending node of the lunar orbit on the
*  ecliptic, measured from the mean equinox of date.
      OM = ANPM( ( 450160.280D0 + ( -482890.539D0 +
     :                 ( 7.455D0 + 0.008D0 * T ) * T ) * T ) * DAS2R
     :               + MOD(-5D0*T,1D0) * D2PI )

*  Nutation components and mean obliquity.
      CALL NUT80 ( DATE1, DATE2, DPSI, DEPS )
      EPS0 = OBL80 ( DATE1, DATE2 )

*  Equation of the equinoxes.
      EQEQ94 = DPSI * COS(EPS0) + DAS2R * ( 0.00264D0 * SIN(OM) +
     :                                          0.000063D0 * SIN(OM+OM))
* Normalize angle into the range 0 <= A < 2pi.
      W = MOD(EQEQ94,D2PI)
      IF ( W .LT. 0.D0 ) W = W + D2PI
      EQEQ94 = W

      end

!---------------------------------------------------------------------------------------------------
!                              Introduced in version 4....
!
! CREATION: S. Bourdarie - July 2009
! MODIFICATION: None
!
! DESCRIPTION: Compute the dates following the J2000 method.
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!
! OUTPUT: datE1, date2 -> julday
!
! CALLING SEQUENCE: call date2dateJ2000(iyr,idoy,UT,date1,date2)
!---------------------------------------------------------------------------------------------------
      SUBROUTINE date2dateJ2000(iyr,idoy,UT,date1,date2)
      IMPLICIT NONE
c
c     input variables
      INTEGER*4 iyr,idoy
      REAL*8 UT
c
c     internal variables
      REAL*8 DJ00
      PARAMETER ( DJ00 = 2451545D0 )
      INTEGER*4 Month, Day,hour, minute, second,julday,jd
      REAL*8 eps,eps2
c
c     Output variables
      REAL*8 DATE1,DATE2

c -------------------------------------------------------------------
c     Compute the dates following J2000 method
      DATE1=DJ00   ! julday for 1st january 2000 at 12 UT (J2000 method)
      call DOY_AND_UT2DATE_AND_TIME(iyr,idoy,UT, Month, Day,
     &            hour, minute, second)

      jd=JULDAY(iyr,month,day)

      eps=2.2204460d-16
      eps2 = eps*ABS(jd)
      if (eps2 .gt. eps) eps=eps2
      DATE2 = dble(jd) + ( (Hour/24.d0 - 0.5d0) +
     &        (UT-hour*3600.d0)/86400.d0 + eps )-DATE1  !(J2000 method)
c
      end


!---------------------------------------------------------------------------------------------------
!                              Introduced in version 4....
!
! CREATION: S. Bourdarie - July 2009
! MODIFICATION: None
!
! DESCRIPTION: Rotates coordinates from ECI J2000 to ECI true of date
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xIN -> position in ECI J2000 system (double array(3))
!
! OUTPUT: xOUT -> position in ECI True of Date (TOD) system (double array(3))
!
! CALLING SEQUENCE: call ECIJ2000_2_ECITOD(iyr,idoy,UT,xIN,xOUT)
!---------------------------------------------------------------------------------------------------
      SUBROUTINE ECIJ2000_2_ECITOD(iyr,idoy,UT,xIN,xOUT)
c
      IMPLICIT NONE
c
c     input variables
      INTEGER*4 iyr,idoy
      REAL*8 UT,xIN(3)
c
c     internal variables
      REAL*8 RMATPN(3,3)
      REAL*8 DATE1,DATE2

c     Output variables
      REAL*8 xOUT(3)

c     Compute the dates following J2000 method
      call date2dateJ2000(iyr,idoy,UT,date1,date2)
c  Form the matrix of precession/nutation for a given date, IAU 1976
c  precession model, IAU 1980 nutation model.
      call PNM80 ( DATE1, DATE2, RMATPN)


c  Rotate input coordinates to outputs
      xOUT(1)=RMATPN(1,1)*xIN(1)+RMATPN(1,2)*xIN(2)+RMATPN(1,3)*xIN(3)
      xOUT(2)=RMATPN(2,1)*xIN(1)+RMATPN(2,2)*xIN(2)+RMATPN(2,3)*xIN(3)
      xOUT(3)=RMATPN(3,1)*xIN(1)+RMATPN(3,2)*xIN(2)+RMATPN(3,3)*xIN(3)
      end

!---------------------------------------------------------------------------------------------------
!                              Introduced in version 4....
!
! CREATION: S. Bourdarie - July 2009
! MODIFICATION: None
!
! DESCRIPTION: Rotates coordinates from ECI true of date to ECI J2000
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xIN -> position in ECI True of Date (TOD) system (double array(3))
!
! OUTPUT: xOUT -> position in ECI J2000 system (double array(3))
!
! CALLING SEQUENCE: call ECITOD_2_ECIJ2000(iyr,idoy,UT,xIN,xOUT)
!---------------------------------------------------------------------------------------------------
      SUBROUTINE ECITOD_2_ECIJ2000(iyr,idoy,UT,xIN,xOUT)
c
      IMPLICIT NONE
c
c     input variables
      INTEGER*4 iyr,idoy
      REAL*8 UT,xIN(3)
c
c     internal variables
      REAL*8 RMATPN(3,3),invRMATPN(3,3),det
      REAL*8 DATE1,DATE2
c
c     Output variables
      REAL*8 xOUT(3)

c     Compute the dates following J2000 method
      call date2dateJ2000(iyr,idoy,UT,date1,date2)
c  Form the matrix of precession/nutation for a given date, IAU 1976
c  precession model, IAU 1980 nutation model.
      call PNM80 ( DATE1, DATE2, RMATPN)

c
c      invert RMATPN matrix
      det=RMATPN(1,1)*(RMATPN(2,2)*RMATPN(3,3)-RMATPN(2,3)*RMATPN(3,2))
     &   +RMATPN(1,2)*(RMATPN(2,1)*RMATPN(3,3)-RMATPN(2,3)*RMATPN(3,1))
     &   +RMATPN(1,3)*(RMATPN(2,1)*RMATPN(3,2)-RMATPN(2,2)*RMATPN(3,1))

      invRMATPN(1,1)=(RMATPN(2,2)*RMATPN(3,3)-RMATPN(2,3)*RMATPN(3,2))
     & /det
      invRMATPN(1,2)=(RMATPN(1,3)*RMATPN(3,2)-RMATPN(1,2)*RMATPN(3,3))
     & /det
      invRMATPN(1,3)=(RMATPN(1,2)*RMATPN(2,3)-RMATPN(1,3)*RMATPN(2,2))
     & /det
      invRMATPN(2,1)=(RMATPN(2,3)*RMATPN(3,1)-RMATPN(2,1)*RMATPN(3,3))
     & /det
      invRMATPN(2,2)=(RMATPN(1,1)*RMATPN(3,3)-RMATPN(1,3)*RMATPN(3,1))
     & /det
      invRMATPN(2,3)=(RMATPN(1,3)*RMATPN(2,1)-RMATPN(1,1)*RMATPN(2,3))
     & /det
      invRMATPN(3,1)=(RMATPN(2,1)*RMATPN(3,2)-RMATPN(2,2)*RMATPN(3,1))
     & /det
      invRMATPN(3,2)=(RMATPN(1,2)*RMATPN(3,1)-RMATPN(1,1)*RMATPN(3,2))
     & /det
      invRMATPN(3,3)=(RMATPN(1,1)*RMATPN(2,2)-RMATPN(1,2)*RMATPN(2,1))
     & /det
c
c  Rotate input coordinates to outputs
      xOUT(1)=invRMATPN(1,1)*xIN(1)+invRMATPN(1,2)*xIN(2)+
     &        invRMATPN(1,3)*xIN(3)
      xOUT(2)=invRMATPN(2,1)*xIN(1)+invRMATPN(2,2)*xIN(2)+
     &        invRMATPN(2,3)*xIN(3)
      xOUT(3)=invRMATPN(3,1)*xIN(1)+invRMATPN(3,2)*xIN(2)+
     &        invRMATPN(3,3)*xIN(3)
      end

!---------------------------------------------------------------------------------------------------
!                              Introduced in version 4....
!
! CREATION: S. Bourdarie - July 2009
! MODIFICATION: None
!
! DESCRIPTION: Rotates coordinates from TEME to ECI true of date
! TEME=True Equator Mean Equinox
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xIN -> position in TEME system (double array(3))
!
! OUTPUT: xOUT -> position in ECI TOD system (double array(3))
!
! CALLING SEQUENCE: call TEME2ECITOD(iyr,idoy,UT,xIN,xOUT)
!---------------------------------------------------------------------------------------------------
      SUBROUTINE TEME2ECITOD(iyr,idoy,UT,xIN,xOUT)
c
      IMPLICIT NONE
c
c     input variables
      INTEGER*4 iyr,idoy
      REAL*8 UT,xIN(3)

c     internal variables
      REAL*8 RMATPN(3,3),invRMATPN(3,3),det
      REAL*8 DATE1,DATE2
      REAL*8 EQEQ94,psi,S,C,A(3,3)
c
c     Output variables
      REAL*8 xOUT(3)
c
c     Compute the dates following J2000 method
      call date2dateJ2000(iyr,idoy,UT,date1,date2)
!c  Form the rotation matrix around z axis by angle -Eqe82
      psi=-EQEQ94 ( DATE1, DATE2 )
*  Matrix representing new rotation.
      S = SIN(PSI)
      C = COS(PSI)
      CALL IR ( A )
      A(1,1) = C
      A(2,1) = -S
      A(1,2) = S
      A(2,2) = C
      xOUT(1)=A(1,1)*xIN(1)+A(1,2)*xIN(2)+A(1,3)*xIN(3)
      xOUT(2)=A(2,1)*xIN(1)+A(2,2)*xIN(2)+A(2,3)*xIN(3)
      xOUT(3)=A(3,1)*xIN(1)+A(3,2)*xIN(2)+A(3,3)*xIN(3)
      end
c
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 4....
!
! CREATION: S. Bourdarie - July 2009
! MODIFICATION: None
!
! DESCRIPTION: Rotates coordinates from ECI true of date to TEME
! TEME=True Equator Mean Equinox
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xIN -> position in ECI True of Date (TOD) system (double array(3))
!
! OUTPUT: xOUT -> position in TEME system (double array(3))
!
! CALLING SEQUENCE: call ECITOD2TEME(iyr,idoy,UT,xIN,xOUT)
!---------------------------------------------------------------------------------------------------
      SUBROUTINE ECITOD2TEME(iyr,idoy,UT,xIN,xOUT)
c
      IMPLICIT NONE
c
c     input variables
      INTEGER*4 iyr,idoy
      REAL*8 UT,xIN(3)

c     internal variables
      REAL*8 RMATPN(3,3),invRMATPN(3,3),det
      REAL*8 DATE1,DATE2
      REAL*8 EQEQ94,psi,S,C,A(3,3)
c
c     Output variables
      REAL*8 xOUT(3)
c
c     Compute the dates following J2000 method
      call date2dateJ2000(iyr,idoy,UT,date1,date2)
!c  Form the rotation matrix around z axis by angle Eqe82
      psi=EQEQ94 ( DATE1, DATE2 )
*  Matrix representing new rotation.
      S = SIN(PSI)
      C = COS(PSI)
      CALL IR ( A )
      A(1,1) = C
      A(2,1) = -S
      A(1,2) = S
      A(2,2) = C
      xOUT(1)=A(1,1)*xIN(1)+A(1,2)*xIN(2)+A(1,3)*xIN(3)
      xOUT(2)=A(2,1)*xIN(1)+A(2,2)*xIN(2)+A(2,3)*xIN(3)
      xOUT(3)=A(3,1)*xIN(1)+A(3,2)*xIN(2)+A(3,3)*xIN(3)
      end
c
c---------------------------------------------------------------------------------------------------
!                              Introduced in version 4.0
!
! CREATION: S. Bourdarie - January 2007
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from one Earth or Heliospheric coordinate
!                                        system to another one
!
! INPUT: sysaxesIN -> designed input coordinate system (long integer)
!        sysaxesOUT> designed output coordinate system (long integer)
!        iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xIN -> position in input coordinate system (double array(3))
!
! OUTPUT: xOUT -> position in output coordinate system (double array(3))
!
! CALLING SEQUENCE: call coord_trans1(sysaxesIN,sysaxesOUT,iyr,idoy,secs,xIN,xOUT)
!---------------------------------------------------------------------------------------------------
c
      SUBROUTINE coord_trans1(sysaxesIN,sysaxesOUT,iyr,idoy,
     &   secs,xIN,xOUT)
c
      IMPLICIT NONE
c
      INTEGER*4 sysaxesIN,sysaxesOUT,iyr,idoy
      INTEGER*4 i
      REAL*8    secs,psi
      REAL*8    xIN(3),xOUT(3),xTMP(3),alti

      call initize ! sets rad, pi used by various routines

      if (sysaxesIN.EQ.sysaxesOUT) then
c         write(6,*)'sysaxesIN = sysaxesOUT!'
         do i=1,3
            xOUT(i)=xIN(i)
         enddo
         return
      endif
      if ((sysaxesIN.LT.0).or.(sysaxesIN.GT.14)) then
         write(6,*)'sysaxesIN out of range !'
         do i=1,3
            xOUT(i)=-1.D31
         enddo
         return
      endif
      if ((sysaxesOUT.LT.0).or.(sysaxesOUT.GT.14)) then
         write(6,*)'sysaxesOUT out of range !'
         do i=1,3
            xOUT(i)=-1.D31
         enddo
         return
      endif
c
c input=GDZ
      if (sysaxesIN.EQ.0) then
         if (sysaxesOUT.EQ.1) then  !GEO
            call gdz_geo(xIN(2),xIN(3),xIN(1),xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            xOUT(1)=SQRT(xTMP(1)*xTMP(1)+xTMP(2)*xTMP(2)+
     &               xTMP(3)*xTMP(3))
            xOUT(2)=xIN(2)
            xOUT(3)=xIN(3)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call gdz_geo(xIN(2),xIN(3),xIN(1),xTMP(1),xTMP(2),xTMP(3))
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=GEO
      if (sysaxesIN.EQ.1) then
         if (sysaxesOUT.EQ.0) then  !GDZ
           call geo_gdz(xIN(1),xIN(2),xIN(3),xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call geo2gsm1(iyr,idoy,secs,psi,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call geo2gse1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call geo2sm1(iyr,idoy,secs,xIN,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call geo2gei1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call geo2mag1(iyr,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call CAR_SPH(xIN,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
           call geo_gdz(xIN(1),xIN(2),xIN(3),xTMP(1),xTMP(2),xTMP(3))
            xOUT(1)=SQRT(xIN(1)*xIN(1)+xIN(2)*xIN(2)+xIN(3)*xIN(3))
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call geo2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call geo2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call geo2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call geo2gei1(iyr,idoy,secs,xIN,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call geo2gei1(iyr,idoy,secs,xIN,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=GSM
      if (sysaxesIN.EQ.2) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call gsm2sm1(iyr,idoy,secs,xIN,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            xOUT(1)=SQRT(xIN(1)*xIN(1)+xIN(2)*xIN(2)+xIN(3)*xIN(3))
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call gsm2geo1(iyr,idoy,secs,psi,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=GSE
      if (sysaxesIN.EQ.3) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call gse2geo1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            xOUT(1)=SQRT(xIN(1)*xIN(1)+xIN(2)*xIN(2)+xIN(3)*xIN(3))
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call gse2hee1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call gse2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call gse2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call gse2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=SM
      if (sysaxesIN.EQ.4) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call sm2geo1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call sm2gsm1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            xOUT(1)=SQRT(xIN(1)*xIN(1)+xIN(2)*xIN(2)+xIN(3)*xIN(3))
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call sm2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c input=GEI (which is also ECI ToD)
      if ((sysaxesIN.EQ.5).or.(sysaxesIN.EQ.12)) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call gei2geo1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            xOUT(1)=SQRT(xIN(1)*xIN(1)+xIN(2)*xIN(2)+xIN(3)*xIN(3))
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call gei2geo1(iyr,idoy,secs,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.12).or.(sysaxesOUT.EQ.5)) then  !ECI ToD
            do i=1,3
               xOUT(i)=xIN(i)
            enddo
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            CALL ECITOD2TEME(iyr,idoy,secs,xIN,xOUT)
         endif
      endif
c
c
c input=MAG
      if (sysaxesIN.EQ.6) then
         if (sysaxesOUT.EQ.0) then  !GDZ
              call mag2geo1(iyr,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
              call mag2geo1(iyr,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
              call mag2geo1(iyr,xIN,xTMP)
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
              call mag2geo1(iyr,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
              call mag2geo1(iyr,xIN,xTMP)
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
              call mag2geo1(iyr,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
              call mag2geo1(iyr,xIN,xTMP)
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
              call mag2geo1(iyr,xIN,xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            xOUT(1)=SQRT(xIN(1)*xIN(1)+xIN(2)*xIN(2)+xIN(3)*xIN(3))
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
              call mag2geo1(iyr,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
              call mag2geo1(iyr,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
              call mag2geo1(iyr,xIN,xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call mag2geo1(iyr,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call mag2geo1(iyr,xIN,xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=SPH
      if (sysaxesIN.EQ.7) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3)
     &             ,xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            xOUT(1)=xIN(1)
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call SPH_CAR(xIN(1),xIN(2),xIN(3),xTMP)
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=RLL
      if (sysaxesIN.EQ.8) then
         if (sysaxesOUT.EQ.0) then  !GDZ
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
              call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call RLL_GDZ(xIN(1),xIN(2),xIN(3),alti)
            call gdz_geo(xIN(2),xIN(3),alti,xTMP(1),xTMP(2),xTMP(3))
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=HEE
      if (sysaxesIN.EQ.9) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            xOUT(3)=xOUT(2)
            xOUT(2)=xOUT(1)
            xOUT(1)=SQRT(xTMP(1)*xTMP(1)+xTMP(2)*xTMP(2)
     &                     +xTMP(3)*xTMP(3))
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call hee2hae1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call hee2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call hee2gse1(iyr,idoy,secs,xIN,xTMP)
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=HAE
      if (sysaxesIN.EQ.10) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            xOUT(3)=xOUT(2)
            xOUT(2)=xOUT(1)
            xOUT(1)=SQRT(xTMP(1)*xTMP(1)+xTMP(2)*xTMP(2)
     &                     +xTMP(3)*xTMP(3))
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call hae2hee1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call hae2heeq1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call hae2hee1(iyr,idoy,secs,xIN,xTMP)
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=HEEQ
      if (sysaxesIN.EQ.11) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            xOUT(3)=xOUT(2)
            xOUT(2)=xOUT(1)
            xOUT(1)=SQRT(xTMP(1)*xTMP(1)+xTMP(2)*xTMP(2)
     &                     +xTMP(3)*xTMP(3))
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call heeq2hae1(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call heeq2hae1(iyr,idoy,secs,xIN,xTMP)
            call hae2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gei1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            CALL ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=J2000
      if (sysaxesIN.EQ.13) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            xOUT(1)=SQRT(xIN(1)*xIN(1)+xIN(2)*xIN(2)+xIN(3)*xIN(3))
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.14) then  !TEME
            call ECIJ2000_2_ECITOD(iyr,idoy,secs,xIN,xTMP)
            call ECITOD2TEME(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c input=TEME
      if (sysaxesIN.EQ.14) then
         if (sysaxesOUT.EQ.0) then  !GDZ
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(2),xOUT(3),xOUT(1))
         endif
         if (sysaxesOUT.EQ.1) then  !GEO
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.2) then  !GSM
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gsm1(iyr,idoy,secs,psi,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.3) then  !GSE
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.4) then  !SM
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2sm1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if ((sysaxesOUT.EQ.5).or.(sysaxesOUT.EQ.12)) then  !GEI (TOD)
            call TEME2ECITOD(iyr,idoy,secs,xIN,xOUT)
         endif
         if (sysaxesOUT.EQ.6) then  !MAG
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2mag1(iyr,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.7) then  !SPH
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call CAR_SPH(xTMP,xOUT(1),xOUT(2),xOUT(3))
         endif
         if (sysaxesOUT.EQ.8) then  !RLL
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo_gdz(xTMP(1),xTMP(2),xTMP(3),
     &                     xOUT(1),xOUT(2),xOUT(3))
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            xOUT(1)=SQRT(xIN(1)*xIN(1)+xIN(2)*xIN(2)+xIN(3)*xIN(3))
            xOUT(2)=xTMP(1)
            xOUT(3)=xTMP(2)
         endif
         if (sysaxesOUT.EQ.9) then  !HEE
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.10) then  !HAE
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.11) then  !HEEQ
            call TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            call gei2geo1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call geo2gse1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call gse2hee1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hee2hae1(iyr,idoy,secs,xTMP,xOUT)
            do i=1,3
               xTMP(i)=xOUT(i)
            enddo
            call hae2heeq1(iyr,idoy,secs,xTMP,xOUT)
         endif
         if (sysaxesOUT.EQ.13) then  !J2000
            CALL TEME2ECITOD(iyr,idoy,secs,xIN,xTMP)
            CALL ECITOD_2_ECIJ2000(iyr,idoy,secs,xTMP,xOUT)
         endif
      endif
c
c
      end
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE coord_trans_vec
C      Routine to vectorize coord_trans1, the single-element
C      coordinate transformation utility.
C      Calling sequence:
C
C      call coord_trans_vec(ntime,sysaxesIN,sysaxesOUT,iyear,idoy,secs,
C     +          xIN,xOUT)
C
C         with the following types:
C      INTEGER*4 sysaxesIN, sysaxesOUT
C      INTEGER*4 iyear(nmax),idoy(nmax)
C      REAL*8 secs(nmax)
C      REAL*8 xINV(3,nmax), xOUTV(3,nmax)
C      INTEGER*4 numpoints
C
C     As with all (most?) onera library calls, the maximum array size
C     is limited to ntime_max elements
C                              Contributed by Timothy Guild, 2.2.07
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C

        SUBROUTINE coord_trans_vec1(ntime,sysaxesIN,sysaxesOUT,
     &   iyear,idoy,secs,xINV,xOUTV)

      IMPLICIT NONE
      INCLUDE 'ntime_max.inc'
      INCLUDE 'variables.inc'

      INTEGER*4 nmax,i,ntime, sysaxesIN, sysaxesOUT
      INTEGER*4 iyear(ntime_max),idoy(ntime_max),y,d
      REAL*8 secs(ntime_max),xINV(3,ntime_max),xOUTV(3,ntime_max)
      ! local vars
      REAL*8 xIN(3),xOUT(3),s

      ! Loop over the number of points specified, calling
      !  coord_trans1 each iteration
      DO i = 1,ntime
         y = iyear(i)
         d = idoy(i)
         s = secs(i)

        if (xINV(1,i) .eq. baddata .and. xINV(2,i) .eq. baddata
     &  .and. xINV(3,i) .eq.baddata) then
           xOUTV(1,i) = baddata
           xOUTV(2,i) = baddata
           xOUTV(3,i) = baddata
           goto 10
        endif
       xIN(1) = xINV(1,i) ! copy each array element into 3x1 array
       xIN(2) = xINV(2,i)
         xIN(3) = xINV(3,i)

         call coord_trans1( sysaxesIN,sysaxesOUT,y,d,s,xIN,xOUT)

       xOUTV(1,i) = xOUT(1)  ! copy back to 3xN array to pass back
       xOUTV(2,i) = xOUT(2)
         xOUTV(3,i) = xOUT(3)

10      continue
      ENDDO

      END

!***************************************************************************************************
! Copyright  2004 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C
C

C     Legacy wrapper w/ R0=1.0
       SUBROUTINE field_line_tracing(
     &         lati,longi,alti,Lm,leI0,Bposit,Bmin,posit,Nposit)
       IMPLICIT NONE
       INTEGER*4  Nreb,Ntet
       PARAMETER (Nreb = 150, Ntet = 720)
       INTEGER*4  Nposit
       REAL*8     lati,longi,alti,R0
       REAL*8     Lm,leI0,Bmin,xx0(3)
       REAL*8     posit(3,20*Nreb),Bposit(20*Nreb)

       CALL GDZ_GEO(lati,longi,alti,xx0(1),xx0(2),xx0(3))
C
       call field_line_tracing_opt2(xx0,1.D0,
     & Lm,leI0,Bposit,Bmin,posit,Nposit)

       RETURN
       END
       SUBROUTINE field_line_tracing2(
     &         lati,longi,alti,R0,Lm,leI0,Bposit,Bmin,posit,Nposit)
C
C    modified from field_line_tracing to add R0 parameter: radius (Re) of
C    reference surface
       IMPLICIT NONE
       INTEGER*4  Nreb,Ntet
       PARAMETER (Nreb = 150, Ntet = 720)
       INTEGER*4  Nposit
       REAL*8     lati,longi,alti,R0
       REAL*8     Lm,leI0,Bmin,xx0(3)
       REAL*8     posit(3,20*Nreb),Bposit(20*Nreb)

       CALL GDZ_GEO(lati,longi,alti,xx0(1),xx0(2),xx0(3))
C
       call field_line_tracing_opt2(xx0,R0,
     & Lm,leI0,Bposit,Bmin,posit,Nposit)

       RETURN
       END
       
       SUBROUTINE field_line_tracing_opt(
     &         xx0,Lm,leI0,Bposit,Bmin,posit,Nposit)
       IMPLICIT NONE
       INTEGER*4  Nreb,Ntet
       PARAMETER (Nreb = 150, Ntet = 720)
       INTEGER*4  Nposit
       REAL*8     xx0(3),R0
       REAL*8     Lm,leI0,Bmin
       REAL*8     posit(3,20*Nreb),Bposit(20*Nreb)

       call field_line_tracing_opt2(xx0,1.D0,
     & Lm,leI0,Bposit,Bmin,posit,Nposit)
       RETURN
       END

       SUBROUTINE field_line_tracing_opt2(
     &         xx0,R0,Lm,leI0,Bposit,Bmin,posit,Nposit)
C
C    modified from field_line_tracing to add R0 parameter: radius (Re) of
C    reference surface
       IMPLICIT NONE
       INCLUDE 'variables.inc'
C
       INTEGER*4  Nreb,Ntet
       PARAMETER (Nreb = 150, Ntet = 720)
C
       INTEGER*4  k_ext,k_l,kint
       INTEGER*4  Nrebmax
       REAL*8     rr,rr2
       REAL*8     xx0(3),xx(3),x1(3),x2(3)
       REAL*8     xmin(3)
       REAL*8     lati,longi,alti
       REAL*8     B(3),Bl,B0,Bmin,B1,B3
       REAL*8     dsreb,smin

       INTEGER*4  I,J,Iflag,Iflag_I,Ilflag,ind,II,Ifail
       INTEGER*4  Nposit
       REAL*8     Lm,Lstar,Lb
       REAL*8     leI,leI0,leI1
       REAL*8     XY,YY
       REAL*8     aa,bb
C
       REAL*8     tt
       REAL*8     tetl,tet1,dtet
       REAL*8     somme
C
       REAL*8     Bo,xc,yc,zc,ct,st,cp,sp
C
       REAL*8     posit(3,20*Nreb),Bposit(20*Nreb)
       real*8     R0,R02 ! R0^2
C
       COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
       COMMON /flag_L/Ilflag
       COMMON /magmod/k_ext,k_l,kint
C
C
       R02 = R0*R0
C
       Nrebmax = 20*Nreb
c       write(*,*)'Nrebmax',Nrebmax
C
       Lm = baddata
       leI0 = 0.D0
C
       CALL GEO_SM(xx0,xx)
       rr = SQRT(xx(1)*xx(1)+xx(2)*xx(2)+xx(3)*xx(3))
       tt = ACOS(xx(3)/rr)
       Lb  = rr/SIN(tt)/SIN(tt)
c       write(6,*)'L bete ',Lb
C
       CALL CHAMP(xx0,B,B0,Ifail)
       IF (Ifail.LT.0) THEN
          leI0 = baddata
          Bmin = baddata
	  RETURN
       ENDIF
       Bmin = B0
C
       dsreb = Lb/Nreb
C
C calcul du sens du depart
C
       CALL sksyst(-dsreb,xx0,x1,Bl,Ifail)
       IF (Ifail.LT.0) THEN
          leI0 = baddata
          Bmin = baddata
	  RETURN
       ENDIF
       B1 = Bl
       CALL sksyst(dsreb,xx0,x2,Bl,Ifail)
       IF (Ifail.LT.0) THEN
          leI0 = baddata
          Bmin = baddata
	  RETURN
       ENDIF
       B3 = Bl
C
C attention cas equatorial
C
       IF(B1.GT.B0 .AND. B3.GT.B0)THEN
         aa = 0.5D0*(B3+B1-2.D0*B0)
         bb = 0.5D0*(B3-B1)
         smin = -0.5D0*bb/aa
         Bmin = B0 - aa*smin*smin
         leI0 = SQRT(1.D0-Bmin/B0)*2.D0*ABS(smin*dsreb)
         Lm = (Bo/Bmin)**(1.D0/3.D0)
c         write(6,*)'L McIlwain eq ',B0,leI0,Lm
         GOTO 100
       ENDIF
       IF (B3.GT.B1) THEN
         dsreb = -dsreb
       ENDIF
C
C calcul de la ligne de champ et de I
C
       Bmin = B0
       leI = 0.D0
       ind=0
       DO I = 1,3
         x1(I)  = xx0(I)
       ENDDO
C
c       write(6,*)dsreb
       DO J = 1,Nrebmax
         CALL sksyst(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) THEN
            leI0 = baddata
            Bmin = baddata
	    RETURN
	 ENDIF
c	 write(6,*)J,x1(1),x1(2),x1(3),Bl
         IF (Bl.LT.Bmin) THEN
           xmin(1) = x2(1)
           xmin(2) = x2(2)
           xmin(3) = x2(3)
           Bmin = Bl
         ENDIF
         IF (Bl.GT.B0) GOTO 20
	 x1(1) = x2(1)
	 x1(2) = x2(2)
	 x1(3) = x2(3)
         leI = leI + SQRT(1.D0-Bl/B0)
	 B1 = Bl
       ENDDO
20     CONTINUE
c	write(6,*)J,leI
C
       IF (J.GE.Nrebmax) THEN !open field line
        leI0 = baddata
        Bmin = baddata
	RETURN
       ENDIF
C
       leI = leI+0.5D0*SQRT(1.D0-B1/B0)*(B0-Bl)/(Bl-B1)
       leI = leI*ABS(dsreb)
       leI0 = leI
C
C calcul de L Mc Ilwain (Mc Ilwain-Hilton)
C
       XY = leI*leI*leI*B0/Bo
       YY = 1.D0 + 1.35047D0*XY**(1.D0/3.D0)
     &      + 0.465376D0*XY**(2.D0/3.D0)
     &      + 0.0475455D0*XY
       Lm = (Bo*YY/B0)**(1.D0/3.D0)
c       write(6,*)'L McIlwain ',B0,leI0,Lm
C
C calcul de Bmin
C
       CALL sksyst(dsreb,xmin,x1,B3,Ifail)
       IF (Ifail.LT.0) THEN
          Bmin = baddata
	  RETURN
       ENDIF
       CALL sksyst(-dsreb,xmin,x1,B1,Ifail)
       IF (Ifail.LT.0) THEN
          Bmin = baddata
	  RETURN
       ENDIF
       aa = 0.5D0*(B3+B1-2.D0*Bmin)
       bb = 0.5D0*(B3-B1)
       smin = -0.5D0*bb/aa
       Bmin = Bmin - aa*smin*smin
       IF (x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3).LT.1.D0) THEN
        Lm = -Lm
       ENDIF
C
100    CONTINUE
C
C calcul du point sur la ligne de champ a la surface de la terre du
C cote nord
C
       DO I = 1,3
         x1(I)  = xx0(I)
       ENDDO
       dsreb = ABS(dsreb)
       DO J = 1,Nrebmax
         CALL sksyst(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) RETURN
	 rr = sqrt(x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3))
	 IF (rr.LT.R0) GOTO 102
	 x1(1) = x2(1)
	 x1(2) = x2(2)
	 x1(3) = x2(3)
       ENDDO
102    CONTINUE
       smin = sqrt(x1(1)*x1(1)+x1(2)*x1(2)+x1(3)*x1(3))
       smin = (R0-smin)/(rr-smin)
       CALL sksyst(smin*dsreb,x1,x2,Bl,Ifail)
       IF (Ifail.LT.0) RETURN
C
c trace la ligne de champ complete.
c
       x1(1) = x2(1)
       x1(2) = x2(2)
       x1(3) = x2(3)
       ind=1
       Nposit=ind
       posit(1,ind)=x1(1)
       posit(2,ind)=x1(2)
       posit(3,ind)=x1(3)
       Bposit(ind)=Bl
       DO J = 1,Nrebmax-1 ! this is the corrected version
                            !, gives 3000 values, A. Kellerman
         CALL sksyst(-dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) RETURN
	 ind=ind+1
	 posit(1,ind)=x2(1)
	 posit(2,ind)=x2(2)
	 posit(3,ind)=x2(3)
         Bposit(ind)=Bl
c	 write(6,*)J,x1(1),x1(2),x1(3),Bl
         rr2 = x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3)
         IF (rr2.LT.R02) GOTO 201
	 x1(1) = x2(1)
	 x1(2) = x2(2)
	 x1(3) = x2(3)
       ENDDO
201    CONTINUE
       Nposit=ind
       END
C

!***************************************************************************************************
! Copyright 2011 T.P. O'Brien
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!

      SUBROUTINE GET_Bderivs(ntime,kext,options,sysaxes,dX,
     & iyearsat,
     & idoy,UT,xIN1,xIN2,xIN3,maginput,Bgeo,Bmag,gradBmag,diffB)
C     computes derivatives of B (vector and magnitude)
C     inputs: ntime through maginput have the usual meaning, except dX
C     REAL*8 dX is the step size, in RE for the numerical derivatives (recommend 1E-3?)
C     real*8 Bgeo(3,ntime_max) - components of B in GEO, nT
C     real*8 Bmag(ntime_max) - magnitude of B in nT
C     real*8 gradBmag(3,ntime_max) - gradient of Bmag in GEO, nT/RE
C     real*8 diffB(3,3,ntime_max) - derivatives of Bgeo in GEO, nT/RE
C        diffB(i,j,t) = dB_i/dx_j for point t (t=1 to ntime)

      IMPLICIT NONE
      INCLUDE 'ntime_max.inc'   ! include file created by make, defines ntime_max
      INCLUDE 'variables.inc'
C
      COMMON /magmod/k_ext,k_l,kint

c     declare inputs
      INTEGER*4    ntime,kext,options(5)
      INTEGER*4    sysaxes
      REAL*8       dX
      INTEGER*4    iyearsat(ntime_max)
      integer*4    idoy(ntime_max)
      real*8     UT(ntime_max)
      real*8     xIN1(ntime_max),xIN2(ntime_max),xIN3(ntime_max)
      real*8     maginput(25,ntime_max)

c     declare outputs
      real*8 Bgeo(3,ntime_max) ! components of B in GEO, nT
      real*8 Bmag(ntime_max) ! magnitude of B in nT
      real*8 gradBmag(3,ntime_max) ! gradient of Bmag in GEO, nT/RE
      real*8 diffB(3,3,ntime_max) ! derivatives of Bgeo in GEO, nT/RE

c     declare internal variables
      integer*4  isat
      integer*4  i,j,k_ext,k_l,kint,ifail
      real*8     xGEO(3),xGEOtmp(3)
      real*8     alti,lati,longi
      REAL*8     B1GEO(3),B1,BtmpGEO(3),Btmp
      integer*4 int_field_select, ext_field_select ! functions to call
C
      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
      CALL INITIZE

      if (k_ext .eq. 13 .or. k_ext .eq. 14) then
        call INIT_TS07D_TLPR
      endif

      do isat = 1,ntime

         ! initialize outputs to baddata
         Bmag(isat) = baddata
         do i=1,3
            Bgeo(i,isat) = baddata
            gradBmag(i,isat) = baddata
            do j=1,3
               diffB(i,j,isat) = baddata
            enddo
         enddo

         call init_fields(kint,iyearsat(isat),idoy(isat),
     &        UT(isat),options(2))

         call get_coordinates (sysaxes,xIN1(isat),xIN2(isat),xIN3(isat),
     6        alti, lati, longi, xGEO )

         call set_magfield_inputs ( k_ext, maginput(1,isat), ifail)
         if (k_ext .eq. 13 .or. k_ext .eq. 14) then
            call INIT_TS07D_COEFFS(iyearsat(isat),idoy(isat),
     &      UT(isat),ifail)
         endif

         if (ifail.lt.0) goto 1000
c
         CALL CHAMP(xGEO,B1GEO,B1,Ifail)
         IF ((Ifail.LT.0).or.(B1.eq.baddata)) goto 1000

C copy start point to outputs
         Bmag(isat) = B1
         do i = 1,3
            Bgeo(i,isat) = B1GEO(i)
         enddo

         do j=1,3
C displace in dimension j
            do i = 1,3
               xGEOtmp(i)= xGEO(i)
            enddo
            xGEOtmp(j) = xGEOtmp(j)+dX
            CALL CHAMP(xGEOtmp,BtmpGEO,Btmp,Ifail) ! compute B at displace point
            IF ((Ifail.LT.0).or.(Btmp.eq.baddata)) THEN
               goto 1000
            ENDIF
c     compute derivatives
            gradBmag(j,isat) = (Btmp-B1)/dX
            do i = 1,3
               diffB(i,j,isat) = (BtmpGEO(i)-B1GEO(i))/dX
            enddo
         enddo ! end of j loop

 1000       continue            ! end of isat loop
         enddo

      end



      SUBROUTINE compute_grad_curv_curl(ntime,Bgeo,Bmag,gradBmag,diffB,
     & grad_par,grad_perp,grad_drift,curvature,Rcurv,curv_drift,
     & curlB,divB)
C     computes gradient factors, curvature factors, and curl of B

      IMPLICIT NONE
      INCLUDE 'ntime_max.inc'   ! include file created by make, defines ntime_max
      INCLUDE 'variables.inc'

C     all coordinates are in GEO reference frame
C     inputs: 
      integer*4 ntime           ! number of points
      real*8 Bgeo(3,ntime_max)  ! components of B in GEO, nT
      real*8 Bmag(ntime_max)    ! magnitude of B in nT
      real*8 gradBmag(3,ntime_max) ! gradient of Bmag in GEO, nT/RE
      real*8 diffB(3,3,ntime_max) ! derivatives of Bgeo in GEO, nT/RE
c     diffB(i,j,t) = dB_i/dx_j for point t (t=1 to ntime)
c     outputs:
      real*8 grad_par(ntime_max) ! gradient of Bmag along B nT/RE
      real*8 grad_perp(3,ntime_max) ! gradient of Bmag perpendicular to B nT/RE
      real*8 grad_drift(3,ntime_max) ! (bhat x grad_perp)/B, 1/RE (part of gradient drift velocity)
      real*8 curvature(3,ntime_max) ! (bhat dot grad)bhat, 1/RE (part of curvature force)
      real*8 Rcurv(ntime_max) ! 1/|curvature| RE (radius of curvature)
      real*8 curv_drift(3,ntime_max) ! (bhat x curvature), 1/RE (part of curvature drift)
      real*8 curlB(3,ntime_max) ! curl of B (nT/RE) (part of electrostatic current term)
      real*8 divB(ntime_max) ! divergence of B (nT/RE) (should be zero!)


c     internal variables
      integer*4 i,j,k,isat
      real*8 bhat(3), dbiBk ! unit vector along B and partial db_i/dB_k

      do isat = 1,ntime

         ! compute bhat and grad_par
         grad_par(isat) = 0.0
         do i = 1,3
            bhat(i) = Bgeo(i,isat)/Bmag(isat)
            grad_par(isat) = grad_par(isat) + gradBmag(i,isat)*bhat(i)
         enddo

         ! compute grad_perp
         do i = 1,3
            grad_perp(i,isat) = gradBmag(i,isat)-grad_par(isat)*bhat(i)
         enddo

         ! compute grad_drift
         grad_drift(1,isat) = (bhat(2)*grad_perp(3,isat) 
     &        - bhat(3)*grad_perp(2,isat)) / Bmag(isat)
         grad_drift(2,isat) = (bhat(3)*grad_perp(1,isat) 
     &        - bhat(1)*grad_perp(3,isat)) / Bmag(isat)
         grad_drift(3,isat) = (bhat(1)*grad_perp(2,isat) 
     &        - bhat(2)*grad_perp(1,isat)) / Bmag(isat)

         ! compute curvature (via chain rule on b = Bgeo/Bmag)
         do i = 1,3
            curvature(i,isat) = 0.0
            do k = 1,3
               ! compute db_i/dB_k
               if (i.eq.k) then
                  dbiBk = Bmag(isat)**2 - Bgeo(i,isat)**2
               else
                  dbiBk = -Bgeo(i,isat)*Bgeo(k,isat)
               endif
               dbiBk = dbiBk/Bmag(isat)**3
               do j = 1,3
                  curvature(i,isat) = curvature(i,isat)
     &                 +bhat(j)*dbiBk*diffB(k,j,isat)
               enddo
            enddo
         enddo
         
         ! compute radius of curvature = 1/|curvature|
         Rcurv(isat) = 0.0
         do i = 1,3
            Rcurv(isat) = Rcurv(isat)+curvature(i,isat)**2
         enddo
         if (Rcurv(isat).gt.0) then
            Rcurv(isat) = 1.0/sqrt(Rcurv(isat))
         else
            Rcurv(isat) = baddata
         endif
         
         ! compute curv_drift
         curv_drift(1,isat) = (bhat(2)*curvature(3,isat) 
     &        - bhat(3)*curvature(2,isat))
         curv_drift(2,isat) = (bhat(3)*curvature(1,isat) 
     &        - bhat(1)*curvature(3,isat))
         curv_drift(3,isat) = (bhat(1)*curvature(2,isat) 
     &        - bhat(2)*curvature(1,isat))

         ! compute curl of B
         curlB(1,isat) = diffB(3,2,isat)-diffB(2,3,isat)
         curlB(2,isat) = diffB(1,3,isat)-diffB(3,1,isat)
         curlB(3,isat) = diffB(2,1,isat)-diffB(1,2,isat)

         ! compute divergence of B
         divB(isat) = diffB(1,1,isat)+diffB(2,2,isat)+diffB(3,3,isat)

      enddo ! end isat loop

      end

!***************************************************************************************************
! Copyright , 2005 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
! 
!----------------------------------------------------------------------      
! NAME:
!	JULDAY
!
! PURPOSE:
!	Calculate the Julian Day Number for a given month, day, and year.
!
!
! CALLING SEQUENCE:
!	Result = JULDAY(Year,Month, Day)
!
! INPUTS:
!	MONTH:	Number of the desired month (1 = January, ..., 12 = December).
!
!	DAY:	Number of day of the month.
!
!	YEAR:	Number of the desired year.Year parameters must be valid
!               values from the civil calendar.  Years B.C.E. are represented
!               as negative integers.  Years in the common era are represented
!               as positive integers.  In particular, note that there is no
!               year 0 in the civil calendar.  1 B.C.E. (-1) is followed by
!               1 C.E. (1).
!
! OUTPUTS:
!	JULDAY returns the Julian Day Number (which begins at noon) of the
!	specified calendar date.
!-----------------------------------------------------------------------
       FUNCTION JULDAY (iyear,month,day)
!
       IMPLICIT NONE
!
       INTEGER*4 JULDAY,year,month,day,iyear
       INTEGER*4 min_calendar,max_calendar,bc,inJanFeb
       INTEGER*4 JY,JM,GREG,JA
!
!
! Gregorian Calander was adopted on Oct. 15, 1582
! skipping from Oct. 4, 1582 to Oct. 15, 1582
       GREG = 2299171  ! incorrect Julian day for Oct. 25, 1582
!
       year=iyear
       min_calendar = -4716
       max_calendar = 5000000
       IF ((year .LT. min_calendar) .OR. (year .GT. max_calendar)) THEN
	   write(6,*)'Value of Julian date is out of allowed range.'
	   stop
       ENDIF
       IF (year .eq. 0)  then
	   write(6,*)'There is no year zero in the civil calendar.'
	   write(6,*)'Value of Julian date is out of allowed range.'
	   stop
       ENDIF
!
       bc=0
       IF (year.lt.0) bc=1
       year=year+bc
!
       inJanFeb=0
       IF (month .le.2) inJanFeb=1

       JY = YEAR - inJanFeb
       JM = MONTH + (1 + 12*inJanFeb)


       JULDAY = INT(365.25d0 * JY) + INT(30.6001d0*JM) + DAY + 1720995


! Test whether to change to Gregorian Calandar.
       IF (JULDAY .GE. GREG) THEN   ! change all dates
          JA = INT(0.01d0 * JY)
	  JULDAY = JULDAY + 2 - JA +INT(0.25d0 * JA)
       ENDIF
       END 
!
!-------------------------------------------------------------------------
! NAME:
!	CALDAT
!
! PURPOSE:
!	Return the calendar date given julian day.
!	This is the inverse of the function JULDAY.
! CALLING SEQUENCE:
!	CALDAT, Julian,  Year, Month, Day
!	See also: julday, the inverse of this function.
!
! INPUTS:
!	JULIAN contains the Julian Day Number (which begins at noon) of the
!	specified calendar date.  It should be a long integer.
! OUTPUTS:
!	(Trailing parameters may be omitted if not required.)
!	MONTH:	Number of the desired month (1 = January, ..., 12 = December).
!
!	DAY:	Number of day of the month.
!
!	YEAR:	Number of the desired year.
!-------------------------------------------------------------------------
!
       SUBROUTINE CALDAT(julian, year,month, day)
!
       IMPLICIT NONE
!
       INTEGER*4  julian
       INTEGER*4  year,month, day
       INTEGER*4  min_julian,max_julian,igreg,jalpha,ja,jb,jc,jd,je
!
       min_julian = -1095
       max_julian = 1827933925
!
       IF ((julian .LT. min_julian) .OR. (julian .GT. max_julian)) THEN
          write(6,*)'Value of Julian date is out of allowed range.'
          stop
       ENDIF

       igreg = 2299161    !Beginning of Gregorian calendar

       ja=0
       IF (julian .GE. igreg) THEN    ! all are Gregorian
          jalpha = INT(((julian - 1867216) - 0.25d0) / 36524.25d0)
          ja = julian + 1 + jalpha - INT(0.25d0 * jalpha)
       ENDIF

       jb = ja + 1524
       jc = INT(6680d0 + ((jb-2439870)-122.1d0)/365.25d0)
       jd = INT(365d0 * jc + (0.25d0 * jc))
       je = INT((jb - jd) / 30.6001d0)

       day = jb - jd - INT(30.6001d0 * je)
       month = je - 1
       month = MOD((month - 1),12) + 1
       year = jc - 4715
       if (month .gt. 2) year = year - 1
       if (year .le. 0) year = year - 1

       END
! 
!----------------------------------------------------------------------      
! NAME:
!	GET_DOY
!
! PURPOSE:
!	Calculate the day of year for a given month, day, and year.
!
!
! CALLING SEQUENCE:
!	Result = GET_DOY(Year,Month, Day)
!
! INPUTS:
!	MONTH:	Number of the desired month (1 = January, ..., 12 = December).
!
!	DAY:	Number of day of the month.
!
!	YEAR:	Number of the desired year.Year parameters must be valid
!               values from the civil calendar.  Years B.C.E. are represented
!               as negative integers.  Years in the common era are represented
!               as positive integers.  In particular, note that there is no
!               year 0 in the civil calendar.  1 B.C.E. (-1) is followed by
!               1 C.E. (1).
!
! OUTPUTS:
!	GET_DOY returns the day of year of the specified calendar date.
!-----------------------------------------------------------------------
       FUNCTION GET_DOY (year,month,day)
!
       IMPLICIT NONE
!
       INTEGER*4 GET_DOY,JULDAY,year,month,day
       INTEGER*4 firstJanuary
!
       firstJanuary=JULDAY(year,01,01)
       GET_DOY=JULDAY(year,month,day)-firstJanuary+1
       END 
!----------------------------------------------------------------------      
! NAME:
!	DOY_AND_UT2DATE_AND_TIME
!
! PURPOSE:
!	Calculate month, day, and year from year and day of year.
!       Calulate time (hour, minute, second) from UT
!
! CALLING SEQUENCE:
!	CALL DOY_AND_UT2DATE_AND_TIME(Year,Doy,UT, Month, Day, hour, minute, second)
!
! INPUTS:
!	YEAR:	Number of the desired year.Year parameters must be valid
!               values from the civil calendar.  Years B.C.E. are represented
!               as negative integers.  Years in the common era are represented
!               as positive integers.  In particular, note that there is no
!               year 0 in the civil calendar.  1 B.C.E. (-1) is followed by
!               1 C.E. (1).
!
!	DOY:    The day of year of the specified calendar date.
!
!       UT:     Universal time in seconds
!
! OUTPUTS:
!	MONTH:	Number of the desired month (1 = January, ..., 12 = December).
!
!	DAY:	Number of day of the month.
!
!	hour, minute second: time
!-----------------------------------------------------------------------
       SUBROUTINE DOY_AND_UT2DATE_AND_TIME(Year,Doy,UT, Month, Day, 
     &            hour, minute, second)
!
       IMPLICIT NONE
!
       INTEGER*4 jd,year,month,day,doy
       INTEGER*4 hour,minute,second
       INTEGER*4 firstJanuary,julday
       REAL*8    UT
!
       firstJanuary=JULDAY(year,01,01)
       jd=doy+firstJanuary-1
       CALL CALDAT(jd, year,month, day)
       hour=int(UT/3600)
       minute=int((UT-hour*3600)/60)
       second=int(UT-hour*3600.-minute*60.)
       END 
!            
!----------------------------------------------------------------------      
! NAME:
!	DECY2DATE_AND_TIME
!
! PURPOSE:
!	Calculate the date and time (yeay,month,day of month, day of year, hour, minute and second and
!         Universal Time).
!
!
! CALLING SEQUENCE:
!	CALL DECY2DATE_AND_TIME(Dec_y,Year,Month, Day, doy, hour,minute,second)
!
! INPUTS:
!       DEC_Y : Decimal year where yyyy.0d0 is January 1st at 00:00:00
!
! OUTPUTS:
!	YEAR:	Number year.Year parameters must be valid
!               values from the civil calendar.  Years B.C.E. are represented
!               as negative integers.  Years in the common era are represented
!               as positive integers.  In particular, note that there is no
!               year 0 in the civil calendar.  1 B.C.E. (-1) is followed by
!               1 C.E. (1).
!
!	MONTH:	Number  month (1 = January, ..., 12 = December).
!
!	DAY:	Number of day of the month.
!
!	DOY: Number of day of year (DOY=1 is for January 1st)
!
!       HOUR, MINUTE and SECOND: Universal time in the day
!
!      UT: Univeral time in seconds
!
!-----------------------------------------------------------------------
       SUBROUTINE DECY2DATE_AND_TIME (dec_y,year,month, day, doy, 
     &           hour,minute,second,UT)
!
       IMPLICIT NONE
!
       INTEGER*4 I
       INTEGER*4 JULDAY,year,month,day,doy,hour,minute,second
       INTEGER*4 firstJanuary,lastDecember,Ndays
       INTEGER*4 dom_n(12),dom_b(12),dom(12),tmp
!
       REAL*8  dec_y,aux,UT
!
       DATA  dom_n /31,28,31,30,31,30,31,31,30,31,30,31/
       DATA  dom_b /31,29,31,30,31,30,31,31,30,31,30,31/
!       
       year=INT(dec_y)
       firstJanuary=JULDAY(year,01,01)
       lastDecember=JULDAY(year,12,31)
       Ndays=lastDecember-firstJanuary+1
       IF (Ndays.EQ.365) THEN
          DO I=1,12
	     dom(I)=dom_n(I)
	  ENDDO
       ELSE
          DO I=1,12
	     dom(I)=dom_b(I)
	  ENDDO
       ENDIF
       aux=(dec_y-year*1.d0)*Ndays
       doy=INT(aux)+1
!
       tmp=0       
       DO I=1,12
          tmp=tmp+dom(I)
	  IF (tmp .GE. doy) GOTO 10
       ENDDO
10     CONTINUE
       month = I
       tmp=tmp-dom(I)
       day = doy-tmp
!
       aux=(aux-(doy-1)*1.d0)*24.d0
       hour=INT(aux)
       aux=(aux-hour*1.d0)*60.d0
       minute=INT(aux)
       aux=(aux-minute*1.d0)*60.d0
       second=INT(aux)
!
       UT=hour*3600.0d0+minute*60.0d0+second*1.0d0
       END 
       
!-------------------------------------------------------------------------
! NAME:
!	DATE_AND_TIME2DECY
!
! PURPOSE:
!	Return the decimal year for a given date and time.
! CALLING SEQUENCE:
!	CALL DATE_2_DECY(Year, Month, Day, hour,minute,second,decy)
!
! INPUTS:
!	MONTH:	Number of the desired month (1 = January, ..., 12 = December).
!
!	DAY:	Number of day of the month.
!
!	YEAR,HOUR,MINUTE,SECOND.
!
! OUTPUTS:
!       decy : decimal year for a given date and time
!-------------------------------------------------------------------------
!
       SUBROUTINE DATE_AND_TIME2DECY(Year,Month,Day,hour,minute
     &,second,decy)
!
       IMPLICIT NONE
!
       INTEGER*4 Year, Month, Day, hour,minute,second
       INTEGER*4 firstJanuary,lastDecember,xut1
       INTEGER*4 julday
!
       REAL*8 decy
!
       firstJanuary=julday(Year,01,01)
       lastDecember=julday(Year,12,31)
       xut1=julday(Year,month,day)
      
       decy=Year*1.d0+(xut1-firstJanuary
     &      +(hour*3600.d0+minute*60.d0+second*1.d0)
     &       /86400.d0)/(lastDecember-firstJanuary+1.d0)

       end

!--------------------------------------------------------------------------

! This function returns TT seconds from J2000.0 for
! a given UTC date and time.
! NAME: QCDFTDB
! INPUT: year,month,day,hour,minute,sec,msec or arrays thereof
!              UTC date and time (from 1/1/1972), UT1 time for 1900-1972
! KEYWORDS: cdfepoin  calculate UTC date from CDF epoch value first
! OUTPUT: TT (~TDB) seconds from J2000.0 (1/1/2000 12:00 TDB)
! RESTRICTIONS: for array input before 2000.0 it works only if timespan
!               less than 6 months. Also does not work when array spans
!               years before and after 2000.
!
! HISTORY: created by m.fraenz@qmw.ac.uk 23/8/2001
!       03/12/2001 array input MF
!       addapted for IRBEM - A. C. Kellerman 01/02/2012
!

      FUNCTION QCDFTDB (year,month,day,hour,minute,sec,msec)
      IMPLICIT NONE
      INTEGER*4 year, month, day, hour, minute
      INTEGER*4 sec, msec, yarr(23), marr(23)
      INTEGER*4 jd, i, index0, yvar

      REAL*8 cdfepoin, deltat, theta, jsec, QCDFTDB

      ! some of this may be repetative from above
      ! calculate Julian Date from J2000 (Seidelmann 12.92):
      yvar=year+4800+(month-14)/12
      jd=(yvar*1461)/4
      jd=jd+((month-2-((month-14)/12)*12)*367)/12
      jd=jd-2451545 ! subtract jd2000.0 to keep numbers small
      yvar=yvar+100
      jd=1D0*(jd-((yvar/100)*3)/4+day-32076)+0.5d0 ! for 00:00

      ! convert to seconds and add seconds of day:
      jsec=jd*86400d0
      jsec=jsec+hour*3600d0
      jsec=jsec+minute*60d0
      jsec=jsec+sec+1D0
      jsec=jsec+msec/1000d0
      ! now add leapseconds:
      IF (year.GE.2000) then
          deltat=63.184d0
      ELSE IF (year.GE.1972) THEN
          deltat=42.184d0
      DATA yarr / 1972,1973,1974,1975,1976,1977,1978,1979,1980,1981,
     *1982,1983,1985,1988,1990,1991,1992,1993,1994,1996,1997,1999,3000/
      DATA marr / 7,1,1,1,1,1,1,1,1,7,7,7,7,1,1,1,7,7,7,1,7,1,0 /

      i=1
100   IF (year.GE.yarr(i)) then
        deltat=deltat+1d0
        i=i+1
        goto 100
      endif
      IF ((i.LT.22).AND.(month.LT.marr(i-1))) deltat=deltat-1d0
      ELSE IF (year.GE.1900) THEN
        theta=(jsec/86400d0/36525d0)+1D0 ! Julian centuries from 1900.0
      deltat=((((((((58353.42d0*theta-232424.66d0)*theta+372919.88d0)
     **theta-303191.19d0)*theta+124906.15d0)*theta-18756.33d0)*
     *theta-2637.8d0)*theta+815.20d0)*theta+87.24)*theta-2.44d0
      ELSE
        deltat=0d0
      END IF
      jsec=jsec+deltat

      QCDFTDB = jsec
      END

!***************************************************************************************************
! Copyright  2009 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C
C
       SUBROUTINE field_line_tracing_towards_Earth(
     &         lati,longi,alti,dsreb,posit,Nposit)
C
       IMPLICIT NONE
       
       INTEGER*4  Nreb
       PARAMETER (Nreb = 150)
       REAL*8     xx0(3)
       REAL*8     lati,longi,alti
       REAL*8     dsreb
       INTEGER*4  Nposit
       REAL*8     posit(3,20*Nreb)

       CALL GDZ_GEO(lati,longi,alti,xx0(1),xx0(2),xx0(3))
C
       call field_line_tracing_towards_Earth_opt(
     &         xx0,dsreb,posit,Nposit)

       RETURN
       END

       SUBROUTINE field_line_tracing_towards_Earth_opt(
     &         xx0,dsreb,posit,Nposit)
C
       IMPLICIT NONE
       INCLUDE 'variables.inc'
C
       INTEGER*4  Nreb
       PARAMETER (Nreb = 150)
C
       INTEGER*4  Nrebmax
       REAL*8     rr,rr2
       REAL*8     xx0(3),xx(3),x1(3),x2(3)
       REAL*8     xmin(3)
       REAL*8     lati,longi,alti
       REAL*8     B(3),Bl,B0,Bmin,B1,B3
       REAL*8     dsreb

       INTEGER*4  J,ind,Ifail
       INTEGER*4  Nposit
C
       REAL*8     posit(3,20*Nreb)
C
       Nrebmax = 20*Nreb
C
       CALL CHAMP(xx0,B,B0,Ifail)
       IF (Ifail.LT.0) THEN
         RETURN
       ENDIF
       Bmin = B0
C
C calcul du sens du depart
C
       CALL sksyst(-dsreb,xx0,x1,Bl,Ifail)
       IF (Ifail.LT.0) THEN
         RETURN
       ENDIF
       B1 = Bl
       CALL sksyst(dsreb,xx0,x2,Bl,Ifail)
       IF (Ifail.LT.0) THEN
         RETURN
       ENDIF
       B3 = Bl
C
       IF (B3.LT.B1) THEN
         dsreb = -dsreb
       ENDIF
C
c trace la ligne de champ complete.
c
       x1(1) = xx0(1)
       x1(2) = xx0(2)
       x1(3) = xx0(3)
       ind=1
       Nposit=ind
       posit(1,ind)=x1(1)
       posit(2,ind)=x1(2)
       posit(3,ind)=x1(3)
       DO J = 1,Nrebmax
         CALL sksyst(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) RETURN
         ind=ind+1
         posit(1,ind)=x2(1)
         posit(2,ind)=x2(2)
         posit(3,ind)=x2(3)
c        write(6,*)J,x1(1),x1(2),x1(3),Bl
         rr2 = x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3)
         IF (rr2.LT.1.) GOTO 201
         x1(1) = x2(1)
         x1(2) = x2(2)
         x1(3) = x2(3)
         if (ind .eq. Nrebmax) goto 201
       ENDDO
201    CONTINUE
       Nposit=ind
       RETURN
       END
C

C This is a set of replacement routines written by Jay Albert, that improve 
C execution time by reducing calls to bessj
C
C Tested by A. C. Kellerman against the original, output was identical
C for 10,000 points R = 1:10 across 24 MLT sectors
C=======================================================================
        SUBROUTINE  SHTBNORM_E_2015(K,L,X,Y,Z,FX,FY,FZ) ! modified SHTBNORM_E
        IMPLICIT  REAL * 8  (A - H, O - Z)
        DIMENSION AK(5)
        DIMENSION AJM(0:14),AJMD(0:14)
        COMMON /TSE/ TSE(80,5,4)

        AK(1)=TSE(76,K,L)
        AK(2)=TSE(77,K,L)
        AK(3)=TSE(78,K,L)
        AK(4)=TSE(79,K,L)
        AK(5)=TSE(80,K,L)

        phi=DATAN2(Y,X)
        RHO=dsqrt(X*X+Y*Y)
        if(RHO.lt.1.D-8) then
           RHOI=1.D8
        else
           RHOI=1.D0/RHO
        endif
        DPDX=-Y*RHOI*RHOI
        DPDY= X*RHOI*RHOI

        FX=0.D0
        FY=0.D0
        FZ=0.D0

        DO 2 n=1,5
           AKN=dabs(AK(n))
           AKNR=AKN*RHO
           if(AKNR.lt.1.D-8) then
              AKNRI=1.D8
           else
              AKNRI=1.D0/AKNR
           endif

           CHZ=dcosh(Z*AKN)
           SHZ=dsinh(Z*AKN)

           AJM(0)=BESSJJ_2015(14,AKNR, AJM(1)) !!! get all n in one call
           DO 3 m=1,14
              AJMD(m)=AJM(m-1)-m*AJM(m)*AKNRI
  3        CONTINUE
           AJMD(0)=-AJM(1)

           DO 4 m=0,14
              CMP=DCOS(m*phi)
              SMP=DSIN(m*phi)

              HX1=-m*DPDX*CMP*SHZ*AJM(m)
              HX2=-AKN*X*RHOI*SMP*SHZ*AJMD(m)
              HX=HX1+HX2
              HY1=-m*DPDY*CMP*SHZ*AJM(m)
              HY2=-AKN*Y*RHOI*SMP*SHZ*AJMD(m)
              HY=HY1+HY2
              HZ=-AKN*SMP*CHZ*AJM(m)

              L1=n+5*m
              FX=FX+HX*TSE(L1,K,L)
              FY=FY+HY*TSE(L1,K,L)
              FZ=FZ+HZ*TSE(L1,K,L)
  4        CONTINUE
  2     CONTINUE
      RETURN
      END
C==---------------------------------------------------------------------
        SUBROUTINE  SHTBNORM_O_2015(K,L,X,Y,Z,FX,FY,FZ) ! modified SHTBNORM_O
        IMPLICIT  REAL * 8  (A - H, O - Z)
        DIMENSION AK(5)
        DIMENSION AJM(0:14),AJMD(0:14)
        COMMON /TSO/ TSO(80,5,4)

        AK(1)=TSO(76,K,L)
        AK(2)=TSO(77,K,L)
        AK(3)=TSO(78,K,L)
        AK(4)=TSO(79,K,L)
        AK(5)=TSO(80,K,L)

        phi=DATAN2(Y,X)
        RHO=dsqrt(X*X+Y*Y)
        if(RHO.lt.1.D-8) then
           RHOI=1.D8
        else
           RHOI=1.D0/RHO
        endif
        DPDX=-Y*RHOI*RHOI
        DPDY= X*RHOI*RHOI

        FX=0.D0
        FY=0.D0
        FZ=0.D0

        DO 2 n=1,5
           AKN=dabs(AK(n))
           AKNR=AKN*RHO
           if(AKNR.lt.1.D-8) then
              AKNRI=1.D8
           else
              AKNRI=1.D0/AKNR
           endif

           CHZ=dcosh(Z*AKN)
           SHZ=dsinh(Z*AKN)

           AJM(0)=BESSJJ_2015(14,AKNR, AJM(1)) !!! get all n in one call
           DO 3 m=1,14
              AJMD(m)=AJM(m-1)-m*AJM(m)*AKNRI
  3        CONTINUE
           AJMD(0)=-AJM(1)

           DO 4 m=0,14
              CMP=DCOS(m*phi)
              SMP=DSIN(m*phi)

              HX1=m*DPDX*SMP*SHZ*AJM(m)
              HX2=-AKN*X*RHOI*CMP*SHZ*AJMD(m)
              HX=HX1+HX2
              HY1=m*DPDY*SMP*SHZ*AJM(m)
              HY2=-AKN*Y*RHOI*CMP*SHZ*AJMD(m)
              HY=HY1+HY2
              HZ=-AKN*CMP*CHZ*AJM(m)

              L1=n+5*m
              FX=FX+HX*TSO(L1,K,L)
              FY=FY+HY*TSO(L1,K,L)
              FZ=FZ+HZ*TSO(L1,K,L)
  4        CONTINUE
  2     CONTINUE
        RETURN
        END
C==---------------------------------------------------------------------
        SUBROUTINE  SHTBNORM_S_2015(K,X,Y,Z,FX,FY,FZ) ! modified SHTBNORM_S
        IMPLICIT  REAL * 8  (A - H, O - Z)
        DIMENSION AK(5)
        DIMENSION AJM(0:14),AJMD(0:14)
        COMMON /TSS/ TSS(80,5)

        AK(1)=TSS(76,K)
        AK(2)=TSS(77,K)
        AK(3)=TSS(78,K)
        AK(4)=TSS(79,K)
        AK(5)=TSS(80,K)

        phi=DATAN2(Y,X)
        RHO=dsqrt(X*X+Y*Y)
        if (RHO.lt.1.D-8) then
           RHOI=1.D8
        else
           RHOI=1.D0/RHO
        endif
        DPDX=-Y*RHOI*RHOI
        DPDY= X*RHOI*RHOI

        FX=0.D0
        FY=0.D0
        FZ=0.D0

        DO 2 n=1,5
           AKN=dabs(AK(n))
           AKNR=AKN*RHO
           if (AKNR.lt.1.D-8) then
              AKNRI=1.D8
           else
              AKNRI=1.D0/AKNR
           endif

           CHZ=dcosh(Z*AKN)
           SHZ=dsinh(Z*AKN)

           AJM(0)=BESSJJ_2015(14,AKNR, AJM(1)) !!! get all n in one call
           DO 3 m=1,14
              AJMD(m)=AJM(m-1)-m*AJM(m)*AKNRI
    3      CONTINUE
           AJMD(0)=-AJM(1)

           DO 4 m=0,14
              CMP=DCOS(m*phi)
              SMP=DSIN(m*phi)
   
              HX1=m*DPDX*SMP*SHZ*AJM(m)
              HX2=-AKN*X*RHOI*CMP*SHZ*AJMD(m)
              HX=HX1+HX2
              HY1=m*DPDY*SMP*SHZ*AJM(m)
              HY2=-AKN*Y*RHOI*CMP*SHZ*AJMD(m)
              HY=HY1+HY2
              HZ=-AKN*CMP*CHZ*AJM(m)
   
              L=n+5*m
              FX=FX+HX*TSS(L,K)
              FY=FY+HY*TSS(L,K)
              FZ=FZ+HZ*TSS(L,K)
  4        CONTINUE
  2     CONTINUE
        RETURN
        END
C==---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION BESSJJ_2015(n,x, bessJ)
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension bessJ(n) ! BESSJJ_2015 returns J0, bessJ holds J1 to Jn
      PARAMETER (IACC=40,BIGNO=1.D10,BIGNI=1.D-10)
CU    USES bessj0,bessj1
      if(n.lt.2) then
         print *,' *** bad argument n in BESSJJ_2015'
         stop
      endif
      ax=Dabs(x)
      if(ax.eq.0.D0)then
        BESSJJ_2015=0.
      else if(ax.gt.Dfloat(n))then
        tox=2.D0/ax
        bjm=bessj0(ax)
        bj =bessj1(ax)
        BESSJJ_2015  =bjm ! J0(x)
        bessJ(1)=bj  ! J1(x)
        do 11 j=1,n-1
          bjp=j*tox*bj-bjm
          bjm=bj
          bj=bjp
          bessJ(j+1)=bjp ! J_j+1(x)
11      continue
      else
         tox=2.D0/ax
         m=2*((n+int(Dsqrt(Dfloat(IACC*n))))/2)
         jsum=0
         sum=0.D0
         bjp=0.D0
         bj =1.D0
         do i=1,n
            bessJ(i)=0.
         enddo
   
         do 12 j=m,1,-1
            bjm=j*tox*bj-bjp
            bjp=bj
            bj=bjm
   
            if (Dabs(bj).gt.BIGNO) then
               bj =bj *BIGNI
               bjp=bjp*BIGNI
               sum=sum*BIGNI
   	    do i=j+1,n
   	       bessJ(i)=bessJ(i)*BIGNI
               enddo
            endif
   
            if(jsum.ne.0)sum=sum+bj
            jsum=1-jsum
            if(j.le.n) bessJ(j)=bjp ! Jj(x)
   12    continue
   
         sum=2.D0*sum-bj
         do i=1,n
            bessJ(i)=bessJ(i)/sum
         enddo
         BESSJJ_2015=bj/sum ! J0(x)
      endif

      if (x .lt. 0.D0) then
         do i=1,n,2
            bessJ(i)=-bessJ(i)
         enddo
      endif
      return
      END
C=======================================================================

!***************************************************************************************************
! Copyright 2003, 2004, D. Boscher, S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C Boscher modifie pour la nieme fois le 4Feb2004
C A. C. Kellerman added code to exit search along NH FL when Nrebmax is reached Jan, 2017
C
C
       SUBROUTINE calcul_Lstar(t_resol,r_resol,
     &         lati,longi,alti,Lm,Lstar,leI0,B0,Bmin)
C
       IMPLICIT NONE
C
       INTEGER*4  t_resol,r_resol
       REAL*8     xx0(3)
       REAL*8     lati,longi,alti
       REAL*8     B0,Bmin
       REAL*8     Lm,Lstar
       REAL*8     leI0
C
       CALL GDZ_GEO(lati,longi,alti,xx0(1),xx0(2),xx0(3))
C
       call calcul_Lstar_opt(t_resol,r_resol,
     &         xx0,Lm,Lstar,leI0,B0,Bmin)

       RETURN
       END
       SUBROUTINE calcul_Lstar_opt(t_resol,r_resol,
     &         xx0,Lm,Lstar,leI0,B0,Bmin)
C
       IMPLICIT NONE
       INCLUDE 'variables.inc'
C
       INTEGER*4  Nreb_def,Nder_def,Ntet_def
       PARAMETER (Nreb_def = 50, Nder_def = 25, Ntet_def = 720)
C
       INTEGER*4  Nder,Nreb,Ntet
       INTEGER*4  k_ext,k_l,kint,n_resol,t_resol,r_resol
       INTEGER*4  Nrebmax
       REAL*8     rr,rr2
       REAL*8     xx0(3),xx(3),x1(3),x2(3)
       REAL*8     xmin(3)
       REAL*8     lati,longi,alti
       REAL*8     B(3),Bl,B0,Bmin,B1,B3
       REAL*8     dsreb,smin

       INTEGER*4  I,J,Iflag,Iflag_I,Ilflag,Ifail,Iflag3
       REAL*8     Lm,Lstar,Lb
       REAL*8     leI,leI0,leI1
       REAL*8     XY,YY
       REAL*8     aa,bb
C
       REAL*8     tt
       REAL*8     tet(10*Nder_def),phi(10*Nder_def)
       REAL*8     tetl,tet1,dtet
       REAL*8     somme,BrR2
       REAL*8     Bmin3,x3(3),xmin3(3),Bl3,rr32,x13(3),Bl13,ds3
C
       REAL*8     Bo,xc,yc,zc,ct,st,cp,sp
C
       COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
       COMMON /calotte/tet
       COMMON /flag_L/Ilflag
       COMMON /magmod/k_ext,k_l,kint
       REAL*8     pi,rad
       common /rconst/rad,pi
C
C
       Nder=Nder_def*r_resol
       Nreb=Nreb_def
       Ntet=Ntet_def*t_resol
       dtet = pi/Ntet
C
       Nrebmax = 20*Nreb
C
       Lm = baddata
       Lstar = baddata
       leI0 = baddata
C
       CALL GEO_SM(xx0,xx)
       rr = SQRT(xx(1)*xx(1)+xx(2)*xx(2)+xx(3)*xx(3))
       tt = ACOS(xx(3)/rr)
       Lb  = rr/SIN(tt)/SIN(tt)
c       write(6,*)'L bete ',Lb
C
       CALL CHAMP(xx0,B,B0,Ifail)
       IF (Ifail.LT.0) THEN
	  B0=baddata
          leI0 = baddata
          Bmin = baddata
          Ilflag = 0
	  RETURN
       ENDIF
       Bmin = B0
C
       dsreb = Lb/Nreb
C
C calcul du sens du depart
c"calculation of the direction of the departure"
C
       CALL sksyst(-dsreb,xx0,x1,Bl,Ifail)
       IF (Ifail.LT.0) THEN
          leI0 = baddata
          Bmin = baddata
          Ilflag = 0
	  RETURN
       ENDIF
       B1 = Bl
       CALL sksyst(dsreb,xx0,x2,Bl,Ifail)
       IF (Ifail.LT.0) THEN
          leI0 = baddata
          Bmin = baddata
          Ilflag = 0
	  RETURN
       ENDIF
       B3 = Bl
C
C attention cas equatorial
C
       IF(B1.GT.B0 .AND. B3.GT.B0)THEN
         aa = 0.5D0*(B3+B1-2.D0*B0)
         bb = 0.5D0*(B3-B1)
         smin = -0.5D0*bb/aa
         Bmin = B0 - aa*smin*smin
         leI0 = SQRT(1.D0-Bmin/B0)*2.D0*ABS(smin*dsreb)
         Lm = (Bo/Bmin)**(1.D0/3.D0)
c         write(6,*)'L McIlwain eq ',B0,leI0,Lm
         GOTO 100
       ENDIF
       IF (B3.GT.B1) THEN
         dsreb = -dsreb
       ENDIF
C
C calcul de la ligne de champ et de I
c "calculation of the field line and I"
C
       Bmin = B0
       leI = 0.D0
       DO I = 1,3
         x1(I)  = xx0(I)
       ENDDO
C
c       write(6,*)dsreb
       DO J = 1,Nrebmax
         CALL sksyst(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) THEN
            leI0 = baddata
            Bmin = baddata
            Ilflag = 0
	        RETURN
         ENDIF
c	 write(6,*)J,x1(1),x1(2),x1(3),Bl
         IF (Bl.LT.Bmin) THEN
           xmin(1) = x2(1)
           xmin(2) = x2(2)
           xmin(3) = x2(3)
           Bmin = Bl
         ENDIF
         IF (Bl.GT.B0) GOTO 20
        x1(1) = x2(1)
        x1(2) = x2(2)
        x1(3) = x2(3)
         leI = leI + SQRT(1.D0-Bl/B0)
        B1 = Bl
       ENDDO
20     CONTINUE
c	write(6,*)J,leI
C
       IF (J.GE.Nrebmax) THEN !open field line
          leI0 = baddata
          Bmin = baddata
          Ilflag = 0
	  RETURN
       ENDIF
C
       leI = leI+0.5D0*SQRT(1.D0-B1/B0)*(B0-Bl)/(Bl-B1)
       leI = leI*ABS(dsreb)
       leI0 = leI
C
C calcul de L Mc Ilwain (Mc Ilwain-Hilton)
C
       XY = leI*leI*leI*B0/Bo
C->Lm B0 constant###       XY = leI*leI*leI*B0/(31165.3)
       YY = 1.D0 + 1.35047D0*XY**(1.D0/3.D0)
     &      + 0.465376D0*XY**(2.D0/3.D0)
     &      + 0.0475455D0*XY
       Lm = (Bo*YY/B0)**(1.D0/3.D0)
C->Lm B0 constant###       Lm = ((31165.3)*YY/B0)**(1.D0/3.D0)
c       write(6,*)'L McIlwain ',B0,leI0,Lm
C
C calcul de Bmin
C
       CALL sksyst(dsreb,xmin,x1,B3,Ifail)
       IF (Ifail.LT.0) THEN
          Bmin = baddata
          Ilflag = 0
	  RETURN
       ENDIF
       CALL sksyst(-dsreb,xmin,x1,B1,Ifail)
       IF (Ifail.LT.0) THEN
          Bmin = baddata
          Ilflag = 0
	  RETURN
       ENDIF
       aa = 0.5D0*(B3+B1-2.D0*Bmin)
       bb = 0.5D0*(B3-B1)
       smin = -0.5D0*bb/aa
       Bmin = Bmin - aa*smin*smin
       IF (x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3).LT.1.D0) THEN
        Lm = -Lm
       ENDIF
C
100    CONTINUE
       if (k_l .eq.0) then
          Ilflag = 0
	  RETURN
       endif
       IF (ABS(Lm) .GT. 10.D0) THEN
        Ilflag = 0
        RETURN
       ENDIF
C
C derive
C
C
c "calculation of the point of the field line on the surface 
c    of the earth of the northern slope(?)"
C calcul du point sur la ligne de champ a la surface de la terre du
C cote nord
C
        DO I = 1,3
            x1(I)  = xx0(I)
        ENDDO
            dsreb = ABS(dsreb)
        DO J = 1,Nrebmax
            CALL sksyst(dsreb,x1,x2,Bl,Ifail)
            IF (Ifail.LT.0) THEN
                Ilflag = 0
                RETURN
            ENDIF
            rr = sqrt(x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3))
            IF (rr.LT.1.D0) GOTO 102
c need to return if we past here at Nrebmax, as we will end
c up with /0 error at smin below
            IF (J.EQ.Nrebmax) THEN
                Ilflag = 0
                RETURN
            ENDIF
            x1(1) = x2(1)
            x1(2) = x2(2)
            x1(3) = x2(3)
        ENDDO
102    CONTINUE
       smin = sqrt(x1(1)*x1(1)+x1(2)*x1(2)+x1(3)*x1(3))
       smin = (1.D0-smin)/(rr-smin)
       CALL sksyst(smin*dsreb,x1,x2,Bl,Ifail)
       IF (Ifail.LT.0) THEN
          Ilflag = 0
	  RETURN
       ENDIF
       rr = sqrt(x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3))
       tet(1) = ACOS(x2(3)/rr)
       phi(1) = ATAN2(x2(2),x2(1))
C
c "and one turns" -> "one shifts on surface in phi and one seeks teta 
c    to have the constant IO and BO"
C et on tourne -> on se decale sur la surface en phi et on cherche teta
C pour avoir leI0 et B0 constants
C
       dsreb = -dsreb
       DO I = 2,Nder
        phi(I) = phi(I-1)+2.D0*pi/Nder
        Iflag_I = 0
c	write(6,*)tet(I)
	IF (Ilflag.EQ.0) THEN
         tetl = tet(I-1)
	 IF (I.GT.2) tetl = 2.D0*tet(I-1)-tet(I-2)
         tet1 = tetl
	ELSE
	 tetl = tet(I)
	 tet1 = tetl
	ENDIF
c	write(6,*)tetl
c	read(5,*)
	leI1 = baddata
C
107     CONTINUE
        x1(1) = SIN(tetl)*COS(phi(I))
        x1(2) = SIN(tetl)*SIN(phi(I))
        x1(3) = COS(tetl)
        Iflag = 0
        leI = baddata
C
        DO J = 1,Nrebmax
         CALL sksyst(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) THEN
            Ilflag = 0
	    RETURN
	 ENDIF
         rr2 = x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3)
	 IF (Bl.LT.B0) THEN
	  IF (Iflag .EQ. 0) THEN
	    CALL CHAMP(x1,B,B1,Ifail)
	    IF (Ifail.LT.0) THEN
               Ilflag = 0
	       RETURN
	    ENDIF
	    leI = 0.5D0*SQRT(1.D0-Bl/B0)*(1.D0+(Bl-B0)/(Bl-B1))
	    Iflag = 1
	  ELSE
	    leI = leI+SQRT(1.D0-Bl/B0)
	  ENDIF
	 ENDIF
         IF (Bl.GT.B0 .AND. Iflag.EQ.1) GOTO 103
	 IF (rr2.LT.1.D0) GOTO 103
	 x1(1) = x2(1)
	 x1(2) = x2(2)
	 x1(3) = x2(3)
c	 write(6,*)J,Bl,B0,leI*ABS(dsreb)
        ENDDO
103     CONTINUE
c Pourquoi?  "why?"
        IF (rr2.LT.1.D0) THEN
         leI = baddata
	ENDIF
        IF (J.LT.Nrebmax .AND. rr2.GE.1.D0) THEN
            CALL CHAMP(x1,B,B1,Ifail)
	    IF (Ifail.LT.0) THEN
               Ilflag = 0
	       RETURN
	    ENDIF
            leI = leI+0.5D0*SQRT(1.D0-B1/B0)*(B0-Bl)/(Bl-B1)
            leI = leI*ABS(dsreb)
	ENDIF
c	write(6,*)I,tetl,leI,leI0,J
C
        IF (Iflag_I .EQ.0) THEN
	 IF (J.GE.Nrebmax) THEN
	  tetl = tetl-dtet
         ELSE
	  tetl = tetl+dtet
	 ENDIF
	 leI1 = leI
	 tet1 = tetl
	 Iflag_I = 1
	 GOTO 107
	ENDIF
	IF ((leI-leI0)*(leI1-leI0) .LT. 0.D0) GOTO 108
	leI1 = leI
	tet1 = tetl
	IF (leI.LT.leI0) THEN
	 tetl = tetl-dtet
	ElSE
	 tetl = tetl+dtet
	ENDIF
	IF (tetl.GT.pi .OR. tetl.LT.0.D0) GOTO 108
	GOTO 107
108     CONTINUE
        tet(I) = 0.5D0*(tetl+tet1)
c	read(5,*)
	IF (J.GE.Nrebmax .AND. leI.GT.0.D0) THEN
	 Ilflag = 0
	 RETURN
	ENDIF
C
        x1(1) = SIN(tet(I))*COS(phi(I))
        x1(2) = SIN(tet(I))*SIN(phi(I))
        x1(3) = COS(tet(I))
	CALL CHAMP(x1,B,Bl,Ifail)
	IF (Ifail.LT.0) THEN
	   Ilflag = 0
	   RETURN
	ENDIF
	IF (Bl.LT.B0) THEN
	 Ilflag = 0
	 RETURN
	ENDIF

C rajout D. Boscher 25 Mars 2009
       Bmin3 = Bl
       xmin3(1) = x1(1)
       xmin3(2) = x1(2)
       xmin3(3) = x1(3)
       x13(1) = x1(1)
       x13(2) = x1(2)
       x13(3) = x1(3)
       Iflag3 = 0
       DO J = 1,Nrebmax
         CALL sksyst(dsreb,x13,x3,Bl3,Ifail)
         IF (Bl3 .GT. Bl) GOTO 203
         IF (Bl3.LT.Bmin3) THEN
           xmin3(1) = x3(1)
           xmin3(2) = x3(2)
           xmin3(3) = x3(3)
           Bmin3 = Bl3
         ENDIF
         IF (Bl3 .LT. B0) Iflag3 = 1    !test pas a l'equateur
         x13(1) = x3(1)
         x13(2) = x3(2)
         x13(3) = x3(3)
       ENDDO
203    CONTINUE
       rr32 = xmin3(1)*xmin3(1)+xmin3(2)*xmin3(2)+xmin3(3)*xmin3(3)
       IF (rr32 .LT. 1.03d0) GOTO 303
       IF (Iflag3 .EQ. 1) THEN
         x13(1) = x1(1)
         x13(2) = x1(2)
         x13(3) = x1(3)
         Bl13 = Bl
         DO J=1,Nrebmax
           CALL sksyst(dsreb,x13,x3,Bl3,Ifail)
           IF (Bl3 .LT. B0) GOTO 204
           x13(1) = x3(1)
           x13(2) = x3(2)
           x13(3) = x3(3)
           Bl13 = Bl3
       ENDDO
204    CONTINUE
        ds3 = dsreb*(B0-Bl13)/(Bl3-Bl13)
        CALL sksyst(ds3,x13,x3,Bl3,Ifail)
        rr32  = x3(1)*x3(1)+x3(2)*x3(2)+x3(3)*x3(3)
        IF (rr32 .LT. 1.03D0) GOTO 303
C
        x13(1) = x1(1)
        x13(2) = x1(2)
        x13(3) = x1(3)
        Bl13 = Bl
        Iflag3 = 0
        DO J=1,Nrebmax
         CALL sksyst(dsreb,x13,x3,Bl3,Ifail)
         IF (Bl3 .GT. Bl) GOTO 205
         IF (Bl3 .GT. B0 .AND. Iflag3 .EQ. 1) GOTO 205
         IF (Bl3 .LT. B0) Iflag3 = 1
         x13(1) = x3(1)
         x13(2) = x3(2)
         x13(3) = x3(3)
         Bl13 = Bl3
        ENDDO
205     CONTINUE
        IF (J .EQ. Nrebmax+1) GOTO 303
        ds3 = dsreb*(B0-Bl13)/(Bl3-Bl13)
        CALL sksyst(ds3,x13,x3,Bl3,Ifail)
        rr32  = x3(1)*x3(1)+x3(2)*x3(2)+x3(3)*x3(3)
        IF (rr32 .LT. 1.03D0) GOTO 303
       ENDIF
c end rajout
       ENDDO
303    CONTINUE
c       write(6,*)(tet(I),I=1,Nder)
c       read(5,*)
C
C calcul de somme de BdS sur la calotte nord
c "calculation of sum of BdS on the northern cap"
C
       IF (rr32 .LT. 1.03d0) THEN
         Ilflag = 0
         RETURN
       ENDIF
       x1(1) = 0.D0
       x1(2) = 0.D0
       x1(3) = 1.D0
       CALL CHAMP(x1,B,Bl,Ifail)
       IF (Ifail.LT.0)THEN
	   Ilflag = 0
	   RETURN
       ENDIF
       BrR2 = abs((x1(1)*B(1)+x1(2)*B(2)+x1(3)*B(3))) ! phi integrates B dot dA, or Br*R^2dphi*dtheta, R=1
       somme = BrR2*pi*dtet*dtet/4.D0
       DO I = 1,Nder
         tetl = 0.D0
         DO J = 1,Ntet
	  tetl = tetl+dtet
	  IF (tetl .GT. tet(I)) GOTO 111
          x1(1) = SIN(tetl)*COS(phi(I))
          x1(2) = SIN(tetl)*SIN(phi(I))
          x1(3) = COS(tetl)
          CALL CHAMP(x1,B,Bl,Ifail)
          IF (Ifail.LT.0)THEN
	      Ilflag = 0
	      RETURN
          ENDIF
          BrR2 = abs((x1(1)*B(1)+x1(2)*B(2)+x1(3)*B(3))) ! phi integrates B dot dA, or Br*R^2dphi*dtheta, R=1
	  somme = somme+BrR2*SIN(tetl)*dtet*2.D0*pi/Nder
	 ENDDO
111      CONTINUE
       ENDDO
       if (k_l .eq.1) Lstar = 2.D0*pi*Bo/somme
       if (k_l .eq.2) Lstar = somme  ! Phi and not Lstar
       IF (Lm.LT.0.D0) Lstar = -Lstar
       Ilflag = 1
C
       END
C
C***********************************************************************
C* RUNGE-KUTTA d'ordre 4
C***********************************************************************
        SUBROUTINE sksyst(h,xx,x2,Bl,Ifail)
C
        IMPLICIT NONE
C
        INTEGER*4  Ifail
        REAL*8 xx(3),x2(3)
        REAL*8 B(3),Bl
        REAL*8 h
        REAL*8 xwrk(4,3)
C
C-----------------------------------------------------------------------
C
c        write(6,*)'sksyst'
c        write(6,*)xx(1),xx(2),xx(3),h
        CALL CHAMP(xx,B,Bl,Ifail)
c	write(6,*)xx,B,Bl,Ifail
	IF (Ifail.LT.0) RETURN
c        write(6,*)'b',B(1),B(2),B(3),Bl
        xwrk(1,1) = h*B(1)/Bl
        xwrk(1,2) = h*B(2)/Bl
        xwrk(1,3) = h*B(3)/Bl
        x2(1) = xx(1)+xwrk(1,1)/2.D0
        x2(2) = xx(2)+xwrk(1,2)/2.D0
        x2(3) = xx(3)+xwrk(1,3)/2.D0
c        write(6,*)x2(1),x2(2),x2(3),Bl
C
        CALL CHAMP(x2,B,Bl,Ifail)
	IF (Ifail.LT.0) RETURN
        xwrk(2,1) = h*B(1)/Bl
        xwrk(2,2) = h*B(2)/Bl
        xwrk(2,3) = h*B(3)/Bl
        x2(1) = xx(1)+xwrk(2,1)/2.D0
        x2(2) = xx(2)+xwrk(2,2)/2.D0
        x2(3) = xx(3)+xwrk(2,3)/2.D0
c        write(6,*)x2(1),x2(2),x2(3),Bl
C
        CALL CHAMP(x2,B,Bl,Ifail)
	IF (Ifail.LT.0) RETURN
        xwrk(3,1) = h*B(1)/Bl
        xwrk(3,2) = h*B(2)/Bl
        xwrk(3,3) = h*B(3)/Bl
        x2(1) = xx(1)+xwrk(3,1)
        x2(2) = xx(2)+xwrk(3,2)
        x2(3) = xx(3)+xwrk(3,3)
c        write(6,*)x2(1),x2(2),x2(3),Bl
C
        CALL CHAMP(x2,B,Bl,Ifail)
	IF (Ifail.LT.0) RETURN
        xwrk(4,1) = h*B(1)/Bl
        xwrk(4,2) = h*B(2)/Bl
        xwrk(4,3) = h*B(3)/Bl
C
C-----------------------------------------------------------------------
C
        x2(1) = xx(1)+(   xwrk(1,1)+2.D0*xwrk(2,1)
     &               + 2.D0*xwrk(3,1)+   xwrk(4,1))/6.D0
        x2(2) = xx(2)+(   xwrk(1,2)+2.D0*xwrk(2,2)
     &               + 2.D0*xwrk(3,2)+   xwrk(4,2))/6.D0
        x2(3) = xx(3)+(   xwrk(1,3)+2.D0*xwrk(2,3)
     &               + 2.D0*xwrk(3,3)+   xwrk(4,3))/6.D0
        CALL CHAMP(x2,B,Bl,Ifail)
	IF (Ifail.LT.0) RETURN
c        write(6,*)x2(1),x2(2),x2(3),Bl
c        read(5,*)
C
        RETURN
        END
        SUBROUTINE sksyst2(h,xx,x2,Bl,Ifail)
C
        IMPLICIT NONE
C
        INTEGER*4  II,JJ,Ifail
        REAL*8 xx(3),x2(3)
        REAL*8 B(3),Bl
        REAL*8 h, c1, c2, c3
        REAL*8 xw, xf(3)
C
C-----------------------------------------------------------------------
C
c        write(6,*)'sksyst'
c        write(6,*)xx(1),xx(2),xx(3),h
        CALL CHAMP(XX,B,Bl,Ifail)
c        write(6,*)xx,B,Bl,Ifail
        IF (Ifail.LT.0) RETURN
	C1 = 1.D0
	C2 = 0.5D0
	DO JJ=1,3
          C3 = h/Bl
	  IF (JJ.eq.3) C2 = 1.D0
          DO II=1,3
c            write(6,*)'b',B(1),B(2),B(3),Bl
            xw = C3*B(II)
            x2(II) = xx(II)+xw*C2
            XF(II) = XF(II)+xw*C1
          ENDDO
          CALL CHAMP(X2,B,Bl,Ifail)
c          write(6,*)xx,B,Bl,Ifail
          IF (Ifail.LT.0) RETURN
	  C1 = 2.D0
        ENDDO
        C3 = h/Bl
        DO II=1,3
c          write(6,*)'b',B(1),B(2),B(3),Bl
          xw = C3*B(II)
          x2(II) = xx(II) + xf(ii)/6.D0
        ENDDO
        CALL CHAMP(X2,B,Bl,Ifail)
c        write(6,*)xx,B,Bl,Ifail
        IF (Ifail.LT.0) RETURN
        END

!***************************************************************************************************
! Copyright 1989, 1992, N. Tsyganenko
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C-----------------------------------------------------------------------
      SUBROUTINE T89C(IOPT,X,Y,Z,BX,BY,BZ)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
C
C
C   COMPUTES GSM COMPONENTS OF THE MAGNETIC FIELD PRODUCED BY EXTRA-
C   TERRESTRIAL CURRENT SYSTEMS IN THE GEOMAGNETOSPHERE. THE MODEL IS
C   VALID UP TO GEOCENTRIC DISTANCES OF 70 RE AND IS BASED ON THE MER-
C   GED IMP-A,C,D,E,F,G,H,I,J (1966-1974), HEOS-1 AND -2 (1969-1974),
C   AND ISEE-1 AND -2  SPACECRAFT DATA SET.
C
C   THIS IS A MODIFIED VERSION (T89c), WHICH REPLACED THE ORIGINAL ONE
C     IN 1992 AND DIFFERS FROM IT IN THE FOLLOWING:
C
C   (1)  ISEE-1,2 DATA WERE ADDED TO THE ORIGINAL IMP-HEOS DATASET
C   (2)  TWO TERMS WERE ADDED TO THE ORIGINAL TAIL FIELD MODES, ALLOWING
C          A MODULATION OF THE CURRENT BY THE GEODIPOLE TILT ANGLE
C
C
C  REFERENCE FOR THE ORIGINAL MODEL: N.A. TSYGANENKO, A MAGNETOSPHERIC MAGNETIC
C       FIELD MODEL WITH A WARPED TAIL CURRENT SHEET: PLANET.SPACE SCI., V.37,
C         PP.5-20, 1989.
C
C----INPUT PARAMETERS: IOPT - SPECIFIES THE GROUND DISTURBANCE LEVEL:
C
C   IOPT= 1       2        3        4        5        6      7
C                  CORRESPOND TO:
C    KP= 0,0+  1-,1,1+  2-,2,2+  3-,3,3+  4-,4,4+  5-,5,5+  > =6-
C
C    PS - GEODIPOLE TILT ANGLE IN RADIANS
C    X, Y, Z  - GSM COORDINATES OF THE POINT IN EARTH RADII
C
C----OUTPUT PARAMETERS: BX,BY,BZ - GSM COMPONENTS OF THE MODEL MAGNETIC
C                        FIELD IN NANOTESLAS
c
c   THE PARAMETER PARMOD(10) IS A DUMMY ARRAY.  IT IS NOT USED IN THIS
C        SUBROUTINE AND IS PROVIDED JUST FOR MAKING IT COMPATIBLE WITH THE
C           NEW VERSION (4/16/96) OF THE GEOPACK SOFTWARE.
C
C   THIS RELEASE OF T89C IS DATED  FEB 12, 1996;
C--------------------------------------------------------------------------
C
C
C              AUTHOR:     NIKOLAI A. TSYGANENKO
C                          HSTX CORP./NASA GSFC
C
       DIMENSION XI(4),F(3),DER(3,30),PARAM(30,7),A(30),PARMOD(10)
c-mk-c       DOUBLE PRECISION F,DER
       real*8 F,DER,tilt
      COMMON /dip_ang/tilt
        DATA PARAM/-116.53,-10719.,42.375,59.753,-11363.,1.7844,30.268,
     * -0.35372E-01,-0.66832E-01,0.16456E-01,-1.3024,0.16529E-02,
     * 0.20293E-02,20.289,-0.25203E-01,224.91,-9234.8,22.788,7.8813,
     * 1.8362,-0.27228,8.8184,2.8714,14.468,32.177,0.01,0.0,
     * 7.0459,4.0,20.0,-55.553,-13198.,60.647,61.072,-16064.,
     * 2.2534,34.407,-0.38887E-01,-0.94571E-01,0.27154E-01,-1.3901,
     * 0.13460E-02,0.13238E-02,23.005,-0.30565E-01,55.047,-3875.7,
     * 20.178,7.9693,1.4575,0.89471,9.4039,3.5215,14.474,36.555,
     * 0.01,0.0,7.0787,4.0,20.0,-101.34,-13480.,111.35,12.386,-24699.,
     * 2.6459,38.948,-0.34080E-01,-0.12404,0.29702E-01,-1.4052,
     * 0.12103E-02,0.16381E-02,24.49,-0.37705E-01,-298.32,4400.9,18.692,
     * 7.9064,1.3047,2.4541,9.7012,7.1624,14.288,33.822,0.01,0.0,6.7442,
     * 4.0,20.0,-181.69,-12320.,173.79,-96.664,-39051.,3.2633,44.968,
     * -0.46377E-01,-0.16686,0.048298,-1.5473,0.10277E-02,0.31632E-02,
     * 27.341,-0.50655E-01,-514.10,12482.,16.257,8.5834,1.0194,3.6148,
     * 8.6042,5.5057,13.778,32.373,0.01,0.0,7.3195,4.0,20.0,-436.54,
     * -9001.0,323.66,-410.08,-50340.,3.9932,58.524,-0.38519E-01,
     * -0.26822,0.74528E-01,-1.4268,-0.10985E-02,0.96613E-02,27.557,
     * -0.56522E-01,-867.03,20652.,14.101,8.3501,0.72996,3.8149,9.2908,
     *  6.4674,13.729,28.353,0.01,0.0,7.4237,4.0,20.0,-707.77,-4471.9,
     * 432.81,-435.51,-60400.,4.6229,68.178,-0.88245E-01,-0.21002,
     * 0.11846,-2.6711,0.22305E-02,0.10910E-01,27.547,-0.54080E-01,
     * -424.23,1100.2,13.954,7.5337,0.89714,3.7813,8.2945,5.174,14.213,
     * 25.237,0.01,0.0,7.0037,4.0,20.0,-1190.4,2749.9,742.56,-1110.3,
     * -77193.,7.6727,102.05,-0.96015E-01,-0.74507,0.11214,-1.3614,
     * 0.15157E-02,0.22283E-01,23.164,-0.74146E-01,-2219.1,48253.,
     * 12.714,7.6777,0.57138,2.9633,9.3909,9.7263,11.123,21.558,0.01,
     * 0.0,4.4518,4.0,20.0/

        DATA IOP/10/
C
      ps=tilt*4.D0*ATAN(1.D0)/180.d0
c
         id=0
         IF (IOP.NE.IOPT) THEN
C
            ID=1
            IOP=IOPT
            DO 1 I=1,30
   1        A(I)=PARAM(I,IOPT)
C
         ENDIF
C
        XI(1)=X
        XI(2)=Y
        XI(3)=Z
        XI(4)=PS
         CALL T89(ID,A,XI,F,DER)
          IF (ID.EQ.1) ID=2
        BX=F(1)
        BY=F(2)
        BZ=F(3)
        RETURN
       END
C-------------------------------------------------------------------
C
          SUBROUTINE  T89 (ID, A, XI, F, DER)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
C
C        ***  N.A. Tsyganenko ***  8-10.12.1991  ***
C
C      Calculates dependent model variables and their deriva-
C  tives for given independent variables and model parame-
C  ters.  Specifies model functions with free parameters which
C  must be determined by means of least squares fits (RMS
C  minimization procedure).
C
C      Description of parameters:
C
C  ID  - number of the data point in a set (initial assignments are performed
c        only for ID=1, saving thus CPU time)
C  A   - input vector containing model parameters;
C  XI  - input vector containing independent variables;
C  F   - output double precision vector containing
C        calculated values of dependent variables;
C  DER   - output double precision vector containing
C        calculated values for derivatives of dependent
C        variables with respect to model parameters;
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C      T89 represents external magnetospheric magnetic field
C  in Cartesian SOLAR MAGNETOSPHERIC coordinates (Tsyganenko N.A.,
C  Planet. Space Sci., 1989, v.37, p.5-20; the "T89 model" with the warped
c  tail current sheet) + A MODIFICATION ADDED IN APRIL 1992 (SEE BELOW)
C
C      Model formulas for the magnetic field components contain in total
c  30 free parameters (17 linear and 13 nonlinear parameters).
C      First 2 independent linear parameters A(1)-A(2) correspond to contribu-
c  tion from the tail current system, then follow A(3) and A(4) which are the
c  amplitudes of symmetric and antisymmetric terms in the contribution from
c  the closure currents; A(5) is the ring current amplitude. Then follow the
c coefficients A(6)-A(15) which define Chapman-Ferraro+Birkeland current field.
c    The coefficients c16-c19  (see Formula 20 in the original paper),
c   due to DivB=0 condition, are expressed through A(6)-A(15) and hence are not
c    independent ones.
c  A(16) AND A(17) CORRESPOND TO THE TERMS WHICH YIELD THE TILT ANGLE DEPEN-
C    DENCE OF THE TAIL CURRENT INTENSITY (ADDED ON APRIL 9, 1992)
C
C      Nonlinear parameters:
C
C    A(18) : DX - Characteristic scale of the Chapman-Ferraro field along the
c        X-axis
C    A(19) : ADR (aRC) - Characteristic radius of the ring current
c    A(20) : D0 - Basic half-thickness of the tail current sheet
C    A(21) : DD (GamRC)- defines rate of thickening of the ring current, as
c             we go from night- to dayside
C    A(22) : Rc - an analog of "hinging distance" entering formula (11)
C    A(23) : G - amplitude of tail current warping in the Y-direction
C    A(24) : aT - Characteristic radius of the tail current
c    A(25) : Dy - characteristic scale distance in the Y direction entering
c                 in W(x,y) in (13)
c    A(26) : Delta - defines the rate of thickening of the tail current sheet
c                 in the Y-direction (in T89 it was fixed at 0.01)
c    A(27) : Q - this parameter was fixed at 0 in the final version of T89;
c              initially it was introduced for making Dy to depend on X
c    A(28) : Sx (Xo) - enters in W(x,y) ; see (13)
c    A(29) : Gam (GamT) - enters in DT in (13) and defines rate of tail sheet
c              thickening on going from night to dayside; in T89 fixed at 4.0
c    A(30) : Dyc - the Dy parameter for closure current system; in T89 fixed
c               at 20.0
c  - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C
         REAL*8  A(*), XI(*)
C
         DIMENSION  F(3), DER(3,30)
C
         INTEGER*4  ID, I, L
         save
         DATA A02,XLW2,YN,RPI,RT/25.D0,170.D0,30.D0,0.31830989D0,30.D0/
         DATA XD,XLD2/0.D0,40.D0/
C
C   The last four quantities define variation of tail sheet thickness along X
C
      DATA SXC,XLWC2/4.D0,50.D0/
C
C   The two quantities belong to the function WC which confines tail closure
c    current in X- and Y- direction
C
      DATA DXL/20.D0/
C
C
         IF (ID.NE.1)  GOTO  3
           DO  2  I = 1, 30
             DO  1  L = 1, 3
  1            DER(L,I) = 0.0D0
  2        CONTINUE
C
       DYC=A(30)
       DYC2=DYC**2
       DX=A(18)
       HA02=0.5D0*A02
       RDX2M=-1.D0/DX**2
       RDX2=-RDX2M
       RDYC2=1.D0/DYC2
       HLWC2M=-0.5D0*XLWC2
       DRDYC2=-2.D0*RDYC2
       DRDYC3=2.D0*RDYC2*DSQRT(RDYC2)
       HXLW2M=-0.5D0*XLW2
       ADR=A(19)
       D0=A(20)
       DD=A(21)
       RC=A(22)
       G=A(23)
       AT=A(24)
       DT=D0
       DEL=A(26)
       P=A(25)
       Q=A(27)
       SX=A(28)
       GAM=A(29)
       HXLD2M=-0.5D0*XLD2
       ADSL=0.D0
       XGHS=0.D0
       H=0.D0
       HS=0.D0
       GAMH=0.D0
       W1=-0.5D0/DX
       DBLDEL=2.D0*DEL
       W2=W1*2.D0
       W4=-1.D0/3.D0
       W3=W4/DX
       W5=-0.5D0
       W6=-3.D0
       AK1=A(1)
       AK2=A(2)
       AK3=A(3)
       AK4=A(4)
       AK5=A(5)
       AK6=A(6)
       AK7=A(7)
       AK8=A(8)
       AK9=A(9)
       AK10=A(10)
       AK11=A(11)
       AK12=A(12)
       AK13=A(13)
       AK14=A(14)
       AK15=A(15)
        AK16=A(16)
        AK17=A(17)
       SXA=0.D0
       SYA=0.D0
       SZA=0.D0
       AK610=AK6*W1+AK10*W5
       AK711=AK7*W2-AK11
       AK812=AK8*W2+AK12*W6
       AK913=AK9*W3+AK13*W4
       RDXL=1.D0/DXL
       HRDXL=0.5D0*RDXL
       A6H=AK6*0.5D0
       A9T=AK9/3.D0
       YNP=RPI/YN*0.5D0
       YND=2.D0*YN
C
  3      CONTINUE
C
           X  = XI(1)
           Y  = XI(2)
           Z  = XI(3)
           TILT=XI(4)
               TLT2=TILT**2
           SPS = DSIN(TILT)
           CPS = DSQRT (1.0D0 - SPS ** 2)
C
       X2=X*X
       Y2=Y*Y
       Z2=Z*Z
       TPS=SPS/CPS
       HTP=TPS*0.5D0
       GSP=G*SPS
       XSM=X*CPS-Z*SPS
       ZSM=X*SPS+Z*CPS
C
C   CALCULATE THE FUNCTION ZS DEFINING THE SHAPE OF THE TAIL CURRENT SHEET
C    AND ITS SPATIAL DERIVATIVES:
C
       XRC=XSM+RC
       XRC16=XRC**2+16.D0
       SXRC=DSQRT(XRC16)
       Y4=Y2*Y2
       Y410=Y4+1.D4
       SY4=SPS/Y410
       GSY4=G*SY4
       ZS1=HTP*(XRC-SXRC)
       DZSX=-ZS1/SXRC
       ZS=ZS1-GSY4*Y4
       D2ZSGY=-SY4/Y410*4.D4*Y2*Y
       DZSY=G*D2ZSGY
C
C   CALCULATE THE COMPONENTS OF THE RING CURRENT CONTRIBUTION:
C
       XSM2=XSM**2
       DSQT=DSQRT(XSM2+A02)
       FA0=0.5D0*(1.D0+XSM/DSQT)
       DDR=D0+DD*FA0
       DFA0=HA02/DSQT**3
       ZR=ZSM-ZS
       TR=DSQRT(ZR**2+DDR**2)
       RTR=1.D0/TR
       RO2=XSM2+Y2
       ADRT=ADR+TR
       ADRT2=ADRT**2
       FK=1.D0/(ADRT2+RO2)
       DSFC=DSQRT(FK)
       FC=FK**2*DSFC
       FACXY=3.0D0*ADRT*FC*RTR
       XZR=XSM*ZR
       YZR=Y*ZR
       DBXDP=FACXY*XZR
       DER(2,5)=FACXY*YZR
       XZYZ=XSM*DZSX+Y*DZSY
       FAQ=ZR*XZYZ-DDR*DD*DFA0*XSM
       DBZDP=FC*(2.D0*ADRT2-RO2)+FACXY*FAQ
       DER(1,5)=DBXDP*CPS+DBZDP*SPS
       DER(3,5)=DBZDP*CPS-DBXDP*SPS
C
C  CALCULATE THE TAIL CURRENT SHEET CONTRIBUTION:
C
       DELY2=DEL*Y2
       D=DT+DELY2
       IF (DABS(GAM).LT.1.D-6) GOTO 8
       XXD=XSM-XD
       RQD=1.D0/(XXD**2+XLD2)
       RQDS=DSQRT(RQD)
       H=0.5D0*(1.D0+XXD*RQDS)
       HS=-HXLD2M*RQD*RQDS
       GAMH=GAM*H
       D=D+GAMH
       XGHS=XSM*GAM*HS
       ADSL=-D*XGHS
   8   D2=D**2
       T=DSQRT(ZR**2+D2)
       XSMX=XSM-SX
       RDSQ2=1.D0/(XSMX**2+XLW2)
       RDSQ=DSQRT(RDSQ2)
       V=0.5D0*(1.D0-XSMX*RDSQ)
       DVX=HXLW2M*RDSQ*RDSQ2
       OM=DSQRT(DSQRT(XSM2+16.D0)-XSM)
       OMS=-OM/(OM*OM+XSM)*0.5D0
       RDY=1.D0/(P+Q*OM)
       OMSV=OMS*V
       RDY2=RDY**2
       FY=1.D0/(1.D0+Y2*RDY2)
       W=V*FY
       YFY1=2.D0*FY*Y2*RDY2
       FYPR=YFY1*RDY
       FYDY=FYPR*FY
       DWX=DVX*FY+FYDY*Q*OMSV
       YDWY=-V*YFY1*FY
       DDY=DBLDEL*Y
       ATT=AT+T
       S1=DSQRT(ATT**2+RO2)
       F5=1.D0/S1
       F7=1.D0/(S1+ATT)
       F1=F5*F7
       F3=F5**3
       F9=ATT*F3
       FS=ZR*XZYZ-D*Y*DDY+ADSL
       XDWX=XSM*DWX+YDWY
       RTT=1.D0/T
       WT=W*RTT
       BRRZ1=WT*F1
       BRRZ2=WT*F3
       DBXC1=BRRZ1*XZR
       DBXC2=BRRZ2*XZR
       DER(2,1)=BRRZ1*YZR
       DER(2,2)=BRRZ2*YZR
          DER(2,16)=DER(2,1)*TLT2
          DER(2,17)=DER(2,2)*TLT2
       WTFS=WT*FS
       DBZC1=W*F5+XDWX*F7+WTFS*F1
       DBZC2=W*F9+XDWX*F1+WTFS*F3
       DER(1,1)=DBXC1*CPS+DBZC1*SPS
       DER(1,2)=DBXC2*CPS+DBZC2*SPS
       DER(3,1)=DBZC1*CPS-DBXC1*SPS
       DER(3,2)=DBZC2*CPS-DBXC2*SPS
          DER(1,16)=DER(1,1)*TLT2
          DER(1,17)=DER(1,2)*TLT2
          DER(3,16)=DER(3,1)*TLT2
          DER(3,17)=DER(3,2)*TLT2
C
C  CALCULATE CONTRIBUTION FROM THE CLOSURE CURRENTS
C
       ZPL=Z+RT
       ZMN=Z-RT
       ROGSM2=X2+Y2
       SPL=DSQRT(ZPL**2+ROGSM2)
       SMN=DSQRT(ZMN**2+ROGSM2)
       XSXC=X-SXC
       RQC2=1.D0/(XSXC**2+XLWC2)
       RQC=DSQRT(RQC2)
       FYC=1.D0/(1.D0+Y2*RDYC2)
       WC=0.5D0*(1.D0-XSXC*RQC)*FYC
       DWCX=HLWC2M*RQC2*RQC*FYC
       DWCY=DRDYC2*WC*FYC*Y
       SZRP=1.D0/(SPL+ZPL)
       SZRM=1.D0/(SMN-ZMN)
       XYWC=X*DWCX+Y*DWCY
       WCSP=WC/SPL
       WCSM=WC/SMN
       FXYP=WCSP*SZRP
       FXYM=WCSM*SZRM
       FXPL=X*FXYP
       FXMN=-X*FXYM
       FYPL=Y*FXYP
       FYMN=-Y*FXYM
       FZPL=WCSP+XYWC*SZRP
       FZMN=WCSM+XYWC*SZRM
       DER(1,3)=FXPL+FXMN
       DER(1,4)=(FXPL-FXMN)*SPS
       DER(2,3)=FYPL+FYMN
       DER(2,4)=(FYPL-FYMN)*SPS
       DER(3,3)=FZPL+FZMN
       DER(3,4)=(FZPL-FZMN)*SPS
C
C   NOW CALCULATE CONTRIBUTION FROM CHAPMAN-FERRARO SOURCES + ALL OTHER
C
           EX=DEXP(X/DX)
           EC=EX*CPS
           ES=EX*SPS
           ECZ=EC*Z
           ESZ=ES*Z
           ESZY2=ESZ*Y2
           ESZZ2=ESZ*Z2
           ECZ2=ECZ*Z
           ESY=ES*Y
C
           DER(1,6)=ECZ
           DER(1,7)=ES
           DER(1,8)=ESY*Y
           DER(1,9)=ESZ*Z
           DER(2,10)=ECZ*Y
           DER(2,11)=ESY
           DER(2,12)=ESY*Y2
           DER(2,13)=ESY*Z2
           DER(3,14)=EC
           DER(3,15)=EC*Y2
           DER(3,6)=ECZ2*W1
           DER(3,10)=ECZ2*W5
           DER(3,7)=ESZ*W2
           DER(3,11)=-ESZ
           DER(3,8)=ESZY2*W2
           DER(3,12)=ESZY2*W6
           DER(3,9)=ESZZ2*W3
           DER(3,13)=ESZZ2*W4
C
C  FINALLY, CALCULATE NET EXTERNAL MAGNETIC FIELD COMPONENTS,
C    BUT FIRST OF ALL THOSE FOR C.-F. FIELD:
C
      SX1=AK6*DER(1,6)+AK7*DER(1,7)+AK8*DER(1,8)+AK9*DER(1,9)
      SY1=AK10*DER(2,10)+AK11*DER(2,11)+AK12*DER(2,12)+AK13*DER(2,13)
      SZ1=AK14*DER(3,14)+AK15*DER(3,15)+AK610*ECZ2+AK711*ESZ+AK812
     * *ESZY2+AK913*ESZZ2
       BXCL=AK3*DER(1,3)+AK4*DER(1,4)
       BYCL=AK3*DER(2,3)+AK4*DER(2,4)
       BZCL=AK3*DER(3,3)+AK4*DER(3,4)
       BXT=AK1*DER(1,1)+AK2*DER(1,2)+BXCL +AK16*DER(1,16)+AK17*DER(1,17)
       BYT=AK1*DER(2,1)+AK2*DER(2,2)+BYCL +AK16*DER(2,16)+AK17*DER(2,17)
       BZT=AK1*DER(3,1)+AK2*DER(3,2)+BZCL +AK16*DER(3,16)+AK17*DER(3,17)
       F(1)=BXT+AK5*DER(1,5)+SX1+SXA
       F(2)=BYT+AK5*DER(2,5)+SY1+SYA
       F(3)=BZT+AK5*DER(3,5)+SZ1+SZA
C
       RETURN
       END
c

!***************************************************************************************************
! Copyright 2001 N. Tsyganenko
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c
      SUBROUTINE T01_01 (PARMOD,X,Y,Z,BX,BY,BZ)
c
c     RELEASE DATE OF THIS VERSION:   AUGUST 8, 2001.
C
C    Updated 23 May 2012 to incorporate corrections by N. Tsyganenko (detailed below)
C    =====
c     LATEST MODIFICATIONS/BUGS REMOVED:  JUNE 24, 2006:  REPLACED COEFFICIENTS IN:
c        (i) DATA statement in FUNCTION AP,
C        (ii)  DATA C_SY statement in SUBROUTINE FULL_RC, and
c        (iii) DATA A statement in SUBROUTINE T01_01.
C     This correction was needed because of a bug found in the symmetric ring current module.
c     Its impact is a minor (a few percent) change of the model field in the inner magnetosphere.
C    =====
C
c--------------------------------------------------------------------
C   A DATA-BASED MODEL OF THE EXTERNAL (I.E., WITHOUT EARTH'S CONTRIBUTION) PART OF THE
C   MAGNETOSPHERIC MAGNETIC FIELD, CALIBRATED BY
C    (1) SOLAR WIND PRESSURE PDYN (NANOPASCALS),
C    (2) DST (NANOTESLA),
C    (3) BYIMF,
C    (4) BZIMF (NANOTESLA)
C    (5) G1-INDEX
C    (6) G2-INDEX  (SEE TSYGANENKO [2001] FOR AN EXACT DEFINITION OF THESE TWO INDICES)

c   THESE INPUT PARAMETERS SHOULD BE PLACED IN THE FIRST 6 ELEMENTS
c   OF THE ARRAY PARMOD(10).
C
C   THE REST OF THE INPUT VARIABLES ARE: THE GEOdipole_01 TILT ANGLE PS (RADIANS),
C     AND   X,Y,Z -  GSM POSITION (RE)
C
c   IOPT  IS JUST A DUMMY INPUT PARAMETER, NECESSARY TO MAKE THIS SUBROUTINE
C   COMPATIBLE WITH THE TRACING SOFTWARE PACKAGE (GEOPACK). IN THIS MODEL
C   IT DOES NOT AFFECT THE OUTPUT FIELD.
c
C*******************************************************************************************
c** ATTENTION:  THE MODEL IS BASED ON DATA TAKEN SUNWARD FROM X=-15Re, AND HENCE BECOMES   *
C**              INVALID AT LARGER TAILWARD DISTANCES !!!                                  *
C*******************************************************************************************
C
c   OUTPUT:  GSM COMPONENTS OF THE EXTERNAL MAGNETIC FIELD (BX,BY,BZ, nanotesla)
C            COMPUTED AS A SUM OF CONTRIBUTIONS FROM PRINCIPAL FIELD SOURCES
C
c  (C) Copr. 2001, Nikolai A. Tsyganenko, USRA, Code 690.2, NASA GSFC
c      Greenbelt, MD 20771, USA
c
C                            REFERENCE:
C
C    N. A. Tsyganenko, A new data-based model of the near magnetosphere magnetic field:
c       1. Mathematical structure.
c       2. Parameterization and fitting to observations.
c
c             (submitted to JGR, July 2001; available online in the PDF format
c              from anonymous ftp-area www-istp.gsfc.nasa.gov,  /pub/kolya/T01)
c
c----------------------------------------------------------------------
c
      REAL*8 PARMOD(10),PS,X,Y,Z,BX,BY,BZ,tilt
      REAL*8 A(43),PDYN,DST_AST,BYIMF,BZIMF,G1,G2,PSS,XX,YY,ZZ,
     *  BXCF,BYCF,BZCF,BXT1,BYT1,BZT1,BXT2,BYT2,BZT2,
     *  BXSRC,BYSRC,BZSRC,BXPRC,BYPRC,BZPRC, BXR11,BYR11,BZR11,
     *  BXR12,BYR12,BZR12,BXR21,BYR21,BZR21,BXR22,BYR22,BZR22,HXIMF,
     *  HYIMF,HZIMF,BBX,BBY,BBZ
C
      COMMON /dip_ang/tilt
c
      DATA A /1.00000,2.47341,0.40791,0.30429,-0.10637,-0.89108,3.29350,
     * -0.05413,-0.00696,1.07869,-0.02314,-0.66173,-0.68018,-0.03246,
     *  0.02681,0.28062,0.16535,-0.02939,0.02639,-0.24891,-0.08063,
     *  0.08900,-0.02475,0.05887,0.57691,0.65256,-0.03230,2.24733,
     *  4.10546,1.13665,0.05506,0.97669,0.21164,0.64594,1.12556,0.01389,
     *  1.02978,0.02968,0.15821,9.00519,28.17582,1.35285,0.42279/
C
       ps=tilt*4.D0*ATAN(1.D0)/180.d0
c       
      IF (X.LT.-20.D0) THEN
      PRINT *,
     * '  ATTENTION:  THE MODEL IS VALID SUNWARD FROM X=-15 Re ONLY,'
      PRINT *,'              WHILE YOU ARE TRYING TO USE IT AT X=', X
C      PAUSE
      ENDIF
C
      PDYN=PARMOD(1)
      DST_AST=PARMOD(2)*0.8D0-13.D0*SQRT(PDYN)
      BYIMF=PARMOD(3)
      BZIMF=PARMOD(4)
C
      G1=PARMOD(5)
      G2=PARMOD(6)
      PSS=PS
      XX=X
      YY=Y
      ZZ=Z
C
      CALL EXTALL (0,0,0,0,A,43,PDYN,DST_AST,BYIMF,BZIMF,G1,G2,
     *  PSS,XX,YY,ZZ,BXCF,BYCF,BZCF,BXT1,BYT1,BZT1,BXT2,BYT2,BZT2,
     *  BXSRC,BYSRC,BZSRC,BXPRC,BYPRC,BZPRC, BXR11,BYR11,BZR11,
     *  BXR12,BYR12,BZR12,BXR21,BYR21,BZR21,BXR22,BYR22,BZR22,HXIMF,
     *  HYIMF,HZIMF,BBX,BBY,BBZ)
C
      BX=BBX
      BY=BBY
      BZ=BBZ
C
      RETURN
      END
C
C================================================================
      SUBROUTINE EXTALL (IOPGEN,IOPT,IOPB,IOPR,A,NTOT,
     *  PDYN,DST,BYIMF,BZIMF,VBIMF1,VBIMF2,PS,X,Y,Z,
     *  BXCF,BYCF,BZCF,BXT1,BYT1,BZT1,BXT2,BYT2,BZT2,
     *  BXSRC,BYSRC,BZSRC,BXPRC,BYPRC,BZPRC, BXR11,BYR11,BZR11,
     *  BXR12,BYR12,BZR12,BXR21,BYR21,BZR21,BXR22,BYR22,BZR22,HXIMF,
     *  HYIMF,HZIMF,BX,BY,BZ)
C
C   IOPGEN - GENERAL OPTION FLAG:  IOPGEN=0 - CALCULATE TOTAL FIELD
C                                  IOPGEN=1 - dipole_01 SHIELDING ONLY
C                                  IOPGEN=2 - TAIL FIELD ONLY
C                                  IOPGEN=3 - BIRKELAND FIELD ONLY
C                                  IOPGEN=4 - RING CURRENT FIELD ONLY
C                                  IOPGEN=5 - INTERCONNECTION FIELD ONLY
C
C   IOPT -  TAIL FIELD FLAG:       IOPT=0  -  BOTH MODES
C                                  IOPT=1  -  MODE 1 ONLY
C                                  IOPT=2  -  MODE 2 ONLY
C
C   IOPB -  BIRKELAND FIELD FLAG:  IOPB=0  -  ALL 4 TERMS
C                                  IOPB=1  -  REGION 1, MODES 1 AND 2
C                                  IOPB=2  -  REGION 2, MODES 1 AND 2
C
C   IOPR -  RING CURRENT FLAG:     IOPR=0  -  BOTH SRC AND PRC
C                                  IOPR=1  -  SRC ONLY
C                                  IOPR=2  -  PRC ONLY
C
      IMPLICIT  REAL * 8  (A - H, O - Z)
C
      DIMENSION A(NTOT)
C
      COMMON /TAIL/ DXSHIFT1,DXSHIFT2,D,DELTADY  ! THE COMMON BLOCKS FORWARD NONLINEAR PARAMETERS
      COMMON /BIRKPAR/ XKAPPA1,XKAPPA2
      COMMON /RCPAR/ SC_SY,SC_AS,PHI
      COMMON /G/ G
      COMMON /RH0/ RH0
C
      DATA A0_A,A0_S0,A0_X0 /34.586D0,1.1960D0,3.4397D0/   !   SHUE ET AL. PARAMETERS
      DATA DSIG /0.003D0/, RH0,RH2 /8.0D0,-5.2D0/
c
      XAPPA=(PDYN/2.)**A(39)   !  NOW THIS IS A VARIABLE PARAMETER
      RH0=A(40)
      G=A(41)

      XAPPA3=XAPPA**3

      XX=X*XAPPA
      YY=Y*XAPPA
      ZZ=Z*XAPPA
C
      SPS=DSIN(PS)
c
      X0=A0_X0/XAPPA
      AM=A0_A/XAPPA
      S0=A0_S0
c
      BPERP=DSQRT(BYIMF**2+BZIMF**2)
C
C   CALCULATE THE IMF CLOCK ANGLE:
C
        IF (BYIMF.EQ.0.D0.AND.BZIMF.EQ.0.D0) THEN
            THETA=0.D0
         ELSE
            THETA=DATAN2(BYIMF,BZIMF)
            IF (THETA.LE.0.D0) THETA=THETA+6.283185307D0
        ENDIF
c
       CT=COS(THETA)
       ST=SIN(THETA)
       YS=Y*CT-Z*ST
       ZS=Z*CT+Y*ST

       STHETAH=SIN(THETA/2.D0)**2
C
C  CALCULATE "IMF" COMPONENTS OUTSIDE THE MAGNETOPAUSE LAYER (HENCE BEGIN WITH "O")
C  THEY ARE NEEDED ONLY IF THE POINT (X,Y,Z) IS WITHIN THE TRANSITION MAGNETOPAUSE LAYER
C  OR OUTSIDE THE MAGNETOSPHERE:
C
      FACTIMF=A(24)+A(25)*STHETAH
c
      OIMFX=0.D0
      OIMFY=BYIMF*FACTIMF
      OIMFZ=BZIMF*FACTIMF
c
      R=SQRT(X**2+Y**2+Z**2)
      XSS=X
      ZSS=Z

  1   XSOLD=XSS      !   BEGIN ITERATIVE SEARCH OF UNWARPED COORDS (TO FIND SIGMA)
      ZSOLD=ZSS

      RH=RH0+RH2*(ZSS/R)**2
      SINPSAS=SPS/(1.D0+(R/RH)**3)**0.33333333D0
      COSPSAS=DSQRT(1.D0-SINPSAS**2)
      ZSS=X*SINPSAS+Z*COSPSAS
      XSS=X*COSPSAS-Z*SINPSAS
      DD=DABS(XSS-XSOLD)+DABS(ZSS-ZSOLD)
      IF (DD.GT.1.D-6) GOTO 1
C                                END OF ITERATIVE SEARCH
      RHO2=Y**2+ZSS**2
      ASQ=AM**2
      XMXM=AM+XSS-X0
      IF (XMXM.LT.0.D0) XMXM=0.D0 ! THE BOUNDARY IS A CYLINDER TAILWARD OF X=X0-AM
      AXX0=XMXM**2
      ARO=ASQ+RHO2
      SIGMA=DSQRT((ARO+AXX0+SQRT((ARO+AXX0)**2-4.D0*ASQ*AXX0))
     * /(2.D0*ASQ))
C
C   NOW, THERE ARE THREE POSSIBLE CASES:
C    (1) INSIDE THE MAGNETOSPHERE   (SIGMA
C    (2) IN THE BOUNDARY LAYER
C    (3) OUTSIDE THE MAGNETOSPHERE AND B.LAYER
C       FIRST OF ALL, CONSIDER THE CASES (1) AND (2):
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IF (SIGMA.LT.S0+DSIG) THEN  !  CASES (1) OR (2); CALCULATE THE MODEL FIELD
C                              (WITH THE POTENTIAL "PENETRATED" INTERCONNECTION FIELD):
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IF (IOPGEN.LE.1) THEN
         CALL SHLCAR3X3_01(XX,YY,ZZ,PS,CFX,CFY,CFZ)         !  dipole_01 SHIELDING FIELD
         BXCF=CFX*XAPPA3
         BYCF=CFY*XAPPA3
         BZCF=CFZ*XAPPA3
      ELSE
         BXCF=0.D0
         BYCF=0.D0
         BZCF=0.D0
      ENDIF

      IF (IOPGEN.EQ.0.OR.IOPGEN.EQ.2) THEN
         DXSHIFT1=A(26)+A(27)*VBIMF2
         DXSHIFT2=0.D0
         D=A(28)
         DELTADY=A(29)
         CALL DEFORMED (IOPT,PS,XX,YY,ZZ,                !  TAIL FIELD (THREE MODES)
     *    BXT1,BYT1,BZT1,BXT2,BYT2,BZT2)
      ELSE
         BXT1=0.D0
         BYT1=0.D0
         BZT1=0.D0
         BXT2=0.D0
         BYT2=0.D0
         BZT2=0.D0
      ENDIF

      IF (IOPGEN.EQ.0.OR.IOPGEN.EQ.3) THEN
         XKAPPA1=A(35)+A(36)*VBIMF2
         XKAPPA2=A(37)+A(38)*VBIMF2
         CALL BIRK_TOT (IOPB,PS,XX,YY,ZZ,BXR11,BYR11,BZR11,BXR12,BYR12,
     *   BZR12,BXR21,BYR21,BZR21,BXR22,BYR22,BZR22)    !   BIRKELAND FIELD (TWO MODES FOR R1 AND TWO MODES FOR R2)
      ELSE
         BXR11=0.D0
         BYR11=0.D0
         BZR11=0.D0
         BXR12=0.D0
         BYR12=0.D0
         BZR12=0.D0
         BXR21=0.D0
         BYR21=0.D0
         BZR21=0.D0
         BXR22=0.D0
         BYR22=0.D0
         BZR22=0.D0
      ENDIF

      IF (IOPGEN.EQ.0.OR.IOPGEN.EQ.4) THEN
         PHI=1.5707963D0*DTANH(DABS(DST)/A(34))
         ZNAM=DABS(DST)
         IF (ZNAM.LT.20.D0) ZNAM=20.D0
         SC_SY=A(30)*(20.D0/ZNAM)**A(31) *XAPPA    !
         SC_AS=A(32)*(20.D0/ZNAM)**A(33) *XAPPA
         CALL FULL_RC(IOPR,PS,XX,YY,ZZ,BXSRC,BYSRC,BZSRC,BXPRC,BYPRC,
     *                                        BZPRC)  !  SHIELDED RING CURRENT (SRC AND PRC)
      ELSE
         BXSRC=0.D0
         BYSRC=0.D0
         BZSRC=0.D0
         BXPRC=0.D0
         BYPRC=0.D0
         BZPRC=0.D0
      ENDIF
C
      IF (IOPGEN.EQ.0.OR.IOPGEN.EQ.5) THEN
         HXIMF=0.D0
         HYIMF=BYIMF
         HZIMF=BZIMF   ! THESE ARE COMPONENTS OF THE PENETRATED FIELD PER UNIT OF THE PENETRATION COEFFICIENT.
C                        IN OTHER WORDS, THESE ARE DERIVATIVES OF THE PENETRATION FIELD COMPONENTS WITH RESPECT
C                        TO THE PENETRATION COEFFICIENT.   WE ASSUME THAT ONLY THE TRANSVERSE COMPONENT OF THE
C                        FIELD PENETRATES INSIDE.
       ELSE
         HXIMF=0.D0
         HYIMF=0.D0
         HZIMF=0.D0
       ENDIF
C
C-----------------------------------------------------------
C
C    NOW, ADD UP ALL THE COMPONENTS:

      DLP1=(PDYN/2.D0)**A(42)
      DLP2=(PDYN/2.D0)**A(43)

      TAMP1=A(2)+A(3)*DLP1+A(4)*VBIMF1+A(5)*DST
      TAMP2=A(6)+A(7)*DLP2+A(8)*VBIMF1+A(9)*DST
      A_SRC=A(10)+A(11)*DST+A(12)*DSQRT(PDYN)
      A_PRC=A(13)+A(14)*DST+A(15)*DSQRT(PDYN)
      A_R11=A(16)+A(17)*VBIMF2
      A_R12=A(18)+A(19)*VBIMF2
      A_R21=A(20)+A(21)*VBIMF2
      A_R22=A(22)+A(23)*VBIMF2

      BBX=A(1)*BXCF+TAMP1*BXT1+TAMP2*BXT2+A_SRC*BXSRC+A_PRC*BXPRC
     * +A_R11*BXR11+A_R12*BXR12+A_R21*BXR21+A_R22*BXR22
     *   +A(24)*HXIMF+A(25)*HXIMF*STHETAH

      BBY=A(1)*BYCF+TAMP1*BYT1+TAMP2*BYT2+A_SRC*BYSRC+A_PRC*BYPRC
     * +A_R11*BYR11+A_R12*BYR12+A_R21*BYR21+A_R22*BYR22
     *   +A(24)*HYIMF+A(25)*HYIMF*STHETAH

      BBZ=A(1)*BZCF+TAMP1*BZT1+TAMP2*BZT2+A_SRC*BZSRC+A_PRC*BZPRC
     * +A_R11*BZR11+A_R12*BZR12+A_R21*BZR21+A_R22*BZR22
     *   +A(24)*HZIMF+A(25)*HZIMF*STHETAH

C
C   AND WE HAVE THE TOTAL EXTERNAL FIELD.
C
C  NOW, LET US CHECK WHETHER WE HAVE THE CASE (1). IF YES - WE ARE DONE:
C
      IF (SIGMA.LT.S0-DSIG) THEN    !  (X,Y,Z) IS INSIDE THE MAGNETOSPHERE
C-------------------------------------------------------------------------
       BX=BBX
       BY=BBY
       BZ=BBZ
C-------------------------------------------------------------------------
                     ELSE           !  THIS IS THE MOST COMPLEX CASE: WE ARE INSIDE
C                                             THE INTERPOLATION REGION
       FINT=0.5D0*(1.-(SIGMA-S0)/DSIG)
       FEXT=0.5D0*(1.+(SIGMA-S0)/DSIG)
C
       CALL dipole_01 (PS,X,Y,Z,QX,QY,QZ)
       BX=(BBX+QX)*FINT+OIMFX*FEXT -QX
       BY=(BBY+QY)*FINT+OIMFY*FEXT -QY
       BZ=(BBZ+QZ)*FINT+OIMFZ*FEXT -QZ
c
        ENDIF  !   THE CASES (1) AND (2) ARE EXHAUSTED; THE ONLY REMAINING
C                      POSSIBILITY IS NOW THE CASE (3):
C--------------------------------------------------------------------------
        ELSE
                CALL dipole_01 (PS,X,Y,Z,QX,QY,QZ)
                BX=OIMFX-QX
                BY=OIMFY-QY
                BZ=OIMFZ-QZ
        ENDIF
C
      END
c
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
         SUBROUTINE  SHLCAR3X3_01(X,Y,Z,PS,BX,BY,BZ)
C
C   THIS S/R RETURNS THE SHIELDING FIELD FOR THE EARTH'S dipole_01,
C   REPRESENTED BY  2x3x3=18 "CARTESIAN" HARMONICS, tilted with respect
C   to the z=0 plane  (NB#4, p.74)
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  The 36 coefficients enter in pairs in the amplitudes of the "cartesian"
c    harmonics (A(1)-A(36).
c  The 14 nonlinear parameters (A(37)-A(50) are the scales Pi,Ri,Qi,and Si
C   entering the arguments of exponents, sines, and cosines in each of the
C   18 "Cartesian" harmonics  PLUS TWO TILT ANGLES FOR THE CARTESIAN HARMONICS
C       (ONE FOR THE PSI=0 MODE AND ANOTHER FOR THE PSI=90 MODE)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      IMPLICIT  REAL * 8  (A - H, O - Z)
C
      DIMENSION A(50)
      DATA A/-901.2327248D0,895.8011176D0,817.6208321D0,-845.5880889D0,
     *-83.73539535D0,86.58542841D0,336.8781402D0,-329.3619944D0,
     *-311.2947120D0,308.6011161D0,31.94469304D0,-31.30824526D0,
     *125.8739681D0,-372.3384278D0,-235.4720434D0,286.7594095D0,
     *21.86305585D0,-27.42344605D0,-150.4874688D0,2.669338538D0,
     *1.395023949D0,-.5540427503D0,-56.85224007D0,3.681827033D0,
     *-43.48705106D0,5.103131905D0,1.073551279D0,-.6673083508D0,
     *12.21404266D0,4.177465543D0,5.799964188D0,-.3977802319D0,
     *-1.044652977D0,.5703560010D0,3.536082962D0,-3.222069852D0,
     *9.620648151D0,6.082014949D0,27.75216226D0,12.44199571D0,
     *5.122226936D0,6.982039615D0,20.12149582D0,6.150973118D0,
     *4.663639687D0,15.73319647D0,2.303504968D0,5.840511214D0,
     *.8385953499D-01,.3477844929D0/
C
       P1=A(37)
       P2=A(38)
       P3=A(39)
       R1=A(40)
       R2=A(41)
       R3=A(42)
       Q1=A(43)
       Q2=A(44)
       Q3=A(45)
       S1=A(46)
       S2=A(47)
       S3=A(48)

       T1 =A(49)
       T2 =A(50)
C
       CPS=DCOS(PS)
       SPS=DSIN(PS)
       S2PS=2.D0*CPS      !   MODIFIED HERE (SIN(2*PS) INSTEAD OF SIN(3*PS))
C
       ST1=DSIN(PS*T1)
       CT1=DCOS(PS*T1)
       ST2=DSIN(PS*T2)
       CT2=DCOS(PS*T2)

       X1=X*CT1-Z*ST1
       Z1=X*ST1+Z*CT1
       X2=X*CT2-Z*ST2
       Z2=X*ST2+Z*CT2
C
C
c  MAKE THE TERMS IN THE 1ST SUM ("PERPENDICULAR" SYMMETRY):
C
C       I=1:
C
       SQPR= DSQRT(1.D0/P1**2+1.D0/R1**2)
       CYP = DCOS(Y/P1)
       SYP = DSIN(Y/P1)
       CZR = DCOS(Z1/R1)
       SZR = DSIN(Z1/R1)
       EXPR= DEXP(SQPR*X1)
       FX1 =-SQPR*EXPR*CYP*SZR
       HY1 = EXPR/P1*SYP*SZR
       FZ1 =-EXPR*CYP/R1*CZR
       HX1 = FX1*CT1+FZ1*ST1
       HZ1 =-FX1*ST1+FZ1*CT1

       SQPR= DSQRT(1.D0/P1**2+1.D0/R2**2)
       CYP = DCOS(Y/P1)
       SYP = DSIN(Y/P1)
       CZR = DCOS(Z1/R2)
       SZR = DSIN(Z1/R2)
       EXPR= DEXP(SQPR*X1)
       FX2 =-SQPR*EXPR*CYP*SZR
       HY2 = EXPR/P1*SYP*SZR
       FZ2 =-EXPR*CYP/R2*CZR
       HX2 = FX2*CT1+FZ2*ST1
       HZ2 =-FX2*ST1+FZ2*CT1

       SQPR= DSQRT(1.D0/P1**2+1.D0/R3**2)
       CYP = DCOS(Y/P1)
       SYP = DSIN(Y/P1)
       CZR = DCOS(Z1/R3)
       SZR = DSIN(Z1/R3)
       EXPR= DEXP(SQPR*X1)
       FX3 =-EXPR*CYP*(SQPR*Z1*CZR+SZR/R3*(X1+1.D0/SQPR))
       HY3 = EXPR/P1*SYP*(Z1*CZR+X1/R3*SZR/SQPR)
       FZ3 =-EXPR*CYP*(CZR*(1.D0+X1/R3**2/SQPR)-Z1/R3*SZR)
       HX3 = FX3*CT1+FZ3*ST1
       HZ3 =-FX3*ST1+FZ3*CT1
C
C       I=2:
C
       SQPR= DSQRT(1.D0/P2**2+1.D0/R1**2)
       CYP = DCOS(Y/P2)
       SYP = DSIN(Y/P2)
       CZR = DCOS(Z1/R1)
       SZR = DSIN(Z1/R1)
       EXPR= DEXP(SQPR*X1)
       FX4 =-SQPR*EXPR*CYP*SZR
       HY4 = EXPR/P2*SYP*SZR
       FZ4 =-EXPR*CYP/R1*CZR
       HX4 = FX4*CT1+FZ4*ST1
       HZ4 =-FX4*ST1+FZ4*CT1

       SQPR= DSQRT(1.D0/P2**2+1.D0/R2**2)
       CYP = DCOS(Y/P2)
       SYP = DSIN(Y/P2)
       CZR = DCOS(Z1/R2)
       SZR = DSIN(Z1/R2)
       EXPR= DEXP(SQPR*X1)
       FX5 =-SQPR*EXPR*CYP*SZR
       HY5 = EXPR/P2*SYP*SZR
       FZ5 =-EXPR*CYP/R2*CZR
       HX5 = FX5*CT1+FZ5*ST1
       HZ5 =-FX5*ST1+FZ5*CT1

       SQPR= DSQRT(1.D0/P2**2+1.D0/R3**2)
       CYP = DCOS(Y/P2)
       SYP = DSIN(Y/P2)
       CZR = DCOS(Z1/R3)
       SZR = DSIN(Z1/R3)
       EXPR= DEXP(SQPR*X1)
       FX6 =-EXPR*CYP*(SQPR*Z1*CZR+SZR/R3*(X1+1.D0/SQPR))
       HY6 = EXPR/P2*SYP*(Z1*CZR+X1/R3*SZR/SQPR)
       FZ6 =-EXPR*CYP*(CZR*(1.D0+X1/R3**2/SQPR)-Z1/R3*SZR)
       HX6 = FX6*CT1+FZ6*ST1
       HZ6 =-FX6*ST1+FZ6*CT1
C
C      I=3:
C
       SQPR= DSQRT(1.D0/P3**2+1.D0/R1**2)
       CYP = DCOS(Y/P3)
       SYP = DSIN(Y/P3)
       CZR = DCOS(Z1/R1)
       SZR = DSIN(Z1/R1)
       EXPR= DEXP(SQPR*X1)
       FX7 =-SQPR*EXPR*CYP*SZR
       HY7 = EXPR/P3*SYP*SZR
       FZ7 =-EXPR*CYP/R1*CZR
       HX7 = FX7*CT1+FZ7*ST1
       HZ7 =-FX7*ST1+FZ7*CT1

       SQPR= DSQRT(1.D0/P3**2+1.D0/R2**2)
       CYP = DCOS(Y/P3)
       SYP = DSIN(Y/P3)
       CZR = DCOS(Z1/R2)
       SZR = DSIN(Z1/R2)
       EXPR= DEXP(SQPR*X1)
       FX8 =-SQPR*EXPR*CYP*SZR
       HY8 = EXPR/P3*SYP*SZR
       FZ8 =-EXPR*CYP/R2*CZR
       HX8 = FX8*CT1+FZ8*ST1
       HZ8 =-FX8*ST1+FZ8*CT1

       SQPR= DSQRT(1.D0/P3**2+1.D0/R3**2)
       CYP = DCOS(Y/P3)
       SYP = DSIN(Y/P3)
       CZR = DCOS(Z1/R3)
       SZR = DSIN(Z1/R3)
       EXPR= DEXP(SQPR*X1)
       FX9 =-EXPR*CYP*(SQPR*Z1*CZR+SZR/R3*(X1+1.D0/SQPR))
       HY9 = EXPR/P3*SYP*(Z1*CZR+X1/R3*SZR/SQPR)
       FZ9 =-EXPR*CYP*(CZR*(1.D0+X1/R3**2/SQPR)-Z1/R3*SZR)
       HX9 = FX9*CT1+FZ9*ST1
       HZ9 =-FX9*ST1+FZ9*CT1
C
       A1=A(1)+A(2)*CPS
       A2=A(3)+A(4)*CPS
       A3=A(5)+A(6)*CPS
       A4=A(7)+A(8)*CPS
       A5=A(9)+A(10)*CPS
       A6=A(11)+A(12)*CPS
       A7=A(13)+A(14)*CPS
       A8=A(15)+A(16)*CPS
       A9=A(17)+A(18)*CPS
       BX=A1*HX1+A2*HX2+A3*HX3+A4*HX4+A5*HX5+A6*HX6+A7*HX7+A8*HX8+A9*HX9
       BY=A1*HY1+A2*HY2+A3*HY3+A4*HY4+A5*HY5+A6*HY6+A7*HY7+A8*HY8+A9*HY9
       BZ=A1*HZ1+A2*HZ2+A3*HZ3+A4*HZ4+A5*HZ5+A6*HZ6+A7*HZ7+A8*HZ8+A9*HZ9


c  MAKE THE TERMS IN THE 2ND SUM ("PARALLEL" SYMMETRY):
C
C       I=1
C
       SQQS= DSQRT(1.D0/Q1**2+1.D0/S1**2)
       CYQ = DCOS(Y/Q1)
       SYQ = DSIN(Y/Q1)
       CZS = DCOS(Z2/S1)
       SZS = DSIN(Z2/S1)
       EXQS= DEXP(SQQS*X2)
       FX1 =-SQQS*EXQS*CYQ*CZS *SPS
       HY1 = EXQS/Q1*SYQ*CZS   *SPS
       FZ1 = EXQS*CYQ/S1*SZS   *SPS
       HX1 = FX1*CT2+FZ1*ST2
       HZ1 =-FX1*ST2+FZ1*CT2

       SQQS= DSQRT(1.D0/Q1**2+1.D0/S2**2)
       CYQ = DCOS(Y/Q1)
       SYQ = DSIN(Y/Q1)
       CZS = DCOS(Z2/S2)
       SZS = DSIN(Z2/S2)
       EXQS= DEXP(SQQS*X2)
       FX2 =-SQQS*EXQS*CYQ*CZS *SPS
       HY2 = EXQS/Q1*SYQ*CZS   *SPS
       FZ2 = EXQS*CYQ/S2*SZS   *SPS
       HX2 = FX2*CT2+FZ2*ST2
       HZ2 =-FX2*ST2+FZ2*CT2

       SQQS= DSQRT(1.D0/Q1**2+1.D0/S3**2)
       CYQ = DCOS(Y/Q1)
       SYQ = DSIN(Y/Q1)
       CZS = DCOS(Z2/S3)
       SZS = DSIN(Z2/S3)
       EXQS= DEXP(SQQS*X2)
       FX3 =-SQQS*EXQS*CYQ*CZS *SPS
       HY3 = EXQS/Q1*SYQ*CZS   *SPS
       FZ3 = EXQS*CYQ/S3*SZS   *SPS
       HX3 = FX3*CT2+FZ3*ST2
       HZ3 =-FX3*ST2+FZ3*CT2
C
C       I=2:
C
       SQQS= DSQRT(1.D0/Q2**2+1.D0/S1**2)
       CYQ = DCOS(Y/Q2)
       SYQ = DSIN(Y/Q2)
       CZS = DCOS(Z2/S1)
       SZS = DSIN(Z2/S1)
       EXQS= DEXP(SQQS*X2)
       FX4 =-SQQS*EXQS*CYQ*CZS *SPS
       HY4 = EXQS/Q2*SYQ*CZS   *SPS
       FZ4 = EXQS*CYQ/S1*SZS   *SPS
       HX4 = FX4*CT2+FZ4*ST2
       HZ4 =-FX4*ST2+FZ4*CT2

       SQQS= DSQRT(1.D0/Q2**2+1.D0/S2**2)
       CYQ = DCOS(Y/Q2)
       SYQ = DSIN(Y/Q2)
       CZS = DCOS(Z2/S2)
       SZS = DSIN(Z2/S2)
       EXQS= DEXP(SQQS*X2)
       FX5 =-SQQS*EXQS*CYQ*CZS *SPS
       HY5 = EXQS/Q2*SYQ*CZS   *SPS
       FZ5 = EXQS*CYQ/S2*SZS   *SPS
       HX5 = FX5*CT2+FZ5*ST2
       HZ5 =-FX5*ST2+FZ5*CT2

       SQQS= DSQRT(1.D0/Q2**2+1.D0/S3**2)
       CYQ = DCOS(Y/Q2)
       SYQ = DSIN(Y/Q2)
       CZS = DCOS(Z2/S3)
       SZS = DSIN(Z2/S3)
       EXQS= DEXP(SQQS*X2)
       FX6 =-SQQS*EXQS*CYQ*CZS *SPS
       HY6 = EXQS/Q2*SYQ*CZS   *SPS
       FZ6 = EXQS*CYQ/S3*SZS   *SPS
       HX6 = FX6*CT2+FZ6*ST2
       HZ6 =-FX6*ST2+FZ6*CT2
C
C       I=3:
C
       SQQS= DSQRT(1.D0/Q3**2+1.D0/S1**2)
       CYQ = DCOS(Y/Q3)
       SYQ = DSIN(Y/Q3)
       CZS = DCOS(Z2/S1)
       SZS = DSIN(Z2/S1)
       EXQS= DEXP(SQQS*X2)
       FX7 =-SQQS*EXQS*CYQ*CZS *SPS
       HY7 = EXQS/Q3*SYQ*CZS   *SPS
       FZ7 = EXQS*CYQ/S1*SZS   *SPS
       HX7 = FX7*CT2+FZ7*ST2
       HZ7 =-FX7*ST2+FZ7*CT2

       SQQS= DSQRT(1.D0/Q3**2+1.D0/S2**2)
       CYQ = DCOS(Y/Q3)
       SYQ = DSIN(Y/Q3)
       CZS = DCOS(Z2/S2)
       SZS = DSIN(Z2/S2)
       EXQS= DEXP(SQQS*X2)
       FX8 =-SQQS*EXQS*CYQ*CZS *SPS
       HY8 = EXQS/Q3*SYQ*CZS   *SPS
       FZ8 = EXQS*CYQ/S2*SZS   *SPS
       HX8 = FX8*CT2+FZ8*ST2
       HZ8 =-FX8*ST2+FZ8*CT2

       SQQS= DSQRT(1.D0/Q3**2+1.D0/S3**2)
       CYQ = DCOS(Y/Q3)
       SYQ = DSIN(Y/Q3)
       CZS = DCOS(Z2/S3)
       SZS = DSIN(Z2/S3)
       EXQS= DEXP(SQQS*X2)
       FX9 =-SQQS*EXQS*CYQ*CZS *SPS
       HY9 = EXQS/Q3*SYQ*CZS   *SPS
       FZ9 = EXQS*CYQ/S3*SZS   *SPS
       HX9 = FX9*CT2+FZ9*ST2
       HZ9 =-FX9*ST2+FZ9*CT2

       A1=A(19)+A(20)*S2PS
       A2=A(21)+A(22)*S2PS
       A3=A(23)+A(24)*S2PS
       A4=A(25)+A(26)*S2PS
       A5=A(27)+A(28)*S2PS
       A6=A(29)+A(30)*S2PS
       A7=A(31)+A(32)*S2PS
       A8=A(33)+A(34)*S2PS
       A9=A(35)+A(36)*S2PS

       BX=BX+A1*HX1+A2*HX2+A3*HX3+A4*HX4+A5*HX5+A6*HX6+A7*HX7+A8*HX8
     *   +A9*HX9
       BY=BY+A1*HY1+A2*HY2+A3*HY3+A4*HY4+A5*HY5+A6*HY6+A7*HY7+A8*HY8
     *   +A9*HY9
       BZ=BZ+A1*HZ1+A2*HZ2+A3*HZ3+A4*HZ4+A5*HZ5+A6*HZ6+A7*HZ7+A8*HZ8
     *   +A9*HZ9
C
       RETURN
       END
c
c############################################################################
c
C
      SUBROUTINE DEFORMED (IOPT,PS,X,Y,Z,BX1,BY1,BZ1,BX2,BY2,BZ2)
C
C   IOPT - TAIL FIELD MODE FLAG:   IOPT=0 - THE TWO TAIL MODES ARE ADDED UP
C                                  IOPT=1 - MODE 1 ONLY
C                                  IOPT=2 - MODE 2 ONLY
C
C   CALCULATES GSM COMPONENTS OF TWO UNIT-AMPLITUDE TAIL FIELD MODES,
C    TAKING INTO ACCOUNT BOTH EFFECTS OF dipole_01 TILT:
C    WARPING IN Y-Z (DONE BY THE S/R WARPED) AND BENDING IN X-Z (DONE BY THIS SUBROUTINE)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /RH0/ RH0
      DATA RH2,IEPS /-5.2D0,3/
C
C  RH0,RH1,RH2, AND IEPS CONTROL THE TILT-RELATED DEFORMATION OF THE TAIL FIELD
C
      SPS=DSIN(PS)
      CPS=DSQRT(1.D0-SPS**2)
      R2=X**2+Y**2+Z**2
      R=SQRT(R2)
      ZR=Z/R
      RH=RH0+RH2*ZR**2
      DRHDR=-ZR/R*2.D0*RH2*ZR
      DRHDZ= 2.D0*RH2*ZR/R
C
      RRH=R/RH
      F=1.D0/(1.D0+RRH**IEPS)**(1.D0/IEPS)
      DFDR=-RRH**(IEPS-1)*F**(IEPS+1)/RH
      DFDRH=-RRH*DFDR
c
      SPSAS=SPS*F
      CPSAS=DSQRT(1.D0-SPSAS**2)
C
      XAS=X*CPSAS-Z*SPSAS
      ZAS=X*SPSAS+Z*CPSAS
C
      FACPS=SPS/CPSAS*(DFDR+DFDRH*DRHDR)/R
      PSASX=FACPS*X
      PSASY=FACPS*Y
      PSASZ=FACPS*Z+SPS/CPSAS*DFDRH*DRHDZ
C
      DXASDX=CPSAS-ZAS*PSASX
      DXASDY=-ZAS*PSASY
      DXASDZ=-SPSAS-ZAS*PSASZ
      DZASDX=SPSAS+XAS*PSASX
      DZASDY=XAS*PSASY
      DZASDZ=CPSAS+XAS*PSASZ
      FAC1=DXASDZ*DZASDY-DXASDY*DZASDZ
      FAC2=DXASDX*DZASDZ-DXASDZ*DZASDX
      FAC3=DZASDX*DXASDY-DXASDX*DZASDY
C
C     DEFORM:
C
      CALL WARPED(IOPT,PS,XAS,Y,ZAS,BXAS1,BYAS1,BZAS1,BXAS2,BYAS2,BZAS2)
C
      BX1=BXAS1*DZASDZ-BZAS1*DXASDZ +BYAS1*FAC1
      BY1=BYAS1*FAC2
      BZ1=BZAS1*DXASDX-BXAS1*DZASDX +BYAS1*FAC3

      BX2=BXAS2*DZASDZ-BZAS2*DXASDZ +BYAS2*FAC1
      BY2=BYAS2*FAC2
      BZ2=BZAS2*DXASDX-BXAS2*DZASDX +BYAS2*FAC3

      RETURN
      END
C
C------------------------------------------------------------------
C
      SUBROUTINE WARPED (IOPT,PS,X,Y,Z,BX1,BY1,BZ1,BX2,BY2,BZ2)
C
C   CALCULATES GSM COMPONENTS OF THE WARPED FIELD FOR TWO TAIL UNIT MODES.
C   THE WARPING DEFORMATION IS IMPOSED ON THE UNWARPED FIELD, COMPUTED
C   BY THE S/R "UNWARPED".  THE WARPING PARAMETER G WAS OBTAINED BY LEAST
C   SQUARES FITTING TO THE ENTIRE DATASET.
C
C   IOPT - TAIL FIELD MODE FLAG:   IOPT=0 - THE TWO TAIL MODES ARE ADDED UP
C                                  IOPT=1 - MODE 1 ONLY
C                                  IOPT=2 - MODE 2 ONLY
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMMON /G/ G
      DGDX=0.D0
      XL=20.D0
      DXLDX=0.D0

      SPS=DSIN(PS)
      RHO2=Y**2+Z**2
      RHO=DSQRT(RHO2)

      IF (Y.EQ.0.D0.AND.Z.EQ.0.D0) THEN
       PHI=0.D0
       CPHI=1.D0
       SPHI=0.D0
      ELSE
       PHI=DATAN2(Z,Y)
       CPHI=Y/RHO
       SPHI=Z/RHO
      ENDIF

      RR4L4=RHO/(RHO2**2+XL**4)

      F=PHI+G*RHO2*RR4L4*CPHI*SPS
      DFDPHI=1.D0-G*RHO2*RR4L4*SPHI*SPS
      DFDRHO=G*RR4L4**2*(3.D0*XL**4-RHO2**2)*CPHI*SPS
      DFDX=RR4L4*CPHI*SPS*(DGDX*RHO2-G*RHO*RR4L4*4.D0*XL**3*DXLDX)

      CF=DCOS(F)
      SF=DSIN(F)
      YAS=RHO*CF
      ZAS=RHO*SF

      CALL UNWARPED (IOPT,X,YAS,ZAS,BX_AS1,BY_AS1,BZ_AS1,
     *  BX_AS2,BY_AS2,BZ_AS2)

      BRHO_AS =  BY_AS1*CF+BZ_AS1*SF      !   DEFORM THE 1ST MODE
      BPHI_AS = -BY_AS1*SF+BZ_AS1*CF

      BRHO_S = BRHO_AS*DFDPHI
      BPHI_S = BPHI_AS-RHO*(BX_AS1*DFDX+BRHO_AS*DFDRHO)
      BX1    = BX_AS1*DFDPHI

      BY1    = BRHO_S*CPHI-BPHI_S*SPHI
      BZ1    = BRHO_S*SPHI+BPHI_S*CPHI    !   DONE

      BRHO_AS =  BY_AS2*CF+BZ_AS2*SF      !   DEFORM THE 2ND MODE
      BPHI_AS = -BY_AS2*SF+BZ_AS2*CF

      BRHO_S = BRHO_AS*DFDPHI
      BPHI_S = BPHI_AS-RHO*(BX_AS2*DFDX+BRHO_AS*DFDRHO)
      BX2    = BX_AS2*DFDPHI

      BY2    = BRHO_S*CPHI-BPHI_S*SPHI
      BZ2    = BRHO_S*SPHI+BPHI_S*CPHI    !   DONE

      RETURN
      END
C
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
       SUBROUTINE UNWARPED (IOPT,X,Y,Z,BX1,BY1,BZ1,BX2,BY2,BZ2)

C   IOPT - TAIL FIELD MODE FLAG:   IOPT=0 - THE TWO TAIL MODES ARE ADDED UP
C                                  IOPT=1 - MODE 1 ONLY
C                                  IOPT=2 - MODE 2 ONLY
C
C    CALCULATES GSM COMPONENTS OF THE SHIELDED FIELD OF TWO TAIL MODES WITH UNIT
C    AMPLITUDES,  WITHOUT ANY WARPING OR BENDING.  NONLINEAR PARAMETERS OF THE MODES
C    ARE FORWARDED HERE VIA A COMMON BLOCK /TAIL/.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION A1(60),A2(60)  !   TAIL SHIELDING FIELD PARAMETERS FOR THE MODES #1 & #2

      COMMON /TAIL/ DXSHIFT1,DXSHIFT2,D0,DELTADY
C
      DATA DELTADX1,ALPHA1,XSHIFT1 /1.D0,1.1D0,6.D0/
      DATA DELTADX2,ALPHA2,XSHIFT2 /0.D0,.25D0,4.D0/

      DATA A1/-25.45869857D0,57.35899080D0,317.5501869D0,
     *-2.626756717D0,-93.38053698D0,-199.6467926D0,-858.8129729D0,
     *34.09192395D0,845.4214929D0,-29.07463068D0,47.10678547D0,
     *-128.9797943D0,-781.7512093D0,6.165038619D0,167.8905046D0,
     *492.0680410D0,1654.724031D0,-46.77337920D0,-1635.922669D0,
     *40.86186772D0,-.1349775602D0,-.9661991179D-01,-.1662302354D0,
     *.002810467517D0,.2487355077D0,.1025565237D0,-14.41750229D0,
     *-.8185333989D0,11.07693629D0,.7569503173D0,-9.655264745D0,
     *112.2446542D0,777.5948964D0,-5.745008536D0,-83.03921993D0,
     *-490.2278695D0,-1155.004209D0,39.08023320D0,1172.780574D0,
     *-39.44349797D0,-14.07211198D0,-40.41201127D0,-313.2277343D0,
     *2.203920979D0,8.232835341D0,197.7065115D0,391.2733948D0,
     *-18.57424451D0,-437.2779053D0,23.04976898D0,11.75673963D0,
     *13.60497313D0,4.691927060D0,18.20923547D0,27.59044809D0,
     *6.677425469D0,1.398283308D0,2.839005878D0,
     *31.24817706D0,24.53577264D0/

      DATA A2/-287187.1962D0,4970.499233D0,410490.1952D0,
     *-1347.839052D0,-386370.3240D0,3317.983750D0,-143462.3895D0,
     *5706.513767D0,171176.2904D0,250.8882750D0,-506570.8891D0,
     *5733.592632D0,397975.5842D0,9771.762168D0,-941834.2436D0,
     *7990.975260D0,54313.10318D0,447.5388060D0,528046.3449D0,
     *12751.04453D0,-21920.98301D0,-21.05075617D0,31971.07875D0,
     *3012.641612D0,-301822.9103D0,-3601.107387D0,1797.577552D0,
     *-6.315855803D0,142578.8406D0,13161.93640D0,804184.8410D0,
     *-14168.99698D0,-851926.6360D0,-1890.885671D0,972475.6869D0,
     *-8571.862853D0,26432.49197D0,-2554.752298D0,-482308.3431D0,
     *-4391.473324D0,105155.9160D0,-1134.622050D0,-74353.53091D0,
     *-5382.670711D0,695055.0788D0,-916.3365144D0,-12111.06667D0,
     *67.20923358D0,-367200.9285D0,-21414.14421D0,14.75567902D0,
     *20.75638190D0,59.78601609D0,16.86431444D0,32.58482365D0,
     *23.69472951D0,17.24977936D0,13.64902647D0,68.40989058D0,
     *11.67828167D0/

      DATA XM1,XM2/2*-12.D0/

      IF (IOPT.EQ.2) GOTO 1

      XSC1=(X-XSHIFT1-DXSHIFT1)*ALPHA1-XM1*(ALPHA1-1.D0)
      YSC1=Y*ALPHA1
      ZSC1=Z*ALPHA1
      D0SC1=D0*ALPHA1   ! HERE WE USE A SINGLE VALUE D0 OF THE THICKNESS FOR BOTH MODES

      CALL taildisk_01(D0SC1,DELTADX1,DELTADY,XSC1,YSC1,ZSC1,FX1,FY1,
     &FZ1)
      CALL SHLCAR5X5(A1,X,Y,Z,DXSHIFT1,HX1,HY1,HZ1)

      BX1=FX1+HX1
      BY1=FY1+HY1
      BZ1=FZ1+HZ1

      IF (IOPT.EQ.1) THEN
        BX2=0.D0
        BY2=0.D0
        BZ2=0.D0
        RETURN
      ENDIF

 1    XSC2=(X-XSHIFT2-DXSHIFT2)*ALPHA2-XM2*(ALPHA2-1.D0)
      YSC2=Y*ALPHA2
      ZSC2=Z*ALPHA2
      D0SC2=D0*ALPHA2   ! HERE WE USE A SINGLE VALUE D0 OF THE THICKNESS FOR BOTH MODES

      CALL taildisk_01(D0SC2,DELTADX2,DELTADY,XSC2,YSC2,ZSC2,FX2,FY2,
     &FZ2)
      CALL SHLCAR5X5(A2,X,Y,Z,DXSHIFT2,HX2,HY2,HZ2)

      BX2=FX2+HX2
      BY2=FY2+HY2
      BZ2=FZ2+HZ2

      IF (IOPT.EQ.2) THEN
        BX1=0.D0
        BY1=0.D0
        BZ1=0.D0
        RETURN
      ENDIF

      RETURN
      END
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
      SUBROUTINE taildisk_01(D0,DELTADX,DELTADY,X,Y,Z,BX,BY,BZ)
c
c       THIS SUBROUTINE COMPUTES THE COMPONENTS OF THE TAIL CURRENT FIELD,
C       SIMILAR TO THAT DESCRIBED BY TSYGANENKO AND PEREDO (1994).  THE
C       DIFFERENCE IS THAT NOW WE USE SPACEWARPING, AS DESCRIBED IN OUR
C       PAPER ON MODELING BIRKELAND CURRENTS (TSYGANENKO AND STERN, 1996)
C       INSTEAD OF SHEARING IT IN THE SPIRIT OF THE T89 TAIL MODEL.
C
      IMPLICIT REAL*8 (A-H,O-Z)
c
      DIMENSION F(5),B(5),C(5)
C
      DATA F /-71.09346626D0,-1014.308601D0,-1272.939359D0,
     *        -3224.935936D0,-44546.86232D0/
      DATA B /10.90101242D0,12.68393898D0,13.51791954D0,14.86775017D0,
     *          15.12306404D0/
      DATA C /.7954069972D0,.6716601849D0,1.174866319D0,2.565249920D0,
     *          10.01986790D0/
C
      RHO=DSQRT(X**2+Y**2)
      DRHODX=X/RHO
      DRHODY=Y/RHO

      DEX=DEXP(X/7.D0)
      D=D0+DELTADY*(Y/20.D0)**2  +DELTADX*DEX !   THE LAST TERM (INTRODUCED 10/11/2000) MAKES THE SHEET
      DDDY=DELTADY*Y*0.005D0                  !   THICKEN SUNWARD, TO AVOID PROBLEMS IN THE SUBSOLAR REGION
      DDDX=DELTADX/7.D0*DEX
C
      DZETA=DSQRT(Z**2+D**2)  !  THIS IS THE SAME SIMPLE WAY TO SPREAD
C                                        OUT THE SHEET, AS THAT USED IN T89
      DDZETADX=D*DDDX/DZETA
      DDZETADY=D*DDDY/DZETA
      DDZETADZ=Z/DZETA

C
      DBX=0.D0
      DBY=0.D0
      DBZ=0.D0
C
      DO 1 I=1,5
C
      BI=B(I)
      CI=C(I)
C
      S1=DSQRT((RHO+BI)**2+(DZETA+CI)**2)
      S2=DSQRT((RHO-BI)**2+(DZETA+CI)**2)

      DS1DRHO=(RHO+BI)/S1
      DS2DRHO=(RHO-BI)/S2
      DS1DDZ=(DZETA+CI)/S1
      DS2DDZ=(DZETA+CI)/S2
C
      DS1DX=DS1DRHO*DRHODX  +DS1DDZ*DDZETADX
      DS1DY=DS1DRHO*DRHODY  +   DS1DDZ*DDZETADY
      DS1DZ=                      DS1DDZ*DDZETADZ
C
      DS2DX=DS2DRHO*DRHODX  +DS2DDZ*DDZETADX
      DS2DY=DS2DRHO*DRHODY  +   DS2DDZ*DDZETADY
      DS2DZ=                    DS2DDZ*DDZETADZ
C
      S1TS2=S1*S2
      S1PS2=S1+S2
      S1PS2SQ=S1PS2**2

      FAC1=DSQRT(S1PS2SQ-(2.D0*BI)**2)
      AS=FAC1/(S1TS2*S1PS2SQ)
      DASDS1=(1.D0/(FAC1*S2)-AS/S1PS2*(S2*S2+S1*(3.D0*S1+4.D0*S2)))
     *          /(S1*S1PS2)
      DASDS2=(1.D0/(FAC1*S1)-AS/S1PS2*(S1*S1+S2*(3.D0*S2+4.D0*S1)))
     *          /(S2*S1PS2)
C
      DASDX=DASDS1*DS1DX+DASDS2*DS2DX
      DASDY=DASDS1*DS1DY+DASDS2*DS2DY
      DASDZ=DASDS1*DS1DZ+DASDS2*DS2DZ
C
      DBX=DBX-F(I)*X*DASDZ
      DBY=DBY-F(I)*Y*DASDZ
  1   DBZ=DBZ+F(I)*(2.D0*AS+X*DASDX+Y*DASDY)

      BX=DBX
      BY=DBY
      BZ=DBZ

      RETURN
      END
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C THIS CODE RETURNS THE SHIELDING FIELD REPRESENTED BY  5x5=25 "CARTESIAN"
C    HARMONICS
C
         SUBROUTINE  SHLCAR5X5(A,X,Y,Z,DSHIFT,HX,HY,HZ)
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  The NLIN coefficients are the amplitudes of the "cartesian"
c    harmonics (A(1)-A(NLIN).
c  The NNP nonlinear parameters (A(NLIN+1)-A(NTOT) are the scales Pi and Ri
C   entering the arguments of exponents, sines, and cosines in each of the
C   NLIN "Cartesian" harmonics
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
         IMPLICIT  REAL * 8  (A - H, O - Z)
C
         DIMENSION A(60)
C
         DHX=0.D0
         DHY=0.D0
         DHZ=0.D0

         L=0
C
         DO 2 I=1,5
         RP=1.D0/A(50+I)
         CYPI=DCOS(Y*RP)
         SYPI=DSIN(Y*RP)
C
         DO 2 K=1,5
         RR=1.D0/A(55+K)
         SZRK=DSIN(Z*RR)
         CZRK=DCOS(Z*RR)
         SQPR=DSQRT(RP**2+RR**2)
         EPR=DEXP(X*SQPR)
C
         DBX=-SQPR*EPR*CYPI*SZRK
         DBY= RP*EPR*SYPI*SZRK
         DBZ=-RR*EPR*CYPI*CZRK

         L=L+2
         COEF=A(L-1)+A(L)*DSHIFT

         DHX=DHX+COEF*DBX
         DHY=DHY+COEF*DBY
         DHZ=DHZ+COEF*DBZ
c
  2      CONTINUE

         HX=DHX
         HY=DHY
         HZ=DHZ
C
      RETURN
      END
c
c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
      SUBROUTINE BIRK_TOT (IOPB,PS,X,Y,Z,BX11,BY11,BZ11,BX12,BY12,BZ12,
     *                          BX21,BY21,BZ21,BX22,BY22,BZ22)
C
C      IOPB -  BIRKELAND FIELD MODE FLAG:
C         IOPB=0 - ALL COMPONENTS
C         IOPB=1 - REGION 1, MODES 1 & 2
C         IOPB=2 - REGION 2, MODES 1 & 2
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SH11(86),SH12(86),SH21(86),SH22(86)
      COMMON /BIRKPAR/ XKAPPA1,XKAPPA2   !  INPUT PARAMETERS, SPECIFIED FROM S/R EXTALL
      COMMON /DPHI_B_RHO0/ DPHI,B,RHO_0,XKAPPA ! PARAMETERS, CONTROLLING THE DAY-NIGHT ASYMMETRY OF F.A.C.

      DATA SH11/46488.84663D0,-15541.95244D0,-23210.09824D0,
     *-32625.03856D0,-109894.4551D0,-71415.32808D0,58168.94612D0,
     *55564.87578D0,-22890.60626D0,-6056.763968D0,5091.368100D0,
     *239.7001538D0,-13899.49253D0,4648.016991D0,6971.310672D0,
     *9699.351891D0,32633.34599D0,21028.48811D0,-17395.96190D0,
     *-16461.11037D0,7447.621471D0,2528.844345D0,-1934.094784D0,
     *-588.3108359D0,-32588.88216D0,10894.11453D0,16238.25044D0,
     *22925.60557D0,77251.11274D0,50375.97787D0,-40763.78048D0,
     *-39088.60660D0,15546.53559D0,3559.617561D0,-3187.730438D0,
     *309.1487975D0,88.22153914D0,-243.0721938D0,-63.63543051D0,
     *191.1109142D0,69.94451996D0,-187.9539415D0,-49.89923833D0,
     *104.0902848D0,-120.2459738D0,253.5572433D0,89.25456949D0,
     *-205.6516252D0,-44.93654156D0,124.7026309D0,32.53005523D0,
     *-98.85321751D0,-36.51904756D0,98.88241690D0,24.88493459D0,
     *-55.04058524D0,61.14493565D0,-128.4224895D0,-45.35023460D0,
     *105.0548704D0,-43.66748755D0,119.3284161D0,31.38442798D0,
     *-92.87946767D0,-33.52716686D0,89.98992001D0,25.87341323D0,
     *-48.86305045D0,59.69362881D0,-126.5353789D0,-44.39474251D0,
     *101.5196856D0,59.41537992D0,41.18892281D0,80.86101200D0,
     *3.066809418D0,7.893523804D0,30.56212082D0,10.36861082D0,
     *8.222335945D0,19.97575641D0,2.050148531D0,4.992657093D0,
     *2.300564232D0,.2256245602D0,-.05841594319D0/

      DATA SH12/210260.4816D0,-1443587.401D0,-1468919.281D0,
     *281939.2993D0,-1131124.839D0,729331.7943D0,2573541.307D0,
     *304616.7457D0,468887.5847D0,181554.7517D0,-1300722.650D0,
     *-257012.8601D0,645888.8041D0,-2048126.412D0,-2529093.041D0,
     *571093.7972D0,-2115508.353D0,1122035.951D0,4489168.802D0,
     *75234.22743D0,823905.6909D0,147926.6121D0,-2276322.876D0,
     *-155528.5992D0,-858076.2979D0,3474422.388D0,3986279.931D0,
     *-834613.9747D0,3250625.781D0,-1818680.377D0,-7040468.986D0,
     *-414359.6073D0,-1295117.666D0,-346320.6487D0,3565527.409D0,
     *430091.9496D0,-.1565573462D0,7.377619826D0,.4115646037D0,
     *-6.146078880D0,3.808028815D0,-.5232034932D0,1.454841807D0,
     *-12.32274869D0,-4.466974237D0,-2.941184626D0,-.6172620658D0,
     *12.64613490D0,1.494922012D0,-21.35489898D0,-1.652256960D0,
     *16.81799898D0,-1.404079922D0,-24.09369677D0,-10.99900839D0,
     *45.94237820D0,2.248579894D0,31.91234041D0,7.575026816D0,
     *-45.80833339D0,-1.507664976D0,14.60016998D0,1.348516288D0,
     *-11.05980247D0,-5.402866968D0,31.69094514D0,12.28261196D0,
     *-37.55354174D0,4.155626879D0,-33.70159657D0,-8.437907434D0,
     *36.22672602D0,145.0262164D0,70.73187036D0,85.51110098D0,
     *21.47490989D0,24.34554406D0,31.34405345D0,4.655207476D0,
     *5.747889264D0,7.802304187D0,1.844169801D0,4.867254550D0,
     *2.941393119D0,.1379899178D0,.06607020029D0/

      DATA SH21/162294.6224D0,503885.1125D0,-27057.67122D0,
     *-531450.1339D0,84747.05678D0,-237142.1712D0,84133.61490D0,
     *259530.0402D0,69196.05160D0,-189093.5264D0,-19278.55134D0,
     *195724.5034D0,-263082.6367D0,-818899.6923D0,43061.10073D0,
     *863506.6932D0,-139707.9428D0,389984.8850D0,-135167.5555D0,
     *-426286.9206D0,-109504.0387D0,295258.3531D0,30415.07087D0,
     *-305502.9405D0,100785.3400D0,315010.9567D0,-15999.50673D0,
     *-332052.2548D0,54964.34639D0,-152808.3750D0,51024.67566D0,
     *166720.0603D0,40389.67945D0,-106257.7272D0,-11126.14442D0,
     *109876.2047D0,2.978695024D0,558.6019011D0,2.685592939D0,
     *-338.0004730D0,-81.99724090D0,-444.1102659D0,89.44617716D0,
     *212.0849592D0,-32.58562625D0,-982.7336105D0,-35.10860935D0,
     *567.8931751D0,-1.917212423D0,-260.2023543D0,-1.023821735D0,
     *157.5533477D0,23.00200055D0,232.0603673D0,-36.79100036D0,
     *-111.9110936D0,18.05429984D0,447.0481000D0,15.10187415D0,
     *-258.7297813D0,-1.032340149D0,-298.6402478D0,-1.676201415D0,
     *180.5856487D0,64.52313024D0,209.0160857D0,-53.85574010D0,
     *-98.52164290D0,14.35891214D0,536.7666279D0,20.09318806D0,
     *-309.7349530D0,58.54144539D0,67.45226850D0,97.92374406D0,
     *4.752449760D0,10.46824379D0,32.91856110D0,12.05124381D0,
     *9.962933904D0,15.91258637D0,1.804233877D0,6.578149088D0,
     *2.515223491D0,.1930034238D0,-.02261109942D0/

      DATA SH22/-131287.8986D0,-631927.6885D0,-318797.4173D0,
     *616785.8782D0,-50027.36189D0,863099.9833D0,47680.20240D0,
     *-1053367.944D0,-501120.3811D0,-174400.9476D0,222328.6873D0,
     *333551.7374D0,-389338.7841D0,-1995527.467D0,-982971.3024D0,
     *1960434.268D0,297239.7137D0,2676525.168D0,-147113.4775D0,
     *-3358059.979D0,-2106979.191D0,-462827.1322D0,1017607.960D0,
     *1039018.475D0,520266.9296D0,2627427.473D0,1301981.763D0,
     *-2577171.706D0,-238071.9956D0,-3539781.111D0,94628.16420D0,
     *4411304.724D0,2598205.733D0,637504.9351D0,-1234794.298D0,
     *-1372562.403D0,-2.646186796D0,-31.10055575D0,2.295799273D0,
     *19.20203279D0,30.01931202D0,-302.1028550D0,-14.78310655D0,
     *162.1561899D0,.4943938056D0,176.8089129D0,-.2444921680D0,
     *-100.6148929D0,9.172262228D0,137.4303440D0,-8.451613443D0,
     *-84.20684224D0,-167.3354083D0,1321.830393D0,76.89928813D0,
     *-705.7586223D0,18.28186732D0,-770.1665162D0,-9.084224422D0,
     *436.3368157D0,-6.374255638D0,-107.2730177D0,6.080451222D0,
     *65.53843753D0,143.2872994D0,-1028.009017D0,-64.22739330D0,
     *547.8536586D0,-20.58928632D0,597.3893669D0,10.17964133D0,
     *-337.7800252D0,159.3532209D0,76.34445954D0,84.74398828D0,
     *12.76722651D0,27.63870691D0,32.69873634D0,5.145153451D0,
     *6.310949163D0,6.996159733D0,1.971629939D0,4.436299219D0,
     *2.904964304D0,.1486276863D0,.06859991529D0/
C
      XKAPPA=XKAPPA1        !  FORWARDED IN BIRK_1N2
      X_SC=XKAPPA1-1.1D0    !  FORWARDED IN BIRK_SHL

      IF (IOPB.EQ.0.OR.IOPB.EQ.1) THEN

      CALL BIRK_1N2 (1,1,PS,X,Y,Z,FX11,FY11,FZ11)           !  REGION 1, MODE 1
      CALL BIRK_SHL (SH11,PS,X_SC,X,Y,Z,HX11,HY11,HZ11)
      BX11=FX11+HX11
      BY11=FY11+HY11
      BZ11=FZ11+HZ11

      CALL BIRK_1N2 (1,2,PS,X,Y,Z,FX12,FY12,FZ12)           !  REGION 1, MODE 2
      CALL BIRK_SHL (SH12,PS,X_SC,X,Y,Z,HX12,HY12,HZ12)
      BX12=FX12+HX12
      BY12=FY12+HY12
      BZ12=FZ12+HZ12

      ENDIF

      XKAPPA=XKAPPA2        !  FORWARDED IN BIRK_1N2
      X_SC=XKAPPA2-1.0D0    !  FORWARDED IN BIRK_SHL

      IF (IOPB.EQ.0.OR.IOPB.EQ.2) THEN

      CALL BIRK_1N2 (2,1,PS,X,Y,Z,FX21,FY21,FZ21)           !  REGION 2, MODE 1
      CALL BIRK_SHL (SH21,PS,X_SC,X,Y,Z,HX21,HY21,HZ21)
      BX21=FX21+HX21
      BY21=FY21+HY21
      BZ21=FZ21+HZ21

      CALL BIRK_1N2 (2,2,PS,X,Y,Z,FX22,FY22,FZ22)           !  REGION 2, MODE 2
      CALL BIRK_SHL (SH22,PS,X_SC,X,Y,Z,HX22,HY22,HZ22)
      BX22=FX22+HX22
      BY22=FY22+HY22
      BZ22=FZ22+HZ22

      ENDIF

      RETURN
      END
C
c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c
      SUBROUTINE BIRK_1N2 (NUMB,MODE,PS,X,Y,Z,BX,BY,BZ)        !   NB# 6, P.60
C
C  CALCULATES COMPONENTS  OF REGION 1/2 FIELD IN SPHERICAL COORDS.  DERIVED FROM THE S/R DIPDEF2C (WHICH
C    DOES THE SAME JOB, BUT INPUT/OUTPUT THERE WAS IN SPHERICAL COORDS, WHILE HERE WE USE CARTESIAN ONES)
C
C   INPUT:  NUMB=1 (2) FOR REGION 1 (2) CURRENTS
C           MODE=1 YIELDS SIMPLE SINUSOIDAL MLT VARIATION, WITH MAXIMUM CURRENT AT DAWN/DUSK MERIDIAN
C     WHILE MODE=2 YIELDS THE SECOND HARMONIC.
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A11(31),A12(31),A21(31),A22(31)
      COMMON /MODENUM/ M
      COMMON /DTHETA/ DTHETA

      COMMON /DPHI_B_RHO0/ DPHI,B,RHO_0,XKAPPA ! THESE PARAMETERS CONTROL DAY-NIGHT ASYMMETRY OF F.A.C., AS FOLLOWS:

C  (1) DPHI:   HALF-DIFFERENCE (IN RADIANS) BETWEEN DAY AND NIGHT LATITUDE OF FAC OVAL AT IONOSPHERIC ALTITUDE;
C              TYPICAL VALUE: 0.06
C  (2) B:      AN ASYMMETRY FACTOR AT HIGH-ALTITUDES;  FOR B=0, THE ONLY ASYMMETRY IS THAT FROM DPHI
C              TYPICAL VALUES: 0.35-0.70
C  (3) RHO_0:  A FIXED PARAMETER, DEFINING THE DISTANCE RHO, AT WHICH THE LATITUDE SHIFT GRADUALLY SATURATES AND
C              STOPS INCREASING
C              ITS VALUE WAS ASSUMED FIXED, EQUAL TO 7.0.
C  (4) XKAPPA: AN OVERALL SCALING FACTOR, WHICH CAN BE USED FOR CHANGING THE SIZE OF THE F.A.C. OVAL
C
      DATA BETA,RH,EPS/0.9D0,10.D0,3.D0/ ! parameters of the tilt-dependent deformation of the untilted F.A.C. field

      DATA A11/.1618068350D0,-.1797957553D0,2.999642482D0,
     *-.9322708978D0,-.6811059760D0,.2099057262D0,-8.358815746D0,
     *-14.86033550D0,.3838362986D0,-16.30945494D0,4.537022847D0,
     *2.685836007D0,27.97833029D0,6.330871059D0,1.876532361D0,
     *18.95619213D0,.9651528100D0,.4217195118D0,-.08957770020D0,
     *-1.823555887D0,.7457045438D0,-.5785916524D0,-1.010200918D0,
     *.01112389357D0,.09572927448D0,-.3599292276D0,8.713700514D0,
     *.9763932955D0,3.834602998D0,2.492118385D0,.7113544659D0/
      DATA A12/.7058026940D0,-.2845938535D0,5.715471266D0,
     *-2.472820880D0,-.7738802408D0,.3478293930D0,-11.37653694D0,
     *-38.64768867D0,.6932927651D0,-212.4017288D0,4.944204937D0,
     *3.071270411D0,33.05882281D0,7.387533799D0,2.366769108D0,
     *79.22572682D0,.6154290178D0,.5592050551D0,-.1796585105D0,
     *-1.654932210D0,.7309108776D0,-.4926292779D0,-1.130266095D0,
     *-.009613974555D0,.1484586169D0,-.2215347198D0,7.883592948D0,
     *.02768251655D0,2.950280953D0,1.212634762D0,.5567714182D0/
      DATA A21/.1278764024D0,-.2320034273D0,1.805623266D0,
     *-32.37241440D0,-.9931490648D0,.3175085630D0,-2.492465814D0,
     *-16.21600096D0,.2695393416D0,-6.752691265D0,3.971794901D0,
     *14.54477563D0,41.10158386D0,7.912889730D0,1.258297372D0,
     *9.583547721D0,1.014141963D0,.5104134759D0,-.1790430468D0,
     *-1.756358428D0,.7561986717D0,-.6775248254D0,-.04014016420D0,
     *.01446794851D0,.1200521731D0,-.2203584559D0,4.508963850D0,
     *.8221623576D0,1.779933730D0,1.102649543D0,.8867880020D0/
      DATA A22/.4036015198D0,-.3302974212D0,2.827730930D0,
     *-45.44405830D0,-1.611103927D0,.4927112073D0,-.003258457559D0,
     *-49.59014949D0,.3796217108D0,-233.7884098D0,4.312666980D0,
     *18.05051709D0,28.95320323D0,11.09948019D0,.7471649558D0,
     *67.10246193D0,.5667096597D0,.6468519751D0,-.1560665317D0,
     *-1.460805289D0,.7719653528D0,-.6658988668D0,.2515179349D-05,
     *.02426021891D0,.1195003324D0,-.2625739255D0,4.377172556D0,
     *.2421190547D0,2.503482679D0,1.071587299D0,.7247997430D0/

      B=0.5D0
      RHO_0=7.0D0

      M=MODE
      IF (NUMB.EQ.1) THEN
          DPHI=0.055D0
          DTHETA=0.06D0
      ENDIF

      IF (NUMB.EQ.2) THEN
          DPHI=0.030D0
          DTHETA=0.09D0
      ENDIF

      Xsc=X*XKAPPA
      Ysc=Y*XKAPPA
      Zsc=Z*XKAPPA
      RHO=DSQRT(Xsc**2+Zsc**2)

      Rsc=DSQRT(Xsc**2+Ysc**2+Zsc**2)                                 !  SCALED
      RHO2=RHO_0**2

      IF (Xsc.EQ.0.D0.AND.Zsc.EQ.0.D0) THEN
         PHI=0.D0
      ELSE
         PHI=DATAN2(-Zsc,Xsc)  !  FROM CARTESIAN TO CYLINDRICAL (RHO,PHI,Y)
      ENDIF

      SPHIC=DSIN(PHI)
      CPHIC=DCOS(PHI)  !  "C" means "CYLINDRICAL", TO DISTINGUISH FROM SPHERICAL PHI

      BRACK=DPHI+B*RHO2/(RHO2+1.D0)*(RHO**2-1.D0)/(RHO2+RHO**2)
      R1RH=(Rsc-1.D0)/RH
      IF (R1RH.LT.0.D0) R1RH=0.D0  !  AVOID NEGATIVE VALUES OF R1RH, WHICH MAY OCCUR IF THE
C                                     POINT (X,Y,Z) LIES CLOSE TO EARTH'S SURFACE AND THE S.W.
C                                     PRESSURE IS ABNORMALLY LOW

      PSIAS=BETA*PS/(1.D0+R1RH**EPS)**(1.D0/EPS)

      PHIS=PHI-BRACK*DSIN(PHI) -PSIAS
      DPHISPHI=1.D0-BRACK*DCOS(PHI)
      DPHISRHO=-2.D0*B*RHO2*RHO/(RHO2+RHO**2)**2 *DSIN(PHI)
     *   +BETA*PS*R1RH**(EPS-1.D0)*RHO/(RH*Rsc*
     *   (1.D0+R1RH**EPS)**(1.D0/EPS+1.D0))
      DPHISDY= BETA*PS*R1RH**(EPS-1.D0)*Ysc/(RH*Rsc*
     *   (1.D0+R1RH**EPS)**(1.D0/EPS+1.D0))

      SPHICS=DSIN(PHIS)
      CPHICS=DCOS(PHIS)

      XS= RHO*CPHICS
      ZS=-RHO*SPHICS

      IF (NUMB.EQ.1) THEN
        IF (MODE.EQ.1) CALL TWOCONES (A11,XS,Ysc,ZS,BXS,BYAS,BZS)
        IF (MODE.EQ.2) CALL TWOCONES (A12,XS,Ysc,ZS,BXS,BYAS,BZS)
      ELSE
        IF (MODE.EQ.1) CALL TWOCONES (A21,XS,Ysc,ZS,BXS,BYAS,BZS)
        IF (MODE.EQ.2) CALL TWOCONES (A22,XS,Ysc,ZS,BXS,BYAS,BZS)
      ENDIF

      BRHOAS=BXS*CPHICS-BZS*SPHICS
      BPHIAS=-BXS*SPHICS-BZS*CPHICS

      BRHO_S=BRHOAS*DPHISPHI                             *XKAPPA        ! SCALING
      BPHI_S=(BPHIAS-RHO*(BYAS*DPHISDY+BRHOAS*DPHISRHO)) *XKAPPA
      BY_S=BYAS*DPHISPHI                                 *XKAPPA

      BX=BRHO_S*CPHIC-BPHI_S*SPHIC
      BY=BY_S
      BZ=-BRHO_S*SPHIC-BPHI_S*CPHIC

      RETURN
      END
c
C=========================================================================
c
      SUBROUTINE TWOCONES (A,X,Y,Z,BX,BY,BZ)
C
C  ADDS FIELDS FROM TWO CONES (NORTHERN AND SOUTHERN), WITH A PROPER SYMMETRY
C  OF THE CURRENT AND FIELD, CORRESPONDING TO THE REGION 1 BIRKELAND CURRENTS. (NB #6, P.58).
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)

      CALL ONE_CONE (A,X,Y,Z,BXN,BYN,BZN)
      CALL ONE_CONE (A,X,-Y,-Z,BXS,BYS,BZS)
      BX=BXN-BXS
      BY=BYN+BYS
      BZ=BZN+BZS

      RETURN
      END
c
C-------------------------------------------------------------------------
C
      SUBROUTINE ONE_CONE(A,X,Y,Z,BX,BY,BZ)
c
c  RETURNS FIELD COMPONENTS FOR A DEFORMED CONICAL CURRENT SYSTEM, FITTED TO A BIOSAVART FIELD
c  HERE ONLY THE NORTHERN CONE IS TAKEN INTO ACCOUNT.
c
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)

      COMMON /DTHETA/ DTHETA
      COMMON /MODENUM/ M

      DATA DR,DT/1.D-6,1.D-6/  !   JUST FOR NUMERICAL DIFFERENTIATION

      THETA0=A(31)

      RHO2=X**2+Y**2
      RHO=DSQRT(RHO2)
      R=DSQRT(RHO2+Z**2)
      THETA=DATAN2(RHO,Z)
      PHI=DATAN2(Y,X)
C
C   MAKE THE DEFORMATION OF COORDINATES:
C
       RS=R_S(A,R,THETA)
       THETAS=THETA_S(A,R,THETA)
       PHIS=PHI
C
C   CALCULATE FIELD COMPONENTS AT THE NEW POSITION (ASTERISKED):
C
       CALL FIALCOS (RS,THETAS,PHIS,BTAST,BFAST,M,THETA0,DTHETA)    !   MODE #M
C
C   NOW TRANSFORM B{R,T,F}_AST BY THE DEFORMATION TENSOR:
C
C      FIRST OF ALL, FIND THE DERIVATIVES:
C
       DRSDR=(R_S(A,R+DR,THETA)-R_S(A,R-DR,THETA))/(2.D0*DR)
       DRSDT=(R_S(A,R,THETA+DT)-R_S(A,R,THETA-DT))/(2.D0*DT)
       DTSDR=(THETA_S(A,R+DR,THETA)-THETA_S(A,R-DR,THETA))/(2.D0*DR)
       DTSDT=(THETA_S(A,R,THETA+DT)-THETA_S(A,R,THETA-DT))/(2.D0*DT)

       STSST=DSIN(THETAS)/DSIN(THETA)
       RSR=RS/R

       BR     =-RSR/R*STSST*BTAST*DRSDT                 !   NB#6, P.43    BRAST DOES NOT ENTER HERE
       BTHETA = RSR*STSST*BTAST*DRSDR                  !          (IT IS IDENTICALLY ZERO IN OUR CASE)
       BPHI   = RSR*BFAST*(DRSDR*DTSDT-DRSDT*DTSDR)

       S=RHO/R
       C=Z/R
       SF=Y/RHO
       CF=X/RHO

       BE=BR*S+BTHETA*C

       BX=A(1)*(BE*CF-BPHI*SF)
       BY=A(1)*(BE*SF+BPHI*CF)
       BZ=A(1)*(BR*C-BTHETA*S)

       RETURN
       END
C
C=====================================================================================
      DOUBLE PRECISION FUNCTION R_S(A,R,THETA)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)
C
      R_S=R+A(2)/R+A(3)*R/DSQRT(R**2+A(11)**2)+A(4)*R/(R**2+A(12)**2)
     *+(A(5)+A(6)/R+A(7)*R/DSQRT(R**2+A(13)**2)+A(8)*R/(R**2+A(14)**2))*
     * DCOS(THETA)
     *+(A(9)*R/DSQRT(R**2+A(15)**2)+A(10)*R/(R**2+A(16)**2)**2)
     * *DCOS(2.D0*THETA)
C
      RETURN
      END
C
C-----------------------------------------------------------------------------
C
      DOUBLE PRECISION FUNCTION THETA_S(A,R,THETA)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)
c
      THETA_S=THETA+(A(17)+A(18)/R+A(19)/R**2
     *                +A(20)*R/DSQRT(R**2+A(27)**2))*DSIN(THETA)
     * +(A(21)+A(22)*R/DSQRT(R**2+A(28)**2)
     *                +A(23)*R/(R**2+A(29)**2))*DSIN(2.D0*THETA)
     * +(A(24)+A(25)/R+A(26)*R/(R**2+A(30)**2))*DSIN(3.D0*THETA)
C
      RETURN
      END
C
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
      SUBROUTINE FIALCOS(R,THETA,PHI,BTHETA,BPHI,N,THETA0,DT)
C
C  CONICAL MODEL OF BIRKELAND CURRENT FIELD; BASED ON THE OLD S/R FIALCO (OF 1990-91)
C  NB OF 1985-86-88, NOTE OF MARCH 5, BUT HERE BOTH INPUT AND OUTPUT ARE IN SPHERICAL CDS.

C  BTN, AND BPN ARE THE ARRAYS OF BTHETA AND BPHI (BTN(i), BPN(i) CORRESPOND TO i-th MODE).
C   ONLY FIRST  N  MODE AMPLITUDES ARE COMPUTED (N<=10).
C    THETA0 IS THE ANGULAR HALF-WIDTH OF THE CONE, DT IS THE ANGULAR H.-W. OF THE CURRENT LAYER

C   NOTE:  BR=0  (BECAUSE ONLY RADIAL CURRENTS ARE PRESENT IN THIS MODEL)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION  BTN(10),BPN(10),CCOS(10),SSIN(10)

      SINTE=DSIN(THETA)
      RO=R*SINTE
      COSTE=DCOS(THETA)
      SINFI=DSIN(PHI)
      COSFI=DCOS(PHI)
      TG=SINTE/(1.D0+COSTE)   !        TAN(THETA/2)
      CTG=SINTE/(1.D0-COSTE)  !        COT(THETA/2)
C
C
      TETANP=THETA0+DT
      TETANM=THETA0-DT
      IF(THETA.LT.TETANM) GOTO 1
      TGP=DTAN(TETANP*0.5D0)
      TGM=DTAN(TETANM*0.5D0)
      TGM2=TGM*TGM
      TGP2=TGP*TGP
  1   CONTINUE

      COSM1=1.D0
      SINM1=0.D0
      TM=1.D0
      TGM2M=1.D0
      TGP2M=1.D0

      DO 2 M=1,N
      TM=TM*TG
      CCOS(M)=COSM1*COSFI-SINM1*SINFI
      SSIN(M)=SINM1*COSFI+COSM1*SINFI
      COSM1=CCOS(M)
      SINM1=SSIN(M)
      IF(THETA.LT.TETANM) THEN
      T=TM
      DTT=0.5D0*M*TM*(TG+CTG)
      DTT0=0.D0
      ELSE IF(THETA.LT.TETANP) THEN
      TGM2M=TGM2M*TGM2
      FC=1.D0/(TGP-TGM)
      FC1=1.D0/(2*M+1)
      TGM2M1=TGM2M*TGM
      TG21=1.D0+TG*TG
      T=FC*(TM*(TGP-TG)+FC1*(TM*TG-TGM2M1/TM))
      DTT=0.5D0*M*FC*TG21*(TM/TG*(TGP-TG)-FC1*(TM-TGM2M1/(TM*TG)))
      DTT0=0.5D0*FC*((TGP+TGM)*(TM*TG-FC1*(TM*TG-TGM2M1/TM))+
     * TM*(1.D0-TGP*TGM)-(1.D0+TGM2)*TGM2M/TM)
      ELSE
      TGP2M=TGP2M*TGP2
      TGM2M=TGM2M*TGM2
      FC=1.D0/(TGP-TGM)
      FC1=1.D0/(2*M+1)
      T=FC*FC1*(TGP2M*TGP-TGM2M*TGM)/TM
      DTT=-T*M*0.5D0*(TG+CTG)
      ENDIF

      BTN(M)=M*T*CCOS(M)/RO
  2   BPN(M)=-DTT*SSIN(M)/R

      BTHETA=BTN(N) *800.D0
      BPHI  =BPN(N) *800.D0

      RETURN
      END
C
C-------------------------------------------------------------------------
C
C
         SUBROUTINE BIRK_SHL (A,PS,X_SC,X,Y,Z,BX,BY,BZ)
C
	 IMPLICIT  REAL * 8  (A - H, O - Z)
         DIMENSION A(86)
C
         CPS=DCOS(PS)
         SPS=DSIN(PS)

         S3PS=2.D0*CPS
C
         PST1=PS*A(85)
         PST2=PS*A(86)

         ST1=DSIN(PST1)
         CT1=DCOS(PST1)
         ST2=DSIN(PST2)
         CT2=DCOS(PST2)

         X1=X*CT1-Z*ST1
         Z1=X*ST1+Z*CT1
         X2=X*CT2-Z*ST2
         Z2=X*ST2+Z*CT2
C
         L=0
         GX=0.D0
         GY=0.D0
         GZ=0.D0
C
         DO 1 M=1,2     !    M=1 IS FOR THE 1ST SUM ("PERP." SYMMETRY)
C                          AND M=2 IS FOR THE SECOND SUM ("PARALL." SYMMETRY)
             DO 2 I=1,3
                  P=A(72+I)
                  Q=A(78+I)
                  CYPI=DCOS(Y/P)
                  CYQI=DCOS(Y/Q)
                  SYPI=DSIN(Y/P)
                  SYQI=DSIN(Y/Q)
C
                DO 3 K=1,3
                   R=A(75+K)
                   S=A(81+K)
                   SZRK=DSIN(Z1/R)
                   CZSK=DCOS(Z2/S)
                   CZRK=DCOS(Z1/R)
                   SZSK=DSIN(Z2/S)
                     SQPR=DSQRT(1.D0/P**2+1.D0/R**2)
                     SQQS=DSQRT(1.D0/Q**2+1.D0/S**2)
                        EPR=DEXP(X1*SQPR)
                        EQS=DEXP(X2*SQQS)
C
                  DO 4 N=1,2  ! N=1 IS FOR THE FIRST PART OF EACH COEFFICIENT
C                                AND N=2 IS FOR THE SECOND ONE

                    DO 5 NN=1,2 !   NN = 1,2 FURTHER SPLITS THE COEFFICIENTS INTO 2 PARTS,
C                                         TO TAKE INTO ACCOUNT THE SCALE FACTOR DEPENDENCE

                    IF (M.EQ.1) THEN
                         FX=-SQPR*EPR*CYPI*SZRK
                         FY=EPR*SYPI*SZRK/P
                         FZ=-EPR*CYPI*CZRK/R
                       IF (N.EQ.1) THEN
                         IF (NN.EQ.1) THEN
                          HX=FX
                          HY=FY
                          HZ=FZ
                         ELSE
                          HX=FX*X_SC
                          HY=FY*X_SC
                          HZ=FZ*X_SC
                         ENDIF
                       ELSE
                         IF (NN.EQ.1) THEN
                          HX=FX*CPS
                          HY=FY*CPS
                          HZ=FZ*CPS
                         ELSE
                          HX=FX*CPS*X_SC
                          HY=FY*CPS*X_SC
                          HZ=FZ*CPS*X_SC
                         ENDIF
                       ENDIF

                     ELSE                            !   M.EQ.2
                         FX=-SPS*SQQS*EQS*CYQI*CZSK
                         FY=SPS/Q*EQS*SYQI*CZSK
                         FZ=SPS/S*EQS*CYQI*SZSK
                       IF (N.EQ.1) THEN
                        IF (NN.EQ.1) THEN
                          HX=FX
                          HY=FY
                          HZ=FZ
                        ELSE
                          HX=FX*X_SC
                          HY=FY*X_SC
                          HZ=FZ*X_SC
                        ENDIF
                       ELSE
                        IF (NN.EQ.1) THEN
                         HX=FX*S3PS
                         HY=FY*S3PS
                         HZ=FZ*S3PS
                        ELSE
                         HX=FX*S3PS*X_SC
                         HY=FY*S3PS*X_SC
                         HZ=FZ*S3PS*X_SC
                        ENDIF
                       ENDIF
                  ENDIF
       L=L+1

       IF (M.EQ.1) THEN
       HXR=HX*CT1+HZ*ST1
       HZR=-HX*ST1+HZ*CT1
       ELSE
       HXR=HX*CT2+HZ*ST2
       HZR=-HX*ST2+HZ*CT2
       ENDIF

       GX=GX+HXR*A(L)
       GY=GY+HY *A(L)
  5    GZ=GZ+HZR*A(L)

  4   CONTINUE
  3   CONTINUE
  2   CONTINUE
  1   CONTINUE

      BX=GX
      BY=GY
      BZ=GZ

      RETURN
      END

C
C************************************************************************************
C
      SUBROUTINE FULL_RC (IOPR,PS,X,Y,Z,BXSRC,BYSRC,BZSRC,BXPRC,BYPRC,
     *  BZPRC)
C
C   CALCULATES GSM FIELD COMPONENTS OF THE SYMMETRIC (SRC) AND PARTIAL (PRC) COMPONENTS OF THE RING CURRENT
C   SRC  PROVIDES A DEPRESSION OF -28 nT AT EARTH
C   PRC  CORRESPONDS TO THE PRESSURE DIFFERENCE OF 2 nPa BETWEEN MIDNIGHT AND NOON RING CURRENT
C             PARTICLE PRESSURE AND YIELDS A DEPRESSION OF -17 nT AT X=-6Re
C
C   SC_SY AND SC_PR ARE SCALING FACTORS FOR THE SYMMETRIC AND PARTIAL COMPONENTS:
C          VALUES LARGER THAN 1 RESULT IN SPATIALLY LARGER CURRENTS
C
C   PHI IS THE ROTATION ANGLE IN RADIANS OF THE PARTIAL RING CURRENT (MEASURED FROM MIDNIGHT TOWARD DUSK)
C
C     IOPR -  A RING CURRENT CALCULATION FLAG (FOR LEAST-SQUARES FITTING ONLY):
C             IOPR=0 - BOTH SRC AND PRC FIELDS ARE CALCULATED
C             IOPR=1 - SRC ONLY
C             IOPR=2 - PRC ONLY
C
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION C_SY(86),C_PR(86)
        COMMON /RCPAR/ SC_SY,SC_PR,PHI
C
        DATA C_SY/-957.2534900,-817.5450246,583.2991249,758.8568270,     !   CORRECTED VALUES (AS OF MAY 2006)
     *13.17029064,68.94173502,-15.29764089,-53.43151590,27.34311724,
     *149.5252826,-11.00696044,-179.7031814,953.0914774,817.2340042,
     *-581.0791366,-757.5387665,-13.10602697,-68.58155678,15.22447386,
     *53.15535633,-27.07982637,-149.1413391,10.91433279,179.3251739,
     *-6.028703251,1.303196101,-1.345909343,-1.138296330,-0.06642634348,
     *-0.3795246458,.07487833559,.2891156371,-.5506314391,-.4443105812,
     *0.2273682152,0.01086886655,-9.130025352,1.118684840,1.110838825,
     *.1219761512,-.06263009645,-.1896093743,.03434321042,.01523060688,
     *-.4913171541,-.2264814165,-.04791374574,.1981955976,-68.32678140,
     *-48.72036263,14.03247808,16.56233733,2.369921099,6.200577111,
     *-1.415841250,-0.8184867835,-3.401307527,-8.490692287,3.217860767,
     *-9.037752107,66.09298105,48.23198578,-13.67277141,-16.27028909,
     *-2.309299411,-6.016572391,1.381468849,0.7935312553,3.436934845,
     * 8.260038635,-3.136213782,8.833214943,8.041075485,8.024818618,
     * 35.54861873,12.55415215,1.738167799,3.721685353,23.06768025,
     * 6.871230562,6.806229878,21.35990364,1.687412298,3.500885177,
     * 0.3498952546,0.6595919814/

        DATA C_PR/-64820.58481D0,-63965.62048D0,66267.93413D0,
     *135049.7504D0,-36.56316878D0,124.6614669D0,56.75637955D0,
     *-87.56841077D0,5848.631425D0,4981.097722D0,-6233.712207D0,
     *-10986.40188D0,68716.52057D0,65682.69473D0,-69673.32198D0,
     *-138829.3568D0,43.45817708D0,-117.9565488D0,-62.14836263D0,
     *79.83651604D0,-6211.451069D0,-5151.633113D0,6544.481271D0,
     *11353.03491D0,23.72352603D0,-256.4846331D0,25.77629189D0,
     *145.2377187D0,-4.472639098D0,-3.554312754D0,2.936973114D0,
     *2.682302576D0,2.728979958D0,26.43396781D0,-9.312348296D0,
     *-29.65427726D0,-247.5855336D0,-206.9111326D0,74.25277664D0,
     *106.4069993D0,15.45391072D0,16.35943569D0,-5.965177750D0,
     *-6.079451700D0,115.6748385D0,-35.27377307D0,-32.28763497D0,
     *-32.53122151D0,93.74409310D0,84.25677504D0,-29.23010465D0,
     *-43.79485175D0,-6.434679514D0,-6.620247951D0,2.443524317D0,
     *2.266538956D0,-43.82903825D0,6.904117876D0,12.24289401D0,
     *17.62014361D0,152.3078796D0,124.5505289D0,-44.58690290D0,
     *-63.02382410D0,-8.999368955D0,-9.693774119D0,3.510930306D0,
     *3.770949738D0,-77.96705716D0,22.07730961D0,20.46491655D0,
     *18.67728847D0,9.451290614D0,9.313661792D0,644.7620970D0,
     *418.2515954D0,7.183754387D0,35.62128817D0,19.43180682D0,
     *39.57218411D0,15.69384715D0,7.123215241D0,2.300635346D0,
     *21.90881131D0,-.01775839370D0,.3996346710D0/

        CALL SRC_PRC (IOPR,SC_SY,SC_PR,PHI,PS,X,Y,Z,HXSRC,HYSRC,HZSRC,
     *      HXPRC,HYPRC,HZPRC)

        X_SC=SC_SY-1.D0
        IF (IOPR.EQ.0.OR.IOPR.EQ.1) THEN
          CALL RC_SHIELD (C_SY,PS,X_SC,X,Y,Z,FSX,FSY,FSZ)
        ELSE
           FSX=0.D0
           FSY=0.D0
           FSZ=0.D0
        ENDIF

        X_SC=SC_PR-1.D0
        IF (IOPR.EQ.0.OR.IOPR.EQ.2) THEN
          CALL RC_SHIELD (C_PR,PS,X_SC,X,Y,Z,FPX,FPY,FPZ)
        ELSE
           FPX=0.D0
           FPY=0.D0
           FPZ=0.D0
        ENDIF

        BXSRC=HXSRC+FSX
        BYSRC=HYSRC+FSY
        BZSRC=HZSRC+FSZ

        BXPRC=HXPRC+FPX
        BYPRC=HYPRC+FPY
        BZPRC=HZPRC+FPZ

        RETURN
        END
C---------------------------------------------------------------------------------------
C
       SUBROUTINE SRC_PRC (IOPR,SC_SY,SC_PR,PHI,PS,X,Y,Z,BXSRC,BYSRC,
     *    BZSRC,BXPRC,BYPRC,BZPRC)
C
C   RETURNS FIELD COMPONENTS FROM A MODEL RING CURRENT, INCLUDING ITS SYMMETRIC PART
C     AND A PARTIAL RING CURRENT, CLOSED VIA BIRKELAND CURRENTS. BASED ON RESULTS, DESCRIBED
C     IN A PAPER "MODELING THE INNER MAGNETOSPHERE: ASYMMETRIC RING CURRENT AND REGION 2
C     BIRKELAND CURRENTS REVISITED" (JGR, DEC.2000).
C
C     IOPR -  A RING CURRENT CALCULATION FLAG (FOR LEAST-SQUARES FITTING ONLY):
C             IOPR=0 - BOTH SRC AND PRC FIELDS ARE CALCULATED
C             IOPR=1 - SRC ONLY
C             IOPR=2 - PRC ONLY
C
C     SC_SY &  SC_PR ARE SCALE FACTORS FOR THE ABOVE COMPONENTS;  TAKING SC<1 OR SC>1 MAKES THE CURRENTS
C                      SHRINK OR EXPAND, RESPECTIVELY.
C
C   PHI IS THE ROTATION ANGLE (RADIANS) OF THE PARTIAL RING CURRENT (MEASURED FROM MIDNIGHT TOWARD DUSK)
C
        IMPLICIT REAL*8 (A-H,O-Z)
c
c   1.  TRANSFORM TO TILTED COORDINATES (i.e., SM coordinates):
C
        CPS=DCOS(PS)
        SPS=DSIN(PS)

        XT=X*CPS-Z*SPS
        ZT=Z*CPS+X*SPS
C
C   2.  SCALE THE COORDINATES FOR THE SYMMETRIC AND PARTIAL RC COMPONENTS:
C
        XTS=XT/SC_SY    !  SYMMETRIC
        YTS=Y /SC_SY
        ZTS=ZT/SC_SY

        XTA=XT/SC_PR    !  PARTIAL
        YTA=Y /SC_PR
        ZTA=ZT/SC_PR
C
C   3.  CALCULATE COMPONENTS OF THE TOTAL FIELD IN THE TILTED (SOLAR-MAGNETIC) COORDINATE SYSTEM:
C
C==========   ONLY FOR LEAST SQUARES FITTING:
        BXS=0.D0
        BYS=0.D0
        BZS=0.D0
        BXA_S=0.D0
        BYA_S=0.D0
        BZA_S=0.D0
        BXA_QR=0.D0
        BYA_QR=0.D0
        BZA_Q=0.D0
C============================================
C
C    3a. SYMMETRIC FIELD:
C
        IF (IOPR.LE.1) CALL RC_SYMM(XTS,YTS,ZTS,BXS,BYS,BZS)
        IF (IOPR.EQ.0.OR.IOPR.EQ.2)
     *                 CALL PRC_SYMM(XTA,YTA,ZTA,BXA_S,BYA_S,BZA_S)

C    3b. ROTATE THE SCALED SM COORDINATES BY PHI AROUND ZSM AXIS AND CALCULATE QUADRUPOLE PRC FIELD
C         IN THOSE COORDS:

        CP=DCOS(PHI)
        SP=DSIN(PHI)
        XR=XTA*CP-YTA*SP
        YR=XTA*SP+YTA*CP

        IF (IOPR.EQ.0.OR.IOPR.EQ.2)
     *                 CALL PRC_QUAD(XR,YR,ZTA,BXA_QR,BYA_QR,BZA_Q)

C    3c. TRANSFORM THE QUADRUPOLE FIELD COMPONENTS BACK TO THE SM COORDS:
C
        BXA_Q= BXA_QR*CP+BYA_QR*SP
        BYA_Q=-BXA_QR*SP+BYA_QR*CP

C    3d. FIND THE TOTAL FIELD OF PRC (SYMM.+QUADR.) IN THE SM COORDS:
C
        BXP=BXA_S+BXA_Q
        BYP=BYA_S+BYA_Q
        BZP=BZA_S+BZA_Q
C
C   4.  TRANSFORM THE FIELDS OF BOTH PARTS OF THE RING CURRENT BACK TO THE GSM SYSTEM:
C
        BXSRC=BXS*CPS+BZS*SPS   !    SYMMETRIC RC
        BYSRC=BYS
        BZSRC=BZS*CPS-BXS*SPS
C
        BXPRC=BXP*CPS+BZP*SPS   !    PARTIAL RC
        BYPRC=BYP
        BZPRC=BZP*CPS-BXP*SPS
C
        RETURN
        END
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
      SUBROUTINE RC_SYMM (X,Y,Z,BX,BY,BZ)
      IMPLICIT  REAL * 8  (A - H, O - Z)
      DATA DS,DC/1.D-2,0.99994999875D0/, D/1.D-4/,DRD/5.D3/  ! DS=SIN(THETA) AT THE BOUNDARY OF THE LINEARITY
                                                             !           REGION; DC=SQRT(1-DS**2);  DRD=1/(2*D)
      RHO2=X**2+Y**2
      R2=RHO2+Z**2
      R=DSQRT(R2)
      RP=R+D
      RM=R-D
      SINT=DSQRT(RHO2)/R
      COST=Z/R

      IF (SINT.LT.DS) THEN  !  TOO CLOSE TO THE Z-AXIS; USING A LINEAR APPROXIMATION A_PHI~SINT,
C                                    TO AVOID THE SINGULARITY PROBLEM
        A=AP(R,DS,DC)/DS
        DARDR=(RP*AP(RP,DS,DC)-RM*AP(RM,DS,DC))*DRD
        FXY=Z*(2.D0*A-DARDR)/(R*R2)
        BX=FXY*X
        BY=FXY*Y
        BZ=(2.D0*A*COST**2+DARDR*SINT**2)/R

       ELSE

        THETA=DATAN2(SINT,COST)
        TP=THETA+D
        TM=THETA-D
        SINTP=DSIN(TP)
        SINTM=DSIN(TM)
        COSTP=DCOS(TP)
        COSTM=DCOS(TM)
        BR=(SINTP*AP(R,SINTP,COSTP)-SINTM*AP(R,SINTM,COSTM))
     *       /(R*SINT)*DRD
        BT=(RM*AP(RM,SINT,COST)-RP*AP(RP,SINT,COST))/R*DRD
        FXY=(BR+BT*COST/SINT)/R
        BX=FXY*X
        BY=FXY*Y
        BZ=BR*COST-BT*SINT

      ENDIF

      RETURN
      END
c
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
      DOUBLE PRECISION FUNCTION AP(R,SINT,COST)
C
C      Calculates azimuthal component of the vector potential of the symmetric
c  part of the model ring current.
C
      IMPLICIT  REAL * 8  (A - H, O - Z)
      LOGICAL PROX   !  INDICATES WHETHER WE ARE TOO CLOSE TO THE AXIS OF SYMMETRY, WHERE THE INVERSION
C                                                             OF DIPOLAR COORDINATES BECOMES INACCURATE
      DATA A1,A2,RRC1,DD1,RRC2,DD2,P1,R1,DR1,DLA1,P2,R2,DR2,DLA2,P3,
     *R3,DR3/
     *-456.5289941,375.9055332,4.274684950,2.439528329,3.367557287,          !    CORRECTED VALUES
     *3.146382545,-0.2291904607,3.746064740,1.508802177,0.5873525737,        !   (UPDATED 04/20/06 (SEE NB#9, P.37))
     *0.1556236119,4.993638842,3.324180497,0.4368407663,0.1855957207,
     *2.969226745,2.243367377/

      PROX=.FALSE.
      SINT1=SINT
      COST1=COST
      IF (SINT1.LT.1.D-2) THEN  !  TOO CLOSE TO Z-AXIS;  USE LINEAR INTERPOLATION BETWEEN SINT=0 & SINT=0.01
        SINT1=1.D-2
        COST1=.99994999875D0
        PROX=.TRUE.
      ENDIF

         ALPHA=SINT1**2/R         !  R,THETA -> ALPHA,GAMMA
         GAMMA=COST1/R**2

         ARG1=-((R-R1)/DR1)**2-(COST1/DLA1)**2
         ARG2=-((R-R2)/DR2)**2-(COST1/DLA2)**2
         ARG3=-((R-R3)/DR3)**2

         IF (ARG1.LT.-500.D0) THEN        !   TO PREVENT "FLOATING UNDERFLOW" CRASHES
           DEXP1=0.D0
         ELSE
           DEXP1=DEXP(ARG1)
         ENDIF

         IF (ARG2.LT.-500.D0) THEN
           DEXP2=0.D0
         ELSE
           DEXP2=DEXP(ARG2)
         ENDIF

         IF (ARG3.LT.-500.D0) THEN
           DEXP3=0.D0
         ELSE
           DEXP3=DEXP(ARG3)
         ENDIF


         ALPHA_S=ALPHA*(1.D0+P1*DEXP1+P2*DEXP2+P3*DEXP3)     !  ALPHA -> ALPHA_S  (DEFORMED)

         GAMMA_S=GAMMA
         GAMMAS2=GAMMA_S**2


         ALSQH=ALPHA_S**2/2.D0            !  ALPHA_S,GAMMA_S -> RS,SINTS,COSTS
         F=64.D0/27.D0*GAMMAS2+ALSQH**2
         Q=(DSQRT(F)+ALSQH)**(1.D0/3.D0)
         C=Q-4.D0*GAMMAS2**(1.D0/3.D0)/(3.D0*Q)
         IF (C.LT.0.D0) C=0.D0
         G=DSQRT(C**2+4.D0*GAMMAS2**(1.D0/3.D0))
         RS=4.D0/((DSQRT(2.D0*G-C)+DSQRT(C))*(G+C))
         COSTS=GAMMA_S*RS**2
         SINTS=DSQRT(1.D0-COSTS**2)
         RHOS=RS*SINTS
         RHOS2=RHOS**2
         ZS=RS*COSTS
C
c  1st loop:

         P=(RRC1+RHOS)**2+ZS**2+DD1**2
         XK2=4.D0*RRC1*RHOS/P
         XK=SQRT(XK2)
         XKRHO12=XK*SQRT(RHOS)     !   SEE NB#4, P.3
C
      XK2S=1.D0-XK2
      DL=DLOG(1.D0/XK2S)
      ELK=1.38629436112d0+XK2S*(0.09666344259D0+XK2S*(0.03590092383D0+
     *     XK2S*(0.03742563713D0+XK2S*0.01451196212D0))) +DL*
     *     (0.5D0+XK2S*(0.12498593597D0+XK2S*(0.06880248576D0+
     *     XK2S*(0.03328355346D0+XK2S*0.00441787012D0))))
      ELE=1.D0+XK2S*(0.44325141463D0+XK2S*(0.0626060122D0+XK2S*
     *      (0.04757383546D0+XK2S*0.01736506451D0))) +DL*
     *     XK2S*(0.2499836831D0+XK2S*(0.09200180037D0+XK2S*
     *       (0.04069697526D0+XK2S*0.00526449639D0)))
C
      APHI1=((1.D0-XK2*0.5D0)*ELK-ELE)/XKRHO12
c
c  2nd loop:

         P=(RRC2+RHOS)**2+ZS**2+DD2**2
         XK2=4.D0*RRC2*RHOS/P
         XK=SQRT(XK2)
         XKRHO12=XK*SQRT(RHOS)     !   SEE NB#4, P.3
C
      XK2S=1.D0-XK2
      DL=DLOG(1.D0/XK2S)
      ELK=1.38629436112d0+XK2S*(0.09666344259D0+XK2S*(0.03590092383D0+
     *     XK2S*(0.03742563713D0+XK2S*0.01451196212D0))) +DL*
     *     (0.5D0+XK2S*(0.12498593597D0+XK2S*(0.06880248576D0+
     *     XK2S*(0.03328355346D0+XK2S*0.00441787012D0))))
      ELE=1.D0+XK2S*(0.44325141463D0+XK2S*(0.0626060122D0+XK2S*
     *      (0.04757383546D0+XK2S*0.01736506451D0))) +DL*
     *     XK2S*(0.2499836831D0+XK2S*(0.09200180037D0+XK2S*
     *       (0.04069697526D0+XK2S*0.00526449639D0)))
C
       APHI2=((1.D0-XK2*0.5D0)*ELK-ELE)/XKRHO12

       AP=A1*APHI1+A2*APHI2
       IF (PROX) AP=AP*SINT/SINT1   !   LINEAR INTERPOLATION, IF TOO CLOSE TO THE Z-AXIS
C
       RETURN
       END
c
c@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C
      SUBROUTINE PRC_SYMM (X,Y,Z,BX,BY,BZ)
      IMPLICIT  REAL * 8  (A - H, O - Z)
      DATA DS,DC/1.D-2,0.99994999875D0/, D/1.D-4/,DRD/5.D3/  ! DS=SIN(THETA) AT THE BOUNDARY OF THE LINEARITY
                                                             !           REGION; DC=SQRT(1-DS**2);  DRD=1/(2*D)
      RHO2=X**2+Y**2
      R2=RHO2+Z**2
      R=DSQRT(R2)
      RP=R+D
      RM=R-D
      SINT=DSQRT(RHO2)/R
      COST=Z/R

      IF (SINT.LT.DS) THEN  !  TOO CLOSE TO THE Z-AXIS; USING A LINEAR APPROXIMATION A_PHI~SINT,
C                                    TO AVOID THE SINGULARITY PROBLEM
        A=APPRC(R,DS,DC)/DS
        DARDR=(RP*APPRC(RP,DS,DC)-RM*APPRC(RM,DS,DC))*DRD
        FXY=Z*(2.D0*A-DARDR)/(R*R2)
        BX=FXY*X
        BY=FXY*Y
        BZ=(2.D0*A*COST**2+DARDR*SINT**2)/R

       ELSE

        THETA=DATAN2(SINT,COST)
        TP=THETA+D
        TM=THETA-D
        SINTP=DSIN(TP)
        SINTM=DSIN(TM)
        COSTP=DCOS(TP)
        COSTM=DCOS(TM)
        BR=(SINTP*APPRC(R,SINTP,COSTP)-SINTM*APPRC(R,SINTM,COSTM))
     *       /(R*SINT)*DRD
        BT=(RM*APPRC(RM,SINT,COST)-RP*APPRC(RP,SINT,COST))/R*DRD
        FXY=(BR+BT*COST/SINT)/R
        BX=FXY*X
        BY=FXY*Y
        BZ=BR*COST-BT*SINT

      ENDIF

      RETURN
      END
c
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
C
      DOUBLE PRECISION FUNCTION APPRC(R,SINT,COST)
C
C      Calculates azimuthal component of the vector potential of the symmetric
c  part of the model PARTIAL ring current.
C
      IMPLICIT  REAL * 8  (A - H, O - Z)
      LOGICAL PROX
      DATA A1,A2,RRC1,DD1,RRC2,DD2,P1,ALPHA1,DAL1,BETA1,DG1,P2,ALPHA2,
     * DAL2,BETA2,DG2,BETA3,P3,ALPHA3,DAL3,BETA4,DG3,BETA5,Q0,Q1,ALPHA4,
     * DAL4,DG4,Q2,ALPHA5,DAL5,DG5,BETA6,BETA7
     * /-80.11202281D0,12.58246758D0,6.560486035D0,1.930711037D0,
     *3.827208119D0,.7789990504D0,.3058309043D0,.1817139853D0,
     *.1257532909D0,3.422509402D0,.04742939676D0,-4.800458958D0,
     *-.02845643596D0,.2188114228D0,2.545944574D0,.00813272793D0,
     *.35868244D0,103.1601001D0,-.00764731187D0,.1046487459D0,
     *2.958863546D0,.01172314188D0,.4382872938D0,.01134908150D0,
     *14.51339943D0,.2647095287D0,.07091230197D0,.01512963586D0,
     *6.861329631D0,.1677400816D0,.04433648846D0,.05553741389D0,
     *.7665599464D0,.7277854652D0/

      PROX=.FALSE.
      SINT1=SINT
      COST1=COST
      IF (SINT1.LT.1.D-2) THEN  !  TOO CLOSE TO Z-AXIS;  USE LINEAR INTERPOLATION BETWEEN SINT=0 & SINT=0.01
        SINT1=1.D-2
        COST1=.99994999875D0
        PROX=.TRUE.
      ENDIF

         ALPHA=SINT1**2/R         !  R,THETA -> ALPHA,GAMMA
         GAMMA=COST1/R**2

         ALPHA_S=ALPHA*(1.D0+P1/(1.D0+((ALPHA-ALPHA1)/DAL1)**2)**BETA1
     * *DEXP(-(GAMMA/DG1)**2)
     *+P2*(ALPHA-ALPHA2)/(1.D0+((ALPHA-ALPHA2)/DAL2)**2)**BETA2
     */(1.D0+(GAMMA/DG2)**2)**BETA3
     *+P3*(ALPHA-ALPHA3)**2/(1.D0+((ALPHA-ALPHA3)/DAL3)**2)**BETA4
     */(1.D0+(GAMMA/DG3)**2)**BETA5)     !  ALPHA -> ALPHA_S  (DEFORMED)

         GAMMA_S=GAMMA*(1.D0+Q0+Q1*(ALPHA-ALPHA4)
     * *DEXP(-((ALPHA-ALPHA4)/DAL4)**2-(GAMMA/DG4)**2)   !  GAMMA -> GAMMA_  (DEFORMED)
     * +Q2*(ALPHA-ALPHA5)/(1.D0+((ALPHA-ALPHA5)/DAL5)**2)**BETA6
     * /(1.D0+(GAMMA/DG5)**2)**BETA7)

         GAMMAS2=GAMMA_S**2

         ALSQH=ALPHA_S**2/2.D0                            !  ALPHA_S,GAMMA_S -> RS,SINTS,COSTS
         F=64.D0/27.D0*GAMMAS2+ALSQH**2
         Q=(DSQRT(F)+ALSQH)**(1.D0/3.D0)
         C=Q-4.D0*GAMMAS2**(1.D0/3.D0)/(3.D0*Q)
         IF (C.LT.0.D0) C=0.D0
         G=DSQRT(C**2+4.D0*GAMMAS2**(1.D0/3.D0))
         RS=4.D0/((DSQRT(2.D0*G-C)+DSQRT(C))*(G+C))
         COSTS=GAMMA_S*RS**2
         SINTS=DSQRT(1.D0-COSTS**2)
         RHOS=RS*SINTS
         RHOS2=RHOS**2
         ZS=RS*COSTS
C
c  1st loop:

         P=(RRC1+RHOS)**2+ZS**2+DD1**2
         XK2=4.D0*RRC1*RHOS/P
         XK=SQRT(XK2)
         XKRHO12=XK*SQRT(RHOS)     !    NB#4, P.3
C
      XK2S=1.D0-XK2
      DL=DLOG(1.D0/XK2S)
      ELK=1.38629436112d0+XK2S*(0.09666344259D0+XK2S*(0.03590092383D0+
     *     XK2S*(0.03742563713D0+XK2S*0.01451196212D0))) +DL*
     *     (0.5D0+XK2S*(0.12498593597D0+XK2S*(0.06880248576D0+
     *     XK2S*(0.03328355346D0+XK2S*0.00441787012D0))))
      ELE=1.D0+XK2S*(0.44325141463D0+XK2S*(0.0626060122D0+XK2S*
     *      (0.04757383546D0+XK2S*0.01736506451D0))) +DL*
     *     XK2S*(0.2499836831D0+XK2S*(0.09200180037D0+XK2S*
     *       (0.04069697526D0+XK2S*0.00526449639D0)))
C
      APHI1=((1.D0-XK2*0.5D0)*ELK-ELE)/XKRHO12
c
c  2nd loop:

         P=(RRC2+RHOS)**2+ZS**2+DD2**2
         XK2=4.D0*RRC2*RHOS/P
         XK=SQRT(XK2)
         XKRHO12=XK*SQRT(RHOS)     !    NB#4, P.3
C
      XK2S=1.D0-XK2
      DL=DLOG(1.D0/XK2S)
      ELK=1.38629436112d0+XK2S*(0.09666344259D0+XK2S*(0.03590092383D0+
     *     XK2S*(0.03742563713D0+XK2S*0.01451196212D0))) +DL*
     *     (0.5D0+XK2S*(0.12498593597D0+XK2S*(0.06880248576D0+
     *     XK2S*(0.03328355346D0+XK2S*0.00441787012D0))))
      ELE=1.D0+XK2S*(0.44325141463D0+XK2S*(0.0626060122D0+XK2S*
     *      (0.04757383546D0+XK2S*0.01736506451D0))) +DL*
     *     XK2S*(0.2499836831D0+XK2S*(0.09200180037D0+XK2S*
     *       (0.04069697526D0+XK2S*0.00526449639D0)))
C
      APHI2=((1.D0-XK2*0.5D0)*ELK-ELE)/XKRHO12

      APPRC=A1*APHI1+A2*APHI2
      IF (PROX) APPRC=APPRC*SINT/SINT1   !   LINEAR INTERPOLATION, IF TOO CLOSE TO THE Z-AXIS
C
      RETURN
      END
C
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C
C
         SUBROUTINE PRC_QUAD (X,Y,Z,BX,BY,BZ)
C
C  CALCULATES COMPONENTS OF THE FIELD FROM THE "QUADRUPOLE" COMPONENT OF THE PRC
C
         IMPLICIT  REAL * 8  (A - H, O - Z)

         DATA D,DD/1.D-4,2.D-4/, DS/1.D-2/,DC/0.99994999875D0/

         RHO2=X**2+Y**2
         R=DSQRT(RHO2+Z**2)
         RHO=DSQRT(RHO2)
         SINT=RHO/R
         COST=Z/R
         RP=R+D
         RM=R-D

         IF (SINT.GT.DS) THEN
           CPHI=X/RHO
           SPHI=Y/RHO
           BR=BR_PRC_Q(R,SINT,COST)
           BT=BT_PRC_Q(R,SINT,COST)
           DBRR=(BR_PRC_Q(RP,SINT,COST)-BR_PRC_Q(RM,SINT,COST))/DD
           THETA=DATAN2(SINT,COST)
           TP=THETA+D
           TM=THETA-D
           SINTP=DSIN(TP)
           COSTP=DCOS(TP)
           SINTM=DSIN(TM)
           COSTM=DCOS(TM)
           DBTT=(BT_PRC_Q(R,SINTP,COSTP)-BT_PRC_Q(R,SINTM,COSTM))/DD
           BX=SINT*(BR+(BR+R*DBRR+DBTT)*SPHI**2)+COST*BT
           BY=-SINT*SPHI*CPHI*(BR+R*DBRR+DBTT)
           BZ=(BR*COST-BT*SINT)*CPHI
         ELSE
           ST=DS
           CT=DC
           IF (Z.LT.0.D0) CT=-DC
           THETA=DATAN2(ST,CT)
           TP=THETA+D
           TM=THETA-D
           SINTP=DSIN(TP)
           COSTP=DCOS(TP)
           SINTM=DSIN(TM)
           COSTM=DCOS(TM)
           BR=BR_PRC_Q(R,ST,CT)
           BT=BT_PRC_Q(R,ST,CT)
           DBRR=(BR_PRC_Q(RP,ST,CT)-BR_PRC_Q(RM,ST,CT))/DD
           DBTT=(BT_PRC_Q(R,SINTP,COSTP)-BT_PRC_Q(R,SINTM,COSTM))/DD
           FCXY=R*DBRR+DBTT
           BX=(BR*(X**2+2.D0*Y**2)+FCXY*Y**2)/(R*ST)**2+BT*COST
           BY=-(BR+FCXY)*X*Y/(R*ST)**2
           BZ=(BR*COST/ST-BT)*X/R
         ENDIF

         RETURN
         END
c
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
      DOUBLE PRECISION FUNCTION BR_PRC_Q (R,SINT,COST)
C
Calculates the radial component of the "quadrupole" part of the model partial ring current.
C
      IMPLICIT  REAL * 8  (A - H, O - Z)

      DATA A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,A15,A16,A17,   ! ALL LINEAR PARAMETERS HERE
     * A18,XK1,AL1,DAL1,B1,BE1,XK2,AL2,DAL2,B2,BE2,XK3,XK4,AL3,DAL3,B3,  ! WERE MULTIPLIED BY 0.1,
     * BE3,AL4,DAL4,DG1,AL5,DAL5,DG2,C1,C2,C3,AL6,DAL6,
     *DRM/-21.2666329D0,  ! SO THAT THEY CORRESPOND TO P_0=1 nPa,
     *32.24527521D0,-6.062894078D0,7.515660734D0,233.7341288D0,
     *-227.1195714D0,     ! RATHER THAN THE ORIGINAL VALUE OF 10 nPa
     *8.483233889D0,16.80642754D0,-24.63534184D0,9.067120578D0,
     *-1.052686913D0,     ! ASSUMED IN THE BIOT-SAVART INTEGRAL
     *-12.08384538D0,18.61969572D0,-12.71686069D0,47017.35679D0,
     *-50646.71204D0,7746.058231D0,1.531069371D0,2.318824273D0,
     *.1417519429D0,.6388013110D-02,5.303934488D0,4.213397467D0,
     *.7955534018D0,.1401142771D0,.2306094179D-01,3.462235072D0,
     *2.568743010D0,3.477425908D0,1.922155110D0,.1485233485D0,
     *.2319676273D-01,7.830223587D0,8.492933868D0,.1295221828D0,
     *.01753008801D0,.01125504083D0,.1811846095D0,.04841237481D0,
     *.01981805097D0,6.557801891D0,6.348576071D0,5.744436687D0,
     *.2265212965D0,.1301957209D0,.5654023158D0/

        SINT2=SINT**2
        COST2=COST**2
        SC=SINT*COST
        ALPHA=SINT2/R
        GAMMA=COST/R**2

        CALL FFS(ALPHA,AL1,DAL1,F,FA,FS)
        D1=SC*F**XK1/((R/B1)**BE1+1.D0)
        D2=D1*COST2

        CALL FFS(ALPHA,AL2,DAL2,F,FA,FS)
        D3=SC*FS**XK2/((R/B2)**BE2+1.D0)
        D4=D3*COST2

        CALL FFS(ALPHA,AL3,DAL3,F,FA,FS)
        D5=SC*(ALPHA**XK3)*(FS**XK4)/((R/B3)**BE3+1.D0)
        D6=D5*COST2

        ARGA=((ALPHA-AL4)/DAL4)**2+1.D0
        ARGG=1.D0+(GAMMA/DG1)**2

        D7=SC/ARGA/ARGG
        D8=D7/ARGA
        D9=D8/ARGA
        D10=D9/ARGA

        ARGA=((ALPHA-AL5)/DAL5)**2+1.D0
        ARGG=1.D0+(GAMMA/DG2)**2

        D11=SC/ARGA/ARGG
        D12=D11/ARGA
        D13=D12/ARGA
        D14=D13/ARGA


        D15=SC/(R**4+C1**4)
        D16=SC/(R**4+C2**4)*COST2
        D17=SC/(R**4+C3**4)*COST2**2

        CALL FFS(ALPHA,AL6,DAL6,F,FA,FS)
        D18=SC*FS/(1.D0+((R-1.2D0)/DRM)**2)

        BR_PRC_Q=A1*D1+A2*D2+A3*D3+A4*D4+A5*D5+A6*D6+A7*D7+A8*D8+A9*D9+
     *  A10*D10+A11*D11+A12*D12+A13*D13+A14*D14+A15*D15+A16*D16+A17*D17+
     *   A18*D18
C
        RETURN
        END
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
        DOUBLE PRECISION FUNCTION BT_PRC_Q (R,SINT,COST)
C
Calculates the Theta component of the "quadrupole" part of the model partial ring current.
C
        IMPLICIT  REAL * 8  (A - H, O - Z)

      DATA A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,A15,A16,A17,  ! ALL LINEAR PARAMETERS HERE
     *XK1,AL1,DAL1,B1,BE1,XK2,AL2,DAL2,BE2,XK3,XK4,AL3,DAL3,B3,BE3,AL4, ! WERE MULTIPLIED BY 0.1,
     *DAL4,DG1,AL5,DAL5,DG2,C1,C2,C3/12.74640393D0,-7.516393516D0,          ! SO THAT THEY CORRESPOND TO P_0=1 nPa,
     *-5.476233865D0,3.212704645D0,-59.10926169D0,46.62198189D0,
     *-.01644280062D0,  ! RATHER THAN THE ORIGINAL VALUE OF 10 nPa
     *.1234229112D0,-.08579198697D0,.01321366966D0,.8970494003D0,
     *9.136186247D0,   ! ASSUMED IN THE BIOT-SAVART INTEGRAL
     *-38.19301215D0,21.73775846D0,-410.0783424D0,-69.90832690D0,
     *-848.8543440D0,1.243288286D0,.2071721360D0,.05030555417D0,
     *7.471332374D0,3.180533613D0,1.376743507D0,.1568504222D0,
     *.02092910682D0,1.985148197D0,.3157139940D0,1.056309517D0,
     *.1701395257D0,.1019870070D0,6.293740981D0,5.671824276D0,
     *.1280772299D0,.02189060799D0,.01040696080D0,.1648265607D0,
     *.04701592613D0,.01526400086D0,12.88384229D0,3.361775101D0,
     *23.44173897D0/

        SINT2=SINT**2
        COST2=COST**2
        SC=SINT*COST
        ALPHA=SINT2/R
        GAMMA=COST/R**2

        CALL FFS(ALPHA,AL1,DAL1,F,FA,FS)
        D1=F**XK1/((R/B1)**BE1+1.D0)
        D2=D1*COST2

        CALL FFS(ALPHA,AL2,DAL2,F,FA,FS)
        D3=FA**XK2/R**BE2
        D4=D3*COST2

        CALL FFS(ALPHA,AL3,DAL3,F,FA,FS)
        D5=FS**XK3*ALPHA**XK4/((R/B3)**BE3+1.D0)
        D6=D5*COST2

        CALL FFS(GAMMA,0.D0,DG1,F,FA,FS)
        FCC=(1.D0+((ALPHA-AL4)/DAL4)**2)
        D7 =1.D0/FCC*FS
        D8 =D7/FCC
        D9 =D8/FCC
        D10=D9/FCC

        ARG=1.D0+((ALPHA-AL5)/DAL5)**2
        D11=1.D0/ARG/(1.D0+(GAMMA/DG2)**2)
        D12=D11/ARG
        D13=D12/ARG
        D14=D13/ARG

        D15=1.D0/(R**4+C1**2)
        D16=COST2/(R**4+C2**2)
        D17=COST2**2/(R**4+C3**2)
C
        BT_PRC_Q=A1*D1+A2*D2+A3*D3+A4*D4+A5*D5+A6*D6+A7*D7+A8*D8+A9*D9+
     *   A10*D10+A11*D11+A12*D12+A13*D13+A14*D14+A15*D15+A16*D16+A17*D17
C
       RETURN
       END
c
c@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

       SUBROUTINE FFS(A,A0,DA,F,FA,FS)
       IMPLICIT  REAL * 8  (A - H, O - Z)
       SQ1=DSQRT((A+A0)**2+DA**2)
       SQ2=DSQRT((A-A0)**2+DA**2)
       FA=2.D0/(SQ1+SQ2)
       F=FA*A
       FS=0.5D0*(SQ1+SQ2)/(SQ1*SQ2)*(1.D0-F*F)
       RETURN
       END
C
C||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
C
C
         SUBROUTINE RC_SHIELD (A,PS,X_SC,X,Y,Z,BX,BY,BZ)
C
C   COMPUTES THE COMPONENTS OF THE SHIELDING FIELD FOR THE RING CURRENT
C       (EITHER PARTIAL OR AXISYMMETRICAL)
C   INPUT:   A - AN ARRAY CONTAINING THE HARMONIC COEFFICIENTS AND NONLINEAR PARAMETERS
C            PS - GEOdipole_01 TILT ANGLE IN RADIANS
C            X_SC - SCALING FACTOR ( X_SC> 1 AND X_SC< 1 CORRESPOND TO LARGER/SMALLER
C                  RING CURRENT, RESP.)
C            X,Y,Z - POSITION IN RE (GSM COORDS)
C   OUTPUT:  BX,BY,BZ - SHIELDING FIELD COMPONENTS (GSM)
C
	 IMPLICIT  REAL * 8  (A - H, O - Z)
         DIMENSION A(86)
C
         FAC_SC=(X_SC+1.D0)**3
C
         CPS=DCOS(PS)
         SPS=DSIN(PS)

         S3PS=2.D0*CPS
C
         PST1=PS*A(85)
         PST2=PS*A(86)

         ST1=DSIN(PST1)
         CT1=DCOS(PST1)
         ST2=DSIN(PST2)
         CT2=DCOS(PST2)

         X1=X*CT1-Z*ST1
         Z1=X*ST1+Z*CT1
         X2=X*CT2-Z*ST2
         Z2=X*ST2+Z*CT2
C
         L=0
         GX=0.D0
         GY=0.D0
         GZ=0.D0
C
         DO 1 M=1,2     !    M=1 IS FOR THE 1ST SUM ("PERP." SYMMETRY)
C                           AND M=2 IS FOR THE SECOND SUM ("PARALL." SYMMETRY)
             DO 2 I=1,3
                  P=A(72+I)
                  Q=A(78+I)
                  CYPI=DCOS(Y/P)
                  CYQI=DCOS(Y/Q)
                  SYPI=DSIN(Y/P)
                  SYQI=DSIN(Y/Q)
C
                DO 3 K=1,3
                   R=A(75+K)
                   S=A(81+K)
                   SZRK=DSIN(Z1/R)
                   CZSK=DCOS(Z2/S)
                   CZRK=DCOS(Z1/R)
                   SZSK=DSIN(Z2/S)
                     SQPR=DSQRT(1.D0/P**2+1.D0/R**2)
                     SQQS=DSQRT(1.D0/Q**2+1.D0/S**2)
                        EPR=DEXP(X1*SQPR)
                        EQS=DEXP(X2*SQQS)
C
                  DO 4 N=1,2  ! N=1 IS FOR THE FIRST PART OF EACH COEFFICIENT
C                                AND N=2 IS FOR THE SECOND ONE

                    DO 5 NN=1,2 !   NN = 1,2 FURTHER SPLITS THE COEFFICIENTS INTO 2 PARTS,
C                                         TO TAKE INTO ACCOUNT THE SCALE FACTOR DEPENDENCE

                    IF (M.EQ.1) THEN
                         FX=-SQPR*EPR*CYPI*SZRK  *FAC_SC
                         FY=EPR*SYPI*SZRK/P   *FAC_SC
                         FZ=-EPR*CYPI*CZRK/R  *FAC_SC
                       IF (N.EQ.1) THEN
                         IF (NN.EQ.1) THEN
                          HX=FX
                          HY=FY
                          HZ=FZ
                         ELSE
                          HX=FX*X_SC
                          HY=FY*X_SC
                          HZ=FZ*X_SC
                         ENDIF
                       ELSE
                         IF (NN.EQ.1) THEN
                          HX=FX*CPS
                          HY=FY*CPS
                          HZ=FZ*CPS
                         ELSE
                          HX=FX*CPS*X_SC
                          HY=FY*CPS*X_SC
                          HZ=FZ*CPS*X_SC
                         ENDIF
                       ENDIF

                     ELSE                            !   M.EQ.2
                         FX=-SPS*SQQS*EQS*CYQI*CZSK  *FAC_SC
                         FY=SPS/Q*EQS*SYQI*CZSK   *FAC_SC
                         FZ=SPS/S*EQS*CYQI*SZSK   *FAC_SC
                       IF (N.EQ.1) THEN
                        IF (NN.EQ.1) THEN
                          HX=FX
                          HY=FY
                          HZ=FZ
                        ELSE
                          HX=FX*X_SC
                          HY=FY*X_SC
                          HZ=FZ*X_SC
                        ENDIF
                       ELSE
                        IF (NN.EQ.1) THEN
                         HX=FX*S3PS
                         HY=FY*S3PS
                         HZ=FZ*S3PS
                        ELSE
                         HX=FX*S3PS*X_SC
                         HY=FY*S3PS*X_SC
                         HZ=FZ*S3PS*X_SC
                        ENDIF
                       ENDIF
                  ENDIF
       L=L+1

       IF (M.EQ.1) THEN
       HXR=HX*CT1+HZ*ST1
       HZR=-HX*ST1+HZ*CT1
       ELSE
       HXR=HX*CT2+HZ*ST2
       HZR=-HX*ST2+HZ*CT2
       ENDIF

       GX=GX+HXR*A(L)
       GY=GY+HY *A(L)
  5    GZ=GZ+HZR*A(L)

  4   CONTINUE
  3   CONTINUE
  2   CONTINUE
  1   CONTINUE

      BX=GX
      BY=GY
      BZ=GZ

      RETURN
      END
C
c===========================================================================
c
      SUBROUTINE dipole_01 (PS,X,Y,Z,BX,BY,BZ)
C
C     THIS IS A DOUBLE PRECISION ROUTINE, OTHERWISE IDENTICAL TO THE S/R DIP OF GEOPACK
C
C     CALCULATES GSM COMPONENTS OF A GEOdipole_01 FIELD WITH THE dipole_01 MOMENT
C     CORRESPONDING TO THE EPOCH OF 2000.
C
C------INPUT PARAMETERS:
C       PS - GEOdipole_01 TILT ANGLE IN RADIANS,
C       X,Y,Z - GSM COORDINATES IN RE (1 RE = 6371.2 km)
C
C----OUTPUT PARAMETERS:
C     BX,BY,BZ - FIELD COMPONENTS IN GSM SYSTEM, IN NANOTESLA.
C
C    LAST MODIFICATION: JAN. 5, 2001. THE VALUE OF THE dipole_01 MOMENT WAS UPDATED TO 2000.
C      AND A "SAVE" STATEMENT HAS BEEN ADDED, TO AVOID POTENTIAL PROBLEMS WITH SOME
C      FORTRAN COMPILERS
C
C    WRITTEN BY: N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      SAVE M,PSI,SPS,CPS
      DATA M,PSI/0,5.D0/
      IF(M.EQ.1.AND.DABS(PS-PSI).LT.1.D-5) GOTO 1   !   THIS IS TO AVOID MULTIPLE CALCULATIONS
      SPS=DSIN(PS)                                  !   OF SIN(PS) AND COS(PS), IF THE ANGLE PS
      CPS=DCOS(PS)                                  !   REMAINS UNCHANGED
      PSI=PS
      M=1
  1   P=X**2
      U=Z**2
      V=3.D0*Z*X
      T=Y**2
      Q=30115.D0/DSQRT(P+T+U)**5
      BX=Q*((T+U-2.D0*P)*SPS-V*CPS)
      BY=-3.D0*Y*Q*(X*SPS+Z*CPS)
      BZ=Q*((P+T-2.D0*U)*CPS-V*SPS)
      RETURN
      END



c@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!      PROGRAM SD2
C
C     SHIELDOSE-2, VERSION 2.10, 28 APR 94.
C
C        S.M. SELTZER
C        NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY
C        GAITHERSBURG, MD 20899
C        (301) 975-5552
C
C        IDET = 1, AL DETECTOR
C               2, GRAPHITE DETECTOR
C               3, SI DETECTOR
C               4, AIR DETECTOR
C               5, BONE DETECTOR
C               6, CALCIUM FLUORIDE DETECTOR
C               7, GALLIUM ARSENIDE DETECTOR
C               8, LITHIUM FLUORIDE DETECTOR
C               9, SILICON DIOXIDE DETECTOR
C              10, TISSUE DETECTOR
C              11, WATER DETECTOR
C
C        INUC = 1, NO NUCLEAR ATTENUATION FOR PROTONS IN AL
C               2, NUCLEAR ATTENUATION, LOCAL CHARGED-SECONDARY ENERGY
C                     DEPOSITION
C               3, NUCLEAR ATTENUATION, LOCAL CHARGED-SECONDARY ENERGY
C                     DEPOSITION, AND APPROX EXPONENTIAL DISTRIBUTION OF
C                     NEUTRON DOSE
C
C        IMAX = Number of shielding depth (max allowed=71)
C
C        IUNT = the shielding depth unit
C               1, Mils
C               2, g/cm2
C               3, mm
C
C        Zin = array(IMAX) of thickness in unit of IUNT
C
C        EMINS,EMAXS= the min and max energy of solar protons spectrum [MeV]
C        EMINP,EMAXP= the min and max energy of trapped protons spectrum [MeV]
C        NPTSP= number of spectrum points which divides proton spectra for integration.
C        EMINE,EMAXE= the min and max energy of trapped electrons spectrum [MeV]
C        NPTSE=number of spectrum points which divides electron spectrum for integration.
C
C        JSMAX= number of points in falling spectrum of solar protons
C        JPMAX= number of points in falling spectrum of trapped protons
C        JEMAX= number of points in falling spectrum of trapped electrons
C
C        EUNIT= CONVERSION FACTOR FROM /ENERGY TO /MEV,
C             E.G., EUNIT = 1000 IF FLUX IS /KEV.
C
C        DURATN= MISSION DURATION IN MULTIPLES OF UNIT TIME (s).
C
C        INCIDENT OMNIDIRECTIONAL FLUX IN /ENERGY/CM2/UNIT TIME
C             (SOLAR-FLARE FLUX IN /ENERGY/CM2).
C        ESin: Energy array(JSMAX) of solar proton spectrum
C        SFLUXin: Flux array(JSMAX) for solar protons( SOLAR-FLARE FLUX IN /ENERGY/CM2)
C
C        EPin: Energy array(JPMAX) of trapped proton spectrum
C        PFLUXin: Flux array(JPMAX) for trapped  protons (INCIDENT OMNIDIRECTIONAL FLUX IN /ENERGY/CM2/UNIT TIME)
C
C        EEin: Energy array(JEMAX) of trapped electron spectrum
C        EFLUXin: Flux array(JEMAX) for trapped  electrons (INCIDENT OMNIDIRECTIONAL FLUX IN /ENERGY/CM2/UNIT TIME)
C
C        OUTPUTS:
C        SolDose: Dose profile array (Imax,3) for solar protons
C        ProtDose: Dose profile array (Imax,3) for trapped protons
C        ElecDose: Dose profile array (Imax,3) for trapped electrons
C        BremDose: Dose profile array (Imax,3) for Brem
C        TotDose: Total dose profile array (Imax,3)
C
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      subroutine shieldose2(IDET,INUC,IMAX,IUNT,Zin,
     * EMINS,EMAXS,EMINP,EMAXP,NPTSP,EMINE,EMAXE,NPTSE,
     * JSMAX,JPMAX,JEMAX,EUNIT,DURATN,
     * ESin,SFLUXin,EPin,PFLUXin,EEin,EFLUXin,
     * SolDose,ProtDose,ElecDose,BremDose,TotDose)

      implicit none

      integer*4 MMAXPI,KMAXPI,NMAXPI,LMAXPI,IMIXI,MMAXEI,NMAXEI,LMAXSI
      integer*4 LMAXEI,LMAXTI,LMAXBI,IMAXI,NPTSI,JMAXI
      PARAMETER  (MMAXPI=133,KMAXPI=30,NMAXPI=49,LMAXPI=51,IMIXI=11,
     1   MMAXEI=81,NMAXEI=14,LMAXSI=33+1,LMAXEI=51,LMAXTI=37,LMAXBI=47,
     2   IMAXI=71,NPTSI=1001,JMAXI=301)
      integer*4 NPTSPI,NPTSEI
      PARAMETER  (NPTSPI=NPTSI,NPTSEI=NPTSI)
      real*8 ZCON,ZMCON
C     PARAMETER  (ZCON=0.001D0*2.540005D0*2.70D0,ZMCON=10.0D0/2.70D0)
      PARAMETER  (ZCON=0.0068580134999D0,ZMCON=3.7037037037033D0)
      CHARACTER  TAG*81,DET(IMIXI)*8,
     1   VERSION*4
      real*8  EP(MMAXPI),RP(MMAXPI),RPB(MMAXPI),RPC(MMAXPI),
     1   RPD(MMAXPI),TEPN(KMAXPI),FEPN(KMAXPI),FEPNB(KMAXPI),
     2   FEPNC(KMAXPI),FEPND(KMAXPI),TP(NMAXPI),ZRP(LMAXPI),
     3   DALP(NMAXPI,LMAXPI),DALPB(NMAXPI,LMAXPI),
     4   DALPC(NMAXPI,LMAXPI),DALPD(NMAXPI,LMAXPI),
     5   DRATP(NMAXPI,LMAXPI),DRATPB(NMAXPI,LMAXPI),
     6   DRATPC(NMAXPI,LMAXPI),DRATPD(NMAXPI,LMAXPI)
      real*8  EE(MMAXEI),RE(MMAXEI),REB(MMAXEI),REC(MMAXEI),
     1   RED(MMAXEI),YE(MMAXEI),YEB(MMAXEI),YEC(MMAXEI),YED(MMAXEI),
     2   TE(NMAXEI),AR(NMAXEI),ARB(NMAXEI),ARC(NMAXEI),ARD(NMAXEI),
     3   RS(NMAXEI),RSB(NMAXEI),RSC(NMAXEI),RSD(NMAXEI),BS(LMAXSI),
     4   ZRE(LMAXEI),ZS(LMAXTI),ZB(LMAXBI),DALE(NMAXEI,LMAXSI),
     5   DALEB(NMAXEI,LMAXSI),DALEC(NMAXEI,LMAXSI),DALED(NMAXEI,LMAXSI),
     6   DALB(NMAXEI,LMAXTI),DALBB(NMAXEI,LMAXTI),DALBC(NMAXEI,LMAXTI),
     7   DALBD(NMAXEI,LMAXTI),DRATE(NMAXEI,LMAXEI,2),
     8   DRATEB(NMAXEI,LMAXEI,2),DRATEC(NMAXEI,LMAXEI,2),
     9   DRATED(NMAXEI,LMAXEI,2),DRATB(NMAXEI,LMAXBI,2),
     X   DRATBB(NMAXEI,LMAXBI,2),DRATBC(NMAXEI,LMAXBI,2),
     1   DRATBD(NMAXEI,LMAXBI,2)
      real*8  ZM(IMAXI),Z(IMAXI),ZMM(IMAXI),ZL(IMAXI),TPL(NPTSPI),
     1   TPP(NPTSPI),TEL(NPTSEI),ENEWT(NPTSPI),TEE(NPTSEI),RINE(NPTSEI),
     2   RINS(NPTSEI),ARES(NPTSEI),YLDE(NPTSEI),DIN(LMAXPI),
     3   DINB(LMAXPI),DINC(LMAXPI),DIND(LMAXPI),DRIN(LMAXPI),
     4   GP(NPTSPI,IMAXI),GE(NPTSEI,IMAXI,2),GB(NPTSEI,IMAXI,2),
     5   EPS(JMAXI),S(JMAXI),SOL(NPTSPI),SPG(NPTSPI),SEG(NPTSEI),
     6   G(NPTSI),DOSOL(IMAXI,2),DOSP(IMAXI,2),DOSE(IMAXI,2,2),
     7   DOSB(IMAXI,2,2)
c
C     missing declaration
      real*8 ZMIN,RADCON,ENMU,EMINU,EMAXU,DEP,EMINUL,DELP
      integer*4 NBEGE,INATT,INEWT,IMIX
      integer*4 MMAXP,KMAXP,NMAXP,LMAXP,IMIXP
      integer*4 MMAXE,NMAXE,LMAXS,LMAXE,LMAXT,LMAXB,IMIXE
      integer*4 M,K,L,N,NLENE,I,J
      integer*4 NFSTSB,NLSTSB,NLENSB
      integer*4 NFSTPB,NLSTPB,NLENPB
      real*8 ANS,RINP,ANSR,BENMU,ZRIN,EMINEL,DEE,DELE
      integer*4 NE,NP,ISOL,NLENS
      integer*4 NFSTS,NLSTS,ITRP,NLENP,NFSTP,NLSTP,ILEC,NFSTE,NLSTE
      real*8 ZRINL,DELTAS,DELTAP,DELTAE,ENEUT,EAV
c
c     declaration added to cleanup the code and avoid memory fault
      real*8 dosSphIN(IMAXI),dosSpOut(IMAXI)
cccc INPUTS:
      INTEGER*4 IDET, INUC, IMAX, IUNT
      REAL*8 Zin(IMAXI)
      REAL*8 EMINS,EMAXS,EMINP,EMAXP,EMINE,EMAXE
      INTEGER*4 NPTSP,NPTSE
      INTEGER*4 JSMAX,JPMAX,JEMAX
      REAL*8 EUNIT,DURATN
      REAL*8 ESin(JMAXI),SFLUXin(JMAXI)
      REAL*8 EPin(JMAXI),PFLUXin(JMAXI)
      REAL*8 EEin(JMAXI),EFLUXin(JMAXI)
      REAL*8 SolDose(IMAXI,3), ProtDose(IMAXI,3)
      REAL*8 ElecDose(IMAXI,3), BremDose(IMAXI,3), TotDose(IMAXI,3)
ccccccEND OF INPUTS cccccccccccccccccccccccc

      COMMON /sd2pro/MMAXP,KMAXP,NMAXP,LMAXP,IMIXP
      COMMON /sd2proTab/EP,RP,TEPN,FEPN,TP,ZRP,
     &DALP,DRATP
      COMMON /sd2elbr/MMAXE,NMAXE,LMAXS,LMAXE,
     &LMAXT,LMAXB,IMIXE
      COMMON /sd2elbrTab/EE,RE,YE,TE,AR,RS,BS,ZRE
     &,ZS,ZB,DALE,DALB,DRATE,DRATB


      DATA  DET/'Aluminum','Graphite','Silicon','Air','Bone','CaF2',
     1   'GaAs','LiF','SiO2','Tissue','H2O'/
      DATA  ZMIN/1.0E-06/,RADCON/1.6021892E-08/,NBEGE/1/,ENMU/0.03/
      DATA  VERSION/'2.10'/
c
c     add init var to 0
      NLSTS = 0
      NLSTP = 0
      NLSTE = 0
      NFSTS = 0
      NFSTP = 0
      NFSTE = 0
c     end add var
c
C      CALL LOGO (VERSION)
c      PRINT 10
c   10 FORMAT (' Enter input filename: ')
c      READ 20,FILENM
c   20 FORMAT (A)
c      OPEN (UNIT=9,FILE=FILENM)
c      READ (9,20) PRTFIL
c      OPEN (UNIT=10,FILE=PRTFIL)
c      READ (9,20) ARRFIL
c      OPEN (UNIT=12,FILE=ARRFIL)
c      WRITE (10,30) VERSION
c      WRITE (12,30) VERSION
c   30 FORMAT (' OUTPUT FROM SHIELDOSE-2, VERSION ',A)
c      WRITE (10,32) FILENM
c      WRITE (12,32) FILENM
c   32 FORMAT (' Input filename: ',A)
c      WRITE (10,34) PRTFIL
c      WRITE (12,34) PRTFIL
c   34 FORMAT (' Print-out filename: ',A)
c      WRITE (10,36) ARRFIL
c      WRITE (12,36) ARRFIL
c   36 FORMAT (' Array output filename: ',A)
c      WRITE (10,370)
c  370 FORMAT (/'  IDET  INUC  IMAX  IUNT')
c      READ (9,*) IDET,INUC,IMAX,IUNT
c      WRITE (10,380) IDET,INUC,IMAX,IUNT
c  380 FORMAT (12I6)
c      WRITE (12,380) IDET,IMAX,INUC
      INATT=2
      IF (INUC.EQ.1) INATT=1
      INEWT=0
      IF (INUC.EQ.3) INEWT=1
!      PRINT *,' Reading database and preparing base arrays.............'
!      PRINT *,'    Protons.............................................'
!      OPEN (UNIT=11,FILE='PROTBAS2.DAT')
!      READ (11,20) TAG
!      READ (11,*) MMAXP,KMAXP,NMAXP,LMAXP,IMIX
!      READ (11,*) (EP(M),M=1,MMAXP)
!      READ (11,*) (RP(M),M=1,MMAXP)
!      READ (11,*) (TEPN(K),K=1,KMAXP)
!      READ (11,*) (FEPN(K),K=1,KMAXP)
!      READ (11,*) (TP(N),N=1,NMAXP)
!      READ (11,*) (ZRP(L),L=1,LMAXP)
!      DO 50 N=1,NMAXP
!      DO 38 I=1,2
!      READ (11,*) (DUM(L),L=1,LMAXP)
!      IF (I.NE.INATT) GO TO 38
!      DO 390 L=1,LMAXP
!  390 DALP(N,L)=DUM(L)
!      DALP(N,LMAXP)=(DALP(N,LMAXP-1)/DALP(N,LMAXP-2))*DALP(N,LMAXP-1)
!   38 CONTINUE
!      DO 40 I=1,IMIX
!      READ (11,*) (DUM(L),L=1,LMAXP)
!      IF (I.NE.IDET) GO TO 40
!      DO 39 L=1,LMAXP
!   39 DRATP(N,L)=DUM(L)
!   40 CONTINUE
!   50 CONTINUE
!      CLOSE (11)
      call protbas2(INATT,IDET,tag)
      IMIX=IMIXP

      DO 60 M=1,MMAXP
      EP(M)=LOG(EP(M))
   60 RP(M)=LOG(RP(M))
      DO 65 K=1,KMAXP
   65 TEPN(K)=LOG(TEPN(K))
      DO 70 N=1,NMAXP
   70 TP(N)=LOG(TP(N))
      CALL SCOF (MMAXP,EP,RP,RPB,RPC,RPD)
      CALL SCOF (KMAXP,TEPN,FEPN,FEPNB,FEPNC,FEPND)
      DO 75 L=1,LMAXP
      DO 72 N=1,NMAXP
   72 DALP(N,L)=LOG(DALP(N,L))
      CALL SCOF (NMAXP,TP,DALP(1,L),DALPB(1,L),DALPC(1,L),DALPD(1,L))
   75 CONTINUE
!      PRINT *,'    Electrons and bremsstrahlung........................'
!      OPEN (UNIT=11,FILE='ELBRBAS2.DAT')
!      READ (11,20) TAG
!      READ (11,*) MMAXE,NMAXE,LMAXS,LMAXE,LMAXT,LMAXB,IMIX
      call elbrbas2(IDET,tag)
      IMIX=IMIXE
      NLENE=NMAXE-NBEGE+1
!      READ (11,*) (EE(M),M=1,MMAXE)
!      READ (11,*) (RE(M),M=1,MMAXE)
!      READ (11,*) (YE(M),M=1,MMAXE)
!      READ (11,*) (TE(N),N=1,NMAXE)
!      READ (11,*) (AR(N),N=1,NMAXE)
!      READ (11,*) (RS(N),N=1,NMAXE)
!      READ (11,*) (BS(L),L=1,LMAXS)
!      BS(LMAXS+1)=2.0
!      READ (11,*) (ZRE(L),L=1,LMAXE)
!      READ (11,*) (ZS(L),L=1,LMAXT)
!      READ (11,*) (ZB(L),L=1,LMAXB)
!      DO 100 N=1,NMAXE
!      READ (11,*) (DALE(N,L),L=1,LMAXS)
!      DALE(N,LMAXS+1)=1.0E-07
!      READ (11,*) (DALB(N,L),L=1,LMAXT)
!      DO 90 I=1,IMIX
!      DO 80 M=1,2
!      READ (11,*) (DUM(L),L=1,LMAXE)
!      IF (I.NE.IDET) GO TO 77
!      DO 76 L=1,LMAXE
!   76 DRATE(N,L,M)=DUM(L)
!   77 READ (11,*) (DUM(L),L=1,LMAXB)
!      IF (I.NE.IDET) GO TO 80
!      DO 78 L=1,LMAXB
!   78 DRATB(N,L,M)=DUM(L)
!   80 CONTINUE
!   90 CONTINUE
!  100 CONTINUE
      LMAXS=LMAXS+1
!      CLOSE (11)
      DO 110 M=1,MMAXE
      EE(M)=LOG(EE(M))
      RE(M)=LOG(RE(M))
  110 YE(M)=LOG(YE(M))
      DO 120 N=1,NMAXE
      TE(N)=LOG(TE(N))
      AR(N)=LOG(AR(N))
  120 RS(N)=LOG(RS(N))
      DO 130 L=1,LMAXB
  130 ZB(L)=LOG(ZB(L))
      CALL SCOF (MMAXE,EE,RE,REB,REC,RED)
      CALL SCOF (MMAXE,EE,YE,YEB,YEC,YED)
      CALL SCOF (NMAXE,TE,AR,ARB,ARC,ARD)
      CALL SCOF (NMAXE,TE,RS,RSB,RSC,RSD)
      DO 150 L=1,LMAXS
      DO 140 N=NBEGE,NMAXE
  140 DALE(N,L)=LOG(DALE(N,L))
      CALL LCOF (NLENE,TE(NBEGE),DALE(NBEGE,L),DALEB(NBEGE,L),
     1   DALEC(NBEGE,L),DALED(NBEGE,L))
C     CALL SCOF (NLENE,TE(NBEGE),DALE(NBEGE,L),DALEB(NBEGE,L),
C    1   DALEC(NBEGE,L),DALED(NBEGE,L))
  150 CONTINUE
      DO 170 L=1,LMAXT
      ZS(L)=LOG(ZS(L))
      DO 160 N=NBEGE,NMAXE
  160 DALB(N,L)=LOG(DALB(N,L))
      CALL LCOF (NLENE,TE(NBEGE),DALB(NBEGE,L),DALBB(NBEGE,L),
     1   DALBC(NBEGE,L),DALBD(NBEGE,L))
C     CALL SCOF (NLENE,TE(NBEGE),DALB(NBEGE,L),DALBB(NBEGE,L),
C    1   DALBC(NBEGE,L),DALBD(NBEGE,L))
  170 CONTINUE
!      PRINT *,' Preparing base arrays for selected detector material...'
      DO 220 L=1,LMAXP
      CALL SCOF (NMAXP,TP,DRATP(1,L),DRATPB(1,L),DRATPC(1,L),
     1   DRATPD(1,L))
  220 CONTINUE
      DO 240 M=1,2
      DO 230 L=1,LMAXE
      CALL LCOF (NLENE,TE(NBEGE),DRATE(NBEGE,L,M),
     1   DRATEB(NBEGE,L,M),DRATEC(NBEGE,L,M),DRATED(NBEGE,L,M))
C     CALL SCOF (NLENE,TE(NBEGE),DRATE(NBEGE,L,M),
C    1   DRATEB(NBEGE,L,M),DRATEC(NBEGE,L,M),DRATED(NBEGE,L,M))
  230 CONTINUE
  240 CONTINUE
      DO 260 M=1,2
      DO 250 L=1,LMAXB
      CALL LCOF (NLENE,TE(NBEGE),DRATB(NBEGE,L,M),
     1   DRATBB(NBEGE,L,M),DRATBC(NBEGE,L,M),DRATBD(NBEGE,L,M))
C     CALL SCOF (NLENE,TE(NBEGE),DRATB(NBEGE,L,M),
C    1   DRATBB(NBEGE,L,M),DRATBC(NBEGE,L,M),DRATBD(NBEGE,L,M))
  250 CONTINUE
  260 CONTINUE
      GO TO (440,470,500), IUNT
  440 continue
c  440 WRITE (10,450)
c  450 FORMAT (/' SHIELD DEPTH (mils)')
c      READ (9,*) (ZM(I),I=1,IMAX)
c      WRITE (10,455) (ZM(I),I=1,IMAX)
c  455 FORMAT (1P6E12.5)
      do I = 1,IMAX
        ZM(I) = Zin(I)
      enddo
      DO 460 I=1,IMAX
      IF (ZM(I).LE.ZMIN/ZCON) ZM(I)=ZMIN/ZCON
      Z(I)=ZCON*ZM(I)
  460 ZMM(I)=Z(I)*ZMCON
      GO TO 530
  470 continue
c  470 WRITE (10,480)
c  480 FORMAT (/' SHIELD DEPTH (g/cm2)')
c      READ (9,*) (Z(I),I=1,IMAX)
c      WRITE (10,455) (Z(I),I=1,IMAX)
      DO I=1,IMAX
         Z(I) = Zin(I)
      ENDDO
      DO 490 I=1,IMAX
      IF (Z(I).LE.ZMIN) Z(I)=ZMIN
      ZM(I)=Z(I)/ZCON
  490 ZMM(I)=Z(I)*ZMCON
      GO TO 530
  500 continue
c  500 WRITE (10,510)
c  510 FORMAT (/' SHIELD DEPTH (mm)')
c      READ (9,*) (ZMM(I),I=1,IMAX)
c      WRITE (10,455) (ZMM(I),I=1,IMAX)
      DO I=1,IMAX
        ZMM(I) = Zin(I)
      ENDDO
      DO 520 I=1,IMAX
      IF (ZMM(I).LE.ZMIN*ZMCON) ZMM(I)=ZMIN*ZMCON
      Z(I)=ZMM(I)/ZMCON
  520 ZM(I)=Z(I)/ZCON
  530 DO 540 I=1,IMAX
  540 ZL(I)=LOG(Z(I))
c      WRITE (12,1435) (Z(I),I=1,IMAX)
c      WRITE (10,550)
c  550 FORMAT(/'     EMINS     EMAXS     EMINP     EMAXP NPTSP     EMINE
c     1    EMAXE NPTSE')
c      READ (9,*) EMINS,EMAXS,EMINP,EMAXP,NPTSP,EMINE,EMAXE,NPTSE
c      WRITE (10,560) EMINS,EMAXS,EMINP,EMAXP,NPTSP,EMINE,EMAXE,NPTSE
c  560 FORMAT (4F10.3,I6,2F10.3,I6)
      EMINU=MIN(EMINP,EMINS)
      EMAXU=MAX(EMAXP,EMAXS)
      DEP=LOG(EMAXU/EMINU)/FLOAT(NPTSP-1)
      EMINUL=LOG(EMINU)
      DELP=DEP/3.0
      CALL EINDEX (EMINU,DEP,NPTSP,EMINS,EMAXS,NFSTSB,NLSTSB,NLENSB)
      CALL EINDEX (EMINU,DEP,NPTSP,EMINP,EMAXP,NFSTPB,NLSTPB,NLENPB)
      DO 570 NP=1,NPTSP
      TPL(NP)=EMINUL+FLOAT(NP-1)*DEP
      TPP(NP)=EXP(TPL(NP))
  570 CONTINUE
c      WRITE (10,580) TPP(NFSTSB),TPP(NLSTSB),TPP(NFSTPB),TPP(NLSTPB),
c     1   NPTSP,EMINE,EMAXE,NPTSE
c  580 FORMAT (4F10.3,I6,2F10.3,I6,'  ADJUSTED VALUES')
c      WRITE (12,560) TPP(NFSTSB),TPP(NLSTSB),TPP(NFSTPB),TPP(NLSTPB),
c     1   NPTSP,EMINE,EMAXE,NPTSE
!      PRINT *,' Preparing mesh arrays to be integrated over spectra....'
!      PRINT *,'    Protons.............................................'
      DO 660 NP=1,NPTSP
      CALL BSPOL (TPL(NP),MMAXP,EP,RP,RPB,RPC,RPD,ANS)
      RINP=EXP(ANS)
      DO 610 L=1,LMAXP
      IF (TPL(NP).LT.TP(NMAXP)) GO TO 590
      ANS=DALP(NMAXP,L)
      ANSR=DRATP(NMAXP,L)
      GO TO 605
  590 IF (TPL(NP).GT.TP(1)) GO TO 600
      ANS=DALP(1,L)
      ANSR=DRATP(1,L)
      GO TO 605
  600 CALL BSPOL (TPL(NP),NMAXP,TP,DALP(1,L),DALPB(1,L),
     1   DALPC(1,L),DALPD(1,L),ANS)
      ANSR=1.0
      IF (IDET.EQ.1) GO TO 605
      CALL BSPOL (TPL(NP),NMAXP,TP,DRATP(1,L),DRATPB(1,L),
     1   DRATPC(1,L),DRATPD(1,L),ANSR)
  605 DIN(L)=ANS+LOG(ANSR)
  610 CONTINUE
      ENEWT(NP)=0.0
      BENMU=0.0
      IF (INATT.EQ.1) GO TO 620
      IF (TPL(NP).LE.TEPN(1)) GO TO 615
      CALL BSPOL (TPL(NP),KMAXP,TEPN,FEPN,FEPNB,FEPNC,FEPND,ANS)
      ENEWT(NP)=TPP(NP)*ANS
  615 BENMU=ENEWT(NP)*ENMU
  620 CALL SCOF (LMAXP,ZRP,DIN,DINB,DINC,DIND)
      DO 650 I=1,IMAX
      ZRIN=Z(I)/RINP
      IF (ZRIN.LT.ZRP(LMAXP)) GO TO 640
      GP(NP,I)=0.0
      GO TO 645
  640 CALL BSPOL (ZRIN,LMAXP,ZRP,DIN,DINB,DINC,DIND,ANS)
      ANS=EXP(ANS)
      GP(NP,I)=TPP(NP)*ANS/RINP
  645 IF (INEWT.EQ.1.AND.TPL(NP).GT.TEPN(1)) GP(NP,I)=GP(NP,I)+
     1   BENMU*EXP(-ENMU*Z(I))
  650 CONTINUE
  660 CONTINUE
!      PRINT *,'    Electrons and bremsstrahlung try...................'
      EMINEL=LOG(EMINE)
      DEE=(LOG(EMAXE)-EMINEL)/FLOAT(NPTSE-1)
      DELE=DEE/3.0
      DO 670 NE=1,NPTSE
      TEL(NE)=EMINEL+FLOAT(NE-1)*DEE
      TEE(NE)=EXP(TEL(NE))
      CALL BSPOL (TEL(NE),MMAXE,EE,RE,REB,REC,RED,ANS)
      RINE(NE)=EXP(ANS)
      CALL BSPOL (TEL(NE),NMAXE,TE,RS,RSB,RSC,RSD,ANS)
      RINS(NE)=RINE(NE)*EXP(ANS)
      CALL BSPOL (TEL(NE),NMAXE,TE,AR,ARB,ARC,ARD,ANS)
      ARES(NE)=EXP(ANS)
      CALL BSPOL (TEL(NE),MMAXE,EE,YE,YEB,YEC,YED,ANS)
  670 YLDE(NE)=EXP(ANS)
      DO 820 M=1,2
      DO 815 NE=1,NPTSE
      DO 700 L=1,LMAXS
      IF (TEL(NE).LT.TE(NMAXE)) GO TO 680
      DIN(L)=DALE(NMAXE,L)
      GO TO 700
  680 IF (TEL(NE).GT.TE(NBEGE)) GO TO 690
      DIN(L)=DALE(NBEGE,L)
      GO TO 700
  690 CALL BSPOL (TEL(NE),NLENE,TE(NBEGE),DALE(NBEGE,L),DALEB(NBEGE,L),
     1   DALEC(NBEGE,L),DALED(NBEGE,L),DIN(L))
  700 CONTINUE
      DO 715 L=1,LMAXE
      DRIN(L)=1.0
      IF (IDET.EQ.1.AND.M.EQ.1) GO TO 715
      IF (TEL(NE).LT.TE(NMAXE)) GO TO 710
      DRIN(L)=DRATE(NMAXE,L,M)
      GO TO 715
  710 IF (TEL(NE).GT.TE(NBEGE)) GO TO 712
      DRIN(L)=DRATE(NBEGE,L,M)
      GO TO 715
  712 CALL BSPOL (TEL(NE),NLENE,TE(NBEGE),DRATE(NBEGE,L,M),
     1   DRATEB(NBEGE,L,M),DRATEC(NBEGE,L,M),DRATED(NBEGE,L,M),DRIN(L))
      IF (DRIN(L).LT.0.0) DRIN(L)=0.0
  715 CONTINUE
C     CALL LCOF (LMAXS,BS,DIN,DINB,DINC,DIND)
      CALL SCOF (LMAXS,BS,DIN,DINB,DINC,DIND)
      DO 740 I=1,IMAX
      ZRIN=Z(I)/RINS(NE)
      IF (ZRIN.LT.BS(LMAXS)) GO TO 730
  720 GE(NE,I,M)=0.0
      GO TO 740
  730 CALL BSPOL (ZRIN,LMAXS,BS,DIN,DINB,DINC,DIND,ANS)
      ANS=EXP(ANS)
      GE(NE,I,M)=TEE(NE)*ANS*ARES(NE)/RINS(NE)
  740 CONTINUE
C     CALL LCOF (LMAXE,ZRE,DRIN,DINB,DINC,DIND)
      CALL SCOF (LMAXE,ZRE,DRIN,DINB,DINC,DIND)
      DO 745 I=1,IMAX
      ZRIN=Z(I)/RINE(NE)
      IF (ZRIN.LT.ZRE(LMAXE)) GO TO 742
      GE(NE,I,M)=GE(NE,I,M)*DRIN(LMAXE)
      GO TO 745
  742 CALL BSPOL (ZRIN,LMAXE,ZRE,DRIN,DINB,DINC,DIND,ANSR)
      IF (ANSR.LT.0.0) ANSR=0.0
      GE(NE,I,M)=GE(NE,I,M)*ANSR
  745 CONTINUE
      DO 780 L=1,LMAXT
      IF (TEL(NE).LT.TE(NMAXE)) GO TO 760
      DIN(L)=DALB(NMAXE,L)
      GO TO 780
  760 IF (TEL(NE).GT.TE(NBEGE)) GO TO 770
      DIN(L)=DALB(NBEGE,L)
      GO TO 780
  770 CALL BSPOL (TEL(NE),NLENE,TE(NBEGE),DALB(NBEGE,L),DALBB(NBEGE,L),
     1   DALBC(NBEGE,L),DALBD(NBEGE,L),DIN(L))
  780 CONTINUE
      DO 795 L=1,LMAXB
      DRIN(L)=1.0
      IF (IDET.EQ.1.AND.M.EQ.1) GO TO 795
      IF (TEL(NE).LT.TE(NMAXE)) GO TO 790
      DRIN(L)=DRATB(NMAXE,L,M)
      GO TO 795
  790 IF (TEL(NE).GT.TE(NBEGE)) GO TO 792
      DRIN(L)=DRATB(NBEGE,L,M)
      GO TO 795
  792 CALL BSPOL (TEL(NE),NLENE,TE(NBEGE),DRATB(NBEGE,L,M),
     1   DRATBB(NBEGE,L,M),DRATBC(NBEGE,L,M),DRATBD(NBEGE,L,M),DRIN(L))
      IF (DRIN(L).LT.0.0) DRIN(L)=0.0
  795 CONTINUE
      CALL LCOF (LMAXT,ZS,DIN,DINB,DINC,DIND)
C     CALL SCOF (LMAXT,ZS,DIN,DINB,DINC,DIND)
      DO 800 I=1,IMAX
      ZRINL=LOG(Z(I)/RINE(NE))
      CALL BSPOL (ZRINL,LMAXT,ZS,DIN,DINB,DINC,DIND,ANS)
      ANS=EXP(ANS)
      GB(NE,I,M)=TEE(NE)*ANS*YLDE(NE)/RINE(NE)
  800 CONTINUE
      CALL LCOF (LMAXB,ZB,DRIN,DINB,DINC,DIND)
C     CALL SCOF (LMAXB,ZB,DRIN,DINB,DINC,DIND)
      DO 812 I=1,IMAX
      IF (ZL(I).LT.ZB(LMAXB)) GO TO 810
      GB(NE,I,M)=GB(NE,I,M)*DRIN(LMAXB)
      GO TO 812
  810 CALL BSPOL (ZL(I),LMAXB,ZB,DRIN,DINB,DINC,DIND,ANSR)
      IF (ANSR.LT.0.0) ANSR=0.0
      GB(NE,I,M)=GB(NE,I,M)*ANSR
  812 CONTINUE
  815 CONTINUE
  820 CONTINUE
!      PRINT *,' Performing calculations for input spectra..............'
  830 continue
c  830 WRITE (10,840)
c  840 FORMAT (/)
c      WRITE (10,850)
c  850 FORMAT (' ')
c      READ (9,20,END=1440) TAG
c      PRINT 860, TAG
c  860 FORMAT (4X,A)
c      WRITE (10,20) TAG
c      WRITE (12,20) TAG
c      WRITE (10,870)
c  870 FORMAT (/' JSMAX JPMAX JEMAX       EUNIT      DURATN')
c      READ (9,*)  JSMAX,JPMAX,JEMAX,EUNIT,DURATN
c      WRITE (10,880) JSMAX,JPMAX,JEMAX,EUNIT,DURATN
c      WRITE (12,880) JSMAX,JPMAX,JEMAX,EUNIT,DURATN
c  880 FORMAT (3I6,1P2E12.5)
      IF (DURATN.LE.0.0) DURATN=1.0
      DELTAS=RADCON*DELP/4.0
      DELTAP=DURATN*RADCON*DELP/4.0
      DELTAE=DURATN*RADCON*DELE/4.0
      IF (EUNIT.LE.0.0) EUNIT=1.0
      ISOL=2
      IF (JSMAX.LT.3) GO TO 900
      ISOL=1
c      WRITE (10,885)
c  885 FORMAT (//' E(MeV)')
c      READ (9,*) (EPS(J),J=1,JSMAX)
      DO J=1,JSMAX
        EPS(J) = ESin(J)
      ENDDO
c      WRITE (10,905) (EPS(J),J=1,JSMAX)
c      WRITE (12,905) (EPS(J),J=1,JSMAX)
c      WRITE (10,890)
c  890 FORMAT (/' SOLAR PROTON SPECTRUM (/energy/cm2)')
c      READ (9,*) (S(J),J=1,JSMAX)
      DO J=1,JSMAX
        S(J) = SFLUXin(J)
      ENDDO
c      WRITE (10,905) (S(J),J=1,JSMAX)
c      WRITE (12,905) (S(J),J=1,JSMAX)
      NLENS=NLENSB
      NFSTS=NFSTSB
      NLSTS=NLSTSB
      CALL SPECTR (JSMAX,EPS,S,EUNIT,EMINU,DEP,NPTSP,NFSTS,NLSTS,NLENS,
     1   TPP,TPL,SOL)
c      WRITE (10,891) TPP(NFSTS),TPP(NLSTS),NLENS
c  891 FORMAT (/' SPECTRUM INTEGRATED FROM',1PE11.4,' TO',1PE11.4,
c     1   ' MeV, USING',I5,' POINTS')
      DO 892 NP=NFSTS,NLSTS
  892 G(NP)=SOL(NP)*ENEWT(NP)
      CALL INTEG (DELP,G(NFSTS),NLENS,ENEUT)
      DO 894 NP=NFSTS,NLSTS
  894 G(NP)=SOL(NP)*TPP(NP)
      CALL INTEG (DELP,G(NFSTS),NLENS,EAV)
      ENEUT=ENEUT/EAV
c      WRITE (10,896) ENEUT
c  896 FORMAT (/' ASSUMED FRACTION OF BEAM ENERGY INTO NEUTRON ENERGY =',
c     1   1PE12.5)
  900 ITRP=2
      IF (JPMAX.LT.3) GO TO 920
      ITRP=1
c      WRITE (10,885)
c      READ (9,*) (EPS(J),J=1,JPMAX)
      DO J=1,JPMAX
        EPS(J) = EPin(J)
      ENDDO
c      WRITE (10,905) (EPS(J),J=1,JPMAX)
c      WRITE (12,905) (EPS(J),J=1,JPMAX)
c  905 FORMAT (1P10E12.4)
c      WRITE (10,910)
c  910 FORMAT (/' TRAPPED PROTON SPECTRUM (/energy/cm2/time)')
c      READ (9,*) (S(J),J=1,JPMAX)
      DO J=1,JPMAX
        S(J) = PFLUXin(J)
      ENDDO
c      WRITE (10,905) (S(J),J=1,JPMAX)
c      WRITE (12,905) (S(J),J=1,JPMAX)
      NLENP=NLENPB
      NFSTP=NFSTPB
      NLSTP=NLSTPB
      CALL SPECTR (JPMAX,EPS,S,EUNIT,EMINU,DEP,NPTSP,NFSTP,NLSTP,NLENP,
     1   TPP,TPL,SPG)
c      WRITE (10,891) TPP(NFSTP),TPP(NLSTP),NLENP
      DO 912 NP=NFSTP,NLSTP
  912 G(NP)=SPG(NP)*ENEWT(NP)
      CALL INTEG (DELP,G(NFSTP),NLENP,ENEUT)
      DO 914 NP=NFSTP,NLSTP
  914 G(NP)=SPG(NP)*TPP(NP)
      CALL INTEG (DELP,G(NFSTP),NLENP,EAV)
      ENEUT=ENEUT/EAV
c      WRITE (10,896) ENEUT
  920 ILEC=2
      IF (JEMAX.LT.3) GO TO 940
      ILEC=1
c      WRITE (10,885)
c      READ (9,*) (EPS(J),J=1,JEMAX)
      DO J=1,JEMAX
        EPS(J) = EEin(J)
      ENDDO
c      WRITE (10,905) (EPS(J),J=1,JEMAX)
c      WRITE (12,905) (EPS(J),J=1,JEMAX)
c      WRITE (10,930)
c  930 FORMAT (/' ELECTRON SPECTRUM (/energy/cm2/time)')
c      READ (9,*) (S(J),J=1,JEMAX)
      DO J=1,JEMAX
        S(J) = EFLUXin(J)
      ENDDO
c      WRITE (10,905) (S(J),J=1,JEMAX)
c      WRITE (12,905) (S(J),J=1,JEMAX)
      NLENE=NPTSE
      NFSTE=1
      NLSTE=NPTSE
      CALL SPECTR (JEMAX,EPS,S,EUNIT,EMINE,DEE,NPTSE,NFSTE,NLSTE,NLENE,
     1   TEE,TEL,SEG)
c
c      WRITE (10,891) TEE(NFSTE),TEE(NLSTE),NLENE
  940 GO TO (980,950), ISOL
!  950 DO 960 NP=NFSTS,NLSTS
!  960 SOL(NP)=0.0
  950 continue
      DO 970 J=1,2
      DO 970 I=1,IMAX
  970 DOSOL(I,J)=0.0
      GO TO 1010
  980 DO 1000 I=1,IMAX
      DO 990 NP=NFSTS,NLSTS
  990 G(NP)=SOL(NP)*GP(NP,I)
      CALL INTEG (DELTAS,G(NFSTS),NLENS,DOSOL(I,1))
 1000 CONTINUE
      do  I=1,IMAX
        dosSphIN(I)=DOSOL(I,1)
      enddo
      CALL SPHERE (ZL,dosSphIN,IMAX,dosSpOut)
      do  I=1,IMAX
        DOSOL(I,2)=dosSpOut(I)
      enddo

 1010 GO TO (1050,1020), ITRP
c 1020 DO 1030 NP=NFSTP,NLSTP
c 1030 SPG(NP)=0.0
 1020 continue
      DO 1040 J=1,2
      DO 1040 I=1,IMAX
 1040 DOSP(I,J)=0.0
      GO TO 1080
 1050 DO 1070 I=1,IMAX
      DO 1060 NP=NFSTP,NLSTP
 1060 G(NP)=SPG(NP)*GP(NP,I)
      CALL INTEG (DELTAP,G(NFSTP),NLENP,DOSP(I,1))
 1070 CONTINUE
      do  I=1,IMAX
        dosSphIN(I)=DOSP(I,1)
      enddo
      CALL SPHERE (ZL,dosSphIN,IMAX,dosSpOut)
      do  I=1,IMAX
        DOSP(I,2)=dosSpOut(I)
      enddo

 1080 GO TO (1110,1090), ILEC
 1090 DO 1100 J=1,2
      DO 1100 M=1,2
      DO 1100 I=1,IMAX
      DOSE(I,M,J)=0.0
 1100 DOSB(I,M,J)=0.0
      GO TO 1160
 1110 DO 1150 M=1,2
      DO 1130 I=1,IMAX
      DO 1120 NE=NFSTE,NLSTE
      G(NE)=SEG(NE)*GE(NE,I,M)
 1120 SPG(NE)=SEG(NE)*GB(NE,I,M)
      CALL INTEG (DELTAE,G(NFSTE),NLENE,DOSE(I,M,1))
      CALL INTEG (DELTAE,SPG(NFSTE),NLENE,DOSB(I,M,1))
 1130 CONTINUE
      GO TO (1140,1150), M
 1140 continue
      do  I=1,IMAX
        dosSphIN(I)=DOSE(I,M,1)
      enddo
      CALL SPHERE (ZL,dosSphIN,IMAX,dosSpOut)
      do  I=1,IMAX
        DOSE(I,M,2)=dosSpOut(I)
      enddo

      do  I=1,IMAX
        dosSphIN(I)=DOSB(I,M,1)
      enddo
      CALL SPHERE (ZL,dosSphIN,IMAX,dosSpOut)
      do  I=1,IMAX
        DOSB(I,M,2)=dosSpOut(I)
      enddo
 1150 CONTINUE
 1160 continue
ccccccccccccccccccccc my code to store outputs
c K=1, J=1,M=1, DOSE IN SEMI-INFINITE ALUMINUM MEDIUM
c K=2, J=1,M=2, DOSE AT TRANSMISSION SURFACE OF FINITE ALUMINUM SLAB SHIELDS
c K=3, J=2,M=1, 1/2 DOSE AT CENTER OF ALUMINUM SPHERES
c         DOSOL(I,J), DOSP(I,J), DOSE(I,J,M), DOSB(I,J,M)
!      write(6,*)'Format output ...'
      K=1
      J=1
      M=1
      DO I=1,IMAX
         ProtDose(I,K) = DOSP(I,J)
         SolDose(I,K) = DOSOL(I,J)
         ElecDose(I,K) = DOSE(I,M,J)
         BremDose(I,K) = DOSB(I,M,J)
         TotDose(I,K)=DOSP(I,J)+DOSOL(I,J)+DOSE(I,M,J)+DOSB(I,M,J)
      ENDDO
      K=2
      J=1
      M=2
      DO I=1,IMAX
         ProtDose(I,K) = DOSP(I,J)
         SolDose(I,K) = DOSOL(I,J)
         ElecDose(I,K) = DOSE(I,M,J)
         BremDose(I,K) = DOSB(I,M,J)
         TotDose(I,K)=DOSP(I,J)+DOSOL(I,J)+DOSE(I,M,J)+DOSB(I,M,J)
      ENDDO
      K=3
      J=2
      M=1
      DO I=1,IMAX
         ProtDose(I,K) = DOSP(I,J)
         SolDose(I,K) = DOSOL(I,J);
         ElecDose(I,K) = DOSE(I,M,J)
         BremDose(I,K) = DOSB(I,M,J)
         TotDose(I,K)=DOSP(I,J)+DOSOL(I,J)+DOSE(I,M,J)+DOSB(I,M,J)
      ENDDO

c 1160 return
ccccccccccccccccccccc all the rest of this code is just write statements

c 1160 J=1
c      DO 1340 M=2,1,-1
c      GO TO (1190,1170), M
c 1170 WRITE (10,1180)
c 1180 FORMAT(//' DOSE AT TRANSMISSION SURFACE OF FINITE ALUMINUM SLAB SH
c     1IELDS')
c      GO TO 1210
c 1190 WRITE (10,1200)
c 1200 FORMAT(//' DOSE IN SEMI-INFINITE ALUMINUM MEDIUM')
c 1210 WRITE (10,1230) DET(IDET)
c 1230 FORMAT (/' rads ',A)
c      IF (INATT.EQ.1) WRITE (10,1240)
c 1240 FORMAT (/' Proton results without nuclear attenuation')
c      IF (INATT.EQ.2) WRITE (10,1250)
c 1250 FORMAT (/' Proton results with approximate treatment of nuclear at
c     1tenuation')
c      IF (INATT.EQ.2.AND.INEWT.EQ.0) WRITE (10,1260)
c 1260 FORMAT ( '    neglecting transport of energy by neutrons')
c      IF (INATT.EQ.2.AND.INEWT.EQ.1) WRITE (10,1270)
c 1270 FORMAT ( '    and crude exponential transport of energy by neutron
c     1s')
c      WRITE (10,1310)
c 1310 FORMAT(/'    Z(mils)      Z(mm)   Z(g/cm2)   ELECTRON    BREMS
c     1  EL+BR     TRP PROT   SOL PROT  EL+BR+TRP    TOTAL')
c      WRITE (10,850)
c      DO 1330 I=1,IMAX
c      DOSEB=DOSE(I,M,J)+DOSB(I,M,J)
c      DOSEBP=DOSEB+DOSP(I,J)
c      DOST=DOSEBP+DOSOL(I,J)
c      WRITE (10,1320) ZM(I),ZMM(I),Z(I),DOSE(I,M,J),DOSB(I,M,J),DOSEB,
c     1   DOSP(I,J),DOSOL(I,J),DOSEBP,DOST
c 1320 FORMAT (1P10E11.3)
c      IF (FLOAT(I/10).EQ.0.1*FLOAT(I)) WRITE (10,850)
c 1330 CONTINUE
c 1340 CONTINUE
c      J=2
c      M=1
c      WRITE (10,1350)
c 1350 FORMAT (//' 1/2 DOSE AT CENTER OF ALUMINUM SPHERES')
c      WRITE (10,1230) DET(IDET)
c      IF (INATT.EQ.1) WRITE (10,1240)
c      IF (INATT.EQ.2) WRITE (10,1250)
c      IF (INATT.EQ.2.AND.INEWT.EQ.0) WRITE (10,1260)
c      IF (INATT.EQ.2.AND.INEWT.EQ.1) WRITE (10,1270)
c      WRITE (10,1310)
c      WRITE (10,850)
c      DO 1410 I=1,IMAX
c      DOSEB=DOSE(I,M,J)+DOSB(I,M,J)
c      DOSEBP=DOSEB+DOSP(I,J)
c      DOST=DOSEBP+DOSOL(I,J)
c      WRITE (10,1320) ZM(I),ZMM(I),Z(I),DOSE(I,M,J),DOSB(I,M,J),DOSEB,
c     1   DOSP(I,J),DOSOL(I,J),DOSEBP,DOST
c      IF (FLOAT(I/10).EQ.0.1*FLOAT(I)) WRITE (10,850)
c 1410 CONTINUE
c      DO 1437 J=1,2
c      WRITE (12,1435) (DOSOL(I,J),I=1,IMAX)
c      WRITE (12,1435) (DOSP(I,J),I=1,IMAX)
c 1435 FORMAT (1P10E10.3)
c 1437 CONTINUE
c      DO 1438 M=2,1,-1
c      WRITE (12,1435) (DOSE(I,M,1),I=1,IMAX)
c      WRITE (12,1435) (DOSB(I,M,1),I=1,IMAX)
c 1438 CONTINUE
c      WRITE (12,1435) (DOSE(I,1,2),I=1,IMAX)
c      WRITE (12,1435) (DOSB(I,1,2),I=1,IMAX)
c      GO TO 830
c 1440 PRINT 32, FILENM
c      PRINT 34, PRTFIL
c      PRINT 36, ARRFIL
cC      print 1500,CHAR(27)
cC 1500 format (' ',A1,'[0m')
c      STOP
      END

C     SUBROUTINE EINDEX (EMINB,DE,NPTS,EMIN,EMAX,NFST,NLST,NLEN), 28 APR 94.
      SUBROUTINE EINDEX (EMINB,DE,NPTS,EMIN,EMAX,NFST,NLST,NLEN)
      implicit none
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      integer*4 NFST,NLST,NLEN,NPTS
      real*8 EMINB,EMIN,EMAX,DE

      NFST=LOG(EMIN/EMINB)/DE+0.5
      NFST=NFST+1
      IF (NFST.LT.1) NFST=1
      NLST=LOG(EMAX/EMINB)/DE+0.5
      NLST=NLST+1
      IF (NLST.GT.NPTS) NLST=NPTS
      NLEN=NLST-NFST+1
      RETURN
      END
C     SUBROUTINE SPECTR (JMAX,EPS,S,EUNIT,EMINB,DEL,NPTS,NFST,NLST,NLEN,
C    1   T,TL,SP), 28 APR 94.
      SUBROUTINE SPECTR (JMAX,EPS,S,EUNIT,EMINB,DEL,NPTS,NFST,NLST,NLEN,
     1   T,TL,SP)
      implicit none
c     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      integer*4 JMAXI,NPTSI
      PARAMETER  (JMAXI=301,NPTSI=1001)
      integer*4 JMAX,NPTS,NFST,NLST,NLEN,N,J
      real*8  EPS(JMAXI),S(JMAXI),T(NPTSI),TL(NPTSI),SP(NPTSI),
     &   BCOF(JMAXI),CCOF(JMAXI),
     1   DCOF(JMAXI),G(NPTSI)
      real*8 EUNIT,EMINB,P,ARG
      real*8 EMC2,ARGLIM,DELTA,DEL,ALPHA,BETA,ANS,SIN,EBAR

C           ARGLIM = 700.0 (DOUBLE PRECISION), 85.0 (SINGLE PRECISION)
      DATA  EMC2/938.27231/,ARGLIM/85.0/
      DELTA=DEL/3.0
      IF (EPS(1).GT.0.0) GO TO 20
      ALPHA=S(1)
      BETA=S(2)
      IF (BETA.LE.0.0) BETA=1.0
      BETA=BETA/ALPHA
      DO 10 N=NFST,NLST
      SP(N)=0.0
      G(N)=0.0
      IF (S(3).LE.0.0) GO TO 6
      P=SQRT(T(N)*(T(N)+2.0*EMC2))
      ARG=P/ALPHA
      IF (ARG.GT.ARGLIM) GO TO 10
      SP(N)=T(N)*BETA*((T(N)+EMC2)/P)*EXP(-ARG)
      GO TO 8
    6 ARG=T(N)/ALPHA
      IF (ARG.GT.ARGLIM) GO TO 10
      SP(N)=T(N)*BETA*EXP(-ARG)
    8 G(N)=T(N)*SP(N)
   10 CONTINUE
      GO TO 50
   20 CALL EINDEX (EMINB,DEL,NPTS,EPS(1),EPS(JMAX),NFST,NLST,NLEN)
      DO 30 J=1,JMAX
      EPS(J)=LOG(EPS(J))
   30 S(J)=LOG(EUNIT*S(J))
      CALL SCOF (JMAX,EPS,S,BCOF,CCOF,DCOF)
      DO 40 N=NFST,NLST
      CALL BSPOL (TL(N),JMAX,EPS,S,BCOF,CCOF,DCOF,ANS)
      SP(N)=T(N)*EXP(ANS)
   40 G(N)=T(N)*SP(N)
   50 CALL INTEG (DELTA,SP(NFST),NLEN,SIN)
      CALL INTEG (DELTA,G(NFST),NLEN,EBAR)
      EBAR=EBAR/SIN
c      WRITE (10,60)
c   60 FORMAT (/'    INT SPEC    EAV(MeV)')
c      WRITE (10,70) SIN,EBAR
c   70 FORMAT (1PE12.4,0PF12.5)
      RETURN
      END
C     SUBROUTINE SPHERE (ZL,DOSE,IMAX,DOSPH), 26 JAN 93.
      SUBROUTINE SPHERE (ZL,DOSE,IMAX,DOSPH)
      implicit none
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      integer*4 IMAXI,IMAX,I,IMIX,IMIX1
      PARAMETER  (IMAXI=71)
      real*8  ZL(IMAX),DOSE(IMAXI),DOSPH(IMAXI),DOSL(IMAXI),BCOF(IMAXI),
     1   CCOF(IMAXI),DCOF(IMAXI)
      DO 10 I=1,IMAX
      IF (DOSE(I).LE.0.0) GO TO 20
   10 DOSL(I)=LOG(DOSE(I))
      I=IMAX+1
   20 IMIX=I-1
      IF (IMIX.LT.3) GO TO 40
      CALL SCOF (IMIX,ZL,DOSL,BCOF,CCOF,DCOF)
      BCOF(IMIX)=BCOF(IMIX-1)+(2.0*CCOF(IMIX-1)+3.0*DCOF(IMIX-1)*
     1   (ZL(IMIX)-ZL(IMIX-1)))*(ZL(IMIX)-ZL(IMIX-1))
      DO 30 I=1,IMIX
   30 DOSPH(I)=DOSE(I)*(1.0-BCOF(I))
   40 IMIX1=IMIX+1
      IF (IMIX1.GT.IMAX) RETURN
      DO 50 I=IMIX1,IMAX
   50 DOSPH(I)=0.0
      RETURN
      END
      SUBROUTINE SCOF(N,X,Y,B,C,D)
      implicit none
C        REINSCH ALGORITHM, VIA MJB, 22 FEB 83
C        Y(S)=((D(J)*(X-X(J))+C(J))*(X-X(J))+B(J))*(X-X(J))+Y(J)
C             FOR X BETWEEN X(J) AND X(J+1)
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      !DIMENSION X(1),Y(1),B(1),C(1),D(1)
      integer*4 N,N1,J,JR
c      real*8 X(N),Y(N),B(N),C(N),D(N)
      real*8 X,Y,B,C,D
      DIMENSION X(1),Y(1),B(1),C(1),D(1)
      real*8 S,R
      N1=N-1
      S=0.0
      DO 10 J=1,N1
      D(J)=X(J+1)-X(J)
      R=(Y(J+1)-Y(J))/D(J)
      C(J)=R-S
   10 S=R
      S=0.0
      R=0.0
      C(1)=0.0
      C(N)=0.0
      DO 20 J=2,N1
      C(J)=C(J)+R*C(J-1)
      B(J)=(X(J-1)-X(J+1))*2.0-R*S
      S=D(J)
   20 R=S/B(J)
      DO 30 JR=N1,2,-1
   30 C(JR)=(D(JR)*C(JR+1)-C(JR))/B(JR)
      DO 40 J=1,N1
      S=D(J)
      R=C(J+1)-C(J)
      D(J)=R/S
      C(J)=3.0*C(J)
   40 B(J)=(Y(J+1)-Y(J))/S-(C(J)+R)*S
      RETURN
      END
      SUBROUTINE BSPOL(S,N,X,Y,B,C,D,T)
      implicit none
C        BINARY SEARCH, X ASCENDING OR DESCENDING
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      !DIMENSION X(1),Y(1),B(1),C(1),D(1)
      integer*4 N,IDIR,MLB,MUB,IDIR1,ML,MU,MAV
c      real*8 X(N),Y(N),B(N),C(N),D(N),T,S,Q
      real*8 X,Y,B,C,D,T,S,Q
      DIMENSION X(1),Y(1),B(1),C(1),D(1)

      IF (X(1).GT.X(N)) GO TO 10
      IDIR=0
      MLB=0
      MUB=N
      GO TO 20
   10 IDIR=1
      MLB=N
      MUB=0
   20 IDIR1=IDIR-1
      IF (S.GE.X(MUB+IDIR)) GO TO 60
      IF (S.LE.X(MLB-IDIR1)) GO TO 70
      ML=MLB
      MU=MUB
      GO TO 40
   30 IF (IABS(MU-ML).LE.1) GO TO 80
   40 MAV=(ML+MU)/2
      IF (S.LT.X(MAV)) GO TO 50
      ML=MAV
      GO TO 30
   50 MU=MAV
      GO TO 30
   60 MU=MUB+IDIR+IDIR1
      GO TO 90
   70 MU=MLB-IDIR-IDIR1
      GO TO 90
   80 MU=MU+IDIR1
   90 Q=S-X(MU)
      T=((D(MU)*Q+C(MU))*Q+B(MU))*Q+Y(MU)
      RETURN
      END
      SUBROUTINE LCOF (NMAX,X,F,B,C,D)
      implicit none
C        26 JAN 93.  SIMPLE LINEAR INTERPOLATION
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      !DIMENSION  X(1), F(1), B(1), C(1), D(1)
      integer*4 NMAX,N
c      REAL*8  X(NMAX), F(NMAX), B(NMAX), C(NMAX), D(NMAX)
      REAL*8  X, F, B, C, D
      DIMENSION  X(1), F(1), B(1), C(1), D(1)

      DO 10 N=1,NMAX-1
      B(N)=(F(N+1)-F(N))/(X(N+1)-X(N))
      C(N)=0.0
      D(N)=0.0
   10 CONTINUE
      RETURN
      END
      SUBROUTINE INTEG (DELTA,G,N,RESULT)
      implicit none
C          INCLUDES N=1
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      integer*4 N,NL1,NL2,K
      real*8 DELTA,result,SIGMA,SUM4,SUM2,SIG6
      real*8 G(*)
c      real*8 G
c      dimension G(1)

      NL1=N-1
      NL2=N-2
      IF (REAL (N) -2.0*REAL (N/2)) 100,100,10
   10  IF (N-1) 15,15,20
   15 SIGMA=0.0
      GO TO 70
   20 IF(N-3) 30,30,40
   30 SIGMA=G(1)+4.0*G(2)+G(3)
      GO TO 70
   40 SUM4=0.0
      DO 50 K=2,NL1,2
   50 SUM4=SUM4+G(K)
      SUM2=0.0
      DO 60 K=3,NL2,2
   60 SUM2=SUM2+G(K)
      SIGMA=G(1)+4.0*SUM4+2.0*SUM2+G(N)
   70 RESULT=DELTA*SIGMA
      RETURN
  100 IF(N-2)110,110,120
  110 SIGMA=1.5*(G(1)+G(2))
      GO TO 70
  120 IF(N-4)130,130,140
  130 SIGMA=1.125*(G(1)+3.0*G(2)+3.0*G(3)+G(4))
      GO TO 70
  140 IF(N-6)150,150,160
  150 SIGMA=G(1)+3.875*G(2)+2.625*G(3)+2.625*G(4)+3.875*G(5)+G(6)
      GO TO 70
  160 IF (N-8)170,170,180
  170 SIGMA=G(1)+3.875*G(2)+2.625*G(3)+2.625*G(4)+3.875*G(5)+2.0*G(6)
     1   +4.0*G(7)+G(8)
      GO TO 70
  180 SIG6=G(1)+3.875*G(2)+2.625*G(3)+2.625*G(4)+3.875*G(5)+G(6)
      SUM4=0.0
      DO 190 K=7,NL1,2
  190 SUM4=SUM4+G(K)
      SUM2=0.0
      DO 200 K=8,NL2,2
  200 SUM2=SUM2+G(K)
      SIGMA=SIG6+G(6)+4.0*SUM4+2.0*SUM2+G(N)
      GO TO 70
      END

!***************************************************************************************************
! Copyright 2007 T.P. O'Brien
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
      SUBROUTINE GET_HEMI1(kext,options,sysaxes,iyearsat,idoy,UT,
     &     xIN1,xIN2,xIN3,maginput,xHEMI)
c      computes magnetic hemisphere by taking a small 0.001 Re step
c      along field line and comparing B at the new point to that at the old
c      if the new B is larger, then in Northern Hemisphere (xHEMI=+1), else (xHEMI=-1)
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C     
      COMMON /magmod/k_ext,k_l,kint
c     declare inputs
      INTEGER*4    kext,options(5)
      INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT
      real*8     xIN1,xIN2,xIN3
      real*8     maginput(25)

c     declare outputs
      integer*4     xHEMI

c     declare internal variables
      integer*4  i,k_ext,k_l,kint,ifail
      real*8     xGEO(3)
      real*8     alti,lati,longi
      REAL*8     BxGEO(3),B1,B2
      integer*4 int_field_select, ext_field_select ! functions to call
C     
      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c     
      CALL INITIZE
      
      call init_fields ( kint, iyearsat, idoy, ut, options(2) )
      
      call get_coordinates ( sysaxes, xIN1, xIN2, xIN3, 
     6     alti, lati, longi, xGEO )
      
      call set_magfield_inputs ( k_ext, maginput, ifail )
      
      xHEMI = 0                 ! default, indicates a failure
      
      if ( ifail.lt.0 ) RETURN
      if (k_ext .eq. 13 .or. k_ext .eq. 14) then
            call INIT_TS07D_TLPR
            call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
            if ( ifail.lt.0 ) RETURN
      end if

c     
      CALL CHAMP(xGEO,BxGEO,B1,Ifail)
      IF ((Ifail.LT.0).or.(B1.eq.baddata)) THEN
         return
      ENDIF
      
      do i=1,3
         xGEO(i) = xGEO(i)+BxGEO(i)/B1/1e3 ! scale so that dX is 0.001 Re
      enddo
      
      CALL CHAMP(xGEO,BxGEO,B2,Ifail)
      IF ((Ifail.LT.0).or.(B2.eq.baddata)) THEN
         return
      ENDIF
      
      if (B2.GT.B1) then
         xHEMI = +1
      else
         xHEMI = -1
      endif
      
      END
      

      SUBROUTINE GET_HEMI_MULTI(ntime,kext,options,sysaxes,iyearsat,
     & idoy,UT,xIN1,xIN2,xIN3,maginput,xHEMI)
c     calls get_hemi1 multiple times (ntime, <= ntime_max)
      IMPLICIT NONE
      INCLUDE 'variables.inc'
      INCLUDE 'ntime_max.inc'   ! include file created by make, defines ntime_max

c     declare inputs
      INTEGER*4    ntime,kext,options(5)
      INTEGER*4    sysaxes
      INTEGER*4    iyearsat(ntime_max)
      integer*4    idoy(ntime_max)
      real*8     UT(ntime_max)
      real*8     xIN1(ntime_max),xIN2(ntime_max),xIN3(ntime_max)
      real*8     maginput(25,ntime_max)

c     declare outputs
      integer*4     xHEMI(ntime_max)

c     declare internal variables
      integer*4  isat
c       TODO: implement the TS07D load flag here and uncomment this
c      if (kext .eq. 13) then
c        call INIT_TS07D_TLPR
c      end if
    
      do isat = 1,ntime
         call GET_HEMI1(kext,options,sysaxes,
     &    iyearsat(isat),idoy(isat),UT(isat),
     &    xIN1(isat),xIN2(isat),xIN3(isat),
     &    maginput(1,isat),xHEMI(isat))
      enddo

      end

!***************************************************************************************************
! Copyright 2004 D. Vallado
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
*     ----------------------------------------------------------------
*
*                               sgp4io.for
*
*    this file contains miscallaneous functions to read two line element
*    sets. while not formerly part of the sgp4 mathematical theory, they are
*    required for practical implemenation.
*
*                            companion code for
*               fundamentals of astrodynamics and applications
*                                    2004
*                              by david vallado
*
*       (w) 719-573-2600, email dvallado@agi.com
*
*    current :
*              15 aug 06  david vallado
*                           update mfe for verif time steps, consts, mfe
*    changes :
*              15 dec 05  david vallado
*                           original baseline
*       ----------------------------------------------------------------


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE TWOLINE2RVSGP4
*
*  this function converts the two line element set character string data to
*    variables and initializes the sgp4 variables. several intermediate varaibles
*    and quantities are determined. note that the result is a structure so multiple
*    satellites can be processed simaltaneously without having to reinitialize. the
*    verification mode is an important option that permits quick checks of any
*    changes to the underlying technical theory. this option works using a
*    modified tle file in which the start, stop, and delta time values are
*    included at the end of the second line of data. this only works with the
*    verification mode. the catalog mode simply propagates from -1440 to 1440 min
*    from epoch and is useful when performing entire catalog runs.
*
*  author        : david vallado                  719-573-2600    1 mar 2001
*
*  inputs        :
*    Numsats     - Number of satellites processed. It also becomes the record
*                  number for each satellite
*    typerun     - type of run                    verification 'V', catalog 'C', 'N'
*    whichconst  - which set of constants to use  72, 84
*
*  outputs       :
*    Code        - EOF indicator. Code = 999 when EOF reached
*    startmfe    - starttime of simulation,       min from epoch
*    stopmfe     - stoptime of simulation,        min from epoch
*    deltamin    - time step                      min
*
*  coupling      :
*    days2mdhms  - conversion of days to month, day, hour, minute, second
*    jday        - convert day month year hour minute second into julian date
*    sgp4init    - initialize the sgp4 variables
*
*  Files         :
*    Unit 10     - test.elm        input 2-line element set file
*    Unit 11     - test.bak        output file
*    Unit 15     - sgp4rec.bak     temporary file of record for 2 line element sets
*
*  references    :
*    norad spacetrack report #3
*    vallado, crawford, hujsak, kelso  2006
*------------------------------------------------------------------------------

      SUBROUTINE TwoLine2RVSGP4 ( NumSats, Typerun, whichconst, 
     &                            startmfe, stopmfe, deltamin, Code )
        IMPLICIT NONE
        Character Typerun
        INTEGER*4 Code, NumSats, whichconst,i,iline,EpochYr3
        REAL*8 startmfe, stopmfe, deltamin

* ----------------------------  Locals  -------------------------------
        REAL*8 J2,TUMin,TwoPi,Rad,RadiusEarthKm,VKmPerSec, xke
        REAL*8 BC,EPDay, sec, de2ra, xpdotp, j3, j4, j3oj2 
	REAL*8 EPDay3,JDSatEpoch3
        INTEGER*4 Yr,Mon,Day,Hr,Minute,  ICrdno,nexp,bexp, error
        CHARACTER Show
        Character*130 LongStr1,LongStr2,LongStr3

        INCLUDE 'SGP4.CMN'

        COMMON /DebugHelp/ Help
        CHARACTER Help

        ! --------------------  Implementation   ----------------------
        Show = 'N'
        TwoPi         =    6.28318530717959D0
        Rad           =   57.29577951308230D0
        DE2RA         =    0.01745329251994330D0
        xpdotp        =  1440.0D0 / twopi  ! 229.1831180523293
        VKmPerSec     =  RadiusEarthKm * xke / 60.0D0

        CALL getgravconst( whichconst, tumin, radiusearthkm, xke, j2, 
     &       j3, j4, j3oj2 )

c        make sure the main program opens this file, otherwise do so here
c        ! store results in a temporary file of record
c        OPEN(15,FILE='Sgp4Rec.bak',ACCESS='DIRECT', FORM='UNFORMATTED',
c     &       RECL=1000,STATUS='UNKNOWN')

* ----------------- READ THE FIRST LINE OF ELEMENT SET ----------------
        Code = 0

        LongStr1 = ' '
   50   READ(10,'(a130)',END=999) LongStr1
        IF(LongStr1(1:1) .eq. '#') GOTO 50 ! Commented line of text, skip

        READ(LongStr1,500) ICRDNO,SatNum,SatName,EpochYr,EpDay,
     &                       NDot,NDDot,nexp,BStar,bexp,EPHTYP,ELNO
  500   FORMAT( I1,1X,I5,1X,A10,I2,D12.0,1X,D10.0,1X,
     &          F6.5,I2,1X,F6.5,I2,1X,I1,1X,I4 )

* ----------- READ THE SECOND LINE OF ELEMENT SET AND TIME ------------
        LongStr2 = ' '
   51   READ(10,'(a130)',END=999) LongStr2
        IF(LongStr2(1:1) .eq. '#') GOTO 51 ! Commented line of text, skip

        IF (Typerun.eq.'V') THEN
          READ(LongStr2,502) ICRDNO,Inclo,nodeo,Ecco,Argpo,Mo,No,REVI,
     &              startmfe, stopmfe, DeltaMin
         else
          READ(LongStr2,501) ICRDNO,Inclo,nodeo,Ecco,Argpo,Mo,No,REVI
         endif
  501   FORMAT( I1,7X,D8.0,1X,D8.0,1X,F7.7,1X,D8.0,1X,D8.0,1X,D11.0,I5)
  502   FORMAT( I1,7X,D8.0,1X,D8.0,1X,F7.7,1X,D8.0,1X,D8.0,1X,D11.0,I5,
     &          1X,F12.6,F12.6,F12.6 )

* Added Seb to process from one element to the next
*
        if (typerun .EQ. 'Y') then
           iline=0
   52      READ(10,'(a130)',END=999) LongStr3
           IF(LongStr3(1:1) .eq. '#') THEN
	      iline=iline+1
	      GOTO 52 ! Commented line of text, skip
           ENDIF
           READ(LongStr3,503) EpochYr3,EpDay3
  503      FORMAT( 18x,I2,D12.0)
           ! Temporary year fix
           IF (EpochYr.lt.50) THEN
               Yr = EpochYr + 2000
           ELSE
               Yr = EpochYr + 1900
           ENDIF
           CALL Days2MDHMS( Yr,EpDay, Mon,Day,Hr,Minute,Sec )
           CALL JDAY ( Yr,Mon,Day,Hr,Minute,Sec,  JDSatEpoch )

           IF (EpochYr3.lt.50) THEN
               Yr = EpochYr3 + 2000
           ELSE
               Yr = EpochYr3 + 1900
           ENDIF

           CALL Days2MDHMS( Yr,EpDay3, Mon,Day,Hr,Minute,Sec )
           CALL JDAY ( Yr,Mon,Day,Hr,Minute,Sec,  JDSatEpoch3 )
	   startmfe=0.D0
	   stopmfe=(JDSatEpoch3-JDSatEpoch)*1440.D0
	   if (stopmfe .EQ. 0.D0) stopmfe=1440.D0
c	   deltamin=1.D0
	   if (JDSatEpoch3.le.JDSatEpoch) then
	      READ(10,*)
	      iline=0
	      GOTO 52
	   endif
	   DO I=1,iline+1
	      backspace(10)
	   ENDDO
	ENDIF
*
* End Added Seb to process from one element to the next
*
* ---------------------- CONVERT TO INTERNAL UNITS --------------------
* ---- RADIANS, DISTANCE IN EARTH RADII, AND VELOCITY IN ER/KEMIN) ----
        NDDot  = NDDot * 10.0D0**Nexp
        NDot   = NDot / (XPDOTP*1440)
        NDDot  = NDDot / (XPDOTP*1440*1440)
        BStar  = BStar * 10.0D0**Bexp

        No     = No / XPDOTP
        a      = (No*TUMin)**(-2.0D0/3.0D0)
        Inclo  = Inclo  * DE2RA
        nodeo  = nodeo * DE2RA
        Argpo  = Argpo * DE2RA
        Mo     = Mo   * DE2RA
                                                                        
        IF (DABS(Ecco-1.0D0) .gt. 0.000001D0) THEN
            Altp= (a*(1.0D0-Ecco))-1.0D0
            Alta= (a*(1.0D0+Ecco))-1.0D0
          ELSE
            Alta= 999999.9D0
            Altp= 2.0D0* (4.0D0/(No*No)**(1.0D0/3.0D0))
          ENDIF

        ! ---- Ballistic Coefficient ----
        IF (DABS(BStar) .gt. 0.00000001D0) THEN
            BC= 1.0D0/(12.741621D0*BStar)
          ELSE
            BC= 1.111111111111111D0
          ENDIF

        ! ----------------------------------------------------------------
        ! find sgp4epoch time of element set
        ! remember that sgp4 uses units of days from 0 jan 1950 (sgp4epoch)
        ! and minutes from the epoch (time)
        ! ----------------------------------------------------------------

        ! ---- input start stop times manually
c        IF ((typerun.ne.'V').and.(typerun.ne.'C')) THEN
c            write(*,*) 'input start min from epoch'
c            read(*,*) startmfe
c            write(*,*) 'input stop min from epoch'
c            read(*,*) stopmfe
c            write(*,*) 'input time step in minutes'
c            read(*,*) deltamin
c          ENDIF

       ! ---- perform complete catalog evaluation
c       if (typerun .eq. 'C') THEN
c           startmfe = -1440.0D0
c           stopmfe  =  1440.0D0
c           deltamin =    20.0D0
c         ENDIF

        ! Temporary year fix
        IF (EpochYr.lt.50) THEN
            Yr = EpochYr + 2000
          ELSE
            Yr = EpochYr + 1900
          ENDIF

        CALL Days2MDHMS( Yr,EpDay, Mon,Day,Hr,Minute,Sec )
        CALL JDAY ( Yr,Mon,Day,Hr,Minute,Sec,  JDSatEpoch )

* ------------------- MAKE INITIAL PREDICTION AT EPOCH ----------------
        ! 2433281.5 - 2400000.5 = 33281.0, thus time from 1950
        CALL SGP4Init( whichconst,
     &                 SatNum,BStar, Ecco, JDSatEpoch-2433281.5D0,
     &                 Argpo,Inclo,Mo,No, nodeo, Error )

        ! ---- Write common block of data into file of record ----
c        WRITE(15,Rec=NumSats) SatName,
c     &          SatNum, ELNO  , EPHTYP, REVI  , EpochYr,
c     &          BStar , Ecco  , Inclo , nodeo, Argpo , No    , Mo    ,
c     &          NDot  , NDDot ,
c     &          alta  , altp  , a     ,
c     &          DeltaMin, JDSatEpoch, EpochDays,
c     &          Isimp , Init  , Method,
c     &          Aycof , CON41 , Cc1   , Cc4   , Cc5   , D2    , D3    ,
c     &          D4    , Delmo , Eta   , ArgpDot,Omgcof, Sinmao,
c     &          T2cof , T3cof , T4cof , T5cof , X1mth2, X7thm1, MDot  ,
c     &          nodeDot,Xlcof, Xmcof , Xnodcf,
c     &          D2201 , D2211 , D3210 , D3222 , D4410 , D4422 , D5220 ,
c     &          D5232 , D5421 , D5433 , Dedt  , Del1  , Del2  , Del3  ,
c     &          Didt  , Dmdt  , Dnodt , Domdt , E3    , Ee2   , Peo   ,
c     &          Pgho  , Pho   , Pinco , Plo   , Se2   , Se3   , Sgh2  ,
c     &          Sgh3  , Sgh4  , Sh2   , Sh3   , Si2   , Si3   , Sl2   ,
c     &          Sl3   , Sl4   , GSTo  , Xfact , Xgh2  , Xgh3  , Xgh4  ,
c     &          Xh2   , Xh3   , Xi2   , Xi3   , Xl2   , Xl3   , Xl4   ,
c     &          Xlamo , Zmol  , Zmos  , Atime , Xli   , Xni   , IRez

        IF(Error .GT. 0) THEN
            WRITE( *,*) '# *** SGP4 Model Error ***',Error
          ENDIF

c      write tle output details
c      INCLUDE 'debug8.for'

        ! ---- Fix to indicate end-of-file
        GOTO 1000
  999   Code = 999
 1000   CONTINUE
       if (typerun.EQ.'C') Code = 999
       RETURN
       END  !       SUBROUTINE TwoLine2RVSGP4

!***************************************************************************************************
! Copyright 2004 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C S. Bourdarie (June 2004)
c Modified S./ Bourdarie (July 2004)
c Modified from find_bm and find_mirror_point by TPO (July 2008)
c Modified to prevent overshooting into the other hemisphere ACK (Nov 2016)
c
C Routine to find foot point of field line at specified altitude and hemi
C finds foot point at specified altitude to within 1 km
c --------------------------------------------------------------------
c
        SUBROUTINE find_foot_point1(kext,options,sysaxes,iyearsat,
     &  idoy,UT,xIN1,xIN2,xIN3,stop_alt,hemi_flag,maginput,
     &  XFOOT,BFOOT,BFOOTMAG)
c
c       INPUTS have the usual meaning, except:
c      REAL*8 stop_alt - geodetic altitude of desired foot point (gdz), km
c      integer*4 hemi_flag - hemishere flag, specifies hemisphere of foot point
c      0 - same Hemisphere as start point
c      +1 - Northern Hemisphere
c      -1 - Southern Hemisphere
c      2 - opposite Hemisphere as start point
c
c      OUTPUTS
c      REAL*8 XFOOT(3) - GDZ position of foot point (alt, lat, lon)
c      REAL*8 BFOOT(3) - Magnetic field at foot point (nT, GEO)
c      REAL*8 BFOOTMAG - Magnetic field at foot point (nT)

	IMPLICIT NONE
	INCLUDE 'variables.inc'
C
c declare inputs
        INTEGER*4    kext,k_ext,k_l,kint,options(5)
        INTEGER*4    sysaxes
	INTEGER*4    iyearsat
	integer*4    idoy
	real*8     UT
	real*8     xIN1,xIN2,xIN3
	real*8     stop_alt
        INTEGER*4  hemi_flag
	real*8     maginput(25)
c
c Declare internal variables
	INTEGER*4    isat,iyear,Iint
        INTEGER*4    Ndays,activ,Ifail
	REAL*8     psi,mlon,tilt
	REAL*8     xGEO(3)
	real*8     alti,lati,longi
	real*8     BxGEO(3)
c
c Declare output variables	
        REAL*8     XFOOT(3),BFOOT(3),BFOOTMAG
C
	COMMON /magmod/k_ext,k_l,kint
      integer*4 int_field_select, ext_field_select
C

        if ((stop_alt.lt.0).or.(stop_alt.ge.6378.0*500.0)) then
           goto 999 ! fail, stop_alt out of range 0 to 500 Re
        endif
	kint = int_field_select ( options(5) )
	k_ext = ext_field_select ( kext )
c
        CALL INITIZE
	
	call init_fields ( kint, iyearsat, idoy, ut, options(2) )
	
	call get_coordinates ( sysaxes, xIN1, xIN2, xIN3, 
     6    alti, lati, longi, xGEO )
	    
	call set_magfield_inputs ( k_ext, maginput, ifail )
 
	if ( ifail.lt.0 ) goto 999

        if (k_ext .eq. 13 .or. k_ext .eq. 14) then 
            call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
            call INIT_TS07D_TLPR
	        if ( ifail.lt.0 ) goto 999
        end if
c
c
        CALL find_foot(lati,longi,alti,stop_alt,
     &       hemi_flag,XFOOT,BFOOT,BFOOTMAG)
        return
 999    continue ! bad data
        XFOOT(1) = baddata
        XFOOT(2) = baddata
        XFOOT(3) = baddata
        BFOOT(1) = baddata
        BFOOT(2) = baddata
        BFOOT(3) = baddata
        BFOOTMAG = baddata
	END
      
       SUBROUTINE find_foot(
     &     lati,longi,alti,stop_alt,hemi_flag,
     &     XFOOT,BFOOT,BFOOTMAG)
C
c      inputs: 
c      REAL*8 lati - geodetic latitude of start point (gdz), degrees
c      REAL*8 longi - geodetic longitude of start point  (gdz), degrees
c      REAL*8 alti - geodetic altitude of start point  (gdz), km
c      REAL*8 stop_alt - geodetic altitude of desired foot point (gdz), km
c      integer*4 hemi_flag - hemishere flag, specifies hemisphere of foot point
c      0 - same Hemisphere as start point
c      +1 - Northern Hemisphere
c      -1 - Southern Hemisphere
c      2 - opposite Hemisphere as start point
c
c      outputs:
c      REAL*8 XFOOT(3) - GDZ position of foot point (alt, lat, lon)
c      REAL*8 BFOOT(3) - Magnetic field at foot point (nT, GEO)
c      REAL*8 BFOOTMAG - Magnetic field at foot point (nT)
       IMPLICIT NONE

       INTEGER*4  k_ext,k_l,kint,Ifail
       REAL*8     xx0(3)
       REAL*8     lati,longi,alti
       REAL*8     stop_alt
       INTEGER*4  hemi_flag
       REAL*8     XFOOT(3),BFOOT(3),BFOOTMAG

       CALL GDZ_GEO(lati,longi,alti,xx0(1),xx0(2),xx0(3))
C
       call find_foot_opt ( xx0,stop_alt,hemi_flag,
     &     XFOOT,BFOOT,BFOOTMAG)

       RETURN
       END

       SUBROUTINE find_foot_opt (
     &     xx0,stop_alt,hemi_flag,
     &     XFOOT,BFOOT,BFOOTMAG)
C
c      inputs: 
c      REAL*8 xx0(3) - GEO cartesian coordinates
c      REAL*8 stop_alt - geodetic altitude of desired foot point (gdz), km
c      integer*4 hemi_flag - hemishere flag, specifies hemisphere of foot point
c      0 - same Hemisphere as start point
c      +1 - Northern Hemisphere
c      -1 - Southern Hemisphere
c      2 - opposite Hemisphere as start point
c
c      outputs:
c      REAL*8 XFOOT(3) - GDZ position of foot point (alt, lat, lon)
c      REAL*8 BFOOT(3) - Magnetic field at foot point (nT, GEO)
c      REAL*8 BFOOTMAG - Magnetic field at foot point (nT)
       IMPLICIT NONE
       INCLUDE 'variables.inc'
C
       INTEGER*4  Nreb
       PARAMETER (Nreb = 50)
C
       INTEGER*4  Ifail
       REAL*8     rr,tt
       REAL*8     xx0(3),xx(3),x1(3),x2(3)
       REAL*8     stop_alt
       INTEGER*4  hemi_flag
       REAL*8     B(3),Bl,B0,B1,B3
       REAL*8     dsreb
       
       REAL*8     XFOOT(3),BFOOT(3),BFOOTMAG

       INTEGER*4  I,J
       REAL*8     Lb
C      IFOUND is a dummy loop result variable
       integer*4  IFOUND
C
C
       CALL GEO_SM(xx0,xx)
       rr = SQRT(xx(1)*xx(1)+xx(2)*xx(2)+xx(3)*xx(3))
       tt = ACOS(xx(3)/rr)
       Lb  = rr/SIN(tt)/SIN(tt)
c       write(6,*)'L bete ',Lb
C
       CALL CHAMP(xx0,B,B0,Ifail)
       IF (Ifail.LT.0) THEN
          goto 999
       ENDIF

       !geo_gdz provides lat/lon/alt at x2
       call geo_gdz(xx0(1),xx0(2),xx0(3),XFOOT(2),XFOOT(3),XFOOT(1))
       if (XFOOT(1).LE.stop_alt) then
            goto 999 ! fail altitude of starting point to low
       endif


       XFOOT(1) = baddata
       XFOOT(2) = baddata
       XFOOT(3) = baddata
       BFOOT(1) = baddata
       BFOOT(2) = baddata
       BFOOT(3) = baddata
       BFOOTMAG = baddata

       dsreb = Lb/(Nreb*1.d0) ! step size

        ! introduced to prevent overshooting
        ! where one may end up in the opposite hemisphere
        ! Kellerman / Tenfjord
       if (dsreb.GT.1) THEN
        dsreb = 1
       ENDIF

C calcul du sens du depart 
C sksyst call takes southward step
       CALL sksyst(-dsreb,xx0,x1,Bl,Ifail)
       IF (Ifail.LT.0) THEN
          goto 999
       ENDIF
       B1 = Bl
C sksyst call takes northward step
       CALL sksyst(dsreb,xx0,x2,Bl,Ifail)
       IF (Ifail.LT.0) THEN
          goto 999
       ENDIF
       B3 = Bl
C

c     dsreb is currently pointing north
       if (hemi_flag.eq.-1) then
          dsreb = -dsreb ! point dsreb south
       endif
       if (hemi_flag.eq.0) then
          IF (B1.GT.B3) THEN
             dsreb = -dsreb     ! point dsreb toward larger field (same hemi)
          ENDIF
       endif
       if (hemi_flag.eq.2) then
          IF (B1.LT.B3) THEN
             dsreb = -dsreb     ! point dsreb toward smaller field (toward other hemi)
          ENDIF
       endif

C
C calcul de la ligne de champ
C
       DO I = 1,3
         x1(I)  = xx0(I)
       ENDDO
C
       Bl = B0 ! reset to starting value
15     continue ! prepare to do loop
       IFOUND = 0
       DO J = 1,500
         B1 = Bl ! store for comparison after step
         CALL sksyst(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) THEN
            goto 999
         ENDIF
c
c test for completion
c need to check: alt < stop_alt, and moving to lower alt (higher B)
         ! geo_gdz provides lat/lon/alt at x2
         call geo_gdz(x2(1),x2(2),x2(3),XFOOT(2),XFOOT(3),XFOOT(1))
         if (XFOOT(1).LE.stop_alt) then
            IFOUND = 1
            goto 20 ! done with loop
         endif
	 x1(1) = x2(1)
	 x1(2) = x2(2)
	 x1(3) = x2(3)
       ENDDO
20     CONTINUE
C

       if (IFOUND.EQ.1) then
          ! footpoint is between x1 and x2
          if (abs(XFOOT(1)-stop_alt).le.1.0) then
             !get B field at x2
             call champ(x2,BFOOT,BFOOTMAG,Ifail)
             if (Ifail.LT.0) then
                goto 999
             endif
             return
          else  ! try loop again with smaller step
             dsreb = dsreb/100.0
             goto 15
          endif
       else
          goto 999
       endif
C
100    CONTINUE
C
       RETURN
 999   CONTINUE  ! fail!
       XFOOT(1) = baddata
       XFOOT(2) = baddata
       XFOOT(3) = baddata
       BFOOT(1) = baddata
       BFOOT(2) = baddata
       BFOOT(3) = baddata
       BFOOTMAG = baddata
       RETURN
       END
C

!***************************************************************************************************
! Copyright 2004, 2008 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C-----------------------------------------------------------------------------
C Wrappers and procedures for ONERA_DESP_LIB
C-----------------------------------------------------------------------------


c function returns version of fortran source code
      SUBROUTINE IRBEM_FORTRAN_VERSION1(VERSN)
        INCLUDE 'fortran_version.inc' ! include file created by make
        INTEGER*4 VERSN
        VERSN = FORTRAN_VERSION
      END


c function returns release of fortran source code
      SUBROUTINE IRBEM_FORTRAN_RELEASE1(RLS)
        INCLUDE 'fortran_release.inc'
        CHARACTER*80 RLS
        RLS = FORTRAN_RELEASE
      END


c function returns maximum size of variables
      SUBROUTINE GET_IRBEM_NTIME_MAX1(ntime_max1)
        INCLUDE 'ntime_max.inc' ! include file created by make
        INTEGER*4 ntime_max1
        ntime_max1 = ntime_max
      END
c
c --------------------------------------------------------------------
c
        SUBROUTINE make_lstar1(ntime,kext,options,sysaxes,iyearsat,
     &  idoy,UT,xIN1,xIN2,xIN3,maginput,Lm,Lstar,BLOCAL,BMIN,XJ,MLT)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
      INCLUDE 'ntime_max.inc'
C
c declare inputs
        INTEGER*4    kext,k_ext,k_l,options(5)
        INTEGER*4    ntime,sysaxes
      INTEGER*4    iyearsat(ntime_max)
      integer*4    idoy(ntime_max)
      real*8     UT(ntime_max)
      real*8     xIN1(ntime_max),xIN2(ntime_max),xIN3(ntime_max)
      real*8     maginput(25,ntime_max)
c
c Declare internal variables
      INTEGER*4    isat,iyear,kint,ifail
        INTEGER*4    t_resol,r_resol,Ilflag,Ilflag_old
      REAL*8     mlon,mlon1
      REAL*8     xGEO(3),xMAG(3),xSUN(3),rM,MLAT
      real*8     alti,lati,longi
c
c Declare output variables
        REAL*8     BLOCAL(ntime_max),BMIN(ntime_max),XJ(ntime_max)
      REAL*8     MLT(ntime_max)
        REAL*8     Lm(ntime_max),Lstar(ntime_max)
C
      COMMON /magmod/k_ext,k_l,kint
        COMMON /flag_L/Ilflag
        DATA  xSUN /1.d0,0.d0,0.d0/
      integer*4 int_field_select, ext_field_select
C
      Ilflag=0
      Ilflag_old=Ilflag
      if (options(3).lt.0 .or. options(3).gt.9) options(3)=0
      t_resol=options(3)+1
      r_resol=options(4)+1
      k_l=options(1)

      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
      CALL INITIZE
      if (k_ext .eq. 13 .or. k_ext .eq. 14) then !TS07D tail par init, only need it once
          call INIT_TS07D_TLPR
      end if

      DO isat = 1,ntime

          call init_fields ( kint, iyearsat(isat), idoy(isat),
     6          ut(isat), options(2) )

          call get_coordinates ( sysaxes,
     6        xIN1(isat), xIN2(isat), xIN3(isat),
     6        alti, lati, longi, xGEO )

        if (xIN1(isat) .eq. baddata .and. xIN2(isat) .eq. baddata
     &  .and. xIN3(isat) .eq.baddata) then
           Lm(isat)=baddata
           Lstar(isat)=baddata
           XJ(isat)=baddata
           BLOCAL(isat)=baddata
           BMIN(isat)=baddata
           GOTO 99
        endif

          call set_magfield_inputs ( k_ext, maginput(1,isat), ifail )

        if (k_ext .eq. 13 .or. k_ext .eq. 14) then !TS07D coeff init
            call INIT_TS07D_COEFFS(iyearsat(isat),idoy(isat),
     &      ut(isat),ifail)
        end if

c        if (alti .le. 50.) ifail=-10 ! removed by TPO, 5/31/2011 - why would we force fail for alt<50km?
          if ( ifail.lt.0 ) then
                Lm(isat)=baddata
              Lstar(isat)=baddata
              XJ(isat)=baddata
              BLOCAL(isat)=baddata
              BMIN(isat)=baddata
              GOTO 99
             endif
c
           CALL calcul_Lstar_opt(t_resol,r_resol,XGeo
     &     ,Lm(isat),Lstar(isat),XJ(isat),BLOCAL(isat),BMIN(isat))
           if (Ilflag_old .eq.1 .and. Lstar(isat).eq. Baddata) then
            Ilflag=0
              CALL calcul_Lstar_opt(t_resol,r_resol,xGeo
     &        ,Lm(isat),Lstar(isat),XJ(isat),BLOCAL(isat),BMIN(isat))
         endif
         Ilflag_old=Ilflag

99         continue

        if (ifail .eq. -10) then
          MLT(isat) = baddata
        else
           CALL GDZ_GEO(lati,longi,alti
     &     ,xGEO(1),xGEO(2),xGEO(3))
           CALL geo_mag(xGEO,xMAG)
           CALL car_sph(xMAG,rM,MLAT,Mlon1)
           CALL GSM_GEO(xSUN,xGEO)
           CALL geo_mag(xGEO,xMAG)
           CALL car_sph(xMAG,rM,MLAT,Mlon)
           MLT(isat) = (Mlon1 - Mlon)/15.d0 + 12.d0
           IF (MLT(isat).GE.24.d0) MLT(isat) = MLT(isat) - 24.d0
           IF (MLT(isat).LT.0.d0) MLT(isat) = MLT(isat) + 24.d0
        endif
      ENDDO

      END
c
c --------------------------------------------------------------------
c
        SUBROUTINE make_lstar_shell_splitting1(ntime,Nipa,kext,options,
     & sysaxes,iyearsat,idoy,UT,xIN1,xIN2,xIN3,
     &  alpha,maginput,Lm,Lstar,BLOCAL,BMIN,XJ,MLT)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
        INCLUDE 'ntime_max.inc'
C
c declare inputs
        INTEGER*4    kext,k_ext,k_l,options(5),Nalp,Nipa
      PARAMETER (Nalp=25)
        INTEGER*4    ntime,sysaxes
      INTEGER*4    iyearsat(ntime_max)
      integer*4    idoy(ntime_max)
      real*8     UT(ntime_max)
      real*8     xIN1(ntime_max),xIN2(ntime_max),xIN3(ntime_max)
      real*8     alpha(Nalp)
      real*8     maginput(25,ntime_max)
c
c
c Declare internal variables
      INTEGER*4    isat,iyear,IPA,kint,ifail
        INTEGER*4    Ilflag,t_resol,r_resol
      REAL*8     mlon,mlon1,BL,BMIR(25),Bmin_tmp
      REAL*8     xGEO(3),xMAG(3),xSUN(3),rM,MLAT
      REAL*8     xGEOp(3,25)
      real*8     alti,lati,longi
c
c Declare output variables
        REAL*8     BLOCAL(ntime_max,Nalp),BMIN(ntime_max)
      REAL*8     XJ(ntime_max,Nalp),MLT(ntime_max)
        REAL*8     Lm(ntime_max,Nalp),Lstar(ntime_max,Nalp)
C
      COMMON /magmod/k_ext,k_l,kint
        COMMON /flag_L/Ilflag
        DATA  xSUN /1.d0,0.d0,0.d0/
      integer*4 int_field_select, ext_field_select
C
      Ilflag=0
      k_ext=kext
      if (options(3).lt.0 .or. options(3).gt.9) options(3)=0
      t_resol=options(3)+1
      r_resol=options(4)+1
      k_l=options(1)

      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
        CALL INITIZE
        if (k_ext .eq. 13 .or. k_ext .eq. 14) then !TS07D tail par init, only need it once
            call INIT_TS07D_TLPR
        end if

       DO isat = 1,ntime
        call init_fields ( kint, iyearsat(isat), idoy(isat),
     6      ut(isat), options(2) )

          call get_coordinates ( sysaxes,
     6        xIN1(isat), xIN2(isat), xIN3(isat),
     6        alti, lati, longi, xGEO )

        call set_magfield_inputs ( k_ext, maginput(1,isat), ifail )

       if (k_ext .eq. 13 .or. k_ext .eq. 14) then 
            call INIT_TS07D_COEFFS(iyearsat(isat),idoy(isat),
     &      ut(isat),ifail)
       end if


        if ( ifail.lt.0 ) then
          DO IPA=1,Nipa
                Lm(isat,IPA)=baddata
                Lstar(isat,IPA)=baddata
                XJ(isat,IPA)=baddata
                BLOCAL(isat,IPA)=baddata
            ENDDO
            BMIN(isat)=baddata
            GOTO 99
          endif
c
c Compute Bmin assuming 90deg PA at S/C
         k_l=0
           IPA=1
           CALL calcul_Lstar_opt(t_resol,r_resol,xGEO
     &         ,Lm(isat,IPA),Lstar(isat,IPA),XJ(isat,IPA)
     &         ,BLOCAL(isat,IPA),BMIN(isat))
         k_l=options(1)
           CALL find_bm_nalpha(xGEO,nipa,alpha,BL,BMIR,xGEOp)
           DO IPA=1,Nipa
           IF (Bmir(ipa).NE.baddata) THEN
             Ilflag=0
               CALL calcul_Lstar_opt(t_resol,r_resol,xGEOp(1,ipa)
     &         ,Lm(isat,IPA),Lstar(isat,IPA),XJ(isat,IPA)
     &         ,BLOCAL(isat,IPA),BMIN_tmp)
             ELSE
             Lm(isat,IPA)=baddata
             Lstar(isat,IPA)=baddata
             XJ(isat,IPA)=baddata
             BLOCAL(isat,IPA)=baddata
           ENDIF
           ENDDO

99         continue

           CALL geo_mag(xGEO,xMAG)
           CALL car_sph(xMAG,rM,MLAT,Mlon1)
           CALL GSM_GEO(xSUN,xGEO)
           CALL geo_mag(xGEO,xMAG)
           CALL car_sph(xMAG,rM,MLAT,Mlon)
           MLT(isat) = (Mlon1 - Mlon)/15.d0 + 12.d0
           IF (MLT(isat).GE.24.d0) MLT(isat) = MLT(isat) - 24.d0
           IF (MLT(isat).LT.0.d0) MLT(isat) = MLT(isat) + 24.d0

      ENDDO

      END
c
C-----------------------------------------------------------------------------
c
        SUBROUTINE Lstar_Phi1(ntime,whichinv,options,iyearsat,
     &  idoy,Lstar,Phi)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
        INCLUDE 'ntime_max.inc'
C
c declare inputs
        INTEGER*4    whichinv,options(5)
        INTEGER*4    ntime
      INTEGER*4    iyearsat(ntime_max)
      integer*4    idoy(ntime_max)
c
c Declare internal variables
      INTEGER*4    isat,kint
        REAL*8     Bo,xc,yc,zc,ct,st,cp,sp
c
c Declare output variables
        REAL*8     Phi(ntime_max),Lstar(ntime_max)
C
        COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
        REAL*8     pi,rad
        common /rconst/rad,pi
      integer*4 int_field_select, ext_field_select
C

      kint = int_field_select ( options(5) )
c
        CALL INITIZE

        DO isat = 1,ntime
          call init_fields ( kint, iyearsat(isat),idoy(isat),-1.D0,
     6      options(2) )

         if (whichinv .EQ. 1) then !Lstar to Phi
            if (Lstar(isat) .NE. baddata) then
               Phi(isat)=2.D0*pi*Bo/Lstar(isat)
            else
               Phi(isat)=baddata
            endif
         else
            if (phi(isat) .NE. baddata) then
               Lstar(isat)=2.D0*pi*Bo/Phi(isat)
            else
               Lstar(isat)=baddata
            endif
         endif
      enddo
      end
c
c --------------------------------------------------------------------
c
        SUBROUTINE drift_shell1(kext,options,sysaxes,iyearsat,idoy,UT,
     &  xIN1,xIN2,xIN3,maginput,Lm,Lstar,BLOCAL,BMIN,XJ,posit,ind)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C
c declare inputs
        INTEGER*4    kext,k_ext,k_l,options(5)
        INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT
      real*8     xIN1,xIN2,xIN3
      real*8     maginput(25)
c
c Declare internal variables
      INTEGER*4    isat,iyear,kint,ifail
      REAL*8     xGEO(3)
      real*8     alti,lati,longi
c
c Declare output variables
        INTEGER*4  ind(48)
        REAL*8     BLOCAL(1000,48),BMIN,XJ
        REAL*8     Lm,Lstar
      REAL*8     posit(3,1000,48)
C
      COMMON /magmod/k_ext,k_l,kint
      integer*4 int_field_select, ext_field_select
C
      k_l=options(1)
c
      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
        CALL INITIZE

      call init_fields ( kint, iyearsat, idoy, ut, options(2) )

      call get_coordinates ( sysaxes, xIN1, xIN2, xIN3,
     6    alti, lati, longi, xGEO )

      call set_magfield_inputs ( k_ext, maginput, ifail )

        if (k_ext .eq. 13 .or. k_ext .eq. 14) then
            call INIT_TS07D_TLPR
            call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
       end if

      if ( ifail.lt.0 ) then
             Lm=baddata
             Lstar=baddata
             XJ=baddata
             BMIN=baddata
             RETURN
          endif
c
        CALL trace_drift_shell_opt(xGeo
     &     ,Lm,Lstar,XJ,BLOCAL,BMIN,
     &     posit,ind)
      END

c --------------------------------------------------------------------
c
        SUBROUTINE trace_field_line1(kext,options,sysaxes,iyearsat,
     &  idoy,UT,xIN1,xIN2,xIN3,maginput,
     &  Lm,BLOCAL,BMIN,XJ,posit,ind)
        IMPLICIT NONE
        INTEGER*4 kext,options(5),sysaxes,iyearsat,idoy
        REAL*8 UT,xIN1,xIN2,xIN3,maginput(25),R0
        REAL*8 Lm,BLOCAL(3000),BMIN,XJ,posit(3,3000)
        INTEGER*4 ind

        R0=1.D0
        call trace_field_line2_1(kext,options,sysaxes,iyearsat,idoy,
     &  UT,xIN1,xIN2,xIN3,maginput,R0,
     &  Lm,BLOCAL,BMIN,XJ,posit,ind)
        end

        SUBROUTINE trace_field_line2_1(kext,options,sysaxes,iyearsat,
     &  idoy,UT,xIN1,xIN2,xIN3,maginput,R0,
     &  Lm,BLOCAL,BMIN,XJ,posit,ind)
C - added R0 argument - radius of reference sphere
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C
c declare inputs
        INTEGER*4    kext,k_ext,k_l,kint,options(5)
        INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT
      real*8     xIN1,xIN2,xIN3
      real*8     maginput(25)
        real*8     R0
c
c Declare internal variables
      INTEGER*4    isat,iyear,ifail
        INTEGER*4    i,j
      REAL*8     xGEO(3)
      real*8     alti,lati,longi
c
c Declare output variables
        INTEGER*4  ind
        REAL*8     BLOCAL(3000),BMIN,XJ
        REAL*8     Lm
      REAL*8     posit(3,3000)
C
      COMMON /magmod/k_ext,k_l,kint
      integer*4 int_field_select, ext_field_select
C
        do i=1,3
         do j=1,3000
           posit(i,j)=baddata
         enddo
      enddo
c
      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
        CALL INITIZE

      call init_fields ( kint, iyearsat, idoy, ut, options(2) )

      call get_coordinates ( sysaxes, xIN1, xIN2, xIN3,
     6    alti, lati, longi, xGEO )

      call set_magfield_inputs ( k_ext, maginput, ifail )
        if (k_ext .eq. 13 .or. k_ext .eq. 14) then
            call INIT_TS07D_TLPR
            call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
        end if

      if ( ifail.lt.0 ) then
              Lm=baddata
             XJ=baddata
             BMIN=baddata
             ind=0
             RETURN
          endif
c
        CALL field_line_tracing_opt2(xGeo,R0
     &     ,Lm,XJ,BLOCAL,BMIN,posit,ind)
      END
c
c --------------------------------------------------------------------
c
      SUBROUTINE trace_field_line_towards_earth1(kext,options,sysaxes
     &  ,iyearsat,idoy,UT,xIN1,xIN2,xIN3,maginput,ds,posit,ind)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C
c declare inputs
      INTEGER*4    kext,k_ext,k_l,kint,options(5)
      INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT,ds
      real*8     xIN1,xIN2,xIN3
      real*8     maginput(25)
c
c Declare internal variables
      INTEGER*4    isat,iyear
      INTEGER*4    Ndays,activ,i,j
      REAL*8     xGEO(3)
      real*8     alti,lati,longi
c
c Declare output variables
      INTEGER*4  ind, ifail
      REAL*8     posit(3,3000)
      integer*4 int_field_select, ext_field_select
C
C
      do i=1,3
        do j=1,3000
          posit(i,j)=baddata
        enddo
      enddo
c
      k_ext=kext
      k_l=options(1)
      kint=options(5)

      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
        CALL INITIZE

      call init_fields ( kint, iyearsat, idoy, ut, options(2) )

      call get_coordinates ( sysaxes, xIN1, xIN2, xIN3,
     6    alti, lati, longi, xGEO )

      call set_magfield_inputs ( k_ext, maginput, ifail )

      if (k_ext .eq. 13 .or. k_ext .eq. 14) then
        call INIT_TS07D_TLPR
        call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
      end if

      if ( ifail.lt.0 ) then
             ind=0
             RETURN
          endif
c
        CALL field_line_tracing_towards_Earth_opt(xGEO,ds,posit,ind)
      END

c --------------------------------------------------------------------
c
        SUBROUTINE find_mirror_point1(kext,options,sysaxes,iyearsat,
     &  idoy,UT,xIN1,xIN2,xIN3,alpha,maginput,BLOCAL,BMIR,xGEO)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C
c declare inputs
        INTEGER*4    kext,k_ext,k_l,kint,options(5)
        INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT
      real*8     xIN1,xIN2,xIN3
      real*8     alpha
      real*8     maginput(25)
c
c Declare internal variables
      INTEGER*4    isat,iyear,Iint,ifail
      REAL*8     xMAG(3)
      real*8     alti,lati,longi
      real*8     BxGEO(3),xGeop(3,25),myalpha(25)
      real*8     MyBmir(25)
c
c Declare output variables
        REAL*8     BLOCAL,xGEO(3),BMIR
C
      COMMON /magmod/k_ext,k_l,kint
      integer*4 int_field_select, ext_field_select
C
      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
        CALL INITIZE

      call init_fields ( kint, iyearsat, idoy, ut, options(2) )

      call get_coordinates ( sysaxes, xIN1, xIN2, xIN3,
     6    alti, lati, longi, xGEO )

      call set_magfield_inputs ( k_ext, maginput, ifail )

        if (k_ext .eq. 13 .or. k_ext .eq. 14) then
            call INIT_TS07D_TLPR
            call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
        end if

      if ( ifail.lt.0 ) then
             xGEO(1)=baddata
             xGEO(2)=baddata
             xGEO(3)=baddata
             BLOCAL=baddata
             BMIR=baddata
             RETURN
          endif
c
        if (alpha.eq.90.0d0) then
          Iint=2 ! TPO: presume this sets internal field?
c          CALL CHAMP(Iint,xGEO,BxGEO,Blocal,Ifail) ! Iint is superfluous
          CALL CHAMP(xGEO,BxGEO,Blocal,Ifail)
        IF (Ifail.LT.0) THEN
          Blocal=baddata
          Bmir=baddata
          xGEO(1)=baddata
          xGEO(2)=baddata
          xGEO(3)=baddata
        ELSE
          BMIR=Blocal
        ENDIF
        RETURN
      endif
c
       myalpha(1)=alpha
        CALL find_bm_nalpha(xGeo,1,myalpha
     &     ,BLOCAL,myBMIR,xGEOp)
        xGEO(1)=xGeop(1,1)
        xGEO(2)=xGeop(2,1)
        xGEO(3)=xGeop(3,1)
        Bmir=MyBmir(1)
      END



c --------------------------------------------------------------------
c
        SUBROUTINE FIND_MAGEQUATOR1(kext,options,sysaxes,iyearsat
     &  ,idoy,UT,xIN1,xIN2,xIN3,maginput,BMIN,posit)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C
c declare inputs
        INTEGER*4    kext,k_ext,k_l,kint,options(5)
        INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT
      real*8     xIN1,xIN2,xIN3
      real*8     maginput(25)
c
c Declare internal variables
      INTEGER*4    isat,iyear,ifail
      REAL*8     xGEO(3)
      real*8     alti,lati,longi
c
c Declare output variables
        REAL*8     BMIN
      REAL*8     posit(3)
C
      COMMON /magmod/k_ext,k_l,kint
      integer*4 int_field_select, ext_field_select
C
      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
        CALL INITIZE

      call init_fields ( kint, iyearsat, idoy, ut, options(2) )

      call get_coordinates ( sysaxes, xIN1, xIN2, xIN3,
     6    alti, lati, longi, xGEO )

      call set_magfield_inputs ( k_ext, maginput, ifail )

        if (k_ext .eq. 13 .or. k_ext .eq. 14) then
            call INIT_TS07D_TLPR
            call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
        end if

      if ( ifail.lt.0 ) then
             posit(1)=baddata
             posit(2)=baddata
             posit(3)=baddata
             BMIN=baddata
             RETURN
          endif
c
c
        CALL loc_equator_opt(xGeo,BMIN,posit)
      END
c --------------------------------------------------------------------
c
      SUBROUTINE GET_FIELD1(kext,options,sysaxes,iyearsat,idoy,UT,
     &     xIN1,xIN2,xIN3,maginput,BxGEO,Bl)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C
c     declare inputs
      INTEGER*4    kext,k_ext,k_l,kint,options(5)
      INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT
      real*8     xIN1,xIN2,xIN3
      real*8     maginput(25)
c
c     Declare internal variables
      INTEGER*4    isat,iyear,ifail
      REAL*8     xGEO(3)
      real*8     alti,lati,longi
c
c     Declare output variables
      REAL*8     BxGEO(3),Bl
C
      COMMON /magmod/k_ext,k_l,kint
      integer*4 int_field_select, ext_field_select
C
      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c

      CALL INITIZE

      call init_fields ( kint, iyearsat, idoy, ut, options(2) )

      call get_coordinates ( sysaxes, xIN1, xIN2, xIN3,
     6     alti, lati, longi, xGEO )

      call set_magfield_inputs ( k_ext, maginput, ifail )

        if (k_ext .eq. 13 .or. k_ext .eq. 14) then !special script to read files and
            call INIT_TS07D_TLPR
            call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
        end if

      if ( ifail.lt.0 ) then
         Bl=baddata
         BxGEO(1)=baddata
         BxGEO(2)=baddata
         BxGEO(3)=baddata
         RETURN
      endif
c
      CALL CHAMP(xGEO,BxGEO,Bl,Ifail)
      IF (Ifail.LT.0) THEN
         BxGEO(1)=baddata
         BxGEO(2)=baddata
         BxGEO(3)=baddata
         Bl=baddata
      ENDIF
      END
C-----------------------------------------------------------------------------

      SUBROUTINE GET_FIELD_MULTI(ntime,kext,options,sysaxes,iyearsat,
     &     idoy,UT,xIN1,xIN2,xIN3,maginput,BxGEO,Bl)
C     Call get_field1 many times (ntime, in fact, up to ntime = ntime_max)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
      INCLUDE 'ntime_max.inc'   ! include file created by make, defines ntime_max
C
c     declare inputs
      INTEGER*4    ntime
      INTEGER*4    kext,options(5)
      INTEGER*4    sysaxes
      INTEGER*4    iyearsat(ntime_max)
      integer*4    idoy(ntime_max)
      real*8     UT(ntime_max)
      real*8     xIN1(ntime_max),xIN2(ntime_max),xIN3(ntime_max)
      real*8     maginput(25,ntime_max)

c     Declare output variables
      REAL*8     BxGEO(3,ntime_max),Bl(ntime_max)
C
c     Declare internal variables
      integer*4 isat
      INTEGER*4 k_ext,k_l,kint,ifail

c    For now we call this every time
c   TODO: create a load flag so that we skip repetative loads
c      if (kext.eq.13) then
c            call INIT_TS07D_TLPR
c      endif

      do isat = 1,ntime
         call GET_FIELD1(kext,options,sysaxes,iyearsat(isat),
     &        idoy(isat),UT(isat), xIN1(isat),xIN2(isat),
     &        xIN3(isat),maginput(1,isat),BxGEO(1,isat),Bl(isat))

      enddo
      end
c
c --------------------------------------------------------------------
c
        SUBROUTINE GET_MLT1(iyr,idoy,UT,xGEO,MLT)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C
c declare inputs
      INTEGER*4    iyr
      integer*4    idoy
      real*8     UT
      real*8     xGEO(3)
c
c Declare internal variables
        REAL*8     dyear
      REAL*8     psi,mlon
      REAL*8     xMAG(3),xSUN(3),rM,MLAT,Mlon1
      REAL*8     xTMP(3)
c
c Declare output variables
        REAL*8     MLT
C
        DATA  xSUN /1.d0,0.d0,0.d0/
C
      dyear=iyr+0.5d0
        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,ut,psi)
C
        CALL geo_mag(xGEO,xMAG)
        CALL car_sph(xMAG,rM,MLAT,Mlon1)
        CALL GSM_GEO(xSUN,xTMP)
        CALL geo_mag(xTMP,xMAG)
        CALL car_sph(xMAG,rM,MLAT,Mlon)
        MLT = (Mlon1 - Mlon)/15.d0 + 12.d0
        IF (MLT.GE.24.d0) MLT = MLT - 24.d0
        IF (MLT.LT.0.d0) MLT = MLT + 24.d0

        END
C-----------------------------------------------------------------------------
c
      integer*4 function int_field_select ( kint )
      integer*4 kint

      !write(6,*)kint
      IF (kint .lt. 0) THEN
         kint=0
         WRITE(6,*)
         WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(6,*)'Invalid internal field specification'
         WRITE(6,*)'Selecting IGRF'
         WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(6,*)
      ENDIF
      if (kint .gt. 5) THEN
         kint=0
         WRITE(6,*)
         WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(6,*)'Invalid internal field specification'
         WRITE(6,*)'Selecting IGRF'
         WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(6,*)
      ENDIF

      int_field_select = kint

      return
      end

      integer*4 function ext_field_select ( kext )

        integer*4 kext

      IF (kext .lt. 0) THEN
         k_ext=5
         WRITE(6,*)
         WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(6,*)'Invalid external field specification'
         WRITE(6,*)'Selecting Olson-Pfitzer (quiet)'
         WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(6,*)
      ENDIF
      if (kext .gt. 14) THEN
         k_ext=5
         WRITE(6,*)
         WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(6,*)'Invalid external field specification'
         WRITE(6,*)'Selecting Olson-Pfitzer (quiet)'
         WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(6,*)
      ENDIF

      ext_field_select = kext

      return
      end


      subroutine init_fields ( kint, iyearsat, idoy, ut, opt2 )
      INTEGER*4    firstJanuary,lastDecember,Julday,currentdoy
      INTEGER*4    kint,opt2,iyearsat,iyear
      integer*4    idoy
      real*8     UT,dec_year
      REAL*8 tilt,psi
      INTEGER*4    a2000_iyear,a2000_imonth,a2000_iday
      REAL*8      a2000_ut
      COMMON /dip_ang/tilt
      REAL*8     pi,rad

      common /rconst/rad,pi
      COMMON /a2000_time/a2000_ut,a2000_iyear,a2000_imonth,a2000_iday

      iyear = 1800

      if (kint .eq. 2) CALL JensenANDCain1960
      if (kint .eq. 3) CALL GSFC1266
c         write(6,*)real(isat)*100./real(ntime), '% done'
c
      if (kint .le. 1 .or. kint .eq. 4 .or. kint .eq. 5) then
        if (opt2 .eq. 0) then
          if (iyearsat .ne. iyear) then
            iyear=iyearsat
            dec_year=iyear+0.5d0
            if (Kint .eq. 4) then
              call myOwnMagField_init(dec_year)
            else
              CALL INIT_DTD(dec_year)
            endif
            if (kint .eq. 5) CALL INIT_CD
          endif
        else
          if (iyearsat .ne. iyear .or.
     &          MOD(idoy*1.d0,opt2*1.d0) .eq. 0) THEN
            iyear=iyearsat
            firstJanuary=JULDAY(iyear,01,01)
            lastDecember=JULDAY(iyear,12,31)
            currentdoy=(idoy/opt2)*opt2
            if (currentdoy .eq. 0) currentdoy=1
            dec_year=iyear+currentdoy*1.d0/
     &             ((lastDecember-firstJanuary+1)*1.d0)
            if (Kint .eq. 4) then
              call myOwnMagField_init(dec_year)
            else
              CALL INIT_DTD(dec_year)
            endif
          endif
        endif
      endif
c
      if ( ut.ge.0.0 ) CALL INIT_GSM(iyearsat,idoy,UT,psi)
      tilt = psi/rad

      a2000_iyear=iyearsat
      firstJanuary=JULDAY(a2000_iyear,01,01)
      currentdoy=firstJanuary+idoy-1
      CALL CALDAT(currentdoy,a2000_iyear,a2000_imonth,a2000_iday)
      a2000_ut=UT

      return
      end

      subroutine get_coordinates ( sysaxes, xIN1, xIN2, xIN3,
     6    alti, lati, longi, xGEO )

      integer*4 sysaxes
      real*8 xIN1, xIN2, xIN3
      real*8 alti, lati, longi, xGEO(3)
      real*8 xGSM(3), xGSE(3), xSM(3), xGEI(3), xMAG(3)

         if (sysaxes .EQ. 0) then
             alti=xIN1
             lati=xIN2
             longi=xIN3
               CALL GDZ_GEO(lati,longi,alti,xGEO(1),xGEO(2),xGEO(3))
         endif
         if (sysaxes .EQ. 1) then
             xGEO(1)=xIN1
             xGEO(2)=xIN2
             xGEO(3)=xIN3
             CALL GEO_GDZ(xGEO(1),xGEO(2),xGEO(3),lati,longi,alti)
         endif
         if (sysaxes .EQ. 2) then
             xGSM(1)=xIN1
             xGSM(2)=xIN2
             xGSM(3)=xIN3
             CALL GSM_GEO(xGSM,xGEO)
             CALL GEO_GDZ(xGEO(1),xGEO(2),xGEO(3),lati,longi,alti)
         endif
         if (sysaxes .EQ. 3) then
             xGSE(1)=xIN1
             xGSE(2)=xIN2
             xGSE(3)=xIN3
             CALL GSE_GEO(xGSE,xGEO)
             CALL GEO_GDZ(xGEO(1),xGEO(2),xGEO(3),lati,longi,alti)
         endif
         if (sysaxes .EQ. 4) then
             xSM(1)=xIN1
             xSM(2)=xIN2
             xSM(3)=xIN3
             CALL SM_GEO(xSM,xGEO)
             CALL GEO_GDZ(xGEO(1),xGEO(2),xGEO(3),lati,longi,alti)
         endif
         if (sysaxes .EQ. 5) then
             xGEI(1)=xIN1
             xGEI(2)=xIN2
             xGEI(3)=xIN3
             CALL GEI_GEO(xGEI,xGEO)
             CALL GEO_GDZ(xGEO(1),xGEO(2),xGEO(3),lati,longi,alti)
         endif
         if (sysaxes .EQ. 6) then
             xMAG(1)=xIN1
             xMAG(2)=xIN2
             xMAG(3)=xIN3
             CALL MAG_GEO(xMAG,xGEO)
             CALL GEO_GDZ(xGEO(1),xGEO(2),xGEO(3),lati,longi,alti)
         endif
         if (sysaxes .EQ. 7) then
             xMAG(1)=xIN1
             xMAG(2)=xIN2
             xMAG(3)=xIN3
             CALL SPH_CAR(xMAG(1),xMAG(2),xMAG(3),xGEO)
             CALL GEO_GDZ(xGEO(1),xGEO(2),xGEO(3),lati,longi,alti)
         endif
         if (sysaxes .EQ. 8) then
             xMAG(1)=xIN1
             lati=xIN2
             longi=xIN3
             CALL RLL_GDZ(xMAG(1),lati,longi,alti)
             CALL GDZ_GEO(lati,longi,alti,xGEO(1),xGEO(2),xGEO(3))
         endif

         return
         end

       subroutine set_magfield_inputs ( kext, maginput, ifail )
      INCLUDE 'variables.inc'
      COMMON /index/activ
      integer*4 activ
      COMMON /drivers/density,speed,dst_nt,Pdyn_nPa,BxIMF_nt,ByIMF_nt
     &       ,BzIMF_nt,G1_tsy01,G2_tsy01,fkp,G3_tsy01,W1_tsy04,W2_tsy04
     &       ,W3_tsy04,W4_tsy04,W5_tsy04,W6_tsy04,Al
      real*8  density,speed,dst_nt,Pdyn_nPa,BxIMF_nt,ByIMF_nt,BzIMF_nt
      real*8  G1_tsy01,G2_tsy01,fkp,G3_tsy01,W1_tsy04,W2_tsy04
      real*8  W3_tsy04,W4_tsy04,W5_tsy04,W6_tsy04,Al

       integer*4 kext, ifail
       real*8 maginput(25)
c                      1: Kp
c                      2: Dst
c                      3: dens
c                      4: velo
c                      5: Pdyn
c                      6: ByIMF
c                      7: BzIMF
c                      8: G1
c                      9: G2
c                     10: G3
c
c make inputs according to magn. field model chosen
c
c     set fail flag 'on' by default
         ifail = -1
c     clear it if all tests for respective selection are ok
c
c            'none'
           if (kext .eq. 0) then
             ifail = 0
             return
         endif
c            'Olsen-Pfitzer' = default
           if (kext .eq. 5) then
             ifail = 0
             return
         endif

           if (kext .eq. 1) then
c Input for MEAD
           if (maginput(1).eq.baddata) return
             if (maginput(1).le.3.d0) Activ=1
             if (maginput(1).gt.3.d0 .and.
     &         maginput(1).lt.20.d0) Activ=2
             if (maginput(1).ge.20.d0 .and.
     &         maginput(1).lt.30.d0) Activ=3
             if (maginput(1).ge.30.d0) Activ=4
c
             if (maginput(1).lt.0.d0 .or.
     &         maginput(1).gt.90.d0) return
             ifail = 0
             return
         endif
           if (kext .eq. 2) then
c Input for TSYG87s
           if (maginput(1).eq.baddata) return
             if (maginput(1).lt.7.d0) Activ=1
             if (maginput(1).ge.7.d0 .and.
     &         maginput(1).lt.17.d0) Activ=2
             if (maginput(1).ge.17.d0 .and.
     &         maginput(1).lt.20.d0) Activ=3
             if (maginput(1).ge.20.d0 .and.
     &         maginput(1).lt.27.d0) Activ=4
             if (maginput(1).ge.27.d0 .and.
     &         maginput(1).lt.37.d0) Activ=5
             if (maginput(1).ge.37.d0 .and.
     &         maginput(1).lt.47.d0) Activ=6
             if (maginput(1).ge.47.d0) Activ=7
             if (maginput(1).ge.53.d0) Activ=8
c
             if (maginput(1).lt.0.d0 .or.
     &         maginput(1).gt.90.d0) return
             ifail = 0
             return
         endif
           if (kext .eq. 3) then
c Input for TSYG87l
           if (maginput(1).eq.baddata) return
             if (maginput(1).lt.7.d0) Activ=1
             if (maginput(1).ge.7.d0 .and.
     &         maginput(1).lt.17.d0) Activ=2
             if (maginput(1).ge.17.d0 .and.
     &         maginput(1).lt.27.d0) Activ=3
             if (maginput(1).ge.27.d0 .and.
     &         maginput(1).lt.37.d0) Activ=4
             if (maginput(1).ge.37.d0 .and.
     &         maginput(1).lt.47.d0) Activ=5
             if (maginput(1).ge.47.d0) Activ=6
c
             if (maginput(1).lt.0.d0 .or.
     &         maginput(1).gt.90.d0) return
             ifail = 0
             return
           endif
           if (kext .eq. 4) then
c Input for Tsy89
           if (maginput(1).eq.baddata) return
             if (maginput(1).lt.7.d0) Activ=1
             if (maginput(1).ge.7.d0 .and.
     &         maginput(1).lt.17.d0) Activ=2
             if (maginput(1).ge.17.d0 .and.
     &         maginput(1).lt.27.d0) Activ=3
             if (maginput(1).ge.27.d0 .and.
     &         maginput(1).lt.37.d0) Activ=4
             if (maginput(1).ge.37.d0 .and.
     &         maginput(1).lt.47.d0) Activ=5
             if (maginput(1).ge.47.d0 .and.
     &         maginput(1).lt.57.d0) Activ=6
             if (maginput(1).ge.57.d0) Activ=7
c
             if (maginput(1).lt.0.d0 .or.
     &         maginput(1).gt.90.d0) return
             ifail = 0
             return
          endif
           if (kext .eq. 6) then
c Input for OP dyn
           if (maginput(2).eq.baddata) return
           if (maginput(3).eq.baddata) return
           if (maginput(4).eq.baddata) return
               density=maginput(3)
             speed=maginput(4)
             dst_nt=maginput(2)
c
             if (dst_nt.lt.-100.d0 .or. dst_nt.gt.20.d0) return
             if (density.lt.5.d0 .or. density.gt.50.d0) return
             if (speed.lt.300.d0 .or. speed.gt.500.d0) return
             ifail = 0
             return
         endif
           if (kext .eq. 7) then
c Input for Tsy96
           if (maginput(2).eq.baddata) return
           if (maginput(5).eq.baddata) return
           if (maginput(6).eq.baddata) return
           if (maginput(7).eq.baddata) return
             dst_nt=maginput(2)
             Pdyn_nPa=maginput(5)
             ByIMF_nt=maginput(6)
             BzIMF_nt=maginput(7)
c
             if (dst_nt.lt.-100.d0 .or. dst_nt.gt.20.d0) return
             if (Pdyn_nPa.lt.0.5d0 .or. Pdyn_nPa.gt.10.d0) return
             if (ByIMF_nt.lt.-10.d0 .or. ByIMF_nt.gt.10.d0) return
             if (BzIMF_nt.lt.-10.d0 .or. BzIMF_nt.gt.10.d0) return
             ifail = 0
             return
         endif
           if (kext .eq. 8) then
c Input for Ostapenko97
           if (maginput(2).eq.baddata) return
           if (maginput(5).eq.baddata) return
           if (maginput(7).eq.baddata) return
             dst_nt=maginput(2)
             Pdyn_nPa=maginput(5)
             BzIMF_nt=maginput(7)
             fkp=maginput(1)*1.d0/10.d0
             ifail = 0
             return
         endif
           if (kext .eq. 9) then
c Input for Tsy01
           if (maginput(2).eq.baddata) return
           if (maginput(5).eq.baddata) return
           if (maginput(6).eq.baddata) return
           if (maginput(7).eq.baddata) return
           if (maginput(8).eq.baddata) return
           if (maginput(9).eq.baddata) return
             dst_nt=maginput(2)
             Pdyn_nPa=maginput(5)
             ByIMF_nt=maginput(6)
             BzIMF_nt=maginput(7)
             G1_tsy01=maginput(8)
             G2_tsy01=maginput(9)
c
             if (dst_nt.lt.-50.d0 .or. dst_nt.gt.20.d0) return
             if (Pdyn_nPa.lt.0.5d0 .or. Pdyn_nPa.gt.5.d0) return
             if (ByIMF_nt.lt.-5.d0 .or. ByIMF_nt.gt.5.d0) return
             if (BzIMF_nt.lt.-5.d0 .or. BzIMF_nt.gt.5.d0) return
             if (G1_tsy01.lt.0.d0 .or. G1_tsy01.gt.10.d0) return
             if (G2_tsy01.lt.0.d0 .or. G2_tsy01.gt.10.d0) return
             ifail = 0
             return
         endif
           if (kext .eq. 10) then
c Input for Tsy01 storm
           if (maginput(2).eq.baddata) return
           if (maginput(5).eq.baddata) return
           if (maginput(6).eq.baddata) return
           if (maginput(7).eq.baddata) return
           if (maginput(9).eq.baddata) return
           if (maginput(10).eq.baddata) return
             dst_nt=maginput(2)
             Pdyn_nPa=maginput(5)
             ByIMF_nt=maginput(6)
             BzIMF_nt=maginput(7)
             G2_tsy01=maginput(9)
             G3_tsy01=maginput(10)
             ifail = 0
             return
         endif
c
           if (kext .eq. 11) then
c Input for Tsy04 storm
           if (maginput(2).eq.baddata) return
           if (maginput(5).eq.baddata) return
           if (maginput(6).eq.baddata) return
           if (maginput(7).eq.baddata) return
           if (maginput(11).eq.baddata) return
           if (maginput(12).eq.baddata) return
           if (maginput(13).eq.baddata) return
           if (maginput(14).eq.baddata) return
           if (maginput(15).eq.baddata) return
           if (maginput(16).eq.baddata) return
             dst_nt=maginput(2)
             Pdyn_nPa=maginput(5)
             ByIMF_nt=maginput(6)
             BzIMF_nt=maginput(7)
             W1_tsy04=maginput(11)
             W2_tsy04=maginput(12)
             W3_tsy04=maginput(13)
             W4_tsy04=maginput(14)
             W5_tsy04=maginput(15)
             W6_tsy04=maginput(16)
             ifail = 0
             return
         endif
c
        if (kext .eq. 12) then
c Input for Alexeev 2000
           if (maginput(2).eq.baddata) return
           if (maginput(3).eq.baddata) return
           if (maginput(4).eq.baddata) return
           if (maginput(6).eq.baddata) return
           if (maginput(7).eq.baddata) return
           if (maginput(18).eq.baddata) return
           if (maginput(17).eq.baddata) return
           density=maginput(3)
           speed=maginput(4)
           dst_nt=maginput(2)
           BxIMF_nt=maginput(18)
           ByIMF_nt=maginput(6)
           BzIMF_nt=maginput(7)
           Al=maginput(17)
           ifail = 0
           return
        endif

        if (kext .eq. 13 .or. kext .eq. 14) then
c            if (maginput(5).eq.baddata) return
c            Pdyn_nPa=maginput(5)
c           no need for solar-wind inputs anymore
c           they are read directly from the coefficient files
            ifail=0
            return
        endif

c not sure why this is here, it's not implemented in other places
c        if (kext .eq. 14) then
c Input for Mead-Tsyganenko
c           if (maginput(1).eq.baddata) return
c             fkp=maginput(1)*1.d0/10.d0
c             if (maginput(1).lt.0.d0 .or.
c     &         maginput(1).gt.90.d0) return
c           ifail = 0
c           return
c        endif
       print *, ' invalid kext'

       return
       end

c Wrapper and procedure to access many coordinate transformation form the
c ONERA library
c
c =======================================================================
c GEO2GSM
c
c Routine to transform Cartesian GEO to cartesian GSM coordinates
c
c  INPUTS: iyr = integer year
c          idoy = integer day of year
c          secs = UT in seconds
c          xGEO = 3D array of cartesian position in GEO (Re)
c
c OUTPUTS: psi: angle for GSM coordinate
c         xGSM: 3D array of cartesian position in GSM  (Re)
c
c CALLING SEQUENCE from IDL:
c  result = call_external(lib_name,  $            ;The sharable object file
c           'geo2gsm_', $                         ;The entry point
c           iyr,idoy,secs,psi,xGEO,xGSM, $               ;return values (6)
c           /f_value)                             ;function returns a float.
c
c =======================================================================
c GSM2GEO
c
c Routine to transform Cartesian GSM to cartesian GEO coordinates
c
c  INPUTS: iyr = integer year
c          idoy = integer day of year
c          secs = UT in seconds
c          xGSM = 3D array of cartesian position in GSM (Re)
c
c OUTPUTS: psi: angle for GSM coordinate
c         xGEO: 3D array of cartesian position in GEO (Re)
c
c CALLING SEQUENCE from IDL:
c  result = call_external(lib_name,  $            ;The sharable object file
c           'gsm2geo_', $                         ;The entry point
c           iyr,idoy,secs,psi,xGSM,xGEO, $               ;return values (6)
c           /f_value)                             ;function returns a float.
c
c
c =======================================================================
c GDZ2GEO
c
c Routine to transform GEODEZIC coordinates to cartesian GEO coordinates
c
c  INPUTS: lati = latitude (degres)
c          longi = longitude (degres)
c          alti = altitude (km)
c
c OUTPUTS: xx = xGEO (Re)
c          yy = yGEO (Re)
c          zz = zGEO (Re)
c
c CALLING SEQUENCE from IDL:
c  result = call_external(lib_name,  $            ;The sharable object file
c           'gdz2geo_', $                         ;The entry point
c           lati,longi,alti,xx,yy,zz, $               ;return values (6)
c           /f_value)                             ;function returns a float.
c
c
c =======================================================================
c GEO2GDZ
c
c Routine to transform cartesian GEO coordinates to GEODEZIC coordinates
c
c INPUTS: xx = xGEO (Re)
c          yy = yGEO (Re)
c          zz = zGEO (Re)
c
c OUTPUTS: lati = latitude (degres)
c          longi = longitude (degres)
c          alti = altitude (km)
c
c
c CALLING SEQUENCE from IDL:
c  result = call_external(lib_name,  $            ;The sharable object file
c           'geo2gdz_', $                         ;The entry point
c           xx,yy,zz,lati,longi,alti, $               ;return values (6)
c           /f_value)                             ;function returns a float.
c
c =======================================================================
c --------------------------------------------------------------------
c
        SUBROUTINE geo2gsm1(iyr,idoy,secs,psi,xGEO,xGSM)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGEO(3),xGSM(3)

      dyear=iyr+0.5d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL GEO_GSM(xGEO,xGSM)
        end
c --------------------------------------------------------------------
c
        SUBROUTINE gsm2geo1(iyr,idoy,secs,psi,xGSM,xGEO)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGEO(3),xGSM(3)


      dyear=iyr+0.5d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL GSM_GEO(xGSM,xGEO)
        end

c --------------------------------------------------------------------
c
        SUBROUTINE geo2gse1(iyr,idoy,secs,xGEO,xGSE)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGEO(3),xGSE(3)

        dyear=iyr+0.5d0
        psi=0.d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL GEO_GSE(xGEO,xGSE)
        end
c --------------------------------------------------------------------
c
        SUBROUTINE gse2geo1(iyr,idoy,secs,xGSE,xGEO)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGEO(3),xGSE(3)


      dyear=iyr+0.5d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL GSE_GEO(xGSE,xGEO)
        end



c --------------------------------------------------------------------
c
        SUBROUTINE geo2gei1(iyr,idoy,secs,xGEO,xGEI)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGEO(3),xGEI(3)

       dyear=iyr+0.5d0
       psi=0.d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL GEO_GEI(xGEO,xGEI)
        end

c --------------------------------------------------------------------
c
        SUBROUTINE gei2geo1(iyr,idoy,secs,xGEI,xGEO)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGEO(3),xGEI(3)

        dyear=iyr+0.5d0
        psi=0.d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL GEI_GEO(xGEI,xGEO)
        end

c --------------------------------------------------------------------
c
        SUBROUTINE geo2sm1(iyr,idoy,secs,xGEO,xSM)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGEO(3),xSM(3)

       dyear=iyr+0.5d0
       psi=0.d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL GEO_SM(xGEO,xSM)
        end

c --------------------------------------------------------------------
c
        SUBROUTINE sm2geo1(iyr,idoy,secs,xSM,xGEO)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGEO(3),xSM(3)

        dyear=iyr+0.5d0
        psi=0.d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL SM_GEO(xSM,xGEO)
        end

c --------------------------------------------------------------------
c
        SUBROUTINE gsm2sm1(iyr,idoy,secs,xGSM,xSM)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGSM(3),xSM(3)

        dyear=iyr+0.5d0
        psi=0.d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL GSM_SM(xGSM,xSM)
        end

c --------------------------------------------------------------------
c
        SUBROUTINE sm2gsm1(iyr,idoy,secs,xSM,xGSM)
      INTEGER*4 iyr,idoy
      REAL*8    secs,psi,dyear
      REAL*8    xGSM(3),xSM(3)

        dyear=iyr+0.5d0
        psi=0.d0
        call initize ! sets rad, pi used by various routines

        CALL INIT_DTD(dyear)
        CALL INIT_GSM(iyr,idoy,secs,psi)
        CALL SM_GSM(xSM,xGSM)
        end
c --------------------------------------------------------------------
c
        SUBROUTINE geo2mag1(iyr,xGEO,xMAG)
      INTEGER*4 iyr
      REAL*8    dyear
      REAL*8    xGEO(3),xMAG(3)

      dyear=iyr+0.5d0
        CALL INIT_DTD(dyear)
        CALL GEO_MAG(xGEO,xMAG)
        end

c --------------------------------------------------------------------
c
        SUBROUTINE mag2geo1(iyr,xMAG,xGEO)
      INTEGER*4 iyr
      REAL*8    dyear
      REAL*8    xGEO(3),xMAG(3)

      dyear=iyr+0.5d0
        CALL INIT_DTD(dyear)
        CALL MAG_GEO(xMAG,xGEO)
        end
c
c --------------------------------------------------------------------
c
      subroutine msis86(ntime,whichAp,DOY,UT,ALT,LAT,LONG,F107A,
     &F107,AP,Dens,Temp)
c
      IMPLICIT NONE
      INTEGER*4 ISW,ntime,whichAp,DOY(100000),I,J
      REAL*8 SV(25),STL
      REAL*8 UT(100000),ALT(100000),LAT(100000),LONG(100000)
      REAL*8 F107A(100000),F107(100000),AP(7,100000)
      REAL*8 Dens(8,100000),Temp(2,100000),APin(7),D(8),T(2)
c
      COMMON/CSWI/ISW
      DO I=1,25
         SV(I)=1.D0
      ENDDO
      if (WhichAp .EQ.2) SV(9)=-1.D0
      CALL TSELEC(SV)
      ISW=64999
      DO I=1,ntime
         STL=UT(I)/3600.D0+Long(I)/15.D0
       DO J=1,7
          APin(J)=AP(J,I)
       ENDDO
       IF (ALT(I).GE.85.D0) then
          CALL GTS5(DOY(I),UT(I),ALT(I),LAT(I),LONG(I),STL,F107A(I),
     &             F107(I),APin,48,D,T)
         ELSE
            DO J=1,8
             D(J)=-1.D31
          ENDDO
          DO J=1,2
             T(J)=-1.D31
          ENDDO
       ENDIF
         DO J=1,8
          Dens(J,I)=D(J)
       ENDDO
       DO J=1,2
          Temp(J,I)=T(J)
       ENDDO
      ENDDO
      END

c --------------------------------------------------------------------
c
      subroutine msise90(ntime,whichAp,DOY,UT,ALT,LAT,LONG,F107A,
     &F107,AP,Dens,Temp)
c
      IMPLICIT NONE
      INTEGER*4 ISW,ntime,whichAp,DOY(100000),I,J
      REAL*8 SV(25),STL
      REAL*8 UT(100000),ALT(100000),LAT(100000),LONG(100000)
      REAL*8 F107A(100000),F107(100000),AP(7,100000)
      REAL*8 Dens(8,100000),Temp(2,100000),APin(7),D(8),T(2)
c
      COMMON/CSWI/ISW
      DO I=1,25
         SV(I)=1.D0
      ENDDO
      if (WhichAp .EQ.2) SV(9)=-1.D0
      CALL TSELEC5(SV)
      ISW=64999
      DO I=1,ntime
         STL=UT(I)/3600.D0+Long(I)/15.D0
       DO J=1,7
          APin(J)=AP(J,I)
       ENDDO
       CALL GTD6(DOY(I),UT(I),ALT(I),LAT(I),LONG(I),STL,F107A(I),
     &             F107(I),APin,48,D,T)
         DO J=1,8
          Dens(J,I)=D(J)
       ENDDO
       DO J=1,2
          Temp(J,I)=T(J)
       ENDDO
      ENDDO
      END
c --------------------------------------------------------------------
c
      subroutine nrlmsise00(ntime,whichAp,DOY,UT,ALT,LAT,LONG,F107A,
     &F107,AP,Dens,Temp)
c
      IMPLICIT NONE
      INTEGER*4 ISW,ntime,whichAp,DOY(100000),I,J
      REAL*8 SV(25),STL
      REAL*8 UT(100000),ALT(100000),LAT(100000),LONG(100000)
      REAL*8 F107A(100000),F107(100000),AP(7,100000)
      REAL*8 Dens(9,100000),Temp(2,100000),APin(7),D(8),T(2)
c
      COMMON/CSWI/ISW
      DO I=1,25
         SV(I)=1.D0
      ENDDO
      if (WhichAp .EQ.2) SV(9)=-1.D0
      CALL TSELEC7(SV)
      ISW=64999
      DO I=1,ntime
         STL=UT(I)/3600.D0+Long(I)/15.D0
       DO J=1,7
          APin(J)=AP(J,I)
       ENDDO
       CALL GTD7(DOY(I),UT(I),ALT(I),LAT(I),LONG(I),STL,F107A(I),
     &             F107(I),APin,48,D,T)
         DO J=1,9
          Dens(J,I)=D(J)
       ENDDO
       DO J=1,2
          Temp(J,I)=T(J)
       ENDDO
      ENDDO
      END


c --------------------------------------------------------------------
c
c Alternate version without useless 100k time/position array
        SUBROUTINE make_lstar_shell_splitting2(Nipa,kext,options,
     & sysaxes,iyearsat,idoy,UT,xIN1,xIN2,xIN3,
     &  alpha,maginput,Lm,Lstar,BMirror,BLOCAL,BMIN,XJ,MLT)
c
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C
c declare inputs
        INTEGER*4    kext,k_ext,k_l,options(5),Nalp,Nipa
      PARAMETER (Nalp=25)
        INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT
      real*8     xIN1,xIN2,xIN3
      real*8     alpha(Nalp)
      real*8     maginput(25)
c
c
c Declare internal variables
      INTEGER*4    iyear,IPA,kint,ifail
        INTEGER*4    Ilflag,t_resol,r_resol
      REAL*8     mlon,BL,BMIR(25),Bmin_tmp
      REAL*8     xGEO(3),xMAG(3),xSUN(3),rM,MLAT,Mlon1
      REAL*8     xGEOp(3,25)
      real*8     alti,lati,longi
c
c Declare output variables
        REAL*8     Bmirror(Nalp),BMIN,Blocal
      REAL*8     XJ(Nalp),MLT
        REAL*8     Lm(Nalp),Lstar(Nalp)
C
      COMMON /magmod/k_ext,k_l,kint
        COMMON /flag_L/Ilflag
        DATA  xSUN /1.d0,0.d0,0.d0/
      integer*4 int_field_select, ext_field_select
C
      Ilflag=0
      k_ext=kext
      if (options(3).lt.0 .or. options(3).gt.9) options(3)=0
      t_resol=options(3)+1
      r_resol=options(4)+1
      k_l=options(1)
      kint = int_field_select ( options(5) )
      k_ext = ext_field_select ( kext )
c
        CALL INITIZE

      call init_fields ( kint, iyearsat, idoy, ut, options(2) )

      call get_coordinates ( sysaxes, xIN1, xIN2, xIN3,
     6    alti, lati, longi, xGEO )

      call set_magfield_inputs ( k_ext, maginput, ifail )

        if (k_ext .eq. 13 .or. k_ext .eq. 14) then !special script to read files and
            call INIT_TS07D_TLPR
            call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
        end if

      if ( ifail.lt.0 ) then
          DO IPA=1,Nipa
             Lm(IPA)=baddata
             Lstar(IPA)=baddata
             XJ(IPA)=baddata
             Bmirror(IPA)=baddata
          ENDDO
          BMIN=baddata
          GOTO 99
         endif
c
c      load the GDZ and GSM coordinates in unused end of maginput
       maginput(20) = alti
         maginput(21) = lati
       maginput(22) = longi
         CALL GEO_GSM(xGEO,maginput(23))

c      collect the B components for return in maginput() array
        CALL CHAMP(xGEO,maginput(17),maginput(16),Ifail)
      IF (Ifail.LT.0) THEN
         maginput(17)=baddata
         maginput(18)=baddata
         maginput(19)=baddata
         maginput(16)=baddata
      ENDIF
c
c Compute Bmin assuming 90deg PA at S/C
         k_l=0
           IPA=1
c             all returned values except Bmin are subsequently overwritten
c            this call is required to return a valid Bmin value, as it is
c            not guaranteed that input pitch angles will produce valid results
           CALL calcul_Lstar_opt(t_resol,r_resol,xGeo
     &         ,Lm(IPA),Lstar(IPA),XJ(IPA)
     &         ,Bmirror(IPA),BMIN)
         k_l=options(1)
c            for the specified location and array of pitch angles,
c              return 'Blocal' for the specified location
c              return Bmir() array for bmirror values for each pitch angle
c              return xGeop() array for location of mirror points ""  ""
           CALL find_bm_nalpha(xGEO,nipa,alpha,Blocal,BMIR,xGEOp)
           DO IPA=1,Nipa
           IF (Bmir(ipa).NE.baddata) THEN
             Ilflag=0
c    for each mirror point location in xGEOp, calc several values
               CALL calcul_Lstar_opt(t_resol,r_resol,xGEOp(1,ipa)
     &         ,Lm(IPA),Lstar(IPA),XJ(IPA)
c        bmirror is the blocal at the xGEOp mirror point,
c         (should be identical to the BMIR() array returned by find_bm_nalpha)
     &         ,Bmirror(IPA),BMIN_tmp)
             ELSE
             Lm(IPA)=baddata
             Lstar(IPA)=baddata
             XJ(IPA)=baddata
             Bmirror(IPA)=baddata
           ENDIF
           ENDDO
99         continue
           CALL geo_mag(xGEO,xMAG)
           CALL car_sph(xMAG,rM,MLAT,Mlon1)
           CALL GSM_GEO(xSUN,xGEO)
           CALL geo_mag(xGEO,xMAG)
           CALL car_sph(xMAG,rM,MLAT,Mlon)
           MLT = (Mlon1 - Mlon)/15.d0 + 12.d0
           IF (MLT.GE.24.d0) MLT = MLT - 24.d0
           IF (MLT.LT.0.d0) MLT = MLT + 24.d0

      END

!***************************************************************************************************
! Copyright 2010 T.P. O'Brien
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
!-----------------------------------------------------------------------------
      SUBROUTINE drift_bounce_orbit1(kext,options,sysaxes,
     &     iyearsat,idoy,UT,xIN1,xIN2,xIN3,alpha,maginput,
     &     Lm,Lstar,BLOCAL,BMIN,BMIR,XJ,posit,ind)
      ! inputs
      INTEGER*4 kext, options(5),sysaxes,iyearsat,idoy
      REAL*8 UT,xIN1,xIN2,xIN3,alpha,maginput(25)
      ! outputs
      REAL*8 Lm,Lstar
      REAL*8 BLOCAL(1000,25),BMIN,BMIR,XJ,posit(3,1000,25)
      INTEGER*4 ind(25)
      ! locals
      REAL*8 R0,hmin,hmin_lon
      R0 = 1.D0 ! stop search at surface of Earth
      call drift_bounce_orbit2_1(kext,options,sysaxes,
     &     iyearsat,idoy,UT,xIN1,xIN2,xIN3,alpha,maginput,
     &     R0,
     &     Lm,Lstar,BLOCAL,BMIN,BMIR,XJ,posit,ind,
     &     hmin,hmin_lon)
      end

      
      SUBROUTINE drift_bounce_orbit2_1(kext,options,sysaxes,
     &     iyearsat,idoy,UT,xIN1,xIN2,xIN3,alpha,maginput,
     &     R0,
     &     Lm,Lstar,BLOCAL,BMIN,BMIR,XJ,posit,ind,
     &     hmin,hmin_lon)
      
c     computes posit(3,1000,25), BLOCAL(1000,25) and ind(25) in same
c     format as drift_shell1 (note 25 not 48 azimuths)
c     also provides Bmin, Bmirror and usual stuff
c     allows user to specify R0 = surface below which a particle is considered
c     lost (R0 is in RE and the usual value is 1 but for the drift loss cone, one
c     may wish to allow R0<1)
c     also provides hmin and hmin_lon, the altitude and longitude (GDZ) of the
c     minimum altitude along the drift orbit
      
      
      IMPLICIT NONE
      INCLUDE 'variables.inc'
C     
c     declare inputs
      INTEGER*4    kext,k_ext,k_l,options(5)
      INTEGER*4    sysaxes
      INTEGER*4    iyearsat
      integer*4    idoy
      real*8     UT
      real*8     xIN1,xIN2,xIN3
      real*8     alpha
      real*8     maginput(25),R0
      REAL*8 hmin,hmin_lon
c     
c     
c     Declare internal variables
      INTEGER*4    kint,i,j,k
      INTEGER*4    ifail,Ilflag,t_resol,r_resol
      REAL*8     xGEO(3),xGEOmir(3), BL
      REAL*8     alti,lati,longi
c     
c     Declare output variables
      INTEGER*4  ind(25)
      REAL*8     posit(3,1000,25)
      REAL*8     BLOCAL(1000,25)
      REAL*8     BMIN,BMIR
      REAL*8     XJ
      REAL*8     Lm,Lstar
C     
      COMMON /magmod/k_ext,k_l,kint
      COMMON /flag_L/Ilflag
      integer*4 int_field_select, ext_field_select
C     
c     initialize outputs
      Lm=baddata
      Lstar=baddata
      XJ=baddata
      BMIN=baddata
      BMIR=baddata
      hmin = baddata
      hmin_lon = baddata
      do i=1,25
         ind(i)=0
         do j=1,1000
            BLOCAL(j,i)=baddata
            do k=1,3
               posit(k,j,i)=baddata
            enddo
         enddo
      enddo

      Ilflag=0
      k_ext=kext
      if (options(1).eq.0) options(1)=1
      if (options(3).lt.0 .or. options(3).gt.9) options(3)=0
      t_resol=options(3)+1
      r_resol=options(4)+1
      k_l=options(1)
c
	kint = int_field_select ( options(5) )
	k_ext = ext_field_select ( kext )
c
        CALL INITIZE
	
	call init_fields ( kint, iyearsat, idoy, ut, options(2) )
	
	call get_coordinates ( sysaxes, xIN1, xIN2, xIN3, 
     6    alti, lati, longi, xGEO )
	    
	call set_magfield_inputs ( kext, maginput, ifail )
	
	if ( ifail.lt.0 ) RETURN
      if (kext .eq. 13 .or. kext .eq. 14) then !special script to read files and
         call INIT_TS07D_COEFFS(iyearsat,idoy,ut,ifail)
         call INIT_TS07D_TLPR
	     if ( ifail.lt.0 ) RETURN
      end if
c
c    

      CALL find_bm_nalpha(xGEO,1,alpha,BL,BMIR,xGEOmir)
      IF (Bmir.NE.baddata) THEN
         Ilflag=0
         call trace_drift_bounce_orbit_opt(t_resol,r_resol,
     &        xGEOmir,R0,Lm,Lstar,XJ,
     &        BLOCAL,Bmin,Bmir,posit,ind,hmin,hmin_lon)
         if (Lstar.eq.baddata) then
            hmin = baddata
            hmin_lon = baddata
         endif
         
      ENDIF
 99   continue
      
      end                       ! end subroutine drift_bounce_orbit1


c     --------------------------------------------------------------------
c     

      SUBROUTINE trace_drift_bounce_orbit(t_resol,r_resol,
     &     lati,longi,alti,R0,Lm,Lstar,leI0,Bposit,
     &     Bmin,Bmir,posit,Nposit,hmin,hmin_lon)
C     
      IMPLICIT NONE
      INCLUDE 'variables.inc'
      
C     Parameters
      INTEGER*4  Nreb_def,Nder_def,Ntet_def
      PARAMETER (Nreb_def = 50, Nder_def = 25, Ntet_def = 720)
      
C     Input Variables
      INTEGER*4 t_resol,r_resol
      REAL*8     lati,longi,alti,R0
      REAL*8     xx0(3)
C     Output Variables       
      REAL*8     Lm,Lstar,leI0,Bmin,Bmir
      REAL*8     posit(3,20*Nreb_def,Nder_def)
      REAL*8     Bposit(20*Nreb_def,Nder_def)
      REAL*8     hmin,hmin_lon
      INTEGER*4  Nposit(Nder_def)

      CALL GDZ_GEO(lati,longi,alti,xx0(1),xx0(2),xx0(3))
C     
      call trace_drift_bounce_orbit_opt(t_resol,r_resol,
     &     xx0,R0,Lm,Lstar,leI0,Bposit,
     &     Bmin,Bmir,posit,Nposit,hmin,hmin_lon)

      RETURN
      END      

      SUBROUTINE trace_drift_bounce_orbit_opt(t_resol,r_resol,
     &     xx0,R0,Lm,Lstar,leI0,Bposit,
     &     Bmin,Bmir,posit,Nposit,hmin,hmin_lon)
C     
      IMPLICIT NONE
      INCLUDE 'variables.inc'
      
C     Parameters
      INTEGER*4  Nreb_def,Nder_def,Ntet_def
      PARAMETER (Nreb_def = 50, Nder_def = 25, Ntet_def = 720)
      
C     Input Variables
      INTEGER*4 t_resol,r_resol
      REAL*8     R0
      
C     Internal Variables
      INTEGER*4  Nder,Nreb,Ntet
      INTEGER*4  k_ext,k_l,kint,n_resol
      INTEGER*4  Nrebmax
      REAL*8     rr,rr2
      REAL*8     xx0(3),xx(3),x1(3),x2(3)
      REAL*8     xmin(3)
      REAL*8     B(3),Bl,B0,B1,B3
      REAL*8     dsreb0,dsreb,smin
      
      INTEGER*4  I,J,K,Iflag,Iflag_I,Ilflag,Ifail
      INTEGER*4  Ibounce_flag
      !istore is azimuth cursor
      INTEGER*4  istore
      REAL*8     Lb
      REAL*8     leI,leI1
      REAL*8     XY,YY
      REAL*8     aa,bb
      
C     
      REAL*8     tt
      REAL*8     tet(10*Nder_def),phi(10*Nder_def)
      REAL*8     tetl,tet1,dtet,lasttet
      REAL*8     somme,BrR2
        REAL*8     pi,rad
        common /rconst/rad,pi

c variables to deal with leI~0 case
      REAL*8     x1old(3)
      INTEGER*4  I0flag
C     
      REAL*8     Bo,xc,yc,zc,ct,st,cp,sp
      
C     Output Variables       
      REAL*8     Lm,Lstar,leI0,Bmin,Bmir
      REAL*8     posit(3,20*Nreb_def,Nder_def)
      REAL*8     Bposit(20*Nreb_def,Nder_def)
      REAL*8     hmin,hmin_lon
      INTEGER*4  Nposit(Nder_def), tet_count
C     
      COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
      COMMON /calotte/tet
      COMMON /flag_L/Ilflag
      COMMON /magmod/k_ext,k_l,kint
C     
C     


      Nder=Nder_def*r_resol     ! longitude steps
      Nreb=Nreb_def             ! steps along field line
      Ntet=Ntet_def*t_resol     ! latitude steps
      dtet = pi/Ntet            ! theta (latitude) step
C     
      Nrebmax = 20*Nreb         ! maximum steps along field line
C     
C
c     initialize hmin,hmin_lon to starting point
      hmin = baddata
      call check_hmin(xx0(1),xx0(2),xx0(3),hmin,hmin_lon)

      CALL GEO_SM(xx0,xx)
      rr = SQRT(xx(1)*xx(1)+xx(2)*xx(2)+xx(3)*xx(3))
      tt = ACOS(xx(3)/rr)
      Lb  = rr/SIN(tt)/SIN(tt)  ! dipole L
C     
      CALL CHAMP(xx0,B,B0,Ifail)
      Bmir = B0 ! local field at starting point - for Bmir=0 case when alpha=90
      IF (Ifail.LT.0) THEN
         Ilflag = 0
         RETURN
      ENDIF
      Bmin = B0
C     
      dsreb0 = Lb/Nreb           ! step size dipole L / Nsteps
      dsreb = dsreb0
C     
C     calcul du sens du depart
C     (compute hemisphere)
 10   CONTINUE
      CALL sksyst_var(-dsreb,xx0,x1,Bl,Ifail)
      IF (Ifail.LT.0) THEN
         Ilflag = 0
         RETURN
      ENDIF
      B1 = Bl
      
      CALL sksyst_var(dsreb,xx0,x2,Bl,Ifail)
      IF (Ifail.LT.0) THEN
         Ilflag = 0
         RETURN
      ENDIF
      B3 = Bl

C     
C     attention cas equatorial
C     (equatorial special case)
      IF(B1.GT.B0 .AND. B3.GT.B0)THEN
         aa = 0.5D0*(B3+B1-2.D0*B0)
         bb = 0.5D0*(B3-B1)
         smin = -0.5D0*bb/aa
         Bmin = B0 - aa*smin*smin
         leI0 = SQRT(1.D0-Bmin/B0)*2.D0*ABS(smin*dsreb)
         Lm = (Bo/Bmin)**(1.D0/3.D0)
c     write(6,*)'L McIlwain eq ',B0,leI0,Lm
         GOTO 100
      ENDIF
      dsreb0 = dsreb ! keep smaller step size for future use
      IF (B3.GT.B1) THEN
         dsreb = -dsreb
      ENDIF
C     
C     calcul de la ligne de champ et de I
C     (compute field line and I)
      Bmin = B0
      B1 = B0
      leI = 0.D0
      DO I = 1,3
         x1(I)  = xx0(I)
      ENDDO
C     
      DO J = 1,Nrebmax
         CALL sksyst_var(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) THEN
            Ilflag = 0
            RETURN
         ENDIF
         IF (Bl.LT.Bmin) THEN
            xmin(1) = x2(1)
            xmin(2) = x2(2)
            xmin(3) = x2(3)
            Bmin = Bl
         ENDIF
         IF (Bl.GT.B0) GOTO 20  ! traced past southern mirror point
         x1(1) = x2(1)
         x1(2) = x2(2)
         x1(3) = x2(3)
         leI = leI + SQRT(1.D0-Bl/B0)
         
         B1 = Bl
      ENDDO
 20   CONTINUE

C     
      IF (J.GE.Nrebmax) THEN    !open field line
         Ilflag = 0
         RETURN
      ENDIF

C     
      leI = leI+0.5D0*SQRT(1.D0-B1/B0)*(B0-Bl)/(Bl-B1)
      leI = leI*ABS(dsreb)
      leI0 = leI
C     
C     calcul de L Mc Ilwain (Mc Ilwain-Hilton)
C     (compute L McIlwain (McIlwain-Hilton))
C     
      XY = leI*leI*leI*B0/Bo
      YY = 1.D0 + 1.35047D0*XY**(1.D0/3.D0)
     &     + 0.465376D0*XY**(2.D0/3.D0)
     &     + 0.0475455D0*XY
      Lm = (Bo*YY/B0)**(1.D0/3.D0)
C     
C     calcul de Bmin
c     (compute Bmin)
C     
      CALL sksyst_var(dsreb,xmin,x1,B3,Ifail)
      IF (Ifail.LT.0) THEN
         Ilflag = 0
         RETURN
      ENDIF
      CALL sksyst_var(-dsreb,xmin,x1,B1,Ifail)
      IF (Ifail.LT.0) THEN
         Ilflag = 0
         RETURN
      ENDIF
      aa = 0.5D0*(B3+B1-2.D0*Bmin)
      bb = 0.5D0*(B3-B1)
      smin = -0.5D0*bb/aa
      Bmin = Bmin - aa*smin*smin
      IF (x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3).LT.1.0) THEN
         Lm = -Lm
      ENDIF
C     
 100  CONTINUE
      if (k_l .eq.0) then
         Ilflag = 0
         RETURN
      endif
      IF (ABS(Lm) .GT. 10.D0) THEN
         Ilflag = 0
         RETURN
      ENDIF
C     
C     calcul du point sur la ligne de champ a la surface de la terre du
C     cote nord
C     (compute the point nothern footpoint at Earth's surface)
C     
      DO I = 1,3
         x1(I)  = xx0(I)
      ENDDO
      dsreb = ABS(dsreb)
      DO J = 1,Nrebmax
         CALL sksyst_var(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) THEN
            Ilflag = 0
	    RETURN
	 ENDIF
	 rr = sqrt(x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3))
	 IF (rr.LT.R0) GOTO 102
	 x1(1) = x2(1)
	 x1(2) = x2(2)
	 x1(3) = x2(3)
      ENDDO
 102  CONTINUE
      smin = sqrt(x1(1)*x1(1)+x1(2)*x1(2)+x1(3)*x1(3))
      smin = (R0-smin)/(rr-smin)
      CALL sksyst_var(smin*dsreb,x1,x2,Bl,Ifail)
      IF (Ifail.LT.0) THEN
         Ilflag = 0
         RETURN
      ENDIF
      rr = sqrt(x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3))
      tet(1) = ACOS(x2(3)/rr)
      phi(1) = ATAN2(x2(2),x2(1))
C     
C     et on tourne -> on se decale sur la surface en phi et on cherche teta
C     pour avoir leI0 et B0 constants
C     (find the thetta/phi contour on the surface of the earth that conserves
C     B0= Bmirror and leI0=I)
      call trace_bounce_orbit(x2,B0,1,dsreb0,R0,
     &     Bposit,posit,Nposit,Ibounce_flag,hmin,hmin_lon)
      if (Ibounce_flag.ne.1) then ! try again from starting point
         call trace_bounce_orbit(xx0,B0,1,dsreb0,R0,
     &        Bposit,posit,Nposit,Ibounce_flag,hmin,hmin_lon)
      endif
      if (Ibounce_flag.ne.1) then
         Ilflag = 0
         RETURN
      endif

      istore = 2 ! istore=1 already stored in first bounce orbit trace
      dsreb = -dsreb
      DO I = 2,Nder
         phi(I) = phi(I-1)+2.D0*pi/Nder
         Iflag_I = 0
         I0flag = 0
         IF (Ilflag.EQ.0) THEN
            tetl = tet(I-1)
            IF (I.GT.2) tetl = 2.D0*tet(I-1)-tet(I-2)
            tet1 = tetl
         ELSE
            tetl = tet(I)
            tet1 = tetl
         ENDIF
         leI1 = baddata
C     
         tet_count = 0          ! number of tries of different theta
 107     CONTINUE
         tet_count = tet_count+1
         leI = baddata
         IF (tetl.GT.pi .OR. tetl.LT.0.D0) GOTO 108
         x1(1) = R0*SIN(tetl)*COS(phi(I))
         x1(2) = R0*SIN(tetl)*SIN(phi(I))
         x1(3) = R0*COS(tetl)
         Iflag = 0
         CALL CHAMP(x1,B,B1,Ifail)
         IF (Ifail.LT.0) THEN
            Ilflag = 0
            RETURN
         ENDIF
         if (B1.lt.Bmir) then
            if (tet_count.gt.Ntet*2) goto 108 ! abort
            ! starting point is in middle of field line. Try again at lower colat
            tetl = tetl-dtet
            goto 107
         endif
C     
         dsreb = dsreb/abs(dsreb)*dsreb0
         DO J = 1,Nrebmax
 109        CALL sksyst_var(dsreb,x1,x2,Bl,Ifail)
            IF (Ifail.LT.0) THEN
               Ilflag = 0
               RETURN
            ENDIF
            rr2 = sqrt(x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3))
            IF (Bl.LT.B0) THEN
               lasttet = tetl
               IF (Iflag .EQ. 0) THEN
                  CALL CHAMP(x1,B,B1,Ifail)
                  IF (Ifail.LT.0) THEN
                     Ilflag = 0
                     RETURN
                  ENDIF
                  leI = 0.5D0*SQRT(1.D0-Bl/B0)*(1.D0+(Bl-B0)/(Bl-B1))
     &                 *abs(dsreb)
                  Iflag = 1
               ELSE
                  leI = leI+SQRT(1.D0-Bl/B0)*abs(dsreb)
               ENDIF
            ENDIF
            IF (Bl.GT.B0 .AND. Iflag.EQ.1) GOTO 103
            IF (rr2.LT.R0) GOTO 103
            x1(1) = x2(1)
            x1(2) = x2(2)
            x1(3) = x2(3)
            B1 = Bl
         ENDDO
 103     CONTINUE
         if ((Iflag.eq.0).and.(J.LT.Nrebmax)) then ! never got to B < Bmirror
            leI=0 ! assume particle is equatorially mirroring
                  ! Not technically true, but effectively gives desired result
                  ! (i.e., leI=0 for field lines way inside trajectory)
            I0flag = 1
         else
            I0flag = 0
c     Pourquoi? (why? I don't know!)
            IF (rr2.LT.R0) THEN
               leI = baddata
            ENDIF
            IF (J.LT.Nrebmax .AND. rr2.GE.R0) THEN
               CALL CHAMP(x1,B,B1,Ifail)
               IF (Ifail.LT.0) THEN
                  Ilflag = 0
                  RETURN
               ENDIF
               lasttet = tetl
               leI = leI+0.5D0*SQRT(1.D0-B1/B0)*(B0-Bl)/(Bl-B1)*
     &              abs(dsreb)
            ENDIF
         endif
C     
         IF (Iflag_I .EQ.0) THEN
            IF (J.GE.Nrebmax) THEN
               tetl = tetl-dtet
            ELSE
               tetl = tetl+dtet
            ENDIF
            leI1 = leI
            tet1 = tetl
            Iflag_I = 1
            GOTO 107
         ENDIF
         IF ((leI-leI0)*(leI1-leI0) .LT. 0.D0) GOTO 108
         leI1 = leI
         tet1 = tetl
         IF (leI.LT.leI0) THEN
            tetl = tetl-dtet
         ElSE
            tetl = tetl+dtet
         ENDIF
         GOTO 107
 108     CONTINUE
         IF ((J.GE.Nrebmax .AND. leI.GT.0.D0).or.(leI.LT.0.D0)) THEN
            Ilflag = 0
            RETURN
         ENDIF

         tetl = 0.5D0*(tetl+tet1) ! both tetl and tet1 work, so average
         tet(I) = tetl
         x1(1) = R0*SIN(tet(I))*COS(phi(I))
         x1(2) = R0*SIN(tet(I))*SIN(phi(I))
         x1(3) = R0*COS(tet(I))
         CALL CHAMP(x1,B,Bl,Ifail)
         IF (Ifail.LT.0) THEN
            Ilflag = 0
            RETURN
         ENDIF
         IF (Bl.LT.B0) THEN
            Ilflag = 0
            RETURN
         ENDIF
         
! Trace bounce orbit on field line from x1
         call trace_bounce_orbit(x1,Bmir,istore,dsreb0,R0,
     &        Bposit,posit,Nposit,Ibounce_flag,hmin,hmin_lon)
         if (Ibounce_flag.ne.1) then
            ! try again from lasttet, which worked
            tet(I) = lasttet
            x1(1) = R0*SIN(tet(I))*COS(phi(I))
            x1(2) = R0*SIN(tet(I))*SIN(phi(I))
            x1(3) = R0*COS(tet(I))
            call trace_bounce_orbit(x1,Bmir,istore,dsreb0,R0,
     &           Bposit,posit,Nposit,Ibounce_flag,hmin,hmin_lon)
         endif
         if (Ibounce_flag.ne.1) then
            Ilflag = 0
            RETURN
         endif
         if (MOD(I-1,r_resol).eq.0) then
            istore = istore+1 ! next time, store in next array step
         endif                  ! mode(I,r_resol)
      ENDDO                     ! end of do I = 2,Nder
C     
C     calcul de somme de BdS sur la calotte nord
C     (compute the integral of BdS on the norther polar cap)
      x1(1) = 0.D0
      x1(2) = 0.D0
      x1(3) = R0
      CALL CHAMP(x1,B,Bl,Ifail)
      IF (Ifail.LT.0)THEN
         Ilflag = 0
         RETURN
      ENDIF
      BrR2 = abs((x1(1)*B(1)+x1(2)*B(2)+x1(3)*B(3)))*R0 ! phi integrates B dot dA, or Br*R^2dphi*dtheta
      somme = BrR2*pi*dtet*dtet/4.D0
      DO I = 1,Nder
         tetl = 0.D0
         DO J = 1,Ntet
            tetl = tetl+dtet
            IF (tetl .GT. tet(I)) GOTO 111
            x1(1) = R0*SIN(tetl)*COS(phi(I))
            x1(2) = R0*SIN(tetl)*SIN(phi(I))
            x1(3) = R0*COS(tetl)
            CALL CHAMP(x1,B,Bl,Ifail)
            IF (Ifail.LT.0)THEN
               Ilflag = 0
               RETURN
            ENDIF
            BrR2 = abs((x1(1)*B(1)+x1(2)*B(2)+x1(3)*B(3)))*R0  ! phi integrates B dot dA, or Br*R^2dphi*dtheta
            somme = somme+BrR2*SIN(tetl)*dtet*2.D0*pi/Nder
	 ENDDO
 111     CONTINUE
      ENDDO
      if (k_l .eq.1) Lstar = 2.D0*pi*Bo/somme
      if (k_l .eq.2) Lstar = somme ! Phi and not Lstar
      IF (Lm.LT.0.D0) Lstar = -Lstar
      Ilflag = 1
C     
      END
      
      SUBROUTINE trace_bounce_orbit(xstart,Bmirror,istore,dsreb0,
     &     R0,Bposit,posit,Nposit,Iflag,hmin,hmin_lon)

      IMPLICIT NONE

c     Declare input variables
      !xstart in GEO, Bmirror is particle mirror field strength
      !istore stores bounce orbit
      REAL*8 xstart(3)
      REAL*8 Bmirror
      INTEGER*4 istore
      ! hmin,hmin_lon are also inputs

c     Declare output variables
      INTEGER*4  Nposit(25),Iflag
      REAL*8     posit(3,1000,25)
      REAL*8     Bposit(1000,25),R0,hmin,hmin_lon

c     Declare internal variables
      INTEGER*4 i,j,k,Ifail
      REAL*8 lati,longi,alti,Bl,Bmir
      REAL*8 xmir(3)
      REAL*8 alpha
      REAL*8 dsreb0,dsreb,x1(3),x2(3),B1,B2,Bvec(3)
      ! store or not?
      INTEGER*4 store

      j = 1 ! TPO 5 Jan 2020 seems like j was never initialized

      ! Iflag=1 means success, set to fail until succeeded
      Iflag = 0

      if ((istore.gt.25).or.(istore.lt.1)) then
         store = 0
      else
         store = 1
      endif

c     trace up to mirror point, leave starting pointin Bmir, xmir

      call champ(xstart,Bvec,B1,Ifail)

      dsreb = -dsreb0 ! assume starting at northern R=1 foot point

      do i = 1,3
         x1(i) = xstart(i)
      enddo

      call sksyst_var(dsreb,x1,x2,B2,Ifail)
      if (B2.GT.B1) then
         dsreb = -dsreb ! going wrong way
      endif

      call sksyst_var(dsreb,x1,x2,B2,Ifail)
      if (B2.GT.B1) then ! already at local min w/in resolution of dsreb
         ! store & return
         if (store.eq.1) then
            Bposit(1,istore) = B2
            Nposit(istore) = 1
            do k = 1,3
               posit(k,j,istore) = x1(k)
            enddo
         endif
         call check_hmin(x1(1),x1(2),x1(3),hmin,hmin_lon)
         Iflag=1
         return
      endif

      do j = 1,999
         call sksyst_var(dsreb,x1,x2,B2,Ifail)
         if (B2.GT.Bmirror) then ! still haven't crossed Bmirror
            do i = 1,3
               x1(i) = x2(i)
            enddo
            B1 = B2
         else
            do i = 1,3
               xmir(i) = x2(i)
            enddo
            Bmir = B2
            if (abs((Bmir/Bmirror-1.0D0)).lt.1.0D-6) then
               goto 101         ! good convergence
            endif
            dsreb = dsreb/2.D0 ! try again with smaller step (converges logarithmically)
         endif
      enddo
      return ! did not converge (Iflag=0)
 101  continue

      call check_hmin(xmir(1),xmir(2),xmir(3),hmin,hmin_lon)
      dsreb = -dsreb0

c     trace bounce trajectory
      call sksyst_var(dsreb,xmir,x2,B2,Ifail)
      if (B2.GT.Bmir) then
         dsreb = -dsreb ! going wrong way
      endif

c     trace to opposite mirror point
c     set up trace
      B2 = BMIR
      do k=1,3
         x1(k)=xmir(k)
      enddo
c     do trace
      do j=1,999
         if (store.eq.1) then
            Bposit(j,istore) = B2
            Nposit(istore) = j
            do k = 1,3
               posit(k,j,istore) = x1(k)
            enddo
         endif
         call sksyst_var(dsreb,x1,x2,B2,Ifail)
         if (Ifail.LT.0) then
            Iflag = 0
            return
         endif
         if (B2.ge.BMIR) goto 201
         do k=1,3
            x1(k)=x2(k)
         enddo
      enddo
 201  continue
      if (B2.lt.BMIR) then
         Iflag = 0 ! failed to get past BMIR
         return
      elseif (B2.gt.BMIR) then
c     finish trace to Bm: Bm between x1 and x2
         BL = B2 ! closest stored point so far (x1)
         j = j+1                ! prepare to store in next element
         do i = 1,10            ! this converges logarithmically, so reduces step size by up to 2^10
            dsreb = dsreb/2.0D0 ! restart with half step size
            call sksyst_var(dsreb,x1,x2,B2,Ifail)
            if (B2.LT.Bmirror) then ! still inside bounce orbit
               do k=1,3
                  x1(k) = x2(k)
               enddo
               if (store.eq.1) then ! got closer, so store x1
                  Bposit(j,istore) = B2
                  Nposit(istore) = j
                  do k=1,3
                     posit(k,j,istore) = x1(k)
                  enddo
               endif
            endif
         enddo
         call check_hmin(x1(1),x1(2),x1(3),hmin,hmin_lon)
      endif

      Iflag = 1
      END ! end sub trace_bounce_orbit

      subroutine check_hmin(x,y,z,hmin,hmin_lon)
      ! check alt/lat/lon at x,y,z and replace hmin,hmin_lon if needed
      IMPLICIT NONE
      INCLUDE 'variables.inc'
      ! inputs - x,y,z GEO
      real*8 x,y,z
      
      ! outputs
      real*8 hmin,hmin_lon

      ! locals
      real*8 lati,longi,alti

      call geo_gdz(x,y,z,lati,longi,alti)
      if ((hmin.eq.baddata).or.(alti .lt. hmin)) then
         hmin = alti
         hmin_lon = longi
      endif
      end


      subroutine sksyst_var(dsreb,x0,x1,B,Ifail)
      ! sksyt but takes 1/10 size steps for R<1
      IMPLICIT NONE

      REAL*8 dsreb,x0(3),x1(3),B,xtmp(3)
      INTEGER*4 Ifail,i,j

      if ((x0(1)**2+x0(2)**2+x0(3)**2).ge.1.0) then
         ! R>= 1.0, so use regular dsreb
         call sksyst(dsreb,x0,x1,B,Ifail)
         return
      endif
      ! else, take 10 small steps
      do i = 1,3
         xtmp(i) = x0(i)
      enddo
      do j = 1,10
         call sksyst(dsreb/10.D0,xtmp,x1,B,Ifail)
         if (Ifail.LT.0) return
         do i = 1,3
            xtmp(i) = x1(i)
         enddo
      enddo
      end

      ! Adapted for IRBEM by A. C. Kellerman, needs to be called on date
      ! update. TODO: check if we already loaded the current files and
      ! skip the load if so, as they currently have a cadence of 5
      ! minutes
      ! ifail returns as -1 if the files are not found, resulting in 
      ! bad data returned by each subroutine
      
      SUBROUTINE INIT_TS07D_COEFFS (iyear,idoy,dut,ifail)

      IMPLICIT NONE
     
      INTEGER*4 iyear,idoy,ifail
      REAL*8 A07,dut,COEFF_Q,COEFF_B_RMS,VXGSE,VYGSE,VZGSE
      REAL*8 PDYN,TILT
      INTEGER*4 M_INX,N_INX,NTOT,I,MODMIN
      
      INTEGER IYR,IDY,IHR,IMN,ISC
      INTEGER TS7LEN,ierr,stat,statb(13) ! file i/o
      LOGICAL OK ! I/O

      CHARACTER*18 PAR_FNAME
      CHARACTER*200 filename,FMT
      CHARACTER*80 TS7DIR
      CHARACTER*255 ts07d_env
      CHARACTER TRIM

      PARAMETER (NTOT=101)

      COMMON /TS07D_DATA/ M_INX,N_INX,PDYN,TILT,A07(NTOT)

      CALL GETENV('TS07_DATA_PATH', ts07d_env)
      if (LEN_TRIM(ts07d_env).ne.0) then 
        TS7DIR=TRIM(ts07d_env)
      else
        write(*,*) "error, TS07_DATA_PATH global variable not set"
        stop
      endif
      i=len(TS7DIR)
      do while (TS7DIR(i:i) == ' ')
        i = i - 1  
      enddo
      TS7LEN=i

      IYR=iyear
      IDY=idoy
      IHR=floor(dut/3600.D0)
      IMN=floor(((dut/3600.D0)-IHR) * 60.D0) 
      ISC=floor(dut-IHR*3600.D0-IMN*60.D0)

      MODMIN=MOD(IMN,5)
      WRITE (PAR_FNAME,'(I4,A1,I0.3,A1,I0.2,A1,I0.2,A4)')
     +iyear,'_',idoy,'_',IHR,'_',IMN-MODMIN,'.par' 

C     TS7LEN is the directory length
c      WRITE(FMT,'("(A", I0, ",A8,A18)")') TS7LEN
c      write(filename,FMT), TS7DIR(1:TS7LEN),'/Coeffs/',PAR_FNAME

      WRITE(FMT,'("(A", I0, ",A8,I4,A1,I0.3,A1,A18)")') TS7LEN
      write(filename,FMT) TS7DIR(1:TS7LEN),'/Coeffs/',iyear,'_',
     * idoy,'/',PAR_FNAME

c check that filename exists:
      INQUIRE( FILE=filename, EXIST=OK ) 
      if (OK) then
      OPEN (UNIT=1,FILE=filename,action='read') !  MODEL PARAMETER FILE FOR
        ierr=stat(filename,statb)
      if (ierr.ne.0) then
        print *, 'Could not open ',filename,' for reading.'
        stop
      endif

      READ (1,100) (A07(I),I=1,NTOT)                             !  A SPECIFIC TIME MOMENT
      READ (1,101) COEFF_Q 
      READ (1,101) COEFF_B_RMS 
      READ (1,102) M_INX
      READ (1,102) N_INX
      READ (1,101) PDYN
      READ (1,101) TILT
      CLOSE(1)                                        

c      print *, filename
c      do i=1,NTOT
c        write(*,*) 'i=',i,', A07=',A07(i)
c        call sleep(1)
c      enddo
c      write(*,*) COEFF_G, COEFF_B_RMS, M_INX, N_INX, PDYN, TILT
c      call sleep(10)

 100  FORMAT(G15.6)                                         
 101  FORMAT(7x,G15.6)                                            
 102  FORMAT(7x,I15)                                            

      
!      print *, filename
      VXGSE=-400.D0  !  GSE COMPONENTS OF SOLAR WIND VELOCITY VECTOR; THIS PARTICULAR CHOICE
      VYGSE=   0.D0  !   IS MADE IN ORDER TO MAKE THE GSW SYSTEM IDENTICAL TO THE STANDARD GSM
      VZGSE=   0.D0


      call RECALC_08 (IYR,IDY,IHR,IMN,ISC,VXGSE,VYGSE,VZGSE) ! CALCULATES TILT ANGLE AND
C                                                                  UPDATES MAIN FIELD COEFFICIENTS      

      else
        print *, 'TS07d error: No Coeff files exist for ',iyear,idoy
        print *, 'TS07d error: filename: ',filename,' does not exist'
        ifail=-1
      endif
      end

!***************************************************************************************************
! Copyright 2006, 2007 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
! CREATION: S. Bourdarie - ONERA-DESP
!
! FILE CONTENT: 
!               SUBROUTINE fly_in_afrl_crres1: Allows to fly a spacecraft in AFRL CRRES ele and pro models.
!               SUBROUTINE get_crres_flux: Compute flux from AFRL CRRES models for an energy, B/B0 and L
!               SUBROUTINE Init_CRRESPRO_Quiet: Set block data for AFRL CRRESPRO QUIET model
!               SUBROUTINE Init_CRRESPRO_Active: Set block data for AFRL CRRESPRO Active model
!               SUBROUTINE Init_CRRESELE_Average: Set block data for AFRL CRRESELE Average model
!               SUBROUTINE Init_CRRESELE_WorstCase: Set block data for AFRL CRRESELE Worstcase model
!
!***************************************************************************************************
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: S. Bourdarie - March 2007 (add multi channel calculcations; add time input for coordinates transformations) - V4.1
!
! DESCRIPTION: Allows to fly a spacecraft in CRRES models (AFRL)
!
! INPUT: ntime -> maximum number of time to compute (long integer)
!        sysaxes -> define which coordinate system is provided in
!        whichm -> which model to use, 1=pro quiet 2=pro active 3=ele ave  4=ele worst case  5=ele Ap15 (long integer)
!        whatf -> which kind of flux, 1=differential 2=E range 3=integral (long integer)
!        Nene -> Number of energy channels to compute
!        energy -> energy (MeV) at which fluxes must be computed (double array [2,25])
!        iyear,idoy,UT -> times when flux are to be computed (not usefull if imput position is not in GSE, GSM, SM,GEI) (respectively long array(ntime_max), long array(ntime_max), double array(ntime_max))
!        xIN1 -> first coordinate in the chosen system (double array [ntime_max])
!        xIN2 -> second coordinate in the chosen system (double array [ntime_max])
!        xIN3 -> third coordinate in the chosen system (double array [ntime_max])
!        Ap15 -> 15 previous days average of Ap index assuming a one day delay (double array [ntime_max])
!
! OUTPUT: flux -> Computed fluxes (MeV-1 cm-2 s-1 or cm-2 s-1) (double array [ntime_max,25])
!
! CALLING SEQUENCE: CALL fly_in_afrl_crres1(ntime,sysaxes,whichm,whatf,energy,xIN1,xIN2,xIN3,flux)
!---------------------------------------------------------------------------------------------------
        SUBROUTINE fly_in_afrl_crres1(ntime,sysaxes,whichm,whatf,nene,
     &                             energy,iyear,idoy,UT,xIN1,xIN2,xIN3,
     &                             Ap15,flux,ascii_path,STRLEN)
c
	IMPLICIT NONE
        INCLUDE 'ntime_max.inc'
C
c declare inputs
        INTEGER*4  STRLEN
        BYTE       ascii_path(strlen)
c
        INTEGER*4  nene_max
	PARAMETER (nene_max=25)
        INTEGER*4  ntime,sysaxes,whichm,whatf,nene
	INTEGER*4  iyear(ntime_max),idoy(ntime_max)
	REAL*8     energy(2,nene_max)
	REAL*8     UT(ntime_max)
	real*8     xIN1(ntime_max),xIN2(ntime_max),xIN3(ntime_max)
c Declare internal variables
	INTEGER*4  k_ext,k_l,isat,kint
        INTEGER*4  t_resol,r_resol,Ilflag
	INTEGER*4  i,iyear_dip,idoy_dip
	REAL*8     dec_year,ut_dip
	REAL*8     xGEO(3),xMAG(3),xSUN(3),rM,MLAT,Mlon1
	REAL*8     xGSM(3),xSM(3),xGEI(3),xGSE(3)
	real*8     alti,lati,longi,psi,tilt
        REAL*8     ERA,AQUAD,BQUAD
        REAL*8     BLOCAL(ntime_max),BMIN(ntime_max),XJ(ntime_max)
        REAL*8     Lm(ntime_max),Lstar(ntime_max),BBo(ntime_max)
	REAL*8     Ap15(ntime_max)
c
c Declare output variables	
	REAL*8     flux(ntime_max,nene_max)
c
	CHARACTER*(500) afrl_crres_path
C
        COMMON/GENER/ERA,AQUAD,BQUAD
	COMMON /magmod/k_ext,k_l,kint
        COMMON /flag_L/Ilflag
        COMMON /dip_ang/tilt
        DATA  xSUN /1.d0,0.d0,0.d0/
        REAL*8     pi,rad
        common /rconst/rad,pi
C
        DO i=1,strlen
	   afrl_crres_path(i:i)=char(ascii_path(i))
	ENDDO
	afrl_crres_path=afrl_crres_path(1:strlen)
	Ilflag=0
	k_ext=5
	t_resol=3
	r_resol=0
	k_l=0
	if (whichm .lt. 1 .or. whichm .gt. 5) then
           whichm=1
	   WRITE(6,*)
	   WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   WRITE(6,*)'Invalid AFRL CRRES model specification'
	   WRITE(6,*)'Selecting crrespro quiet'
	   WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   WRITE(6,*)
	endif   
c
	if (whatf .lt. 1 .or. whatf .gt. 3) then
           whatf=1
	   WRITE(6,*)
	   WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   WRITE(6,*)'Invalid flux output specification'
	   WRITE(6,*)'Selecting differential flux'
	   WRITE(6,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   WRITE(6,*)
	endif   
c
	kint=1    !set IGRF
        CALL INITIZE
	dec_year=1985.5d0
	CALL INIT_DTD(dec_year)
c
	iyear_dip=1985
        idoy_dip=182
	UT_dip=0.d0
        CALL INIT_GSM(iyear_dip,idoy_dip,UT_dip,psi)
        tilt = psi/rad
        DO isat = 1,ntime
	
	    call get_coordinates ( sysaxes, 
     6        xIN1(isat), xIN2(isat), xIN3(isat), 
     6        alti, lati, longi, xGEO )
	    
           CALL calcul_Lstar_opt(t_resol,r_resol,xGEO
     &     ,Lm(isat),Lstar(isat),XJ(isat),BLOCAL(isat),BMIN(isat))
           BBo(isat)=BLOCAL(isat)/BMIN(isat)
	   if (Lm(isat) .le. 0.D0 .and. Lm(isat) .ne. -1.D31) 
     &       Lm(isat)=-Lm(isat)
	enddo   
        call get_crres_flux(ntime,whichm,whatf,nene,
     &               energy,BBo,Lm,Ap15,flux,afrl_crres_path,strlen)
        end
!
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: S. Bourdarie - March 2007 (add multi channel calculcations) - V4.1
!
! DESCRIPTION: Compute flux from CRRES models for an energy, B/B0 and L
!
! INPUT: ntmax -> maximum number of time to compute (long integer)
!        whichm -> which model to use, 1=pro quiet 2=pro active 3=ele ave  4=ele worst case  5=ele Ap15 (long integer)
!        whatf -> which kind of flux, 1=differential 2=E range 3=integral (long integer)
!        Nene -> Number of energy channels to compute
!        energy -> energy (MeV) at which fluxes must be computed (double array [2,25])
!        BBo -> Blocal/Bequator (double array [ntime_max])
!        L -> McIlwain L (double array [ntime_max])
!        Ap15 -> 15 previous days average of Ap index assuming a one day delay (double array [ntime_max])
!
! OUTPUT: flux -> Computed fluxes (MeV-1 cm-2 s-1 or cm-2 s-1) (double array [ntime_max,25])
!
! CALLING SEQUENCE: get_crres_flux(ntmax,whichm,whatf,energy,BBo,L,flux)
!---------------------------------------------------------------------------------------------------
       SUBROUTINE get_crres_flux(ntmax,whichm,whatf,nene,
     &            energy,BBo,L,Ap15,flux,afrl_crres_path,strlen)
c       
       IMPLICIT NONE
       INCLUDE 'variables.inc'
       INCLUDE 'ntime_max.inc'
c
       INTEGER*4    STRLEN
c
       INTEGER*4   ntmax,nene,i,ie,il,ib,ie1,ie2,iap,ieny
       INTEGER*4   whichm !1=pro quiet 2=pro active 3=ele ave  4=ele worst case  5=ele Ap15
       INTEGER*4   whatf  !1=diff 2=E range 3=int
c
       INTEGER*4   Ne,Nl,Nbb0,ind
c
       REAL*8      energy(2,25)
       REAL*8      flux(ntime_max,25),BBo(ntime_max),L(ntime_max)
       REAL*8      Ap15(ntime_max)
       REAL*8      pente,cste,Flux1,Flux2
c
c crres variables
       REAL*8 c_Ec(22)
       REAL*8 c_bb0(35)
       REAL*8 c_flux(22,34,90)  !energy;bb0,Lshell
       REAL*8 c_Lshell(91)
       REAL*8 c_Ap15(7)
c
       CHARACTER*(*) afrl_crres_path
C
c
c       common /crres_model/Ne,Nbb0,Nl,c_Lshell,c_Ec,c_bb0,c_flux
       common /crres_model_int/Ne,Nbb0,Nl
       common /crres_model_dbl/c_Lshell,c_Ec,c_bb0,c_flux
c       
       data c_Ap15 /5.0D0,7.0D0,10.0D0,15.0D0,20.0D0,25.0D0,55.0D0/
c
c  init
       DO i=1,ntmax
          do ieny=1,25
             Flux(i,ieny) = baddata
          enddo
       enddo
       CALL Init_CRRES(whichm,afrl_crres_path,strlen)
c	 
       if (whatf.EQ. 1) then
	  DO i=1,ntmax
c
c search in Lbin
	       if (L(i).GE.c_Lshell(1) .AND. 
     &                   L(i).LT.c_Lshell(Nl)) then
	          do il=2,Nl
		     if (L(i).LT.c_Lshell(IL)) goto 10
	          enddo
10                continue
                  Il=Il-1
c
c search in bb0bin
                  if (BBo(i).GT.c_bb0(Nbb0)) goto 50
	          do ib=2,Nbb0
		     if (BBo(i).LE.c_bb0(IB)) goto 20
	          enddo
20                continue
                  ib=ib-1
c
c search in Ap15bin if whichm=5
                  if (whichm .EQ. 5) then 
                     if (Ap15(i).LT.c_Ap15(1) .OR. 
     &                   Ap15(i).GT.c_Ap15(7)) goto 50
	             do iap=2,7
		        if (Ap15(i).LE.c_Ap15(iap)) goto 30
	             enddo
30                   continue
                     iap=iap-1
		     ind=4+iap
		     CALL Init_CRRES(ind,afrl_crres_path,strlen)
		  endif
c
c loop on energies
                  do ieny=1,nene
		     if (energy(1,ieny).LT.c_Ec(1) .OR. 
     &                   energy(1,ieny).GT.c_Ec(Ne)) then
	                Flux(i,ieny) = baddata
                     else
	                do ie=2,Ne
	                   if (energy(1,ieny).LE.c_Ec(ie)) goto 40
	                enddo
40                      continue
c
                        if (c_flux(ie,ib,il).LE.0.D0 .OR.
     &                     c_flux(ie-1,ib,il).LE.0.D0) then
                           Flux(i,ieny) = baddata
		        else
	                   pente=(LOG(c_flux(ie,ib,il))-
     &                           LOG(c_flux(ie-1,ib,il)))/
     &                        (LOG(c_Ec(ie))-LOG(c_Ec(ie-1)))
                           cste=LOG(c_flux(ie,ib,il))-
     &                          pente*LOG(c_Ec(ie))
		           Flux(i,ieny)=exp(pente*LOG(energy(1,ieny))
     &                                  +cste)
		        endif
		     endif
		  enddo
	       else
		  do ieny=1,nene
	             Flux(i,ieny) = baddata
		  enddo
	       endif
50	       continue
	    enddo
	 endif
c	 
c 
         if (whatf.EQ. 2) then
	    DO i=1,ntmax
	       if (L(i).GE.c_Lshell(1) .AND. 
     &                 L(i).LT.c_Lshell(Nl)) then
	          do il=2,Nl
		     if (L(i).LT.c_Lshell(IL)) goto 110
	          enddo
110               continue
                  Il=Il-1
                  if (BBo(i).GT.c_bb0(Nbb0)) then
		     do ieny=1,nene
	                Flux(i,ieny) = baddata
		     enddo
		     goto 150
		  endif
	          do ib=2,Nbb0
		     if (BBo(i).LE.c_bb0(IB)) goto 120
	          enddo
120               continue
                  Ib=Ib-1
c search in Ap15bin if whichm=5
                  if (whichm .EQ. 5) then 
                     if (Ap15(i).LT.c_Ap15(1) .OR. 
     &                   Ap15(i).GT.c_Ap15(7)) then
		        do ieny=1,nene
	                   Flux(i,ieny) = baddata
		        enddo
		        goto 150
		     endif
	             do iap=2,7
		        if (Ap15(i).LE.c_Ap15(iap)) goto 125
	             enddo
125                   continue
                     iap=iap-1
		     ind=4+iap
		     CALL Init_CRRES(ind,afrl_crres_path,strlen)
		  endif
c
c loop on energies
                  do ieny=1,nene
		     if (energy(1,ieny).LT.c_Ec(1) .OR. 
     &                   energy(1,ieny).GT.c_Ec(Ne)) then
	                Flux(i,ieny) = baddata
                     else
	                do ie1=2,Ne
	                   if (energy(1,ieny).LE.c_Ec(ie1)) goto 140
	                enddo
140                     continue
	                do ie2=2,Ne
	                   if (energy(2,ieny).LE.c_Ec(ie2)) goto 145
	                enddo
145                     continue
                        if (c_flux(ie1,ib,il).LE.0.D0 .OR.
     &                      c_flux(ie1-1,ib,il).LE.0.D0) then
                           flux1=0.D0
		        else
	                   pente=(LOG(c_flux(ie1,ib,il))-
     &                         LOG(c_flux(ie1-1,ib,il)))/
     &                        (LOG(c_Ec(ie1))-LOG(c_Ec(ie1-1)))
                           cste=LOG(c_flux(ie1,ib,il))-
     &                          pente*LOG(c_Ec(ie1))
		           Flux1=exp(pente*LOG(energy(1,ieny))+cste)
		        endif
c
                        if (c_flux(ie2,ib,il).LE.0.D0 .OR.
     &                     c_flux(ie2-1,ib,il).LE.0.D0) then
                           flux2=0.D0
		        else
	                   pente=(LOG(c_flux(ie2,ib,il))-
     &                         LOG(c_flux(ie2-1,ib,il)))/
     &                        (LOG(c_Ec(ie2))-LOG(c_Ec(ie2-1)))
                           cste=LOG(c_flux(ie2,ib,il))-
     &                          pente*LOG(c_Ec(ie2))
		           Flux2=exp(pente*LOG(energy(2,ieny))+cste)
		        endif
		        if (ie1.ne.ie2) then
		           Flux(i,ieny)=(Flux1+c_flux(ie1,ib,il))*
     &                               (c_Ec(ie1)-energy(1,ieny))/2.D0
		           do ie=ie1,ie2-2
		              Flux(i,ieny)=Flux(i,ieny)+
     &                           (c_flux(ie,ib,il)+c_flux(ie+1,ib,il))*
     &                           (c_Ec(ie+1)-c_Ec(ie))/2.D0
		           enddo
		           Flux(i,ieny)=Flux(i,ieny)+
     &                        (c_flux(ie2-1,ib,il)+flux2)*
     &                        (energy(2,ieny)-c_Ec(ie2-1))/2.D0
		           Flux(i,ieny)=Flux(i,ieny)/(energy(2,ieny)-
     &                        energy(1,ieny))
                        else
		           Flux(i,ieny)=(Flux1+Flux2)/2.D0
		        endif
		        if (Flux(i,ieny).LE.0.D0) Flux(i,ieny)=baddata
		     endif
		  enddo
	       else
		  do ieny=1,nene
	             Flux(i,ieny) = baddata
		  enddo
	       endif
150	       continue
	    enddo
	 endif
c
c
         if (whatf.EQ. 3) then
	    DO i=1,ntmax
	       if (L(i).GE.c_Lshell(1) .AND. 
     &                    L(i).LT.c_Lshell(Nl)) then
	          do il=2,Nl
		     if (L(i).LT.c_Lshell(IL)) goto 210
	          enddo
210               continue
                  Il=Il-1
                  if (BBo(i).GT.c_bb0(Nbb0)) then
		     do ieny=1,nene
	                Flux(i,ieny) = baddata
		     enddo
		     goto 250
		  endif
	          do ib=2,Nbb0
		     if (BBo(i).LE.c_bb0(IB)) goto 220
	          enddo
220               continue
                  Ib=Ib-1
c search in Ap15bin if whichm=5
                  if (whichm .EQ. 5) then 
                     if (Ap15(i).LT.c_Ap15(1) .OR. 
     &                   Ap15(i).GT.c_Ap15(7)) then
		        do ieny=1,nene
	                   Flux(i,ieny) = baddata
		        enddo
		        goto 250
		     endif
	             do iap=2,7
		        if (Ap15(i).LE.c_Ap15(iap)) goto 225
	             enddo
225                  continue
                     iap=iap-1
		     ind=4+iap
		     CALL Init_CRRES(ind,afrl_crres_path,strlen)
		  endif
c
c loop on energies
                  do ieny=1,nene
		     if (energy(1,ieny).LT.c_Ec(1) .OR. 
     &                   energy(1,ieny).GT.c_Ec(Ne)) then
	                Flux(i,ieny) = baddata
                     else
	                do ie1=2,Ne
	                   if (energy(1,ieny).LE.c_Ec(ie1)) goto 240
	                enddo
240                     continue
c
                        if (c_flux(ie1,ib,il).LE.0.D0 .OR.
     &                     c_flux(ie1-1,ib,il).LE.0.D0) then
                           Flux1 = 0.D0
		        else
	                   pente=(LOG(c_flux(ie1,ib,il))-
     &                         LOG(c_flux(ie1-1,ib,il)))/
     &                        (LOG(c_Ec(ie1))-LOG(c_Ec(ie1-1)))
                           cste=LOG(c_flux(ie1,ib,il))-
     &                        pente*LOG(c_Ec(ie1))
		           Flux1=exp(pente*LOG(energy(1,ieny))+cste)
		        endif
c
		        if (ie1.ne.Ne) then
		           Flux(i,ieny)=(Flux1+c_flux(ie1,ib,il))*
     &                               (c_Ec(ie1)-energy(1,ieny))/2.D0
		           do ie=ie1,Ne-1
		              Flux(i,ieny)=Flux(i,ieny)+
     &                        (c_flux(ie,ib,il)+c_flux(ie+1,ib,il))*
     &                        (c_Ec(ie+1)-c_Ec(ie))/2.D0
		           enddo
                        else
		           Flux(i,ieny)=(Flux1+c_flux(Ne,ib,il))*
     &                               (c_Ec(Ne)-energy(1,ieny))/2.D0
		        endif
		        if (Flux(i,ieny).LE.0.D0) Flux(i,ieny)=baddata
		     endif
		  enddo
	       else
		  do ieny=1,nene
	             Flux(i,ieny) = baddata
		  enddo
	       endif
250	       continue
	    enddo
	 endif
         end 
!
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006 (from Don Brautigam)
!
! DESCRIPTION: Set block data for CRRES model
!              Valid range is: 1.5 <E < 81.3 MeV
!                             1. < bb0 < 684.6
!                             1. < L < 5.5
!
! INPUT: imod, 1=CRRESPRO Quiet, 2=CRRESPRO Active, 3=CRRESELE Average,
!              4=CRRESELE Worst case, 5=CRRESELE 5<Ap15<7, 6=CRRESELE 7<Ap15<10
!              7=CRRESELE 10<Ap15<15, 8=CRRESELE 15<Ap15<20,
!              9=CRRESELE 20<Ap15<25, 10=CRRESELE 25<Ap15<55 (long integer)
! OUTPUT: None
!
! CALLING SEQUENCE: call Init_CRRES(imod)
!---------------------------------------------------------------------------------------------------
       SUBROUTINE Init_CRRES(imod,afrl_crres_path,strlen)
c
       IMPLICIT NONE
       INCLUDE 'variables.inc'
c
       INTEGER*4    STRLEN
c
       INTEGER*4 ish,k,e,imod
       INTEGER*4 Ne,Nbb0,Nl
c
       REAL*8 Ec(22)
       REAL*8 bb0(35)
       REAL*8 flux(22,34,90)
       REAL*8 Lshell(91)
c
       CHARACTER*(*) afrl_crres_path
       CHARACTER*(1000) afrl_crres_path_tmp
C
       common /crres_model_int/Ne,Nbb0,Nl
       common /crres_model_dbl/Lshell,Ec,bb0,flux
c       
       if (imod .EQ. 1) then
          Ne=22
	  Nbb0=35
	  Nl=91
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     &'crrespro_quiet.txt'
c          open(10,file=afrl_crres_path(1:STRLEN)//'crrespro_quiet.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,22
	     do ish=1,90
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
          CALL Init_CRRESPRO
       endif
c
       if (imod .EQ. 2) then
          Ne=22
	  Nbb0=35
	  Nl=91
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crrespro_active.txt'
c          open(10,file=afrl_crres_path(1:STRLEN)//'crrespro_active.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,22
	     do ish=1,90
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
          CALL Init_CRRESPRO
       endif
c
       if (imod .EQ. 3) then
          Ne=10
	  Nbb0=35
	  Nl=87
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crresele_Average.txt'
c         open(10,file=
c     &afrl_crres_path(1:STRLEN)//'crresele_Average.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,10
	     do ish=1,86
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
c flux /keV in CRRESELE changed to /MeV in the lib.
	  do e=1,10
	     do ish=1,86
	        do k=1,34
	           flux(e,k,ish)=flux(e,k,ish)*1000.D0
		enddo
	     enddo
	  enddo
c
          CALL Init_CRRESELE
       endif
c
       if (imod .EQ. 4) then
          Ne=10
	  Nbb0=35
	  Nl=87
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crresele_Worst_case.txt'
c          open(10,file=
c     &afrl_crres_path(1:STRLEN)//'crresele_Worst_case.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,10
	     do ish=1,86
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
c flux /keV in CRRESELE changed to /MeV in the lib.
	  do e=1,10
	     do ish=1,86
	        do k=1,34
	           flux(e,k,ish)=flux(e,k,ish)*1000.D0
		enddo
	     enddo
	  enddo
c
          CALL Init_CRRESELE
       endif
c
       if (imod .EQ. 5) then
          Ne=10
	  Nbb0=35
	  Nl=87
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crresele_Ap1.txt'
c          open(10,file=afrl_crres_path(1:STRLEN)//'crresele_Ap1.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,10
	     do ish=1,86
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
c flux /keV in CRRESELE changed to /MeV in the lib.
	  do e=1,10
	     do ish=1,86
	        do k=1,34
	           flux(e,k,ish)=flux(e,k,ish)*1000.D0
		enddo
	     enddo
	  enddo
c
          CALL Init_CRRESELE
       endif
c
       if (imod .EQ. 6) then
          Ne=10
	  Nbb0=35
	  Nl=87
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crresele_Ap2.txt'
c          open(10,file=afrl_crres_path(1:STRLEN)//'crresele_Ap2.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,10
	     do ish=1,86
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
c flux /keV in CRRESELE changed to /MeV in the lib.
	  do e=1,10
	     do ish=1,86
	        do k=1,34
	           flux(e,k,ish)=flux(e,k,ish)*1000.D0
		enddo
	     enddo
	  enddo
c
          CALL Init_CRRESELE
       endif
c
       if (imod .EQ. 7) then
          Ne=10
	  Nbb0=35
	  Nl=87
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crresele_Ap3.txt'
c          open(10,file=afrl_crres_path(1:STRLEN)//'crresele_Ap3.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,10
	     do ish=1,86
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
c flux /keV in CRRESELE changed to /MeV in the lib.
	  do e=1,10
	     do ish=1,86
	        do k=1,34
	           flux(e,k,ish)=flux(e,k,ish)*1000.D0
		enddo
	     enddo
	  enddo
c
          CALL Init_CRRESELE
       endif
c
       if (imod .EQ. 8) then
          Ne=10
	  Nbb0=35
	  Nl=87
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crresele_Ap4.txt'
c          open(10,file=afrl_crres_path(1:STRLEN)//'crresele_Ap4.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,10
	     do ish=1,86
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
c flux /keV in CRRESELE changed to /MeV in the lib.
	  do e=1,10
	     do ish=1,86
	        do k=1,34
	           flux(e,k,ish)=flux(e,k,ish)*1000.D0
		enddo
	     enddo
	  enddo
c
          CALL Init_CRRESELE
       endif
c
       if (imod .EQ. 9) then
          Ne=10
	  Nbb0=35
	  Nl=87
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crresele_Ap5.txt'
c          open(10,file=afrl_crres_path(1:STRLEN)//'crresele_Ap5.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,10
	     do ish=1,86
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
c flux /keV in CRRESELE changed to /MeV in the lib.
	  do e=1,10
	     do ish=1,86
	        do k=1,34
	           flux(e,k,ish)=flux(e,k,ish)*1000.D0
		enddo
	     enddo
	  enddo
c
          CALL Init_CRRESELE
       endif
c
       if (imod .EQ. 10) then
          Ne=10
	  Nbb0=35
	  Nl=87
	  afrl_crres_path_tmp=afrl_crres_path(1:STRLEN)//
     & 'crresele_Ap6.txt'
c          open(10,file=afrl_crres_path(1:STRLEN)//'crresele_Ap6.txt')
          open(10,file=afrl_crres_path_tmp)
	  do e=1,10
	     do ish=1,86
	        read(10,'(34(D9.3,1x))')(flux(e,k,ish),k=1,34)
	     enddo
	  enddo
	  close(10)
c
c flux /keV in CRRESELE changed to /MeV in the lib.
	  do e=1,10
	     do ish=1,86
	        do k=1,34
	           flux(e,k,ish)=flux(e,k,ish)*1000.D0
		enddo
	     enddo
	  enddo
c
          CALL Init_CRRESELE
       endif
c
	end
c
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006 (from Don Brautigam)
!
! DESCRIPTION: Set block data for CRRES PRO model
!              Valid range is: 1.5 <E < 81.3 MeV
!                             1. < bb0 < 684.6
!                             1. < L < 5.5
!
! INPUT: None
! OUTPUT: None
!
! CALLING SEQUENCE: call Init_CRRESPRO
!---------------------------------------------------------------------------------------------------
       SUBROUTINE Init_CRRESPRO
c
       IMPLICIT NONE
c
       INTEGER*4 ish
       INTEGER*4 Ne,Nbb0,Nl
c
       REAL*8 Ec(22),tmp_Ec(22)
       REAL*8 bb0(35),tmp_bb0(35)
       REAL*8 flux(22,34,90)
       REAL*8 Lshell(91)
c
       common /crres_model_int/Ne,Nbb0,Nl
       common /crres_model_dbl/Lshell,Ec,bb0,flux
c       common /crres_model/Ne,Nbb0,Nl,Lshell,Ec,bb0,flux
c       
       data tmp_bb0 /1.000D0,1.004D0,1.020D0,1.046D0,1.085D0,1.140D0,
     >           1.200D0,1.300D0,1.400D0,1.520D0,1.690D0,1.880D0,
     >           2.100D0,2.400D0,2.730D0,3.130D0,3.670D0,4.350D0,
     >           5.02D0 ,6.1D0  ,7.410D0,9.088D0,11.29D0,14.22D0,
     >           18.16D0,23.56D0,31.07D0,41.47D0,57.23D0,80.25D0, 
     >           115.4D0,170.7D0,260.7D0,413.4D0,684.6D0/
c
       data tmp_Ec /1.5D0,2.1D0,2.5D0,2.9D0,3.6D0,4.3D0,5.7D0,
     >          6.8D0,8.5D0,
     >          9.7D0,10.7D0,13.2D0,16.9D0,19.4D0,26.3D0,30.9D0,36.3D0,
     >          41.1D0,47.0D0,55.0D0,65.7D0,81.3D0/
c
        do ish=1,35
	   bb0(ish)=tmp_bb0(ish)
	enddo
        do ish=1,22
	   Ec(ish)=tmp_Ec(ish)
	enddo
	do ish=1,91
           Lshell(ish)=1.0D0+(ish-1)*.05D0
	enddo
	end
c
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006 (from Don Brautigam)
!
! DESCRIPTION: Set block data for CRRES ELE Average model
!              Valid range is: 0.65 <E < 5.75 MeV
!                             1. < bb0 < 684.6
!                             2.5 < L < 6.8
!
! INPUT: None
! OUTPUT: None
!
! CALLING SEQUENCE: call Init_CRRESELE
!---------------------------------------------------------------------------------------------------
       SUBROUTINE Init_CRRESELE
c
       IMPLICIT NONE
c
       INTEGER*4 ish
       INTEGER*4 Ne,Nbb0,Nl
c
       REAL*8 Ec(22),tmp_Ec(22)
       REAL*8 bb0(35),tmp_bb0(35)
       REAL*8 flux(22,34,90)   !energy;bb0,Lshell
       REAL*8 Lshell(91)
c
c       common /crres_model/Ne,Nbb0,Nl,Lshell,Ec,bb0,flux
       common /crres_model_int/Ne,Nbb0,Nl
       common /crres_model_dbl/Lshell,Ec,bb0,flux
c       
       data tmp_bb0 /1.000D0,1.004D0,1.020D0,1.046D0,1.085D0,1.140D0,
     >           1.200D0,1.300D0,1.400D0,1.520D0,1.690D0,1.880D0,
     >           2.100D0,2.400D0,2.730D0,3.130D0,3.670D0,4.350D0,
     >           5.02D0 ,6.1D0  ,7.410D0,9.088D0,11.29D0,14.22D0,
     >           18.16D0,23.56D0,31.07D0,41.47D0,57.23D0,80.25D0, 
     >           115.4D0,170.7D0,260.7D0,413.4D0,684.6D0/
c
       data tmp_Ec /0.65D0,0.95D0,1.60D0,2.00D0,2.35D0,2.75D0,3.15D0,
     >          3.75D0,4.55D0,5.75D0,12*0.D0/
c
        do ish=1,35
	   bb0(ish)=tmp_bb0(ish)
	enddo
        do ish=1,22
	   Ec(ish)=tmp_Ec(ish)
	enddo
	do ish=1,87
           Lshell(ish)=2.5D0+(ish-1)*.05D0
	enddo
	do ish=88,91
           Lshell(ish)=0.D0
	enddo
	end

!***************************************************************************************************
! Copyright 1987, D. Bilitza, 2009 H. Evans
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
!
! CREATION: H. Evans European Space Agency, 1993-2009
!
! The method of interpolation used by ESA_TRARAP is documented in:
!   E.J. Daly et al, "Problems with Models of the Radiation Belts", 
!   IEEE Trans. Nucl. Sci, Vol 43, No.2, April 1996
!
! FILE CONTENT:
C      SUBROUTINE ESA_TRARA1 : Finds particle fluxes for given energies, mag field strength and L-shell
C      SUBROUTINE ESA_CrossP : computes cross product of two vectors
C      SUBROUTINE ESA_EVals  : returns the energy levels of the A*-8 particle model
C      SUBROUTINE ESA_LVals  : returns the L-shell values in the A*-8 particle models
C      SUBROUTINE ESA_BB0Val : returns the B/B0 and Log10(flux) values from an L-shell string
C      SUBROUTINE ESA_BVals  : returns the B and Log10(flux) values from an L-shell string
C      REAL*8 FUNCTION ESA_TRARAP     : Finds particle flux for given B and L from a model energy string
C      REAL*8 FUNCTION ESA_INTERP     : linearly interpolates between 3 points in 3d space
C      REAL*8 FUNCTION ESA_DotP       : calculates the scalar product of two vectors
C      LOGICAL FUNCTION ESA_InPoly    : Returns TRUE/FALSE if XY coords of a point are within a polygon
C                                       described by 3 points
C      REAL*8 FUNCTION ESA_XINTER     : linearly interpolates between (x1,y1) and (x2,y2)
C      INTEGER*4 FUNCTION ESA_LStrng  : returns the index in the energy string of the 
C                                       retuired L value string
C      REAL*8 FUNCTION ESA_XPHI       : computes the hybrid magnetic field coordinate
C      REAL*8 FUNCTION ESA_B0         : computes B0 for an L value using McIlwain's magnetic moment.
!
!***************************************************************************************************
      SUBROUTINE ESA_TRARA1(DESCR, MAP, FL, BoB0, E, F)
C***********************************************************************
C     B / B0 CASE     JOEL STEIN     9-15-71     X2133     KMS
C   ESA_TRARA1 DOES ENERGY VALUE SEARCH FOR FLUX CALCULATION WHEN GIVEN A
C    B AND L POINT.
*  Modified version based on Kluge and Lenhart ESOC Int. Note 78 (1971)
*  
*  Modified    APRIL 1988 E.J. DALY ESA/ESTEC/WMA
*                         can pick up geomagnetic dipole moment GMAGMO
*                         from common block and use it in place of
*                         McIlwain's value of .311653
*                         GMAGMO is passed from the geomagnetic
*                         coordinate program.
*                         Default for models should be McIlwain's value
*
*  Modified    JULY  1993 H.D.R. EVANS    ESA/ESTEC/WMA
*                         Kluge and Lenhart interpolation method in
*                         (B/B0,L) space changed to a linear polygon
*                         interpolation method in (Phi,L) space.
*
C***********************************************************************
C MAP(1) is the first word of list

      IMPLICIT NONE

      LOGICAL S0, S1, S2
C S0,S1,S2 are logical variables which indicate whether the flux for a
C particular E,B,L point has already been found in a previous call
C to ESA_TRARAP.

      REAL*8 E, F, FL, BOB0
      REAL*8 E0, E1, E2, F0, F1, F2
      REAL*8 ESA_B0, ESA_TRARAP
      REAL*4 DESCR(8)
      INTEGER*4 MAP(*), N, NB, NL, I0, I1, I2, I3, L3, IE

C      PRINT*,'ESA_TRARA1:', FL, BoB0, E

      NL = MIN(32766.0D0, ABS(FL*DBLE(DESCR(5))))
C max B/B0 allowed here is 1000 (protect against integer overflow)
C      BOB0 = MIN( BABS/ ESA_B0(FL), 1000.0D0)

      IF (BOB0 .LT. 1.0D0) BOB0 = 1.0D0
        
C force any possible representational errors to 1.0
      BoB0 = MAX(BoB0, 1.0D0)

      NB = ABS((BOB0-1.0)*DESCR(6))
C NL is the minimum of the L value or 15.999, scaled to an integer by
C THE L SCALING FACTOR
C NB IS THE DIFFERENCE BETWEEN THE INPUT B VALUE AND B EQUATORIAL,
C SCALED TO AN INTEGER BY THE B SCALING FACTOR.
      I1 = 0
      I2 = MAP(1)
      I3 = I2 + MAP(I2+1)
      L3 = MAP(I3+1)
      E1 = MAP(I1+2) / DESCR(4)
      E2 = MAP(I2+2) / DESCR(4)
      S1 = .TRUE.
      S2 = .TRUE.

C I2 IS THE NUMBER OF ELEMENTS IN THE FLUX MAP FOR THE FIRST ENERGY.
C I3 IS THE INDEX OF THE LAST ELEMENT OF THE SECOND ENERGY MAP.
C L3 IS THE LENGTH OF THE MAP FOR THE THIRD ENERGY.
C E1 IS THE ENERGY OF THE FIRST ENERGY MAP (UNSCALED)
C E2 IS THE ENERGY OF THE SECOND ENERGY MAP (UNSCALED)
C S1 AND S2 ARE TRUE TO INDICATE THAT NO FLUXES HAVE YET BEEN FOUND.
C THE DO STATEMENT LOOPS THROUGH THE ENERGIES FOR WHICH FLUXES ARE
C DESIRED AT THE GIVEN B,L POINT (BABS,FL).
 1      IF ((E .LE. E2) .OR. (L3 .EQ. 0)) GO TO 2
C THE IF STATEMENT CHECKS TO SEE IF THE INPUT ENERGY IS LESS THAN OR E
C THE ENERGY OF THE SECOND MAP, OR IF THE LENGTH OF THE THIRD MAP IS 0.
C (I.E. THERE ARE NO HIGHER ENERGIES IN THE TABLE).  IF TRUE, USE TH
C FOR THOSE TWO ENERGY MAPS TO FIND THE DESIRED FLUX AT THE DESIRED
C ENERGY.  IF FALSE, THE ZEROTH ENERGY MAP IS DEFINED TO BE TNE FIRS
C ENERGY MAP, THE FIRST BECOMES THE SECOND, AND THE SECOND BECOMES
C THE THIRD.  E0,E1,E2 ARE THE ENERGIES FOR THE ZEROTH,FIRST,AND SEC
C ENERGY MAPS.  F0,F1,F2 ARE THE FLUXES FOR THE ZEROTH, FIRST, AND
C SECOND ENERGY MAPS AT THE B,L POINT.
        I0 = I1
        I1 = I2
        I2 = I3
        I3 = I3 + L3
        L3 = MAP(I3+1)
        E0 = E1
        E1 = E2
        E2 = MAP(I2+2) / DESCR(4)
        S0 = S1
        S1 = S2
        S2 = .TRUE.
        F0 = F1
        F1 = F2
        GO TO 1
 2      IF (S1) F1 = ESA_TRARAP(DESCR, MAP(I1+1), FL, BoB0)
        IF (S2) F2 = ESA_TRARAP(DESCR, MAP(I2+1), FL, BoB0)
C THESE TWO LOGICAL IFS CALL ESA_TRARAP FOR THE FLUX FROM THE FIRST AND
C SECOND ENERGY MAPS AT THE B,L POINT IF THEY HAVE NOT ALREADY BEEN
        S1 = .FALSE.
        S2 = .FALSE.
C S1 AND S2 ARE FALSE SINCE F1 AND F2 ARE NOW FOUND.
        F = F1 + (F2-F1) * (E-E1) / (E2-E1)
C INTERPOLATE FOR THE FLUX F(IE) USING THE FLUXES AND ENERGIES FOR MAP
C ONE AND TWO.
C THE FOLLOWING COMMENTS APPLY TO THE REMAINING PROGRAM STATEMENTS.
C IF THE FLUX F2 FOR THE SECOND ENERGY MAP IS GREATER THAN ZERO, OR TH
C ZEROTH ENERGY MAP HAS NOT BEEN DEFINED, THE FINAL FLUX IS THE MAXI
C OF THE INTEROOLATED FLUX OR ZERO.  IF THE FLUX FOR THE SECOND ENER
C MAP IS EQUAL TO ZERO, AND THE ZEROTH ENERGY MAP HAS BEEN DEFINED,
C THEN INTERPOLATE FOR THE FLUX USING THE ZEROTH AND FIRST ENERGY MA
C CHOOSE THE MINIMUM OF THE TWO INTERPOLATIONS, AND THEN THE MAXIMUM
C CHOICE AND ZERO FOR THE FINAL FLUX VALUE.
        IF ((F2 .LE. 0.0D0) .AND. (I1 .NE. 0)) THEN
          IF (S0) F0 = ESA_TRARAP(DESCR, MAP(I0+1), FL, BoB0)
          S0 = .FALSE.
          F = MIN(F, F0+(F1-F0)*(E-E0)/(E1-E0))
        END IF
        F = MAX(F, 0.0D0)
C      END DO
C      PRINT*,'ESA_TRARA1:', FL, BoB0, E,F

      RETURN
      END
C
C************************************************************************ 
C 
C    REAL*8 FUNCTION ESA_TRARAP 
C 
C     PURPOSE:    This function converts the B argument to a hybrid 
C                 value, defined by Phi = ASIN( ( B - B0) / (Bmax- B0)) 
C                 and interpolates the MAP in (PHI-L) space. 
C 
C    
C
C
C     METHOD:     The conversion to the Phi-L space requires the
C                 maximum B value. This is obtained by interpolating
C                 between the maximum B values for  the L strings
C                 that subtend the L value passed to the routine.
C
C                 The Flux at the Phi point along the two L strings
C                 is determined by  locating the three model points
C                 that form a polygon (triangle) that contains the
C                 (L,Phi) point.  The interpolation is then performed
C                 by a linear interpolation using the slope of the
C                 plane in (L,Phi,lnF) space.
C
C     HISTORY:    CREATED July 1993    H.D.R. Evans ESA/ESTEC/WMA
C
C************************************************************************

      REAL*8 FUNCTION ESA_TRARAP(HEADER, MAP, L, BoB0) 

      IMPLICIT NONE 

      REAL*4 HEADER(*)
      REAL*8 BoB0, L, B, Phi 
      INTEGER*4 MAP(*)
      REAL*8 Model(3,100,2), Ls(100), Bs(100), Fluxes(100), Bm(2), bo
      REAL*8 Verts(3,3), ReqPt(3)
      INTEGER*4 ESA_LStrng, Lpos(2), Llen, Blen(2), Li, I, J
      INTEGER*4 s(2), N(2), string, other, tmp
      LOGICAL Found, EndStr
      REAL*8 ESA_XPHI, ESA_B0, ESA_XINTER, ESA_INTERP
      LOGICAL ESA_INPOLY

      IF (BoB0 .LT. 1.0) THEN
        ESA_TRARAP = 0.0
        RETURN
      END IF

      B = BoB0 * ESA_B0(L)
      CALL ESA_LVals(MAP, header, Ls, Llen)

C Find the two L strings that subtend the L value we are given...
      DO Li=1,Llen-2
        IF (L .LE. Ls(Li+1)) GO TO 6
      END DO
 6    CONTINUE

C Get the Maximum B values for the two L strings.  Allows us to
C linearly interpolate to find the maximum B value for the given 
C L value.
      DO i=1,2
        Lpos(i) = ESA_LStrng(MAP, Header, Ls(Li+i-1), Llen) + 1
        CALL ESA_BVals(MAP(Lpos(i)), Header, Bs, Fluxes, Blen(i))
        Bm(i) = Bs(Blen(i))
        Bo = ESA_B0(Ls(li+i-1))
        IF (Bo .GT. 0.0) THEN
          DO j=1,Blen(i)
            Model(1,j,i) = Ls(Li+i-1)
            Model(2,j,i) = ESA_XPHI(Bs(j)/Bo, Bm(i)/Bo) 
            Model(3,j,i) = Fluxes(j)
          END DO
        ELSE
          Blen(i) = 1 
          Model(1,1,i) = Ls(Li+i-1)
          Model(2,1,i) = -1.0
          Model(3,1,i) = 0.0
        END IF
      END DO
      Bo = ESA_B0(L)
      Phi = ESA_XPHI(B/Bo, ESA_XINTER(L,Ls(Li),Bm(1),Ls(Li+1),Bm(2))/Bo)

C Check for an invalid Phi value, e.g. if B > Bmax
      IF (Phi .LT. 0.0) THEN
        ESA_TRARAP = 0.0
        RETURN
      END IF

C If length of both strings is 1, then linear interpolation between
C points and return
      IF ((blen(1) .EQ. 1) .AND. (blen(2) .EQ. 1)) THEN
        ESA_TRARAP = (L-Model(1,1,1)) * (Model(3,1,2)-Model(3,1,1)) /
     &           (Model(1,1,2) - Model(1,1,1))
        IF (ESA_TRARAP .GT. 0.0) ESA_TRARAP = (ESA_TRARAP)
        RETURN
      END IF

C Now find the H values in both L strings that subtend the required point.
      ReqPt(1) = L
      ReqPt(2) = Phi
      S(1) = 1
      S(2) = 1
      N(1) = MIN(S(1)+1, blen(1))
      N(2) = MIN(S(2)+1, blen(2))

 10   EndStr = (s(1) .EQ. blen(1)) .AND. (s(2) .EQ. blen(2))
      IF (.NOT. EndStr) THEN
        IF (S(1) .EQ. blen(1)) THEN
C String 1 is empty, have to use string 2 now.
          string = 2
          other = 1
        ELSE IF (S(2) .EQ. blen(2)) THEN
C String 2 is empty, have to use string 1.
          string = 1
          other = 2
        ELSE
          IF (Model(2,N(1),1) .LT. Model(2,N(2),2)) THEN
            string = 1
            other = 2
          ELSE
            string = 2
            other = 1
          END IF
        END IF
        Found = ESA_INPOLY(model(1,s(string),string),
     &                 model(1,s(other),other),
     &                 model(1,N(string),string), ReqPt)
        IF (.NOT. Found) THEN
            s(string) = N(string) 
            N(string) = MIN(N(string)+1, blen(String))
        END IF
      END IF

      IF (.NOT. (Found .OR. EndStr)) GO TO 10

C Repeat this UNTIL end of both strings or poly found
C Now check for end of string condition, requires backing up and
C using a previous point.
      IF (EndStr) THEN
        IF (blen(1) .EQ. 1) THEN
          string = 2
          other = 1
        ELSE IF (blen(2) .EQ. 1) THEN
          string = 1
          other = 2
        ELSE IF (Model(2,s(string)-1,string) .LT.
     &           Model(2,s(other)-1,other)) THEN
          tmp = other
          other = string
          string = tmp
        END IF
        n(string) = s(string) - 1
      END IF
      DO j=1,3
        verts(j,1) = Model(j,s(string),string)
        verts(j,2) = Model(j,s(other),other)
        verts(j,3) = Model(j,n(string),string)
      END DO
      ESA_TRARAP = ESA_INTERP(verts, ReqPt)
      IF (ESA_TRARAP .GT. 0) ESA_TRARAP = (ESA_TRARAP)

      RETURN
      END      
C
C***********************************************************************
C
C     REAL*8 FUNCTION ESA_INTERP
C
C     PURPOSE:    Interpolates between 3 points in 3D space.
C
C     METHOD:     Constructs function of a plane containing the 3 points
C                 and calculates the Z value for the given (X,Y) point.
C
C     HISTORY:    CREATED     July 1993      H.D.R. Evans
C
C***********************************************************************

      REAL*8 FUNCTION ESA_Interp(GPnts, ReqPnt)

      IMPLICIT NONE

C      INCLUDE 'interface.h'

      REAL*8 GPnts(3,*), ReqPnt(3)
      REAL*8 v1(3), v2(3), plane(4), ESA_DotP
      INTEGER*4 I, n /3/, incx /1/, incy /1/

      ESA_Interp = 0.0
C Compute vectors in plane of three points.
      DO i=1,3
        v1(i) = GPnts(i,2) - GPnts(i,1)
        v2(i) = GPnts(i,3) - GPnts(i,1)
      END DO
C Determine normal to plane defined by v1 and v2, and plane constant.
C plane(1)x + plane(2)y + plane(3)z = plane(4)
      call ESA_CrossP(v1, v2, plane, n)
      plane(4) = ESA_DotP(n, GPnts(1,1), incx, plane, incy)
C Value we require is the Z value at the point specified
C by the solution of:
C Z = (plane(4) - Plane(1)x - Plane(2)y ) / Plane(3)
      IF (Plane(3) .NE. 0.0) THEN
        ESA_Interp = (Plane(4)-Plane(1)*ReqPnt(1)-Plane(2)*ReqPnt(2)) /
     &           Plane(3)
      ELSE
C        CALL ERR_WRITE(' Plane with 3 given points is independent of Z')
      END IF

      RETURN
      END
C
C***********************************************************************
C
C     Subroutine ESA_CrossP
C
C     PURPOSE:    Takes the cross product of the two vectors.
C
C     METHOD:     Basic vector calculations.  Vectors must be the
C                 same size.
C
C     HISTORY:    CREATED     July 1993      H.D.R. Evans ESA/ESTEC/WMA
C
C***********************************************************************

      SUBROUTINE ESA_CrossP(X, Y, Z, DIM)

      IMPLICIT NONE

C X   - 1st vector
C Y   - 2nd vector
C Z   - crossproduct = X^Y
C DIM - dimension of X, Y and Z

      REAL*8 X(*), Y(*), Z(*), magZ
      INTEGER*4 DIM, I, J, INDX

      INDX(J) = MOD(J+DIM-1, DIM) + 1
      DO I=1,DIM
        magZ = 0.0
        Z(I) = X(INDX(I+1)) * Y(INDX(I+2)) - X(INDX(I+2)) * Y(INDX(I+1))
      END DO

      RETURN
      END
C
C***********************************************************************
C
C     REAL*8 FUNCTION ESA_DotP
C
C     PURPOSE:    Returns the inner (dot) product of SX and SY.
C
C     METHOD:     Basic vector calculations.  Vectors must be the
C                 same size.
C
C     HISTORY:    CREATED     July 1993      H.D.R. Evans ESA/ESTEC/WMA
C
C***********************************************************************

      REAL*8 FUNCTION ESA_DotP(N, sx, incx, sy, incy)

      IMPLICIT NONE

      REAL*8 sx(*), sy(*)
      INTEGER*4 N, incx, incy
      INTEGER*4 I, J, k, l, POS

      pos(i, j) = (i-1) * j + 1

      k = incx
      l = incy
      ESA_DotP = 0.0
      DO i=1,n
        ESA_DotP = ESA_DotP + sx(pos(i, k)) * sy(pos(i, l))
      END DO

      return
      end
C
C***********************************************************************
C
C     LOGICAL FUNCTION ESA_InPoly
C
C     PURPOSE:    Returns .TRUE. if the (X,Y) coordinates of point Pt 
C                 is in the polygon described by the points A,B,and C
C
C     METHOD:     Pts is decomposed into the sum of the line segments 
C                 AC and BC, i.e. PTS = a * AC + b * BC.  If either a 
C                 or b is less than zero, then PTS is not subtended by 
C                 the lines AC & BC.
C
C                 This is then repeated for the AB and CB line segements 
C                 to ensure PTS isn't the other side of the AB line from C.
C
C     HISTORY:    CREATED     July 1993      H.D.R. Evans ESA/ESTEC/WMA
C
C***********************************************************************

      LOGICAL FUNCTION ESA_InPoly(A, B, C, Pt)

      IMPLICIT NONE

C      INCLUDE 'interface.h'

      REAL*8 A(2), B(2), C(2), Pt(2)
      REAL*8 M(2,2), IM(2,2), PO(2), coeff(2), DET
      INTEGER*4 I

C Initialise the matrix
      DO i=1,2
        M(1,i) = A(i) - C(i)
        M(2,i) = B(i) - C(i)
        PO(i) = Pt(i) - C(i)
      END DO
      det = M(1,1) * M(2,2) - M(1,2) * M(2,1)
      IF (det .eq. 0.0) go to 999

      IM(1,1) = M(2,2)
      IM(2,2) = M(1,1)
      IM(1,2) = -M(2,1)
      IM(2,1) = -M(1,2)
      Coeff(1) = (IM(1,1)*PO(1)+IM(1,2)*PO(2)) / DET
      Coeff(2) = (IM(2,1)*PO(1)+IM(2,2)*PO(2)) / DET
      ESA_InPoly = (coeff(1) .GE. 0.0) .AND. (Coeff(2) .GE. 0.0)
C Repeat the previous, only this time with the end point.
      DO i=1,2
        M(1,i) = B(i) - A(i)
        M(2,i) = C(i) - A(i)
        PO(i) = Pt(i) - A(i)
      END DO
      det = M(1,1) * M(2,2) - M(1,2) * M(2,1)
      IF (det .eq. 0.0) go to 999
      IM(1,1) = M(2,2)
      IM(2,2) = M(1,1)
      IM(1,2) = -M(2,1)
      IM(2,1) = -M(1,2)
      Coeff(1) = (IM(1,1)*PO(1)+IM(1,2)*PO(2)) / DET
      Coeff(2) = (IM(2,1)*PO(1)+IM(2,2)*PO(2)) / DET
      ESA_InPoly = (coeff(1) .GE. 0.0) .AND. (Coeff(2) .GE. 0.0)
     &          .AND. ESA_INPOLY
      RETURN

 999  ESA_InPoly = .FALSE.
C      CALL ERR_WRITE(' ***INPOLY*** Determinant = 0')

      END
C
C***********************************************************************
C
C     REAL*8 FUNCTION ESA_XINTER
C
C     PURPOSE:    Linearly interpolates between (x1,y1) and (x2,y2).
C
C     METHOD:     simple linear interpolation.
C
C     HISTORY:    CREATED     July 1993      H.D.R. Evans ESA/ESTEC/WMA
C
C***********************************************************************

      REAL*8 FUNCTION ESA_XINTER(X, X1, Y1, X2, Y2)

      IMPLICIT NONE

      REAL*8 X, X1, X2, Y1, Y2

      IF (X2 .NE. X1) THEN
        ESA_XINTER = y1 + (x-x1) * (y2-y1) / (x2-x1)
      ELSE
        ESA_XINTER = Y1
      END IF

      RETURN
      END

C***********************************************************************
C
C     INTEGER*4 FUNCTION ESA_LStrng
C
C     Returns the index in the Energy string (ESTR)
C     that the requested L string starts.
C     
C***********************************************************************

      INTEGER*4 FUNCTION ESA_LStrng(ESTR, Header, L, len)

      IMPLICIT NONE

      INTEGER*4 index, len
      INTEGER*4 ESTR(*)
      REAL*4 Header(*)
      REAL*8 L, MapL

C SLEN  - Position in the E string of the E string length
C LPOS  - Offset in the L string of the L value
C LSCL  - Position in the header of the L scale factor

      INTEGER*4 SLEN, LPOS, LSCL
      DATA SLEN, LPOS, LSCL /1, 1, 5/

C index = position of the first L string in the E string
      index = 3
      MapL = 0.0

      IF (L .EQ. 0.0) THEN
        ESA_LStrng = index - 1
        return
      END IF

 10   IF ((L .LE. MapL) .OR. (index .GT. ESTR(SLEN))) GO TO 20
      len = ESTR(index)
      MapL = ESTR(index+Lpos) / HEADER(LSCL)
      IF (L .GT. MapL) index = index + len
      GO TO 10
 20   ESA_LStrng = index - 1
 
      RETURN
      END      
C
C***********************************************************************
C
C     ESA_EVals
C
C     Searches through the Ax8 model for all of the energies it contains.
C
C***********************************************************************

      SUBROUTINE ESA_EVals(MAP, Header, E, Npts, iE)

      IMPLICIT NONE

      INTEGER*4 MAP(*)
      REAL*4 HEADER(*)
      REAL*8 E(*)
      INTEGER*4 NPTS, iE(*)

C ESCL   : Position in the Header of the energy scale factor
C MAPLEN : Position in the Header of the total map length

      INTEGER*4 ESCL, MAPLEN
      INTEGER*4 INDEX
      DATA ESCL, MAPLEN /4, 8/   
      
      index = 1
      Npts = 0

 10   Npts = Npts + 1
      iE(Npts) = index+1
      E(Npts) = MAP(index + 1) / HEADER(ESCL)
      index = index + MAP(index)    
      IF ((index .LE. HEADER(MAPLEN)) .AND. (MAP(index) .NE. 0)) GOTO 10

      RETURN
      END
C
C***********************************************************************
C
C     ESA_LVals
C
C     Searches through the Energy string for all of the L values 
C     it contains.
C
C***********************************************************************

      SUBROUTINE ESA_LVals(ESTR, Header, L, Npts)

      IMPLICIT NONE

      INTEGER*4 ESTR(*), NPTS
      REAL*4 HEADER(*)
      REAL*8 L(*)

C SLEN  - Position in the E string of the E string length
C LPOS  - Offset in the L string of the L value
C LSCL  - Position in the header of the L scale factor

      INTEGER*4 SLEN, LPOS, LSCL, INDEX
      DATA SLEN, LPOS, LSCL /1, 1, 5/

      index = 3
      Npts = 0

 10   IF (index .GE. ESTR(SLEN)) RETURN
      Npts = Npts + 1
      L(Npts) = ESTR(index + LPOS) / HEADER(LSCL)
      index = index + ESTR(index)
      GO TO 10
 
      END
C
C***********************************************************************
C
C     ESA_BB0Val
C
C     Returns the BoBo and Log10(flux) values contained in the L string
C     (MAP)
C
C***********************************************************************

      SUBROUTINE ESA_BB0Val(LSTR, Header, BoB0, lnFlux, Npts)

      IMPLICIT NONE

      INTEGER*4 LSTR(*), NPTS, LEN, I
      REAL*4 HEADER(*)
      REAL*8 BoB0(*), lnFlux(*)

C SLEN   - Position in the B string of the B string length
C LPOS   - Offset in the L string of the L value
C LSCL   - Position in the header of the L scale factor
C FlxSCL - Position in the Header of the lnFlux scale factor
C FlxInc - Unscaled increment in B between string values
C FlxOff - Offset in B string of the B0 lnFlux value

      INTEGER*4 SLEN, BSCL, FlxSCL, FlxInc, FlxOff
      DATA SLEN, BSCL, FlxSCL, FlxInc, FlxOff /1, 6, 7, -256, 3/

      Npts = 1
      LEN = LSTR(SLEN)
      BoB0(1) = 1.0
      lnFlux(1) = LSTR(Flxoff) / HEADER(FlxScl)

      IF (LEN .LT. 4) RETURN

      Npts = 0
      i = 4

 10   IF ((i .GT. LEN) .OR. (LSTR(i) .LE. 0)) RETURN
      Npts = Npts + 1
      lnFlux(i-2) = (LSTR(FlxOff)+FlxInc*(i-FlxOff)) / HEADER(FlxSCL)
      BoB0(i-2) = BoB0(i-FlxOff) + LSTR(i) / HEADER(BSCL)
      i = i + 1
      GO TO 10

      end
C
C***********************************************************************
C
C     ESA_BVals
C
C     Returns the B and Log10(flux) values contained in the L string
C     (MAP)
C
C***********************************************************************

      SUBROUTINE ESA_BVals(LSTR, Header, B, lnFlux, Npts)

      IMPLICIT NONE

      INTEGER*4 LSTR(*), NPTS
      REAL*4 HEADER(*)
      REAL*8 B(*), lnFlux(*)
      REAL*8 BoB0(40), L, Bo, ESA_B0 

C LPOS - Position in L string of the L value
C LSCL - Position in the Header of the L scale factor

      INTEGER*4 LPOS, LSCL, I
      DATA LPOS, LSCL /2, 5/

      L = LSTR(LPOS) / Header(LSCL)
      CALL ESA_BB0Val(LSTR, Header, BoB0, lnFlux, Npts)
      Bo = ESA_B0(L)

      DO i=1,Npts
        B(i) = BoB0(i) * Bo
        IF (B(i) .EQ. 0.0) lnFlux(i) = 0.0
      END DO
   
      return
      end
C
C****************************************************************************
C
C     REAL*8 FUNCTION ESA_XPHI
C     
C     Computes the hybrid magnetic field coordinate=
C
C                   ( B/B0 - 1     )
C     ESA_XPHI= ASIN( --------     )
C                   ( Bmax/B0 - 1  )
C
C     Where Bmax is the atmospheric cutoff value for B.
C     If Bmax = 1, then ESA_XPHI = 90. ( Arcsin( 1.0) )
C
C****************************************************************************

      REAL*8 FUNCTION ESA_XPHI(BoB0, BMax)

      IMPLICIT NONE

      REAL*8 BoB0, BMax
      REAL*8 sine, RADDEG

      RADDEG = 45.0 / ATAN(1.0)
C ARCSIN( >1.0) --- BoB0 beyond the atmospheric cut off.
      IF (Bob0 .GT. BMax) then
        ESA_XPHI = -1.0                 
        RETURN
      END IF

      IF (BMax .NE. 1.0) THEN
         SINE = (BoB0-1.0) / (BMax-1.0)
         IF ((-1.0 .LE. SINE) .AND. (SINE .LE. 1.0)) THEN
           ESA_XPHI = ASIN(SINE) * RADDEG
         ELSE
           ESA_XPHI = -1.0
         END IF
      ELSE
         ESA_XPHI = -1.0
      END IF

      return
      END
C
C****************************************************************************
C
C     REAL*8 FUNCTION ESA_B0
C
C     computes the magnetic field strength for an L shell at the magnetic
C     equator.
C
C****************************************************************************

      REAL*8 FUNCTION ESA_B0(L)
      IMPLICIT NONE
      REAL*8 L

      IF (L .GT. 0.0) THEN
        ESA_B0 = 0.311653 / (L*L*L) ! McIlwain's magnetic moment 0.311653 Gauss
      ELSE
        ESA_B0 = 0.0
      END IF

      RETURN
      END

!***************************************************************************************************
! Copyright 2004 D. Vallado
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
* ---------------------------------------------------------------------
*http://www.centerforspace.com/downloads/files/pubs/AIAA%202006-6753%20Revisiting%20Spacetrack%20Report%203.pdf
*                              TESTFOR.FOR
*
*  this program tests the sgp4 propagator.
*
*                          companion code for
*             fundamentals of astrodynamics and applications
*                                  2004
*                            by david vallado
*
*     (w) 719-573-2600, email dvallado@agi.com
*     *****************************************************************
*  current :
*            15 aug 06  david vallado
*                        update mfe for verification time steps, constants
*  changes :
*            20 jul 05  david vallado
*                         fixes for paper, corrections from paul crawford
*             7 jul 04  david vallado
*                         fix record file and get working
*            14 may 01  david vallado
*                         2nd edition baseline
*                   97  nasa
*                         internet version
*                   80  norad
*                         original baseline
*     *****************************************************************
*
*  Files         :
*    Unit 10     - input elm file  input file for element sets
*    Unit 11     - sgp4test.out    output file
*    Unit 14     - sgp4test.dbg    debug output file
*    Unit 15     - sgp4rec.bak     temporary file of record for 2 line element sets
*
*  Uses object files:
*    Sgp4ext,
*    Sgp4io,
*    Sgp4unit

      SUBROUTINE SGP4_ORB1(Yr,Mon,Day,Hr,Minute,Sec,inclination,
     &     perigee,apogee,AscendingNode,Argument_Perigee,MeanAnomaly,
     &     startsfe,stopsfe,deltasec,sysaxes,OutputArray)
        IMPLICIT NONE
        INCLUDE 'ntime_max.inc'
c   TBG, 3.27.07:  added input argument sysaxes for internal rotation.
        INTEGER*4 k, error, whichconst,strlenOut,istep,sysaxes
        INTEGER*4 i,j, Year,yr,mon,day,hr,min,doy,GET_DOY,isec
	INTEGER*4 Minute,numberOfOutputLines
c
c        BYTE      OutFileByte(strlenOut)
c
        Real*8 ro(3),vo(3), startmfe, stopmfe, deltamin
        REAL*8 p, ecc, incl, node, argp, nu, m,arglat,truelon,lonper

* ----------------------------  Locals  -------------------------------
        REAL*8 J2,TwoPi,Rad,RadiusEarthKm,VKmPerSec, xke,
     &         de2ra, xpdotp, T, sec, JD, pi, j3, j4, j3oj2, tumin
	REAL*8  secs,xGEI(3),xGEO(3),xOUT(3),alti,lati,longi,dec_y
        REAL*8 inclination,perigee,apogee,AscendingNode
	REAL*8 Argument_Perigee,MeanAnomaly,BC,mu
        Real*8 startsfe, stopsfe, deltasec
        REAL*8 outputArray(10,ntime_max)
c
c
c        Character*500 OutFileName


        INCLUDE 'SGP4.CMN'

        COMMON /DebugHelp/ Help
        CHARACTER Help
        Help = 'N'

* ------------------------  Implementation   --------------------------
c changed input times from minute to seconds by SB. The first
c 3 lines change it back to minutes to be compliant with SGP4 code.
        startmfe=startsfe/60.0D0
        stopmfe=stopsfe/60.0D0
        deltamin=deltasec/60.0D0
        numberOfOutputLines = (stopmfe - startmfe) / deltamin
c        write(*,*) 'Input whichconst - 721, 72, 84'
c        read(*,*) whichconst
        whichconst=84
	SatNum=00000
c
        TwoPi         =    6.28318530717959D0
        Rad           =   57.29577951308230D0
        DE2RA         =    0.01745329251994330D0
        pi            =    3.14159265358979D0
        xpdotp        =  1440.0 / (2.0 *pi)  ! 229.1831180523293D0
        mu     = 398600.8D0            ! in km3 / s2

        ! sgp4fix identify constants and allow alternate values
        CALL getgravconst( whichconst, tumin, radiusearthkm, xke, j2,
     &       j3, j4, j3oj2 )
        VKmPerSec     =  RadiusEarthKm * xke/60.0D0

c        DO i=1,strlenOut
c	   OutFileName(i:i)=char(OutFileByte(i))
c	ENDDO
c        OutFileName=OutFileName(1:strlenOut) ! added by TPO
c        OPEN(11,FILE = OutFileName ,STATUS='UNKNOWN',
c     &      ACCESS = 'SEQUENTIAL' )
        ! ----------------- Test simple propagation -------------------

	Inclo=inclination
	nodeo=AscendingNode
	Ecco=(apogee-perigee)/(apogee+perigee+2.D0*RadiusEarthKm)
	Argpo=Argument_Perigee
	Mo=MeanAnomaly
Cwrong	No=(24.D0/1.4D0)/(SQRT(
Cwrong     &  (0.5D0*(apogee+perigee+2.D0*RadiusEarthKm)/RadiusEarthKm)**3))
	a = 0.5D0*(apogee+perigee+2.D0*RadiusEarthKm)
	No=(43200.D0/PI) * SQRT(mu/a**3)
	a = a/RadiusEarthKm

	BSTAR=0.D0
*
* ---------------------- CONVERT TO INTERNAL UNITS --------------------
* ---- RADIANS, DISTANCE IN EARTH RADII, AND VELOCITY IN ER/KEMIN) ----
        No     = No / XPDOTP
Cxxxx        a      = (No*TUMin)**(-2.0D0/3.0D0)
        Inclo  = Inclo  * DE2RA
        nodeo  = nodeo * DE2RA
        Argpo  = Argpo * DE2RA
        Mo     = Mo   * DE2RA

        IF (DABS(Ecco-1.0D0) .gt. 0.000001D0) THEN
            Altp= (a*(1.0D0-Ecco))-1.0D0
            Alta= (a*(1.0D0+Ecco))-1.0D0
          ELSE
            Alta= 999999.9D0
            Altp= 2.0D0* (4.0D0/(No*No)**(1.0D0/3.0D0))
          ENDIF

        ! ---- Ballistic Coefficient ----
        IF (DABS(BStar) .gt. 0.00000001D0) THEN
            BC= 1.0D0/(12.741621D0*BStar)
          ELSE
            BC= 1.111111111111111D0
        ENDIF
*
        ! ----------------------------------------------------------------
        ! find sgp4epoch time of element set
        ! remember that sgp4 uses units of days from 0 jan 1950 (sgp4epoch)
        ! and minutes from the epoch (time)
        ! ----------------------------------------------------------------
*
        CALL JDAY ( Yr,Mon,Day,Hr,Minute,Sec,  JDSatEpoch )
*
* ------------------- MAKE INITIAL PREDICTION AT EPOCH ----------------
        ! 2433281.5 - 2400000.5 = 33281.0, thus time from 1950
*
        CALL SGP4Init( whichconst,
     &                 SatNum,BStar, Ecco, JDSatEpoch-2433281.5D0,
     &                 Argpo,Inclo,Mo,No, nodeo, Error )
        IF(Error .GT. 0) WRITE( *,*) '# *** SGP4 Model Error ***',Error

*
* ------------------- PROPAGATE ----------------
        ! 2433281.5 - 2400000.5 = 33281.0, thus time from 1950
*
        T = 0.0D0
        CALL SGP4 ( whichconst, T, Ro, Vo, Error )

        ! now initialize time variables
        T      = startmfe

        ! check so the first value isn't written twice
        IF ( DABS(T).gt.0.00000001D0 ) THEN
            T = T - DeltaMin
        ENDIF

        istep = 0
        DOWHILE ( (T.lt.stopmfe).and.(Error.eq.0) )
           istep = istep + 1
           T = T + DeltaMin
           IF (T.gt.stopmfe) THEN
               T = stopmfe
           ENDIF
           CALL SGP4 ( whichconst, T, Ro, Vo, Error )

           IF (Error .gt. 0 ) THEN
               Write(*,*) '# Error in SGP4 .. ',Error
           ENDIF

           IF ( error .eq. 0) THEN
              JD = JDSatEpoch + T/1440.0D0
              CALL INVJDAY( JD, Year,Mon,Day,Hr,Min, Sec )
              IF (Year.ge.2000) THEN
                 Yr = Year - 2000
              ELSE
                 Yr = Year - 1900
              ENDIF
c
	      DOY = GET_DOY(Year,Mon, Day)
	      secs=3600.D0*Hr+60.D0*Min+1.D0*Sec
	      xGEI(1)=ro(1)/6371.2D0
	      xGEI(2)=ro(2)/6371.2D0
	      xGEI(3)=ro(3)/6371.2D0
c     TBG 3.27.07:  Exchanged two rotations for one call to coord_trans
c     sysaxes now passed into sgp4_orb1
c     SGP4 outputs are given in TEME (True Equator Mean Equinox) coordinate
c     system (so 13 index in the lib for corrdinates conversions)
              call coord_trans1(13,sysaxes,Year,DOY,secs,xGEI,xOUT)
c	      call gei2geo1(Year,DOY,secs,xGEI,xGEO)   ! commented out by TBG
c	      call geo_gdz(xGEO(1),xGEO(2),xGEO(3),lati,longi,alti)  ! same here
              isec=INT(sec)
              CALL DATE_AND_TIME2DECY(Year,Mon, Day,
     &                    hr,min,isec,Dec_y)
c              WRITE( 11,'(I2.2,A1,I2.2,A1,I4,1x,I3,A1,I2,A1,F9.6,
c     &                         1x,f13.8,1x,3F17.6)' )
c     &                    Day,'/',Mon,'/',Year,Hr,':',Min,':',
c     &                   Sec, Dec_y,alti,lati,longi
c     Now assign trajectory info to the outputArray
              outputArray(1,istep) = Day
              outputArray(2,istep) = Mon
              outputArray(3,istep) = Year
              outputArray(4,istep) = Hr
              outputArray(5,istep) = Min
              outputArray(6,istep) = Sec
              outputArray(7,istep) = Dec_y
c              outputArray(8,istep) = alti
c              outputArray(9,istep) = lati
c              outputArray(10,istep) = longi
              outputArray(8,istep) = xOUT(1)  ! sending back the positions rotated
              outputArray(9,istep) = xOUT(2)  ! to the correct sysaxes specified.
              outputArray(10,istep) = xOUT(3)  !  TBG, 3.27.07
           ENDIF ! if error

        ENDDO ! propagating the case

c	close(11)
        AscendingNode  = nodeo / DE2RA
        Argument_Perigee  = Argpo / DE2RA
        MeanAnomaly     = Mo   / DE2RA

      END

C
c***********************************************************************
c
      SUBROUTINE TS07D_JULY_2017 (X,Y,Z,BX,BY,BZ)     !  A DOUBLE-PRECISION SUBROUTINE
C
C  July 2017, G.K.Stephens, This routine was updated to be a double precision subroutine.
C  To indicate the update, the subroutine was renamed from EXTMODEL to TS07D_JULY_2017.
C  Additionally, this July 2017 update incorporates an upgraded version of the Bessel function evaluator,
C  provided by Jay Albert, which significantly speeds up the model. We thank Jay Albert for these
C  contributions.
C
C  This subroutine computes and returns the compoents of the external magnetic field vector in the
C  GSM coordinate system due to extraterrestrial currents, as described in the following references.
C  To compute the total magnetic field, the magnetic field vector from the Earth's internal sources
C  must be added. To compute this see Dr. Tsyganenko's most recent implementation of the IGRF
C  model in the GEOPACK package (Geopack-2008_dp.for).
C
C  References: (1) Tsyganenko, N. A., and M. I. Sitnov (2007), Magnetospheric configurations from a 
C                  high-resolution data-based magneticfield model, J. Geophys. Res., 112,A06225,
C                  doi:10.1029/2007JA012260.
C
C              (2) Sitnov, M. I., N. A. Tsyganenko, A. Y. Ukhorskiy, B. J. Anderson, H. Korth,
C                  A. T. Y. Lui, and P. C. Brandt (2010),Empirical modeling of a CIR-driven magnetic
C                  storm, J. Geophys. Res., 115, A07231, doi:10.1029/2009JA015169.
C
C  Inputs:
C     IOPT - An option flag that allows to break out the magnetic field vector contributions from the
C        individual modules.
C        IOPT=0 - The total external magnetic field (most common)
C        IOPT=1 - The field due to only the shielding of the dipole field on the magnetopause
C        IOPT=2 - The field due to only the equatorial currents and its shielding field
C        IOPT=3 - The field due to only the Birkeland currents and its shielding field
C     PS - The Geodipole tilt angle in radians.
C     PARMOD - A 10-element array, in this model this input is not used and will have no impact on the
C        model evaluation. It is kept here because the TRACE_08 routine in the Geopack package requires
C        a consistent signature with other empirical magnetic field models that do use this parameter.
C     X,Y,Z - The Cartesian Geocentric position where the model will be evaluated in the GSM coordinate
C        system in units of Earth Radii (1 RE=6371.2 KM).
C
C  Common Block Inputs:
C     /INPUT/ PDYN - The solar wind dynamic pressure in nanoPascals (nPa)
C     /PARAM/ A - An 101-element array containing the variable (time-dependent) coefficients and
C        parameters used in evaluating the model
C     /TSS/ TSS - An 80x5-element array containing the static (time-independent) coefficients that are
C        used to shield the symmetric equatorial expansions
C     /TSO/ TSO - An 80x5x4-element array containing the static (time-independent) coefficients that are
C        used to shield the ODD axis-symmetric equatorial expansions
C     /TSE/ TSE - An 80x5x4-element array containing the static (time-independent) coefficients that are
C        used to shield the EVEN axis-symmetric equatorial expansions 
C
C  Outputs:
C     BX,BY,BZ - the evaluated magnetic field vector in the GSM coordinate system in units of nanoTesla (nT)
C
      !IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT NONE

      INTEGER*4 M_INX,N_INX,NTOT,IOPT
      REAL*8 AAA,SPS,CPS,BBB,PSI,CCC,PDYN,TILT,A07,
     &BXCF,BYCF,BZCF,BXTS,BXTO,BXTE,BYTS,BYTO,BYTE,BZTS,BZTO,BZTE,
     &BXR11,BYR11,BZR11,BXR12,BYR12,BZR12,
     &BXR21a,BYR21a,BZR21a,BXR21s,BYR21s,BZR21s,
     &BX,BY,BZ,X,Y,Z

      PARAMETER (NTOT=101)

      COMMON /GEOPACK1/ AAA(10),SPS,CPS,BBB(3),PSI,CCC(18)

      COMMON /TS07D_DATA/  M_INX,N_INX,PDYN,TILT,A07(NTOT)

      DIMENSION BXTS(5),BXTO(5,4),BXTE(5,4)
      DIMENSION BYTS(5),BYTO(5,4),BYTE(5,4)
      DIMENSION BZTS(5),BZTO(5,4),BZTE(5,4)

      IOPT = 0 ! see input options

      CALL EXTERN_2017 (IOPT,A07,NTOT,M_INX,N_INX,PSI,PDYN,X,Y,Z,
     *BXCF,BYCF,BZCF,
     *BXTS,BYTS,BZTS,BXTO,BYTO,BZTO,BXTE,BYTE,BZTE,
     *BXR11,BYR11,BZR11,BXR12,BYR12,BZR12,BXR21a,BYR21a,BZR21a,BXR21s,
     *BYR21s,BZR21s,BX,BY,BZ)

      RETURN
C
      END
c
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      SUBROUTINE EXTERN_2017 (IOPGEN,A,NTOT,M_INX,N_INX,
     *  PS,PDYN,X,Y,Z,
     *  BXCF,BYCF,BZCF,
     *  BXTS,BYTS,BZTS,BXTO,BYTO,BZTO,BXTE,BYTE,BZTE,
     *  BXR11,BYR11,BZR11,BXR12,BYR12,BZR12,
     *  BXR21a,BYR21a,BZR21a,BXR21s,BYR21s,BZR21s,
     *  BX,BY,BZ)
C
C   IOPGEN - GENERAL OPTION FLAG:  IOPGEN=0 - CALCULATE TOTAL FIELD
C                                  IOPGEN=1 - DIPOLE SHIELDING ONLY
C                                  IOPGEN=2 - TAIL FIELD ONLY
C                                  IOPGEN=3 - BIRKELAND FIELD ONLY
C                                  IOPGEN=4 - RING CURRENT FIELD ONLY
C
      IMPLICIT  REAL * 8  (A - H, O - Z)
      INTEGER*4 M_INX,N_INX ! included for future reference
C
      DIMENSION A(NTOT)
C
      DIMENSION BXTS(5),BXTO(5,4),BXTE(5,4)
      DIMENSION BYTS(5),BYTO(5,4),BYTE(5,4)
      DIMENSION BZTS(5),BZTO(5,4),BZTE(5,4)
C
      COMMON /TAIL/ D  ! THE COMMON BLOCK FORWARDS TAIL SHEET THICKNESS
      COMMON /BIRKPAR/ XKAPPA1,XKAPPA2   !  SCALING FACTORS FOR BIRKELAND CURRENTS
      COMMON /G/ G,TW
      COMMON /RH0/ RH0
C
      DATA A0_A,A0_S0,A0_X0 /34.586D0,1.1960D0,3.4397D0/   !   SHUE ET AL. PARAMETERS
      DATA DSIG /0.005D0/, RH2 /-5.2D0/

      XAPPA=(PDYN/2.D0)**0.155   !   0.155 is the value obtained in TS05
      XAPPA3=XAPPA**3

      D=      A(96)
      RH0=    A(97)
      G=      A(98)
      XKAPPA1=A(99)
      XKAPPA2=A(100)
      TW=     A(101)       !   THIS PARAMETER CONTROLS THE IMF-INDUCED TWISTING (ADDED 04/21/06)
c
      XX=X*XAPPA  ! pressure scaling has been reinstated here
      YY=Y*XAPPA
      ZZ=Z*XAPPA

c     print *,XAPPA,PDYN
C
      SPS=DSIN(PS)
c
      X0=A0_X0/XAPPA   ! pressure scaling has been reinstated, even though these parameters are not used in this code
      AM=A0_A/XAPPA    ! pressure scaling has been reinstated, even though these parameters are not used in this code
      S0=A0_S0
C
C   CALCULATE THE IMF CLOCK ANGLE:
C
C        IF (BYIMF.EQ.0.D0.AND.BZIMF.EQ.0.D0) THEN
C            THETA=0.D0
C         ELSE
C            THETA=DATAN2(BYIMF,BZIMF)
C            IF (THETA.LE.0.D0) THETA=THETA+6.283185307D0
C        ENDIF
C
C       CT=COS(THETA)
C       ST=SIN(THETA)
C       YS=Y*CT-Z*ST
C       ZS=Z*CT+Y*ST
C
C       STHETAH=SIN(THETA/2.)**2
C
C  CALCULATE "IMF" COMPONENTS OUTSIDE THE MAGNETOPAUSE LAYER (HENCE BEGIN WITH "O")
C  THEY ARE NEEDED ONLY IF THE POINT (X,Y,Z) IS WITHIN THE TRANSITION MAGNETOPAUSE LAYER
C  OR OUTSIDE THE MAGNETOSPHERE:
C
C      FACTIMF=A(24)+A(25)*STHETAH
C
C      OIMFX=0.D0
C      OIMFY=BYIMF*FACTIMF
C      OIMFZ=BZIMF*FACTIMF
c
C =====================================================================
C  THIS FRAGMENT (BETWEEN THE ===== LINES) DISABLES THE CALCULATION OF THE MAGNETOPAUSE POSITION
C  IT SHOULD BE USED ONLY FOR THE FITTING (WE ASSUME THAT NO POINTS FROM THE SHEATH ARE PRESENT
C  IN THE DATASET, WHICH ITSELF IS STILL A QUESTION).
C
C  REMOVE IT IN THE FINAL VERSION.

C      SIGMA=0.D0
C      GOTO 1111
C======================================================================
c
C      R=SQRT(X**2+Y**2+Z**2)
C      XSS=X
C      ZSS=Z

C  1   XSOLD=XSS      !   BEGIN ITERATIVE SEARCH OF UNWARPED COORDS (TO FIND SIGMA)
C      ZSOLD=ZSS

C      RH=RH0+RH2*(ZSS/R)**2
C      SINPSAS=SPS/(1.D0+(R/RH)**3)**0.33333333D0
C      COSPSAS=DSQRT(1.D0-SINPSAS**2)
C      ZSS=X*SINPSAS+Z*COSPSAS
C      XSS=X*COSPSAS-Z*SINPSAS
C      DD=DABS(XSS-XSOLD)+DABS(ZSS-ZSOLD)
C      IF (DD.GT.1.D-6) GOTO 1
C                                END OF ITERATIVE SEARCH
C      RHO2=Y**2+ZSS**2
C      ASQ=AM**2
C      XMXM=AM+XSS-X0
C      IF (XMXM.LT.0.) XMXM=0. ! THE BOUNDARY IS A CYLINDER TAILWARD OF X=X0-AM
C      AXX0=XMXM**2
C      ARO=ASQ+RHO2
C      SIGMA=DSQRT((ARO+AXX0+SQRT((ARO+AXX0)**2-4.*ASQ*AXX0))/(2.*ASQ))

C==================================================================
C 1111 CONTINUE  !!!!!!!!!!!!  REMOVE IN THE FINAL VERSION
C==================================================================

C
C   NOW, THERE ARE THREE POSSIBLE CASES:
C    (1) INSIDE THE MAGNETOSPHERE   (SIGMA
C    (2) IN THE BOUNDARY LAYER
C    (3) OUTSIDE THE MAGNETOSPHERE AND B.LAYER
C       FIRST OF ALL, CONSIDER THE CASES (1) AND (2):
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      IF (SIGMA.LT.S0+DSIG) THEN  !  CASES (1) OR (2); CALCULATE THE MODEL FIELD
C                                   (WITH THE POTENTIAL "PENETRATED" INTERCONNECTION FIELD):
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IF (IOPGEN.LE.1) THEN

C     print *,XX,YY,ZZ
         CALL SHLCAR3X3_2017(XX,YY,ZZ,PS,CFX,CFY,CFZ)         !  DIPOLE SHIELDING FIELD
         BXCF=CFX  *XAPPA3
         BYCF=CFY  *XAPPA3
         BZCF=CFZ  *XAPPA3
      ELSE
         BXCF=0.D0
         BYCF=0.D0
         BZCF=0.D0
      ENDIF                                              !  DONE

      IF (IOPGEN.EQ.0.OR.IOPGEN.EQ.2) THEN
      CALL DEFORMED_2017 (PS,XX,YY,ZZ,                !  TAIL FIELD (THREE MODES)
     *   BXTS,BYTS,BZTS,BXTO,BYTO,BZTO,BXTE,BYTE,BZTE)
       ELSE
        DO 11 K=1,5

        BXTS(K)=0.D0
        BYTS(K)=0.D0
        BZTS(K)=0.D0

 11     CONTINUE

        DO 12 K=1,5

          DO 13 L=1,4

          BXTO(K,L)=0.D0
          BYTO(K,L)=0.D0
          BZTO(K,L)=0.D0

          BXTE(K,L)=0.D0
          BYTE(K,L)=0.D0
          BZTE(K,L)=0.D0

 13       CONTINUE

 12   CONTINUE

      ENDIF

      IF (IOPGEN.EQ.0.OR.IOPGEN.EQ.3) THEN

         CALL BIRK_TOT_2017 (PS,XX,YY,ZZ,BXR11,BYR11,BZR11,BXR12,BYR12,
     *   BZR12,BXR21a,BYR21a,BZR21a,BXR22a,BYR22a,BZR22a)    !   BIRKELAND FIELD (TWO MODES FOR R1 AND TWO MODES FOR R2)

         CALL BIRTOTSY_2017 (PS,XX,YY,ZZ,BXR11s,BYR11s,BZR11s,BXR12s,
     *   BYR12s,BZR12s,BXR21s,BYR21s,BZR21s,BXR22s,BYR22s,BZR22s)    !   "SYMMETRIC" BIRKELAND FIELD
C                                                                        (TWO MODES FOR R1s AND TWO MODES FOR R2s)
c                                                                        (but we actually use from here only R2s modes)
      ELSE
         BXR11=0.D0
         BYR11=0.D0
         BZR11=0.D0
         BXR12=0.D0
         BYR12=0.D0
         BZR12=0.D0
         BXR21a=0.D0
         BYR21a=0.D0
         BZR21a=0.D0
         BXR21s=0.D0
         BYR21s=0.D0
         BZR21s=0.D0
      ENDIF
C
C-----------------------------------------------------------
C
C    NOW, ADD UP ALL THE COMPONENTS:

      A_R11=A(92)
      A_R12=A(93)
      A_R21a=A(94)
      A_R21s=A(95)

      TX=0.D0
      TY=0.D0
      TZ=0.D0

C --- New tail structure -------------


        PDYN_0=2.D0   !   AVERAGE PRESSURE USED FOR NORMALIZATION

        P_FACTOR=DSQRT(PDYN/PDYN_0)-1.D0


      IND=1

        DO 911 K=1,5
         IND=IND+1
           TX=TX+(A(IND)+A(IND+45)*P_FACTOR)*BXTS(K)    !   2 - 6  &  47 - 51
           TY=TY+(A(IND)+A(IND+45)*P_FACTOR)*BYTS(K)
           TZ=TZ+(A(IND)+A(IND+45)*P_FACTOR)*BZTS(K)
 911     CONTINUE


        DO 912 K=1,5

          DO 913 L=1,4

          IND=IND+1

           TX=TX+(A(IND)+A(IND+45)*P_FACTOR)*BXTO(K,L)  !   7 -26  &  52 - 71
           TY=TY+(A(IND)+A(IND+45)*P_FACTOR)*BYTO(K,L)
           TZ=TZ+(A(IND)+A(IND+45)*P_FACTOR)*BZTO(K,L)

           TX=TX+(A(IND+20)+A(IND+65)*P_FACTOR)*BXTE(K,L) !   27 -46  &  72 - 91
           TY=TY+(A(IND+20)+A(IND+65)*P_FACTOR)*BYTE(K,L)
           TZ=TZ+(A(IND+20)+A(IND+65)*P_FACTOR)*BZTE(K,L)

 913       CONTINUE

 912   CONTINUE
      
      BBX=A(1)*BXCF+TX+
     * A_R11*BXR11+A_R12*BXR12+A_R21a*BXR21a+A_R21s*BXR21s

      BBY=A(1)*BYCF+TY+
     * A_R11*BYR11+A_R12*BYR12+A_R21a*BYR21a+A_R21s*BYR21s

      BBZ=A(1)*BZCF+TZ+
     * A_R11*BZR11+A_R12*BZR12+A_R21a*BZR21a+A_R21s*BZR21s
C
c   -----------------------------------------------------------
C
C   AND WE HAVE THE TOTAL EXTERNAL FIELD.
C
C  NOW, LET US CHECK WHETHER WE HAVE THE CASE (1). IF YES - WE ARE DONE:
C
C      IF (SIGMA.LT.S0-DSIG) THEN    !  (X,Y,Z) IS INSIDE THE MAGNETOSPHERE

C       BX=BBX
C       BY=BBY
C       BZ=BBZ
C                     ELSE           !  THIS IS THE MOST COMPLEX CASE: WE ARE INSIDE
C                                             THE INTERPOLATION REGION
C       FINT=0.5*(1.-(SIGMA-S0)/DSIG)
C       FEXT=0.5*(1.+(SIGMA-S0)/DSIG)
C
C       CALL DIPOLE (PS,X,Y,Z,QX,QY,QZ)
C       BX=(BBX+QX)*FINT+OIMFX*FEXT -QX
C       BY=(BBY+QY)*FINT+OIMFY*FEXT -QY
C       BZ=(BBZ+QZ)*FINT+OIMFZ*FEXT -QZ
c
C        ENDIF  !   THE CASES (1) AND (2) ARE EXHAUSTED; THE ONLY REMAINING
C                      POSSIBILITY IS NOW THE CASE (3):
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C        ELSE
C                CALL DIPOLE (PS,X,Y,Z,QX,QY,QZ)
C                BX=OIMFX-QX
C                BY=OIMFY-QY
C                BZ=OIMFZ-QZ
C        ENDIF
C

       BX=BBX
       BY=BBY
       BZ=BBZ

      RETURN
      END
C
C XXXXXXXXXXXXXXXXXXXXXXXXXXX11/15/05 16:06 XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
         SUBROUTINE  SHLCAR3X3_2017(X,Y,Z,PS,BX,BY,BZ)
C
C   THIS S/R RETURNS THE SHIELDING FIELD FOR THE EARTH'S DIPOLE,
C   REPRESENTED BY  2x3x3=18 "CARTESIAN" HARMONICS, tilted with respect
C   to the z=0 plane (see NB#4, p.74-74)
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  The 36 coefficients enter in pairs in the amplitudes of the "cartesian"
c    harmonics (A(1)-A(36).
c  The 14 nonlinear parameters (A(37)-A(50) are the scales Pi,Ri,Qi,and Si
C   entering the arguments of exponents, sines, and cosines in each of the
C   18 "Cartesian" harmonics  PLUS TWO TILT ANGLES FOR THE CARTESIAN HARMONICS
C       (ONE FOR THE PSI=0 MODE AND ANOTHER FOR THE PSI=90 MODE)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      IMPLICIT  REAL * 8  (A - H, O - Z)
C
      DIMENSION A(50)
      DATA A/-901.2327248,895.8011176,817.6208321,-845.5880889,
     *-83.73539535,86.58542841,336.8781402,-329.3619944,-311.2947120,
     *308.6011161,31.94469304,-31.30824526,125.8739681,-372.3384278,
     *-235.4720434,286.7594095,21.86305585,-27.42344605,-150.4874688,
     *2.669338538,1.395023949,-.5540427503,-56.85224007,3.681827033,
     *-43.48705106,5.103131905,1.073551279,-.6673083508,12.21404266,
     *4.177465543,5.799964188,-.3977802319,-1.044652977,.5703560010,
     *3.536082962,-3.222069852,9.620648151,6.082014949,27.75216226,
     *12.44199571,5.122226936,6.982039615,20.12149582,6.150973118,
     *4.663639687,15.73319647,2.303504968,5.840511214,.8385953499E-01,
     *.3477844929/
C
         P1=A(37)
         P2=A(38)
         P3=A(39)
         R1=A(40)
         R2=A(41)
         R3=A(42)
         Q1=A(43)
         Q2=A(44)
         Q3=A(45)
         S1=A(46)
         S2=A(47)
         S3=A(48)

         T1  =A(49)
         T2  =A(50)
C
         CPS=DCOS(PS)
         SPS=DSIN(PS)
         S2PS=2.D0*CPS      !   MODIFIED HERE (INSTEAD OF SIN(3*PS) I TRY SIN(2*PS)

C
           ST1=DSIN(PS*T1)
           CT1=DCOS(PS*T1)
           ST2=DSIN(PS*T2)
           CT2=DCOS(PS*T2)

C     print *,X,Z

            X1=X*CT1-Z*ST1

C         print *,'X1=',X1

            Z1=X*ST1+Z*CT1
            X2=X*CT2-Z*ST2
            Z2=X*ST2+Z*CT2
C
C
c  MAKE THE TERMS IN THE 1ST SUM ("PERPENDICULAR" SYMMETRY):
C
C       I=1
C
        SQPR= DSQRT(1.D0/P1**2+1.D0/R1**2)
        CYP = DCOS(Y/P1)
        SYP = DSIN(Y/P1)
        CZR = DCOS(Z1/R1)
        SZR = DSIN(Z1/R1)
c       print *,X1
        EXPR= DEXP(SQPR*X1)
        FX1 =-SQPR*EXPR*CYP*SZR
        HY1 = EXPR/P1*SYP*SZR
        FZ1 =-EXPR*CYP/R1*CZR
        HX1 = FX1*CT1+FZ1*ST1
        HZ1 =-FX1*ST1+FZ1*CT1

        SQPR= DSQRT(1.D0/P1**2+1.D0/R2**2)
        CYP = DCOS(Y/P1)
        SYP = DSIN(Y/P1)
        CZR = DCOS(Z1/R2)
        SZR = DSIN(Z1/R2)
        EXPR= DEXP(SQPR*X1)
        FX2 =-SQPR*EXPR*CYP*SZR
        HY2 = EXPR/P1*SYP*SZR
        FZ2 =-EXPR*CYP/R2*CZR
        HX2 = FX2*CT1+FZ2*ST1
        HZ2 =-FX2*ST1+FZ2*CT1

        SQPR= DSQRT(1.D0/P1**2+1.D0/R3**2)
        CYP = DCOS(Y/P1)
        SYP = DSIN(Y/P1)
        CZR = DCOS(Z1/R3)
        SZR = DSIN(Z1/R3)
        EXPR= DEXP(SQPR*X1)
        FX3 =-EXPR*CYP*(SQPR*Z1*CZR+SZR/R3*(X1+1.D0/SQPR))
        HY3 = EXPR/P1*SYP*(Z1*CZR+X1/R3*SZR/SQPR)
        FZ3 =-EXPR*CYP*(CZR*(1.D0+X1/R3**2/SQPR)-Z1/R3*SZR)
        HX3 = FX3*CT1+FZ3*ST1
        HZ3 =-FX3*ST1+FZ3*CT1
C
C       I=2:
C
        SQPR= DSQRT(1.D0/P2**2+1.D0/R1**2)
        CYP = DCOS(Y/P2)
        SYP = DSIN(Y/P2)
        CZR = DCOS(Z1/R1)
        SZR = DSIN(Z1/R1)
        EXPR= DEXP(SQPR*X1)
        FX4 =-SQPR*EXPR*CYP*SZR
        HY4 = EXPR/P2*SYP*SZR
        FZ4 =-EXPR*CYP/R1*CZR
        HX4 = FX4*CT1+FZ4*ST1
        HZ4 =-FX4*ST1+FZ4*CT1

        SQPR= DSQRT(1.D0/P2**2+1.D0/R2**2)
        CYP = DCOS(Y/P2)
        SYP = DSIN(Y/P2)
        CZR = DCOS(Z1/R2)
        SZR = DSIN(Z1/R2)
        EXPR= DEXP(SQPR*X1)
        FX5 =-SQPR*EXPR*CYP*SZR
        HY5 = EXPR/P2*SYP*SZR
        FZ5 =-EXPR*CYP/R2*CZR
        HX5 = FX5*CT1+FZ5*ST1
        HZ5 =-FX5*ST1+FZ5*CT1

        SQPR= DSQRT(1.D0/P2**2+1.D0/R3**2)
        CYP = DCOS(Y/P2)
        SYP = DSIN(Y/P2)
        CZR = DCOS(Z1/R3)
        SZR = DSIN(Z1/R3)
        EXPR= DEXP(SQPR*X1)
        FX6 =-EXPR*CYP*(SQPR*Z1*CZR+SZR/R3*(X1+1.D0/SQPR))
        HY6 = EXPR/P2*SYP*(Z1*CZR+X1/R3*SZR/SQPR)
        FZ6 =-EXPR*CYP*(CZR*(1.D0+X1/R3**2/SQPR)-Z1/R3*SZR)
        HX6 = FX6*CT1+FZ6*ST1
        HZ6 =-FX6*ST1+FZ6*CT1
C
C       I=3:
C
        SQPR= DSQRT(1.D0/P3**2+1.D0/R1**2)
        CYP = DCOS(Y/P3)
        SYP = DSIN(Y/P3)
        CZR = DCOS(Z1/R1)
        SZR = DSIN(Z1/R1)
        EXPR= DEXP(SQPR*X1)
        FX7 =-SQPR*EXPR*CYP*SZR
        HY7 = EXPR/P3*SYP*SZR
        FZ7 =-EXPR*CYP/R1*CZR
        HX7 = FX7*CT1+FZ7*ST1
        HZ7 =-FX7*ST1+FZ7*CT1

        SQPR= DSQRT(1.D0/P3**2+1.D0/R2**2)
        CYP = DCOS(Y/P3)
        SYP = DSIN(Y/P3)
        CZR = DCOS(Z1/R2)
        SZR = DSIN(Z1/R2)
        EXPR= DEXP(SQPR*X1)
        FX8 =-SQPR*EXPR*CYP*SZR
        HY8 = EXPR/P3*SYP*SZR
        FZ8 =-EXPR*CYP/R2*CZR
        HX8 = FX8*CT1+FZ8*ST1
        HZ8 =-FX8*ST1+FZ8*CT1

        SQPR= DSQRT(1.D0/P3**2+1.D0/R3**2)
        CYP = DCOS(Y/P3)
        SYP = DSIN(Y/P3)
        CZR = DCOS(Z1/R3)
        SZR = DSIN(Z1/R3)
        EXPR= DEXP(SQPR*X1)
        FX9 =-EXPR*CYP*(SQPR*Z1*CZR+SZR/R3*(X1+1.D0/SQPR))
        HY9 = EXPR/P3*SYP*(Z1*CZR+X1/R3*SZR/SQPR)
        FZ9 =-EXPR*CYP*(CZR*(1.D0+X1/R3**2/SQPR)-Z1/R3*SZR)
        HX9 = FX9*CT1+FZ9*ST1
        HZ9 =-FX9*ST1+FZ9*CT1


       A1=A(1)+A(2)*CPS
       A2=A(3)+A(4)*CPS
       A3=A(5)+A(6)*CPS
       A4=A(7)+A(8)*CPS
       A5=A(9)+A(10)*CPS
       A6=A(11)+A(12)*CPS
       A7=A(13)+A(14)*CPS
       A8=A(15)+A(16)*CPS
       A9=A(17)+A(18)*CPS
       BX=A1*HX1+A2*HX2+A3*HX3+A4*HX4+A5*HX5+A6*HX6+A7*HX7+A8*HX8+A9*HX9
       BY=A1*HY1+A2*HY2+A3*HY3+A4*HY4+A5*HY5+A6*HY6+A7*HY7+A8*HY8+A9*HY9
       BZ=A1*HZ1+A2*HZ2+A3*HZ3+A4*HZ4+A5*HZ5+A6*HZ6+A7*HZ7+A8*HZ8+A9*HZ9


c  MAKE THE TERMS IN THE 2ND SUM ("PARALLEL" SYMMETRY):
C
C       I=1
C
       SQQS= DSQRT(1.D0/Q1**2+1.D0/S1**2)
       CYQ = DCOS(Y/Q1)
       SYQ = DSIN(Y/Q1)
       CZS = DCOS(Z2/S1)
       SZS = DSIN(Z2/S1)
       EXQS= DEXP(SQQS*X2)
       FX1 =-SQQS*EXQS*CYQ*CZS *SPS
       HY1 = EXQS/Q1*SYQ*CZS   *SPS
       FZ1 = EXQS*CYQ/S1*SZS   *SPS
       HX1 = FX1*CT2+FZ1*ST2
       HZ1 =-FX1*ST2+FZ1*CT2

       SQQS= DSQRT(1.D0/Q1**2+1.D0/S2**2)
       CYQ = DCOS(Y/Q1)
       SYQ = DSIN(Y/Q1)
       CZS = DCOS(Z2/S2)
       SZS = DSIN(Z2/S2)
       EXQS= DEXP(SQQS*X2)
       FX2 =-SQQS*EXQS*CYQ*CZS *SPS
       HY2 = EXQS/Q1*SYQ*CZS   *SPS
       FZ2 = EXQS*CYQ/S2*SZS   *SPS
       HX2 = FX2*CT2+FZ2*ST2
       HZ2 =-FX2*ST2+FZ2*CT2

       SQQS= DSQRT(1.D0/Q1**2+1.D0/S3**2)
       CYQ = DCOS(Y/Q1)
       SYQ = DSIN(Y/Q1)
       CZS = DCOS(Z2/S3)
       SZS = DSIN(Z2/S3)
       EXQS= DEXP(SQQS*X2)
       FX3 =-SQQS*EXQS*CYQ*CZS *SPS
       HY3 = EXQS/Q1*SYQ*CZS   *SPS
       FZ3 = EXQS*CYQ/S3*SZS   *SPS
       HX3 = FX3*CT2+FZ3*ST2
       HZ3 =-FX3*ST2+FZ3*CT2
C
C       I=2
C
       SQQS= DSQRT(1.D0/Q2**2+1.D0/S1**2)
       CYQ = DCOS(Y/Q2)
       SYQ = DSIN(Y/Q2)
       CZS = DCOS(Z2/S1)
       SZS = DSIN(Z2/S1)
       EXQS= DEXP(SQQS*X2)
       FX4 =-SQQS*EXQS*CYQ*CZS *SPS
       HY4 = EXQS/Q2*SYQ*CZS   *SPS
       FZ4 = EXQS*CYQ/S1*SZS   *SPS
       HX4 = FX4*CT2+FZ4*ST2
       HZ4 =-FX4*ST2+FZ4*CT2

       SQQS= DSQRT(1.D0/Q2**2+1.D0/S2**2)
       CYQ = DCOS(Y/Q2)
       SYQ = DSIN(Y/Q2)
       CZS = DCOS(Z2/S2)
       SZS = DSIN(Z2/S2)
       EXQS= DEXP(SQQS*X2)
       FX5 =-SQQS*EXQS*CYQ*CZS *SPS
       HY5 = EXQS/Q2*SYQ*CZS   *SPS
       FZ5 = EXQS*CYQ/S2*SZS   *SPS
       HX5 = FX5*CT2+FZ5*ST2
       HZ5 =-FX5*ST2+FZ5*CT2

       SQQS= DSQRT(1.D0/Q2**2+1.D0/S3**2)
       CYQ = DCOS(Y/Q2)
       SYQ = DSIN(Y/Q2)
       CZS = DCOS(Z2/S3)
       SZS = DSIN(Z2/S3)
       EXQS= DEXP(SQQS*X2)
       FX6 =-SQQS*EXQS*CYQ*CZS *SPS
       HY6 = EXQS/Q2*SYQ*CZS   *SPS
       FZ6 = EXQS*CYQ/S3*SZS   *SPS
       HX6 = FX6*CT2+FZ6*ST2
       HZ6 =-FX6*ST2+FZ6*CT2
C
C       I=3
C
       SQQS= DSQRT(1.D0/Q3**2+1.D0/S1**2)
       CYQ = DCOS(Y/Q3)
       SYQ = DSIN(Y/Q3)
       CZS = DCOS(Z2/S1)
       SZS = DSIN(Z2/S1)
       EXQS= DEXP(SQQS*X2)
       FX7 =-SQQS*EXQS*CYQ*CZS *SPS
       HY7 = EXQS/Q3*SYQ*CZS   *SPS
       FZ7 = EXQS*CYQ/S1*SZS   *SPS
       HX7 = FX7*CT2+FZ7*ST2
       HZ7 =-FX7*ST2+FZ7*CT2

       SQQS= DSQRT(1.D0/Q3**2+1.D0/S2**2)
       CYQ = DCOS(Y/Q3)
       SYQ = DSIN(Y/Q3)
       CZS = DCOS(Z2/S2)
       SZS = DSIN(Z2/S2)
       EXQS= DEXP(SQQS*X2)
       FX8 =-SQQS*EXQS*CYQ*CZS *SPS
       HY8 = EXQS/Q3*SYQ*CZS   *SPS
       FZ8 = EXQS*CYQ/S2*SZS   *SPS
       HX8 = FX8*CT2+FZ8*ST2
       HZ8 =-FX8*ST2+FZ8*CT2

       SQQS= DSQRT(1.D0/Q3**2+1.D0/S3**2)
       CYQ = DCOS(Y/Q3)
       SYQ = DSIN(Y/Q3)
       CZS = DCOS(Z2/S3)
       SZS = DSIN(Z2/S3)
       EXQS= DEXP(SQQS*X2)
       FX9 =-SQQS*EXQS*CYQ*CZS *SPS
       HY9 = EXQS/Q3*SYQ*CZS   *SPS
       FZ9 = EXQS*CYQ/S3*SZS   *SPS
       HX9 = FX9*CT2+FZ9*ST2
       HZ9 =-FX9*ST2+FZ9*CT2

       A1=A(19)+A(20)*S2PS
       A2=A(21)+A(22)*S2PS
       A3=A(23)+A(24)*S2PS
       A4=A(25)+A(26)*S2PS
       A5=A(27)+A(28)*S2PS
       A6=A(29)+A(30)*S2PS
       A7=A(31)+A(32)*S2PS
       A8=A(33)+A(34)*S2PS
       A9=A(35)+A(36)*S2PS

       BX=BX+A1*HX1+A2*HX2+A3*HX3+A4*HX4+A5*HX5+A6*HX6+A7*HX7+A8*HX8
     *   +A9*HX9
       BY=BY+A1*HY1+A2*HY2+A3*HY3+A4*HY4+A5*HY5+A6*HY6+A7*HY7+A8*HY8
     *   +A9*HY9
       BZ=BZ+A1*HZ1+A2*HZ2+A3*HZ3+A4*HZ4+A5*HZ5+A6*HZ6+A7*HZ7+A8*HZ8
     *   +A9*HZ9
C
       RETURN
       END
c
c############################################################################
c
C
      SUBROUTINE DEFORMED_2017 (PS,X,Y,Z,
     *   BXS,BYS,BZS,BXO,BYO,BZO,BXE,BYE,BZE)
C
C    CALCULATES GSM COMPONENTS OF 104 UNIT-AMPLITUDE TAIL FIELD MODES,
C    TAKING INTO ACCOUNT BOTH EFFECTS OF DIPOLE TILT:
C    WARPING IN Y-Z (DONE BY THE S/R WARPED) AND BENDING IN X-Z (DONE BY THIS SUBROUTINE)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION BXS(5),BXO(5,4),BXE(5,4)
      DIMENSION BYS(5),BYO(5,4),BYE(5,4)
      DIMENSION BZS(5),BZO(5,4),BZE(5,4)
C
      DIMENSION BXASS(5),BXASO(5,4),BXASE(5,4)
      DIMENSION BYASS(5),BYASO(5,4),BYASE(5,4)
      DIMENSION BZASS(5),BZASO(5,4),BZASE(5,4)
C
      COMMON /RH0/ RH0
      DATA RH2,IEPS /-5.2D0,3/
C
C  RH0,RH1,RH2, AND IEPS CONTROL THE TILT-RELATED DEFORMATION OF THE TAIL FIELD
C
      SPS=DSIN(PS)
      CPS=DSQRT(1.D0-SPS**2)
      R2=X**2+Y**2+Z**2
      R=SQRT(R2)
      ZR=Z/R
      RH=RH0+RH2*ZR**2
      DRHDR=-ZR/R*2.D0*RH2*ZR
      DRHDZ= 2.D0*RH2*ZR/R
C
      RRH=R/RH
      F=1.D0/(1.D0+RRH**IEPS)**(1.D0/IEPS)
      DFDR=-RRH**(IEPS-1)*F**(IEPS+1)/RH
      DFDRH=-RRH*DFDR
c
      SPSAS=SPS*F
      CPSAS=DSQRT(1.D0-SPSAS**2)
C
      XAS=X*CPSAS-Z*SPSAS
      ZAS=X*SPSAS+Z*CPSAS
C
      FACPS=SPS/CPSAS*(DFDR+DFDRH*DRHDR)/R
      PSASX=FACPS*X
      PSASY=FACPS*Y
      PSASZ=FACPS*Z+SPS/CPSAS*DFDRH*DRHDZ
C
      DXASDX=CPSAS-ZAS*PSASX
      DXASDY=-ZAS*PSASY
      DXASDZ=-SPSAS-ZAS*PSASZ
      DZASDX=SPSAS+XAS*PSASX
      DZASDY=XAS*PSASY
      DZASDZ=CPSAS+XAS*PSASZ
      FAC1=DXASDZ*DZASDY-DXASDY*DZASDZ
      FAC2=DXASDX*DZASDZ-DXASDZ*DZASDX
      FAC3=DZASDX*DXASDY-DXASDX*DZASDY
C
C     DEFORM:
C
      CALL WARPED_2017(PS,XAS,Y,ZAS,
     *   BXASS,BYASS,BZASS,BXASO,BYASO,BZASO,BXASE,BYASE,BZASE)
C
C --- New tail structure -------------

        DO 11 K=1,5

        BXS(K)=BXASS(K)*DZASDZ-BZASS(K)*DXASDZ+BYASS(K)*FAC1
        BYS(K)=BYASS(K)*FAC2
        BZS(K)=BZASS(K)*DXASDX-BXASS(K)*DZASDX+BYASS(K)*FAC3

 11     CONTINUE

        DO 12 K=1,5

          DO 13 L=1,4

          BXO(K,L)=BXASO(K,L)*DZASDZ-BZASO(K,L)*DXASDZ
     *            +BYASO(K,L)*FAC1
          BYO(K,L)=BYASO(K,L)*FAC2
          BZO(K,L)=BZASO(K,L)*DXASDX-BXASO(K,L)*DZASDX
     *            +BYASO(K,L)*FAC3

          BXE(K,L)=BXASE(K,L)*DZASDZ-BZASE(K,L)*DXASDZ
     *            +BYASE(K,L)*FAC1
          BYE(K,L)=BYASE(K,L)*FAC2
          BZE(K,L)=BZASE(K,L)*DXASDX-BXASE(K,L)*DZASDX
     *            +BYASE(K,L)*FAC3

 13       CONTINUE

 12   CONTINUE

C ------------------------------------
C
      RETURN
      END
C
C------------------------------------------------------------------
c
C
      SUBROUTINE WARPED_2017 (PS,X,Y,Z,
     *   BXS,BYS,BZS,BXO,BYO,BZO,BXE,BYE,BZE)
C
C   CALCULATES GSM COMPONENTS OF THE WARPED FIELD FOR TWO TAIL UNIT MODES.
C   THE WARPING DEFORMATION IS IMPOSED ON THE UNWARPED FIELD, COMPUTED
C   BY THE S/R "UNWARPED".  THE WARPING PARAMETERS WERE TAKEN FROM THE
C   RESULTS OF GEOTAIL OBSERVATIONS (TSYGANENKO ET AL. [1998]).
C   NB # 6, P.106, OCT 12, 2000.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION BXS(5),BXO(5,4),BXE(5,4)
      DIMENSION BYS(5),BYO(5,4),BYE(5,4)
      DIMENSION BZS(5),BZO(5,4),BZE(5,4)
C
      DIMENSION BX_ASS(5),BX_ASO(5,4),BX_ASE(5,4)
      DIMENSION BY_ASS(5),BY_ASO(5,4),BY_ASE(5,4)
      DIMENSION BZ_ASS(5),BZ_ASO(5,4),BZ_ASE(5,4)
C
      COMMON /G/ G,TW
      DGDX=0.D0
      XL=20.D0
      DXLDX=0.D0

      SPS=DSIN(PS)
      RHO2=Y**2+Z**2
      RHO=DSQRT(RHO2)

      IF (Y.EQ.0.D0.AND.Z.EQ.0.D0) THEN
       PHI=0.D0
       CPHI=1.D0
       SPHI=0.D0
      ELSE
       PHI=DATAN2(Z,Y)
       CPHI=Y/RHO
       SPHI=Z/RHO
      ENDIF

      RR4L4=RHO/(RHO2**2+XL**4)

      F=PHI+G*RHO2*RR4L4*CPHI*SPS +TW*(X/10.D0)
      DFDPHI=1.D0-G*RHO2*RR4L4*SPHI*SPS
      DFDRHO=G*RR4L4**2*(3.D0*XL**4-RHO2**2)*CPHI*SPS
      DFDX=RR4L4*CPHI*SPS*(DGDX*RHO2-G*RHO*RR4L4*4.D0*XL**3*DXLDX)
     *  +TW/10.D0        !  THE LAST TERM DESCRIBES THE IMF-INDUCED TWISTING (ADDED 04/21/06)

      CF=DCOS(F)
      SF=DSIN(F)
      YAS=RHO*CF
      ZAS=RHO*SF

      CALL UNWARPED_2017 (X,YAS,ZAS,
     *   BX_ASS,BY_ASS,BZ_ASS,
     *   BX_ASO,BY_ASO,BZ_ASO,
     *   BX_ASE,BY_ASE,BZ_ASE)
C
        DO 11 K=1,5
C ------------------------------------------- Deforming symmetric modules
      BRHO_AS =  BY_ASS(K)*CF+BZ_ASS(K)*SF
      BPHI_AS = -BY_ASS(K)*SF+BZ_ASS(K)*CF

      BRHO_S = BRHO_AS*DFDPHI
      BPHI_S = BPHI_AS-RHO*(BX_ASS(K)*DFDX+BRHO_AS*DFDRHO)

        BXS(K)=BX_ASS(K)*DFDPHI
        BYS(K)=BRHO_S*CPHI-BPHI_S*SPHI
        BZS(K)=BRHO_S*SPHI+BPHI_S*CPHI

 11     CONTINUE

        DO 12 K=1,5

          DO 13 L=1,4
C -------------------------------------------- Deforming odd modules
      BRHO_AS =  BY_ASO(K,L)*CF+BZ_ASO(K,L)*SF
      BPHI_AS = -BY_ASO(K,L)*SF+BZ_ASO(K,L)*CF

      BRHO_S = BRHO_AS*DFDPHI
      BPHI_S = BPHI_AS-RHO*(BX_ASO(K,L)*DFDX+BRHO_AS*DFDRHO)

          BXO(K,L)=BX_ASO(K,L)*DFDPHI
          BYO(K,L)=BRHO_S*CPHI-BPHI_S*SPHI
          BZO(K,L)=BRHO_S*SPHI+BPHI_S*CPHI
C ------------------------------------------- Deforming even modules
      BRHO_AS =  BY_ASE(K,L)*CF+BZ_ASE(K,L)*SF
      BPHI_AS = -BY_ASE(K,L)*SF+BZ_ASE(K,L)*CF

      BRHO_S = BRHO_AS*DFDPHI
      BPHI_S = BPHI_AS-RHO*(BX_ASE(K,L)*DFDX+BRHO_AS*DFDRHO)

          BXE(K,L)=BX_ASE(K,L)*DFDPHI
          BYE(K,L)=BRHO_S*CPHI-BPHI_S*SPHI
          BZE(K,L)=BRHO_S*SPHI+BPHI_S*CPHI

 13       CONTINUE

 12   CONTINUE

      RETURN
      END

C==========================================================================
C     July 2017, G.K.Stephens, this routine updated to incorporate Jay Albert's
C     improvements to the Bessel function evaluation.
       SUBROUTINE UNWARPED_2017 (X,Y,Z,BXS,BYS,BZS,BXO,
     *  BYO,BZO,BXE,BYE,BZE)

C    CALCULATES GSM COMPONENTS OF THE SHIELDED FIELD OF 45 TAIL MODES WITH UNIT
C    AMPLITUDES,  WITHOUT ANY WARPING OR BENDING.  NONLINEAR PARAMETERS OF THE MODES
C    ARE FORWARDED HERE VIA A COMMON BLOCK /TAIL/.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMMON /TSS/ TSS(80,5)
      COMMON /TSO/ TSO(80,5,4)
      COMMON /TSE/ TSE(80,5,4)

      COMMON /TAIL/ D0

      DIMENSION BXS(5),BXO(5,4),BXE(5,4)
      DIMENSION BYS(5),BYO(5,4),BYE(5,4)
      DIMENSION BZS(5),BZO(5,4),BZE(5,4)

      DIMENSION AJM(0:5),AJMD(0:5)
      RNOT=20.0     !    Rho_0 - scale parameter along the tail axis

C
C --- New tail structure -------------
C     
C
      DO 11 K=1,5

         RHO=DSQRT(X*X+Y*Y)

         RKMR = DBLE(K)*RHO/RNOT

C     July 2017, G.K.Stephens, all the Bessel functions are now evaluated first,
C     and passed into the subroutines
         CALL BESSJJ_2017(5,RKMR, AJM) !!! get all n in one call
         DO 3 m=1,5
            AJMD(m)=AJM(m-1)-m*AJM(m)/RKMR
 3       CONTINUE
         AJMD(0)=-AJM(1)

         CALL TAILSHT_S_2017 (K,X,Y,Z,AJM,BXSK,BYSK,BZSK)
         CALL SHTBNORM_S_2017 (K,X,Y,Z,HXSK,HYSK,HZSK)

         BXS(K)=BXSK+HXSK
         BYS(K)=BYSK+HYSK
         BZS(K)=BZSK+HZSK

         DO 13 L=1,4
            
            CALL TAILSHT_OE_2017 (1,K,L,X,Y,Z,AJM,AJMD,BXOKL,
     *       BYOKL,BZOKL)
            CALL SHTBNORM_O_2017 (  K,L,X,Y,Z,HXOKL,HYOKL,HZOKL)

            BXO(K,L)=BXOKL+HXOKL
            BYO(K,L)=BYOKL+HYOKL
            BZO(K,L)=BZOKL+HZOKL

            CALL TAILSHT_OE_2017 (0,K,L,X,Y,Z,AJM,AJMD,
     *          BXEKL,BYEKL,BZEKL)
            CALL SHTBNORM_E_2017 (  K,L,X,Y,Z,HXEKL,HYEKL,HZEKL)

            BXE(K,L)=BXEKL+HXEKL
            BYE(K,L)=BYEKL+HYEKL
            BZE(K,L)=BZEKL+HZEKL
            
 13      CONTINUE
         
 11   CONTINUE
      
      RETURN
      END

C==========================================================================
C     July 2017, G.K.Stephens, this routine updated to incorporate Jay Albert's
C     improvements to the Bessel function evaluation. The Bessel function
C     values are now precomputed and  passed into this rather than computed 
C     inside this routine.
      SUBROUTINE TAILSHT_S_2017 (M,X,Y,Z,AJM,BX,BY,BZ)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMMON /TAIL/ D  ! THE COMMON BLOCKS FORWARDS TAIL SHEET THICKNESS
      DIMENSION AJM(0:5),AJMD(0:5)
C-----------------------------------------------------------------------------------
C
      RNOT=20.0        !    This can be replaced by introducing them
      DLTK=1.0         !    through the above common block


      RHO=DSQRT(X*X+Y*Y)
      CSPHI=X/RHO
      SNPHI=Y/RHO
C
      DKM=1.D0+(M-1)*DLTK
      RKM=DKM/RNOT
C
      RKMZ=RKM*Z
      RKMR=RKM*RHO

      ZD=DSQRT(Z*Z+D*D)
C
      RJ0=AJM(0)
      RJ1=AJM(1)
c     July 2017, G.K.Stephens, Bessel functions are now passed in.
c      RJ0=bessj0(RKMR)
c      RJ1=bessj1(RKMR)
      REX=DEXP(RKM*ZD)
C
      BX=RKMZ*RJ1*CSPHI/ZD/REX
      BY=RKMZ*RJ1*SNPHI/ZD/REX
      BZ=RKM*RJ0/REX
C
C    CALCULATION OF THE MAGNETOTAIL CURRENT CONTRIBUTION IS FINISHED
C
      RETURN
      END

C==========================================================================
C     July 2017, G.K.Stephens, this routine updated to incorporate Jay Albert's
C     improvements to the Bessel function evaluation.
      SUBROUTINE  SHTBNORM_S_2017(K,X,Y,Z,FX,FY,FZ) ! modified SHTBNORM_S
      IMPLICIT  REAL * 8  (A - H, O - Z)
      DIMENSION AK(5)
      DIMENSION AJM(0:14),AJMD(0:14)
      COMMON /TSS/ TSS(80,5)
      
      AK(1)=TSS(76,K)
      AK(2)=TSS(77,K)
      AK(3)=TSS(78,K)
      AK(4)=TSS(79,K)
      AK(5)=TSS(80,K)
      
      phi=DATAN2(Y,X)
      RHO=dsqrt(X*X+Y*Y)
      if (RHO.lt.1.D-8) then
         RHOI=1.D8
      else
         RHOI=1.D0/RHO
      endif
      DPDX=-Y*RHOI*RHOI
      DPDY= X*RHOI*RHOI
      
      FX=0.D0
      FY=0.D0
      FZ=0.D0
      
      DO 2 n=1,5
         AKN=dabs(AK(n))
         AKNR=AKN*RHO
         if (AKNR.lt.1.D-8) then
            AKNRI=1.D8
         else
            AKNRI=1.D0/AKNR
         endif
         
         CHZ=dcosh(Z*AKN)
         SHZ=dsinh(Z*AKN)
           
         CALL BESSJJ_2017(14,AKNR, AJM) !!! get all n in one call
         DO 3 m=1,14
            AJMD(m)=AJM(m-1)-m*AJM(m)*AKNRI
 3       CONTINUE
         AJMD(0)=-AJM(1)
         
         DO 4 m=0,14
            CMP=DCOS(m*phi)
            SMP=DSIN(m*phi)
            
            HX1=m*DPDX*SMP*SHZ*AJM(m)
            HX2=-AKN*X*RHOI*CMP*SHZ*AJMD(m)
            HX=HX1+HX2
            HY1=m*DPDY*SMP*SHZ*AJM(m)
            HY2=-AKN*Y*RHOI*CMP*SHZ*AJMD(m)
            HY=HY1+HY2
            HZ=-AKN*CMP*CHZ*AJM(m)
            
            L=n+5*m
            FX=FX+HX*TSS(L,K)
            FY=FY+HY*TSS(L,K)
            FZ=FZ+HZ*TSS(L,K)
 4       CONTINUE
 2    CONTINUE
      RETURN
      END

C==========================================================================
C     July 2017, G.K.Stephens, this routine updated to incorporate Jay Albert's
C     improvements to the Bessel function evaluation. The Bessel function
C     values are now precomputed and  passed into this rather than computed 
C     inside this routine.
      SUBROUTINE TAILSHT_OE_2017 (IEVO,MK,M,X,Y,Z,AJM,AJMD,BX,BY,BZ)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMMON /TAIL/ D0  ! THE COMMON BLOCKS FORWARDS TAIL SHEET THICKNESS
      DIMENSION AJM(0:5),AJMD(0:5)
C-----------------------------------------------------------------------------------
C
      RNOT=20.0     !    Rho_0 - scale parameter along the tail axis
      DLTK=1.0      !    step in Km
c
c -----------------------------------------------------------------------------------

      RHO=DSQRT(X*X+Y*Y)
C
      CSPHI=X/RHO
      SNPHI=Y/RHO
C
      phi=DATAN2(Y,X)
      CSMPHI=DCOS(m*phi)
      SNMPHI=DSIN(m*phi)
C
      DKM=1.D0+(MK-1)*DLTK
      RKM=DKM/RNOT
C
      RKMZ=RKM*Z
      RKMR=RKM*RHO
C
      ZD=DSQRT(Z*Z+D0*D0)
C
      REX=DEXP(RKM*ZD)
c
c     July 2017, G.K.Stephens, Jm is now passed in, not computed internally
c ---- calculating Jm and its derivatives ------
c
c                   if(m.gt.2) then
c                   AJM=bessj(m,RKMR)
c                   AJM1=bessj(m-1,RKMR)
c                   AJMD=AJM1-m*AJM/RKMR
c                   else
c                  --------------------
c                   if(m.eq.2) then
c                   AJM=bessj(2,RKMR)
c                   AJM1=bessj1(RKMR)
c                   AJMD=AJM1-m*AJM/RKMR
c                   else
c                  --------------------
c                   AJM=bessj1(RKMR)
c                   AJM1=bessj0(RKMR)
c                   AJMD=AJM1-AJM/RKMR
c                  --------------------
c                   end if
c                  --------------------
c                   endif
c -----------------------------------------
c
      if(ievo.eq.0) then
c -----------------------------------------
c calculating symmetric modes
c -----------------------------------------
c
      BRO=-M*SNMPHI*Z*AJMD(m)/ZD/REX
      BPHI=-M*M*CSMPHI*Z*AJM(m)/RKMR/ZD/REX
      BZ=M*SNMPHI*AJM(m)/REX
c
c -----------------------------------------
      else
c -----------------------------------------
c calculating asymmetric modes
c -----------------------------------------
c
      BRO=M*CSMPHI*Z*AJMD(m)/ZD/REX
      BPHI=-M*M*SNMPHI*Z*AJM(m)/RKMR/ZD/REX
      BZ=-M*CSMPHI*AJM(m)/REX
c
c -----------------------------------------
      end if
c
c --- transformation from cylindrical ccordinates to GSM ---
c
      BX=BRO*CSPHI-BPHI*SNPHI
      BY=BRO*SNPHI+BPHI*CSPHI
C
C    CALCULATION OF THE MAGNETOTAIL CURRENT CONTRIBUTION IS FINISHED
C
      RETURN
      END

C==========================================================================
C     July 2017, G.K.Stephens, this routine updated to incorporate Jay Albert's
C     improvements to the Bessel function evaluation.
      SUBROUTINE  SHTBNORM_O_2017(K,L,X,Y,Z,FX,FY,FZ) ! modified SHTBNORM_O
      IMPLICIT  REAL * 8  (A - H, O - Z)
      DIMENSION AK(5)
      DIMENSION AJM(0:14),AJMD(0:14)
      COMMON /TSO/ TSO(80,5,4)
      
      AK(1)=TSO(76,K,L)
      AK(2)=TSO(77,K,L)
      AK(3)=TSO(78,K,L)
      AK(4)=TSO(79,K,L)
      AK(5)=TSO(80,K,L)
      
      phi=DATAN2(Y,X)
      RHO=dsqrt(X*X+Y*Y)
      if(RHO.lt.1.D-8) then
         RHOI=1.D8
      else
         RHOI=1.D0/RHO
      endif
      DPDX=-Y*RHOI*RHOI
      DPDY= X*RHOI*RHOI

      FX=0.D0
      FY=0.D0
      FZ=0.D0
      
      DO 2 n=1,5
         AKN=dabs(AK(n))
         AKNR=AKN*RHO
         if(AKNR.lt.1.D-8) then
            AKNRI=1.D8
         else
            AKNRI=1.D0/AKNR
         endif
         
         CHZ=dcosh(Z*AKN)
         SHZ=dsinh(Z*AKN)

         CALL BESSJJ_2017(14,AKNR, AJM) !!! get all n in one call
         DO 3 m=1,14
            AJMD(m)=AJM(m-1)-m*AJM(m)*AKNRI
 3       CONTINUE
         AJMD(0)=-AJM(1)
         
         DO 4 m=0,14
            CMP=DCOS(m*phi)
            SMP=DSIN(m*phi)

            HX1=m*DPDX*SMP*SHZ*AJM(m)
            HX2=-AKN*X*RHOI*CMP*SHZ*AJMD(m)
            HX=HX1+HX2
            HY1=m*DPDY*SMP*SHZ*AJM(m)
            HY2=-AKN*Y*RHOI*CMP*SHZ*AJMD(m)
            HY=HY1+HY2
            HZ=-AKN*CMP*CHZ*AJM(m)

            L1=n+5*m
            FX=FX+HX*TSO(L1,K,L)
            FY=FY+HY*TSO(L1,K,L)
            FZ=FZ+HZ*TSO(L1,K,L)
 4       CONTINUE
 2    CONTINUE
      RETURN
      END

C==========================================================================
C     July 2017, G.K.Stephens, this routine updated to incorporate Jay Albert's
C     improvements to the Bessel function evaluation.
      SUBROUTINE  SHTBNORM_E_2017(K,L,X,Y,Z,FX,FY,FZ) ! modified SHTBNORM_E
      IMPLICIT  REAL * 8  (A - H, O - Z)
      DIMENSION AK(5)
      DIMENSION AJM(0:14),AJMD(0:14)
      COMMON /TSE/ TSE(80,5,4)
      
      AK(1)=TSE(76,K,L)
      AK(2)=TSE(77,K,L)
      AK(3)=TSE(78,K,L)
      AK(4)=TSE(79,K,L)
      AK(5)=TSE(80,K,L)

      phi=DATAN2(Y,X)
      RHO=dsqrt(X*X+Y*Y)
      if(RHO.lt.1.D-8) then
         RHOI=1.D8
      else
         RHOI=1.D0/RHO
      endif
      DPDX=-Y*RHOI*RHOI
      DPDY= X*RHOI*RHOI
      
      FX=0.D0
      FY=0.D0
      FZ=0.D0

      DO 2 n=1,5
         AKN=dabs(AK(n))
         AKNR=AKN*RHO
         if(AKNR.lt.1.D-8) then
            AKNRI=1.D8
         else
            AKNRI=1.D0/AKNR
         endif
         
         CHZ=dcosh(Z*AKN)
         SHZ=dsinh(Z*AKN)
         
         CALL BESSJJ_2017(14,AKNR, AJM) !!! get all n in one call
         DO 3 m=1,14
            AJMD(m)=AJM(m-1)-m*AJM(m)*AKNRI
 3       CONTINUE
         AJMD(0)=-AJM(1)

         DO 4 m=0,14
            CMP=DCOS(m*phi)
            SMP=DSIN(m*phi)

            HX1=-m*DPDX*CMP*SHZ*AJM(m)
            HX2=-AKN*X*RHOI*SMP*SHZ*AJMD(m)
            HX=HX1+HX2
            HY1=-m*DPDY*CMP*SHZ*AJM(m)
            HY2=-AKN*Y*RHOI*SMP*SHZ*AJMD(m)
            HY=HY1+HY2
            HZ=-AKN*SMP*CHZ*AJM(m)
            
            L1=n+5*m
            FX=FX+HX*TSE(L1,K,L)
            FY=FY+HY*TSE(L1,K,L)
            FZ=FZ+HZ*TSE(L1,K,L)
 4       CONTINUE
 2    CONTINUE
      RETURN
      END

C==========================================================================
C     July 2017, G.K.Stephens, this routine updated to incorporate Jay Albert's
C     improvements to the Bessel function evaluation.
      SUBROUTINE BESSJJ_2017(n,x, bessJ)
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension bessJ(0:n) ! bessJ holds J0 to Jn
      PARAMETER (IACC=40,BIGNO=1.D10,BIGNI=1.D-10)
      logical iseven
      ax=Dabs(x)

      tox=2.D0/ax
c     start at some large m, larger than the desired n, multiply by 2 to ensure
c     m starts at an even number
      m=2*((n+int(Dsqrt(Dfloat(IACC*n))))/2)

      evnsum=0.D0! keeps track of the sum of the even Js (J0+J2+J4+...)
      iseven = .false.

c     we set the value of Jm to some arbitrary value, here Jm=1, after the loop
c     is done, the values will be normalized using the sum
      bjp=0.D0
      bj =1.D0

c     initialize to zero
      do i=0,n
         bessJ(i)=0.
      enddo

      do 12 j=m,1,-1

c     the next value int the recursion relation J_n-1 = (2*n/x)*Jn - J_n+1
         bjm=j*tox*bj-bjp
         bjp=bj! decrement so shift J_n+1 ot Jn
         bj=bjm! decrement so shift J_n ot J_n-1

c     if the value gets too large, shift the decimal of everything by 10 places
         if (Dabs(bj).gt.BIGNO) then
            bj =bj *BIGNI
            bjp=bjp*BIGNI
            evnsum=evnsum*BIGNI
	        do i=j+1,n
	       bessJ(i)=bessJ(i)*BIGNI
            enddo
         endif

         if(iseven)evnsum=evnsum+bj ! only sum over the even Jns
         iseven=.not.iseven

         if(j.le.n) bessJ(j)=bjp ! Jj(x)

12    continue

c     sum is currently the sum of all the evens
c     use Miller's algorithm for Bessel functions which uses the identity: 
c     1.0 = 2.0*sum(J_evens) - J0, thus the quantity (2.0*sum(J_evens) - J0)
c     is used as a normalization factor
      bnorm=2.D0*evnsum-bj

c     normalize the Bessel functions
      do i=1,n
         bessJ(i)=bessJ(i)/bnorm
      enddo
      bessJ(0)=bj/bnorm ! J0(x)

c     Apply Jn(-x) = (-1)^n * Jn(x)
      if (x .lt. 0.D0) then
         do i=1,n,2
            bessJ(i)=-bessJ(i)
         enddo
      endif

      return
      END


c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
      SUBROUTINE BIRK_TOT_2017 (PS,X,Y,Z,BX11,BY11,BZ11,BX12,BY12,BZ12,
     *                          BX21,BY21,BZ21,BX22,BY22,BZ22)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SH11(86),SH12(86),SH21(86),SH22(86)
      COMMON /BIRKPAR/ XKAPPA1,XKAPPA2   !  INPUT PARAMETERS, SPECIFIED FROM A MAIN PROGRAM
      COMMON /DPHI_B_RHO0/ DPHI,B,RHO_0,XKAPPA ! PARAMETERS, CONTROL DAY-NIGHT ASYMMETRY OF F.A.C.

      DATA SH11/46488.84663,-15541.95244,-23210.09824,-32625.03856,
     *-109894.4551,-71415.32808,58168.94612,55564.87578,-22890.60626,
     *-6056.763968,5091.368100,239.7001538,-13899.49253,4648.016991,
     *6971.310672,9699.351891,32633.34599,21028.48811,-17395.96190,
     *-16461.11037,7447.621471,2528.844345,-1934.094784,-588.3108359,
     *-32588.88216,10894.11453,16238.25044,22925.60557,77251.11274,
     *50375.97787,-40763.78048,-39088.60660,15546.53559,3559.617561,
     *-3187.730438,309.1487975,88.22153914,-243.0721938,-63.63543051,
     *191.1109142,69.94451996,-187.9539415,-49.89923833,104.0902848,
     *-120.2459738,253.5572433,89.25456949,-205.6516252,-44.93654156,
     *124.7026309,32.53005523,-98.85321751,-36.51904756,98.88241690,
     *24.88493459,-55.04058524,61.14493565,-128.4224895,-45.35023460,
     *105.0548704,-43.66748755,119.3284161,31.38442798,-92.87946767,
     *-33.52716686,89.98992001,25.87341323,-48.86305045,59.69362881,
     *-126.5353789,-44.39474251,101.5196856,59.41537992,41.18892281,
     *80.86101200,3.066809418,7.893523804,30.56212082,10.36861082,
     *8.222335945,19.97575641,2.050148531,4.992657093,2.300564232,
     *.2256245602,-.05841594319/

      DATA SH12/210260.4816,-1443587.401,-1468919.281,281939.2993,
     *-1131124.839,729331.7943,2573541.307,304616.7457,468887.5847,
     *181554.7517,-1300722.650,-257012.8601,645888.8041,-2048126.412,
     *-2529093.041,571093.7972,-2115508.353,1122035.951,4489168.802,
     *75234.22743,823905.6909,147926.6121,-2276322.876,-155528.5992,
     *-858076.2979,3474422.388,3986279.931,-834613.9747,3250625.781,
     *-1818680.377,-7040468.986,-414359.6073,-1295117.666,-346320.6487,
     *3565527.409,430091.9496,-.1565573462,7.377619826,.4115646037,
     *-6.146078880,3.808028815,-.5232034932,1.454841807,-12.32274869,
     *-4.466974237,-2.941184626,-.6172620658,12.64613490,1.494922012,
     *-21.35489898,-1.652256960,16.81799898,-1.404079922,-24.09369677,
     *-10.99900839,45.94237820,2.248579894,31.91234041,7.575026816,
     *-45.80833339,-1.507664976,14.60016998,1.348516288,-11.05980247,
     *-5.402866968,31.69094514,12.28261196,-37.55354174,4.155626879,
     *-33.70159657,-8.437907434,36.22672602,145.0262164,70.73187036,
     *85.51110098,21.47490989,24.34554406,31.34405345,4.655207476,
     *5.747889264,7.802304187,1.844169801,4.867254550,2.941393119,
     *.1379899178,.06607020029/

      DATA SH21/162294.6224,503885.1125,-27057.67122,-531450.1339,
     *84747.05678,-237142.1712,84133.61490,259530.0402,69196.05160,
     *-189093.5264,-19278.55134,195724.5034,-263082.6367,-818899.6923,
     *43061.10073,863506.6932,-139707.9428,389984.8850,-135167.5555,
     *-426286.9206,-109504.0387,295258.3531,30415.07087,-305502.9405,
     *100785.3400,315010.9567,-15999.50673,-332052.2548,54964.34639,
     *-152808.3750,51024.67566,166720.0603,40389.67945,-106257.7272,
     *-11126.14442,109876.2047,2.978695024,558.6019011,2.685592939,
     *-338.0004730,-81.99724090,-444.1102659,89.44617716,212.0849592,
     *-32.58562625,-982.7336105,-35.10860935,567.8931751,-1.917212423,
     *-260.2023543,-1.023821735,157.5533477,23.00200055,232.0603673,
     *-36.79100036,-111.9110936,18.05429984,447.0481000,15.10187415,
     *-258.7297813,-1.032340149,-298.6402478,-1.676201415,180.5856487,
     *64.52313024,209.0160857,-53.85574010,-98.52164290,14.35891214,
     *536.7666279,20.09318806,-309.7349530,58.54144539,67.45226850,
     *97.92374406,4.752449760,10.46824379,32.91856110,12.05124381,
     *9.962933904,15.91258637,1.804233877,6.578149088,2.515223491,
     *.1930034238,-.02261109942/

      DATA SH22/-131287.8986,-631927.6885,-318797.4173,616785.8782,
     *-50027.36189,863099.9833,47680.20240,-1053367.944,-501120.3811,
     *-174400.9476,222328.6873,333551.7374,-389338.7841,-1995527.467,
     *-982971.3024,1960434.268,297239.7137,2676525.168,-147113.4775,
     *-3358059.979,-2106979.191,-462827.1322,1017607.960,1039018.475,
     *520266.9296,2627427.473,1301981.763,-2577171.706,-238071.9956,
     *-3539781.111,94628.16420,4411304.724,2598205.733,637504.9351,
     *-1234794.298,-1372562.403,-2.646186796,-31.10055575,2.295799273,
     *19.20203279,30.01931202,-302.1028550,-14.78310655,162.1561899,
     *.4943938056,176.8089129,-.2444921680,-100.6148929,9.172262228,
     *137.4303440,-8.451613443,-84.20684224,-167.3354083,1321.830393,
     *76.89928813,-705.7586223,18.28186732,-770.1665162,-9.084224422,
     *436.3368157,-6.374255638,-107.2730177,6.080451222,65.53843753,
     *143.2872994,-1028.009017,-64.22739330,547.8536586,-20.58928632,
     *597.3893669,10.17964133,-337.7800252,159.3532209,76.34445954,
     *84.74398828,12.76722651,27.63870691,32.69873634,5.145153451,
     *6.310949163,6.996159733,1.971629939,4.436299219,2.904964304,
     *.1486276863,.06859991529/

C ====   LEAST SQUARES FITTING ONLY:
C       BX11=0.D0
C       BY11=0.D0
C       BZ11=0.D0
C       BX12=0.D0
C       BY12=0.D0
C       BZ12=0.D0
C       BX21=0.D0
C       BY21=0.D0
C       BZ21=0.D0
C       BX22=0.D0
C       BY22=0.D0
C       BZ22=0.D0
C===================================

      XKAPPA=XKAPPA1        !  FORWARDED IN BIRK_1N22017
      X_SC=XKAPPA1-1.1D0    !  FORWARDED IN BIRK_SHL

      CALL BIRK_1N2_2017 (1,1,PS,X,Y,Z,FX11,FY11,FZ11)           !  REGION 1, MODE 1
      CALL BIRK_SHL_2017 (SH11,PS,X_SC,X,Y,Z,HX11,HY11,HZ11)
      BX11=FX11+HX11
      BY11=FY11+HY11
      BZ11=FZ11+HZ11

      CALL BIRK_1N2_2017 (1,2,PS,X,Y,Z,FX12,FY12,FZ12)           !  REGION 1, MODE 2
      CALL BIRK_SHL_2017 (SH12,PS,X_SC,X,Y,Z,HX12,HY12,HZ12)
      BX12=FX12+HX12
      BY12=FY12+HY12
      BZ12=FZ12+HZ12

      XKAPPA=XKAPPA2        !  FORWARDED IN BIRK_1N207
      X_SC=XKAPPA2-1.0D0    !  FORWARDED IN BIRK_SHL

      CALL BIRK_1N2_2017 (2,1,PS,X,Y,Z,FX21,FY21,FZ21)           !  REGION 2, MODE 1
      CALL BIRK_SHL_2017 (SH21,PS,X_SC,X,Y,Z,HX21,HY21,HZ21)
      BX21=FX21+HX21
      BY21=FY21+HY21
      BZ21=FZ21+HZ21

      CALL BIRK_1N2_2017 (2,2,PS,X,Y,Z,FX22,FY22,FZ22)           !  REGION 2, MODE 2
      CALL BIRK_SHL_2017 (SH22,PS,X_SC,X,Y,Z,HX22,HY22,HZ22)
      BX22=FX22+HX22
      BY22=FY22+HY22
      BZ22=FZ22+HZ22

      RETURN
      END
C
c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c
      SUBROUTINE BIRK_1N2_2017 (NUMB,MODE,PS,X,Y,Z,BX,BY,BZ)        !   SEE NB# 6, P.60
C
C  CALCULATES COMPONENTS  OF REGION 1/2 FIELD IN SPHERICAL COORDS.  DERIVED FROM THE S/R DIPDEF2C (WHICH
C    DOES THE SAME JOB, BUT INPUT/OUTPUT THERE WAS IN SPHERICAL COORDS, WHILE HERE WE USE CARTESIAN ONES)
C
C   INPUT:  NUMB=1 (2) FOR REGION 1 (2) CURRENTS
C           MODE=1 YIELDS SIMPLE SINUSOIDAL MLT VARIATION, WITH MAXIMUM CURRENT AT DAWN/DUSK MERIDIAN
C     WHILE MODE=2 YIELDS THE SECOND HARMONIC.
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A11(31),A12(31),A21(31),A22(31)
      COMMON /MODENUM/ M
      COMMON /DTHETA/ DTHETA

      COMMON /DPHI_B_RHO0/ DPHI,B,RHO_0,XKAPPA ! THESE PARAMETERS CONTROL DAY-NIGHT ASYMMETRY OF F.A.C., AS FOLLOWS:

C  (1) DPHI:   HALF-DIFFERENCE (IN RADIANS) BETWEEN DAY AND NIGHT LATITUDE OF FAC OVAL AT IONOSPHERIC ALTITUDE;
C              TYPICAL VALUE: 0.06
C  (2) B:      AN ASYMMETRY FACTOR AT HIGH-ALTITUDES;  FOR B=0, THE ONLY ASYMMETRY IS THAT FROM DPHI
C              TYPICAL VALUES: 0.35-0.70
C  (3) RHO_0:  A FIXED PARAMETER, DEFINING THE DISTANCE RHO, AT WHICH THE LATITUDE SHIFT GRADUALLY SATURATES AND
C              STOPS INCREASING
C              ITS VALUE WAS ASSUMED FIXED, EQUAL TO 7.0.
C  (4) XKAPPA: AN OVERALL SCALING FACTOR, WHICH CAN BE USED FOR CHANGING THE SIZE OF THE F.A.C. OVAL
C
      DATA BETA,RH,EPS/0.9D0,10.D0,3.D0/ ! parameters of the tilt-dependent deformation of the untilted F.A.C. field

      DATA A11/.1618068350,-.1797957553,2.999642482,-.9322708978,
     *-.6811059760,.2099057262,-8.358815746,-14.86033550,.3838362986,
     *-16.30945494,4.537022847,2.685836007,27.97833029,6.330871059,
     *1.876532361,18.95619213,.9651528100,.4217195118,-.08957770020,
     *-1.823555887,.7457045438,-.5785916524,-1.010200918,.01112389357,
     *.09572927448,-.3599292276,8.713700514,.9763932955,3.834602998,
     *2.492118385,.7113544659/
      DATA A12/.7058026940,-.2845938535,5.715471266,-2.472820880,
     *-.7738802408,.3478293930,-11.37653694,-38.64768867,.6932927651,
     *-212.4017288,4.944204937,3.071270411,33.05882281,7.387533799,
     *2.366769108,79.22572682,.6154290178,.5592050551,-.1796585105,
     *-1.654932210,.7309108776,-.4926292779,-1.130266095,-.009613974555,
     *.1484586169,-.2215347198,7.883592948,.02768251655,2.950280953,
     *1.212634762,.5567714182/
      DATA A21/.1278764024,-.2320034273,1.805623266,-32.37241440,
     *-.9931490648,.3175085630,-2.492465814,-16.21600096,.2695393416,
     *-6.752691265,3.971794901,14.54477563,41.10158386,7.912889730,
     *1.258297372,9.583547721,1.014141963,.5104134759,-.1790430468,
     *-1.756358428,.7561986717,-.6775248254,-.04014016420,.01446794851,
     *.1200521731,-.2203584559,4.508963850,.8221623576,1.779933730,
     *1.102649543,.8867880020/
      DATA A22/.4036015198,-.3302974212,2.827730930,-45.44405830,
     *-1.611103927,.4927112073,-.003258457559,-49.59014949,.3796217108,
     *-233.7884098,4.312666980,18.05051709,28.95320323,11.09948019,
     *.7471649558,67.10246193,.5667096597,.6468519751,-.1560665317,
     *-1.460805289,.7719653528,-.6658988668,.2515179349E-05,
     *.02426021891,.1195003324,-.2625739255,4.377172556,.2421190547,
     *2.503482679,1.071587299,.7247997430/

      B=0.5
      RHO_0=7.0

      M=MODE
      IF (NUMB.EQ.1) THEN
          DPHI=0.055D0
          DTHETA=0.06D0
      ENDIF

      IF (NUMB.EQ.2) THEN
          DPHI=0.030D0
          DTHETA=0.09D0
      ENDIF

      Xsc=X*XKAPPA
      Ysc=Y*XKAPPA
      Zsc=Z*XKAPPA
      RHO=DSQRT(Xsc**2+Zsc**2)

      Rsc=DSQRT(Xsc**2+Ysc**2+Zsc**2)                                 !  SCALED
      RHO2=RHO_0**2

      IF (Xsc.EQ.0.D0.AND.Zsc.EQ.0.D0) THEN
         PHI=0.D0
      ELSE
         PHI=DATAN2(-Zsc,Xsc)  !  FROM CARTESIAN TO CYLINDRICAL (RHO,PHI,Y)
      ENDIF

      SPHIC=DSIN(PHI)
      CPHIC=DCOS(PHI)  !  "C" means "CYLINDRICAL", TO DISTINGUISH FROM SPHERICAL PHI

      BRACK=DPHI+B*RHO2/(RHO2+1.D0)*(RHO**2-1.D0)/(RHO2+RHO**2)
      R1RH=(Rsc-1.D0)/RH
      PSIAS=BETA*PS/(1.D0+R1RH**EPS)**(1.D0/EPS)

      PHIS=PHI-BRACK*DSIN(PHI) -PSIAS
      DPHISPHI=1.D0-BRACK*DCOS(PHI)
      DPHISRHO=-2.D0*B*RHO2*RHO/(RHO2+RHO**2)**2 *DSIN(PHI)
     *   +BETA*PS*R1RH**(EPS-1.D0)*RHO/(RH*Rsc*
     *   (1.D0+R1RH**EPS)**(1.D0/EPS+1.D0))
      DPHISDY= BETA*PS*R1RH**(EPS-1.D0)*Ysc/(RH*Rsc*
     *   (1.D0+R1RH**EPS)**(1.D0/EPS+1.D0))

      SPHICS=DSIN(PHIS)
      CPHICS=DCOS(PHIS)

      XS= RHO*CPHICS
      ZS=-RHO*SPHICS

      IF (NUMB.EQ.1) THEN
        IF (MODE.EQ.1) CALL TWOCONES_2017 (A11,XS,Ysc,ZS,BXS,BYAS,BZS)
        IF (MODE.EQ.2) CALL TWOCONES_2017 (A12,XS,Ysc,ZS,BXS,BYAS,BZS)
      ELSE
        IF (MODE.EQ.1) CALL TWOCONES_2017 (A21,XS,Ysc,ZS,BXS,BYAS,BZS)
        IF (MODE.EQ.2) CALL TWOCONES_2017 (A22,XS,Ysc,ZS,BXS,BYAS,BZS)
      ENDIF

      BRHOAS=BXS*CPHICS-BZS*SPHICS
      BPHIAS=-BXS*SPHICS-BZS*CPHICS

      BRHO_S=BRHOAS*DPHISPHI                             *XKAPPA        ! SCALING
      BPHI_S=(BPHIAS-RHO*(BYAS*DPHISDY+BRHOAS*DPHISRHO)) *XKAPPA
      BY_S=BYAS*DPHISPHI                                 *XKAPPA

      BX=BRHO_S*CPHIC-BPHI_S*SPHIC
      BY=BY_S
      BZ=-BRHO_S*SPHIC-BPHI_S*CPHIC

      RETURN
      END
c
C=========================================================================
c
      SUBROUTINE TWOCONES_2017 (A,X,Y,Z,BX,BY,BZ)
C
C   ADDS FIELDS FROM TWO CONES (NORTHERN AND SOUTHERN), WITH A PROPER SYMMETRY OF THE CURRENT AND FIELD,
C     CORRESPONDING TO THE REGION 1 BIRKELAND CURRENTS. (SEE NB #6, P.58).
C

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)

      CALL ONE_CONE_2017 (A,X,Y,Z,BXN,BYN,BZN)
      CALL ONE_CONE_2017 (A,X,-Y,-Z,BXS,BYS,BZS)
      BX=BXN-BXS
      BY=BYN+BYS
      BZ=BZN+BZS

      RETURN
      END
c
C-------------------------------------------------------------------------
C
      SUBROUTINE ONE_CONE_2017(A,X,Y,Z,BX,BY,BZ)
c
c  RETURNS FIELD COMPONENTS FOR A DEFORMED CONICAL CURRENT SYSTEM, FITTED TO A BIOSAVART FIELD
c    BY SIM_14.FOR.  HERE ONLY THE NORTHERN CONE IS TAKEN INTO ACCOUNT.
c

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)

      COMMON /DTHETA/ DTHETA
      COMMON /MODENUM/ M

      DATA DR,DT/1.D-6,1.D-6/  !   JUST FOR NUMERICAL DIFFERENTIATION

      THETA0=A(31)

      RHO2=X**2+Y**2
      RHO=DSQRT(RHO2)
      R=DSQRT(RHO2+Z**2)
      THETA=DATAN2(RHO,Z)
      PHI=DATAN2(Y,X)
C
C   MAKE THE DEFORMATION OF COORDINATES:
C
       RS=R_S_2017(A,R,THETA)
       THETAS=THETA_S_2017(A,R,THETA)
       PHIS=PHI
C
C   CALCULATE FIELD COMPONENTS AT THE NEW POSITION (ASTERISKED):
C
c       MODE #M
       CALL FIALCOS_2017 (RS,THETAS,PHIS,BTAST,BFAST,M,THETA0,DTHETA)   
C
C   NOW TRANSFORM B{R,T,F}_AST BY THE DEFORMATION TENSOR:
C
C      FIRST OF ALL, FIND THE DERIVATIVES:
C
       DRSDR=(R_S_2017(A,R+DR,THETA)-R_S_2017(A,R-DR,THETA))/(2.D0*DR)
       DRSDT=(R_S_2017(A,R,THETA+DT)-R_S_2017(A,R,THETA-DT))/(2.D0*DT)
       DTSDR=(THETA_S_2017(A,R+DR,THETA)-
     &  THETA_S_2017(A,R-DR,THETA))/(2.D0*DR)
       DTSDT=(THETA_S_2017(A,R,THETA+DT)-
     &  THETA_S_2017(A,R,THETA-DT))/(2.D0*DT)
       STSST=DSIN(THETAS)/DSIN(THETA)
       RSR=RS/R

       BR     =-RSR/R*STSST*BTAST*DRSDT                 !   NB#6, P.43    BRAST DOES NOT ENTER HERE
       BTHETA = RSR*STSST*BTAST*DRSDR                  !               (SINCE IT IS ZERO IN OUR CASE)
       BPHI   = RSR*BFAST*(DRSDR*DTSDT-DRSDT*DTSDR)

       S=RHO/R
       C=Z/R
       SF=Y/RHO
       CF=X/RHO

       BE=BR*S+BTHETA*C

       BX=A(1)*(BE*CF-BPHI*SF)
       BY=A(1)*(BE*SF+BPHI*CF)
       BZ=A(1)*(BR*C-BTHETA*S)

       RETURN
       END
C
C=====================================================================================
      DOUBLE PRECISION FUNCTION R_S_2017(A,R,THETA)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)
C
      R_S_2017=R+A(2)/R+A(3)*R/DSQRT(R**2+A(11)**2)+A(4)*R/
     *(R**2+A(12)**2)
     *+(A(5)+A(6)/R+A(7)*R/DSQRT(R**2+A(13)**2)+A(8)*R/(R**2+A(14)**2))*
     * DCOS(THETA)
     *+(A(9)*R/DSQRT(R**2+A(15)**2)+A(10)*R/(R**2+A(16)**2)**2)
     * *DCOS(2.D0*THETA)
C
      RETURN
      END
C
C-----------------------------------------------------------------------------
C
      DOUBLE PRECISION FUNCTION THETA_S_2017(A,R,THETA)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)
c
      THETA_S_2017=THETA+(A(17)+A(18)/R+A(19)/R**2
     *                +A(20)*R/DSQRT(R**2+A(27)**2))*DSIN(THETA)
     * +(A(21)+A(22)*R/DSQRT(R**2+A(28)**2)
     *                +A(23)*R/(R**2+A(29)**2))*DSIN(2.D0*THETA)
     * +(A(24)+A(25)/R+A(26)*R/(R**2+A(30)**2))*DSIN(3.D0*THETA)
C
      RETURN
      END
C
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
      SUBROUTINE FIALCOS_2017(R,THETA,PHI,BTHETA,BPHI,N,THETA0,DT)
C
C  CONICAL MODEL OF BIRKELAND CURRENT FIELD; BASED ON THE OLD S/R FIALCO (OF 1990-91)
C  SEE THE OLD NOTEBOOK 1985-86-88, NOTE OF MARCH 5, BUT HERE BOTH INPUT AND OUTPUT ARE IN SPHERICAL CDS.

C  BTN, AND BPN ARE THE ARRAYS OF BTHETA AND BPHI (BTN(i), BPN(i) CORRESPOND TO i-th MODE).
C   ONLY FIRST  N  MODE AMPLITUDES ARE COMPUTED (N<=10).
C    THETA0 IS THE ANGULAR HALF-WIDTH OF THE CONE, DT IS THE ANGULAR H.-W. OF THE CURRENT LAYER

C   NOTE:  BR=0  (BECAUSE ONLY RADIAL CURRENTS ARE PRESENT IN THIS MODEL)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION  BTN(10),BPN(10),CCOS(10),SSIN(10)

      SINTE=DSIN(THETA)
      RO=R*SINTE
      COSTE=DCOS(THETA)
      SINFI=DSIN(PHI)
      COSFI=DCOS(PHI)
      TG=SINTE/(1.D0+COSTE)   !        TAN(THETA/2)
      CTG=SINTE/(1.D0-COSTE)  !        CTG(THETA/2)
C
C
      TETANP=THETA0+DT
      TETANM=THETA0-DT
      IF(THETA.LT.TETANM) GOTO 1
      TGP=DTAN(TETANP*0.5D0)
      TGM=DTAN(TETANM*0.5D0)
      TGM2=TGM*TGM
      TGP2=TGP*TGP
  1   CONTINUE

      COSM1=1.D0
      SINM1=0.D0
      TM=1.D0
      TGM2M=1.D0
      TGP2M=1.D0

      DO 2 M=1,N
      TM=TM*TG
      CCOS(M)=COSM1*COSFI-SINM1*SINFI
      SSIN(M)=SINM1*COSFI+COSM1*SINFI
      COSM1=CCOS(M)
      SINM1=SSIN(M)
      IF(THETA.LT.TETANM) THEN
      T=TM
      DTT=0.5D0*M*TM*(TG+CTG)
      DTT0=0.D0
      ELSE IF(THETA.LT.TETANP) THEN
      TGM2M=TGM2M*TGM2
      FC=1.D0/(TGP-TGM)
      FC1=1.D0/(2*M+1)
      TGM2M1=TGM2M*TGM
      TG21=1.D0+TG*TG
      T=FC*(TM*(TGP-TG)+FC1*(TM*TG-TGM2M1/TM))
      DTT=0.5D0*M*FC*TG21*(TM/TG*(TGP-TG)-FC1*(TM-TGM2M1/(TM*TG)))
      DTT0=0.5D0*FC*((TGP+TGM)*(TM*TG-FC1*(TM*TG-TGM2M1/TM))+
     * TM*(1.D0-TGP*TGM)-(1.D0+TGM2)*TGM2M/TM)
      ELSE
      TGP2M=TGP2M*TGP2
      TGM2M=TGM2M*TGM2
      FC=1.D0/(TGP-TGM)
      FC1=1.D0/(2*M+1)
      T=FC*FC1*(TGP2M*TGP-TGM2M*TGM)/TM
      DTT=-T*M*0.5D0*(TG+CTG)
      ENDIF

      BTN(M)=M*T*CCOS(M)/RO
  2   BPN(M)=-DTT*SSIN(M)/R

      BTHETA=BTN(N) *800.
      BPHI  =BPN(N) *800.

      RETURN
      END
C
C-------------------------------------------------------------------------
C
C
         SUBROUTINE BIRK_SHL_2017 (A,PS,X_SC,X,Y,Z,BX,BY,BZ)
C
         IMPLICIT  REAL * 8  (A - H, O - Z)
         DIMENSION A(86)
C
         CPS=DCOS(PS)
         SPS=DSIN(PS)

         S3PS=2.D0*CPS
C
         PST1=PS*A(85)
         PST2=PS*A(86)

         ST1=DSIN(PST1)
         CT1=DCOS(PST1)
         ST2=DSIN(PST2)
         CT2=DCOS(PST2)

         X1=X*CT1-Z*ST1
         Z1=X*ST1+Z*CT1
         X2=X*CT2-Z*ST2
         Z2=X*ST2+Z*CT2
C
         L=0
         GX=0.D0
         GY=0.D0
         GZ=0.D0
C
         DO 1 M=1,2     !    M=1 IS FOR THE 1ST SUM ("PERP." SYMMETRY)
C                          AND M=2 IS FOR THE SECOND SUM ("PARALL." SYMMETRY)
             DO 2 I=1,3
                  P=A(72+I)
                  Q=A(78+I)
                  CYPI=DCOS(Y/P)
                  CYQI=DCOS(Y/Q)
                  SYPI=DSIN(Y/P)
                  SYQI=DSIN(Y/Q)
C
                DO 3 K=1,3
                   R=A(75+K)
                   S=A(81+K)
                   SZRK=DSIN(Z1/R)
                   CZSK=DCOS(Z2/S)
                   CZRK=DCOS(Z1/R)
                   SZSK=DSIN(Z2/S)
                     SQPR=DSQRT(1.D0/P**2+1.D0/R**2)
                     SQQS=DSQRT(1.D0/Q**2+1.D0/S**2)
                        EPR=DEXP(X1*SQPR)
                        EQS=DEXP(X2*SQQS)
C
                  DO 4 N=1,2  ! N=1 IS FOR THE FIRST PART OF EACH COEFFICIENT
C                                AND N=2 IS FOR THE SECOND ONE

                    DO 5 NN=1,2 !   NN = 1,2 FURTHER SPLITS THE COEFFICIENTS INTO 2 PARTS,
C                                         TO TAKE INTO ACCOUNT THE SCALE FACTOR DEPENDENCE

                    IF (M.EQ.1) THEN
                         FX=-SQPR*EPR*CYPI*SZRK
                         FY=EPR*SYPI*SZRK/P
                         FZ=-EPR*CYPI*CZRK/R
                       IF (N.EQ.1) THEN
                         IF (NN.EQ.1) THEN
                          HX=FX
                          HY=FY
                          HZ=FZ
                         ELSE
                          HX=FX*X_SC
                          HY=FY*X_SC
                          HZ=FZ*X_SC
                         ENDIF
                       ELSE
                         IF (NN.EQ.1) THEN
                          HX=FX*CPS
                          HY=FY*CPS
                          HZ=FZ*CPS
                         ELSE
                          HX=FX*CPS*X_SC
                          HY=FY*CPS*X_SC
                          HZ=FZ*CPS*X_SC
                         ENDIF
                       ENDIF

                     ELSE                            !   M.EQ.2
                         FX=-SPS*SQQS*EQS*CYQI*CZSK
                         FY=SPS/Q*EQS*SYQI*CZSK
                         FZ=SPS/S*EQS*CYQI*SZSK
                       IF (N.EQ.1) THEN
                        IF (NN.EQ.1) THEN
                          HX=FX
                          HY=FY
                          HZ=FZ
                        ELSE
                          HX=FX*X_SC
                          HY=FY*X_SC
                          HZ=FZ*X_SC
                        ENDIF
                       ELSE
                        IF (NN.EQ.1) THEN
                         HX=FX*S3PS
                         HY=FY*S3PS
                         HZ=FZ*S3PS
                        ELSE
                         HX=FX*S3PS*X_SC
                         HY=FY*S3PS*X_SC
                         HZ=FZ*S3PS*X_SC
                        ENDIF
                       ENDIF
                  ENDIF
       L=L+1

       IF (M.EQ.1) THEN
       HXR=HX*CT1+HZ*ST1
       HZR=-HX*ST1+HZ*CT1
       ELSE
       HXR=HX*CT2+HZ*ST2
       HZR=-HX*ST2+HZ*CT2
       ENDIF

       GX=GX+HXR*A(L)
       GY=GY+HY *A(L)
  5    GZ=GZ+HZR*A(L)

  4   CONTINUE
  3   CONTINUE
  2   CONTINUE
  1   CONTINUE

      BX=GX
      BY=GY
      BZ=GZ

      RETURN
      END
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
      SUBROUTINE BIRTOTSY_2017 (PS,X,Y,Z,BX11,BY11,BZ11,BX12,BY12,BZ12,
     *                          BX21,BY21,BZ21,BX22,BY22,BZ22)
C
C   THIS S/R IS ALMOST IDENTICAL TO BIRK_TOT, BUT IT IS FOR THE SYMMETRIC MODE, IN WHICH
C     J_parallel IS AN EVEN FUNCTION OF Ygsm.
C
C
C      IOPBS -  BIRKELAND FIELD MODE FLAG:
C         IOPBS=0 - ALL COMPONENTS
C         IOPBS=1 - REGION 1, MODES 1 & 2 (SYMMETRIC !)
C         IOPBS=2 - REGION 2, MODES 1 & 2 (SYMMETRIC !)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SH11(86),SH12(86),SH21(86),SH22(86)
      COMMON /BIRKPAR/ XKAPPA1,XKAPPA2   !  INPUT PARAMETERS, SPECIFIED FROM A MAIN PROGRAM
C                                            (JOINT WITH  BIRK_TOT  FOR THE ANTISYMMETRICAL MODE)
C
      COMMON /DPHI_B_RHO0/ DPHI,B,RHO_0,XKAPPA ! PARAMETERS, CONTROL DAY-NIGHT ASYMMETRY OF F.A.C.
c
      DATA SH11/ 4956703.683,-26922641.21,-11383659.85,29604361.65,
     *-38919785.97,70230899.72,34993479.24,-90409215.02,30448713.69,
     *-48360257.19,-35556751.23,57136283.60,-8013815.613,30784907.86,
     * 13501620.50,-35121638.52,50297295.45,-84200377.18,-46946852.58,
     * 107526898.8,-39003263.47,59465850.17,47264335.10,-68892388.73,
     * 3375901.533,-9181255.754,-4494667.217,10812618.51,-17351920.97,
     * 27016083.00,18150032.11,-33186882.96,13340198.63,-19779685.30,
     * -17891788.15,21625767.23,16135.32442,133094.0241,-13845.61859,
     *-79159.98442,432.1215298,-85438.10368,1735.386707,41891.71284,
     * 18158.14923,-105465.8135,-11685.73823,62297.34252,-10811.08476,
     * -87631.38186,9217.499261,52079.94529,-68.29127454,56023.02269,
     * -1246.029857,-27436.42793,-11972.61726,69607.08725,7702.743803,
     * -41114.36810,12.08269108,-21.30967022,-9.100782462,18.26855933,
     * -7.000685929,26.22390883,6.392164144,-21.99351743,2.294204157,
     * -16.10023369,-1.344314750,9.342121230,148.5493329,99.79912328,
     * 70.78093196,35.23177574,47.45346891,58.44877918,139.8135237,
     * 91.96485261,6.983488815,9.055554871,19.80484284,2.860045019,
     * .8213262337E-01,-.7962186676E-05/
c
      DATA SH12/-1210748.720,-52324903.95,-14158413.33,19426123.60,
     * 6808641.947,-5138390.983,-1118600.499,-4675055.459,2059671.506,
     * -1373488.052,-114704.4353,-1435920.472,1438451.655,61199067.17,
     *  16549301.39,-22802423.47,-7814550.995,5986478.728,1299443.190,
     *  5352371.724,-2994351.520,1898553.337,203158.3658,2270182.134,
     * -618083.3112,-25950806.16,-7013783.326,9698792.575,3253693.134,
     * -2528478.464,-546323.4095,-2217735.237,1495336.589,-914647.4222,
     * -114374.1054,-1200441.634,-507068.4700,1163189.975,998411.8381,
     * -861919.3631,5252210.872,-11668550.16,-4113899.385,6972900.950,
     * -2546104.076,7704014.310,2273077.192,-5134603.198,256205.7901,
     * -589970.8086,-503821.0170,437612.8956,-2648640.128,5887640.735,
     *  2074286.234,-3519291.144,1283847.104,-3885817.147,-1145936.942,
     *  2589753.651,-408.7788403,1234.054185,739.8541716,-965.8068853,
     *  3691.383679,-8628.635819,-2855.844091,5268.500178,-1774.372703,
     *  5515.010707,1556.089289,-3665.434660,204.8672197,110.7748799,
     *  87.36036207,5.522491330,31.06364270,73.57632579,281.5331360,
     *  140.3461448,17.07537768,6.729732641,4.100970449,2.780422877,
     *  .8742978101E-01,-.1028562327E-04/
c
      DATA SH21/-67763516.61,-49565522.84,10123356.08,51805446.10,
     * -51607711.68,164360662.1,-4662006.024,-191297217.6,-7204547.103,
     * 30372354.93,-750371.9365,-36564457.17,61114395.65,45702536.50,
     * -9228894.939,-47893708.68,47290934.33,-149155112.0,4226520.638,
     * 173588334.5,7998505.443,-33150962.72,832493.2094,39892545.84,
     * -11303915.16,-8901327.398,1751557.110,9382865.820,-9054707.868,
     * 27918664.50,-788741.7146,-32481294.42,-2264443.753,9022346.503,
     * -233526.0185,-10856269.53,-244450.8850,1908295.272,185445.1967,
     * -1074202.863,41827.75224,-241553.7626,-20199.12580,123235.6084,
     * 199501.4614,-1936498.464,-178857.4074,1044724.507,121044.9917,
     * -946479.9247,-91808.28803,532742.7569,-20742.28628,120633.2193,
     * 10018.49534,-61599.11035,-98709.58977,959095.1770,88500.43489,
     * -517471.5287,-81.56122911,816.2472344,55.30711710,-454.5368824,
     * 25.74693810,-202.5007350,-7.369350794,104.9429812,58.14049362,
     * -685.5919355,-51.71345683,374.0125033,247.9296982,159.2471769,
     * 102.3151816,15.81062488,34.99767599,133.0832773,219.6475201,
     * 107.9582783,10.00264684,7.718306072,25.22866153,5.013583103,
     * .8407754233E-01,-.9613356793E-05/
c
      DATA SH22/-43404887.31,8896854.538,-8077731.036,-10247813.65,
     * 6346729.086,-9416801.212,-1921670.268,7805483.928,2299301.127,
     * 4856980.170,-1253936.462,-4695042.690,54305735.91,-11158768.10,
     * 10051771.85,12837129.47,-6380785.836,12387093.50,1687850.192,
     * -10492039.47,-5777044.862,-6916507.424,2855974.911,7027302.490,
     * -26176628.93,5387959.610,-4827069.106,-6193036.589,2511954.143,
     * -6205105.083,-553187.2984,5341386.847,3823736.361,3669209.068,
     * -1841641.700,-3842906.796,281561.7220,-5013124.630,379824.5943,
     * 2436137.901,-76337.55394,548518.2676,42134.28632,-281711.3841,
     * -365514.8666,-2583093.138,-232355.8377,1104026.712,-131536.3445,
     *  2320169.882,-174967.6603,-1127251.881,35539.82827,-256132.9284,
     * -19620.06116,131598.7965,169033.6708,1194443.500,107320.3699,
     * -510672.0036,1211.177843,-17278.19863,1140.037733,8347.612951,
     * -303.8408243,2405.771304,174.0634046,-1248.722950,-1231.229565,
     * -8666.932647,-754.0488385,3736.878824,227.2102611,115.9154291,
     * 94.34364830,3.625357304,64.03192907,109.0743468,241.4844439,
     * 107.7583478,22.36222385,6.282634037,27.79399216,2.270602235,
     * .8708605901E-01,-.1256706895E-04/
c
      XKAPPA=XKAPPA1        !  FORWARDED IN BIR1N2SY_2017
      X_SC=XKAPPA1-1.1D0    !  FORWARDED IN BIRSH_SY_2017

      CALL BIR1N2SY_2017 (1,1,PS,X,Y,Z,FX11,FY11,FZ11)           !  REGION 1, MODE 1
      CALL BIRSH_SY_2017 (SH11,PS,X_SC,X,Y,Z,HX11,HY11,HZ11)

      BX11=FX11+HX11
      BY11=FY11+HY11
      BZ11=FZ11+HZ11

      CALL BIR1N2SY_2017 (1,2,PS,X,Y,Z,FX12,FY12,FZ12)           !  REGION 1, MODE 2
      CALL BIRSH_SY_2017 (SH12,PS,X_SC,X,Y,Z,HX12,HY12,HZ12)

      BX12=FX12+HX12
      BY12=FY12+HY12
      BZ12=FZ12+HZ12

      XKAPPA=XKAPPA2        !  FORWARDED IN BIR1N2SY_2017
      X_SC=XKAPPA2-1.0D0    !  FORWARDED IN BIRSH_SY_2017

      CALL BIR1N2SY_2017 (2,1,PS,X,Y,Z,FX21,FY21,FZ21)           !  REGION 2, MODE 1
      CALL BIRSH_SY_2017 (SH21,PS,X_SC,X,Y,Z,HX21,HY21,HZ21)

      BX21=FX21+HX21
      BY21=FY21+HY21
      BZ21=FZ21+HZ21

      CALL BIR1N2SY_2017 (2,2,PS,X,Y,Z,FX22,FY22,FZ22)           !  REGION 2, MODE 2
      CALL BIRSH_SY_2017 (SH22,PS,X_SC,X,Y,Z,HX22,HY22,HZ22)

      BX22=FX22+HX22
      BY22=FY22+HY22
      BZ22=FZ22+HZ22

      RETURN
      END
C
c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      SUBROUTINE BIR1N2SY_2017 (NUMB,MODE,PS,X,Y,Z,BX,BY,BZ)        !   SEE NB# 6, P.60 and NB#7, P.35-...
C
C   THIS CODE IS VERY SIMILAR TO BIRK_1N2_2017, BUT IT IS FOR THE "SYMMETRICAL" MODE, IN WHICH J_parallel
C     IS A SYMMETRIC (EVEN) FUNCTION OF Ygsm
C
C  CALCULATES COMPONENTS  OF REGION 1/2 FIELD IN SPHERICAL COORDS.  DERIVED FROM THE S/R DIPDEF2C (WHICH
C    DOES THE SAME JOB, BUT INPUT/OUTPUT THERE WAS IN SPHERICAL COORDS, WHILE HERE WE USE CARTESIAN ONES)
C
C   INPUT:  NUMB=1 (2) FOR REGION 1 (2) CURRENTS
C           MODE=1 YIELDS SIMPLE SINUSOIDAL MLT VARIATION, WITH MAXIMUM CURRENT AT DAWN/DUSK MERIDIAN
C     WHILE MODE=2 YIELDS THE SECOND HARMONIC.
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A11(31),A12(31),A21(31),A22(31)
      COMMON /MODENUM/ M
      COMMON /DTHETA/ DTHETA

      COMMON /DPHI_B_RHO0/ DPHI,B,RHO_0,XKAPPA ! THESE PARAMETERS CONTROL DAY-NIGHT ASYMMETRY OF F.A.C., AS FOLLOWS:

C  (1) DPHI:   HALF-DIFFERENCE (IN RADIANS) BETWEEN DAY AND NIGHT LATITUDE OF FAC OVAL AT IONOSPHERIC ALTITUDE;
C              TYPICAL VALUE: 0.06
C  (2) B:      AN ASYMMETRY FACTOR AT HIGH-ALTITUDES;  FOR B=0, THE ONLY ASYMMETRY IS THAT FROM DPHI
C              TYPICAL VALUES: 0.35-0.70
C  (3) RHO_0:  A FIXED PARAMETER, DEFINING THE DISTANCE RHO, AT WHICH THE LATITUDE SHIFT GRADUALLY SATURATES AND
C              STOPS INCREASING
C              ITS VALUE WAS ASSUMED FIXED, EQUAL TO 7.0.
C  (4) XKAPPA: AN OVERALL SCALING FACTOR, WHICH CAN BE USED FOR CHANGING THE SIZE OF THE F.A.C. OVAL
C
      DATA BETA,RH,EPS/0.9D0,10.D0,3.D0/ ! parameters of the tilt-dependent deformation of the untilted F.A.C. field

      DATA A11/.1618068350,-.1797957553,2.999642482,-.9322708978,
     *-.6811059760,.2099057262,-8.358815746,-14.86033550,.3838362986,
     *-16.30945494,4.537022847,2.685836007,27.97833029,6.330871059,
     *1.876532361,18.95619213,.9651528100,.4217195118,-.08957770020,
     *-1.823555887,.7457045438,-.5785916524,-1.010200918,.01112389357,
     *.09572927448,-.3599292276,8.713700514,.9763932955,3.834602998,
     *2.492118385,.7113544659/
      DATA A12/.7058026940,-.2845938535,5.715471266,-2.472820880,
     *-.7738802408,.3478293930,-11.37653694,-38.64768867,.6932927651,
     *-212.4017288,4.944204937,3.071270411,33.05882281,7.387533799,
     *2.366769108,79.22572682,.6154290178,.5592050551,-.1796585105,
     *-1.654932210,.7309108776,-.4926292779,-1.130266095,-.009613974555,
     *.1484586169,-.2215347198,7.883592948,.02768251655,2.950280953,
     *1.212634762,.5567714182/
      DATA A21/.1278764024,-.2320034273,1.805623266,-32.37241440,
     *-.9931490648,.3175085630,-2.492465814,-16.21600096,.2695393416,
     *-6.752691265,3.971794901,14.54477563,41.10158386,7.912889730,
     *1.258297372,9.583547721,1.014141963,.5104134759,-.1790430468,
     *-1.756358428,.7561986717,-.6775248254,-.04014016420,.01446794851,
     *.1200521731,-.2203584559,4.508963850,.8221623576,1.779933730,
     *1.102649543,.8867880020/
      DATA A22/.4036015198,-.3302974212,2.827730930,-45.44405830,
     *-1.611103927,.4927112073,-.003258457559,-49.59014949,.3796217108,
     *-233.7884098,4.312666980,18.05051709,28.95320323,11.09948019,
     *.7471649558,67.10246193,.5667096597,.6468519751,-.1560665317,
     *-1.460805289,.7719653528,-.6658988668,.2515179349E-05,
     *.02426021891,.1195003324,-.2625739255,4.377172556,.2421190547,
     *2.503482679,1.071587299,.7247997430/

      B=0.5
      RHO_0=7.0

      M=MODE
      IF (NUMB.EQ.1) THEN
          DPHI=0.055D0
          DTHETA=0.06D0
      ENDIF

      IF (NUMB.EQ.2) THEN
          DPHI=0.030D0
          DTHETA=0.09D0
      ENDIF

      Xsc=X*XKAPPA
      Ysc=Y*XKAPPA
      Zsc=Z*XKAPPA
      RHO=DSQRT(Xsc**2+Zsc**2)

      Rsc=DSQRT(Xsc**2+Ysc**2+Zsc**2)                                 !  SCALED
      RHO2=RHO_0**2

      IF (Xsc.EQ.0.D0.AND.Zsc.EQ.0.D0) THEN
         PHI=0.D0
      ELSE
         PHI=DATAN2(-Zsc,Xsc)  !  FROM CARTESIAN TO CYLINDRICAL (RHO,PHI,Y)
      ENDIF

      SPHIC=DSIN(PHI)
      CPHIC=DCOS(PHI)  !  "C" means "CYLINDRICAL", TO DISTINGUISH FROM SPHERICAL PHI

      BRACK=DPHI+B*RHO2/(RHO2+1.D0)*(RHO**2-1.D0)/(RHO2+RHO**2)
      R1RH=(Rsc-1.D0)/RH
      PSIAS=BETA*PS/(1.D0+R1RH**EPS)**(1.D0/EPS)

      PHIS=PHI-BRACK*DSIN(PHI) -PSIAS
      DPHISPHI=1.D0-BRACK*DCOS(PHI)
      DPHISRHO=-2.D0*B*RHO2*RHO/(RHO2+RHO**2)**2 *DSIN(PHI)
     *   +BETA*PS*R1RH**(EPS-1.D0)*RHO/(RH*Rsc*
     *   (1.D0+R1RH**EPS)**(1.D0/EPS+1.D0))
      DPHISDY= BETA*PS*R1RH**(EPS-1.D0)*Ysc/(RH*Rsc*
     *   (1.D0+R1RH**EPS)**(1.D0/EPS+1.D0))

      SPHICS=DSIN(PHIS)
      CPHICS=DCOS(PHIS)

      XS= RHO*CPHICS
      ZS=-RHO*SPHICS

      IF (NUMB.EQ.1) THEN
        IF (MODE.EQ.1) CALL TWOCONSS_2017 (A11,XS,Ysc,ZS,BXS,BYAS,BZS)
        IF (MODE.EQ.2) CALL TWOCONSS_2017 (A12,XS,Ysc,ZS,BXS,BYAS,BZS)
      ELSE
        IF (MODE.EQ.1) CALL TWOCONSS_2017 (A21,XS,Ysc,ZS,BXS,BYAS,BZS)
        IF (MODE.EQ.2) CALL TWOCONSS_2017 (A22,XS,Ysc,ZS,BXS,BYAS,BZS)
      ENDIF

      BRHOAS=BXS*CPHICS-BZS*SPHICS
      BPHIAS=-BXS*SPHICS-BZS*CPHICS

      BRHO_S=BRHOAS*DPHISPHI                             *XKAPPA        ! SCALING
      BPHI_S=(BPHIAS-RHO*(BYAS*DPHISDY+BRHOAS*DPHISRHO)) *XKAPPA
      BY_S=BYAS*DPHISPHI                                 *XKAPPA

      BX=BRHO_S*CPHIC-BPHI_S*SPHIC
      BY=BY_S
      BZ=-BRHO_S*SPHIC-BPHI_S*CPHIC

      RETURN
      END
c

C=========================================================================
c
      SUBROUTINE TWOCONSS_2017 (A,X,Y,Z,BX,BY,BZ)
C
C   DIFFERS FROM TWOCONES_2017:  THIS S/R IS FOR THE "SYMMETRIC" MODE OF BIRKELAND CURRENTS IN THAT
C                           HERE THE FIELD IS ROTATED BY 90 DEGS FOR M=1 AND BY 45 DEGS FOR M=2
C
C   ADDS FIELDS FROM TWO CONES (NORTHERN AND SOUTHERN), WITH A PROPER SYMMETRY OF THE CURRENT AND FIELD,
C     CORRESPONDING TO THE REGION 1 BIRKELAND CURRENTS. (SEE NB #6, P.58).
C

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(31)
      COMMON /MODENUM/ M
      DATA HSQR2/0.707106781D0/

      IF (M.EQ.1) THEN   !   ROTATION BY 90 DEGS
       XAS = Y
       YAS =-X
      ELSE               !   ROTATION BY 45 DEGS
       XAS = (X+Y)*HSQR2
       YAS = (Y-X)*HSQR2
      ENDIF

      CALL ONE_CONE_2017 (A,XAS,YAS,Z,BXN,BYN,BZN)
      CALL ONE_CONE_2017 (A,XAS,-YAS,-Z,BXS,BYS,BZS)

      BXAS=BXN-BXS
      BYAS=BYN+BYS
      BZ=BZN+BZS

      IF (M.EQ.1) THEN   !   ROTATION BY 90 DEGS
        BX =-BYAS
        BY = BXAS
      ELSE
        BX=(BXAS-BYAS)*HSQR2
        BY=(BXAS+BYAS)*HSQR2
      ENDIF

      RETURN
      END
c
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C
         SUBROUTINE BIRSH_SY_2017 (A,PS,X_SC,X,Y,Z,BX,BY,BZ)
C
C   THIS S/R IS QUITE SIMILAR TO BIRK_SHL, BUT IT IS FOR THE SYMMETRIC MODE OF BIRKELAND CURRENT FIELD
C     AND FOR THAT REASON THE FIELD COMPONENTS HAVE A DIFFERENT KIND OF SYMMETRY WITH RESPECT TO Y_gsm
C
         IMPLICIT  REAL * 8  (A - H, O - Z)
         DIMENSION A(86)
C
         CPS=DCOS(PS)
         SPS=DSIN(PS)

         S3PS=2.D0*CPS
C
         PST1=PS*A(85)
         PST2=PS*A(86)

         ST1=DSIN(PST1)
         CT1=DCOS(PST1)
         ST2=DSIN(PST2)
         CT2=DCOS(PST2)

         X1=X*CT1-Z*ST1
         Z1=X*ST1+Z*CT1
         X2=X*CT2-Z*ST2
         Z2=X*ST2+Z*CT2
C
         L=0
         GX=0.D0
         GY=0.D0
         GZ=0.D0
C
         DO 1 M=1,2     !    M=1 IS FOR THE 1ST SUM ("PERP." SYMMETRY)
C                          AND M=2 IS FOR THE SECOND SUM ("PARALL." SYMMETRY)
             DO 2 I=1,3
                  P=A(72+I)
                  Q=A(78+I)
                  CYPI=DCOS(Y/P)
                  CYQI=DCOS(Y/Q)
                  SYPI=DSIN(Y/P)
                  SYQI=DSIN(Y/Q)
C
                DO 3 K=1,3
                   R=A(75+K)
                   S=A(81+K)
                   SZRK=DSIN(Z1/R)
                   CZSK=DCOS(Z2/S)
                   CZRK=DCOS(Z1/R)
                   SZSK=DSIN(Z2/S)
                     SQPR=DSQRT(1.D0/P**2+1.D0/R**2)
                     SQQS=DSQRT(1.D0/Q**2+1.D0/S**2)
                        EPR=DEXP(X1*SQPR)
                        EQS=DEXP(X2*SQQS)
C
                  DO 4 N=1,2  ! N=1 IS FOR THE FIRST PART OF EACH COEFFICIENT
C                                AND N=2 IS FOR THE SECOND ONE

                    DO 5 NN=1,2 !   NN = 1,2 FURTHER SPLITS THE COEFFICIENTS INTO 2 PARTS,
C                                         TO TAKE INTO ACCOUNT THE SCALE FACTOR DEPENDENCE

                    IF (M.EQ.1) THEN
                         FX= SQPR*EPR*SYPI*SZRK
                         FY=EPR*CYPI*SZRK/P
                         FZ= EPR*SYPI*CZRK/R
                       IF (N.EQ.1) THEN
                         IF (NN.EQ.1) THEN
                          HX=FX
                          HY=FY
                          HZ=FZ
                         ELSE
                          HX=FX*X_SC
                          HY=FY*X_SC
                          HZ=FZ*X_SC
                         ENDIF
                       ELSE
                         IF (NN.EQ.1) THEN
                          HX=FX*CPS
                          HY=FY*CPS
                          HZ=FZ*CPS
                         ELSE
                          HX=FX*CPS*X_SC
                          HY=FY*CPS*X_SC
                          HZ=FZ*CPS*X_SC
                         ENDIF
                       ENDIF

                     ELSE                            !   M.EQ.2
                         FX= SPS*SQQS*EQS*SYQI*CZSK
                         FY= SPS/Q*EQS*CYQI*CZSK
                         FZ=-SPS/S*EQS*SYQI*SZSK
                       IF (N.EQ.1) THEN
                        IF (NN.EQ.1) THEN
                          HX=FX
                          HY=FY
                          HZ=FZ
                        ELSE
                          HX=FX*X_SC
                          HY=FY*X_SC
                          HZ=FZ*X_SC
                        ENDIF
                       ELSE
                        IF (NN.EQ.1) THEN
                         HX=FX*S3PS
                         HY=FY*S3PS
                         HZ=FZ*S3PS
                        ELSE
                         HX=FX*S3PS*X_SC
                         HY=FY*S3PS*X_SC
                         HZ=FZ*S3PS*X_SC
                        ENDIF
                       ENDIF
                  ENDIF
       L=L+1

       IF (M.EQ.1) THEN
       HXR=HX*CT1+HZ*ST1
       HZR=-HX*ST1+HZ*CT1
       ELSE
       HXR=HX*CT2+HZ*ST2
       HZR=-HX*ST2+HZ*CT2
       ENDIF

       GX=GX+HXR*A(L)
       GY=GY+HY *A(L)
  5    GZ=GZ+HZR*A(L)

  4   CONTINUE
  3   CONTINUE
  2   CONTINUE
  1   CONTINUE

      BX=GX
      BY=GY
      BZ=GZ

      RETURN
      END
C
C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
c
       SUBROUTINE DIPOLE_2017 (PS,X,Y,Z,BX,BY,BZ)
C
C      A DOUBLE PRECISION ROUTINE
C
C  CALCULATES GSM COMPONENTS OF A GEODIPOLE FIELD WITH THE DIPOLE MOMENT
C  CORRESPONDING TO THE EPOCH OF 2000.
C
C----INPUT PARAMETERS:
C     PS - GEODIPOLE TILT ANGLE IN RADIANS,
C     X,Y,Z - GSM COORDINATES IN RE (1 RE = 6371.2 km)
C
C----OUTPUT PARAMETERS:
C     BX,BY,BZ - FIELD COMPONENTS IN GSM SYSTEM, IN NANOTESLA.
C
C  LAST MODIFICATION: JAN. 5, 2001. THE VALUE OF THE DIPOLE MOMENT WAS UPDATED TO 2000.
C    AND A "SAVE" STATEMENT HAS BEEN ADDED, TO AVOID POTENTIAL PROBLEMS WITH SOME
C    FORTRAN COMPILERS
C
C  WRITTEN BY: N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      SAVE M,PSI,SPS,CPS
      DATA M,PSI/0,5.D0/
      IF(M.EQ.1.AND.DABS(PS-PSI).LT.1.D-5) GOTO 1
      SPS=DSIN(PS)
      CPS=DCOS(PS)
      PSI=PS
      M=1
  1   P=X**2
      U=Z**2
      V=3.D0*Z*X
      T=Y**2
      Q=30115.D0/DSQRT(P+T+U)**5
      BX=Q*((T+U-2.D0*P)*SPS-V*CPS)
      BY=-3.D0*Y*Q*(X*SPS+Z*CPS)
      BZ=Q*((P+T-2.D0*U)*CPS-V*SPS)
      RETURN
      END


C(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((
C
C(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((
C=======================================================================================
C
      SUBROUTINE T96_MGNP_D_2017 (XN_PD,VEL,XGSM,YGSM,ZGSM,
     * XMGNP,YMGNP,ZMGNP, DIST,ID)

      IMPLICIT REAL*8 (A-H,O-Z)
C
C  DOUBLE-PRECISION VERSION !!!!!!!!   HENCE THE SUFFIX "D" IN THE NAME
C
C
C  FOR ANY POINT OF SPACE WITH GIVEN COORDINATES (XGSM,YGSM,ZGSM), THIS SUBROUTINE DEFINES
C  THE POSITION OF A POINT (XMGNP,YMGNP,ZMGNP) AT THE T96 MODEL MAGNETOPAUSE, HAVING THE
C  SAME VALUE OF THE ELLIPSOIDAL TAU-COORDINATE, AND THE DISTANCE BETWEEN THEM.  THIS IS
C  NOT THE SHORTEST DISTANCE D_MIN TO THE BOUNDARY, BUT DIST ASYMPTOTICALLY TENDS TO D_MIN,
C  AS THE OBSERVATION POINT GETS CLOSER TO THE MAGNETOPAUSE.
C
C  INPUT: XN_PD - EITHER SOLAR WIND PROTON NUMBER DENSITY (PER C.C.) (IF VEL>0)
C                    OR THE SOLAR WIND RAM PRESSURE IN NANOPASCALS   (IF VEL<0)
C         VEL - EITHER SOLAR WIND VELOCITY (KM/SEC)
C                  OR ANY NEGATIVE NUMBER, WHICH INDICATES THAT XN_PD STANDS
C                     FOR THE SOLAR WIND PRESSURE, RATHER THAN FOR THE DENSITY
C
C         XGSM,YGSM,ZGSM - COORDINATES OF THE OBSERVATION POINT IN EARTH RADII
C
C  OUTPUT: XMGNP,YMGNP,ZMGNP - GSM POSITION OF THE BOUNDARY POINT, HAVING THE SAME
C          VALUE OF TAU-COORDINATE AS THE OBSERVATION POINT (XGSM,YGSM,ZGSM)
C          DIST -  THE DISTANCE BETWEEN THE TWO POINTS, IN RE,
C          ID -    POSITION FLAG; ID=+1 (-1) MEANS THAT THE POINT (XGSM,YGSM,ZGSM)
C          LIES INSIDE (OUTSIDE) THE MODEL MAGNETOPAUSE, RESPECTIVELY.
C
C  THE PRESSURE-DEPENDENT MAGNETOPAUSE IS THAT USED IN THE T96_01 MODEL
C  (TSYGANENKO, JGR, V.100, P.5599, 1995; ESA SP-389, P.181, OCT. 1996)
C
c   AUTHOR:  N.A. TSYGANENKO
C   DATE:    AUG.1, 1995, REVISED APRIL 3, 2003.
C
C
C  DEFINE SOLAR WIND DYNAMIC PRESSURE (NANOPASCALS, ASSUMING 4% OF ALPHA-PARTICLES),
C   IF NOT EXPLICITLY SPECIFIED IN THE INPUT:

      IF (VEL.LT.0.D0) THEN
       PD=XN_PD
      ELSE
       PD=1.94D-6*XN_PD*VEL**2
C
      ENDIF
C
C  RATIO OF PD TO THE AVERAGE PRESSURE, ASSUMED EQUAL TO 2 nPa:

      RAT=PD/2.0D0
      RAT16=RAT**0.14D0

C (THE POWER INDEX 0.14 IN THE SCALING FACTOR IS THE BEST-FIT VALUE OBTAINED FROM DATA
C    AND USED IN THE T96_01 VERSION)
C
C  VALUES OF THE MAGNETOPAUSE PARAMETERS FOR  PD = 2 nPa:
C
      A0 =34.586D0
      S00=1.196D0
      X00=3.4397D0
C
C   VALUES OF THE MAGNETOPAUSE PARAMETERS, SCALED BY THE ACTUAL PRESSURE:
C
      A=A0/RAT16
      S0=S00
      X0=X00/RAT16
      XM=X0-A
C
C  (XM IS THE X-COORDINATE OF THE "SEAM" BETWEEN THE ELLIPSOID AND THE CYLINDER)
C
C     (FOR DETAILS ON THE ELLIPSOIDAL COORDINATES, SEE THE PAPER:
C      N.A.TSYGANENKO, SOLUTION OF CHAPMAN-FERRARO PROBLEM FOR AN
C      ELLIPSOIDAL MAGNETOPAUSE, PLANET.SPACE SCI., V.37, P.1037, 1989).
C
       IF (YGSM.NE.0.D0.OR.ZGSM.NE.0.D0) THEN
          PHI=DATAN2(YGSM,ZGSM)
       ELSE
          PHI=0.D0
       ENDIF
C
       RHO=DSQRT(YGSM**2+ZGSM**2)
C
       IF (XGSM.LT.XM) THEN
           XMGNP=XGSM
           RHOMGNP=A*DSQRT(S0**2-1.D0)
           YMGNP=RHOMGNP*DSIN(PHI)
           ZMGNP=RHOMGNP*DCOS(PHI)
           DIST=DSQRT((XGSM-XMGNP)**2+(YGSM-YMGNP)**2+(ZGSM-ZMGNP)**2)
           IF (RHOMGNP.GT.RHO) ID=+1
           IF (RHOMGNP.LE.RHO) ID=-1
           RETURN
       ENDIF
C
          XKSI=(XGSM-X0)/A+1.D0
          XDZT=RHO/A
          SQ1=DSQRT((1.D0+XKSI)**2+XDZT**2)
          SQ2=DSQRT((1.D0-XKSI)**2+XDZT**2)
          SIGMA=0.5D0*(SQ1+SQ2)
          TAU=0.5D0*(SQ1-SQ2)
C
C  NOW CALCULATE (X,Y,Z) FOR THE CLOSEST POINT AT THE MAGNETOPAUSE
C
          XMGNP=X0-A*(1.D0-S0*TAU)
          ARG=(S0**2-1.D0)*(1.D0-TAU**2)
          IF (ARG.LT.0.D0) ARG=0.D0
          RHOMGNP=A*DSQRT(ARG)
          YMGNP=RHOMGNP*DSIN(PHI)
          ZMGNP=RHOMGNP*DCOS(PHI)
C
C  NOW CALCULATE THE DISTANCE BETWEEN THE POINTS {XGSM,YGSM,ZGSM} AND {XMGNP,YMGNP,ZMGNP}:
C   (IN GENERAL, THIS IS NOT THE SHORTEST DISTANCE D_MIN, BUT DIST ASYMPTOTICALLY TENDS
C    TO D_MIN, AS WE ARE GETTING CLOSER TO THE MAGNETOPAUSE):
C
      DIST=DSQRT((XGSM-XMGNP)**2+(YGSM-YMGNP)**2+(ZGSM-ZMGNP)**2)
C
      IF (SIGMA.GT.S0) ID=-1   !  ID=-1 MEANS THAT THE POINT LIES OUTSIDE
      IF (SIGMA.LE.S0) ID=+1   !  ID=+1 MEANS THAT THE POINT LIES INSIDE
C                                           THE MAGNETOSPHERE
      RETURN
      END

!***************************************************************************************************
! Copyright , 2004 D. Boscher, S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C dipole tilte decentre
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
       SUBROUTINE DTD(xGEO,yGEO,zGEO,BxGEO,ByGEO,BzGEO)
C
       IMPLICIT NONE
C
       REAL*8 xGEO,yGEO,zGEO
       REAL*8 xMAG,yMAG,zMAG
       REAL*8 rr,tt,pp
       REAL*8 Bo
       REAL*8 BxGEO,ByGEO,BzGEO
       REAL*8 BxMAG,ByMAG,BzMAG
       REAL*8 Br,Bt,Bp
       REAL*8 xc,yc,zc
       REAL*8 ct,st,cp,sp
        REAL*8     pi,rad
        common /rconst/rad,pi
C
       COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
C
       xMAG = ct*cp*(xGEO-xc) + ct*sp*(yGEO-yc) - st*(zGEO-zc)
       yMAG = -  sp*(xGEO-xc) +    cp*(yGEO-yc)
       zMAG = st*cp*(xGEO-xc) + st*sp*(yGEO-yc) + ct*(zGEO-zc)
C
       rr = SQRT(xMAG*xMAG + yMAG*yMAG + zMAG*zMAG)
       tt = ACOS(zMAG/rr)
       pp = ATAN2(yMAG,xMAG)
C
       Br = -2.D0*Bo*COS(tt)/(rr*rr*rr)
       Bt = -   Bo*SIN(tt)/(rr*rr*rr)
       Bp = 0.D0
C
       BxMAG = Br*SIN(tt)*COS(pp)
     &       + Bt*COS(tt)*COS(pp)
     &       - Bp*SIN(pp)
       ByMAG = Br*SIN(tt)*SIN(pp)
     &       + Bt*COS(tt)*SIN(pp)
     &       + Bp*COS(pp)
       BzMAG = Br*COS(tt) - Bt*SIN(tt)
C
       BxGEO = ct*cp*BxMAG - sp*ByMAG + st*cp*BzMAG
       ByGEO = ct*sp*BxMAG + cp*ByMAG + st*sp*BzMAG
       BzGEO = -st  *BxMAG            + ct   *BzMAG
C
       RETURN
       END
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Centered dipole
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
       SUBROUTINE centered_dipole(xGEO,yGEO,zGEO,BxGEO,ByGEO,BzGEO)
C
       IMPLICIT NONE
C
       REAL*8 xGEO,yGEO,zGEO
       REAL*8 Bo
       REAL*8 BxGEO,ByGEO,BzGEO
       REAL*8 rr,tt,pp
       REAL*8 Br,Bt,Bp
       REAL*8 xc,yc,zc
       REAL*8 ct,st,cp,sp
       REAL*8     pi,rad
       common /rconst/rad,pi
C
       COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
C
       rr = SQRT(xGEO*xGEO+yGEO*yGEO+zGEO*zGEO)
       tt = ACOS(zGEO/rr)
       pp = ATAN2(yGEO,xGEO)
C
       Br = -2.D0*Bo*COS(tt)/(rr*rr*rr)
       Bt = -   Bo*SIN(tt)/(rr*rr*rr)
       Bp = 0.D0
C
       BxGEO = Br*SIN(tt)*COS(pp)
     &          + Bt*COS(tt)*COS(pp)
     &          - Bp*SIN(pp)
       ByGEO = Br*SIN(tt)*SIN(pp)
     &          + Bt*COS(tt)*SIN(pp)
     &          + Bp*COS(pp)
       BzGEO = Br*COS(tt) - Bt*SIN(tt)
C
       RETURN
       END
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C   Init centered dipole !!! BE CAREFUL : need to be called after
C                            INIT_DTD
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
       SUBROUTINE INIT_CD
C
       IMPLICIT NONE
C
       REAL*8    xc,yc,zc                  !Re
       REAL*8    ct,st,cp,sp
       REAL*8    Bo
C
       COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
C
C  Centered dipole !
       xc = 0.d0
       yc = 0.d0
       zc = 0.d0
       ct = 1.d0
       st = 0.d0
       cp = 1.d0
       sp = 0.d0
C
       RETURN
       END
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

c@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ c
c
c          ##########################################################################
c          #                                                                        #
c          #                          GEOPACK-2008_dp                               #
c          #                     (MAIN SET OF FORTRAN CODES)                        #
c          #               (double-precision version of 03/21/08)                   #
C          #                (IGRF coefficients updated 01/31/15)                    #
c          ##########################################################################
C
c
c  This collection of subroutines is a result of several upgrades of the original package
c  written by N. A. Tsyganenko in 1978-1979.
c
c  PREFATORY NOTE TO THE VERSION OF FEBRUARY 4, 2008:
c
c  To avoid inappropriate use of obsolete subroutines from earlier versions, a suffix 08 was
c  added to the name of each subroutine in this release.
c
c  A possibility has been added in this version to calculate vector components in the
c  "Geocentric Solar Wind" (GSW) coordinate system, which, to our knowledge, was first
c  introduced by Hones et al., Planet. Space Sci., v.34, p.889, 1986 (aka GSWM, see Appendix,
c  Tsyganenko et al., JGRA, v.103(A4), p.6827, 1998). The GSW system is analogous to the
c  standard GSM, except that its X-axis is antiparallel to the currently observed solar wind
c  flow vector, rather than aligned with the Earth-Sun line. The orientation of axes in the
c  GSW system can be uniquely defined by specifying three components (VGSEX,VGSEY,VGSEZ) of
c  the solar wind velocity, and in the case of a strictly radial anti-sunward flow (VGSEY=
c  VGSEZ=0) the GSW system becomes identical to the standard GSM, which fact was used here
c  to minimize the number of subroutines in the package. To that end, instead of the special
c  case of the GSM coordinates, this version uses a more general GSW system, and three more
c  input parameters are added in the subroutine RECALC_08, the observed values (VGSEX,VGSEY,
c  VGSEZ) of the solar wind velocity. Invoking RECALC_08 with VGSEY=VGSEZ=0 restores the
c  standard (sunward) orientation of the X axis, which allows one to easily convert vectors
c  between GSW and GSM, as well as to/from other standard and commonly used systems. For more
c  details, see the documentation file GEOPACK-2008.DOC.
c
c  Another modification allows users to have more control over the procedure of field line
c  mapping using the subroutine TRACE_08. To that end, three new input parameters were added
c  in that subroutine, allowing one to set (i) an upper limit, DSMAX, on the automatically
c  adjusted step size, (ii) a permissible step error, ERR, and (iii) maximal length, LMAX,
c  of arrays where field line point coordinates are stored. Minor changes were also made in
c  the tracing subroutine, to make it more compact and easier for understanding, and to
c  prevent the algorithm from making uncontrollable large number of multiple loops in some
c  cases with plasmoid-like field structures.
c
C  One more subroutine, named GEODGEO_08, was added to the package, allowing one to convert
c  geodetic coordinates of a point in space (altitude above the Earth's WGS84 ellipsoid and
c  geodetic latitude) to geocentric radial distance and colatitude, and vice versa.
c
C  For a complete list of modifications made earlier in previous versions, see the
c  documentation file GEOPACK-2008.DOC.
c
c----------------------------------------------------------------------------------
c
      SUBROUTINE IGRF_GSW_08 (XGSW,YGSW,ZGSW,HXGSW,HYGSW,HZGSW)
c
C  CALCULATES COMPONENTS OF THE MAIN (INTERNAL) GEOMAGNETIC FIELD IN THE GEOCENTRIC SOLAR-WIND
C  (GSW) COORDINATE SYSTEM, USING IAGA INTERNATIONAL GEOMAGNETIC REFERENCE MODEL COEFFICIENTS
C  (e.g., http://www.ngdc.noaa.gov/IAGA/vmod/igrf.html, revised 22 March, 2005)
c
C  THE GSW SYSTEM IS ESSENTIALLY SIMILAR TO THE STANDARD GSM (THE TWO SYSTEMS BECOME IDENTICAL
C  TO EACH OTHER IN THE CASE OF STRICTLY ANTI-SUNWARD SOLAR WIND FLOW). FOR A DETAILED
C  DEFINITION, SEE INTRODUCTORY COMMENTS FOR THE SUBROUTINE GSWGSE_08 .
C
C  BEFORE THE FIRST CALL OF THIS SUBROUTINE, OR, IF THE DATE/TIME (IYEAR,IDAY,IHOUR,MIN,ISEC),
C  OR THE SOLAR WIND VELOCITY COMPONENTS (VGSEX,VGSEY,VGSEZ) HAVE CHANGED, THE MODEL COEFFICIENTS
c  AND GEO-GSW ROTATION MATRIX ELEMENTS SHOULD BE UPDATED BY CALLING THE SUBROUTINE RECALC_08.
C
C-----INPUT PARAMETERS:
C
C     XGSW,YGSW,ZGSW - CARTESIAN GEOCENTRIC SOLAR-WIND COORDINATES (IN UNITS RE=6371.2 KM)
C
C-----OUTPUT PARAMETERS:
C
C     HXGSW,HYGSW,HZGSW - CARTESIAN GEOCENTRIC SOLAR-WIND COMPONENTS OF THE MAIN GEOMAGNETIC
C                           FIELD IN NANOTESLA
C
C     LAST MODIFICATION:  MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C     THIS VERSION OF THE CODE ACCEPTS DATES FROM 1965 THROUGH 2015.
c
C     AUTHOR: N. A. TSYGANENKO
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK2/ G(105),H(105),REC(105)

      DIMENSION A(14),B(14)

      CALL GEOGSW_08 (XGEO,YGEO,ZGEO,XGSW,YGSW,ZGSW,-1)
      RHO2=XGEO**2+YGEO**2
      R=DSQRT(RHO2+ZGEO**2)
      C=ZGEO/R
      RHO=DSQRT(RHO2)
      S=RHO/R
      IF (S.LT.1.D-10) THEN
        CF=1.D0
        SF=0.D0
      ELSE
        CF=XGEO/RHO
        SF=YGEO/RHO
      ENDIF
C
      PP=1.D0/R
      P=PP
C
C  IN THIS VERSION, THE OPTIMAL VALUE OF THE PARAMETER NM (MAXIMAL ORDER OF THE SPHERICAL
C    HARMONIC EXPANSION) IS NOT USER-PRESCRIBED, BUT CALCULATED INSIDE THE SUBROUTINE, BASED
C      ON THE VALUE OF THE RADIAL DISTANCE R:
C
      IRP3=R+2
      NM=3+30/IRP3
      IF (NM.GT.13) NM=13

      K=NM+1
      DO 150 N=1,K
         P=P*PP
         A(N)=P
150      B(N)=P*N

      P=1.D0
      D=0.D0
      BBR=0.D0
      BBT=0.D0
      BBF=0.D0

      DO 200 M=1,K
         IF(M.EQ.1) GOTO 160
         MM=M-1
         W=X
         X=W*CF+Y*SF
         Y=Y*CF-W*SF
         GOTO 170
160      X=0.D0
         Y=1.D0
170      Q=P
         Z=D
         BI=0.D0
         P2=0.D0
         D2=0.D0
         DO 190 N=M,K
            AN=A(N)
            MN=N*(N-1)/2+M
            E=G(MN)
            HH=H(MN)
            W=E*Y+HH*X
            BBR=BBR+B(N)*W*Q
            BBT=BBT-AN*W*Z
            IF(M.EQ.1) GOTO 180
            QQ=Q
            IF(S.LT.1.D-10) QQ=Z
            BI=BI+AN*(E*X-HH*Y)*QQ
180         XK=REC(MN)
            DP=C*Z-S*Q-XK*D2
            PM=C*Q-XK*P2
            D2=Z
            P2=Q
            Z=DP
190        Q=PM
         D=S*D+C*P
         P=S*P
         IF(M.EQ.1) GOTO 200
         BI=BI*MM
         BBF=BBF+BI
200   CONTINUE
C
      BR=BBR
      BT=BBT
      IF(S.LT.1.D-10) GOTO 210
      BF=BBF/S
      GOTO 211
210   IF(C.LT.0.) BBF=-BBF
      BF=BBF

211   HE=BR*S+BT*C
      HXGEO=HE*CF-BF*SF
      HYGEO=HE*SF+BF*CF
      HZGEO=BR*C-BT*S
C
      CALL GEOGSW_08 (HXGEO,HYGEO,HZGEO,HXGSW,HYGSW,HZGSW,1)
C
      RETURN
      END
C
c==========================================================================================
C
c
      SUBROUTINE IGRF_GEO_08 (R,THETA,PHI,BR,BTHETA,BPHI)
c
C  CALCULATES COMPONENTS OF THE MAIN (INTERNAL) GEOMAGNETIC FIELD IN THE SPHERICAL GEOGRAPHIC
C  (GEOCENTRIC) COORDINATE SYSTEM, USING IAGA INTERNATIONAL GEOMAGNETIC REFERENCE MODEL
C  COEFFICIENTS  (e.g., http://www.ngdc.noaa.gov/IAGA/vmod/igrf.html, revised: 22 March, 2005)
C
C  BEFORE THE FIRST CALL OF THIS SUBROUTINE, OR IF THE DATE (IYEAR AND IDAY) WAS CHANGED,
C  THE MODEL COEFFICIENTS SHOULD BE UPDATED BY CALLING THE SUBROUTINE RECALC_08
C
C-----INPUT PARAMETERS:
C
C   R, THETA, PHI - SPHERICAL GEOGRAPHIC (GEOCENTRIC) COORDINATES:
C   RADIAL DISTANCE R IN UNITS RE=6371.2 KM, COLATITUDE THETA AND LONGITUDE PHI IN RADIANS
C
C-----OUTPUT PARAMETERS:
C
C     BR, BTHETA, BPHI - SPHERICAL COMPONENTS OF THE MAIN GEOMAGNETIC FIELD IN NANOTESLA
C      (POSITIVE BR OUTWARD, BTHETA SOUTHWARD, BPHI EASTWARD)
C
C     LAST MODIFICATION:  MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C     THIS VERSION OF THE  CODE ACCEPTS DATES FROM 1965 THROUGH 2015.
c
C     AUTHOR: N. A. TSYGANENKO
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK2/ G(105),H(105),REC(105)

      DIMENSION A(14),B(14)

      C=DCOS(THETA)
      S=DSIN(THETA)
      CF=DCOS(PHI)
      SF=DSIN(PHI)
C
      PP=1.D0/R
      P=PP
C
C  IN THIS NEW VERSION, THE OPTIMAL VALUE OF THE PARAMETER NM (MAXIMAL ORDER OF THE SPHERICAL
C    HARMONIC EXPANSION) IS NOT USER-PRESCRIBED, BUT CALCULATED INSIDE THE SUBROUTINE, BASED
C      ON THE VALUE OF THE RADIAL DISTANCE R:
C
      IRP3=R+2
      NM=3+30/IRP3
      IF (NM.GT.13) NM=13

      K=NM+1
      DO 150 N=1,K
         P=P*PP
         A(N)=P
150      B(N)=P*N

      P=1.D0
      D=0.D0
      BBR=0.D0
      BBT=0.D0
      BBF=0.D0

      DO 200 M=1,K
         IF(M.EQ.1) GOTO 160
         MM=M-1
         W=X
         X=W*CF+Y*SF
         Y=Y*CF-W*SF
         GOTO 170
160      X=0.D0
         Y=1.D0
170      Q=P
         Z=D
         BI=0.D0
         P2=0.D0
         D2=0.D0
         DO 190 N=M,K
            AN=A(N)
            MN=N*(N-1)/2+M
            E=G(MN)
            HH=H(MN)
            W=E*Y+HH*X
            BBR=BBR+B(N)*W*Q
            BBT=BBT-AN*W*Z
            IF(M.EQ.1) GOTO 180
            QQ=Q
            IF(S.LT.1.D-5) QQ=Z
            BI=BI+AN*(E*X-HH*Y)*QQ
180         XK=REC(MN)
            DP=C*Z-S*Q-XK*D2
            PM=C*Q-XK*P2
            D2=Z
            P2=Q
            Z=DP
190        Q=PM
         D=S*D+C*P
         P=S*P
         IF(M.EQ.1) GOTO 200
         BI=BI*MM
         BBF=BBF+BI
200   CONTINUE
C
      BR=BBR
      BTHETA=BBT
      IF(S.LT.1.D-10) GOTO 210
      BPHI=BBF/S
      RETURN
210   IF(C.LT.0.D0) BBF=-BBF
      BPHI=BBF

      RETURN
      END
C
c==========================================================================================
c
       SUBROUTINE DIP_08 (XGSW,YGSW,ZGSW,BXGSW,BYGSW,BZGSW)
C
C  CALCULATES GSW (GEOCENTRIC SOLAR-WIND) COMPONENTS OF GEODIPOLE FIELD WITH THE DIPOLE MOMENT
C  CORRESPONDING TO THE EPOCH, SPECIFIED BY CALLING SUBROUTINE RECALC_08 (SHOULD BE
C  INVOKED BEFORE THE FIRST USE OF THIS ONE, OR IF THE DATE/TIME, AND/OR THE OBSERVED
C  SOLAR WIND DIRECTION, HAVE CHANGED.
C
C  THE GSW COORDINATE SYSTEM IS ESSENTIALLY SIMILAR TO THE STANDARD GSM (THE TWO SYSTEMS BECOME
C  IDENTICAL TO EACH OTHER IN THE CASE OF STRICTLY RADIAL ANTI-SUNWARD SOLAR WIND FLOW). ITS
C  DETAILED DEFINITION IS GIVEN IN INTRODUCTORY COMMENTS FOR THE SUBROUTINE GSWGSE_08 .

C--INPUT PARAMETERS: XGSW,YGSW,ZGSW - GSW COORDINATES IN RE (1 RE = 6371.2 km)
C
C--OUTPUT PARAMETERS: BXGSW,BYGSW,BZGSW - FIELD COMPONENTS IN GSW SYSTEM, IN NANOTESLA.
C
C  LAST MODIFICATION:   MARCH 21, 2008 (DOUBLE-PRECISION VERSION).
C
C  AUTHOR: N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK1/ AA(10),SPS,CPS,BB(22)
      COMMON /GEOPACK2/ G(105),H(105),REC(105)
C
      DIPMOM=DSQRT(G(2)**2+G(3)**2+H(3)**2)
C
      P=XGSW**2
      U=ZGSW**2
      V=3.D0*ZGSW*XGSW
      T=YGSW**2
      Q=DIPMOM/DSQRT(P+T+U)**5
      BXGSW=Q*((T+U-2.D0*P)*SPS-V*CPS)
      BYGSW=-3.D0*YGSW*Q*(XGSW*SPS+ZGSW*CPS)
      BZGSW=Q*((P+T-2.D0*U)*CPS-V*SPS)
      RETURN
      END

C*******************************************************************
c
      SUBROUTINE SUN_08 (IYEAR,IDAY,IHOUR,MIN,ISEC,GST,SLONG,SRASN,SDEC)
C
C  CALCULATES FOUR QUANTITIES NECESSARY FOR COORDINATE TRANSFORMATIONS
C  WHICH DEPEND ON SUN POSITION (AND, HENCE, ON UNIVERSAL TIME AND SEASON)
C
C-------  INPUT PARAMETERS:
C  IYR,IDAY,IHOUR,MIN,ISEC -  YEAR, DAY, AND UNIVERSAL TIME IN HOURS, MINUTES,
C    AND SECONDS  (IDAY=1 CORRESPONDS TO JANUARY 1).
C
C-------  OUTPUT PARAMETERS:
C  GST - GREENWICH MEAN SIDEREAL TIME, SLONG - LONGITUDE ALONG ECLIPTIC
C  SRASN - RIGHT ASCENSION,  SDEC - DECLINATION  OF THE SUN (RADIANS)
C  ORIGINAL VERSION OF THIS SUBROUTINE HAS BEEN COMPILED FROM:
C  RUSSELL, C.T., COSMIC ELECTRODYNAMICS, 1971, V.2, PP.184-196.
C
C  LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C     ORIGINAL VERSION WRITTEN BY:    Gilbert D. Mead
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA RAD/57.295779513D0/
C
      IF(IYEAR.LT.1901.OR.IYEAR.GT.2099) RETURN
      FDAY=DFLOAT(IHOUR*3600+MIN*60+ISEC)/86400.D0
      DJ=365*(IYEAR-1900)+(IYEAR-1901)/4+IDAY-0.5D0+FDAY
      T=DJ/36525.D0
      VL=DMOD(279.696678D0+0.9856473354D0*DJ,360.D0)
      GST=DMOD(279.690983D0+.9856473354D0*DJ+360.D0*FDAY+180.D0,360.D0)/
     * RAD
      G=DMOD(358.475845D0+0.985600267D0*DJ,360.D0)/RAD
      SLONG=(VL+(1.91946D0-0.004789D0*T)*DSIN(G)+0.020094D0
     * *DSIN(2.D0*G))/RAD
      IF(SLONG.GT.6.2831853D0) SLONG=SLONG-6.283185307D0
      IF (SLONG.LT.0.D0) SLONG=SLONG+6.283185307D0
      OBLIQ=(23.45229D0-0.0130125D0*T)/RAD
      SOB=DSIN(OBLIQ)
      SLP=SLONG-9.924D-5
C
C   THE LAST CONSTANT IS A CORRECTION FOR THE ANGULAR ABERRATION DUE TO
C   EARTH'S ORBITAL MOTION
C
      SIND=SOB*DSIN(SLP)
      COSD=DSQRT(1.D0-SIND**2)
      SC=SIND/COSD
      SDEC=DATAN(SC)
      SRASN=3.141592654D0-DATAN2(DCOS(OBLIQ)/SOB*SC,-DCOS(SLP)/COSD)
      RETURN
      END
C
C================================================================================
c
      SUBROUTINE SPHCAR_08 (R,THETA,PHI,X,Y,Z,J)
C
C   CONVERTS SPHERICAL COORDS INTO CARTESIAN ONES AND VICE VERSA
C    (THETA AND PHI IN RADIANS).
C
C                  J>0            J<0
C-----INPUT:   J,R,THETA,PHI     J,X,Y,Z
C----OUTPUT:      X,Y,Z        R,THETA,PHI
C
C  NOTE: AT THE POLES (X=0 AND Y=0) WE ASSUME PHI=0 WHEN CONVERTING
C        FROM CARTESIAN TO SPHERICAL COORDS (I.E., FOR J<0)
C
C   LAST MOFIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C   AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)

      IF(J.GT.0) GOTO 3
      SQ=X**2+Y**2
      R=DSQRT(SQ+Z**2)
      IF (SQ.NE.0.D0) GOTO 2
      PHI=0.D0
      IF (Z.LT.0.D0) GOTO 1
      THETA=0.D0
      RETURN
  1   THETA=3.141592654D0
      RETURN
  2   SQ=DSQRT(SQ)
      PHI=DATAN2(Y,X)
      THETA=DATAN2(SQ,Z)
      IF (PHI.LT.0.D0) PHI=PHI+6.283185307D0
      RETURN
  3   SQ=R*DSIN(THETA)
      X=SQ*DCOS(PHI)
      Y=SQ*DSIN(PHI)
      Z=R*DCOS(THETA)
      RETURN
      END
C
C===========================================================================
c
      SUBROUTINE BSPCAR_08 (THETA,PHI,BR,BTHETA,BPHI,BX,BY,BZ)
C
C   CALCULATES CARTESIAN FIELD COMPONENTS FROM LOCAL SPHERICAL ONES
C
C-----INPUT:   THETA,PHI - SPHERICAL ANGLES OF THE POINT IN RADIANS
C              BR,BTHETA,BPHI -  LOCAL SPHERICAL COMPONENTS OF THE FIELD
C-----OUTPUT:  BX,BY,BZ - CARTESIAN COMPONENTS OF THE FIELD
C
C   LAST MOFIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C   WRITTEN BY:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)

      S=DSIN(THETA)
      C=DCOS(THETA)
      SF=DSIN(PHI)
      CF=DCOS(PHI)
      BE=BR*S+BTHETA*C
      BX=BE*CF-BPHI*SF
      BY=BE*SF+BPHI*CF
      BZ=BR*C-BTHETA*S
      RETURN
      END
c
C==============================================================================
C
      SUBROUTINE BCARSP_08 (X,Y,Z,BX,BY,BZ,BR,BTHETA,BPHI)
C
CALCULATES LOCAL SPHERICAL FIELD COMPONENTS FROM THOSE IN CARTESIAN SYSTEM
C
C-----INPUT:   X,Y,Z  - CARTESIAN COMPONENTS OF THE POSITION VECTOR
C              BX,BY,BZ - CARTESIAN COMPONENTS OF THE FIELD VECTOR
C-----OUTPUT:  BR,BTHETA,BPHI - LOCAL SPHERICAL COMPONENTS OF THE FIELD VECTOR
C
C  NOTE: AT THE POLES (THETA=0 OR THETA=PI) WE ASSUME PHI=0,
C        AND HENCE BTHETA=BX, BPHI=BY
C
C   WRITTEN AND ADDED TO THIS PACKAGE:  APRIL 1, 2003
c   LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C   AUTHOR:   N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)

      RHO2=X**2+Y**2
      R=DSQRT(RHO2+Z**2)
      RHO=DSQRT(RHO2)

      IF (RHO.NE.0.D0) THEN
        CPHI=X/RHO
        SPHI=Y/RHO
       ELSE
        CPHI=1.D0
        SPHI=0.D0
      ENDIF

      CT=Z/R
      ST=RHO/R

      BR=(X*BX+Y*BY+Z*BZ)/R
      BTHETA=(BX*CPHI+BY*SPHI)*CT-BZ*ST
      BPHI=BY*CPHI-BX*SPHI

      RETURN
      END
C
c=====================================================================================
C
      SUBROUTINE RECALC_08 (IYEAR,IDAY,IHOUR,MIN,ISEC,VGSEX,VGSEY,VGSEZ)
C
C  1. PREPARES ELEMENTS OF ROTATION MATRICES FOR TRANSFORMATIONS OF VECTORS BETWEEN
C     SEVERAL COORDINATE SYSTEMS, MOST FREQUENTLY USED IN SPACE PHYSICS.
C
C  2. PREPARES COEFFICIENTS USED IN THE CALCULATION OF THE MAIN GEOMAGNETIC FIELD
C      (IGRF MODEL)
C
C  THIS SUBROUTINE SHOULD BE INVOKED BEFORE USING THE FOLLOWING SUBROUTINES:
C  IGRF_GEO_08, IGRF_GSW_08, DIP_08, GEOMAG_08, GEOGSW_08, MAGSW_08, SMGSW_08, GSWGSE_08,
c  GEIGEO_08, TRACE_08, STEP_08, RHAND_08.
C
C  THERE IS NO NEED TO REPEATEDLY INVOKE RECALC_08, IF MULTIPLE CALCULATIONS ARE MADE
C    FOR THE SAME DATE/TIME AND SOLAR WIND FLOW DIRECTION.
C
C-----INPUT PARAMETERS:
C
C     IYEAR   -  YEAR NUMBER (FOUR DIGITS)
C     IDAY  -  DAY OF YEAR (DAY 1 = JAN 1)
C     IHOUR -  HOUR OF DAY (00 TO 23)
C     MIN   -  MINUTE OF HOUR (00 TO 59)
C     ISEC  -  SECONDS OF MINUTE (00 TO 59)
C     VGSEX,VGSEY,VGSEZ - GSE (GEOCENTRIC SOLAR-ECLIPTIC) COMPONENTS OF THE OBSERVED
C                              SOLAR WIND FLOW VELOCITY (IN KM/S)
C
C  IMPORTANT: IF ONLY QUESTIONABLE INFORMATION (OR NO INFORMATION AT ALL) IS AVAILABLE
C             ON THE SOLAR WIND SPEED, OR, IF THE STANDARD GSM AND/OR SM COORDINATES ARE
C             INTENDED TO BE USED, THEN SET VGSEX=-400.0 AND VGSEY=VGSEZ=0. IN THIS CASE,
C             THE GSW COORDINATE SYSTEM BECOMES IDENTICAL TO THE STANDARD GSM.
C
C             IF ONLY SCALAR SPEED V OF THE SOLAR WIND IS KNOWN, THEN SETTING
C             VGSEX=-V, VGSEY=29.78, VGSEZ=0.0 WILL TAKE INTO ACCOUNT THE ~4 degs
C             ABERRATION OF THE MAGNETOSPHERE DUE TO EARTH'S ORBITAL MOTION
C
C             IF ALL THREE GSE COMPONENTS OF THE SOLAR WIND VELOCITY ARE AVAILABLE,
C             PLEASE NOTE THAT IN SOME SOLAR WIND DATABASES THE ABERRATION EFFECT
C             HAS ALREADY BEEN TAKEN INTO ACCOUNT BY SUBTRACTING 29.78 KM/S FROM VYGSE;
C             IN THAT CASE, THE UNABERRATED (OBSERVED) VYGSE VALUES SHOULD BE RESTORED
C             BY ADDING BACK THE 29.78 KM/S CORRECTION. WHETHER OR NOT TO DO THAT, MUST
C             BE EITHER VERIFIED WITH THE DATA ORIGINATOR OR DETERMINED BY AVERAGING
C             VGSEY OVER A SUFFICIENTLY LONG TIME INTERVAL.
C
C-----OUTPUT PARAMETERS:  NONE (ALL OUTPUT QUANTITIES ARE PLACED
C                         INTO THE COMMON BLOCKS /GEOPACK1/ AND /GEOPACK2/)
C
C    OTHER SUBROUTINES CALLED BY THIS ONE: SUN_08
C
C    AUTHOR:  N.A. TSYGANENKO
C    DATE:    DEC.1, 1991
C
C    REVISION OF JANUARY 31, 2015:
C
C     The table of IGRF coefficients was extended to include those for the epoch 2015 (igrf-12)
c         (for details, see http://www.ngdc.noaa.gov/IAGA/vmod/igrf.html)
C
C    REVISION OF NOVEMBER 30, 2010:
C
C     The table of IGRF coefficients was extended to include those for the epoch 2010
c         (for details, see http://www.ngdc.noaa.gov/IAGA/vmod/igrf.html)
C
C    REVISION OF NOVEMBER 15, 2007: ADDED THE POSSIBILITY TO TAKE INTO ACCOUNT THE OBSERVED
C     DEFLECTION OF THE SOLAR WIND FLOW FROM STRICTLY RADIAL DIRECTION. TO THAT END, THREE
C     GSE COMPONENTS OF THE SOLAR WIND VELOCITY WERE ADDED TO THE INPUT PARAMETERS.
C
c    CORRECTION OF MAY 9, 2006:  INTERPOLATION OF THE COEFFICIENTS (BETWEEN
C     LABELS 50 AND 105) IS NOW MADE THROUGH THE LAST ELEMENT OF THE ARRAYS
C     G(105)  AND H(105) (PREVIOUSLY MADE ONLY THROUGH N=66, WHICH IN SOME
C     CASES CAUSED RUNTIME ERRORS)
c
C    REVISION OF MAY 3, 2005:
C     The table of IGRF coefficients was extended to include those for the epoch 2005
c       the maximal order of spherical harmonics was also increased up to 13
c         (for details, see http://www.ngdc.noaa.gov/IAGA/vmod/igrf.html)
c
C    REVISION OF APRIL 3, 2003:
c    The code now includes preparation of the model coefficients for the subroutines
c    IGRF_08 and GEOMAG_08. This eliminates the need for the SAVE statements, used
c    in the old versions, making the codes easier and more compiler-independent.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      SAVE ISW
C
      COMMON /GEOPACK1/ ST0,CT0,SL0,CL0,CTCL,STCL,CTSL,STSL,SFI,CFI,
     * SPS,CPS,DS3,CGST,SGST,PSI,A11,A21,A31,A12,A22,A32,A13,A23,A33,
     * E11,E21,E31,E12,E22,E32,E13,E23,E33
C
C  THE COMMON BLOCK /GEOPACK1/ CONTAINS ELEMENTS OF THE ROTATION MATRICES AND OTHER
C   PARAMETERS RELATED TO THE COORDINATE TRANSFORMATIONS PERFORMED BY THIS PACKAGE
C
      COMMON /GEOPACK2/ G(105),H(105),REC(105)
C
C  THE COMMON BLOCK /GEOPACK2/ CONTAINS COEFFICIENTS OF THE IGRF FIELD MODEL, CALCULATED
C    FOR A GIVEN YEAR AND DAY FROM THEIR STANDARD EPOCH VALUES. THE ARRAY REC CONTAINS
C    COEFFICIENTS USED IN THE RECURSION RELATIONS FOR LEGENDRE ASSOCIATE POLYNOMIALS.
C
      DIMENSION G65(105),H65(105),G70(105),H70(105),G75(105),H75(105),
     + G80(105),H80(105),G85(105),H85(105),G90(105),H90(105),G95(105),
     + H95(105),G00(105),H00(105),G05(105),H05(105),G10(105),H10(105),
     + G15(105),H15(105),DG15(45),DH15(45)
C
      DATA ISW /0/
c
      DATA G65/0.D0,-30334.D0,-2119.D0,-1662.D0,2997.D0,1594.D0,1297.D0,
     *-2038.D0,1292.D0,856.D0,957.D0,804.D0,479.D0,-390.D0,252.D0,
     *-219.D0,358.D0,254.D0,-31.D0,-157.D0,-62.D0,45.D0,61.D0,8.D0,
     *-228.D0,4.D0,1.D0,-111.D0,75.D0,-57.D0,4.D0,13.D0,-26.D0,-6.D0,
     *13.D0,1.D0,13.D0,5.D0,-4.D0,-14.D0,0.D0,8.D0,-1.D0,11.D0,4.D0,
     *8.D0,10.D0,2.D0,-13.D0,10.D0,-1.D0,-1.D0,5.D0,1.D0,-2.D0,-2.D0,
     *-3.D0,2.D0,-5.D0,-2.D0,4.D0,4.D0,0.D0,2.D0,2.D0,0.D0,39*0.D0/
      DATA H65/0.D0,0.D0,5776.D0,0.D0,-2016.D0,114.D0,0.D0,-404.D0,
     *240.D0,-165.D0,0.D0,148.D0,-269.D0,13.D0,-269.D0,0.D0,19.D0,
     *128.D0,-126.D0,-97.D0,81.D0,0.D0,-11.D0,100.D0,68.D0,-32.D0,-8.D0,
     *-7.D0,0.D0,-61.D0,-27.D0,-2.D0,6.D0,26.D0,-23.D0,-12.D0,0.D0,7.D0,
     *-12.D0,9.D0,-16.D0,4.D0,24.D0,-3.D0,-17.D0,0.D0,-22.D0,15.D0,7.D0,
     *-4.D0,-5.D0,10.D0,10.D0,-4.D0,1.D0,0.D0,2.D0,1.D0,2.D0,6.D0,-4.D0,
     *0.D0,-2.D0,3.D0,0.D0,-6.D0,39*0.D0/
c
      DATA G70/0.D0,-30220.D0,-2068.D0,-1781.D0,3000.D0,1611.D0,1287.D0,
     *-2091.D0,1278.D0,838.D0,952.D0,800.D0,461.D0,-395.D0,234.D0,
     *-216.D0,359.D0,262.D0,-42.D0,-160.D0,-56.D0,43.D0,64.D0,15.D0,
     *-212.D0,2.D0,3.D0,-112.D0,72.D0,-57.D0,1.D0,14.D0,-22.D0,-2.D0,
     *13.D0,-2.D0,14.D0,6.D0,-2.D0,-13.D0,-3.D0,5.D0,0.D0,11.D0,3.D0,
     *8.D0,10.D0,2.D0,-12.D0,10.D0,-1.D0,0.D0,3.D0,1.D0,-1.D0,-3.D0,
     *-3.D0,2.D0,-5.D0,-1.D0,6.D0,4.D0,1.D0,0.D0,3.D0,-1.D0,39*0.D0/
      DATA H70/0.D0,0.D0,5737.D0,0.D0,-2047.D0,25.D0,0.D0,-366.D0,
     *251.D0,-196.D0,0.D0,167.D0,-266.D0,26.D0,-279.D0,0.D0,26.D0,
     *139.D0,-139.D0,-91.D0,83.D0,0.D0,-12.D0,100.D0,72.D0,-37.D0,-6.D0,
     *1.D0,0.D0,-70.D0,-27.D0,-4.D0,8.D0,23.D0,-23.D0,-11.D0,0.D0,7.D0,
     *-15.D0,6.D0,-17.D0,6.D0,21.D0,-6.D0,-16.D0,0.D0,-21.D0,16.D0,6.D0,
     *-4.D0,-5.D0,10.D0,11.D0,-2.D0,1.D0,0.D0,1.D0,1.D0,3.D0,4.D0,-4.D0,
     *0.D0,-1.D0,3.D0,1.D0,-4.D0,39*0.D0/
c
      DATA G75/0.D0,-30100.D0,-2013.D0,-1902.D0,3010.D0,1632.D0,1276.D0,
     *-2144.D0,1260.D0,830.D0,946.D0,791.D0,438.D0,-405.D0,216.D0,
     *-218.D0,356.D0,264.D0,-59.D0,-159.D0,-49.D0,45.D0,66.D0,28.D0,
     *-198.D0,1.D0,6.D0,-111.D0,71.D0,-56.D0,1.D0,16.D0,-14.D0,0.D0,
     *12.D0,-5.D0,14.D0,6.D0,-1.D0,-12.D0,-8.D0,4.D0,0.D0,10.D0,1.D0,
     *7.D0,10.D0,2.D0,-12.D0,10.D0,-1.D0,-1.D0,4.D0,1.D0,-2.D0,-3.D0,
     *-3.D0,2.D0,-5.D0,-2.D0,5.D0,4.D0,1.D0,0.D0,3.D0,-1.D0,39*0.D0/
C
      DATA H75/0.D0,0.D0,5675.D0,0.D0,-2067.D0,-68.D0,0.D0,-333.D0,
     *262.D0,-223.D0,0.D0,191.D0,-265.D0,39.D0,-288.D0,0.D0,31.D0,
     *148.D0,-152.D0,-83.D0,88.D0,0.D0,-13.D0,99.D0,75.D0,-41.D0,-4.D0,
     *11.D0,0.D0,-77.D0,-26.D0,-5.D0,10.D0,22.D0,-23.D0,-12.D0,0.D0,
     *6.D0,-16.D0,4.D0,-19.D0,6.D0,18.D0,-10.D0,-17.D0,0.D0,-21.D0,
     *16.D0,7.D0,-4.D0,-5.D0,10.D0,11.D0,-3.D0,1.D0,0.D0,1.D0,1.D0,3.D0,
     *4.D0,-4.D0,-1.D0,-1.D0,3.D0,1.D0,-5.D0,39*0.D0/
c
      DATA G80/0.D0,-29992.D0,-1956.D0,-1997.D0,3027.D0,1663.D0,1281.D0,
     *-2180.D0,1251.D0,833.D0,938.D0,782.D0,398.D0,-419.D0,199.D0,
     *-218.D0,357.D0,261.D0,-74.D0,-162.D0,-48.D0,48.D0,66.D0,42.D0,
     *-192.D0,4.D0,14.D0,-108.D0,72.D0,-59.D0,2.D0,21.D0,-12.D0,1.D0,
     *11.D0,-2.D0,18.D0,6.D0,0.D0,-11.D0,-7.D0,4.D0,3.D0,6.D0,-1.D0,
     *5.D0,10.D0,1.D0,-12.D0,9.D0,-3.D0,-1.D0,7.D0,2.D0,-5.D0,-4.D0,
     *-4.D0,2.D0,-5.D0,-2.D0,5.D0,3.D0,1.D0,2.D0,3.D0,0.D0,39*0.D0/
C
      DATA H80/0.D0,0.D0,5604.D0,0.D0,-2129.D0,-200.D0,0.D0,-336.D0,
     *271.D0,-252.D0,0.D0,212.D0,-257.D0,53.D0,-297.D0,0.D0,46.D0,
     *150.D0,-151.D0,-78.D0,92.D0,0.D0,-15.D0,93.D0,71.D0,-43.D0,-2.D0,
     *17.D0,0.D0,-82.D0,-27.D0,-5.D0,16.D0,18.D0,-23.D0,-10.D0,0.D0,
     *7.D0,-18.D0,4.D0,-22.D0,9.D0,16.D0,-13.D0,-15.D0,0.D0,-21.D0,
     *16.D0,9.D0,-5.D0,-6.D0,9.D0,10.D0,-6.D0,2.D0,0.D0,1.D0,0.D0,3.D0,
     *6.D0,-4.D0,0.D0,-1.D0,4.D0,0.D0,-6.D0,39*0.D0/
c
      DATA G85/0.D0,-29873.D0,-1905.D0,-2072.D0,3044.D0,1687.D0,1296.D0,
     *-2208.D0,1247.D0,829.D0,936.D0,780.D0,361.D0,-424.D0,170.D0,
     *-214.D0,355.D0,253.D0,-93.D0,-164.D0,-46.D0,53.D0,65.D0,51.D0,
     *-185.D0,4.D0,16.D0,-102.D0,74.D0,-62.D0,3.D0,24.D0,-6.D0,4.D0,
     *10.D0,0.D0,21.D0,6.D0,0.D0,-11.D0,-9.D0,4.D0,4.D0,4.D0,-4.D0,5.D0,
     *10.D0,1.D0,-12.D0,9.D0,-3.D0,-1.D0,7.D0,1.D0,-5.D0,-4.D0,-4.D0,
     *3.D0,-5.D0,-2.D0,5.D0,3.D0,1.D0,2.D0,3.D0,0.D0,39*0.D0/
C
      DATA H85/0.D0,0.D0,5500.D0,0.D0,-2197.D0,-306.D0,0.D0,-310.D0,
     *284.D0,-297.D0,0.D0,232.D0,-249.D0,69.D0,-297.D0,0.D0,47.D0,
     *150.D0,-154.D0,-75.D0,95.D0,0.D0,-16.D0,88.D0,69.D0,-48.D0,-1.D0,
     *21.D0,0.D0,-83.D0,-27.D0,-2.D0,20.D0,17.D0,-23.D0,-7.D0,0.D0,8.D0,
     *-19.D0,5.D0,-23.D0,11.D0,14.D0,-15.D0,-11.D0,0.D0,-21.D0,15.D0,
     *9.D0,-6.D0,-6.D0,9.D0,9.D0,-7.D0,2.D0,0.D0,1.D0,0.D0,3.D0,6.D0,
     *-4.D0,0.D0,-1.D0,4.D0,0.D0,-6.D0,39*0.D0/
c
      DATA G90/0.D0,-29775.D0,-1848.D0,-2131.D0,3059.D0,1686.D0,1314.D0,
     *     -2239.D0,  1248.D0,  802.D0,  939.D0, 780.D0, 325.D0,-423.D0,
     *       141.D0,  -214.D0,  353.D0,  245.D0,-109.D0,-165.D0, -36.D0,
     *        61.D0,    65.D0,   59.D0, -178.D0,   3.D0,  18.D0, -96.D0,
     *        77.D0,   -64.D0,    2.D0,   26.D0,  -1.D0,   5.D0,   9.D0,
     *         0.D0,    23.D0,    5.D0,   -1.D0, -10.D0, -12.D0,   3.D0,
     *         4.D0,     2.D0,   -6.D0,    4.D0,   9.D0,   1.D0, -12.D0,
     *         9.D0,    -4.D0,   -2.D0,    7.D0,   1.D0,  -6.D0,  -3.D0,
     *        -4.D0,     2.D0,   -5.D0,   -2.D0,   4.D0,   3.D0,   1.D0,
     *         3.D0,     3.D0,    0.D0,39*0.D0/

      DATA H90/0.D0,  0.D0,5406.D0,   0.D0,-2279.D0,-373.D0,  0.D0,
     *      -284.D0,293.D0,-352.D0,   0.D0,  247.D0,-240.D0, 84.D0,
     *      -299.D0,  0.D0,  46.D0, 154.D0, -153.D0, -69.D0, 97.D0,
     *         0.D0,-16.D0,  82.D0,  69.D0,  -52.D0,   1.D0, 24.D0,
     *         0.D0,-80.D0, -26.D0,   0.D0,   21.D0,  17.D0,-23.D0,
     *        -4.D0,  0.D0,  10.D0, -19.D0,    6.D0, -22.D0, 12.D0,
     *        12.D0,-16.D0, -10.D0,   0.D0,  -20.D0,  15.D0, 11.D0,
     *        -7.D0, -7.D0,   9.D0,   8.D0,   -7.D0,   2.D0,  0.D0,
     *         2.D0,  1.D0,   3.D0,   6.D0,   -4.D0,   0.D0, -2.D0,
     *         3.D0, -1.D0,  -6.D0,39*0.D0/

      DATA G95/0.D0,-29692.D0,-1784.D0,-2200.D0,3070.D0,1681.D0,1335.D0,
     *     -2267.D0,  1249.D0,  759.D0,  940.D0, 780.D0, 290.D0,-418.D0,
     *       122.D0,  -214.D0,  352.D0,  235.D0,-118.D0,-166.D0, -17.D0,
     *        68.D0,    67.D0,   68.D0, -170.D0,  -1.D0,  19.D0, -93.D0,
     *        77.D0,   -72.D0,    1.D0,   28.D0,   5.D0,   4.D0,   8.D0,
     *        -2.D0,    25.D0,    6.D0,   -6.D0,  -9.D0, -14.D0,   9.D0,
     *         6.D0,    -5.D0,   -7.D0,    4.D0,   9.D0,   3.D0, -10.D0,
     *         8.D0,    -8.D0,   -1.D0,   10.D0,  -2.D0,  -8.D0,  -3.D0,
     *        -6.D0,     2.D0,   -4.D0,   -1.D0,   4.D0,   2.D0,   2.D0,
     *         5.D0,     1.D0,    0.D0,  39*0.D0/

      DATA H95/0.D0,  0.D0,5306.D0,  0.D0,-2366.D0,-413.D0,  0.D0,
     *      -262.D0,302.D0,-427.D0,  0.D0,  262.D0,-236.D0, 97.D0,
     *      -306.D0,  0.D0,  46.D0,165.D0, -143.D0, -55.D0,107.D0,
     *         0.D0,-17.D0,  72.D0, 67.D0,  -58.D0,   1.D0, 36.D0,
     *         0.D0,-69.D0, -25.D0,  4.D0,   24.D0,  17.D0,-24.D0,
     *        -6.D0,  0.D0,  11.D0,-21.D0,    8.D0, -23.D0, 15.D0,
     *        11.D0,-16.D0,  -4.D0,  0.D0,  -20.D0,  15.D0, 12.D0,
     *        -6.D0, -8.D0,   8.D0,  5.D0,   -8.D0,   3.D0,  0.D0,
     *         1.D0,  0.D0,   4.D0,  5.D0,   -5.D0,  -1.D0, -2.D0,
     *         1.D0, -2.D0,  -7.D0,39*0.D0/

      DATA G00/0.D0,-29619.4D0,-1728.2D0,-2267.7D0,3068.4D0,1670.9D0,
     *     1339.6D0,  -2288.D0, 1252.1D0,  714.5D0, 932.3D0, 786.8D0,
     *       250.D0,   -403.D0,  111.3D0, -218.8D0, 351.4D0, 222.3D0,
     *     -130.4D0,  -168.6D0,  -12.9D0,   72.3D0,  68.2D0,  74.2D0,
     *     -160.9D0,    -5.9D0,   16.9D0,  -90.4D0,  79.0D0, -74.0D0,
     *         0.D0,    33.3D0,    9.1D0,    6.9D0,   7.3D0,  -1.2D0,
     *       24.4D0,     6.6D0,   -9.2D0,   -7.9D0, -16.6D0,   9.1D0,
     *        7.0D0,    -7.9D0,    -7.D0,     5.D0,   9.4D0,    3.D0,
     *      - 8.4D0,     6.3D0,   -8.9D0,   -1.5D0,   9.3D0,  -4.3D0,
     *       -8.2D0,    -2.6D0,    -6.D0,    1.7D0,  -3.1D0,  -0.5D0,
     *        3.7D0,      1.D0,     2.D0,    4.2D0,   0.3D0,  -1.1D0,
     *        2.7D0,    -1.7D0,   -1.9D0,    1.5D0,  -0.1D0,   0.1D0,
     *       -0.7D0,     0.7D0,    1.7D0,    0.1D0,   1.2D0,   4.0D0,
     *       -2.2D0,    -0.3D0,    0.2D0,    0.9D0,  -0.2D0,   0.9D0,
     *       -0.5D0,     0.3D0,   -0.3D0,   -0.4D0,  -0.1D0,  -0.2D0,
     *       -0.4D0,    -0.2D0,   -0.9D0,    0.3D0,   0.1D0,  -0.4D0,
     *        1.3D0,    -0.4D0,    0.7D0,   -0.4D0,   0.3D0,  -0.1D0,
     *        0.4D0,      0.D0,    0.1D0/

      DATA H00/0.D0,   0.D0,5186.1D0,   0.D0,-2481.6D0,-458.0D0,   0.D0,
     *     -227.6D0,293.4D0,-491.1D0,   0.D0,  272.6D0,-231.9D0,119.8D0,
     *     -303.8D0,   0.D0,  43.8D0,171.9D0, -133.1D0, -39.3D0,106.3D0,
     *         0.D0,-17.4D0,  63.7D0, 65.1D0,  -61.2D0,   0.7D0, 43.8D0,
     *         0.D0,-64.6D0, -24.2D0,  6.2D0,    24.D0,  14.8D0,-25.4D0,
     *       -5.8D0,  0.0D0,  11.9D0,-21.5D0,    8.5D0, -21.5D0, 15.5D0,
     *        8.9D0,-14.9D0,  -2.1D0,  0.0D0,  -19.7D0,  13.4D0, 12.5D0,
     *       -6.2D0, -8.4D0,   8.4D0,  3.8D0,   -8.2D0,   4.8D0,  0.0D0,
     *        1.7D0,  0.0D0,   4.0D0,  4.9D0,   -5.9D0,  -1.2D0, -2.9D0,
     *        0.2D0, -2.2D0,  -7.4D0,  0.0D0,    0.1D0,   1.3D0, -0.9D0,
     *       -2.6D0,  0.9D0,  -0.7D0, -2.8D0,   -0.9D0,  -1.2D0, -1.9D0,
     *       -0.9D0,  0.0D0,  -0.4D0,  0.3D0,    2.5D0,  -2.6D0,  0.7D0,
     *        0.3D0,  0.0D0,   0.0D0,  0.3D0,   -0.9D0,  -0.4D0,  0.8D0,
     *        0.0D0, -0.9D0,   0.2D0,  1.8D0,   -0.4D0,  -1.0D0, -0.1D0,
     *        0.7D0,  0.3D0,   0.6D0,  0.3D0,   -0.2D0,  -0.5D0, -0.9D0/

      DATA G05/0.D0,  -29554.6D0,-1669.0D0,-2337.2D0,3047.7D0,1657.8D0,
     *     1336.3D0,   -2305.8D0, 1246.4D0,  672.5D0, 920.6D0, 798.0D0,
     *      210.7D0,    -379.9D0,  100.0D0, -227.0D0, 354.4D0, 208.9D0,
     *     -136.5D0,    -168.1D0,  -13.6D0,   73.6D0,  69.6D0,  76.7D0,
     *     -151.3D0,     -14.6D0,   14.6D0,  -86.4D0,  79.9D0, -74.5D0,
     *       -1.7D0,      38.7D0,   12.3D0,    9.4D0,   5.4D0,   1.9D0,
     *       24.8D0,       7.6D0,  -11.7D0,   -6.9D0, -18.1D0,  10.2D0,
     *        9.4D0,     -11.3D0,   -4.9D0,    5.6D0,   9.8D0,   3.6D0,
     *       -6.9D0,       5.0D0,  -10.8D0,   -1.3D0,   8.8D0,  -6.7D0,
     *       -9.2D0,      -2.2D0,   -6.1D0,    1.4D0,  -2.4D0,  -0.2D0,
     *        3.1D0,       0.3D0,    2.1D0,    3.8D0,  -0.2D0,  -2.1D0,
     *        2.9D0,      -1.6D0,   -1.9D0,    1.4D0,  -0.3D0,   0.3D0,
     *       -0.8D0,       0.5D0,    1.8D0,    0.2D0,   1.0D0,   4.0D0,
     *       -2.2D0,      -0.3D0,    0.2D0,    0.9D0,  -0.4D0,   1.0D0,
     *       -0.3D0,       0.5D0,   -0.4D0,   -0.4D0,   0.1D0,  -0.5D0,
     *       -0.1D0,      -0.2D0,   -0.9D0,    0.3D0,   0.3D0,  -0.4D0,
     *        1.2D0,      -0.4D0,    0.8D0,   -0.3D0,   0.4D0,  -0.1D0,
     *        0.4D0,      -0.1D0,   -0.2D0/
C
      DATA H05/0.D0,  0.0D0,5078.0D0,  0.0D0,-2594.5D0,-515.4D0,  0.0D0,
     *     -198.9D0,269.7D0,-524.7D0,  0.0D0,  282.1D0,-225.2D0,145.2D0,
     *     -305.4D0,  0.0D0,  42.7D0,180.3D0, -123.5D0, -19.6D0,103.9D0,
     *        0.0D0,-20.3D0,  54.8D0, 63.6D0,  -63.5D0,   0.2D0, 50.9D0,
     *        0.0D0,-61.1D0, -22.6D0,  6.8D0,   25.4D0,  10.9D0,-26.3D0,
     *       -4.6D0,  0.0D0,  11.2D0,-20.9D0,    9.8D0, -19.7D0, 16.2D0,
     *        7.6D0,-12.8D0,  -0.1D0,  0.0D0,  -20.1D0,  12.7D0, 12.7D0,
     *       -6.7D0, -8.2D0,   8.1D0,  2.9D0,   -7.7D0,   6.0D0,  0.0D0,
     *        2.2D0,  0.1D0,   4.5D0,  4.8D0,   -6.7D0,  -1.0D0, -3.5D0,
     *       -0.9D0, -2.3D0,  -7.9D0,  0.0D0,    0.3D0,   1.4D0, -0.8D0,
     *       -2.3D0,  0.9D0,  -0.6D0, -2.7D0,   -1.1D0,  -1.6D0, -1.9D0,
     *       -1.4D0,  0.0D0,  -0.6D0,  0.2D0,    2.4D0,  -2.6D0,  0.6D0,
     *        0.4D0,  0.0D0,   0.0D0,  0.3D0,   -0.9D0,  -0.3D0,  0.9D0,
     *        0.0D0, -0.8D0,   0.3D0,  1.7D0,   -0.5D0,  -1.1D0,  0.0D0,
     *        0.6D0,  0.2D0,   0.5D0,  0.4D0,   -0.2D0,  -0.6D0, -0.9D0/
C
      DATA G10/0.00D0,-29496.57D0,-1586.42D0,-2396.06D0,3026.34D0,
     *      1668.17D0,  1339.85D0,-2326.54D0, 1232.10D0, 633.73D0, 
     *       912.66D0,   808.97D0,  166.58D0, -356.83D0,  89.40D0,
     *      -230.87D0,   357.29D0,  200.26D0, -141.05D0,-163.17D0,
     *        -8.03D0,    72.78D0,   68.69D0,   75.92D0,-141.40D0, 
     *       -22.83D0,    13.10D0,  -78.09D0,   80.44D0, -75.00D0,
     *        -4.55D0,    45.24D0,   14.00D0,   10.46D0,   1.64D0,
     *         4.92D0,    24.41D0,    8.21D0,  -14.50D0,  -5.59D0,
     *       -19.34D0,    11.61D0,   10.85D0,  -14.05D0,  -3.54D0,
     *         5.50D0,     9.45D0,    3.45D0,   -5.27D0,   3.13D0,
     *       -12.38D0,    -0.76D0,    8.43D0,   -8.42D0, -10.08D0,
     *        -1.94D0,    -6.24D0,    0.89D0,   -1.07D0,  -0.16D0,
     *         2.45D0,    -0.33D0,    2.13D0,    3.09D0,  -1.03D0,
     *        -2.80D0,     3.05D0,   -1.48D0,   -2.03D0,   1.65D0,
     *        -0.51D0,     0.54D0,   -0.79D0,    0.37D0,   1.79D0,
     *         0.12D0,     0.75D0,    3.75D0,   -2.12D0,  -0.21D0,
     *         0.30D0,     1.04D0,   -0.63D0,    0.95D0,  -0.11D0,
     *         0.52D0,    -0.39D0,   -0.37D0,    0.21D0,  -0.77D0,
     *         0.04D0,    -0.09D0,   -0.89D0,    0.31D0,   0.42D0,
     *        -0.45D0,     1.08D0,   -0.31D0,    0.78D0,  -0.18D0,
     *         0.38D0,     0.02D0,    0.42D0,   -0.26D0,  -0.26D0/
C
      DATA H10/0.00D0,  0.00D0,4944.26D0,   0.00D0,-2708.54D0,
     *     -575.73D0,   0.00D0,-160.40D0, 251.75D0, -537.03D0, 0.00D0,
     *      286.48D0,-211.03D0, 164.46D0,-309.72D0,    0.00D0,44.58D0,
     *      189.01D0,-118.06D0,  -0.01D0, 101.04D0,    0.00D0,-20.90D0,
     *       44.18D0,  61.54D0, -66.26D0,   3.02D0,   55.40D0,  0.00D0,
     *      -57.80D0, -21.20D0,   6.54D0,  24.96D0,    7.03D0,-27.61D0,
     *       -3.28D0,   0.00D0,  10.84D0, -20.03D0,   11.83D0,-17.41D0, 
     *       16.71D0,   6.96D0, -10.74D0,   1.64D0,    0.00D0,-20.54D0,
     *       11.51D0,  12.75D0,  -7.14D0,  -7.42D0,    7.97D0,  2.14D0,
     *       -6.08D0,   7.01D0,   0.00D0,   2.73D0,   -0.10D0,  4.71D0,
     *        4.44D0,  -7.22D0,  -0.96D0,  -3.95D0,   -1.99D0, -1.97D0,
     *       -8.31D0,   0.00D0,   0.13D0,   1.67D0,   -0.66D0, -1.76D0,
     *        0.85D0,  -0.39D0,  -2.51D0,  -1.27D0,   -2.11D0, -1.94D0,
     *       -1.86D0,   0.00D0,  -0.87D0,   0.27D0,    2.13D0, -2.49D0,
     *        0.49D0,   0.59D0,   0.00D0,   0.13D0,    0.27D0, -0.86D0,
     *       -0.23D0,   0.87D0,   0.00D0,  -0.87D0,    0.30D0,  1.66D0,
     *       -0.59D0,  -1.14D0,  -0.07D0,   0.54D0,    0.10D0,  0.49D0,
     *        0.44D0,  -0.25D0,  -0.53D0,  -0.79D0/
C
      DATA G15/0.D0,-29442.0D0, -1501.0D0, -2445.1D0,  3012.9D0,
     *     1676.7D0,  1350.7D0, -2352.3D0,  1225.6D0,   582.0D0,907.6D0, 
     *      813.7D0,   120.4D0,  -334.9D0,    70.4D0,  -232.6D0,360.1D0,
     *      192.4D0,  -140.9D0,  -157.5D0,     4.1D0,    70.0D0, 67.7D0,
     *       72.7D0,  -129.9D0,   -28.9D0,    13.2D0,   -70.9D0, 81.6D0,
     *      -76.1D0,    -6.8D0,    51.8D0,    15.0D0,     9.4D0, -2.8D0,
     *        6.8D0,    24.2D0,     8.8D0,   -16.9D0,    -3.2D0,-20.6D0,
     *       13.4D0,    11.7D0,   -15.9D0,    -2.0D0,     5.4D0,  8.8D0, 
     *        3.1D0,    -3.3D0,     0.7D0,   -13.3D0,    -0.1D0,  8.7D0,
     *       -9.1D0,   -10.5D0,    -1.9D0,    -6.3D0,     0.1D0,  0.5D0,
     *       -0.5D0,     1.8D0,    -0.7D0,     2.1D0,     2.4D0, -1.8D0,
     *       -3.6D0,     3.1D0,    -1.5D0,    -2.3D0,     2.0D0, -0.8D0,
     *        0.6D0,    -0.7D0,     0.2D0,     1.7D0,    -0.2D0,  0.4D0,
     *        3.5D0,    -1.9D0,    -0.2D0,     0.4D0,     1.2D0, -0.8D0,
     *        0.9D0,     0.1D0,     0.5D0,    -0.3D0,    -0.4D0,  0.2D0,
     *       -0.9D0,     0.0D0,     0.0D0,    -0.9D0,     0.4D0,  0.5D0,
     *       -0.5D0,     1.0D0,    -0.2D0,     0.8D0,    -0.1D0,  0.3D0,
     *        0.1D0,     0.5D0,    -0.4D0,    -0.3D0/
c
      DATA H15/0.D0,     0.0D0, 4797.1D0,     0.0D0, -2845.6D0,-641.9D0,
     *        0.0D0,  -115.3D0,  244.9D0,  -538.4D0,     0.0D0, 283.3D0,
     *     -188.7D0,   180.9D0, -329.5D0,     0.0D0,    47.3D0, 197.0D0,
     *     -119.3D0,    16.0D0,  100.2D0,     0.0D0,   -20.8D0,  33.2D0,
     *       58.9D0,   -66.7D0,    7.3D0,    62.6D0,     0.0D0, -54.1D0,
     *      -19.5D0,     5.7D0,   24.4D0,     3.4D0,   -27.4D0,  -2.2D0,
     *        0.0D0,    10.1D0,  -18.3D0,    13.3D0,   -14.6D0,  16.2D0,
     *        5.7D0,    -9.1D0,    2.1D0,     0.0D0,   -21.6D0,  10.8D0,
     *       11.8D0,    -6.8D0,   -6.9D0,     7.8D0,     1.0D0,  -4.0D0,
     *        8.4D0,     0.0D0,    3.2D0,    -0.4D0,     4.6D0,   4.4D0,
     *       -7.9D0,    -0.6D0,   -4.2D0,    -2.8D0,    -1.2D0,  -8.7D0,
     *        0.0D0,    -0.1D0,    2.0D0,    -0.7D0,    -1.1D0,   0.8D0,
     *       -0.2D0,    -2.2D0,   -1.4D0,    -2.5D0,    -2.0D0,  -2.4D0,
     *        0.0D0,    -1.1D0,    0.4D0,     1.9D0,    -2.2D0,   0.3D0,
     *        0.7D0,    -0.1D0,    0.3D0,     0.2D0,    -0.9D0,  -0.1D0,
     *        0.7D0,     0.0D0,   -0.9D0,     0.4D0,     1.6D0,  -0.5D0,
     *       -1.2D0,    -0.1D0,    0.4D0,    -0.1D0,     0.4D0,   0.5D0,
     *       -0.3D0,    -0.4D0,   -0.8D0/
c
      DATA DG15/0.0D0, 10.3D0,  18.1D0,  -8.7D0,  -3.3D0,  2.1D0, 3.4D0,
     *         -5.5D0, -0.7D0, -10.1D0,  -0.7D0,   0.2D0, -9.1D0, 4.1D0,
     *         -4.3D0, -0.2D0,   0.5D0,  -1.3D0,  -0.1D0,  1.4D0, 3.9D0,
     *         -0.3D0, -0.1D0,  -0.7D0,   2.1D0,  -1.2D0,  0.3D0, 1.6D0,
     *          0.3D0, -0.2D0,  -0.5D0,   1.3D0,   0.1D0, -0.6D0,-0.8D0,
     *          0.2D0,  0.2D0,   0.0D0,  -0.6D0,   0.5D0, -0.2D0, 0.4D0,
     *          0.1D0, -0.4D0,   0.3D0/
c
      DATA DH15/0.0D0,  0.0D0, -26.6D0,   0.0D0, -27.4D0,-14.1D0, 0.0D0,
     *          8.2D0, -0.4D0,   1.8D0,   0.0D0,  -1.3D0,  5.3D0, 2.9D0,
     *         -5.2D0,  0.0D0,   0.6D0,   1.7D0,  -1.2D0,  3.4D0, 0.0D0,
     *          0.0D0,  0.0D0,  -2.1D0,  -0.7D0,   0.2D0,  0.9D0, 1.0D0,
     *          0.0D0,  0.8D0,   0.4D0,  -0.2D0,  -0.3D0, -0.6D0, 0.1D0,
     *         -0.2D0,  0.0D0,  -0.3D0,   0.3D0,   0.1D0,  0.5D0,-0.2D0,
     *         -0.3D0,  0.3D0,   0.0D0/
C
C
c      IF (VGSEY.EQ.0..AND.VGSEZ.EQ.0..AND.ISW.NE.1) THEN
c      PRINT *, ''
c      PRINT *,
c     *' RECALC_08: RADIAL SOLAR WIND --> GSW SYSTEM IDENTICAL HERE'
c      PRINT *,
c     *' TO STANDARD GSM (I.E., XGSW AXIS COINCIDES WITH EARTH-SUN LINE)'
c      PRINT *, ''
c      ISW=1
c      ENDIF

c      IF ((VGSEY.NE.0.D0.OR.VGSEZ.NE.0.D0).AND.ISW.NE.2) THEN       !  CORRECTED DEC.01, 2010
c      PRINT *, ''
c      PRINT *,
c     *' WARNING: NON-RADIAL SOLAR WIND FLOW SPECIFIED IN RECALC_08;'
c      PRINT *,
c     *' HENCE XGSW AXIS IS ASSUMED ORIENTED ANTIPARALLEL TO V_SW VECTOR'
c      PRINT *, ''
c      ISW=2
c      ENDIF
C
      IY=IYEAR
C
C  WE ARE RESTRICTED BY THE INTERVAL 1965-2020, FOR WHICH EITHER THE IGRF/DGRF COEFFICIENTS OR SECULAR VELOCITIES
c    ARE KNOWN; IF IYEAR IS OUTSIDE THIS INTERVAL, THEN THE SUBROUTINE USES THE
C      NEAREST LIMITING VALUE AND PRINTS A WARNING:
C
      IF(IY.LT.1965) THEN
       IY=1965
       WRITE (*,10) IYEAR,IY
      ENDIF

      IF(IY.GT.2020) THEN
       IY=2020
       WRITE (*,10) IYEAR,IY
      ENDIF
C
C  CALCULATE THE ARRAY REC, CONTAINING COEFFICIENTS FOR THE RECURSION RELATIONS,
C  USED IN THE IGRF SUBROUTINE FOR CALCULATING THE ASSOCIATE LEGENDRE POLYNOMIALS
C  AND THEIR DERIVATIVES:
c
      DO 20 N=1,14
         N2=2*N-1
         N2=N2*(N2-2)
         DO 20 M=1,N
            MN=N*(N-1)/2+M
20    REC(MN)=DFLOAT((N-M)*(N+M-2))/DFLOAT(N2)
C
      IF (IY.LT.1970) GOTO 50          !INTERPOLATE BETWEEN 1965 - 1970
      IF (IY.LT.1975) GOTO 60          !INTERPOLATE BETWEEN 1970 - 1975
      IF (IY.LT.1980) GOTO 70          !INTERPOLATE BETWEEN 1975 - 1980
      IF (IY.LT.1985) GOTO 80          !INTERPOLATE BETWEEN 1980 - 1985
      IF (IY.LT.1990) GOTO 90          !INTERPOLATE BETWEEN 1985 - 1990
      IF (IY.LT.1995) GOTO 100         !INTERPOLATE BETWEEN 1990 - 1995
      IF (IY.LT.2000) GOTO 110         !INTERPOLATE BETWEEN 1995 - 2000
      IF (IY.LT.2005) GOTO 120         !INTERPOLATE BETWEEN 2000 - 2005
      IF (IY.LT.2010) GOTO 130         !INTERPOLATE BETWEEN 2005 - 2010
      IF (IY.LT.2015) GOTO 140         !INTERPOLATE BETWEEN 2010 - 2015
C
C       EXTRAPOLATE BEYOND 2015:
C
      DT=DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-2015.D0
      DO 40 N=1,105
         G(N)=G15(N)
         H(N)=H15(N)
         IF (N.GT.45) GOTO 40
         G(N)=G(N)+DG15(N)*DT
         H(N)=H(N)+DH15(N)*DT
40    CONTINUE
      GOTO 300
C
C       INTERPOLATE BETWEEEN 1965 - 1970:
C
50    F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-1965)/5.D0
      F1=1.D0-F2
      DO 55 N=1,105
         G(N)=G65(N)*F1+G70(N)*F2
55       H(N)=H65(N)*F1+H70(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 1970 - 1975:
C
60    F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-1970)/5.D0
      F1=1.D0-F2
      DO 65 N=1,105
         G(N)=G70(N)*F1+G75(N)*F2
65       H(N)=H70(N)*F1+H75(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 1975 - 1980:
C
70    F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-1975)/5.D0
      F1=1.D0-F2
      DO 75 N=1,105
         G(N)=G75(N)*F1+G80(N)*F2
75       H(N)=H75(N)*F1+H80(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 1980 - 1985:
C
80    F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-1980)/5.D0
      F1=1.D0-F2
      DO 85 N=1,105
         G(N)=G80(N)*F1+G85(N)*F2
85       H(N)=H80(N)*F1+H85(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 1985 - 1990:
C
90    F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-1985)/5.D0
      F1=1.D0-F2
      DO 95 N=1,105
         G(N)=G85(N)*F1+G90(N)*F2
95       H(N)=H85(N)*F1+H90(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 1990 - 1995:
C
100   F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-1990)/5.D0
      F1=1.D0-F2
      DO 105 N=1,105
         G(N)=G90(N)*F1+G95(N)*F2
105      H(N)=H90(N)*F1+H95(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 1995 - 2000:
C
110   F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-1995)/5.D0
      F1=1.D0-F2
      DO 115 N=1,105   !  THE 2000 COEFFICIENTS (G00) GO THROUGH THE ORDER 13, NOT 10
         G(N)=G95(N)*F1+G00(N)*F2
115      H(N)=H95(N)*F1+H00(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 2000 - 2005:
C
120   F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25D0-2000)/5.D0
      F1=1.D0-F2
      DO 125 N=1,105
         G(N)=G00(N)*F1+G05(N)*F2
125      H(N)=H00(N)*F1+H05(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 2005 - 2010:
C
130   F2=(FLOAT(IY)+FLOAT(IDAY-1)/365.25-2005)/5.
      F1=1.-F2
      DO 135 N=1,105
         G(N)=G05(N)*F1+G10(N)*F2
135      H(N)=H05(N)*F1+H10(N)*F2
      GOTO 300
C
C       INTERPOLATE BETWEEN 2010 - 2015:
C
140   F2=(DFLOAT(IY)+DFLOAT(IDAY-1)/365.25-2010)/5.
      F1=1.-F2
      DO 145 N=1,105
         G(N)=G10(N)*F1+G15(N)*F2
145      H(N)=H10(N)*F1+H15(N)*F2
      GOTO 300
C
C   COEFFICIENTS FOR A GIVEN YEAR HAVE BEEN CALCULATED; NOW MULTIPLY
C   THEM BY SCHMIDT NORMALIZATION FACTORS:
C
300   S=1.D0
      DO 150 N=2,14
         MN=N*(N-1)/2+1
         S=S*DFLOAT(2*N-3)/DFLOAT(N-1)
         G(MN)=G(MN)*S
         H(MN)=H(MN)*S
         P=S
         DO 150 M=2,N
            AA=1.D0
            IF (M.EQ.2) AA=2.D0
            P=P*DSQRT(AA*DFLOAT(N-M+1)/DFLOAT(N+M-2))
            MNN=MN+M-1
            G(MNN)=G(MNN)*P
150         H(MNN)=H(MNN)*P

           G_10=-G(2)
           G_11= G(3)
           H_11= H(3)
C
C  NOW CALCULATE GEO COMPONENTS OF THE UNIT VECTOR EzMAG, PARALLEL TO GEODIPOLE AXIS:
C   SIN(TETA0)*COS(LAMBDA0), SIN(TETA0)*SIN(LAMBDA0), AND COS(TETA0)
C         ST0 * CL0                ST0 * SL0                CT0
C
      SQ=G_11**2+H_11**2
      SQQ=DSQRT(SQ)
      SQR=DSQRT(G_10**2+SQ)
      SL0=-H_11/SQQ
      CL0=-G_11/SQQ
      ST0=SQQ/SQR
      CT0=G_10/SQR
      STCL=ST0*CL0
      STSL=ST0*SL0
      CTSL=CT0*SL0
      CTCL=CT0*CL0
C
C  NOW CALCULATE GEI COMPONENTS (S1,S2,S3) OF THE UNIT VECTOR S = EX_GSE
C    POINTING FROM THE EARTH'S CENTER TO SUN
C
      CALL SUN_08 (IY,IDAY,IHOUR,MIN,ISEC,GST,SLONG,SRASN,SDEC)
C
      S1=DCOS(SRASN)*DCOS(SDEC)
      S2=DSIN(SRASN)*DCOS(SDEC)
      S3=DSIN(SDEC)
C
C  NOW CALCULATE GEI COMPONENTS (DZ1,DZ2,DZ3) OF THE UNIT VECTOR EZGSE
C  POINTING NORTHWARD AND ORTHOGONAL TO THE ECLIPTIC PLANE, AS
C  (0,-SIN(OBLIQ),COS(OBLIQ)). FOR THE EPOCH 1978, OBLIQ = 23.44214 DEGS.
C  HERE WE USE A MORE ACCURATE TIME-DEPENDENT VALUE, DETERMINED AS:
C
      DJ=DFLOAT(365*(IY-1900)+(IY-1901)/4 +IDAY)
     * -0.5+DFLOAT(IHOUR*3600+MIN*60+ISEC)/86400.D0
      T=DJ/36525.D0
      OBLIQ=(23.45229D0-0.0130125D0*T)/57.2957795D0
      DZ1=0.D0
      DZ2=-DSIN(OBLIQ)
      DZ3=DCOS(OBLIQ)
C
C  NOW WE OBTAIN GEI COMPONENTS OF THE UNIT VECTOR EYGSE=(DY1,DY2,DY3),
C  COMPLETING THE RIGHT-HANDED SYSTEM. THEY CAN BE FOUND FROM THE VECTOR
C  PRODUCT EZGSE x EXGSE = (DZ1,DZ2,DZ3) x (S1,S2,S3):
C
      DY1=DZ2*S3-DZ3*S2
      DY2=DZ3*S1-DZ1*S3
      DY3=DZ1*S2-DZ2*S1
C
C  NOW LET'S CALCULATE GEI COMPONENTS OF THE UNIT VECTOR X = EXGSW, DIRECTED ANTIPARALLEL
C  TO THE OBSERVED SOLAR WIND FLOW. FIRST, CALCULATE ITS COMPONENTS IN GSE:
C
      V=DSQRT(VGSEX**2+VGSEY**2+VGSEZ**2)
      DX1=-VGSEX/V
      DX2=-VGSEY/V
      DX3=-VGSEZ/V
C
C  THEN IN GEI:
C
      X1=DX1*S1+DX2*DY1+DX3*DZ1
      X2=DX1*S2+DX2*DY2+DX3*DZ2
      X3=DX1*S3+DX2*DY3+DX3*DZ3
C
C  NOW CALCULATE GEI COMPONENTS (DIP1,DIP2,DIP3) OF THE UNIT VECTOR DIP = EZ_SM = EZ_MAG,
C   ALIGNED WITH THE GEODIPOLE AND POINTING NORTHWARD FROM ECLIPTIC PLANE:
C
      CGST=DCOS(GST)
      SGST=DSIN(GST)
C
      DIP1=STCL*CGST-STSL*SGST
      DIP2=STCL*SGST+STSL*CGST
      DIP3=CT0
C
C  THIS ALLOWS US TO CALCULATE GEI COMPONENTS OF THE UNIT VECTOR Y = EYGSW
C   BY TAKING THE VECTOR PRODUCT DIP x X AND NORMALIZING IT TO UNIT LENGTH:
C
      Y1=DIP2*X3-DIP3*X2
      Y2=DIP3*X1-DIP1*X3
      Y3=DIP1*X2-DIP2*X1
      Y=DSQRT(Y1*Y1+Y2*Y2+Y3*Y3)
      Y1=Y1/Y
      Y2=Y2/Y
      Y3=Y3/Y
C
C   AND GEI COMPONENTS OF THE UNIT VECTOR Z = EZGSW = EXGSW x EYGSW = X x Y:
C
      Z1=X2*Y3-X3*Y2
      Z2=X3*Y1-X1*Y3
      Z3=X1*Y2-X2*Y1
C
C   ELEMENTS OF THE MATRIX GSE TO GSW ARE THE SCALAR PRODUCTS:
C
C  E11=(EXGSE,EXGSW)  E12=(EXGSE,EYGSW)  E13=(EXGSE,EZGSW)
C  E21=(EYGSE,EXGSW)  E22=(EYGSE,EYGSW)  E23=(EYGSE,EZGSW)
C  E31=(EZGSE,EXGSW)  E32=(EZGSE,EYGSW)  E33=(EZGSE,EZGSW)
C
      E11= S1*X1 +S2*X2 +S3*X3
      E12= S1*Y1 +S2*Y2 +S3*Y3
      E13= S1*Z1 +S2*Z2 +S3*Z3
      E21=DY1*X1+DY2*X2+DY3*X3
      E22=DY1*Y1+DY2*Y2+DY3*Y3
      E23=DY1*Z1+DY2*Z2+DY3*Z3
      E31=DZ1*X1+DZ2*X2+DZ3*X3
      E32=DZ1*Y1+DZ2*Y2+DZ3*Y3
      E33=DZ1*Z1+DZ2*Z2+DZ3*Z3
C
C   GEODIPOLE TILT ANGLE IN THE GSW SYSTEM: PSI=ARCSIN(DIP,EXGSW)
C
      SPS=DIP1*X1+DIP2*X2+DIP3*X3
      CPS=DSQRT(1.D0-SPS**2)
      PSI=DASIN(SPS)
C
C   ELEMENTS OF THE MATRIX GEO TO GSW ARE THE SCALAR PRODUCTS:
C
C   A11=(EXGEO,EXGSW), A12=(EYGEO,EXGSW), A13=(EZGEO,EXGSW),
C   A21=(EXGEO,EYGSW), A22=(EYGEO,EYGSW), A23=(EZGEO,EYGSW),
C   A31=(EXGEO,EZGSW), A32=(EYGEO,EZGSW), A33=(EZGEO,EZGSW),
C
C   ALL THE UNIT VECTORS IN BRACKETS ARE ALREADY DEFINED IN GEI:
C
C  EXGEO=(CGST,SGST,0), EYGEO=(-SGST,CGST,0), EZGEO=(0,0,1)
C  EXGSW=(X1,X2,X3),  EYGSW=(Y1,Y2,Y3),   EZGSW=(Z1,Z2,Z3)
C                                                           AND  THEREFORE:
C
      A11=X1*CGST+X2*SGST
      A12=-X1*SGST+X2*CGST
      A13=X3
      A21=Y1*CGST+Y2*SGST
      A22=-Y1*SGST+Y2*CGST
      A23=Y3
      A31=Z1*CGST+Z2*SGST
      A32=-Z1*SGST+Z2*CGST
      A33=Z3
C
C  NOW CALCULATE ELEMENTS OF THE MATRIX MAG TO SM (ONE ROTATION ABOUT THE GEODIPOLE AXIS);
C   THEY ARE FOUND AS THE SCALAR PRODUCTS: CFI=GM22=(EYSM,EYMAG)=(EYGSW,EYMAG),
C                                          SFI=GM23=(EYSM,EXMAG)=(EYGSW,EXMAG),
C    DERIVED AS FOLLOWS:
C
C IN GEO, THE VECTORS EXMAG AND EYMAG HAVE THE COMPONENTS (CT0*CL0,CT0*SL0,-ST0)
C  AND (-SL0,CL0,0), RESPECTIVELY.    HENCE, IN GEI THEIR COMPONENTS ARE:
C  EXMAG:    CT0*CL0*COS(GST)-CT0*SL0*SIN(GST)
C            CT0*CL0*SIN(GST)+CT0*SL0*COS(GST)
C            -ST0
C  EYMAG:    -SL0*COS(GST)-CL0*SIN(GST)
C            -SL0*SIN(GST)+CL0*COS(GST)
C             0
C  NOW, NOTE THAT GEI COMPONENTS OF EYSM=EYGSW WERE FOUND ABOVE AS Y1, Y2, AND Y3,
C  AND WE ONLY HAVE TO COMBINE THESE QUANTITIES INTO SCALAR PRODUCTS:
C
      EXMAGX=CT0*(CL0*CGST-SL0*SGST)
      EXMAGY=CT0*(CL0*SGST+SL0*CGST)
      EXMAGZ=-ST0
      EYMAGX=-(SL0*CGST+CL0*SGST)
      EYMAGY=-(SL0*SGST-CL0*CGST)
      CFI=Y1*EYMAGX+Y2*EYMAGY
      SFI=Y1*EXMAGX+Y2*EXMAGY+Y3*EXMAGZ
C
 10   FORMAT(//1X,
     *'**** RECALC_08 WARNS: YEAR IS OUT OF INTERVAL 1965-2020: IYEAR=',
     *I4,/,6X,'CALCULATIONS WILL BE DONE FOR IYEAR=',I4,/)
      RETURN
      END
c
c==================================================================================

      SUBROUTINE GSWGSE_08 (XGSW,YGSW,ZGSW,XGSE,YGSE,ZGSE,J)
C
C  THIS SUBROUTINE TRANSFORMS COMPONENTS OF ANY VECTOR BETWEEN THE STANDARD GSE
C  COORDINATE SYSTEM AND THE GEOCENTRIC SOLAR-WIND (GSW, aka GSWM), DEFINED AS FOLLOWS
C  (HONES ET AL., PLANET.SPACE SCI., V.34, P.889, 1986; TSYGANENKO ET AL., JGRA,
C  V.103(A4), P.6827, 1998):
C
C  IN THE GSW SYSTEM, X AXIS IS ANTIPARALLEL TO THE OBSERVED DIRECTION OF THE SOLAR WIND FLOW.
C  TWO OTHER AXES, Y AND Z, ARE DEFINED IN THE SAME WAY AS FOR THE STANDARD GSM, THAT IS,
C  Z AXIS ORTHOGONAL TO X AXIS, POINTS NORTHWARD, AND LIES IN THE PLANE DEFINED BY THE X-
C  AND GEODIPOLE AXIS. THE Y AXIS COMPLETES THE RIGHT-HANDED SYSTEM.
C
C  THE GSW SYSTEM BECOMES IDENTICAL TO THE STANDARD GSM IN THE CASE OF
C   A STRICTLY RADIAL SOLAR WIND FLOW.
C
C  AUTHOR:  N. A. TSYGANENKO
C  ADDED TO 2008 VERSION OF GEOPACK: JAN 27, 2008.
C  LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C                    J>0                       J<0
C-----INPUT:   J,XGSW,YGSW,ZGSW          J,XGSE,YGSE,ZGSE
C-----OUTPUT:    XGSE,YGSE,ZGSE            XGSW,YGSW,ZGSW
C
C  IMPORTANT THINGS TO REMEMBER:
C
C   (1) BEFORE CALLING GSWGSE_08, BE SURE TO INVOKE SUBROUTINE RECALC_08, IN ORDER
C       TO DEFINE ALL NECESSARY ELEMENTS OF TRANSFORMATION MATRICES
C
C   (2) IN THE ABSENCE OF INFORMATION ON THE SOLAR WIND DIRECTION, E.G., WITH ONLY SCALAR
C       SPEED V KNOWN, THIS SUBROUTINE CAN BE USED TO CONVERT VECTORS TO ABERRATED
C       COORDINATE SYSTEM, TAKING INTO ACCOUNT EARTH'S ORBITAL SPEED OF 29 KM/S.
C       TO DO THAT, SPECIFY THE LAST 3 PARAMETERS IN RECALC_08 AS FOLLOWS:
C       VGSEX=-V, VGSEY=29.0, VGSEZ=0.0.
C
C       IT SHOULD ALSO BE KEPT IN MIND THAT IN SOME SOLAR WIND DATABASES THE ABERRATION
C       EFFECT HAS ALREADY BEEN TAKEN INTO ACCOUNT BY SUBTRACTING 29 KM/S FROM VYGSE;
C       IN THAT CASE, THE ORIGINAL VYGSE VALUES SHOULD BE RESTORED BY ADDING BACK THE
C       29 KM/S CORRECTION. WHETHER OR NOT TO DO THAT, MUST BE VERIFIED WITH THE DATA
C       ORIGINATOR (OR CAN BE DETERMINED BY CALCULATING THE AVERAGE VGSEY OVER
C       A SUFFICIENTLY LONG TIME INTERVAL)
C
C   (3) IF NO INFORMATION IS AVAILABLE ON THE SOLAR WIND SPEED, THEN SET VGSEX=-400.0
c       AND  VGSEY=VGSEZ=0. IN THAT CASE, THE GSW COORDINATE SYSTEM BECOMES
c       IDENTICAL TO THE STANDARD ONE.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK1/ AAA(25),E11,E21,E31,E12,E22,E32,E13,E23,E33
C
C  DIRECT TRANSFORMATION:
C
      IF (J.GT.0) THEN
        XGSE=XGSW*E11+YGSW*E12+ZGSW*E13
        YGSE=XGSW*E21+YGSW*E22+ZGSW*E23
        ZGSE=XGSW*E31+YGSW*E32+ZGSW*E33
      ENDIF
C
C   INVERSE TRANSFORMATION: CARRIED OUT USING THE TRANSPOSED MATRIX:
C
      IF (J.LT.0) THEN
        XGSW=XGSE*E11+YGSE*E21+ZGSE*E31
        YGSW=XGSE*E12+YGSE*E22+ZGSE*E32
        ZGSW=XGSE*E13+YGSE*E23+ZGSE*E33
      ENDIF
C
      RETURN
      END
C
C========================================================================================
C
      SUBROUTINE GEOMAG_08 (XGEO,YGEO,ZGEO,XMAG,YMAG,ZMAG,J)
C
C    CONVERTS GEOGRAPHIC (GEO) TO DIPOLE (MAG) COORDINATES OR VICE VERSA.
C
C                    J>0                       J<0
C-----INPUT:  J,XGEO,YGEO,ZGEO           J,XMAG,YMAG,ZMAG
C-----OUTPUT:    XMAG,YMAG,ZMAG           XGEO,YGEO,ZGEO
C
C  ATTENTION:  SUBROUTINE  RECALC_08  MUST BE INVOKED BEFORE GEOMAG_08 IN TWO CASES:
C     /A/  BEFORE THE FIRST TRANSFORMATION OF COORDINATES
C     /B/  IF THE VALUES OF IYEAR AND/OR IDAY HAVE BEEN CHANGED
C
C  NO INFORMATION IS REQUIRED HERE ON THE SOLAR WIND VELOCITY, SO ONE
C  CAN SET VGSEX=-400.0, VGSEY=0.0, VGSEZ=0.0 IN RECALC_08.
C
C   LAST MOFIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C   AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK1/ ST0,CT0,SL0,CL0,CTCL,STCL,CTSL,STSL,AB(26)

      IF(J.GT.0) THEN
       XMAG=XGEO*CTCL+YGEO*CTSL-ZGEO*ST0
       YMAG=YGEO*CL0-XGEO*SL0
       ZMAG=XGEO*STCL+YGEO*STSL+ZGEO*CT0
      ELSE
       XGEO=XMAG*CTCL-YMAG*SL0+ZMAG*STCL
       YGEO=XMAG*CTSL+YMAG*CL0+ZMAG*STSL
       ZGEO=ZMAG*CT0-XMAG*ST0
      ENDIF

      RETURN
      END
c
c=========================================================================================
c
      SUBROUTINE GEIGEO_08 (XGEI,YGEI,ZGEI,XGEO,YGEO,ZGEO,J)
C
C   CONVERTS EQUATORIAL INERTIAL (GEI) TO GEOGRAPHICAL (GEO) COORDS
C   OR VICE VERSA.
C                    J>0                J<0
C----INPUT:  J,XGEI,YGEI,ZGEI    J,XGEO,YGEO,ZGEO
C----OUTPUT:   XGEO,YGEO,ZGEO      XGEI,YGEI,ZGEI
C
C  ATTENTION:  SUBROUTINE  RECALC_08  MUST BE INVOKED BEFORE GEIGEO_08 IN TWO CASES:
C     /A/  BEFORE THE FIRST TRANSFORMATION OF COORDINATES
C     /B/  IF THE CURRENT VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC HAVE BEEN CHANGED
C
C  NO INFORMATION IS REQUIRED HERE ON THE SOLAR WIND VELOCITY, SO ONE
C  CAN SET VGSEX=-400.0, VGSEY=0.0, VGSEZ=0.0 IN RECALC_08.
C
C     LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)

C     AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK1/ A(13),CGST,SGST,B(19)
C
      IF(J.GT.0) THEN
       XGEO=XGEI*CGST+YGEI*SGST
       YGEO=YGEI*CGST-XGEI*SGST
       ZGEO=ZGEI
      ELSE
       XGEI=XGEO*CGST-YGEO*SGST
       YGEI=YGEO*CGST+XGEO*SGST
       ZGEI=ZGEO
      ENDIF

      RETURN
      END
C
C=======================================================================================
C
      SUBROUTINE MAGSM_08 (XMAG,YMAG,ZMAG,XSM,YSM,ZSM,J)
C
C  CONVERTS DIPOLE (MAG) TO SOLAR MAGNETIC (SM) COORDINATES OR VICE VERSA
C
C                    J>0              J<0
C----INPUT: J,XMAG,YMAG,ZMAG     J,XSM,YSM,ZSM
C----OUTPUT:    XSM,YSM,ZSM       XMAG,YMAG,ZMAG
C
C  ATTENTION:  SUBROUTINE  RECALC_08  MUST BE INVOKED BEFORE MAGSM_08 IN THREE CASES:
C     /A/  BEFORE THE FIRST TRANSFORMATION OF COORDINATES, OR
C     /B/  IF THE VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC HAVE CHANGED, AND/OR
C     /C/  IF THE VALUES OF COMPONENTS OF THE SOLAR WIND FLOW VELOCITY HAVE CHANGED
C
C    IMPORTANT NOTE:
C
C        A NON-STANDARD DEFINITION IS IMPLIED HERE FOR THE SOLAR MAGNETIC COORDINATE
C        SYSTEM:  IT IS ASSUMED THAT THE XSM AXIS LIES IN THE PLANE DEFINED BY THE
C        GEODIPOLE AXIS AND THE OBSERVED VECTOR OF THE SOLAR WIND FLOW (RATHER THAN
C        THE EARTH-SUN LINE).  IN ORDER TO CONVERT MAG COORDINATES TO AND FROM THE
C        STANDARD SM COORDINATES, INVOKE RECALC_08 WITH VGSEX=-400.0, VGSEY=0.0, VGSEZ=0.0
C
C     LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C     AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK1/ A(8),SFI,CFI,B(24)
C
      IF (J.GT.0) THEN
       XSM=XMAG*CFI-YMAG*SFI
       YSM=XMAG*SFI+YMAG*CFI
       ZSM=ZMAG
      ELSE
       XMAG=XSM*CFI+YSM*SFI
       YMAG=YSM*CFI-XSM*SFI
       ZMAG=ZSM
      ENDIF

      RETURN
      END
C
C=====================================================================================
C
       SUBROUTINE SMGSW_08 (XSM,YSM,ZSM,XGSW,YGSW,ZGSW,J)
C
C  CONVERTS SOLAR MAGNETIC (SM) TO GEOCENTRIC SOLAR-WIND (GSW) COORDINATES OR VICE VERSA.
C
C                  J>0                 J<0
C-----INPUT: J,XSM,YSM,ZSM        J,XGSW,YGSW,ZGSW
C----OUTPUT:  XGSW,YGSW,ZGSW       XSM,YSM,ZSM
C
C  ATTENTION:  SUBROUTINE RECALC_08 MUST BE INVOKED BEFORE SMGSW_08 IN THREE CASES:
C     /A/  BEFORE THE FIRST TRANSFORMATION OF COORDINATES
C     /B/  IF THE VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC HAVE BEEN CHANGED
C     /C/  IF THE VALUES OF COMPONENTS OF THE SOLAR WIND FLOW VELOCITY HAVE CHANGED
C
C    IMPORTANT NOTE:
C
C        A NON-STANDARD DEFINITION IS IMPLIED HERE FOR THE SOLAR MAGNETIC (SM) COORDINATE
C        SYSTEM:  IT IS ASSUMED THAT THE XSM AXIS LIES IN THE PLANE DEFINED BY THE
C        GEODIPOLE AXIS AND THE OBSERVED VECTOR OF THE SOLAR WIND FLOW (RATHER THAN
C        THE EARTH-SUN LINE).  IN ORDER TO CONVERT MAG COORDINATES TO AND FROM THE
C        STANDARD SM COORDINATES, INVOKE RECALC_08 WITH VGSEX=-400.0, VGSEY=0.0, VGSEZ=0.0
C
C     LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C     AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK1/ A(10),SPS,CPS,B(22)

      IF (J.GT.0) THEN
       XGSW=XSM*CPS+ZSM*SPS
       YGSW=YSM
       ZGSW=ZSM*CPS-XSM*SPS
      ELSE
       XSM=XGSW*CPS-ZGSW*SPS
       YSM=YGSW
       ZSM=XGSW*SPS+ZGSW*CPS
      ENDIF

      RETURN
      END
C
C==========================================================================================
C
      SUBROUTINE GEOGSW_08 (XGEO,YGEO,ZGEO,XGSW,YGSW,ZGSW,J)
C
C CONVERTS GEOGRAPHIC (GEO) TO GEOCENTRIC SOLAR-WIND (GSW) COORDINATES OR VICE VERSA.
C
C                   J>0                   J<0
C----- INPUT:  J,XGEO,YGEO,ZGEO    J,XGSW,YGSW,ZGSW
C---- OUTPUT:    XGSW,YGSW,ZGSW      XGEO,YGEO,ZGEO
C
C  ATTENTION:  SUBROUTINE  RECALC_08  MUST BE INVOKED BEFORE GEOGSW_08 IN THREE CASES:
C     /A/  BEFORE THE FIRST TRANSFORMATION OF COORDINATES, OR
C     /B/  IF THE VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC  HAVE CHANGED, AND/OR
C     /C/  IF THE VALUES OF COMPONENTS OF THE SOLAR WIND FLOW VELOCITY HAVE CHANGED
C
C  NOTE: THIS SUBROUTINE CONVERTS GEO VECTORS TO AND FROM THE SOLAR-WIND GSW COORDINATE
C        SYSTEM, TAKING INTO ACCOUNT POSSIBLE DEFLECTIONS OF THE SOLAR WIND DIRECTION FROM
C        STRICTLY RADIAL.  BEFORE CONVERTING TO/FROM STANDARD GSM COORDINATES, INVOKE RECALC_08
C        WITH VGSEX=-400.0 and VGSEY=0.0, VGSEZ=0.0
C
C     LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C     AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /GEOPACK1/ AA(16),A11,A21,A31,A12,A22,A32,A13,A23,A33,B(9)
C
      IF (J.GT.0) THEN
       XGSW=A11*XGEO+A12*YGEO+A13*ZGEO
       YGSW=A21*XGEO+A22*YGEO+A23*ZGEO
       ZGSW=A31*XGEO+A32*YGEO+A33*ZGEO
      ELSE
       XGEO=A11*XGSW+A21*YGSW+A31*ZGSW
       YGEO=A12*XGSW+A22*YGSW+A32*ZGSW
       ZGEO=A13*XGSW+A23*YGSW+A33*ZGSW
      ENDIF

      RETURN
      END
C
C=====================================================================================
C
      SUBROUTINE GEODGEO_08 (H,XMU,R,THETA,J)
C
C  THIS SUBROUTINE (1) CONVERTS VERTICAL LOCAL HEIGHT (ALTITUDE) H AND GEODETIC
C  LATITUDE XMU INTO GEOCENTRIC COORDINATES R AND THETA (GEOCENTRIC RADIAL
C  DISTANCE AND COLATITUDE, RESPECTIVELY; ALSO KNOWN AS ECEF COORDINATES),
C  AS WELL AS (2) PERFORMS THE INVERSE TRANSFORMATION FROM {R,THETA} TO {H,XMU}.
C
C  THE SUBROUTINE USES WORLD GEODETIC SYSTEM WGS84 PARAMETERS FOR THE EARTH'S
C  ELLIPSOID. THE ANGULAR QUANTITIES (GEO COLATITUDE THETA AND GEODETIC LATITUDE
C  XMU) ARE IN RADIANS, AND THE DISTANCES (GEOCENTRIC RADIUS R AND ALTITUDE H
C  ABOVE THE EARTH'S ELLIPSOID) ARE IN KILOMETERS.
C
C  IF J>0, THE TRANSFORMATION IS MADE FROM GEODETIC TO GEOCENTRIC COORDINATES
C   USING SIMPLE DIRECT EQUATIONS.
C  IF J<0, THE INVERSE TRANSFORMATION FROM GEOCENTRIC TO GEODETIC COORDINATES
C   IS MADE BY MEANS OF A FAST ITERATIVE ALGORITHM.
C
c-------------------------------------------------------------------------------
C                   J>0                     |            J<0
c-------------------------------------------|-----------------------------------
C--INPUT:   J        H          XMU         |    J         R          THETA
c         flag  altitude (km)  geodetic     |   flag   geocentric    spherical
c                              latitude     |         distance (km) colatitude
c                              (radians)    |                        (radians)
c-------------------------------------------|-----------------------------------
c                                           |
C----OUTPUT:         R           THETA      |          H              XMU
C                geocentric    spherical    |      altitude (km)    geodetic
C                distance (km) colatitude   |                       latitude
C                              (radians)    |                       (radians)
C-------------------------------------------------------------------------------
C
C   AUTHOR:  N. A. TSYGANENKO
c   DATE:    DEC 5, 2007
C   LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA R_EQ, BETA /6378.137D0, 6.73949674228D-3/
c
c  R_EQ is the semi-major axis of the Earth's ellipsoid, and BETA is its
c  second eccentricity squared
c
      DATA TOL /1.D-6/
c
c   Direct transformation (GEOD=>GEO):
c
      IF (J.GT.0) THEN
       COSXMU=DCOS(XMU)
       SINXMU=DSIN(XMU)
       DEN=DSQRT(COSXMU**2+(SINXMU/(1.0D0+BETA))**2)
       COSLAM=COSXMU/DEN
       SINLAM=SINXMU/(DEN*(1.0D0+BETA))
       RS=R_EQ/DSQRT(1.0D0+BETA*SINLAM**2)
       X=RS*COSLAM+H*COSXMU
       Z=RS*SINLAM+H*SINXMU
       R=DSQRT(X**2+Z**2)
       THETA=DACOS(Z/R)
      ENDIF

c
c   Inverse transformation (GEO=>GEOD):
c
      IF (J.LT.0) THEN
       N=0
       PHI=1.570796327D0-THETA
       PHI1=PHI
  1    SP=DSIN(PHI1)
       ARG=SP*(1.0D0+BETA)/DSQRT(1.0D0+BETA*(2.0D0+BETA)*SP**2)
       XMUS=DASIN(ARG)
       RS=R_EQ/DSQRT(1.0D0+BETA*DSIN(PHI1)**2)
       COSFIMS=DCOS(PHI1-XMUS)
       H=DSQRT((RS*COSFIMS)**2+R**2-RS**2)-RS*COSFIMS
       Z=RS*DSIN(PHI1)+H*DSIN(XMUS)
       X=RS*DCOS(PHI1)+H*DCOS(XMUS)
       RR=DSQRT(X**2+Z**2)
       DPHI=DASIN(Z/RR)-PHI
       PHI1=PHI1-DPHI
       N=N+1
       IF (DABS(DPHI).GT.TOL.AND.N.LT.100) GOTO 1
       XMU=XMUS
      ENDIF

      RETURN
      END
C
C=====================================================================================
C
      SUBROUTINE RHAND_08 (X,Y,Z,R1,R2,R3,IOPT,PARMOD,EXNAME,INNAME)
C
C  CALCULATES THE COMPONENTS OF THE RIGHT HAND SIDE VECTOR IN THE GEOMAGNETIC FIELD
C    LINE EQUATION  (a subsidiary subroutine for the subroutine STEP_08)
C
C     LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C     AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PARMOD(10)
C
C     EXNAME AND INNAME ARE NAMES OF SUBROUTINES FOR THE EXTERNAL AND INTERNAL
C     PARTS OF THE TOTAL FIELD, E.G., T96_01 AND IGRF_GSW_08
C
      COMMON /GEOPACK1/ A(12),DS3,BB(2),PSI,CC(18)

      CALL EXNAME (IOPT,PARMOD,PSI,X,Y,Z,BXGSW,BYGSW,BZGSW)
      CALL INNAME (X,Y,Z,HXGSW,HYGSW,HZGSW)

      BX=BXGSW+HXGSW
      BY=BYGSW+HYGSW
      BZ=BZGSW+HZGSW
      B=DS3/DSQRT(BX**2+BY**2+BZ**2)
      R1=BX*B
      R2=BY*B
      R3=BZ*B
      RETURN
      END
C
C===================================================================================
C
      SUBROUTINE STEP_08(X,Y,Z,DS,DSMAX,ERRIN,IOPT,PARMOD,EXNAME,INNAME)
C
C   RE-CALCULATES THE INPUT VALUES {X,Y,Z} (IN GSW COORDINATES) FOR ANY POINT ON A FIELD LINE,
C     BY MAKING A STEP ALONG THAT LINE USING RUNGE-KUTTA-MERSON ALGORITHM (G.N. Lance, Numerical
C      methods for high-speed computers, Iliffe & Sons, London 1960.)
C   DS IS A PRESCRIBED VALUE OF THE CURRENT STEP SIZE, DSMAX IS ITS UPPER LIMIT.
C   ERRIN IS A PERMISSIBLE ERROR (ITS OPTIMAL VALUE SPECIFIED IN THE S/R TRACE_08)
C     IF THE ACTUAL ERROR (ERRCUR) AT THE CURRENT STEP IS LARGER THAN ERRIN, THE STEP IS REJECTED,
C       AND THE CALCULATION IS REPEATED ANEW WITH HALVED STEPSIZE DS.
C     IF ERRCUR IS SMALLER THAN ERRIN, THE STEP IS ACCEPTED, AND THE CURRENT VALUE OF DS IS RETAINED
C       FOR THE NEXT STEP.
C     IF ERRCUR IS SMALLER THAN 0.04*ERRIN, THE STEP IS ACCEPTED, AND THE VALUE OF DS FOR THE NEXT STEP
C       IS INCREASED BY THE FACTOR 1.5, BUT NOT LARGER THAN DSMAX.
C   IOPT IS A FLAG, RESERVED FOR SPECIFYNG A VERSION OF THE EXTERNAL FIELD MODEL EXNAME.
C   ARRAY PARMOD(10) CONTAINS INPUT PARAMETERS FOR THE MODEL EXNAME.
C   EXNAME IS THE NAME OF THE SUBROUTINE FOR THE EXTERNAL FIELD MODEL.
C   INNAME IS THE NAME OF THE SUBROUTINE FOR THE INTERNAL FIELD MODEL (EITHER DIP_08 OR IGRF_GSW_08)
C
C   ALL THE ABOVE PARAMETERS ARE INPUT ONES; OUTPUT IS THE RECALCULATED VALUES OF X,Y,Z
C
C     LAST MODIFICATION:    APRIL 21, 2008 (SEE ERRATA AS OF THAT DATE)
C
C     AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PARMOD(10)
      COMMON /GEOPACK1/ A(12),DS3,B(21)
      EXTERNAL EXNAME,INNAME

  1   DS3=-DS/3.D0
      CALL RHAND_08 (X,Y,Z,R11,R12,R13,IOPT,PARMOD,EXNAME,INNAME)
      CALL RHAND_08 (X+R11,Y+R12,Z+R13,R21,R22,R23,IOPT,PARMOD,EXNAME,
     * INNAME)
      CALL RHAND_08 (X+.5D0*(R11+R21),Y+.5D0*(R12+R22),Z+.5D0*
     *(R13+R23),R31,R32,R33,IOPT,PARMOD,EXNAME,INNAME)
      CALL RHAND_08 (X+.375D0*(R11+3.D0*R31),Y+.375D0*(R12+3.D0*R32
     *),Z+.375D0*(R13+3.D0*R33),R41,R42,R43,IOPT,PARMOD,EXNAME,INNAME)
      CALL RHAND_08 (X+1.5D0*(R11-3.D0*R31+4.D0*R41),Y+1.5D0*(R12-
     *3.D0*R32+4.D0*R42),Z+1.5D0*(R13-3.D0*R33+4.D0*R43),
     *R51,R52,R53,IOPT,PARMOD,EXNAME,INNAME)
      ERRCUR=DABS(R11-4.5D0*R31+4.D0*R41-.5D0*R51)+DABS(R12-4.5D0*R32
     *+4.D0*R42-.5D0*R52)+DABS(R13-4.5D0*R33+4.D0*R43-.5D0*R53)
C
C  READY FOR MAKING THE STEP, BUT CHECK THE ACCURACY; IF INSUFFICIENT,
C   REPEAT THE STEP WITH HALVED STEPSIZE:
C
      IF (ERRCUR.GT.ERRIN) THEN
      DS=DS*.5D0
      GOTO 1
      ENDIF
C
C  ACCURACY IS ACCEPTABLE, BUT CHECK IF THE STEPSIZE IS NOT TOO LARGE;
C    OTHERWISE REPEAT THE STEP WITH DS=DSMAX
C
      IF (DABS(DS).GT.DSMAX) THEN
      DS=DSIGN(DSMAX,DS)
      GOTO 1
      ENDIF
C
C  MAKING THE STEP:
C
  2   X=X+.5D0*(R11+4.D0*R41+R51)
      Y=Y+.5D0*(R12+4.D0*R42+R52)
      Z=Z+.5D0*(R13+4.D0*R43+R53)
C
C  IF THE ACTUAL ERROR IS TOO SMALL (LESS THAN 4% OF ERRIN) AND DS SMALLER
C   THAN DSMAX/1.5, THEN WE INCREASE THE STEPSIZE FOR THE NEXT STEP BY 50%
C
      IF(ERRCUR.LT.ERRIN*.04D0.AND.DS.LT.DSMAX/1.5D0) DS=DS*1.5D0
      RETURN
      END
C
C==============================================================================
C
      SUBROUTINE TRACE_08 (XI,YI,ZI,DIR,DSMAX,ERR,RLIM,R0,IOPT,PARMOD,
     * EXNAME,INNAME,XF,YF,ZF,XX,YY,ZZ,L,LMAX)
C
C  TRACES A FIELD LINE FROM AN ARBITRARY POINT OF SPACE TO THE EARTH'S
C  SURFACE OR TO A MODEL LIMITING BOUNDARY.
C
C  THIS SUBROUTINE ALLOWS TWO OPTIONS:
C
C  (1) IF INNAME=IGRF_GSW_08, THEN THE IGRF MODEL WILL BE USED FOR CALCULATING
C      CONTRIBUTION FROM EARTH'S INTERNAL SOURCES. IN THIS CASE, SUBROUTINE
C      RECALC_08 MUST BE CALLED BEFORE USING TRACE_08, WITH PROPERLY SPECIFIED DATE,
C      UNIVERSAL TIME, AND SOLAR WIND VELOCITY COMPONENTS, TO CALCULATE IN ADVANCE
C      ALL QUANTITIES NEEDED FOR THE MAIN FIELD MODEL AND FOR TRANSFORMATIONS
C      BETWEEN INVOLVED COORDINATE SYSTEMS.
C
C  (2) IF INNAME=DIP_08, THEN A PURE DIPOLE FIELD WILL BE USED INSTEAD OF THE IGRF MODEL.
C      IN THIS CASE, THE SUBROUTINE RECALC_08 MUST ALSO BE CALLED BEFORE TRACE_08.
C      HERE ONE CAN CHOOSE EITHER TO
C      (a) CALCULATE DIPOLE TILT ANGLE BASED ON DATE, TIME, AND SOLAR WIND DIRECTION,
C   OR (b) EXPLICITLY SPECIFY THAT ANGLE, WITHOUT ANY REFERENCE TO DATE/UT/SOLAR WIND.
C      IN THE LAST CASE (b), THE SINE (SPS) AND COSINE (CPS) OF THE DIPOLE TILT
C      ANGLE MUST BE SPECIFIED IN ADVANCE (BUT AFTER HAVING CALLED RECALC_08) AND FORWARDED
C      IN THE COMMON BLOCK /GEOPACK1/ (IN ITS 11th AND 12th ELEMENTS, RESPECTIVELY).
C      IN THIS CASE THE ROLE OF THE SUBROUTINE RECALC_08 IS REDUCED TO ONLY CALCULATING
C      THE COMPONENTS OF THE EARTH'S DIPOLE MOMENT.
C
C------------- INPUT PARAMETERS:
C
C   XI,YI,ZI - GSW COORDS OF THE FIELD LINE STARTING POINT (IN EARTH RADII, 1 RE = 6371.2 km),
C
C   DIR - SIGN OF THE TRACING DIRECTION: IF DIR=1.0 THEN THE TRACING IS MADE ANTIPARALLEL
C     TO THE TOTAL FIELD VECTOR (E.G., FROM NORTHERN TO SOUTHERN CONJUGATE POINT);
C     IF DIR=-1.0 THEN THE TRACING PROCEEDS IN THE OPPOSITE DIRECTION, THAT IS, PARALLEL TO
C     THE TOTAL FIELD VECTOR.
C
C   DSMAX - UPPER LIMIT ON THE STEPSIZE (SETS A DESIRED MAXIMAL SPACING BETWEEN
C                 THE FIELD LINE POINTS)
C
C   ERR - PERMISSIBLE STEP ERROR. A REASONABLE ESTIMATE PROVIDING A SUFFICIENT ACCURACY FOR MOST
C         APPLICATIONS IS ERR=0.0001. SMALLER/LARGER VALUES WILL RESULT IN LARGER/SMALLER NUMBER
C         OF STEPS AND, HENCE, OF OUTPUT FIELD LINE POINTS. NOTE THAT USING MUCH SMALLER VALUES
C         OF ERR MAY REQUIRE USING A DOUBLE PRECISION VERSION OF THE ENTIRE PACKAGE.
C
C   R0 -  RADIUS OF A SPHERE (IN RE), DEFINING THE INNER BOUNDARY OF THE TRACING REGION
C         (USUALLY, EARTH'S SURFACE OR THE IONOSPHERE, WHERE R0~1.0)
C         IF THE FIELD LINE REACHES THAT SPHERE FROM OUTSIDE, ITS INBOUND TRACING IS
C         TERMINATED AND THE CROSSING POINT COORDINATES XF,YF,ZF  ARE CALCULATED.
C
C   RLIM - RADIUS OF A SPHERE (IN RE), DEFINING THE OUTER BOUNDARY OF THE TRACING REGION;
C         IF THE FIELD LINE REACHES THAT BOUNDARY FROM INSIDE, ITS OUTBOUND TRACING IS
C         TERMINATED AND THE CROSSING POINT COORDINATES XF,YF,ZF ARE CALCULATED.
C
C   IOPT - A MODEL INDEX; CAN BE USED FOR SPECIFYING A VERSION OF THE EXTERNAL FIELD
C       MODEL (E.G., A NUMBER OF THE KP-INDEX INTERVAL). ALTERNATIVELY, ONE CAN USE THE ARRAY
C       PARMOD FOR THAT PURPOSE (SEE BELOW); IN THAT CASE IOPT IS JUST A DUMMY PARAMETER.
C
C   PARMOD -  A 10-ELEMENT ARRAY CONTAINING INPUT PARAMETERS NEEDED FOR A UNIQUE
C      SPECIFICATION OF THE EXTERNAL FIELD MODEL. THE CONCRETE MEANING OF THE COMPONENTS
C      OF PARMOD DEPENDS ON A SPECIFIC VERSION OF THAT MODEL.
C
C   EXNAME - NAME OF A SUBROUTINE PROVIDING COMPONENTS OF THE EXTERNAL MAGNETIC FIELD
C    (E.G., T89, OR T96_01, ETC.).
C   INNAME - NAME OF A SUBROUTINE PROVIDING COMPONENTS OF THE INTERNAL MAGNETIC FIELD
C    (EITHER DIP_08 OR IGRF_GSW_08).
C
C   LMAX - MAXIMAL LENGTH OF THE ARRAYS XX,YY,ZZ, IN WHICH COORDINATES OF THE FIELD
C          LINE POINTS ARE STORED. LMAX SHOULD BE SET EQUAL TO THE ACTUAL LENGTH OF
C          THE ARRAYS, DEFINED IN THE MAIN PROGRAM AS ACTUAL ARGUMENTS OF THIS SUBROUTINE.
C
C-------------- OUTPUT PARAMETERS:
C
C   XF,YF,ZF - GSW COORDINATES OF THE ENDPOINT OF THE TRACED FIELD LINE.
C   XX,YY,ZZ - ARRAYS OF LENGTH LMAX, CONTAINING COORDINATES OF THE FIELD LINE POINTS.
C   L - ACTUAL NUMBER OF FIELD LINE POINTS, GENERATED BY THIS SUBROUTINE.
C
C ----------------------------------------------------------
C
C     LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C     AUTHOR:  N. A. TSYGANENKO
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XX(LMAX),YY(LMAX),ZZ(LMAX), PARMOD(10)
      COMMON /GEOPACK1/ AA(12),DD,BB(21)
      EXTERNAL EXNAME,INNAME
C
      L=0
      NREV=0
      DD=DIR
C
C  INITIALIZE THE STEP SIZE AND STARTING PONT:
C
      DS=0.5D0*DIR
      X=XI
      Y=YI
      Z=ZI
c
c  here we call RHAND_08 just to find out the sign of the radial component of the field
c   vector, and to determine the initial direction of the tracing (i.e., either away
c   or towards Earth):
c
      CALL RHAND_08 (X,Y,Z,R1,R2,R3,IOPT,PARMOD,EXNAME,INNAME)
      AD=0.01D0
      IF (X*R1+Y*R2+Z*R3.LT.0.D0) AD=-0.01D0
C
c     |AD|=0.01 and its sign follows the rule:
c (1) if DIR=1 (tracing antiparallel to B vector) then the sign of AD is the same as of Br
c (2) if DIR=-1 (tracing parallel to B vector) then the sign of AD is opposite to that of Br
c     AD is defined in order to initialize the value of RR (radial distance at previous step):

      RR=DSQRT(X**2+Y**2+Z**2)+AD
c
  1   L=L+1
      IF(L.GT.LMAX) GOTO 7
      XX(L)=X
      YY(L)=Y
      ZZ(L)=Z
      RYZ=Y**2+Z**2
      R2=X**2+RYZ
      R=DSQRT(R2)
C
c  check if the line hit the outer tracing boundary; if yes, then terminate
c   the tracing (label 8). The outer boundary is assumed reached, when the line
c   crosses any of the 3 surfaces: (1) a sphere R=RLIM, (2) a cylinder of radius 40Re,
c   coaxial with the XGSW axis, (3) the plane X=20Re:

      IF (R.GT.RLIM.OR.RYZ.GT.1600.D0.OR.X.GT.20.D0) GOTO 8
c
c  check whether or not the inner tracing boundary was crossed from outside,
c  if yes, then calculate the footpoint position by interpolation (go to label 6):
c
      IF (R.LT.R0.AND.RR.GT.R) GOTO 6

c  check if we are moving outward, or R is still larger than 3Re; if yes, proceed further:
c
      IF (R.GE.RR.OR.R.GE.3.D0) GOTO 4
c
c  now we entered inside the sphere R=3: to avoid too large steps (and hence
c  inaccurate interpolated position of the footpoint), enforce the progressively
c  smaller stepsize values as we approach the inner boundary R=R0:
c
      FC=0.2D0
      IF(R-R0.LT.0.05D0) FC=0.05D0
      AL=FC*(R-R0+0.2D0)
      DS=DIR*AL
c
  4   XR=X
      YR=Y
      ZR=Z
c
      DRP=R-RR
      RR=R
c
      CALL STEP_08 (X,Y,Z,DS,DSMAX,ERR,IOPT,PARMOD,EXNAME,INNAME)
c
C  check the total number NREV of changes in the tracing radial direction; (NREV.GT.2) means
c   that the line started making multiple loops, in which case we stop the process:
C
      R=DSQRT(X**2+Y**2+Z**2)
      DR=R-RR
      IF (DRP*DR.LT.0.D0) NREV=NREV+1
      IF (NREV.GT.4) GOTO 8
C
      GOTO 1
c
c  find the footpoint position by interpolating between the current and previous
c   field line points:
c
  6   R1=(R0-R)/(RR-R)
      X=X-(X-XR)*R1
      Y=Y-(Y-YR)*R1
      Z=Z-(Z-ZR)*R1
      GOTO 8
  7   WRITE (*,10)
      L=LMAX
  8   XF=X
      YF=Y
      ZF=Z
C
C  replace the coordinates of the last (L-th) point in the XX,YY,ZZ arrays
C   so that they correspond to the estimated footpoint position {XF,YF,ZF},
c   satisfying:  sqrt(XF**2+YF**2+ZF**2}=R0
C
      XX(L)=XF
      YY(L)=YF
      ZZ(L)=ZF
C
      RETURN
 10   FORMAT(//,1X,'**** COMPUTATIONS IN THE SUBROUTINE TRACE_08 ARE',
     *' TERMINATED: THE NUMBER OF POINTS EXCEEDED LMAX ****'//)
      END
c
C====================================================================================
C
      SUBROUTINE SHUETAL_MGNP_08(XN_PD,VEL,BZIMF,XGSW,YGSW,ZGSW,
     *  XMGNP,YMGNP,ZMGNP,DIST,ID)
C
C  FOR ANY POINT OF SPACE WITH COORDINATES (XGSW,YGSW,ZGSW) AND SPECIFIED CONDITIONS
C  IN THE INCOMING SOLAR WIND, THIS SUBROUTINE:
C
C (1) DETERMINES IF THE POINT (XGSW,YGSW,ZGSW) LIES INSIDE OR OUTSIDE THE
C      MODEL MAGNETOPAUSE OF SHUE ET AL. (JGR-A, V.103, P. 17691, 1998).
C
C (2) CALCULATES THE GSW POSITION OF A POINT {XMGNP,YMGNP,ZMGNP}, LYING AT THE MODEL
C      MAGNETOPAUSE AND ASYMPTOTICALLY TENDING TO THE NEAREST BOUNDARY POINT WITH
C      RESPECT TO THE OBSERVATION POINT {XGSW,YGSW,ZGSW}, AS IT APPROACHES THE MAGNETO-
C      PAUSE.
C
C  INPUT: XN_PD - EITHER SOLAR WIND PROTON NUMBER DENSITY (PER C.C.) (IF VEL>0)
C                    OR THE SOLAR WIND RAM PRESSURE IN NANOPASCALS   (IF VEL<0)
C         BZIMF - IMF BZ IN NANOTESLAS
C
C         VEL - EITHER SOLAR WIND VELOCITY (KM/SEC)
C                  OR ANY NEGATIVE NUMBER, WHICH INDICATES THAT XN_PD STANDS
C                     FOR THE SOLAR WIND PRESSURE, RATHER THAN FOR THE DENSITY
C
C         XGSW,YGSW,ZGSW - GSW POSITION OF THE OBSERVATION POINT IN EARTH RADII
C
C  OUTPUT: XMGNP,YMGNP,ZMGNP - GSW POSITION OF THE BOUNDARY POINT
C          DIST - DISTANCE (IN RE) BETWEEN THE OBSERVATION POINT (XGSW,YGSW,ZGSW)
C                 AND THE MODEL NAGNETOPAUSE
C          ID -  POSITION FLAG:  ID=+1 (-1) MEANS THAT THE OBSERVATION POINT
C          LIES INSIDE (OUTSIDE) OF THE MODEL MAGNETOPAUSE, RESPECTIVELY.
C
C  OTHER SUBROUTINES USED: T96_MGNP_08
C
c          AUTHOR:  N.A. TSYGANENKO,
C          DATE:    APRIL 4, 2003.
C          LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      IF (VEL.LT.0.) THEN
        P=XN_PD
      ELSE
        P=1.94D-6*XN_PD*VEL**2  ! P IS THE SOLAR WIND DYNAMIC PRESSURE (IN nPa)
      ENDIF

c
c  DEFINE THE ANGLE PHI, MEASURED DUSKWARD FROM THE NOON-MIDNIGHT MERIDIAN PLANE;
C  IF THE OBSERVATION POINT LIES ON THE X AXIS, THE ANGLE PHI CANNOT BE UNIQUELY
C  DEFINED, AND WE SET IT AT ZERO:
c
      IF (YGSW.NE.0.D0.OR.ZGSW.NE.0.D0) THEN
         PHI=DATAN2(YGSW,ZGSW)
      ELSE
         PHI=0.D0
      ENDIF
C
C  FIRST, FIND OUT IF THE OBSERVATION POINT LIES INSIDE THE SHUE ET AL BDRY
C  AND SET THE VALUE OF THE ID FLAG:
C
      ID=-1
      R0=(10.22D0+1.29D0*DTANH(.184D0*(BZIMF+8.14D0)))*P**(-.15151515D0)
      ALPHA=(0.58D0-0.007D0*BZIMF)*(1.D0+0.024*DLOG(P))
      R=DSQRT(XGSW**2+YGSW**2+ZGSW**2)
      RM=R0*(2.D0/(1.D0+XGSW/R))**ALPHA
      IF (R.LE.RM) ID=+1
C
C  NOW, FIND THE CORRESPONDING T96 MAGNETOPAUSE POSITION, TO BE USED AS
C  A STARTING APPROXIMATION IN THE SEARCH OF A CORRESPONDING SHUE ET AL.
C  BOUNDARY POINT:
C
      CALL T96_MGNP_08(P,-1.D0,XGSW,YGSW,ZGSW,XMT96,YMT96,ZMT96,DIST,
     *  ID96)
C
      RHO2=YMT96**2+ZMT96**2
      R=DSQRT(RHO2+XMT96**2)
      ST=DSQRT(RHO2)/R
      CT=XMT96/R
C
C  NOW, USE NEWTON'S ITERATIVE METHOD TO FIND THE NEAREST POINT AT THE
C   SHUE ET AL.'S BOUNDARY:
C
      NIT=0

  1   T=DATAN2(ST,CT)
      RM=R0*(2.D0/(1.D0+CT))**ALPHA

      F=R-RM
      GRADF_R=1.D0
      GRADF_T=-ALPHA/R*RM*ST/(1.D0+CT)
      GRADF=DSQRT(GRADF_R**2+GRADF_T**2)

      DR=-F/GRADF**2
      DT= DR/R*GRADF_T

      R=R+DR
      T=T+DT
      ST=DSIN(T)
      CT=DCOS(T)

      DS=DSQRT(DR**2+(R*DT)**2)

      NIT=NIT+1

      IF (NIT.GT.1000) THEN
         PRINT *,
     *' BOUNDARY POINT COULD NOT BE FOUND; ITERATIONS DO NOT CONVERGE'
      ENDIF

      IF (DS.GT.1.D-4) GOTO 1

      XMGNP=R*DCOS(T)
      RHO=  R*DSIN(T)

      YMGNP=RHO*DSIN(PHI)
      ZMGNP=RHO*DCOS(PHI)

      DIST=DSQRT((XGSW-XMGNP)**2+(YGSW-YMGNP)**2+(ZGSW-ZMGNP)**2)

      RETURN
      END
C
C=======================================================================================
C
      SUBROUTINE T96_MGNP_08(XN_PD,VEL,XGSW,YGSW,ZGSW,XMGNP,YMGNP,ZMGNP,
     * DIST,ID)
C
C  FOR ANY POINT OF SPACE WITH GIVEN COORDINATES (XGSW,YGSW,ZGSW), THIS SUBROUTINE DEFINES
C  THE POSITION OF A POINT (XMGNP,YMGNP,ZMGNP) AT THE T96 MODEL MAGNETOPAUSE WITH THE
C  SAME VALUE OF THE ELLIPSOIDAL TAU-COORDINATE, AND THE DISTANCE BETWEEN THEM.  THIS IS
C  NOT THE SHORTEST DISTANCE D_MIN TO THE BOUNDARY, BUT DIST ASYMPTOTICALLY TENDS TO D_MIN,
C  AS THE OBSERVATION POINT GETS CLOSER TO THE MAGNETOPAUSE.
C
C  INPUT: XN_PD - EITHER SOLAR WIND PROTON NUMBER DENSITY (PER C.C.) (IF VEL>0)
C                    OR THE SOLAR WIND RAM PRESSURE IN NANOPASCALS   (IF VEL<0)
C         VEL - EITHER SOLAR WIND VELOCITY (KM/SEC)
C                  OR ANY NEGATIVE NUMBER, WHICH INDICATES THAT XN_PD STANDS
C                     FOR THE SOLAR WIND PRESSURE, RATHER THAN FOR THE DENSITY
C
C         XGSW,YGSW,ZGSW - COORDINATES OF THE OBSERVATION POINT IN EARTH RADII
C
C  OUTPUT: XMGNP,YMGNP,ZMGNP - GSW POSITION OF THE BOUNDARY POINT, HAVING THE SAME
C          VALUE OF TAU-COORDINATE AS THE OBSERVATION POINT (XGSW,YGSW,ZGSW)
C          DIST -  THE DISTANCE BETWEEN THE TWO POINTS, IN RE,
C          ID -    POSITION FLAG; ID=+1 (-1) MEANS THAT THE POINT (XGSW,YGSW,ZGSW)
C          LIES INSIDE (OUTSIDE) THE MODEL MAGNETOPAUSE, RESPECTIVELY.
C
C  THE PRESSURE-DEPENDENT MAGNETOPAUSE IS THAT USED IN THE T96_01 MODEL
C  (TSYGANENKO, JGR, V.100, P.5599, 1995; ESA SP-389, P.181, OCT. 1996)
C
c   AUTHOR:  N.A. TSYGANENKO
C   DATE:    AUG.1, 1995, REVISED APRIL 3, 2003.
C   LAST MODIFICATION:    MARCH 21, 2008 (DOUBLE-PRECISION VERSION)
C
C  DEFINE SOLAR WIND DYNAMIC PRESSURE (NANOPASCALS, ASSUMING 4% OF ALPHA-PARTICLES),
C   IF NOT EXPLICITLY SPECIFIED IN THE INPUT:
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      IF (VEL.LT.0.D0) THEN
       PD=XN_PD
      ELSE
       PD=1.94D-6*XN_PD*VEL**2
C
      ENDIF
C
C  RATIO OF PD TO THE AVERAGE PRESSURE, ASSUMED EQUAL TO 2 nPa:

      RAT=PD/2.0D0
      RAT16=RAT**0.14D0

C (THE POWER INDEX 0.14 IN THE SCALING FACTOR IS THE BEST-FIT VALUE OBTAINED FROM DATA
C    AND USED IN THE T96_01 VERSION)
C
C  VALUES OF THE MAGNETOPAUSE PARAMETERS FOR  PD = 2 nPa:
C
      A0=70.D0
      S00=1.08D0
      X00=5.48D0
C
C   VALUES OF THE MAGNETOPAUSE PARAMETERS, SCALED BY THE ACTUAL PRESSURE:
C
      A=A0/RAT16
      S0=S00
      X0=X00/RAT16
      XM=X0-A
C
C  (XM IS THE X-COORDINATE OF THE "SEAM" BETWEEN THE ELLIPSOID AND THE CYLINDER)
C
C     (FOR DETAILS OF THE ELLIPSOIDAL COORDINATES, SEE THE PAPER:
C      N.A.TSYGANENKO, SOLUTION OF CHAPMAN-FERRARO PROBLEM FOR AN
C      ELLIPSOIDAL MAGNETOPAUSE, PLANET.SPACE SCI., V.37, P.1037, 1989).
C
       IF (YGSW.NE.0.D0.OR.ZGSW.NE.0.D0) THEN
          PHI=DATAN2(YGSW,ZGSW)
       ELSE
          PHI=0.D0
       ENDIF
C
       RHO=DSQRT(YGSW**2+ZGSW**2)
C
       IF (XGSW.LT.XM) THEN
           XMGNP=XGSW
           RHOMGNP=A*DSQRT(S0**2-1.D0)
           YMGNP=RHOMGNP*DSIN(PHI)
           ZMGNP=RHOMGNP*DCOS(PHI)
           DIST=DSQRT((XGSW-XMGNP)**2+(YGSW-YMGNP)**2+(ZGSW-ZMGNP)**2)
           IF (RHOMGNP.GT.RHO) ID=+1
           IF (RHOMGNP.LE.RHO) ID=-1
           RETURN
       ENDIF
C
          XKSI=(XGSW-X0)/A+1.D0
          XDZT=RHO/A
          SQ1=DSQRT((1.D0+XKSI)**2+XDZT**2)
          SQ2=DSQRT((1.D0-XKSI)**2+XDZT**2)
          SIGMA=0.5D0*(SQ1+SQ2)
          TAU=0.5D0*(SQ1-SQ2)
C
C  NOW CALCULATE (X,Y,Z) FOR THE CLOSEST POINT AT THE MAGNETOPAUSE
C
          XMGNP=X0-A*(1.D0-S0*TAU)
          ARG=(S0**2-1.D0)*(1.D0-TAU**2)
          IF (ARG.LT.0.D0) ARG=0.D0
          RHOMGNP=A*DSQRT(ARG)
          YMGNP=RHOMGNP*DSIN(PHI)
          ZMGNP=RHOMGNP*DCOS(PHI)
C
C  NOW CALCULATE THE DISTANCE BETWEEN THE POINTS {XGSW,YGSW,ZGSW} AND {XMGNP,YMGNP,ZMGNP}:
C   (IN GENERAL, THIS IS NOT THE SHORTEST DISTANCE D_MIN, BUT DIST ASYMPTOTICALLY TENDS
C    TO D_MIN, AS WE ARE GETTING CLOSER TO THE MAGNETOPAUSE):
C
      DIST=DSQRT((XGSW-XMGNP)**2+(YGSW-YMGNP)**2+(ZGSW-ZMGNP)**2)
C
      IF (SIGMA.GT.S0) ID=-1   !  ID=-1 MEANS THAT THE POINT LIES OUTSIDE
      IF (SIGMA.LE.S0) ID=+1   !  ID=+1 MEANS THAT THE POINT LIES INSIDE
C                                           THE MAGNETOSPHERE
      RETURN
      END
C
C===================================================================================
C
c

!***************************************************************************************************
! Copyright 2004 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C
       SUBROUTINE loc_equator(
     &         lati,longi,alti,Bmin,posit)
C
       IMPLICIT NONE
       REAL*8     lati,longi,alti
       REAL*8     Bmin
       REAL*8     posit(3)
       REAL*8     xx0(3)
       
       CALL GDZ_GEO(lati,longi,alti,xx0(1),xx0(2),xx0(3))
       
       call loc_equator_opt(xx0,Bmin,posit)

       RETURN
       END

       SUBROUTINE loc_equator_opt(
     &         xx0,Bmin,posit)
C
       IMPLICIT NONE
       INCLUDE 'variables.inc'
C
       INTEGER*4  Nreb,Ntet
       PARAMETER (Nreb = 50, Ntet = 720)
C
       INTEGER*4  k_ext,k_l,kint
       INTEGER*4  Nrebmax
       REAL*8     rr
       REAL*8     xx0(3),xx(3),x1(3),x2(3)
       REAL*8     xmin(3)
       REAL*8     lati,longi,alti
       REAL*8     B(3),Bl,B0,Bmin,B1,B3
       REAL*8     dsreb,smin

       INTEGER*4  I,J,Ifail
       REAL*8     Lb
       REAL*8     aa,bb
C
       REAL*8     tt
       REAL*8     dtet
C
       REAL*8     posit(3)
C
       COMMON /magmod/k_ext,k_l,kint
       REAL*8     pi,rad
       common /rconst/rad,pi
C
C
       dtet = pi/Ntet
C
       Nrebmax = 10*Nreb
C
       CALL GEO_SM(xx0,xx)
       rr = SQRT(xx(1)*xx(1)+xx(2)*xx(2)+xx(3)*xx(3))
       tt = ACOS(xx(3)/rr)
       Lb  = rr/SIN(tt)/SIN(tt)
C
       CALL CHAMP(xx0,B,B0,Ifail)
       IF (Ifail.LT.0) THEN
	  Bmin=baddata
          posit(1) = baddata
          posit(2) = baddata
          posit(3) = baddata
	  RETURN
       ENDIF
       Bmin = B0
C
       dsreb = Lb/Nreb
C
C calcul du sens du depart 
C
       CALL sksyst(-dsreb,xx0,x1,Bl,Ifail)
       IF (Ifail.LT.0) THEN
	  Bmin=baddata
          posit(1) = baddata
          posit(2) = baddata
          posit(3) = baddata
	  RETURN
       ENDIF
       B1 = Bl
       CALL sksyst(dsreb,xx0,x2,Bl,Ifail)
       IF (Ifail.LT.0) THEN
	  Bmin=baddata
          posit(1) = baddata
          posit(2) = baddata
          posit(3) = baddata
	  RETURN
       ENDIF
       B3 = Bl
C
C attention cas equatorial
C
       IF(B1.GT.B0 .AND. B3.GT.B0)THEN
         aa = 0.5D0*(B3+B1-2.D0*B0)
         bb = 0.5D0*(B3-B1)
         smin = -0.5D0*bb/aa
         Bmin = B0 - aa*smin*smin
         CALL sksyst(smin*dsreb,xx0,posit,Bl,Ifail)
         IF (Ifail.LT.0) THEN
	    Bmin=baddata
            posit(1) = baddata
            posit(2) = baddata
            posit(3) = baddata
	    RETURN
         ENDIF
	 RETURN
       ENDIF
       IF (B3.GT.B1) THEN
         dsreb = -dsreb
       ENDIF
C
C calcul de la ligne de champ et de I
C
       Bmin = B0
       DO I = 1,3
         x1(I)  = xx0(I)
       ENDDO
C
       DO J = 1,Nrebmax
         CALL sksyst(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) THEN
	    Bmin=baddata
            posit(1) = baddata
            posit(2) = baddata
            posit(3) = baddata
	    RETURN
         ENDIF
         IF (Bl.LT.Bmin) THEN
           xmin(1) = x2(1)
           xmin(2) = x2(2)
           xmin(3) = x2(3)
           Bmin = Bl
         ENDIF
         IF (Bl.GT.B0) GOTO 20
	 x1(1) = x2(1)
	 x1(2) = x2(2)
	 x1(3) = x2(3)
	 B1 = Bl
       ENDDO
20     CONTINUE
C
       IF (J.GE.Nrebmax) THEN !open field line
          Bmin = baddata
	  posit(1)=baddata
	  posit(2)=baddata
	  posit(3)=baddata
	  RETURN
       ENDIF
c
C calcul de Bmin
C
       CALL sksyst(dsreb,xmin,x1,B3,Ifail)
       IF (Ifail.LT.0) THEN
	  Bmin=baddata
          posit(1) = baddata
          posit(2) = baddata
          posit(3) = baddata
	  RETURN
       ENDIF
       CALL sksyst(-dsreb,xmin,x1,B1,Ifail)
       IF (Ifail.LT.0) THEN
	  Bmin=baddata
          posit(1) = baddata
          posit(2) = baddata
          posit(3) = baddata
	  RETURN
       ENDIF
       aa = 0.5D0*(B3+B1-2.D0*Bmin)
       bb = 0.5D0*(B3-B1)
       smin = -0.5D0*bb/aa
       Bmin = Bmin - aa*smin*smin
       CALL sksyst(smin*dsreb,xmin,posit,Bl,Ifail)
       IF (Ifail.LT.0) THEN
	  Bmin=baddata
          posit(1) = baddata
          posit(2) = baddata
          posit(3) = baddata
	  RETURN
       ENDIF
c
       END
       

!***************************************************************************************************
! Copyright 2004 D. Vallado
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
*   -------------------------------------------------------------------
*
*                               sgp4unit.for
*
*    this file contains the sgp4 procedures. the code was originally
*    released in the 1980 and 1986 papers. in 1997 and 1998, the updated and
*    copmbined code (sgp4 and sdp4) was released by nasa on the internet.
*                 seawifs.gsfc.nasa.gov/~seawifsp/src/bobdays/
*
*                            companion code for
*               fundamentals of astrodynamics and applications
*                                    2004
*                              by david vallado
*
*       (w) 719-573-2600, email dvallado@agi.com
*
*    current :
*              14 aug 06  david vallado
*                           chg lyddane choice back to strn3, constants,
*                           separate debug and writes, misc doc
*    changes :
*              15 dec 05  david vallado
*                           misc fixes
*              26 jul 05  david vallado
*                           fixes for paper
*                           note that each fix is preceded by a
*                           comment with "sgp4fix" and an explanation of
*                           what was changed
*              10 aug 04  david vallado
*                           2nd printing baseline working
*              14 may 01  david vallado
*                           2nd edition baseline
*                     97  nasa
*                           internet version
*                     80  norad
*                           original baseline
*     *****************************************************************
*  Files         :
*    Unit 14     - sgp4test.dbg    debug output file


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE DPPER
*
*  This Subroutine provides deep space long period periodic contributions
*    to the mean elements.  by design, these periodics are zero at epoch.
*    this used to be dscom which included initialization, but it's really a
*    recurring function.
*
*  author        : david vallado                  719-573-2600   28 jun 2005
*
*  inputs        :
*    e3          -
*    ee2         -
*    peo         -
*    pgho        -
*    pho         -
*    pinco       -
*    plo         -
*    se2 , se3 , Sgh2, Sgh3, Sgh4, Sh2, Sh3, Si2, Si3, Sl2, Sl3, Sl4 -
*    t           -
*    xh2, xh3, xi2, xi3, xl2, xl3, xl4 -
*    zmol        -
*    zmos        -
*    ep          - eccentricity                           0.0 - 1.0
*    inclo       - inclination - needed for lyddane modification
*    nodep       - right ascension of ascending node
*    argpp       - argument of perigee
*    mp          - mean anomaly
*
*  outputs       :
*    ep          - eccentricity                           0.0 - 1.0
*    inclp       - inclination
*    nodep       - right ascension of ascending node
*    argpp       - argument of perigee
*    mp          - mean anomaly
*
*  locals        :
*    alfdp       -
*    betdp       -
*    cosip  , sinip  , cosop  , sinop  ,
*    dalf        -
*    dbet        -
*    dls         -
*    f2, f3      -
*    pe          -
*    pgh         -
*    ph          -
*    pinc        -
*    pl          -
*    sel   , ses   , sghl  , sghs  , shl   , shs   , sil   , sinzf , sis   ,
*    sll   , sls
*    xls         -
*    xnoh        -
*    zf          -
*    zm          -
*
*  coupling      :
*    none.
*
*  references    :
*    hoots, roehrich, norad spacetrack report #3 1980
*    hoots, norad spacetrack report #6 1986
*    hoots, schumacher and glover 2004
*    vallado, crawford, hujsak, kelso  2006
*------------------------------------------------------------------------------

      SUBROUTINE DPPER( e3    , ee2   , peo   , pgho  , pho   , pinco ,
     &                  plo   , se2   , se3   , sgh2  , sgh3  , sgh4  ,
     &                  sh2   , sh3   , si2   , si3   , sl2   , sl3   ,
     &                  sl4   , T     , xgh2  , xgh3  , xgh4  , xh2   ,
     &                  xh3   , xi2   , xi3   , xl2   , xl3   , xl4   ,
     &                  zmol  , zmos  , inclo , init  ,
     &                  Eccp  , Inclp , nodep, Argpp , Mp )
        IMPLICIT NONE
        CHARACTER Init
        REAL*8  e3    , ee2   , peo   , pgho  , pho   , pinco , plo   ,
     &          se2   , se3   , sgh2  , sgh3  , sgh4  , sh2   , sh3   ,
     &          si2   , si3   , sl2   , sl3   , sl4   , T     , xgh2  ,
     &          xgh3  , xgh4  , xh2   , xh3   , xi2   , xi3   , xl2   ,
     &          xl3   , xl4   , zmol  , zmos  , inclo ,
     &          Eccp  , Inclp , nodep, Argpp , Mp

* -------------------------- Local Variables --------------------------
        REAL*8  alfdp , betdp , cosip , cosop , dalf  , dbet  , dls   ,
     &          f2    , f3    , pe    , pgh   , ph    , pinc  , pl    ,
     &          sel   , ses   , sghl  , sghs  , shl   , shs   , sil   ,
     &          sinip , sinop , sinzf , sis   , sll   , sls   , xls   ,
     &          xnoh  , zf    , zm
        REAL*8  Zel   , Zes   , Znl   , Zns   , Pi   , TwoPi
        Character ildm
        COMMON /DebugHelp/ Help
        CHARACTER Help

* ----------------------------- Constants -----------------------------
        TwoPi= 6.283185307179586D0
        Pi   = 3.14159265358979D0
        ZES  = 0.01675D0
        ZEL  = 0.05490D0
        ZNS  = 1.19459D-5
        ZNL  = 1.5835218D-4

* ------------------- CALCULATE TIME VARYING PERIODICS ----------------
        ZM   = ZMOS + ZNS*T

        IF (Init.eq.'y') ZM = ZMOS
        ZF   = ZM + 2.0D0*ZES*DSIN(ZM)
        SINZF= DSIN(ZF)
        F2   =  0.5D0*SINZF*SINZF - 0.25D0
        F3   = -0.5D0*SINZF*DCOS(ZF)
        SES  = SE2*F2 + SE3*F3
        SIS  = SI2*F2 + SI3*F3
        SLS  = SL2*F2 + SL3*F3 + SL4*SINZF
        SGHS = SGH2*F2 + SGH3*F3 + SGH4*SINZF
        SHS  = SH2*F2 + SH3*F3
        ZM   = ZMOL + ZNL*T

        IF (Init.eq.'y') ZM = ZMOL
        ZF   = ZM + 2.0D0*ZEL*DSIN(ZM)
        SINZF= DSIN(ZF)
        F2   =  0.5D0*SINZF*SINZF - 0.25D0
        F3   = -0.5D0*SINZF*DCOS(ZF)
        SEL  = EE2*F2 + E3*F3
        SIL  = XI2*F2 + XI3*F3
        SLL  = XL2*F2 + XL3*F3 + XL4*SINZF
        SGHL = XGH2*F2 + XGH3*F3 + XGH4*SINZF
        SHL  = XH2*F2 + XH3*F3
        PE   = SES + SEL
        PINC = SIS + SIL
        PL   = SLS + SLL
        PGH  = SGHS + SGHL
        PH   = SHS + SHL

        IF (Init.eq.'n') THEN
c    0.2 rad = 11.45916 deg
c    sgp4fix for lyddane choice
c    add next three lines to set up use of original inclination per strn3 ver
            ildm = 'y'
            IF (inclo.ge.0.2D0) ildm = 'n'

            PE    = PE   - PEO
            PINC  = PINC - PINCO
            PL    = PL   - PLO
            PGH   = PGH  - PGHO
            PH    = PH   - PHO
            Inclp = Inclp  + PINC
            Eccp  = Eccp   + PE
            SINIP = DSIN(Inclp)
            COSIP = DCOS(Inclp)

* ------------------------- APPLY PERIODICS DIRECTLY ------------------
c    sgp4fix for lyddane choice
c    strn3 used original inclination - this is technically feasible
c    gsfc used perturbed inclination - also technically feasible
c    probably best to readjust the 0.2 limit value and limit discontinuity
c    use next line for original strn3 approach and original inclination
c            if (inclo.ge.0.2D0) THEN
c    use next line for gsfc version and perturbed inclination
            IF (Inclp.ge.0.2D0) THEN

                PH     = PH/SINIP
                PGH    = PGH - COSIP*PH
                Argpp  = Argpp + PGH
                nodep  = nodep + PH
                Mp     = Mp + PL
              ELSE

* ----------------- APPLY PERIODICS WITH LYDDANE MODIFICATION ---------
                SINOP  = DSIN(nodep)
                COSOP  = DCOS(nodep)
                ALFDP  = SINIP*SINOP
                BETDP  = SINIP*COSOP
                DALF   =  PH*COSOP + PINC*COSIP*SINOP
                DBET   = -PH*SINOP + PINC*COSIP*COSOP
                ALFDP  = ALFDP + DALF
                BETDP  = BETDP + DBET
                nodep = DMOD(nodep,TwoPi)
                XLS    = Mp + Argpp + COSIP*nodep
                DLS    = PL + PGH - PINC*nodep*SINIP
                XLS    = XLS + DLS
                XNOH   = nodep
                nodep  = DATAN2(ALFDP,BETDP)
                IF(DABS(XNOH-nodep) .GT. PI) THEN
                    IF(nodep .lt. XNOH) THEN
                        nodep = nodep+TWOPI
                      ELSE
                        nodep = nodep-TWOPI
                      ENDIF
                  ENDIF
                Mp   = Mp + PL
                Argpp=  XLS - Mp - COSIP*nodep
              ENDIF
          ENDIF

c        INCLUDE 'debug1.for'

      RETURN
      END  !  end dpper


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE DSCOM
*
*  This Subroutine provides deep space common items used by both the secular
*    and periodics subroutines.  input is provided as shown. this routine
*    used to be called dpper, but the functions inside weren't well organized.
*
*  author        : david vallado                  719-573-2600   28 jun 2005
*
*  inputs        :
*    epoch       -
*    ep          - eccentricity
*    argpp       - argument of perigee
*    tc          -
*    inclp       - inclination
*    nodep      - right ascension of ascending node
*    np          - mean motion
*
*  outputs       :
*    sinim  , cosim  , sinomm , cosomm , snodm  , cnodm
*    day         -
*    e3          -
*    ee2         -
*    em          - eccentricity
*    emsq        - eccentricity squared
*    gam         -
*    peo         -
*    pgho        -
*    pho         -
*    pinco       -
*    plo         -
*    rtemsq      -
*    se2, se3         -
*    sgh2, sgh3, sgh4        -
*    sh2, sh3, si2, si3, sl2, sl3, sl4         -
*    s1, s2, s3, s4, s5, s6, s7          -
*    ss1, ss2, ss3, ss4, ss5, ss6, ss7, sz1, sz2, sz3         -
*    sz11, sz12, sz13, sz21, sz22, sz23, sz31, sz32, sz33        -
*    xgh2, xgh3, xgh4, xh2, xh3, xi2, xi3, xl2, xl3, xl4         -
*    nm          - mean motion
*    z1, z2, z3, z11, z12, z13, z21, z22, z23, z31, z32, z33         -
*    zmol        -
*    zmos        -
*
*  locals        :
*    a1, a2, a3, a4, a5, a6, a7, a8, a9, a10         -
*    betasq      -
*    cc          -
*    ctem, stem        -
*    x1, x2, x3, x4, x5, x6, x7, x8          -
*    xnodce      -
*    xnoi        -
*    zcosg  , zsing  , zcosgl , zsingl , zcosh  , zsinh  , zcoshl , zsinhl ,
*    zcosi  , zsini  , zcosil , zsinil ,
*    zx          -
*    zy          -
*
*  coupling      :
*    none.
*
*  references    :
*    hoots, roehrich, norad spacetrack report #3 1980
*    hoots, norad spacetrack report #6 1986
*    hoots, schumacher and glover 2004
*    vallado, crawford, hujsak, kelso  2006
*------------------------------------------------------------------------------

      SUBROUTINE DSCOM( EPOCH , Eccp  , Argpp , Tc    , Inclp , nodep,
     &                  Np    ,
     &                  SNODM , CNODM , SINIM , COSIM , SINOMM, COSOMM,
     &                  DAY   , E3    , Ee2   , Eccm  , EMSQ  , GAM   ,
     &                  Peo   , Pgho  , Pho   , PInco , Plo   ,
     &                  RTemSq, Se2   , Se3   , Sgh2  , Sgh3  , Sgh4  ,
     &                  Sh2   , Sh3   , Si2   , Si3   , Sl2   , Sl3   ,
     &                  Sl4   , S1    , S2    , S3    , S4    , S5    ,
     &                  S6    , S7    , SS1   , SS2   , SS3   , SS4   ,
     &                  SS5   , SS6   , SS7   , SZ1   , SZ2   , SZ3   ,
     &                  SZ11  , SZ12  , SZ13  , SZ21  , SZ22  , SZ23  ,
     &                  SZ31  , SZ32  , SZ33  , Xgh2  , Xgh3  , Xgh4  ,
     &                  Xh2   , Xh3   , Xi2   , Xi3   , Xl2   , Xl3   ,
     &                  Xl4   , Xn    , Z1    , Z2    , Z3    , Z11   ,
     &                  Z12   , Z13   , Z21   , Z22   , Z23   , Z31   ,
     &                  Z32   , Z33   , Zmol  , Zmos )
        IMPLICIT NONE
        REAL*8  EPOCH , Eccp  , Argpp , Tc    , Inclp , nodep, Np    ,
     &          SNODM , CNODM , SINIM , COSIM , SINOMM, COSOMM, DAY   ,
     &          E3    , Ee2   , Eccm  , EMSQ  , GAM   , RTemSq, Se2   ,
     &          Peo   , Pgho  , Pho   , PInco , Plo   ,
     &          Se3   , Sgh2  , Sgh3  , Sgh4  , Sh2   , Sh3   , Si2   ,
     &          Si3   , Sl2   , Sl3   , Sl4   , S1    , S2    , S3    ,
     &          S4    , S5    , S6    , S7    , SS1   , SS2   , SS3   ,
     &          SS4   , SS5   , SS6   , SS7   , SZ1   , SZ2   , SZ3   ,
     &          SZ11  , SZ12  , SZ13  , SZ21  , SZ22  , SZ23  , SZ31  ,
     &          SZ32  , SZ33  , Xgh2  , Xgh3  , Xgh4  , Xh2   , Xh3   ,
     &          Xi2   , Xi3   , Xl2   , Xl3   , Xl4   , Xn    , Z1    ,
     &          Z2    , Z3    , Z11   , Z12   , Z13   , Z21   , Z22   ,
     &          Z23   , Z31   , Z32   , Z33   , Zmol  , Zmos

* -------------------------- Local Variables --------------------------
        REAL*8  c1ss  , c1L   , zcosis, zsinis, zsings, zcosgs, twopi ,
     &          Zes   , zel
        INTEGER*4 LsFlg
        REAL*8  a1    , a2    , a3    , a4    , a5    , a6    , a7    ,
     &          a8    , a9    , a10   , betasq, cc    , ctem  , stem  ,
     &          x1    , x2    , x3    , x4    , x5    , x6    , x7    ,
     &          x8    , xnodce, xnoi  , zcosg , zcosgl, zcosh , zcoshl,
     &          zcosi , zcosil, zsing , zsingl, zsinh , zsinhl, zsini ,
     &          zsinil, zx    , zy

        COMMON /DebugHelp/ Help
        CHARACTER Help

* ------------------------------ Constants ----------------------------
        ZES    =  0.01675D0
        ZEL    =  0.05490D0
        C1SS   =  2.9864797D-6
        C1L    =  4.7968065D-7
        ZSINIS =  0.39785416D0
        ZCOSIS =  0.91744867D0
        ZCOSGS =  0.1945905D0
        ZSINGS = -0.98088458D0
        TwoPi  =  6.283185307179586D0

* ----------------- DEEP SPACE PERIODICS INITIALIZATION ---------------
        XN     = Np
        Eccm   = Eccp
        SNODM  = DSIN(nodep)
        CNODM  = DCOS(nodep)
        SINOMM = DSIN(Argpp)
        COSOMM = DCOS(Argpp)
        SINIM  = DSIN(Inclp)
        COSIM  = DCOS(Inclp)
        EMSQ   = Eccm*Eccm
        BETASQ = 1.0D0-EMSQ
        RTEMSQ = DSQRT(BETASQ)

* --------------------- INITIALIZE LUNAR SOLAR TERMS ------------------
        PEO    = 0.0D0
        PINCO  = 0.0D0
        PLO    = 0.0D0
        PGHO   = 0.0D0
        PHO    = 0.0D0
        DAY    = EPOCH + 18261.5D0 + TC/1440.0D0
        XNODCE = DMOD(4.5236020D0 - 9.2422029D-4*DAY,TwoPi)
        STEM   = DSIN(XNODCE)
        CTEM   = DCOS(XNODCE)
        ZCOSIL = 0.91375164D0 - 0.03568096D0*CTEM
        ZSINIL = DSQRT(1.0D0 - ZCOSIL*ZCOSIL)
        ZSINHL = 0.089683511D0*STEM / ZSINIL
        ZCOSHL = DSQRT(1.0D0 - ZSINHL*ZSINHL)
        GAM    = 5.8351514D0 + 0.0019443680D0*DAY
        ZX     = 0.39785416D0*STEM/ZSINIL
        ZY     = ZCOSHL*CTEM + 0.91744867D0*ZSINHL*STEM
        ZX     = DATAN2(ZX,ZY)
        ZX     = GAM + ZX - XNODCE
        ZCOSGL = DCOS(ZX)
        ZSINGL = DSIN(ZX)

* ---------------------------- DO SOLAR TERMS -------------------------
        ZCOSG = ZCOSGS
        ZSING = ZSINGS
        ZCOSI = ZCOSIS
        ZSINI = ZSINIS
        ZCOSH = CNODM
        ZSINH = SNODM
        CC    = C1SS
        XNOI  = 1.0D0 / XN

        DO LSFlg = 1,2
            A1 =   ZCOSG*ZCOSH + ZSING*ZCOSI*ZSINH
            A3 =  -ZSING*ZCOSH + ZCOSG*ZCOSI*ZSINH
            A7 =  -ZCOSG*ZSINH + ZSING*ZCOSI*ZCOSH
            A8 =   ZSING*ZSINI
            A9 =   ZSING*ZSINH + ZCOSG*ZCOSI*ZCOSH
            A10=   ZCOSG*ZSINI
            A2 =   COSIM*A7 + SINIM*A8
            A4 =   COSIM*A9 + SINIM*A10
            A5 =  -SINIM*A7 + COSIM*A8
            A6 =  -SINIM*A9 + COSIM*A10

            X1 =  A1*COSOMM + A2*SINOMM
            X2 =  A3*COSOMM + A4*SINOMM
            X3 = -A1*SINOMM + A2*COSOMM
            X4 = -A3*SINOMM + A4*COSOMM
            X5 =  A5*SINOMM
            X6 =  A6*SINOMM
            X7 =  A5*COSOMM
            X8 =  A6*COSOMM

            Z31= 12.0D0*X1*X1 - 3.0D0*X3*X3
            Z32= 24.0D0*X1*X2 - 6.0D0*X3*X4
            Z33= 12.0D0*X2*X2 - 3.0D0*X4*X4
            Z1 =  3.0D0* (A1*A1 + A2*A2) + Z31*EMSQ
            Z2 =  6.0D0* (A1*A3 + A2*A4) + Z32*EMSQ
            Z3 =  3.0D0* (A3*A3 + A4*A4) + Z33*EMSQ
            Z11= -6.0D0*A1*A5 + EMSQ* (-24.0D0*X1*X7-6.0D0*X3*X5)
            Z12= -6.0D0* (A1*A6 + A3*A5) + EMSQ*
     &           ( -24.0D0*(X2*X7+X1*X8) - 6.0D0*(X3*X6+X4*X5) )
            Z13= -6.0D0*A3*A6 + EMSQ*(-24.0D0*X2*X8 - 6.0D0*X4*X6)
            Z21=  6.0D0*A2*A5 + EMSQ*(24.0D0*X1*X5-6.0D0*X3*X7)
            Z22=  6.0D0* (A4*A5 + A2*A6) + EMSQ*
     &           (  24.0D0*(X2*X5+X1*X6) - 6.0D0*(X4*X7+X3*X8) )
            Z23=  6.0D0*A4*A6 + EMSQ*(24.0D0*X2*X6 - 6.0D0*X4*X8)
            Z1 = Z1 + Z1 + BETASQ*Z31
            Z2 = Z2 + Z2 + BETASQ*Z32
            Z3 = Z3 + Z3 + BETASQ*Z33
            S3 = CC*XNOI
            S2 = -0.5D0*S3 / RTEMSQ
            S4 = S3*RTEMSQ
            S1 = -15.0D0*Eccm*S4
            S5 = X1*X3 + X2*X4
            S6 = X2*X3 + X1*X4
            S7 = X2*X4 - X1*X3

* ------------------------------ DO LUNAR TERMS -----------------------
            IF (LSFLG.eq.1) THEN
                SS1   = S1
                SS2   = S2
                SS3   = S3
                SS4   = S4
                SS5   = S5
                SS6   = S6
                SS7   = S7
                SZ1   = Z1
                SZ2   = Z2
                SZ3   = Z3
                SZ11  = Z11
                SZ12  = Z12
                SZ13  = Z13
                SZ21  = Z21
                SZ22  = Z22
                SZ23  = Z23
                SZ31  = Z31
                SZ32  = Z32
                SZ33  = Z33
                ZCOSG = ZCOSGL
                ZSING = ZSINGL
                ZCOSI = ZCOSIL
                ZSINI = ZSINIL
                ZCOSH = ZCOSHL*CNODM+ZSINHL*SNODM
                ZSINH = SNODM*ZCOSHL-CNODM*ZSINHL
                CC    = C1L
              ENDIF
          ENDDO

        ZMOL  = DMOD( 4.7199672D0 + 0.22997150D0*DAY-GAM,TwoPi )
        ZMOS  = DMOD( 6.2565837D0 + 0.017201977D0*DAY,TwoPi )

* ---------------------------- DO SOLAR TERMS -------------------------
        SE2 =   2.0D0*SS1*SS6
        SE3 =   2.0D0*SS1*SS7
        SI2 =   2.0D0*SS2*SZ12
        SI3 =   2.0D0*SS2*(SZ13-SZ11)
        SL2 =  -2.0D0*SS3*SZ2
        SL3 =  -2.0D0*SS3*(SZ3-SZ1)
        SL4 =  -2.0D0*SS3*(-21.0D0-9.0D0*EMSQ)*ZES
        SGH2=   2.0D0*SS4*SZ32
        SGH3=   2.0D0*SS4*(SZ33-SZ31)
        SGH4= -18.0D0*SS4*ZES
        SH2 =  -2.0D0*SS2*SZ22
        SH3 =  -2.0D0*SS2*(SZ23-SZ21)

* ---------------------------- DO LUNAR TERMS -------------------------
        EE2 =   2.0D0*S1*S6
        E3  =   2.0D0*S1*S7
        XI2 =   2.0D0*S2*Z12
        XI3 =   2.0D0*S2*(Z13-Z11)
        XL2 =  -2.0D0*S3*Z2
        XL3 =  -2.0D0*S3*(Z3-Z1)
        XL4 =  -2.0D0*S3*(-21.0D0-9.0D0*EMSQ)*ZEL
        XGH2=   2.0D0*S4*Z32
        XGH3=   2.0D0*S4*(Z33-Z31)
        XGH4= -18.0D0*S4*ZEL
        XH2 =  -2.0D0*S2*Z22
        XH3 =  -2.0D0*S2*(Z23-Z21)

c        INCLUDE 'debug2.for'

      RETURN
      END  !  dscom


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE DSINIT
*
*  This Subroutine provides Deep Space contributions to Mean Motion Dot due
*    to geopotential resonance with half day and one day orbits.
*
*  Inputs        :
*    Cosim, Sinim-
*    Emsq        - Eccentricity squared
*    Argpo       - Argument of Perigee
*    S1, S2, S3, S4, S5      -
*    Ss1, Ss2, Ss3, Ss4, Ss5 -
*    Sz1, Sz3, Sz11, Sz13, Sz21, Sz23, Sz31, Sz33 -
*    T           - Time
*    Tc          -
*    GSTo        - Greenwich sidereal time                   rad
*    Mo          - Mean Anomaly
*    MDot        - Mean Anomaly dot (rate)
*    No          - Mean Motion
*    nodeo       - right ascension of ascending node
*    nodeDot     - right ascension of ascending node dot (rate)
*    XPIDOT      -
*    Z1, Z3, Z11, Z13, Z21, Z23, Z31, Z33 -
*    Eccm        - Eccentricity
*    Argpm       - Argument of perigee
*    Inclm       - Inclination
*    Mm          - Mean Anomaly
*    Xn          - Mean Motion
*    nodem       - right ascension of ascending node
*
*  Outputs       :
*    Eccm        - Eccentricity
*    Argpm       - Argument of perigee
*    Inclm       - Inclination
*    Mm          - Mean Anomaly
*    Xn          - Mean motion
*    nodem       - right ascension of ascending node
*    IRez        - Resonance flags              0-none, 1-One day,  2-Half day
*    Atime       -
*    D2201, D2211, D3210, D3222, D4410, D4422, D5220, D5232, D5421, D5433       -
*    Dedt        -
*    Didt        -
*    DMDT        -
*    DNDT        -
*    DNODT       -
*    DOMDT       -
*    Del1, Del2, Del3 -
*    Ses  , Sghl , Sghs , Sgs  , Shl  , Shs  , Sis  , Sls
*    THETA       -
*    Xfact       -
*    Xlamo       -
*    Xli         -
*    Xni
*
*  Locals        :
*    ainv2       -
*    aonv        -
*    cosisq      -
*    eoc         -
*    f220, f221, f311, f321, f322, f330, f441, f442, f522, f523, f542, f543        -
*    g200, g201, g211, g300, g310, g322, g410, g422, g520, g521, g532, g533        -
*    sini2       -
*    temp, temp1 -
*    Theta       -
*    xno2        -
*
*  Coupling      :
*    getgravconst-
*
*  references    :
*    hoots, roehrich, norad spacetrack report #3 1980
*    hoots, norad spacetrack report #6 1986
*    hoots, schumacher and glover 2004
*    vallado, crawford, hujsak, kelso  2006
*------------------------------------------------------------------------------

      SUBROUTINE DSINIT( whichconst,
     &                   Cosim , Emsq  , Argpo , S1    , S2    , S3    ,
     &                   S4    , S5    , Sinim , Ss1   , Ss2   , Ss3   ,
     &                   Ss4   , Ss5   , Sz1   , Sz3   , Sz11  , Sz13  ,
     &                   Sz21  , Sz23  , Sz31  , Sz33  , T     , Tc    ,
     &                   GSTo  , Mo    , MDot  , No    , nodeo ,nodeDot,
     &                   XPIDOT, Z1    , Z3    , Z11   , Z13   , Z21   ,
     &                   Z23   , Z31   , Z33   , Ecco  , EccSq ,
     &                   Eccm  , Argpm , Inclm , Mm    , Xn    , nodem,
     &                   IREZ  , Atime , D2201 , D2211 , D3210 , D3222 ,
     &                   D4410 , D4422 , D5220 , D5232 , D5421 , D5433 ,
     &                   Dedt  , Didt  , DMDT  , DNDT  , DNODT , DOMDT ,
     &                   Del1  , Del2  , Del3  , Xfact , Xlamo , Xli   ,
     &                   Xni )
        IMPLICIT NONE
        INTEGER*4  IRez, whichconst
        REAL*8   Cosim , Emsq  , Argpo , S1    , S2    , S3    , S4    ,
     &           S5    , Sinim , Ss1   , Ss2   , Ss3   , Ss4   , Ss5   ,
     &           Sz1   , Sz3   , Sz11  , Sz13  , Sz21  , Sz23  , Sz31  ,
     &           Sz33  , T     , Tc    , GSTo  , Mo    , MDot  , No    ,
     &           nodeo ,nodeDot,XPIDOT , Z1    , Z3    , Z11   , Z13   ,
     &           Z21   , Z23   , Z31   , Z33   , Eccm  , Argpm , Inclm ,
     &           Mm    , Xn    , nodem , Atime , D2201 , D2211 , D3210 ,
     &           D3222 , D4410 , D4422 , D5220 , D5232 , D5421 , D5433 ,
     &           Dedt  , Didt  , DMDT  , DNDT  , DNODT , DOMDT , Del1  ,
     &           Del2  , Del3  , Xfact , Xlamo , Xli   , Xni   , Ecco  ,
     &           Eccsq

* -------------------------- Local Variables --------------------------
        REAL*8  ainv2 , aonv  , cosisq, eoc   , f220  , f221  , f311  ,
     &          f321  , f322  , f330  , f441  , f442  , f522  , f523  ,
     &          f542  , f543  , g200  , g201  , g211  , g300  , g310  ,
     &          g322  , g410  , g422  , g520  , g521  , g532  , g533  ,
     &          ses   , sgs   , sghl  , sghs  , shs   , shl   , sis   ,
     &          sini2 , sls   , temp  , temp1 , Theta , xno2
        REAL*8  Pi    , Q22   , Q31   , Q33   , ROOT22, ROOT44, ROOT54,
     &          RPTim , Root32, Root52, TWOPI , X2o3  , XKe   , Znl   ,
     &          Zns,  Emo, emsqo , tumin, radiusearthkm, j2, j3, j4, 
     &          j3oj2

        COMMON /DebugHelp/ Help
        CHARACTER Help

        Pi     = 3.14159265358979D0
        Q22    = 1.7891679D-6
        Q31    = 2.1460748D-6
        Q33    = 2.2123015D-7
        ROOT22 = 1.7891679D-6
        ROOT44 = 7.3636953D-9
        ROOT54 = 2.1765803D-9
        RPTim  = 4.37526908801129966D-3 ! this equates to 7.29211514668855e-5 rad/sec
        Root32 = 3.7393792D-7
        Root52 = 1.1428639D-7
        TWOPI  = 6.283185307179586D0
        X2o3   = 2.0D0 / 3.0D0
        ZNL    = 1.5835218D-4
        ZNS    = 1.19459D-5

        ! sgp4fix identify constants and allow alternate values
        CALL getgravconst( whichconst, tumin, radiusearthkm, xke, j2, 
     &       j3, j4, j3oj2 )

* ------------------------ DEEP SPACE INITIALIZATION ------------------
        IREZ = 0
        IF ((XN.lt.0.0052359877D0).AND.(XN.GT.0.0034906585D0)) THEN
            IREZ = 1
          ENDIF
        IF ((XN.ge.8.26D-3).AND.(XN.LE.9.24D-3).AND.(Eccm.GE.0.5D0))THEN
            IREZ = 2
          ENDIF

* ---------------------------- DO SOLAR TERMS -------------------------
        SES  =  SS1*ZNS*SS5
        SIS  =  SS2*ZNS*(SZ11 + SZ13)
        SLS  = -ZNS*SS3*(SZ1 + SZ3 - 14.0D0 - 6.0D0*EMSQ)
        SGHS =  SS4*ZNS*(SZ31 + SZ33 - 6.0D0)
        SHS  = -ZNS*SS2*(SZ21 + SZ23)
c       sgp4fix for 180 deg incl
        IF ((Inclm.lt.5.2359877D-2).or.(Inclm.gt.pi-5.2359877D-2)) THEN
            SHS = 0.0D0
          ENDIF
        IF (SINIM.ne.0.0D0) THEN
            SHS = SHS/SINIM
          ENDIF
        SGS  = SGHS - COSIM*SHS

* ----------------------------- DO LUNAR TERMS ------------------------
        DEDT = SES + S1*ZNL*S5
        DIDT = SIS + S2*ZNL*(Z11 + Z13)
        DMDT = SLS - ZNL*S3*(Z1 + Z3 - 14.0D0 - 6.0D0*EMSQ)
        SGHL = S4*ZNL*(Z31 + Z33 - 6.0D0)
        SHL  = -ZNL*S2*(Z21 + Z23)
c       sgp4fix for 180 deg incl
        IF ((Inclm.lt.5.2359877D-2).or.(Inclm.gt.pi-5.2359877D-2)) THEN
            SHL = 0.0D0
          ENDIF
        DOMDT= SGS+SGHL
        DNODT= SHS
        IF (SINIM .ne. 0.0D0) THEN
            DOMDT = DOMDT-COSIM/SINIM*SHL
            DNODT = DNODT+SHL/SINIM
        ENDIF

* --------------- CALCULATE DEEP SPACE RESONANCE EFFECTS --------------
        DNDT  = 0.0D0
        THETA = DMOD(GSTo + TC*RPTIM,TwoPi)
        Eccm  = Eccm + DEDT*T
        emsq  = eccm**2
        Inclm = Inclm + DIDT*T
        Argpm = Argpm + DOMDT*T
        nodem = nodem + DNODT*T
        Mm    = Mm + DMDT*T
c   sgp4fix for negative inclinations
c   the following if statement should be commented out
c           IF(Inclm .lt. 0.0D0) THEN
c             Inclm  = -Inclm
c             Argpm  = Argpm-PI
c             nodem = nodem+PI
c           ENDIF

* ------------------ Initialize the resonance terms -------------------
        IF (IREZ .ne. 0) THEN
            AONV = (XN/XKE)**X2O3

* -------------- GEOPOTENTIAL RESONANCE FOR 12 HOUR ORBITS ------------
        IF (IREZ .eq. 2) THEN
            COSISQ = COSIM*COSIM
            emo    = Eccm
            emsqo  = emsq
            Eccm   = ecco
            emsq   = eccsq
            EOC    = Eccm*EMSQ
            G201   = -0.306D0-(Eccm-0.64D0)*0.440D0
            IF (Eccm.le.0.65D0) THEN
                G211 =   3.616D0 -  13.2470D0*Eccm +  16.2900D0*EMSQ
                G310 = -19.302D0 + 117.3900D0*Eccm - 228.4190D0*EMSQ +
     &                 156.591D0*EOC
                G322 = -18.9068D0+ 109.7927D0*Eccm - 214.6334D0*EMSQ +
     &                 146.5816D0*EOC
                G410 = -41.122D0 + 242.6940D0*Eccm - 471.0940D0*EMSQ +
     &                 313.953D0*EOC
                G422 =-146.407D0 + 841.8800D0*Eccm - 1629.014D0*EMSQ +
     &                1083.435D0*EOC
                G520 =-532.114D0 + 3017.977D0*Eccm - 5740.032D0*EMSQ +
     &                3708.276D0*EOC
              ELSE
                G211 =  -72.099D0 +  331.819D0*Eccm -  508.738D0*EMSQ +
     &                  266.724D0*EOC
                G310 = -346.844D0 + 1582.851D0*Eccm - 2415.925D0*EMSQ +
     &                 1246.113D0*EOC
                G322 = -342.585D0 + 1554.908D0*Eccm - 2366.899D0*EMSQ +
     &                 1215.972D0*EOC
                G410 =-1052.797D0 + 4758.686D0*Eccm - 7193.992D0*EMSQ +
     &                 3651.957D0*EOC
                G422 =-3581.690D0 + 16178.11D0*Eccm - 24462.77D0*EMSQ +
     &                12422.52D0*EOC
                IF (Eccm.gt.0.715D0) THEN
                    G520 =-5149.66D0 + 29936.92D0*Eccm -54087.36D0*EMSQ
     &                    + 31324.56D0*EOC
                  ELSE
                    G520 = 1464.74D0 -  4664.75D0*Eccm + 3763.64D0*EMSQ
                  ENDIF
              ENDIF
            IF (Eccm.lt.0.7D0) THEN
                G533 = -919.22770D0 + 4988.6100D0*Eccm-9064.7700D0*EMSQ
     &               + 5542.21D0*EOC
                G521 = -822.71072D0 + 4568.6173D0*Eccm-8491.4146D0*EMSQ
     &               + 5337.524D0*EOC
                G532 = -853.66600D0 + 4690.2500D0*Eccm-8624.7700D0*EMSQ
     &               + 5341.4D0*EOC
              ELSE
                G533 =-37995.780D0 + 161616.52D0*Eccm-229838.20D0*EMSQ+
     &              109377.94D0*EOC
                G521 =-51752.104D0 + 218913.95D0*Eccm-309468.16D0*EMSQ+
     &              146349.42D0*EOC
                G532 =-40023.880D0 + 170470.89D0*Eccm-242699.48D0*EMSQ+
     &              115605.82D0*EOC
              ENDIF
            SINI2 =  SINIM*SINIM
            F220  =  0.75D0* (1.0D0+2.0D0*COSIM+COSISQ)
            F221  =  1.5D0*SINI2
            F321  =  1.875D0*SINIM * (1.0D0-2.0D0*COSIM-3.0D0*COSISQ)
            F322  = -1.875D0*SINIM * (1.0D0+2.0D0*COSIM-3.0D0*COSISQ)
            F441  = 35.0D0*SINI2*F220
            F442  = 39.3750D0*SINI2*SINI2
            F522  =  9.84375D0*SINIM * (SINI2* (1.0D0-2.0D0*COSIM-
     &               5.0D0*COSISQ)+0.33333333D0 * (-2.0D0+4.0D0*COSIM+
     &               6.0D0*COSISQ) )
            F523  =  SINIM * (4.92187512D0*SINI2 * (-2.0D0-4.0D0*COSIM+
     &               10.0D0*COSISQ) + 6.56250012D0*
     &               (1.0D0+2.0D0*COSIM-3.0D0*COSISQ))
            F542  =  29.53125D0*SINIM * (2.0D0-8.0D0*COSIM+COSISQ*
     &               (-12.0D0+8.0D0*COSIM+10.0D0*COSISQ) )
            F543  = 29.53125D0*SINIM * (-2.0D0-8.0D0*COSIM+COSISQ*
     &               (12.0D0+8.0D0*COSIM-10.0D0*COSISQ) )

            XNO2   =  XN * XN
            AINV2  =  AONV * AONV
            TEMP1  =  3.0D0*XNO2*AINV2
            TEMP   =  TEMP1*ROOT22
            D2201  =  TEMP*F220*G201
            D2211  =  TEMP*F221*G211
            TEMP1  =  TEMP1*AONV
            TEMP   =  TEMP1*ROOT32
            D3210  =  TEMP*F321*G310
            D3222  =  TEMP*F322*G322
            TEMP1  =  TEMP1*AONV
            TEMP   =  2.0D0*TEMP1*ROOT44
            D4410  =  TEMP*F441*G410
            D4422  =  TEMP*F442*G422
            TEMP1  =  TEMP1*AONV
            TEMP   =  TEMP1*ROOT52
            D5220  =  TEMP*F522*G520
            D5232  =  TEMP*F523*G532
            TEMP   =  2.0D0*TEMP1*ROOT54
            D5421  =  TEMP*F542*G521
            D5433  =  TEMP*F543*G533
            XLAMO  =  DMOD(Mo+nodeo+nodeo-THETA-THETA,TwoPi)
            XFACT  = MDot + DMDT + 2.0D0 * (nodeDot+DNODT-RPTIM) - No

            Eccm = emo
            emsq = emsqo
          ENDIF

        IF (Irez .eq. 1) THEN
* -------------------- SYNCHRONOUS RESONANCE TERMS --------------------
            G200  = 1.0D0 + EMSQ * (-2.5D0+0.8125D0*EMSQ)
            G310  = 1.0D0 + 2.0D0*EMSQ
            G300  = 1.0D0 + EMSQ * (-6.0D0+6.60937D0*EMSQ)
            F220  = 0.75D0 * (1.0D0+COSIM) * (1.0D0+COSIM)
            F311  = 0.9375D0*SINIM*SINIM*
     &               (1.0D0+3.0D0*COSIM) - 0.75D0*(1.0D0+COSIM)
            F330  = 1.0D0+COSIM
            F330  = 1.875D0*F330*F330*F330
            DEL1  = 3.0D0*XN*XN*AONV*AONV
            DEL2  = 2.0D0*DEL1*F220*G200*Q22
            DEL3  = 3.0D0*DEL1*F330*G300*Q33*AONV
            DEL1  = DEL1*F311*G310*Q31*AONV
            XLAMO = DMOD(Mo+nodeo+Argpo-THETA,TwoPi)
            XFACT = MDot + XPIDOT - RPTIM + DMDT + DOMDT + DNODT - No
          ENDIF

* ---------------- FOR SGP4, INITIALIZE THE INTEGRATOR ----------------
         XLI   = XLAMO
         XNI   = No
         ATIME = 0.0D0
         XN    = No + DNDT
      ENDIF ! Ires non-zero

c        INCLUDE 'debug3.for'

      RETURN
      END  ! end dsinit


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE DSPACE
*
*  This Subroutine provides deep space contributions to mean elements for
*    perturbing third body.  these effects have been averaged over one
*    revolution of the sun and moon.  for earth resonance effects, the
*    effects have been averaged over no revolutions of the satellite.
*    (mean motion)
*
*  author        : david vallado                  719-573-2600   28 jun 2005
*
*  inputs        :
*    d2201, d2211, d3210, d3222, d4410, d4422, d5220, d5232, d5421, d5433       -
*    dedt        -
*    del1, del2, del3  -
*    didt        -
*    dmdt        -
*    dnodt       -
*    domdt       -
*    irez        - flag for resonance           0-none, 1-one day, 2-half day
*    argpo       - argument of perigee
*    argpdot     - argument of perigee dot (rate)
*    t           - time
*    tc          -
*    gsto        - gst
*    xfact       -
*    xlamo       -
*    no          - mean motion
*    atime       -
*    em          - eccentricity
*    ft          -
*    argpm       - argument of perigee
*    inclm       - inclination
*    xli         -
*    mm          - mean anomaly
*    xni         - mean motion
*    nodem       - right ascension of ascending node
*
*  outputs       :
*    atime       -
*    em          - eccentricity
*    argpm       - argument of perigee
*    inclm       - inclination
*    xli         -
*    mm          - mean anomaly
*    xni         -
*    nodem       - right ascension of ascending node
*    dndt        -
*    nm          - mean motion
*
*  locals        :
*    delt        -
*    ft          -
*    theta       -
*    x2li        -
*    x2omi       -
*    xl          -
*    xldot       -
*    xnddt       -
*    xndt        -
*    xomi        -
*
*  coupling      :
*    none        -
*
*  references    :
*    hoots, roehrich, norad spacetrack report #3 1980
*    hoots, norad spacetrack report #6 1986
*    hoots, schumacher and glover 2004
*    vallado, crawford, hujsak, kelso  2006
*------------------------------------------------------------------------------

      SUBROUTINE DSPACE( IRez  , D2201 , D2211 , D3210 , D3222 , D4410 ,
     &                   D4422 , D5220 , D5232 , D5421 , D5433 , Dedt  ,
     &                   Del1  , Del2  , Del3  , Didt  , Dmdt  , Dnodt ,
     &                   Domdt , Argpo , ArgpDot, T    , TC    , GSTo  ,
     &                   Xfact , Xlamo , No    ,
     &                   Atime , Eccm  , Argpm , Inclm , Xli   , Mm  ,
     &                   XNi   , nodem, Dndt  , XN  )
        IMPLICIT NONE
        INTEGER*4  IRez
        Real*8   D2201 , D2211 , D3210 , D3222 , D4410 , D4422 , D5220 ,
     &           D5232 , D5421 , D5433 , Dedt  , Del1  , Del2  , Del3  ,
     &           Didt  , Dmdt  , Dnodt , Domdt , Argpo , ArgpDot,T     ,
     &           TC    , GSTo  , Xfact , Xlamo , No    , Atime , Eccm  ,
     &           Argpm , Inclm , Xli   , Mm    , Xni   , nodem, Dndt  ,
     &           XN

* -------------------------- Local Variables --------------------------
        INTEGER*4  iretn , iret
        REAL*8   Delt  , Ft    , theta , x2li  , x2omi , xl    , xldot ,
     &           xnddt , xndt  , xomi
        REAL*8   G22   , G32   , G44   , G52   , G54   , Pi    , Fasx2 ,
     &           Fasx4 , Fasx6 , RPtim , Step2 , Stepn , Stepp , TwoPi

        COMMON /DebugHelp/ Help
        CHARACTER Help

* ----------------------------- Constants -----------------------------
        FASX2 = 0.13130908D0
        FASX4 = 2.8843198D0
        FASX6 = 0.37448087D0
        G22   = 5.7686396D0
        G32   = 0.95240898D0
        G44   = 1.8014998D0
        G52   = 1.0508330D0
        G54   = 4.4108898D0
        Pi    = 3.14159265358979D0
        RPTIM = 4.37526908801129966D-3
        STEPP =    720.0D0
        STEPN =   -720.0D0
        STEP2 = 259200.0D0
        TwoPi = 6.283185307179586D0

* --------------- CALCULATE DEEP SPACE RESONANCE EFFECTS --------------
        DNDT  = 0.0D0
        THETA = DMOD(GSTo + TC*RPTIM,TwoPi)
        Eccm  = Eccm + DEDT*T

        Inclm = Inclm + DIDT*T
        Argpm = Argpm + DOMDT*T
        nodem = nodem + DNODT*T
        Mm    = Mm + DMDT*T

c   sgp4fix for negative inclinations
c   the following if statement should be commented out
c        IF(Inclm .lt. 0.0D0) THEN
c            Inclm  = -Inclm
c            Argpm  = Argpm-PI
c            nodem = nodem+PI
c          ENDIF

c   sgp4fix for propagator problems
c   the following integration works for negative time steps and periods
c   the specific changes are unknown because the original code was so convoluted
        Ft    = 0.0D0      ! Just in case - should be set in loops if used.
        ATime = 0.0D0

        IF (IREZ .ne. 0) THEN
* ----- UPDATE RESONANCES : NUMERICAL (EULER-MACLAURIN) INTEGRATION ---
* ---------------------------- EPOCH RESTART --------------------------
            IF ( (ATIME.EQ.0.0D0)  .or.
     &           ((T.GE.0.0D0) .AND. (ATIME.lt.0.0D0)) .or.
     &           ((T.lt.0.0D0) .AND. (ATIME.GE.0.0D0)) ) THEN
                IF (T.GE.0.0D0) THEN
                    DELT = STEPp
                  ELSE
                    Delt = Stepn
                  ENDIF
                ATIME = 0.0D0
                XNI   = No
                XLI   = XLAMO
              ENDIF
            iretn = 381 ! added for do loop
            iret  =   0 ! added for loop
            DO WHILE (IRetn.eq.381)
                IF ( (DABS(T).lt.DABS(ATIME)).or.(Iret.eq.351) ) THEN
                    IF (T.GE.0.0D0) THEN
                        DELT = STEPN
                      ELSE
                        Delt = Stepp
                      ENDIF
                    IRET  = 351
                    IRETN = 381
                  ELSE
                    IF (T.GT.0.0D0) THEN ! Error if prev IF has Atime=0.0 and t=0.0 (ge)
                        DELT = STEPP
                      ELSE
                        Delt = Stepn
                      ENDIF
                    IF (DABS(T-ATIME).ge.STEPP) THEN
                        IRET  = 0
                        IRETN = 381
                      ELSE
                        FT    = T-ATIME
                        IRETN = 0
                      ENDIF
                  ENDIF

* --------------------------- DOT TERMS CALCULATED --------------------
* ------------------- NEAR - SYNCHRONOUS RESONANCE TERMS --------------
            IF (IREZ .ne. 2) THEN
                XNDT  = DEL1*DSIN(XLI-FASX2) +
     &                  DEL2*DSIN(2.0D0*(XLI-FASX4)) +
     &                  DEL3*DSIN(3.0D0*(XLI-FASX6))
                XLDOT = XNI + XFACT
                XNDDT = DEL1*DCOS(XLI-FASX2) +
     &            2.0D0*DEL2*DCOS(2.0D0*(XLI-FASX4)) +
     &            3.0D0*DEL3*DCOS(3.0D0*(XLI-FASX6))
                XNDDT = XNDDT*XLDOT
              ELSE

* --------------------- NEAR - HALF-DAY RESONANCE TERMS ---------------
                XOMI = Argpo + ArgpDot*ATIME
                X2OMI= XOMI + XOMI
                X2LI = XLI + XLI
                XNDT = D2201*DSIN(X2OMI+XLI-G22) + D2211*DSIN(XLI-G22) +
     &                 D3210*DSIN( XOMI+XLI-G32) +
     &                 D3222*DSIN(-XOMI+XLI-G32) +
     &                 D4410*DSIN(X2OMI+X2LI-G44)+ D4422*DSIN(X2LI-G44)+
     &                 D5220*DSIN( XOMI+XLI-G52) +
     &                 D5232*DSIN(-XOMI+XLI-G52) +
     &                 D5421*DSIN( XOMI+X2LI-G54)+
     &                 D5433*DSIN(-XOMI+X2LI-G54)
                XLDOT = XNI+XFACT
                XNDDT = D2201*DCOS(X2OMI+XLI-G22) + D2211*DCOS(XLI-G22)+
     &                  D3210*DCOS( XOMI+XLI-G32) +
     &                  D3222*DCOS(-XOMI+XLI-G32) +
     &                  D5220*DCOS( XOMI+XLI-G52) +
     &                  D5232*DCOS(-XOMI+XLI-G52) +
     &                  2.0D0*(D4410*DCOS(X2OMI+X2LI-G44) +
     &                  D4422*DCOS(X2LI-G44) +
     &                  D5421*DCOS( XOMI+X2LI-G54) +
     &                  D5433*DCOS(-XOMI+X2LI-G54))
                XNDDT = XNDDT*XLDOT
              ENDIF

* ------------------------------- INTEGRATOR --------------------------
                IF (IRETN.EQ.381) THEN
                    XLI   = XLI + XLDOT*DELT + XNDT*STEP2
                    XNI   = XNI + XNDT*DELT + XNDDT*STEP2
                    ATIME = ATIME + DELT
                  ENDIF

              ENDDO

            XN = XNI + XNDT*FT  + XNDDT*FT*FT*0.5D0
            XL = XLI + XLDOT*FT + XNDT*FT*FT*0.5D0
            IF(IREZ .ne. 1) THEN
                Mm   = XL-2.0D0*nodem+2.0D0*THETA
                DNDT = XN-No
              ELSE
                Mm   = XL-nodem-Argpm+THETA
                DNDT = XN-No
              ENDIF

            XN = No + DNDT
          ENDIF

c        INCLUDE 'debug4.for' 

      RETURN
      END  ! end dspace


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE INITL
*
*  this subroutine initializes the spg4 propagator. all the initialization is
*    consolidated here instead of having multiple loops inside other routines.
*
*  author        : david vallado                  719-573-2600   28 jun 2005
*
*  inputs        :
*    ecco        - eccentricity                           0.0 - 1.0
*    epoch       - epoch time in days from jan 0, 1950. 0 hr
*    inclo       - inclination of satellite
*    no          - mean motion of satellite
*    satn        - satellite number
*
*  outputs       :
*    ainv        - 1.0 / a
*    ao          - semi major axis
*    con41       -
*    con42       - 1.0 - 5.0 cos(i)
*    cosio       - cosine of inclination
*    cosio2      - cosio squared
*    eccsq       - eccentricity squared
*    method      - flag for deep space                    'd', 'n'
*    omeosq      - 1.0 - ecco * ecco
*    posq        - semi-parameter squared
*    rp          - radius of perigee
*    rteosq      - square root of (1.0 - ecco*ecco)
*    sinio       - sine of inclination
*    gsto        - gst at time of observation               rad
*    no          - mean motion of satellite
*
*  locals        :
*    ak          -
*    d1          -
*    del         -
*    adel        -
*    po          -
*
*  coupling      :
*    getgravconst-
*
*  references    :
*    hoots, roehrich, norad spacetrack report #3 1980
*    hoots, norad spacetrack report #6 1986
*    hoots, schumacher and glover 2004
*    vallado, crawford, hujsak, kelso  2006
*------------------------------------------------------------------------------

      SUBROUTINE INITL( Satn , whichconst, Ecco  , EPOCH , Inclo , No,
     &         Method, AINV  , AO    , CON41 , CON42 , COSIO , COSIO2,
     &         Eccsq , OMEOSQ, POSQ  , rp    , RTEOSQ, SINIO ,
     &         GSTo )
        IMPLICIT NONE
        CHARACTER Method
        INTEGER*4 Satn, whichconst
        REAL*8 Ecco  , EPOCH , Inclo , No   ,
     &         AINV  , AO    , CON41 , CON42 , COSIO , COSIO2, 
     &         Eccsq , OMEOSQ, POSQ  , rp    , RTEOSQ, SINIO , GSTo

        COMMON /DebugHelp/ Help
        CHARACTER Help

* -------------------------- Local Variables --------------------------
cdav old way
c        INTEGER*4 ids70
c        real*8 ts70, ds70, tfrac, c1, thgr70, fk5r, c1p2p, thgr, thgro,
c     &     twopi
        REAL*8 TwoPi, RadPerDay, Temp, TUT1
        REAL*8  ak, d1, del, adel, po
        REAL*8  X2o3, J2, XKE, tumin, radiusearthkm, j3, j4, j3oj2

* ------------------------ WGS-72 EARTH CONSTANTS ---------------------
        X2o3   = 2.0D0/3.0D0
        ! sgp4fix identify constants and allow alternate values
        CALL getgravconst( whichconst, tumin, radiusearthkm, xke, j2, 
     &       j3, j4, j3oj2 )

* ----------------- CALCULATE AUXILLARY EPOCH QUANTITIES --------------
        Eccsq  = Ecco*Ecco
        OMEOSQ = 1.0D0 - Eccsq
        RTEOSQ = DSQRT(OMEOSQ)
        COSIO  = DCOS(Inclo)
        COSIO2 = COSIO*COSIO

* ---------------------- UN-KOZAI THE MEAN MOTION ---------------------
        AK   =  (XKE/No)**X2O3
        D1   =  0.75D0*J2* (3.0D0*COSIO2-1.0D0) / (RTEOSQ*OMEOSQ)
        DEL  =  D1/(AK*AK)
        ADEL =  AK * ( 1.0D0 - DEL*DEL - DEL*
     &                 (1.0D0/3.0D0 + 134.0D0*DEL*DEL / 81.0D0) )
        DEL  =  D1/(ADEL*ADEL)
        No   =  No/(1.0D0 + DEL)

        AO   =  (XKE/No)**X2O3
        SINIO=  DSIN(Inclo)
        PO   =  AO*OMEOSQ
        CON42=  1.0D0-5.0D0*COSIO2
        CON41=  -CON42-COSIO2-COSIO2
        AINV =  1.0D0/AO
        POSQ =  PO*PO
        rp   =  AO*(1.0D0-Ecco)
        METHOD = 'n'

* ----------------- CALCULATE GREENWICH LOCATION AT EPOCH -------------
cdav new approach using JD
        TwoPi      = 6.28318530717959D0
        RadPerDay  = 6.30038809866574D0
        Temp = Epoch + 2433281.5D0

        TUT1= ( DINT(Temp-0.5D0) + 0.5D0 - 2451545.0D0 ) / 36525.0D0
        Gsto= 1.75336855923327D0 + 628.331970688841D0*TUT1
     &          + 6.77071394490334D-06*TUT1*TUT1
     &          - 4.50876723431868D-10*TUT1*TUT1*TUT1
     &          + RadPerDay*( Temp-0.5D0-DINT(Temp-0.5D0) )

        ! ------------------------ Check quadrants ---------------------
        Gsto = DMOD( Gsto,TwoPi )
        IF ( Gsto .lt. 0.0D0 ) THEN
            Gsto= Gsto + TwoPi
          ENDIF

*     CALCULATE NUMBER OF INTEGER*4 DAYS SINCE 0 JAN 1970.
cdav    old way
c      TS70 =EPOCH-7305.D0
c      IDS70=TS70 + 1.D-8
c      DS70 =IDS70
c      TFRAC=TS70-DS70
*     CALCULATE GREENWICH LOCATION AT EPOCH
c      C1    = 1.72027916940703639D-2
c      THGR70= 1.7321343856509374D0
c      FK5R  = 5.07551419432269442D-15
c      twopi = 6.283185307179586D0
c      C1P2P = C1+TWOPI
c      THGR  = DMOD(THGR70+C1*DS70+C1P2P*TFRAC+TS70*TS70*FK5R,twopi)
c      THGRO = DMOD(THGR,twopi)
c      gsto  = thgro
c      write(*,*) Satn,'  gst delta ', gsto-gsto1

c        INCLUDE 'debug5.for' 

      RETURN
      END  ! end initl


* -----------------------------------------------------------------------------
*
*                             SUBROUTINE SGP4INIT
*
*  This subroutine initializes variables for SGP4.
*
*  author        : david vallado                  719-573-2600   28 jun 2005
*
*  inputs        :
*    satn        - satellite number
*    bstar       - sgp4 type drag coefficient              kg/m2er
*    ecco        - eccentricity
*    epoch       - epoch time in days from jan 0, 1950. 0 hr
*    argpo       - argument of perigee (output if ds)
*    inclo       - inclination
*    mo          - mean anomaly (output if ds)
*    no          - mean motion
*    nodeo      - right ascension of ascending node
*
*  outputs       :
*    satrec      - common block values for subsequent calls
*    return code - non-zero on error.
*                   1 - mean elements, ecc >= 1.0 or ecc < -0.001 or a < 0.95 er
*                   2 - mean motion less than 0.0
*                   3 - pert elements, ecc < 0.0  or  ecc > 1.0
*                   4 - semi-latus rectum < 0.0
*                   5 - epoch elements are sub-orbital
*                   6 - satellite has decayed
*
*  locals        :
*    CNODM  , SNODM  , COSIM  , SINIM  , COSOMM , SINOMM
*    Cc1sq  , Cc2    , Cc3
*    Coef   , Coef1
*    cosio4      -
*    day         -
*    dndt        -
*    em          - eccentricity
*    emsq        - eccentricity squared
*    eeta        -
*    etasq       -
*    gam         -
*    argpm       - argument of perigee
*    ndem        -
*    inclm       - inclination
*    mm          - mean anomaly
*    nm          - mean motion
*    perige      - perigee
*    pinvsq      -
*    psisq       -
*    qzms24      -
*    rtemsq      -
*    s1, s2, s3, s4, s5, s6, s7          -
*    sfour       -
*    ss1, ss2, ss3, ss4, ss5, ss6, ss7         -
*    sz1, sz2, sz3
*    sz11, sz12, sz13, sz21, sz22, sz23, sz31, sz32, sz33        -
*    tc          -
*    temp        -
*    temp1, temp2, temp3       -
*    tsi         -
*    xpidot      -
*    xhdot1      -
*    z1, z2, z3          -
*    z11, z12, z13, z21, z22, z23, z31, z32, z33         -
*
*  coupling      :
*    getgravconst-
*    initl       -
*    dscom       -
*    dpper       -
*    dsinit      -
*
*  references    :
*    hoots, roehrich, norad spacetrack report #3 1980
*    hoots, norad spacetrack report #6 1986
*    hoots, schumacher and glover 2004
*    vallado, crawford, hujsak, kelso  2006
* ---------------------------------------------------------------------------- }

      SUBROUTINE SGP4Init ( whichconst,
     &                      Satn,   xBStar, xEcco,  Epoch, xArgpo,
     &                      xInclo, xMo,    xNo,    xnodeo, Error )
        IMPLICIT NONE
        INTEGER*4 Satn, error, whichconst
        REAL*8  xBStar, xEcco, Epoch, xArgpo, xInclo, xMo, xNo, xnodeo
        REAL*8 T, r(3), v(3)

        INCLUDE 'SGP4.CMN'

        COMMON /DebugHelp/ Help
        CHARACTER Help

* -------------------------- Local Variables --------------------------

        REAL*8  Ao,ainv,con42,cosio,sinio,cosio2,Eccsq,omeosq,
     &          posq,rp,rteosq, CNODM , SNODM , COSIM , SINIM , COSOMM,
     &          SINOMM, Cc1sq ,
     &          Cc2   , Cc3   , Coef  , Coef1 , Cosio4, DAY   , Dndt  ,
     &          Eccm  , EMSQ  , Eeta  , Etasq , GAM   , Argpm , nodem,
     &          Inclm , Mm  , Xn    , Perige, Pinvsq, Psisq , Qzms24,
     &          RTEMSQ, S1    , S2    , S3    , S4    , S5    , S6    ,
     &          S7    , SFour , SS1   , SS2   , SS3   , SS4   , SS5   ,
     &          SS6   , SS7   , SZ1   , SZ2   , SZ3   , SZ11  , SZ12  ,
     &          SZ13  , SZ21  , SZ22  , SZ23  , SZ31  , SZ32  , SZ33  ,
     &          Tc    , Temp  , Temp1 , Temp2 , Temp3 , Tsi   , XPIDOT,
     &          Xhdot1, Z1    , Z2    , Z3    , Z11   , Z12   , Z13   ,
     &          Z21   , Z22   , Z23   , Z31   , Z32   , Z33 
        REAL*8  qzms2t, SS, RadiusEarthKm, twopi, J2,pi,j3oJ2,J4,X2o3,
     &          temp4, j3, xke, tumin

* ---------------------------- INITIALIZATION -------------------------
        method = 'n'
c       clear sgp4 flag
        Error = 0

c      sgp4fix - note the following variables are also passed directly via sgp4 common. 
c      it is possible to streamline the sgp4init call by deleting the "x"
c      variables, but the user would need to set the common values first. we
c      include the additional assignment in case twoline2rv is not used. 
 
        bstar  = xbstar
        ecco   = xecco
        argpo  = xargpo
        inclo  = xinclo
        mo     = xmo
        no     = xno
        nodeo  = xnodeo

        ! sgp4fix identify constants and allow alternate values
        CALL getgravconst( whichconst, tumin, radiusearthkm, xke, j2, 
     &       j3, j4, j3oj2 )

        SS     = 78.0D0/RadiusEarthKm + 1.0D0
        QZMS2T = ((120.0D0-78.0D0)/RadiusEarthKm) ** 4
        TwoPi  =  6.283185307179586D0
        pi     =  3.14159265358979D0
        X2o3   =  2.0D0 / 3.0D0
        temp4  =  1.0D0 + dcos(pi-1.0d-9)

        Init = 'y'
        T = 0.0D0

        CALL INITL( Satn , whichconst, Ecco  , EPOCH , Inclo , No,
     &     Method, AINV  , AO    , CON41 , CON42 , COSIO , COSIO2,
     &     Eccsq , OMEOSQ, POSQ  , rp    , RTEOSQ, SINIO ,
     &     GSTo )

        IF(rp .lt. 1.0D0) THEN
c            Write(*,*) '# *** SATN',Satn,' EPOCH ELTS SUB-ORBITAL *** '
            Error = 5
          ENDIF

        IF(OMEOSQ .ge. 0.0D0 .OR. No .ge. 0.0D0) THEN
            ISIMP = 0
            IF (rp .lt. (220.0D0/RadiusEarthKm+1.0D0)) THEN
                ISIMP = 1
              ENDIF
            SFour  = SS
            QZMS24 = QZMS2T
            PERIGE = (rp-1.0D0)*RadiusEarthKm

* ----------- For perigees below 156 km, S and Qoms2t are altered -----
            IF(PERIGE .lt. 156.0D0) THEN
                SFour = PERIGE-78.0D0
                IF(PERIGE .le. 98.0D0) THEN
                    SFour = 20.0D0
                  ENDIF
                QZMS24 = ( (120.0D0-SFour)/RadiusEarthKm )**4
                SFour  = SFour/RadiusEarthKm + 1.0D0
              ENDIF
            PINVSQ = 1.0D0/POSQ

            TSI    = 1.0D0/(AO-SFour)
            ETA    = AO*Ecco*TSI
            ETASQ  = ETA*ETA
            EETA   = Ecco*ETA
            PSISQ  = DABS(1.0D0-ETASQ)
            COEF   = QZMS24*TSI**4
            COEF1  = COEF/PSISQ**3.5D0
            CC2    = COEF1*No* (AO* (1.0D0+1.5D0*ETASQ+EETA*
     &               (4.0D0+ETASQ) )+0.375D0*
     &         J2*TSI/PSISQ*CON41*(8.0D0+3.0D0*ETASQ*(8.0D0+ETASQ)))
            CC1    = BSTAR*CC2
            CC3    = 0.0D0
            IF(Ecco .GT. 1.0D-4) THEN
                CC3 = -2.0D0*COEF*TSI*J3OJ2*No*SINIO/Ecco
              ENDIF
            X1MTH2 = 1.0D0-COSIO2
            CC4    = 2.0D0*No*COEF1*AO*OMEOSQ*(ETA*(2.0D0+0.5D0*ETASQ)
     &              +Ecco*(0.5D0 + 2.0D0*ETASQ) - J2*TSI / (AO*PSISQ)*
     &              (-3.0D0*CON41*(1.0D0-2.0D0*
     &       EETA+ETASQ*(1.5D0-0.5D0*EETA))+0.75D0*X1MTH2*(2.0D0*ETASQ
     &       -EETA*(1.0D0+ETASQ))*DCOS(2.0D0*Argpo)))
            CC5    = 2.0D0*COEF1*AO*OMEOSQ* (1.0D0 + 2.75D0*
     &               (ETASQ + EETA) + EETA*ETASQ )
            COSIO4 = COSIO2*COSIO2
            TEMP1  = 1.5D0*J2*PINVSQ*No
            TEMP2  = 0.5D0*TEMP1*J2*PINVSQ
            TEMP3  = -0.46875D0*J4*PINVSQ*PINVSQ*No
            MDot   = No + 0.5D0*TEMP1*RTEOSQ*CON41 + 0.0625D0*TEMP2*
     &               RTEOSQ*(13.0D0 - 78.0D0*COSIO2 + 137.0D0*COSIO4)
            ArgpDot= -0.5D0*TEMP1*CON42 + 0.0625D0*TEMP2*
     &               (7.0D0 - 114.0D0*COSIO2 +
     &        395.0D0*COSIO4)+TEMP3*(3.0D0-36.0D0*COSIO2+49.0D0*COSIO4)
            XHDOT1 = -TEMP1*COSIO
            nodeDot = XHDOT1+(0.5D0*TEMP2*(4.0D0-19.0D0*COSIO2)+
     &                 2.0D0*TEMP3*(3.0D0 - 7.0D0*COSIO2))*COSIO
            XPIDOT = ArgpDot+nodeDot
            OMGCOF = BSTAR*CC3*DCOS(Argpo)
            XMCOF  = 0.0D0
            IF(Ecco .GT. 1.0D-4) THEN
                XMCOF = -X2O3*COEF*BSTAR/EETA
              ENDIF
            XNODCF = 3.5D0*OMEOSQ*XHDOT1*CC1
            T2COF  = 1.5D0*CC1
c           sgp4fix for divide by zero with xinco = 180 deg
            if (dabs(cosio+1.0).gt. 1.5d-12) THEN
                XLCOF  = -0.25D0*J3OJ2*SINIO*
     &                   (3.0D0+5.0D0*COSIO)/(1.0D0+COSIO)
              else
                XLCOF  = -0.25D0*J3OJ2*SINIO*
     &                   (3.0D0+5.0D0*COSIO)/temp4
              ENDIF
            AYCOF  = -0.5D0*J3OJ2*SINIO
            DELMO  = (1.0D0+ETA*DCOS(Mo))**3
            SINMAO = DSIN(Mo)
            X7THM1 = 7.0D0*COSIO2-1.0D0

* ------------------------ Deep Space Initialization ------------------
            IF ((TWOPI/No) .ge. 225.0D0) THEN
                METHOD = 'd'
                ISIMP  = 1
                TC     = 0.0D0
                Inclm  = Inclo
                CALL DSCOM( EPOCH     , Ecco  , Argpo , Tc    , Inclo ,
     &                  nodeo, No    ,
     &                  SNODM , CNODM , SINIM , COSIM , SINOMM, COSOMM,
     &                  DAY   , E3    , Ee2   , Eccm  , EMSQ  , GAM   ,
     &                  Peo   , Pgho  , Pho   , PInco , Plo   ,
     &                  RTemSq, Se2   , Se3   , Sgh2  , Sgh3  , Sgh4  ,
     &                  Sh2   , Sh3   , Si2   , Si3   , Sl2   , Sl3   ,
     &                  Sl4   , S1    , S2    , S3    , S4    , S5    ,
     &                  S6    , S7    , SS1   , SS2   , SS3   , SS4   ,
     &                  SS5   , SS6   , SS7   , SZ1   , SZ2   , SZ3   ,
     &                  SZ11  , SZ12  , SZ13  , SZ21  , SZ22  , SZ23  ,
     &                  SZ31  , SZ32  , SZ33  , Xgh2  , Xgh3  , Xgh4  ,
     &                  Xh2   , Xh3   , Xi2   , Xi3   , Xl2   , Xl3   ,
     &                  Xl4   , Xn    , Z1    , Z2    , Z3    , Z11   ,
     &                  Z12   , Z13   , Z21   , Z22   , Z23   , Z31   ,
     &                  Z32   , Z33   , Zmol  , Zmos )
                CALL DPPER( e3, ee2   , peo   , pgho  , pho   , pinco ,
     &                  plo   , se2   , se3   , sgh2  , sgh3  , sgh4  ,
     &                  sh2   , sh3   , si2   , si3   , sl2   , sl3   ,
     &                  sl4   , T     , xgh2  , xgh3  , xgh4  , xh2   ,
     &                  xh3   , xi2   , xi3   , xl2   , xl3   , xl4   ,
     &                  zmol  , zmos  , Inclm , init  ,
     &                  Ecco  , Inclo , nodeo, Argpo , Mo )

                Argpm  = 0.0D0 ! add for DS to work initial
                nodem  = 0.0D0
                Mm     = 0.0D0

                CALL DSINIT( whichconst,
     &                   Cosim ,Emsq, Argpo, S1    , S2    , S3    ,
     &                   S4    , S5    , Sinim , Ss1   , Ss2   , Ss3   ,
     &                   Ss4   , Ss5   , Sz1   , Sz3   , Sz11  , Sz13  ,
     &                   Sz21  , Sz23  , Sz31  , Sz33  , T     , Tc    ,
     &                   GSTo  , Mo    , MDot  , No    ,nodeo,nodeDot,
     &                   XPIDOT, Z1    , Z3    , Z11   , Z13   , Z21   ,
     &                   Z23   , Z31   , Z33   , ecco  , eccsq,
     &                   Eccm  , Argpm , Inclm , Mm    , Xn    , nodem,
     &                   IREZ  , Atime , D2201 , D2211 , D3210 , D3222 ,
     &                   D4410 , D4422 , D5220 , D5232 , D5421 , D5433 ,
     &                   Dedt  , Didt  , DMDT  , DNDT  , DNODT , DOMDT ,
     &                   Del1  , Del2  , Del3  , Xfact , Xlamo , Xli   ,
     &                   Xni )
            ENDIF

* ------------ Set variables if not deep space or rp < 220 -------------
            IF (ISIMP .ne. 1) THEN
                CC1SQ = CC1*CC1
                D2    = 4.0D0*AO*TSI*CC1SQ
                TEMP  = D2*TSI*CC1 / 3.0D0
                D3    = (17.0D0*AO + SFour) * TEMP
                D4    = 0.5D0*TEMP*AO*TSI*
     &                  (221.0D0*AO + 31.0D0*SFour)*CC1
                T3COF = D2 + 2.0D0*CC1SQ
                T4COF = 0.25D0* (3.0D0*D3+CC1*(12.0D0*D2+10.0D0*CC1SQ) )
                T5COF = 0.2D0* (3.0D0*D4 + 12.0D0*CC1*D3 + 6.0D0*D2*D2 +
     &                  15.0D0*CC1SQ* (2.0D0*D2 + CC1SQ) )
              ENDIF

          ENDIF ! ------ if nodeo and No are gtr 0

      init = 'n'

      CALL SGP4(whichconst, 0.0D0, r, v, error)

c        INCLUDE 'debug6.for'

      RETURN
      END  ! end sgp4init


* -----------------------------------------------------------------------------
*
*                             SUBROUTINE SGP4
*
*  this subroutine is the sgp4 prediction model from space command. this is an
*    updated and combined version of sgp4 and sdp4, which were originally
*    published separately in spacetrack report #3. this version follows the nasa
*    release on the internet. there are a few fixes that are added to correct
*    known errors in the existing implementations.
*
*  author        : david vallado                  719-573-2600   28 jun 2005
*
*  inputs        :
*    satrec	 - initialised structure from sgp4init() call.
*    tsince	 - time eince epoch (minutes)
*
*  outputs       :
*    r           - position vector                     km
*    v           - velocity                            km/sec
*  return code - non-zero on error.
*                   1 - mean elements, ecc >= 1.0 or ecc < -0.001 or a < 0.95 er
*                   2 - mean motion less than 0.0
*                   3 - pert elements, ecc < 0.0  or  ecc > 1.0
*                   4 - semi-latus rectum < 0.0
*                   5 - epoch elements are sub-orbital
*                   6 - satellite has decayed
*
*  locals        :
*    am          -
*    axnl, aynl        -
*    betal       -
*    COSIM   , SINIM   , COSOMM  , SINOMM  , Cnod    , Snod    , Cos2u   ,
*    Sin2u   , Coseo1  , Sineo1  , Cosi    , Sini    , Cosip   , Sinip   ,
*    Cosisq  , Cossu   , Sinsu   , Cosu    , Sinu
*    Delm        -
*    Delomg      -
*    Dndt        -
*    Eccm        -
*    EMSQ        -
*    Ecose       -
*    El2         -
*    Eo1         -
*    Eccp        -
*    Esine       -
*    Argpm       -
*    Argpp       -
*    Omgadf      -
*    Pl          -
*    R           -
*    RTEMSQ      -
*    Rdotl       -
*    Rl          -
*    Rvdot       -
*    Rvdotl      -
*    Su          -
*    T2  , T3   , T4    , Tc
*    Tem5, Temp , Temp1 , Temp2  , Tempa  , Tempe  , Templ
*    U   , Ux   , Uy    , Uz     , Vx     , Vy     , Vz
*    inclm       - inclination
*    mm          - mean anomaly
*    nm          - mean motion
*    nodem       - longi of ascending node
*    xinc        -
*    xincp       -
*    xl          -
*    xlm         -
*    mp          -
*    xmdf        -
*    xmx         -
*    xmy         -
*    nodedf     -
*    xnode       -
*    nodep      -
*    np          -
*
*  coupling      :
*    getgravconst-
*    dpper
*    dpspace
*
*  references    :
*    hoots, roehrich, norad spacetrack report #3 1980
*    hoots, norad spacetrack report #6 1986
*    hoots, schumacher and glover 2004
*    vallado, crawford, hujsak, kelso  2006
*------------------------------------------------------------------------------

      SUBROUTINE SGP4 ( whichconst, T, r, v, Error )
        IMPLICIT NONE
        INTEGER*4  Error, whichconst
        REAL*8   T, r(3), v(3)

        INCLUDE 'SGP4.CMN'

* -------------------------- Local Variables --------------------------
        REAL*8 AM    , Axnl  , Aynl  , Betal , COSIM , Cnod  ,
     &         Cos2u , Coseo1, Cosi  , Cosip , Cosisq, Cossu , Cosu  ,
     &         Delm  , Delomg, Eccm  , EMSQ  , Ecose , El2   , Eo1   ,
     &         Eccp  , Esine , Argpm , Argpp , Omgadf, Pl    ,
     &         Rdotl , Rl    , Rvdot , Rvdotl, SINIM ,
     &         Sin2u , Sineo1, Sini  , Sinip , Sinsu , Sinu  ,
     &         Snod  , Su    , T2    , T3    , T4    , Tem5  , Temp  ,
     &         Temp1 , Temp2 , Tempa , Tempe , Templ , U     , Ux    ,
     &         Uy    , Uz    , Vx    , Vy    , Vz    , Inclm , Mm  ,
     &         XN    , nodem , Xinc  , Xincp , Xl    , Xlm   , Mp  ,
     &         Xmdf  , Xmx   , Xmy   , Xnoddf, Xnode , nodep,
     &         Tc    , Dndt

        REAL*8 PI,TWOPI,X2O3, J2,J3,XKE,J3OJ2, mr,mv,
     &         RadiusEarthkm, VKmPerSec, temp4, tumin, j4
	INTEGER*4 iter

        COMMON /DebugHelp/ Help
        CHARACTER Help

* ------------------------ WGS-72 EARTH CONSTANTS ---------------------
* ---------------------- SET MATHEMATICAL CONSTANTS -------------------
      PI     = 3.14159265358979D0
      TWOPI  = 6.283185307179586D0
      X2O3   = 2.0D0/3.0D0

c     Keep compiler ok for warnings on uninitialized variables
      mr = 0.0D0
      Coseo1 = 1.0D0
      Sineo1 = 0.0D0

      ! sgp4fix identify constants and allow alternate values
      CALL getgravconst( whichconst, tumin, radiusearthkm, xke, j2, 
     &     j3, j4, j3oj2 )
      temp4    =   1.0D0 + dcos(pi-1.0d-9)
      VKmPerSec     =  RadiusEarthKm * xke/60.0D0

* ------------------------- CLEAR SGP4 ERROR FLAG ---------------------
      Error = 0

* ----------- UPDATE FOR SECULAR GRAVITY AND ATMOSPHERIC DRAG ---------
      XMDF   = Mo + MDot*T
      OMGADF = Argpo + ArgpDot*T
      XNODDF = nodeo + nodeDot*T
      Argpm  = OMGADF
      Mm     = XMDF
      T2     = T*T
      nodem  = XNODDF + XNODCF*T2
      TEMPA  = 1.0D0 - CC1*T
      TEMPE  = BSTAR*CC4*T
      TEMPL  = T2COF*T2
      IF (ISIMP .ne. 1) THEN
          DELOMG = OMGCOF*T
          DELM   = XMCOF*(( 1.0D0+ETA*DCOS(XMDF) )**3-DELMO)
          TEMP   = DELOMG + DELM
          Mm     = XMDF + TEMP
          Argpm  = OMGADF - TEMP
          T3     = T2*T
          T4     = T3*T
          TEMPA  = TEMPA - D2*T2 - D3*T3 - D4*T4
          TEMPE  = TEMPE + BSTAR*CC5*(DSIN(Mm) - SINMAO)
          TEMPL  = TEMPL + T3COF*T3 + T4*(T4COF + T*T5COF)
        ENDIF
      XN    = No
      Eccm  = Ecco
      Inclm = Inclo
      IF(METHOD .EQ. 'd') THEN
          TC     = T
          CALL DSPACE( IRez  , D2201 , D2211 , D3210 , D3222 , D4410 ,
     &                 D4422 , D5220 , D5232 , D5421 , D5433 , Dedt  ,
     &                 Del1  , Del2  , Del3  , Didt  , Dmdt  , Dnodt ,
     &                 Domdt , Argpo , ArgpDot, T    , TC    , GSTo ,
     &                 Xfact , Xlamo , No   ,
     &                 Atime , Eccm  , Argpm, Inclm , Xli   , Mm  ,
     &                 XNi   , nodem, Dndt  , XN  )
        ENDIF

c     mean motion less than 0.0
      IF(XN .LE. 0.0D0) THEN
          Error = 2
        ENDIF
      AM = (XKE/XN)**X2O3*TEMPA**2
      XN = XKE/AM**1.5D0
      Eccm = Eccm-TEMPE
c   fix tolerance for error recognition
      IF (Eccm .GE. 1.0D0 .or. Eccm.lt.-0.001D0 .or. AM .lt. 0.95) THEN
c	  write(6,*) '# Error 1, Eccm = ',  Eccm, ' AM = ', AM
          Error = 1
        ENDIF
      IF (Eccm .lt. 0.0D0) Eccm = 1.0D-6
      Mm     = Mm+No*TEMPL
      XLM    = Mm+Argpm+nodem
      EMSQ   = Eccm*Eccm
      TEMP   = 1.0D0 - EMSQ
      nodem  = DMOD(nodem,TwoPi)
      Argpm  = DMOD(Argpm,TwoPi)
      XLM    = DMOD(XLM,TwoPi)
      Mm     = DMOD(XLM - Argpm - nodem,TwoPi)

* --------------------- COMPUTE EXTRA MEAN QUANTITIES -----------------
      SINIM  = DSIN(Inclm)
      COSIM  = DCOS(Inclm)

* ------------------------ ADD LUNAR-SOLAR PERIODICS ------------------
      Eccp   = Eccm
      XINCP  = Inclm
      Argpp  = Argpm
      nodep = nodem
      Mp     = Mm
      SINIP  = SINIM
      COSIP  = COSIM
      IF(METHOD .EQ. 'd') THEN
          CALL DPPER( e3    , ee2   , peo   , pgho  , pho   , pinco ,
     &                plo   , se2   , se3   , sgh2  , sgh3  , sgh4  ,
     &                sh2   , sh3   , si2   , si3   , sl2   , sl3   ,
     &                sl4   , T     , xgh2  , xgh3  , xgh4  , xh2   ,
     &                xh3   , xi2   , xi3   , xl2   , xl3   , xl4   ,
     &                zmol  , zmos  , Inclo , 'n'   ,
     &                Eccp  , XIncp , nodep, Argpp, Mp )
          IF(XINCP .lt. 0.0D0) THEN
              XINCP  = -XINCP
              nodep  = nodep + PI
              Argpp  = Argpp - PI
            ENDIF
          IF(Eccp .lt. 0.0D0 .OR. Eccp .GT. 1.0D0) THEN
              Error = 3
            ENDIF
        ENDIF

* ------------------------ LONG PERIOD PERIODICS ----------------------
      IF(METHOD .EQ. 'd') THEN
          SINIP =  DSIN(XINCP)
          COSIP =  DCOS(XINCP)
          AYCOF = -0.5D0*J3OJ2*SINIP
c         sgp4fix for divide by zero with xincp = 180 deg
          if (dabs(cosip+1.0).gt. 1.5d-12) THEN
              XLCOF  = -0.25D0*J3OJ2*SINIP*
     &                 (3.0D0+5.0D0*COSIP)/(1.0D0+COSIP)
            else
              XLCOF  = -0.25D0*J3OJ2*SINIP*
     &                 (3.0D0+5.0D0*COSIP)/temp4
            ENDIF
        ENDIF
      AXNL = Eccp*DCOS(Argpp)
      TEMP = 1.0D0 / (AM*(1.0D0-Eccp*Eccp))
      AYNL = Eccp*DSIN(Argpp) + TEMP*AYCOF
      XL   = Mp + Argpp + nodep + TEMP*XLCOF*AXNL

* ------------------------- SOLVE KEPLER'S EQUATION -------------------
      U    = DMOD(XL-nodep,TwoPi)
      EO1  = U
      ITER=0
c   sgp4fix for kepler iteration
c   the following iteration needs better limits on corrections
      Temp = 9999.9D0
      DO WHILE ((Temp.ge.1.0D-12).and.(ITER.lt.10))
          ITER=ITER+1
          SINEO1= DSIN(EO1)
          COSEO1= DCOS(EO1)
          TEM5  = 1.0D0 - COSEO1*AXNL - SINEO1*AYNL
          TEM5  = (U - AYNL*COSEO1 + AXNL*SINEO1 - EO1) / TEM5
          Temp  = DABS(Tem5)
          IF(Temp.gt.1.0D0) Tem5=Tem5/Temp ! Stop excessive correction
          EO1   = EO1+TEM5
        ENDDO

* ----------------- SHORT PERIOD PRELIMINARY QUANTITIES ---------------
      ECOSE = AXNL*COSEO1+AYNL*SINEO1
      ESINE = AXNL*SINEO1-AYNL*COSEO1
      EL2   = AXNL*AXNL+AYNL*AYNL
      PL    = AM*(1.0D0-EL2)
c     semi-latus rectum < 0.0
      IF ( PL .lt. 0.0D0 ) THEN
          Error = 4
        ELSE
          RL    = AM*(1.0D0-ECOSE)
          RDOTL = DSQRT(AM)*ESINE/RL
          RVDOTL= DSQRT(PL)/RL
          BETAL = DSQRT(1.0D0-EL2)
          TEMP  = ESINE/(1.0D0+BETAL)
          SINU  = AM/RL*(SINEO1-AYNL-AXNL*TEMP)
          COSU  = AM/RL*(COSEO1-AXNL+AYNL*TEMP)
          SU    = DATAN2(SINU,COSU)
          SIN2U = (COSU+COSU)*SINU
          COS2U = 1.0D0-2.0D0*SINU*SINU
          TEMP  = 1.0D0/PL
          TEMP1 = 0.5D0*J2*TEMP
          TEMP2 = TEMP1*TEMP

* ------------------ UPDATE FOR SHORT PERIOD PERIODICS ----------------
          IF(METHOD .EQ. 'd') THEN
              COSISQ = COSIP*COSIP
              CON41  = 3.0D0*COSISQ - 1.0D0
              X1MTH2 = 1.0D0 - COSISQ
              X7THM1 = 7.0D0*COSISQ - 1.0D0
            ENDIF
          mr   = RL*(1.0D0 - 1.5D0*TEMP2*BETAL*CON41) +
     &           0.5D0*TEMP1*X1MTH2*COS2U
          SU   = SU - 0.25D0*TEMP2*X7THM1*SIN2U
          XNODE= nodep + 1.5D0*TEMP2*COSIP*SIN2U
          XINC = XINCP + 1.5D0*TEMP2*COSIP*SINIP*COS2U
          mv   = RDOTL - XN*TEMP1*X1MTH2*SIN2U / XKE
          RVDOT= RVDOTL + XN*TEMP1* (X1MTH2*COS2U+1.5D0*CON41) / XKE

* ------------------------- ORIENTATION VECTORS -----------------------
          SINSU=  DSIN(SU)
          COSSU=  DCOS(SU)
          SNOD =  DSIN(XNODE)
          CNOD =  DCOS(XNODE)
          SINI =  DSIN(XINC)
          COSI =  DCOS(XINC)
          XMX  = -SNOD*COSI
          XMY  =  CNOD*COSI
          UX   =  XMX*SINSU + CNOD*COSSU
          UY   =  XMY*SINSU + SNOD*COSSU
          UZ   =  SINI*SINSU
          VX   =  XMX*COSSU - CNOD*SINSU
          VY   =  XMY*COSSU - SNOD*SINSU
          VZ   =  SINI*COSSU

* ----------------------- POSITION AND VELOCITY -----------------------
          r(1) = mr*UX * RadiusEarthkm
          r(2) = mr*UY * RadiusEarthkm
          r(3) = mr*UZ * RadiusEarthkm
          v(1) = (mv*UX + RVDOT*VX) * VKmPerSec
          v(2) = (mv*UY + RVDOT*VY) * VKmPerSec
          v(3) = (mv*UZ + RVDOT*VZ) * VKmPerSec
        ENDIF

* --------------------------- ERROR PROCESSING ------------------------
c     sgp4fix for decaying satellites
      if (mr .lt. 1.0D0) THEN
c          write(*,*) '# decay condition ',mr
          error = 6
        ENDIF

c        INCLUDE 'debug7.for'

      RETURN
      END  ! end sgp4

* -----------------------------------------------------------------------------
*
*                           FUNCTION GSTIME
*
*  This FUNCTION finds the Greenwich SIDEREAL time.  Notice just the INTEGER*4
*    part of the Julian Date is used for the Julian centuries calculation.
*    We use radper Solar day because we're multiplying by 0-24 solar hours.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    JD          - Julian Date                    days from 4713 BC
*
*  OutPuts       :
*    GSTIME      - Greenwich SIDEREAL Time        0 to 2Pi rad
*
*  Locals        :
*    Temp        - Temporary variable for reals   rad
*    TUT1        - Julian Centuries from the
*                  Jan 1, 2000 12 h epoch (UT1)
*
*  Coupling      :
*
*  References    :
*    Vallado       2004, 191, Eq 3-45
* -----------------------------------------------------------------------------

      REAL*8 FUNCTION GSTIME ( JD )
        IMPLICIT NONE
        REAL*8 JD
* ----------------------------  Locals  -------------------------------
        REAL*8 Temp, TUT1

        INCLUDE 'astmath.cmn'

        ! --------------------  Implementation   ----------------------

        TUT1= ( JD - 2451545.0D0 ) / 36525.0D0
        Temp= - 6.2D-6*TUT1*TUT1*TUT1
     &        + 0.093104D0*TUT1*TUT1
     &        + (876600.0D0*3600.0D0 + 8640184.812866D0)*TUT1
     &        + 67310.54841D0
        Temp= DMOD( Temp*Deg2Rad/240.0D0,TwoPi ) ! 360/86400 = 1/240, to deg, to rad

        ! ------------------------ Check quadrants --------------------
        IF ( Temp .lt. 0.0D0 ) THEN
            Temp= Temp + TwoPi
          ENDIF

        GSTIME= Temp

      RETURN
      END  ! end gstime


* -----------------------------------------------------------------------------
*
*                           function getgravconst
*
*  this function gets constants for the propagator. note that mu is identified to
*    facilitiate comparisons with newer models.
*
*  author        : david vallado                  719-573-2600   21 jul 2006
*
*  inputs        :
*    whichconst  - which set of constants to use  721, 72, 84
*
*  outputs       :
*    tumin       - minutes in one time unit
*    radiusearthkm - radius of the earth in km
*    xke         - reciprocal of tumin
*    j2, j3, j4  - un-normalized zonal harmonic values
*    j3oj2       - j3 divided by j2
*
*  locals        :
*    mu          - earth gravitational parameter
*
*  coupling      :
*
*  references    :
*    norad spacetrack report #3
*    vallado, crawford, hujsak, kelso  2006
*  ---------------------------------------------------------------------------- 

       SUBROUTINE getgravconst ( whichconst, tumin, radiusearthkm, 
     &            xke, j2, j3, j4, j3oj2 )
       IMPLICIT NONE     
       REAL*8 radiusearthkm, xke, j2, j3, j4, j3oj2, mu, tumin
       INTEGER*4 whichconst

       if (whichconst.eq.721) THEN
           ! -- wgs-72 low precision str#3 constants --
           radiusearthkm = 6378.135D0     ! km
           xke    = 0.0743669161D0
           tumin  = 1.0D0 / xke
           j2     =   0.001082616D0
           j3     =  -0.00000253881D0
           j4     =  -0.00000165597D0
           j3oj2  =  j3 / j2
         ENDIF
       if (whichconst.eq.72) THEN
           ! ------------ wgs-72 constants ------------
           mu     = 398600.8D0            ! in km3 / s2
           radiusearthkm = 6378.135D0     ! km
           xke    = 60.0D0 / dsqrt(radiusearthkm**3/mu)
           tumin  = 1.0D0 / xke
           j2     =   0.001082616D0
           j3     =  -0.00000253881D0
           j4     =  -0.00000165597D0
           j3oj2  =  j3 / j2
         ENDIF  
       if (whichconst.eq.84) THEN
           ! ------------ wgs-84 constants ------------
           mu     = 398600.5D0            ! in km3 / s2
           radiusearthkm = 6378.137D0     ! km
           xke    = 60.0D0 / dsqrt(radiusearthkm**3/mu)
           tumin  = 1.0D0 / xke
           j2     =   0.00108262998905D0
           j3     =  -0.00000253215306D0
           j4     =  -0.00000161098761D0
           j3oj2  =  j3 / j2
         ENDIF

       RETURN
       END  !  SUBROUTINE getgravconst

c     Adapted for IRBEM by A. C. Kellerman, loads tail par files
c     these only need to be loaded once
c     TODO: introduce a parameter when this is loaded, so we don't
c     call it in the GET_FIELD1 and GET_MULTI1 scripts for each call

c     revised Nov 8 2017 in preparation for 2017 TS07d model inclusion - A.C.K
      
      SUBROUTINE INIT_TS07D_TLPR

      IMPLICIT NONE

      REAL*8    ::  TSS,TSO,TSE

      INTEGER i,TS7LEN,IREAD,KREAD,KK ! dir length 

      CHARACTER*200 filename,FFMT
      CHARACTER*255 TS7DIR
      CHARACTER*255 ts07d_env

      COMMON /TSS/ TSS(80,5) ! tail pars
      COMMON /TSO/ TSO(80,5,4)
      COMMON /TSE/ TSE(80,5,4)

      CALL GETENV('TS07_DATA_PATH', ts07d_env)
      if (LEN_TRIM(ts07d_env).ne.0) then
        TS7DIR=TRIM(ts07d_env)
      else
        write(*,*) "error, TS07_DATA_PATH global variable not set"
        stop
      endif

      i=len(TS7DIR)
      do while (TS7DIR(i:i) == ' ')
        i = i - 1  
      enddo
      TS7LEN=i

      DO 1001 IREAD=1,5
        WRITE(FFMT,'("(A", I0, ",A20,I0,A4)")') TS7LEN
        WRITE(filename,FFMT) TS7DIR(1:TS7LEN),'/TAIL_PAR/tailamebhr'
     *,IREAD,'.par'
      OPEN (UNIT=1,FILE=filename)
      READ (1,200) (TSS(KK,IREAD),KK=1,80)
 200  FORMAT(G17.10)
 1001 CLOSE(1)

      DO 1002 IREAD=1,5
        DO 1003 KREAD=1,4
        WRITE(FFMT,'("(A", I0, ",A21,I0,I0,A4)")') TS7LEN
        WRITE(filename,FFMT)TS7DIR(1:TS7LEN),'/TAIL_PAR/tailamhr_o_'
     *,IREAD,KREAD,'.par'
      OPEN (UNIT=1,FILE=filename)
      READ (1,200) (TSO(KK,IREAD,KREAD),KK=1,80)
 1003   CONTINUE
 1002 CLOSE(1)

      DO 1004 IREAD=1,5
        DO 1005 KREAD=1,4
        WRITE(FFMT,'("(A", I0, ",A21,I0,I0,A4)")') TS7LEN
        WRITE(filename,FFMT)TS7DIR(1:TS7LEN),'/TAIL_PAR/tailamhr_e_'
     *,IREAD,KREAD,'.par'
      OPEN (UNIT=1,FILE=filename)
      READ (1,200) (TSE(KK,IREAD,KREAD),KK=1,80)
 1005   CONTINUE
 1004 CLOSE(1)

      end

!***************************************************************************************************
! Copyright 2004 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C S. Bourdarie (June 2004)
c Modified S./ Bourdarie (July 2004)
c
C Routine to find mirror point of a trapped particle
C
       SUBROUTINE find_bm(
     &         lati,longi,alti,alpha,Bposit,Bmir,xmin)
C
       IMPLICIT NONE
       REAL*8     xx0(3),xmin(3)
       REAL*8     lati,longi,alti
       REAL*8     Bposit,Bmir
       REAL*8     alpha

       CALL GDZ_GEO(lati,longi,alti,xx0(1),xx0(2),xx0(3))
C
       call find_bm_nalpha (xx0,1,alpha,Bposit,Bmir,xmin)

       RETURN
       END

       SUBROUTINE find_bm_nalpha(xx0,nalp,alpha,Bposit,Bmir,xmin)
C
       IMPLICIT NONE
       INCLUDE 'variables.inc'
C
       INTEGER*4  Nreb
       PARAMETER (Nreb = 50)
C
       INTEGER*4  k_ext,k_l,kint,Ifail
       INTEGER*4  Nrebmax
       REAL*8     rr,alpha(25)
       REAL*8     xx0(3),xx(3),x1(3),x2(3)
       REAL*8     xmin(3,25)
       REAL*8     B(3),Bl,B0,B1,B3
       REAL*8     dsreb

       INTEGER*4  I,J,ind,ii,nalp
       REAL*8     Lb,sn
       REAL*8     leI0
C
       REAL*8     tt
       REAL*8     cste
C
       REAL*8     Bposit,Bmir(25)
       REAL*8     sn2,sn2max
C
       COMMON /magmod/k_ext,k_l,kint
       REAL*8     pi,rad
       common /rconst/rad,pi
C
C
       Nrebmax = 20*Nreb
C
       leI0 = 0.D0
C
       CALL GEO_SM(xx0,xx)
       rr = SQRT(xx(1)*xx(1)+xx(2)*xx(2)+xx(3)*xx(3))
       tt = ACOS(xx(3)/rr)
       Lb  = rr/SIN(tt)/SIN(tt)
c       write(6,*)'L bete ',Lb
C
       CALL CHAMP(xx0,B,B0,Ifail)
       IF (Ifail.LT.0) THEN
          Bposit=baddata
          do 50 ii=1,nalp
	    Bmir(ii)=baddata
            xmin(1,ii) = baddata
            xmin(2,ii) = baddata
            xmin(3,ii) = baddata
50        continue
	  RETURN
       ENDIF
       Bposit=B0
       
       do 100 ii=1,nalp
       
       if ( alpha(ii).eq.90.d0 ) then
           Bmir(ii) = 0.d0
	   xmin(1,ii) = xx0(1)
           xmin(2,ii) = xx0(2)
           xmin(3,ii) = xx0(3)
	   goto 100
	endif
       Bmir(ii) = B0

       sn = SIN(alpha(ii)*rad)  
       sn2=sn*sn
       Sn2max=sn2
       cste=B0/sn2
       dsreb = Lb/(Nreb*1.d0)
C
C calcul du sens du depart
C
       CALL sksyst(-dsreb,xx0,x1,Bl,Ifail)
       IF (Ifail.LT.0) THEN
	  Bmir(ii)=baddata
          xmin(1,ii) = baddata
          xmin(2,ii) = baddata
          xmin(3,ii) = baddata
	  goto 100
       ENDIF
       B1 = Bl
       CALL sksyst(dsreb,xx0,x2,Bl,Ifail)
       IF (Ifail.LT.0) THEN
	  Bmir(ii)=baddata
          xmin(1,ii) = baddata
          xmin(2,ii) = baddata
          xmin(3,ii) = baddata
	  goto 100
       ENDIF
       B3 = Bl
C
       IF (B1.GT.B3) dsreb = -dsreb
C
C calcul de la ligne de champ
C
       ind=0
       DO I = 1,3
         x1(I)  = xx0(I)
       ENDDO
C
c       write(6,*)dsreb
       xmin(1,ii)=x1(1)
       xmin(2,ii)=x1(2)
       xmin(3,ii)=x1(3)
       DO J = 1,Nrebmax
         CALL sksyst(dsreb,x1,x2,Bl,Ifail)
         IF (Ifail.LT.0) THEN
	  Bmir(ii)=baddata
          xmin(1,ii) = baddata
          xmin(2,ii) = baddata
          xmin(3,ii) = baddata
	  goto 100
         ENDIF
c
	 sn2=Bl/cste
	 if (sn2 .GT.1.d0) GOTO 20
         IF (sn2.GT.Sn2max) THEN
           xmin(1,ii) = x2(1)
           xmin(2,ii) = x2(2)
           xmin(3,ii) = x2(3)
           Sn2max = sn2
	   Bmir(ii)=Bl
         ENDIF
	 x1(1) = x2(1)
	 x1(2) = x2(2)
	 x1(3) = x2(3)
       ENDDO
20     CONTINUE
C
       IF (J.GE.Nrebmax) THEN !open field line
	  Bmir(ii)=baddata
          xmin(1,ii) = baddata
          xmin(2,ii) = baddata
          xmin(3,ii) = baddata
	  goto 100
       ENDIF
C
C calcul de Bmirror point
C
       DO i=1,1000
         CALL sksyst(dsreb/1000.d0,xmin(1,ii),x1,Bl,Ifail)
         IF (Ifail.LT.0) THEN
	    Bmir(ii)=baddata
            xmin(1,ii) = baddata
            xmin(2,ii) = baddata
            xmin(3,ii) = baddata
	    goto 100
         ENDIF
	 sn2=Bl/cste
	 if (sn2 .GT.1.d0) GOTO 30
         xmin(1,ii) = x1(1)
         xmin(2,ii) = x1(2)
         xmin(3,ii) = x1(3)
         Sn2max = sn2
	 Bmir(ii)=Bl
       ENDDO
30     CONTINUE
       IF (xmin(1,ii)*xmin(1,ii)+xmin(2,ii)*xmin(2,ii)+
     &      xmin(3,ii)*xmin(3,ii).LT.1.D0) THEN
	  Bmir(ii)=baddata
          xmin(1,ii) = baddata
          xmin(2,ii) = baddata
          xmin(3,ii) = baddata
	  goto 100
       ENDIF
C
100    CONTINUE
C
       RETURN
       END
C

!***************************************************************************************************
! Copyright 1976, K. Pfitzer
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
c
C-----------------------------------------------------------------------
      SUBROUTINE BXYZMU(x, y , z, abx, aby, abz)
C
C  VERSION 11/01/76
C
C     PURPOSE
C       TO CALCULATE THE CONTRIBUTION TO THE EARTHS MAGNETIC FIELD BY SOURCES 
C       EXTERNAL TO THE EARTH. NO INTERNAL FIELD IS INCLUDED IN THIS ROUTINE.
C
C     METHOD
C        THE ROUTINE INCLUDES THE FIELD CONTRIBUTIONS FROM THE MAGNETOPAUSE 
C        CURRENTS, AND CURRENTS DISTRIBUTED THROUGHOUT THE MAGNETOSPHERE 
C        (THE TAIL AND RING CURRENTS). IT IS VALID FOR ALL TILTS OF THEEARTH'S  
C        DIPOLE AXIS AND IS VALID DURING QUIET MAGNETIC CONDITIONS.
C        A GENERALIZED ORTHONORMAL LEAST-SQUARES PROGRAM WAS USED TO FIT THE 
C        COEFFICIENTS OF A POWER SERIES (INCLUDING EXPONENTIAL TERMS) THROUGH 
C        FOURTH ORDER IN SPACE AND THIRD ORDER IN TILT. THIS EXPANSION HAS
C        BEEN OPTIMIZED FOR THE NEAR EARTH REGION AND IS VALID TO 15 EARTH
C        RADII. OUTSIDE OF THIS REGION THE FIELD DIVERGES RAPIDLY AND A
C        TEMPLATE SETS THE FIELD TO ZERO. IN ORDER TO IMPROVE COMPUTATIONAL 
C        SPEED THE FIELD IS SET TO ZERO BELOW 2 EARTH RADII. (IN THIS REGION 
C        THE EARTH'S INTERNAL FIELD DOMINATES AND THE VARIATIONS EXPRESSED 
C        BY THIS EXPANSION ARE NOT SUFFICIENTLY ACCURATE TO PREDICT VARIATIONS 
C        ON THE EARTH'S SURFACE).
C
C        THE POWER SERIES REPRESENTING THE MAGNETIC FIELD IS
C        BX=SUM OVER I,J,K OF ( A(I,J,K)*X**(I-1)*Y**(2*J-2)*Z**(K-1)
C               + B(I,J,K)*X**(I-1)*Y**(2*J-2)*Z**(K-1)*EXP(-.06*R**2))
C            I GOES FROM 1 TO 5,J FROM 1 TO 3, K FROM 1 TO 5
C            THE SUM OF I + 2*J + K IS LESS THAN OR EQUAL TO 9
C        BY=SUM OVER I,J,K OF ( C(I,J,K)*X**(I-1)*Y**(2*J-1)*Z**(K-1)
C               + D(I,J,K)*X**(I-1)*Y**(2*J-1)*Z**(K-1)*EXP(-.06*R**2))
C            I GOES FROM 1 TO 5, J FROM 1 TO 3, K FROM 1 TO 5
C            THE SUM OF I + 2*J+1 + K IS LESS THAN OR EQUAL TO 9
C        BZ=SUM OVER I,J,K OF ( E(I,J,K)*X**(I-1)*Y**(2*J-2)*Z**(K-1)
C               + F(I,J,K)*X**(I-1)*Y**(2*J-2)*Z**(K-1)*EXP(-.06*R**2))
C            I GOES FROM 1 TO 5, J FROM 1 TO 3, K FROM 1 TO 5
C            THE SUM OF I + 2*J + K IS LESS THAN OR EQUAL TO 9
C        THE COEFFICIENTS A-F ARE DEPENDENT ONLY ON POSITION AND ARE 
C        RECALCULATED EACH TIME THE TILT OF THE DIPOLE IS CHANGED.
C        THE COEEFICIENTS A-F ARE DETERMINED FROM THE TILT DEPENDENT
C        CONSTANTS AA-FF BY THE FOLLOWING EXPRESSIONS
C        A(I,J,K)=AA(I,J,K,1)*TILT**(K-1-(K-1)/2*2)
C                 +AA(I,J,K,2)*TILT**(K+1-(K-1)/2*2)
C        B(I,J,K)=BB......
C        C(I,J,K)=CC......
C        D(I,J,K)=DD......
C        E(I,J,K)=EE(I,J,K,1)*TILT**(K-(K)/2*2)
C                 +EE(I,J,K,2)*TILT**(K+2-(K)/2*2)
C        F(I,J,K)=FF......
C
C     INPUT -- CALLING SEQUENCE
C        X,Y,Z  REALS GIVING THE POSITION WHERE THE MAGNETIC FIELD 
C               IS TO BE EVALUATED. XX(1), XX(2), XX(3) ARE RESPECTIVELY 
C               THE X, Y, AND Z SOLAR MAGNETIC COORDINATES IN EARTH RADII. 
C               Z IS ALONG THE EARTH'S NORTH DIPOLE AXIS, X IS PERPENDICULAR 
C               TO Z AND IN THE PLANE CONTAINING THE Z AXIS AND THE SUN-EARTH
C               LINE, Y IS PERPENDICULAR TO X AND Z FORMING A RIGHT HANDED
C               COORDINATE SYSTEM. X IS POSITIVE IN THE SOLAR DIRECTION.
C        TILT   IS THE TILT OF THE DIPOLE AXIS IN DEGREES. IT IS THE COMPLEMENT 
C               OF THE ANGLE BETWEEN THE NORTH DIPOLE AXIS AND THE SOLAR 
C               DIRECTION (PSI). TILT=90-PSI.
C
C     OUTPUT -- CALLING SEQUENCE
C        ABX,ABY,ABZ  THE X, Y, AND Z COMPONENTS OF THE MAGNETOSPHERIC 
C               MAGNETIC FIELD IN GAMMA. 
C
C     CONSTANTS
C        AA,BB,CC,DD,EE,FF ARE REAL ARRAYS CONTAINING THE TILT DEPENDENT
C               COEFFICIENTS. AA(I,J,K,L) ARE STORED SUCH THAT L VARIES MOST
C               RAPIDLY, FOLLOWED IN ORDER BY K, J AND I. I VARIES THE SLOWEST.
C               THE ARRAY IS CLOSE PACKED AND ALL COEFFICIENTS THAT ARE ZERO 
C               BECAUSE OF SYMMETRY OR BECAUSE THE CROSS TERM POWER IS TOO 
C               LARGE ARE DELETED.
C
C     VARIABLES
C        A,B,C,D,E,F  THE TILT INDEPENDENT COEFFICIENTS. THEIR USE IS 
C               DESCRIBED UNDER METHOD.
C        ITA    A REAL ARRAY WHICH CONTAINS THE SYMMETRY OF THE TILT
C               DEPENDENCE FOR EACH OF THE A AND B COEFFICIENTS
C               ITA(1) HAS THE SYMMETRY INFORMATION FOR A(1,1,1,1)
C                      AND A(1,1,1,2)
C               ITA(2) HAS THE SYMMETRY INFORMATION FOR A(1,1,2,1)
C                      AND A(1,1,2,2) ETC.
C               IF ITA = 1 TILT SYMMETRY IS EVEN WITH RESPECT TO Z SYM.
C               IF ITA = 2 TILT SYMMETRY IS ODD WITH RESPECT TO Z SYM.
C        ITB    SYMMETRY POINTER FOR C AND D ARRAYS
C        ITC    SYMMETRY POINTER FOR E AND F ARRAYS
C        X      X COMPONENT OF POSITION
C        Y      Y COMPONENT OF POSITION
C        Z      Z COMPONENT OF POSITION
C        Y2     Y**2
C        Z2     Z**2
C        R2     X**2 + Y**2 + Z**2
C        R      SQRT(R2)
C        I      DO LOOP VARIABLE. IN THE FIELD EXPANSION LOOP IT REPRESENTS 
C               THE POWER TO WHICH X IS CURRENTLY RAISED, I.E. X**(I-1)
C        J      DO LOOP VARIABLE. ALSO Y**(2*J-2)
C        K      DO LOOP VARIABLE. ALSO Z**(K-1)
C        XB     X**(I-1)
C        YEXB   X**(I-1)*Y**(2*J-2)
C        ZEYEXB X**(I-1)*Y**(2*J-2)*Z**(K-1)
C        IJK    I + 2*J + K
C        II     POINTS TO THE ARRAY LOCATION WHERE THE CURRENT POWER SERIES 
C               COEFFICIENT FOR BX IS LOCATED.
C        JJ     BY COEFFICIENT LOCATION POINTER
C        KK     BZ COEFFICIENT LOCATION POINTER
C        BX,BY,BZ ARE USED TO CONSTRUCT THE MAGNETIC FIELD WITHIN THE POWER 
C               SERIES LOOP.
C        EXPR   EXP(-.06*R2)
C        TILTL  HOLDS THE LAST VALUE OF THE TILT FOR WHICH THE TILT
C               INDEPENDENT COEFFICIENTS A-F WERE CALCULATED.
C        TT     A REAL ARRAY HOLDING THE POWERS OF THE TILT.
C               TT(1)=TILT**0, TT(2)=TILT**1, ETC.
C        CON    =0 FOR R LESS THAN 2
C               =1 FOR R GREATER THAN 2.5
C               GOES FROM 0 TO 1 IN THE REGION 2 TO 2.5.
C
C     FOR MORE INFORMATION CALL OR WRITE K.A. PFITZER OR W.P. OLSON AT 
C     MCDONNEL DOUGLAS ASTRONAUTICS CO. 5301 BOLSA AVE, HUNTINGTON
C     CALIF., PHONE (714) 896-3231.
C

      IMPLICIT NONE

C Input
      REAL*8 X, Y, Z, TILT
C Output
      REAL*8 ABX, ABY, ABZ
C Local
      REAL*8 AA(64), BB(64), CC(44), DD(44), EE(64), FF(64), A(32)
      REAL*8 B(32), C(22), D(22), E(32), F(32), TT(4), TILTL
      REAL*8 Y2, Z2, R2, BX, BY, BZ, CON, EXPR, XB, YEXB, ZEYEXB
      INTEGER*4 ITA(32), ITB(22), ITC(32), I, J, K, II, JJ, KK, IJK
      SAVE TILTL,TT,A,B,E,F,C,D
      COMMON /dip_ang/TILT

      DATA ITA /2,1,2,1,2,2,1,2,1,2,1,2,1,2,1,2,2,1,2,2,2,1,
     *          2,1,2,1,2,1,2,2,2,1/
      DATA ITB /2,1,2,1,2,2,1,2,2,2,1,2,1,2,1,2,1,2,2,2,1,2/
      DATA ITC /1,2,1,2,1,1,2,1,2,1,2,1,2,1,2,1,1,2,1,1,1,2,
     *          1,2,1,2,1,2,1,1,1,2/

      DATA AA/-2.26836d-02,-1.01863d-04,3.42986d+00,
     *-3.12195d-04, 9.50629d-03,-2.91512d-06,-1.57317d-03, 8.62856d-08,
     *-4.26478d-05, 1.62924d-08,-1.27549d-04, 1.90732d-06,-1.65983d-02,
     * 8.46680d-09,-5.55850d-05, 1.37404d-08, 9.91815d-05, 1.59296d-08,
     * 4.52864d-07,-7.17669d-09, 4.98627d-05, 3.33662d-10,-5.97620d-02,
     * 1.60669d-05,-2.29457d-01,-1.43777d-04, 1.09403d-03,-9.15606d-07,
     * 1.60658d-03,-4.01198d-07,-3.15064d-06, 2.03125d-09, 4.92887d-04,
     *-1.80676d-07,-1.12022d-03, 5.98568d-07,-5.90009d-06, 5.16504d-09,
     *-1.48737d-06, 4.83477d-10,-7.44379d-04, 3.82472d-06, 7.41737d-04,
     *-1.31468d-05,-1.24729d-04, 1.92930d-08,-1.91764d-04,-5.30371d-08,
     * 1.38186d-05,-2.81594d-08, 7.46386d-06, 2.64404d-08, 2.45049d-04,
     *-1.81802d-07,-1.00278d-03, 1.98742d-06,-1.16425d-05, 1.17556d-08,
     *-2.46079d-06,-3.45831d-10, 1.02440d-05,-1.90716d-08,-4.00855d-05,
     * 1.25818d-07/

      DATA BB/ 9.47753d-02, 1.45981d-04,-1.82933d+00,
     * 5.54882d-04, 5.03665d-03,-2.07698d-06, 1.10959d-01,-3.45837d-05,
     *-4.40075d-05, 5.06464d-07,-1.20112d-03, 3.64911d-06, 1.49849d-01,
     *-7.44929d-05, 2.46382d-04, 9.65870d-07,-9.54881d-04, 2.43647d-07,
     * 3.06520d-04, 3.07836d-07, 6.48301d-03, 1.26251d-06,-7.09548d-03,
     *-1.55596d-05, 3.06465d+00,-7.84893d-05, 4.95145d-03, 3.71921d-06,
     *-1.52002d-01, 6.81988d-06,-8.55686d-05,-9.01230d-08,-3.71458d-04,
     * 1.30476d-07,-1.82971d-01, 1.51390d-05,-1.45912d-04,-2.22778d-07,
     * 6.49278d-05,-3.72758d-08,-1.59932d-03, 8.04921d-06, 5.38012d-01,
     *-1.43182d-04, 1.50000d-04, 5.88020d-07,-1.59000d-02, 1.60744d-06,
     * 3.17837d-04, 1.78959d-07,-8.93794d-03, 6.37549d-06, 1.27887d-03,
     *-2.45878d-07,-1.93210d-01, 6.91233d-06,-2.80637d-04,-2.57073d-07,
     * 5.78343d-05, 4.52128d-10, 1.89621d-04,-4.84911d-08,-1.50058d-02,
     * 6.21772d-06/

      DATA CC/-1.88177d-02,-1.92493d-06,-2.89064d-01,
     *-8.49439d-05,-4.76380d-04,-4.52998d-08, 1.61086d-03, 3.18728d-07,
     * 1.29159d-06, 5.52259d-10, 3.95543d-05, 5.61209d-08, 1.38287d-03,
     * 5.74237d-07, 1.86489d-06, 7.10175d-10, 1.45243d-07,-2.97591d-10,
     *-2.43029d-03,-6.70000d-07,-2.30624d-02,-6.22193d-06,-2.40815d-05,
     * 2.01689d-08, 1.76721d-04, 3.78689d-08, 9.88496d-06, 7.33820d-09,
     * 7.32126d-05, 8.43986d-08, 8.82449d-06,-6.11708d-08, 1.78881d-04,
     * 8.62589d-07, 3.43724d-06, 2.53783d-09,-2.04239d-07, 8.16641d-10,
     * 1.68075d-05, 7.62815d-09, 2.26026d-04, 3.66341d-08, 3.44637d-07,
     * 2.25531d-10/

      DATA DD/ 2.50143d-03, 1.01200d-06, 3.23821d+00,                   
     * 1.08589d-05,-3.39199d-05,-5.27052d-07,-9.46161d-02,-1.95413d-09,
     *-4.23614d-06, 1.43153d-08,-2.62948d-04, 1.05138d-07,-2.15784d-01,
     *-2.20717d-07,-2.65687d-05, 1.26370d-08, 5.88917d-07,-1.13658d-08,
     * 1.64385d-03, 1.44263d-06,-1.66045d-01,-1.46096d-05, 1.22811d-04,
     * 3.43922d-08, 9.66760d-05,-6.32150d-07,-4.97400d-05,-2.78578d-08,
     * 1.77366d-02, 2.05401d-07,-1.91756d-03,-9.49392d-07,-1.99488d-01,
     *-2.07170d-06,-5.40443d-05, 1.59289d-08, 7.30914d-05, 3.38786d-08,
     *-1.59537d-04,-1.65504d-07, 1.90940d-02, 2.03238d-06, 1.01148d-04,
     * 5.20815d-08/

      DATA EE/-2.77924d+01,-1.01457d-03, 9.21436d-02,                   
     *-8.52177d-06, 5.19106d-01, 8.28881d-05,-5.59651d-04, 1.16736d-07,
     *-2.11206d-03,-5.35469d-07, 4.41990d-01,-1.33679d-05,-7.18642d-04,
     * 6.17358d-08,-3.51990d-03,-5.29070d-07, 1.88443d-06,-6.60696d-10,
     *-1.34708d-03, 1.02160d-07, 1.58219d-06, 2.05040d-10, 1.18039d+00,
     * 1.58903d-04, 1.86944d-02,-4.46477d-06, 5.49869d-02, 4.94690d-06,
     *-1.18335d-04, 6.95684d-09,-2.73839d-04,-9.17883d-08, 2.79126d-02,
     *-1.02567d-05,-1.25427d-04, 3.07143d-08,-5.31826d-04,-2.98476d-08,
     *-4.89899d-05, 4.91480d-08, 3.85563d-01, 4.16966d-05, 6.74744d-04,
     *-2.08736d-07,-3.42654d-03,-3.13957d-06,-6.31361d-06,-2.92981d-09,
     *-2.63883d-03,-1.32235d-07,-6.19406d-06, 3.54334d-09, 6.65986d-03,
     *-5.81949d-06,-1.88809d-04, 3.62055d-08,-4.64380d-04,-2.21159d-07,
     *-1.77496d-04, 4.95560d-08,-3.18867d-04,-3.17697d-07,-1.05815d-05,
     * 2.22220d-09/

      DATA FF/-5.07092d+00, 4.71960d-03,-3.79851d-03,                   
     *-3.67309d-06,-6.02439d-01, 1.08490d-04, 5.09287d-04, 5.62210d-07,
     * 7.05718d-02, 5.13160d-06,-2.85571d+00,-4.31728d-05, 1.03185d-03,
     * 1.05332d-07, 1.04106d-02, 1.60749d-05, 4.18031d-05, 3.32759d-08,
     * 1.20113d-01, 1.40486d-05,-3.37993d-05, 5.48340d-09, 9.10815d-02,
     *-4.00608d-04, 3.75393d-03,-4.69939d-07,-2.48561d-02, 1.31836d-04,
     *-2.67755d-04,-7.60285d-08, 3.04443d-03,-3.28956d-06, 5.82367d-01,
     * 5.39496d-06,-6.15261d-04, 4.05316d-08, 1.13546d-02,-4.26493d-06,
     *-2.72007d-02, 5.72523d-08,-2.98576d+00, 3.07325d-05, 1.51645d-03,
     * 1.25098d-06, 4.07213d-02, 1.05964d-05, 1.04232d-04, 1.77381d-08,
     * 1.92781d-01, 2.15734d-05,-1.65741d-05,-1.88683d-09, 2.44803d-01,
     * 1.51316d-05,-3.01157d-04, 8.47006d-08, 1.86971d-02,-6.94074d-06,
     * 9.13198d-03,-2.38052d-07, 1.28552d-01, 6.92595d-06,-8.36792d-05,
     *-6.10021d-08/

      DATA TILTL /99.0D0/
c      write(6,*)tilt
c      stop
C
C  SET UP SOME OF THE INITIAL POSITION VARIABLES.
      Y2 = Y**2
      Z2 = Z**2
      R2 = X**2 + Y2 + Z2
C
C  SET MAGNETIC FIELD VARIABLES TO ZERO.
      BX = 0.0D0
      BY = 0.0D0
      BZ = 0.0D0
C
C  CHECK TO SEE IF POSITION IS WITHIN REGION OF VALIDITY.
      CON = 1.0D0
C  IF DISTANCE TOO LARGE TAKE ERROR EXIT.
      IF (R2 .GT. 225.0D0) GO TO 50
C  IF DISTANCE TOO SMALL SET FIELD TO ZERO AND EXIT.
      IF (R2 .LT. 4.0D0) GO TO 40
      IF (R2 .LT. 6.25D0) CON = CON * (R2-4.0D0) / 2.25D0
C
C  IF TILT HAS NOT CHANGED, GO DIRECTLY TO FIELD CALCULATION.
      IF (TILTL .EQ. TILT) GO TO 6
C  SET UP POWERS OF TILT.
      TILTL = TILT
      TT(1) = 1.0D0
      TT(2) = TILTL
      TT(3) = TILTL**2
      TT(4) = TILT * TT(3)
C
C  SET UP THE X AND Z COMPONENT TILT INDEPENDENT COEFFICIENTS.
      DO 1 I=1,32
        J = (I-1) * 2 + 1
        K = ITA(I)
        A(I) = AA(J) * TT(K) + AA(J+1) * TT(K+2)
        B(I) = BB(J) * TT(K) + BB(J+1) * TT(K+2)
        K = ITC(I)
        E(I) = EE(J) * TT(K) + EE(J+1) * TT(K+2)
        F(I) = FF(J) * TT(K) + FF(J+1) * TT(K+2)
   1  CONTINUE
C
C  SET UP THE Y COMPONENT TILT INDEPENDENT COEFFICIENTS.
      DO 2 I=1,22
        J = (I-1) * 2 + 1
        K = ITB(I)
        C(I) = CC(J) * TT(K) + CC(J+1) * TT(K+2)
        D(I) = DD(J) * TT(K) + DD(J+1) * TT(K+2)
   2  CONTINUE
   6  EXPR = DEXP(-0.06D0*R2)
C
C  INITIALIZE THE POINTERS.
      II=1
      JJ=1
      KK=1
      XB=1.0D0
C
C  BEGIN SUM OVER X.
      DO 30 I=1,5
        YEXB = XB
C
C  BEGIN SUM OVER Y.
        DO 20 J=1,3
          IF (I+2*J .GT. 8) GO TO 25
            ZEYEXB = YEXB
            IJK = I + 2 * J + 1
            K = 1
C
C  Z LOOP STARTS HERE.
  10  BZ = BZ + (E(KK)+F(KK)*EXPR) * ZEYEXB
      KK = KK + 1
      BX = BX + (A(II)+B(II)*EXPR) * ZEYEXB
      II = II + 1
      IF (IJK .GT. 8) GO TO 15
      BY = BY + (C(JJ)+D(JJ)*EXPR) * ZEYEXB * Y
      JJ = JJ + 1
      ZEYEXB = ZEYEXB * Z
      IJK = IJK + 1
      K = K + 1
      IF ((IJK .LE. 9) .AND. (K .LE. 5)) GO TO 10
  15  YEXB = YEXB * Y2
  20  CONTINUE
  25  XB = XB * X
  30  CONTINUE
C
C  SET UP THE OUTPUT ARRAY, MULTIPLY BY CON. CON IS NORMALLY ONE
C  BUT INSIDE OF R=2.5 IT GOES TO ZERO. INSIDE R=2 IT IS ZERO.
  40  ABX = BX * CON
      ABY = BY * CON
      ABZ = BZ * CON
      RETURN

C  ERROR EXIT IF OUTSIDE OF R = 15.
  50  CONTINUE
c     WRITE(6,*)' OUTSIDE THE VALID REGION--POWER SERIES DIVERGES 
c    &BFIELD IS SET TO ZERO'
  60  FORMAT(4H X= ,E10.3,4H Y= ,E10.3,4H Z= ,E10.3,76H 'IS OUTSIDE THE'
     &'VALID REGION--POWER SERIES DIVERGES BFIELD IS SET TO ZERO')
      GO TO 40

      END

!***************************************************************************************************
! Copyright 2004 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
      SUBROUTINE MEAD(xx, yy, zz, kp, abx, aby, abz)

C CALCULATES INCREMENTAL HIGH ALTITUDE GEOMAGNETIC FIELD IN GAUSS
C xx, yy, zz   SM coordinates in Re
C tilt      in degrees
C abx, aby, abz in gauss

      IMPLICIT NONE

C INPUT:
      REAL*8  xx, yy, zz, tilt
      INTEGER*4 KP
C OUTPUT:
      REAL*8  abx, aby, abz
C LOCAL:
      REAL*8  a(7,4), b(3,4), c(7,4), x, y, z, t
      INTEGER*4 i, j, k, l, m, n 

      COMMON /dip_ang/tilt
C COEFFICIENTS OF MODEL 1 (MEAD-FAIRFIELD 1975)

      DATA ((A(I,J),I=1,7),J=1,4)/17.93D0,-5.79D0,2.98D0,-2.57D0,
     1-0.30D0,-1.47D0,1.05D0,21.79D0,-7.03D0,3.02D0,-2.99D0,-0.62D0,
     2-1.22D0,0.95D0,33.16D0,-6.39D0,4.30D0,-3.25D0,-0.44D0,-1.27D0,
     30.45D0,39.48D0,-2.91D0,5.17D0,-3.86D0,-1.04D0,-1.29D0,-1.14D0/,
     4((B(K,L),K=1,3),L=1,4)/-10.11D0,-1.98D0,0.09D0,-11.84D0,-2.57D0,
     5-0.28D0,-16.54D0,-3.08D0,0.22D0,-19.10D0,-3.50D0,0.23D0/,
     6((C(M,N),M=1,7),N=1,4)/-9.41D0,15.07D0,13.16D0,8.36D0,7.95D0,
     74.55D0,0.51D0,-11.96D0,17.87D0,15.88D0,9.77D0,9.43D0,5.57D0,
     81.53D0,-19.88D0,20.23D0,22.72D0,13.23D0,11.46D0,6.33D0,0.67D0,
     9-22.90D0,22.70D0,26.50D0,15.54D0,11.00D0,7.36D0,1.85D0/

C ROTATE AXES ABOUT Z BY 4 DEGREES
      X = 0.99756405D0 * XX - 0.06975647D0 * YY
      Y = 0.06975647D0 * XX + 0.99756405D0 * YY
C SCALE COORDINATES AND TILT ANGLE
      x = x / 10.0D0
      y = y / 10.0D0
      z = zz / 10.0D0
      T = TILT / 10.0D0
C CALCULATE EXTERNAL FIELD COMPONENTS
      ABX = A(1,KP) * Z + A(2,KP) * X * Z + T * (A(3,KP) + A(4,KP) * X
     &      + A(5,KP) * X * X + A(6,KP) * Y * Y + A(7,KP) * Z * Z)
      ABY = B(1,KP) * Y * Z + T * (B(2,KP) * Y + B(3,KP) * X * Y)
      ABZ = C(1,KP) + C(2,KP) * X + C(3,KP) * X * X + C(4,KP) * Y * Y
     &      + C(5,KP) * Z * Z + T * (C(6,KP) * Z + C(7,KP) * X * Z)

      RETURN
      END

!***************************************************************************************************
! Copyright 1995, 1996, N. Tsyganenko
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C----------------------------------------------------------------------
c
      SUBROUTINE T96_01 (PARMOD,X,Y,Z,BX,BY,BZ)
C
c     RELEASE DATE OF THIS VERSION:   JUNE 22, 1996.
C----------------------------------------------------------------------
C
C  WITH TWO CORRECTIONS, SUGGESTED BY T.SOTIRELIS' COMMENTS (APR.7, 1997)
C
C  (1) A "STRAY "  CLOSING PARENTHESIS WAS REMOVED IN THE S/R   R2_BIRK
C  (2) A 0/0 PROBLEM ON THE Z-AXIS WAS SIDESTEPPED (LINES 44-46 OF THE
c       DOUBLE PRECISION FUNCTION XKSI)
c--------------------------------------------------------------------
C DATA-BASED MODEL CALIBRATED BY (1) SOLAR WIND PRESSURE PDYN (NANOPASCALS),
C           (2) DST (NANOTESLA),  (3) BYIMF, AND (4) BZIMF (NANOTESLA).
c THESE INPUT PARAMETERS SHOULD BE PLACED IN THE FIRST 4 ELEMENTS
c OF THE ARRAY PARMOD(10).
C
C   THE REST OF THE INPUT VARIABLES ARE: THE GEODIPOLE TILT ANGLE PS (RADIANS),
C AND   X,Y,Z -  GSM POSITION (RE)
C
c   IOPT  IS JUST A DUMMY INPUT PARAMETER, NECESSARY TO MAKE THIS SUBROUTINE
C COMPATIBLE WITH THE NEW RELEASE (APRIL 1996) OF THE TRACING SOFTWARE
C PACKAGE (GEOPACK). IOPT VALUE DOES NOT AFFECT THE OUTPUT FIELD.
c
C
c OUTPUT:  GSM COMPONENTS OF THE EXTERNAL MAGNETIC FIELD (BX,BY,BZ, nanotesla)
C            COMPUTED AS A SUM OF CONTRIBUTIONS FROM PRINCIPAL FIELD SOURCES
C
c  (C) Copr. 1995, 1996, Nikolai A. Tsyganenko, Hughes STX, Code 695, NASA GSFC
c      Greenbelt, MD 20771, USA
c
C                            REFERENCES:
C
C               (1) N.A. TSYGANENKO AND D.P. STERN, A NEW-GENERATION GLOBAL
C           MAGNETOSPHERE FIELD MODEL  , BASED ON SPACECRAFT MAGNETOMETER DATA,
C           ISTP NEWSLETTER, V.6, NO.1, P.21, FEB.1996.
C
c              (2) N.A.TSYGANENKO,  MODELING THE EARTH'S MAGNETOSPHERIC
C           MAGNETIC FIELD CONFINED WITHIN A REALISTIC MAGNETOPAUSE,
C           J.GEOPHYS.RES., V.100, P. 5599, 1995.
C
C              (3) N.A. TSYGANENKO AND M.PEREDO, ANALYTICAL MODELS OF THE
C           MAGNETIC FIELD OF DISK-SHAPED CURRENT SHEETS, J.GEOPHYS.RES.,
C           V.99, P. 199, 1994.
C
c----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 PDYN,DST,BYIMF,BZIMF,PS,X,Y,Z,BX,BY,BZ,QX,QY,QZ,PARMOD(10),
     *   A(9),tilt
c
      COMMON /dip_ang/tilt
      DATA PDYN0,EPS10 /2.d0,3630.7d0/
C
      DATA A/1.162d0,22.344d0,18.50d0,2.602d0,6.903d0,5.287d0,0.5790d0,
     :       0.4462d0,0.7850d0/
C
      DATA  AM0,S0,X00,DSIG/70.d0,1.08d0,5.48d0,0.005d0/
      DATA  DELIMFX,DELIMFY /20.d0,10.d0/
C
       ps=tilt*4.D0*ATAN(1.D0)/180.d0
c       
       	 idummy=iopt
       PDYN=PARMOD(1)
       DST=PARMOD(2)
       BYIMF=PARMOD(3)
       BZIMF=PARMOD(4)
C
       SPS=SIN(PS)
       PPS=PS
C
       DEPR=0.8*DST-13.*SQRT(PDYN)  
c!  DEPR is an estimate of total near-Earth
c                                         depression, based on DST and Pdyn
c                                             (usually, DEPR &lt 0 )
C
C  CALCULATE THE IMF-RELATED QUANTITIES:
C
       Bt=SQRT(BYIMF**2+BZIMF**2)

       IF (BYIMF.EQ.0.d0.AND.BZIMF.EQ.0.d0) THEN
          THETA=0.
          GOTO 1
       ENDIF
C
       THETA=ATAN2(BYIMF,BZIMF)
       IF (THETA.LE.0.D0) THETA=THETA+atan(1.0d0)*8
  1    CT=COS(THETA)
       ST=SIN(THETA)
       EPS=718.5d0*SQRT(Pdyn)*Bt*SIN(THETA/2)
C
       FACTEPS=EPS/EPS10-1
       FACTPD=SQRT(PDYN/PDYN0)-1
C
       RCAMPL=-A(1)*DEPR     
c!   RCAMPL is the amplitude of the ring current
c                  (positive and equal to abs.value of RC depression at origin)
C
       TAMPL2=A(2)+A(3)*FACTPD+A(4)*FACTEPS
       TAMPL3=A(5)+A(6)*FACTPD
       B1AMPL=A(7)+A(8)*FACTEPS
       B2AMPL=20.*B1AMPL  
c! IT IS EQUIVALENT TO ASSUMING THAT THE TOTAL CURRENT
C                           IN THE REGION 2 SYSTEM IS 40% OF THAT IN REGION 1
       RECONN=A(9)
C
       XAPPA=(PDYN/PDYN0)**0.14d0
       XAPPA3=XAPPA**3
       YS=Y*CT-Z*ST
       ZS=Z*CT+Y*ST
C
       FACTIMF=EXP(X/DELIMFX-(YS/DELIMFY)**2)
C
C  CALCULATE THE "IMF" COMPONENTS OUTSIDE THE LAYER  (HENCE BEGIN WITH "O")
C
       OIMFX=0
       OIMFY=RECONN*BYIMF*FACTIMF
       OIMFZ=RECONN*BZIMF*FACTIMF
C
       RIMFAMPL=RECONN*Bt
C
       PPS=PS
       XX=X*XAPPA
       YY=Y*XAPPA
       ZZ=Z*XAPPA
C
C  SCALE AND CALCULATE THE MAGNETOPAUSE PARAMETERS FOR THE INTERPOLATION ACROSS
C   THE BOUNDARY LAYER (THE COORDINATES XX,YY,ZZ  ARE ALREADY SCALED)
C
       X0=X00/XAPPA
       AM=AM0/XAPPA
       RHO2=Y**2+Z**2
       ASQ=AM**2
       XMXM=AM+X-X0
       IF (XMXM.LT.0) XMXM=0 
c! THE BOUNDARY IS A CYLINDER TAILWARD OF X=X0-AM
       AXX0=XMXM**2
       ARO=ASQ+RHO2
       SIGMA=SQRT((ARO+AXX0+SQRT((ARO+AXX0)**2-4*ASQ*AXX0))/(2*ASQ))
C
C   NOW, THERE ARE THREE POSSIBLE CASES:
C    (1) INSIDE THE MAGNETOSPHERE
C    (2) IN THE BOUNDARY LAYER
C    (3) OUTSIDE THE MAGNETOSPHERE AND B.LAYER
C       FIRST OF ALL, CONSIDER THE CASES (1) AND (2):
C
      IF (SIGMA.LT.S0+DSIG) THEN  
c!  CALCULATE THE T95_06 FIELD (WITH THE
C                                POTENTIAL "PENETRATED" INTERCONNECTION FIELD):

       CALL DIPSHLD(PPS,XX,YY,ZZ,CFX,CFY,CFZ)
       CALL TAILRC96(SPS,XX,YY,ZZ,BXRC,BYRC,BZRC,BXT2,BYT2,BZT2,
     *   BXT3,BYT3,BZT3)
       CALL BIRK1TOT_02(PPS,XX,YY,ZZ,R1X,R1Y,R1Z)
       CALL BIRK2TOT_02(PPS,XX,YY,ZZ,R2X,R2Y,R2Z)
       CALL INTERCON(XX,YS*XAPPA,ZS*XAPPA,RIMFX,RIMFYS,RIMFZS)
       RIMFY=RIMFYS*CT+RIMFZS*ST
       RIMFZ=RIMFZS*CT-RIMFYS*ST
C
      FX=CFX*XAPPA3+RCAMPL*BXRC +TAMPL2*BXT2+TAMPL3*BXT3
     *  +B1AMPL*R1X +B2AMPL*R2X +RIMFAMPL*RIMFX
      FY=CFY*XAPPA3+RCAMPL*BYRC +TAMPL2*BYT2+TAMPL3*BYT3
     *  +B1AMPL*R1Y +B2AMPL*R2Y +RIMFAMPL*RIMFY
      FZ=CFZ*XAPPA3+RCAMPL*BZRC +TAMPL2*BZT2+TAMPL3*BZT3
     *  +B1AMPL*R1Z +B2AMPL*R2Z +RIMFAMPL*RIMFZ
C
C  NOW, LET US CHECK WHETHER WE HAVE THE CASE (1). IF YES - WE ARE DONE:
C
       IF (SIGMA.LT.S0-DSIG) THEN
         BX=FX
         BY=FY
         BZ=FZ
                        ELSE  
c!  THIS IS THE MOST COMPLEX CASE: WE ARE INSIDE
C                                         THE INTERPOLATION REGION
       FINT=0.5d0*(1-(SIGMA-S0)/DSIG)
       FEXT=0.5d0*(1+(SIGMA-S0)/DSIG)
C
       CALL DIPOLE(PS,X,Y,Z,QX,QY,QZ)
       BX=(FX+QX)*FINT+OIMFX*FEXT -QX
       BY=(FY+QY)*FINT+OIMFY*FEXT -QY
       BZ=(FZ+QZ)*FINT+OIMFZ*FEXT -QZ
c
        ENDIF  
c!   THE CASES (1) AND (2) ARE EXHAUSTED; THE ONLY REMAINING
C                      POSSIBILITY IS NOW THE CASE (3):
         ELSE
                CALL DIPOLE(PS,X,Y,Z,QX,QY,QZ)
                BX=OIMFX-QX
                BY=OIMFY-QY
                BZ=OIMFZ-QZ
         ENDIF
C
       RETURN
       END
C=====================================================================

      SUBROUTINE DIPSHLD(PS,X,Y,Z,BX,BY,BZ)
C
C   CALCULATES GSM COMPONENTS OF THE EXTERNAL MAGNETIC FIELD DUE TO
C    SHIELDING OF THE EARTH'S DIPOLE ONLY
C
       IMPLICIT REAL*8 (A-H,O-Z)
       DIMENSION A1(12),A2(12)
      DATA A1 /.24777d0,-27.003d0,-.46815d0,7.0637d0,-1.5918d0,
     :   -.90317d-01,57.522d0,13.757d0,2.0100d0,10.458d0,4.5798d0,
     :   2.1695d0/
      DATA A2/-.65385d0,-18.061d0,-.40457d0,-5.0995d0,1.2846d0,
     :   .78231d-01,39.592d0,13.291d0,1.9970d0,10.062d0,4.5140d0,
     :   2.1558d0/
C
          CPS=DCOS(PS)
          SPS=DSIN(PS)
          CALL CYLHARM(A1,X,Y,Z,HX,HY,HZ)
          CALL CYLHAR1(A2,X,Y,Z,FX,FY,FZ)
C
          BX=HX*CPS+FX*SPS
          BY=HY*CPS+FY*SPS
          BZ=HZ*CPS+FZ*SPS
        RETURN
       END
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  THIS CODE YIELDS THE SHIELDING FIELD FOR THE PERPENDICULAR DIPOLE
C
         SUBROUTINE  CYLHARM( A, X,Y,Z, BX,BY,BZ)
C
C
C   ***  N.A. Tsyganenko ***  Sept. 14-18, 1993; revised March 16, 1994 ***
C
C   An approximation for the Chapman-Ferraro field by a sum of 6 cylin-
c   drical harmonics (see pp. 97-113 in the brown GSFC notebook #1)
c
C      Description of parameters:
C
C  A   - input vector containing model parameters;
C  X,Y,Z   -  input GSM coordinates
C  BX,BY,BZ - output GSM components of the shielding field
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  The 6 linear parameters A(1)-A(6) are amplitudes of the cylindrical harmonic
c       terms.
c  The 6 nonlinear parameters A(7)-A(12) are the corresponding scale lengths
C       for each term (see GSFC brown notebook).
c
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
	 IMPLICIT  REAL * 8  (A - H, O - Z)
C
	 DIMENSION  A(12)
C
           RHO=DSQRT(Y**2+Z**2)
            IF (RHO.LT.1.D-8) THEN
               SINFI=1.D0
               COSFI=0.D0
               RHO=1.D-8
               GOTO 1
            ENDIF
C
           SINFI=Z/RHO
           COSFI=Y/RHO
  1        SINFI2=SINFI**2
           SI2CO2=SINFI2-COSFI**2
C
             BX=0.D0
             BY=0.D0
             BZ=0.D0
C
	   DO 11 I=1,3
             DZETA=RHO/A(I+6)
             XJ0=BES(DZETA,0)
             XJ1=BES(DZETA,1)
             XEXP=DEXP(X/A(I+6))
             BX=BX-A(I)*XJ1*XEXP*SINFI
             BY=BY+A(I)*(2.D0*XJ1/DZETA-XJ0)*XEXP*SINFI*COSFI
             BZ=BZ+A(I)*(XJ1/DZETA*SI2CO2-XJ0*SINFI2)*XEXP
   11        CONTINUE
c
	   DO 12 I=4,6
             DZETA=RHO/A(I+6)
             XKSI=X/A(I+6)
             XJ0=BES(DZETA,0)
             XJ1=BES(DZETA,1)
             XEXP=DEXP(XKSI)
             BRHO=(XKSI*XJ0-(DZETA**2+XKSI-1.D0)*XJ1/DZETA)*XEXP*SINFI
             BPHI=(XJ0+XJ1/DZETA*(XKSI-1.D0))*XEXP*COSFI
             BX=BX+A(I)*(DZETA*XJ0+XKSI*XJ1)*XEXP*SINFI
             BY=BY+A(I)*(BRHO*COSFI-BPHI*SINFI)
             BZ=BZ+A(I)*(BRHO*SINFI+BPHI*COSFI)
   12        CONTINUE
C
c
         RETURN
	 END
C
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
C  THIS CODE YIELDS THE SHIELDING FIELD FOR THE PARALLEL DIPOLE
C
         SUBROUTINE  CYLHAR1(A, X,Y,Z, BX,BY,BZ)
C
C
C   ***  N.A. Tsyganenko ***  Sept. 14-18, 1993; revised March 16, 1994 ***
C
C   An approximation of the Chapman-Ferraro field by a sum of 6 cylin-
c   drical harmonics (see pages 97-113 in the brown GSFC notebook #1)
c
C      Description of parameters:
C
C  A   - input vector containing model parameters;
C  X,Y,Z - input GSM coordinates,
C  BX,BY,BZ - output GSM components of the shielding field
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C      The 6 linear parameters A(1)-A(6) are amplitudes of the cylindrical
c  harmonic terms.
c      The 6 nonlinear parameters A(7)-A(12) are the corresponding scale
c  lengths for each term (see GSFC brown notebook).
c
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
	 IMPLICIT  REAL * 8  (A - H, O - Z)
C
	 DIMENSION  A(12)
C
           RHO=DSQRT(Y**2+Z**2)
            IF (RHO.LT.1.D-10) THEN
               SINFI=1.D0
               COSFI=0.D0
               GOTO 1
            ENDIF
C
           SINFI=Z/RHO
           COSFI=Y/RHO
C
   1      BX=0.D0
          BY=0.D0
          BZ=0.D0
C
             DO 11 I=1,3
             DZETA=RHO/A(I+6)
             XKSI=X/A(I+6)
             XJ0=BES(DZETA,0)
             XJ1=BES(DZETA,1)
             XEXP=DEXP(XKSI)
             BRHO=XJ1*XEXP
             BX=BX-A(I)*XJ0*XEXP
             BY=BY+A(I)*BRHO*COSFI
             BZ=BZ+A(I)*BRHO*SINFI
   11        CONTINUE
c
	   DO 12 I=4,6
             DZETA=RHO/A(I+6)
             XKSI=X/A(I+6)
             XJ0=BES(DZETA,0)
             XJ1=BES(DZETA,1)
             XEXP=DEXP(XKSI)
             BRHO=(DZETA*XJ0+XKSI*XJ1)*XEXP
             BX=BX+A(I)*(DZETA*XJ1-XJ0*(XKSI+1.D0))*XEXP
             BY=BY+A(I)*BRHO*COSFI
             BZ=BZ+A(I)*BRHO*SINFI
   12        CONTINUE
C
         RETURN
	 END

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
      REAL*8 FUNCTION BES(X,K)
      IMPLICIT REAL*8 (A-H,O-Z)
C
      IF (K.EQ.0) THEN
        BES=BES0(X)
        RETURN
      ENDIF
C
      IF (K.EQ.1) THEN
        BES=BES1(X)
        RETURN
      ENDIF
C
      IF (X.EQ.0.D0) THEN
        BES=0.D0
        RETURN
      ENDIF
C
      G=2.D0/X
      IF (X.LE.K) GOTO 10
C
      N=1
      XJN=BES1(X)
      XJNM1=BES0(X)
C
  1   XJNP1=G*N*XJN-XJNM1
      N=N+1
      IF (N.LT.K) GOTO 2
      BES=XJNP1
      RETURN
C
 2    XJNM1=XJN
      XJN=XJNP1
      GOTO 1
C
 10   N=24
      XJN=1.D0
      XJNP1=0.D0
      SUM=0.D0
C
  3   IF (MOD(N,2).EQ.0) SUM=SUM+XJN
      XJNM1=G*N*XJN-XJNP1
      N=N-1
C
      XJNP1=XJN
      XJN=XJNM1
      IF (N.EQ.K) BES=XJN
C
      IF (DABS(XJN).GT.1.D5) THEN
        XJNP1=XJNP1*1.D-5
        XJN=XJN*1.D-5
        SUM=SUM*1.D-5
        IF (N.LE.K) BES=BES*1.D-5
      ENDIF
C
      IF (N.EQ.0) GOTO 4
      GOTO 3
C
  4   SUM=XJN+2.D0*SUM
      BES=BES/SUM
      RETURN
      END
c-------------------------------------------------------------------
c
       REAL*8 FUNCTION BES0(X)
C
        IMPLICIT REAL*8 (A-H,O-Z)
C
        IF (DABS(X).LT.3.D0) THEN
          X32=(X/3.D0)**2
          BES0=1.D0-X32*(2.2499997D0-X32*(1.2656208D0-X32*
     *    (0.3163866D0-X32*(0.0444479D0-X32*(0.0039444D0
     *     -X32*0.00021D0)))))
        ELSE
        XD3=3.D0/X
        F0=0.79788456D0-XD3*(0.00000077D0+XD3*(0.00552740D0+XD3*
     *   (0.00009512D0-XD3*(0.00137237D0-XD3*(0.00072805D0
     *   -XD3*0.00014476D0)))))
        T0=X-0.78539816D0-XD3*(0.04166397D0+XD3*(0.00003954D0-XD3*
     *   (0.00262573D0-XD3*(0.00054125D0+XD3*(0.00029333D0
     *   -XD3*0.00013558D0)))))
        BES0=F0/DSQRT(X)*DCOS(T0)
       ENDIF
       RETURN
       END
c
c--------------------------------------------------------------------------
c
       REAL*8 FUNCTION BES1(X)
C
        IMPLICIT REAL*8 (A-H,O-Z)
C
       IF (DABS(X).LT.3.D0) THEN
        X32=(X/3.D0)**2
        BES1XM1=0.5D0-X32*(0.56249985D0-X32*(0.21093573D0-X32*
     *  (0.03954289D0-X32*(0.00443319D0-X32*(0.00031761D0
     *  -X32*0.00001109D0)))))
         BES1=BES1XM1*X
       ELSE
        XD3=3.D0/X
        F1=0.79788456D0+XD3*(0.00000156D0+XD3*(0.01659667D0+XD3*
     *   (0.00017105D0-XD3*(0.00249511D0-XD3*(0.00113653D0
     *   -XD3*0.00020033D0)))))
        T1=X-2.35619449D0+XD3*(0.12499612D0+XD3*(0.0000565D0-XD3*
     *   (0.00637879D0-XD3*(0.00074348D0+XD3*(0.00079824D0
     *   -XD3*0.00029166D0)))))
        BES1=F1/DSQRT(X)*DCOS(T1)
       ENDIF
       RETURN
       END
C------------------------------------------------------------
C
         SUBROUTINE INTERCON(X,Y,Z,BX,BY,BZ)
C
C      Calculates the potential interconnection field inside the magnetosphere,
c  corresponding to  DELTA_X = 20Re and DELTA_Y = 10Re (NB#3, p.90, 6/6/1996).
C  The position (X,Y,Z) and field components BX,BY,BZ are given in the rotated
c   coordinate system, in which the Z-axis is always directed along the BzIMF
c   (i.e. rotated by the IMF clock angle Theta)
C   It is also assumed that the IMF Bt=1, so that the components should be
c     (i) multiplied by the actual Bt, and
c     (ii) transformed to standard GSM coords by rotating back around X axis
c              by the angle -Theta.
c
C      Description of parameters:
C
C     X,Y,Z -   GSM POSITION
C      BX,BY,BZ - INTERCONNECTION FIELD COMPONENTS INSIDE THE MAGNETOSPHERE
C        OF A STANDARD SIZE (TO TAKE INTO ACCOUNT EFFECTS OF PRESSURE CHANGES,
C         APPLY THE SCALING TRANSFORMATION)
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     The 9 linear parameters are amplitudes of the "cartesian" harmonics
c     The 6 nonlinear parameters are the scales Pi and Ri entering
c    the arguments of exponents, sines, and cosines in the 9 "Cartesian"
c       harmonics (3+3)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
	 IMPLICIT  REAL * 8  (A - H, O - Z)
C
        DIMENSION A(15),RP(3),RR(3),P(3),R(3)
C
      SAVE M,RP,RR
C
      DATA A/-8.411078731d0,5932254.951d0,-9073284.93d0,-11.68794634d0,
     * 6027598.824d0,-9218378.368d0,-6.508798398d0,-11824.42793d0,
     : 18015.66212d0,
     * 7.99754043d0,13.9669886d0,90.24475036d0,16.75728834d0,
     : 1015.645781d0,
     * 1553.493216d0/
C
        DATA M/0/
C
        IF (M.NE.0) GOTO 111
        M=1
C
         P(1)=A(10)
         P(2)=A(11)
         P(3)=A(12)
         R(1)=A(13)
         R(2)=A(14)
         R(3)=A(15)
C
C
           DO 11 I=1,3
            RP(I)=1.D0/P(I)
  11        RR(I)=1.D0/R(I)
C
  111   CONTINUE
C
            L=0
C
               BX=0.d0
               BY=0.d0
               BZ=0.d0
C
c        "PERPENDICULAR" KIND OF SYMMETRY ONLY
C
               DO 2 I=1,3
                  CYPI=DCOS(Y*RP(I))
                  SYPI=DSIN(Y*RP(I))
C
                DO 2 K=1,3
                   SZRK=DSIN(Z*RR(K))
                   CZRK=DCOS(Z*RR(K))
                     SQPR=DSQRT(RP(I)**2+RR(K)**2)
                      EPR=DEXP(X*SQPR)
C
                     HX=-SQPR*EPR*CYPI*SZRK
                     HY=RP(I)*EPR*SYPI*SZRK
                     HZ=-RR(K)*EPR*CYPI*CZRK
             L=L+1
c
          BX=BX+A(L)*HX
          BY=BY+A(L)*HY
          BZ=BZ+A(L)*HZ
  2   CONTINUE
C
      RETURN
      END

C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      SUBROUTINE TAILRC96(SPS,X,Y,Z,BXRC,BYRC,BZRC,BXT2,BYT2,BZT2,
     *   BXT3,BYT3,BZT3)
c
c  COMPUTES THE COMPONENTS OF THE FIELD OF THE MODEL RING CURRENT AND THREE
c                   TAIL MODES WITH UNIT AMPLITUDES
C      (FOR THE RING CURRENT, IT MEANS THE DISTURBANCE OF Bz=-1nT AT ORIGIN,
C   AND FOR THE TAIL MODES IT MEANS MAXIMAL BX JUST ABOVE THE SHEET EQUAL 1 nT.
C
         IMPLICIT REAL*8 (A-H,O-Z)
         DIMENSION ARC(48),ATAIL2(48),ATAIL3(48)
         COMMON /WARP/ CPSS,SPSS,DPSRR,RPS,WARP,D,XS,ZS,DXSX,DXSY,DXSZ,
     *   DZSX,DZSY,DZSZ,DZETAS,DDZETADX,DDZETADY,DDZETADZ,ZSWW
C
         DATA ARC/-3.087699646d0,3.516259114d0,18.81380577d0,
     :  -13.95772338d0,-5.497076303d0,0.1712890838d0,2.392629189d0,
     :  -2.728020808d0,-14.79349936d0,11.08738083d0,4.388174084d0,
     :  0.2492163197d-01,0.7030375685d0,-.7966023165d0,
     :  -3.835041334d0,2.642228681d0,-0.2405352424d0,-0.7297705678d0,
     :  -0.3680255045d0,0.1333685557d0,2.795140897d0,-1.078379954d0,
     :  0.8014028630d0,0.1245825565d0,0.6149982835d0,-0.2207267314d0,
     :  -4.424578723d0,1.730471572d0,-1.716313926d0,-0.2306302941d0,
     :  -0.2450342688d0,0.8617173961d-01,1.54697858d0,
     :  -0.6569391113d0,-0.6537525353d0,0.2079417515d0,12.75434981d0,
     :  11.37659788d0,636.4346279d0,1.752483754d0,3.604231143d0,
     :  12.83078674d0,7.412066636d0,9.434625736d0,676.7557193d0,
     :  1.701162737d0,3.580307144d0,14.64298662d0/
C
        DATA ATAIL2/.8747515218d0,-.9116821411d0,2.209365387d0,
     : -2.159059518d0,-7.059828867d0,5.924671028d0,-1.916935691d0,
     : 1.996707344d0,-3.877101873d0,3.947666061d0,11.38715899d0,
     : -8.343210833d0,1.194109867d0,-1.244316975d0,3.73895491d0,
     : -4.406522465d0,-20.66884863d0,3.020952989d0,.2189908481d0,
     : -.09942543549d0,-.927225562d0,.1555224669d0,.6994137909d0,
     : -.08111721003d0,-.7565493881d0,.4686588792d0,4.266058082d0,
     : -.3717470262d0,-3.920787807d0,.02298569870d0,.7039506341d0,
     : -.5498352719d0,-6.675140817d0,.8279283559d0,-2.234773608d0,
     : -1.622656137d0,5.187666221d0,6.802472048d0,39.13543412d0,
     : 2.784722096d0,6.979576616d0,25.71716760d0,4.495005873d0,
     : 8.068408272d0,93.47887103d0,4.158030104d0,9.313492566d0,
     :57.18240483d0/
C
        DATA ATAIL3/-19091.95061d0,-3011.613928d0,20582.16203d0,
     : 4242.918430d0,-2377.091102d0,-1504.820043d0,19884.04650d0,
     : 2725.150544d0,-21389.04845d0,-3990.475093d0,2401.610097d0,
     : 1548.171792d0,-946.5493963d0,490.1528941d0,986.9156625d0,
     : -489.3265930d0,-67.99278499d0,8.711175710d0,-45.15734260d0,
     : -10.76106500d0,210.7927312d0,11.41764141d0,-178.0262808d0,
     : .7558830028d0,339.3806753d0,9.904695974d0,69.50583193d0,
     : -118.0271581d0,22.85935896d0,45.91014857d0,-425.6607164d0,
     : 15.47250738d0,118.2988915d0,65.58594397d0,-201.4478068d0,
     : -14.57062940d0,19.69877970d0,20.30095680d0,86.45407420d0,
     : 22.50403727d0,23.41617329d0,48.48140573d0,24.61031329d0,
     : 123.5395974d0,223.5367692d0,39.50824342d0,65.83385762d0,
     : 266.2948657d0/
C
       DATA RH,DR,G,D0,DELTADY/9.d0,4.d0,10.d0,2.d0,10.d0/
C
C   TO ECONOMIZE THE CODE, WE FIRST CALCULATE COMMON VARIABLES, WHICH ARE
C      THE SAME FOR ALL MODES, AND PUT THEM IN THE COMMON-BLOCK /WARP/
C
       DR2=DR*DR
       C11=DSQRT((1.D0+RH)**2+DR2)
       C12=DSQRT((1.D0-RH)**2+DR2)
       C1=C11-C12
       SPSC1=SPS/C1
       RPS=0.5d0*(C11+C12)*SPS  
c!  THIS IS THE SHIFT OF OF THE SHEET WITH RESPECT
C                            TO GSM EQ.PLANE FOR THE 3RD (ASYMPTOTIC) TAIL MODE
C
        R=DSQRT(X*X+Y*Y+Z*Z)
        SQ1=DSQRT((R+RH)**2+DR2)
        SQ2=DSQRT((R-RH)**2+DR2)
        C=SQ1-SQ2
        CS=(R+RH)/SQ1-(R-RH)/SQ2
        SPSS=SPSC1/R*C
        CPSS=DSQRT(1.D0-SPSS**2)
        DPSRR=SPS/(R*R)*(CS*R-C)/DSQRT((R*C1)**2-(C*SPS)**2)
C
        WFAC=Y/(Y**4+1.D4)   
c!   WARPING
        W=WFAC*Y**3
        WS=4.D4*Y*WFAC**2
        WARP=G*SPS*W
        XS=X*CPSS-Z*SPSS
        ZSWW=Z*CPSS+X*SPSS  
c! "WW" MEANS "WITHOUT Y-Z WARPING" (IN X-Z ONLY)
        ZS=ZSWW +WARP

        DXSX=CPSS-X*ZSWW*DPSRR
        DXSY=-Y*ZSWW*DPSRR
        DXSZ=-SPSS-Z*ZSWW*DPSRR
        DZSX=SPSS+X*XS*DPSRR
        DZSY=XS*Y*DPSRR  +G*SPS*WS  
c!  THE LAST TERM IS FOR THE Y-Z WARP
        DZSZ=CPSS+XS*Z*DPSRR        
c!      (TAIL MODES ONLY)

        D=D0+DELTADY*(Y/20.D0)**2   
c!  SHEET HALF-THICKNESS FOR THE TAIL MODES
        DDDY=DELTADY*Y*0.005D0      
c!  (THICKENS TO FLANKS, BUT NO VARIATION
C                                         ALONG X, IN CONTRAST TO RING CURRENT)
C
        DZETAS=DSQRT(ZS**2+D**2)  
c!  THIS IS THE SAME SIMPLE WAY TO SPREAD
C                                        OUT THE SHEET, AS THAT USED IN T89
        DDZETADX=ZS*DZSX/DZETAS
        DDZETADY=(ZS*DZSY+D*DDDY)/DZETAS
        DDZETADZ=ZS*DZSZ/DZETAS
C
        CALL SHLCAR3X3(ARC,X,Y,Z,SPS,WX,WY,WZ)
        CALL RINGCURR96(X,Y,Z,HX,HY,HZ)
        BXRC=WX+HX
        BYRC=WY+HY
        BZRC=WZ+HZ
C
        CALL SHLCAR3X3(ATAIL2,X,Y,Z,SPS,WX,WY,WZ)
        CALL TAILDISK(X,Y,Z,HX,HY,HZ)
        BXT2=WX+HX
        BYT2=WY+HY
        BZT2=WZ+HZ
C
        CALL SHLCAR3X3(ATAIL3,X,Y,Z,SPS,WX,WY,WZ)
        CALL TAIL87(X,Z,HX,HZ)
        BXT3=WX+HX
        BYT3=WY
        BZT3=WZ+HZ
C
        RETURN
        END
C
c********************************************************************
C
        SUBROUTINE RINGCURR96(X,Y,Z,BX,BY,BZ)
c
c       THIS SUBROUTINE COMPUTES THE COMPONENTS OF THE RING CURRENT FIELD,
C        SIMILAR TO THAT DESCRIBED BY TSYGANENKO AND PEREDO (1994).  THE
C          DIFFERENCE IS THAT NOW WE USE SPACEWARPING, AS DESCRIBED IN THE
C           PAPER ON MODELING BIRKELAND CURRENTS (TSYGANENKO AND STERN, 1996),
C            INSTEAD OF SHEARING IT IN THE SPIRIT OF THE T89 TAIL MODEL.
C
C          IN  ADDITION, INSTEAD OF 7 TERMS FOR THE RING CURRENT MODEL, WE USE
C             NOW ONLY 2 TERMS;  THIS SIMPLIFICATION ALSO GIVES RISE TO AN
C                EASTWARD RING CURRENT LOCATED EARTHWARD FROM THE MAIN ONE,
C                  IN LINE WITH WHAT IS ACTUALLY OBSERVED
C
C             FOR DETAILS, SEE NB #3, PAGES 70-73
C
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION F(2),BETA(2)
        COMMON /WARP/ CPSS,SPSS,DPSRR, XNEXT(3),XS,ZSWARPED,DXSX,DXSY,
     *   DXSZ,DZSX,DZSYWARPED,DZSZ,OTHER(4),ZS  
c!  ZS HERE IS WITHOUT Y-Z WARP
C

      DATA D0,DELTADX,XD,XLDX /2.d0,0.d0,0.,4.d0/  
c!  ACHTUNG !!  THE RC IS NOW
C                                            COMPLETELY SYMMETRIC (DELTADX=0)

C
        DATA F,BETA /569.895366D0,-1603.386993D0,2.722188D0,3.766875D0/
C
C  THE ORIGINAL VALUES OF F(I) WERE MULTIPLIED BY BETA(I) (TO REDUCE THE
C     NUMBER OF MULTIPLICATIONS BELOW)  AND BY THE FACTOR -0.43, NORMALIZING
C      THE DISTURBANCE AT ORIGIN  TO  B=-1nT
C
           DZSY=XS*Y*DPSRR  
c! NO WARPING IN THE Y-Z PLANE (ALONG X ONLY), AND
C                         THIS IS WHY WE DO NOT USE  DZSY FROM THE COMMON-BLOCK
           XXD=X-XD
           FDX=0.5D0*(1.D0+XXD/DSQRT(XXD**2+XLDX**2))
           DDDX=DELTADX*0.5D0*XLDX**2/DSQRT(XXD**2+XLDX**2)**3
           D=D0+DELTADX*FDX

           DZETAS=DSQRT(ZS**2+D**2)  
c!  THIS IS THE SAME SIMPLE WAY TO SPREAD
C                                        OUT THE SHEET, AS THAT USED IN T89
           RHOS=DSQRT(XS**2+Y**2)
           DDZETADX=(ZS*DZSX+D*DDDX)/DZETAS
           DDZETADY=ZS*DZSY/DZETAS
           DDZETADZ=ZS*DZSZ/DZETAS
         IF (RHOS.LT.1.D-5) THEN
            DRHOSDX=0.D0
            DRHOSDY=DSIGN(1.D0,Y)
            DRHOSDZ=0.D0
          ELSE
           DRHOSDX=XS*DXSX/RHOS
           DRHOSDY=(XS*DXSY+Y)/RHOS
           DRHOSDZ=XS*DXSZ/RHOS
         ENDIF
C
           BX=0.D0
           BY=0.D0
           BZ=0.D0
C
           DO 1 I=1,2
C
           BI=BETA(I)
C
           S1=DSQRT((DZETAS+BI)**2+(RHOS+BI)**2)
           S2=DSQRT((DZETAS+BI)**2+(RHOS-BI)**2)
           DS1DDZ=(DZETAS+BI)/S1
           DS2DDZ=(DZETAS+BI)/S2
           DS1DRHOS=(RHOS+BI)/S1
           DS2DRHOS=(RHOS-BI)/S2
C
           DS1DX=DS1DDZ*DDZETADX+DS1DRHOS*DRHOSDX
           DS1DY=DS1DDZ*DDZETADY+DS1DRHOS*DRHOSDY
           DS1DZ=DS1DDZ*DDZETADZ+DS1DRHOS*DRHOSDZ
C
           DS2DX=DS2DDZ*DDZETADX+DS2DRHOS*DRHOSDX
           DS2DY=DS2DDZ*DDZETADY+DS2DRHOS*DRHOSDY
           DS2DZ=DS2DDZ*DDZETADZ+DS2DRHOS*DRHOSDZ
C
           S1TS2=S1*S2
           S1PS2=S1+S2
           S1PS2SQ=S1PS2**2
           FAC1=DSQRT(S1PS2SQ-(2.D0*BI)**2)
           AS=FAC1/(S1TS2*S1PS2SQ)
           TERM1=1.D0/(S1TS2*S1PS2*FAC1)
           FAC2=AS/S1PS2SQ
           DASDS1=TERM1-FAC2/S1*(S2*S2+S1*(3.D0*S1+4.D0*S2))
           DASDS2=TERM1-FAC2/S2*(S1*S1+S2*(3.D0*S2+4.D0*S1))
C
           DASDX=DASDS1*DS1DX+DASDS2*DS2DX
           DASDY=DASDS1*DS1DY+DASDS2*DS2DY
           DASDZ=DASDS1*DS1DZ+DASDS2*DS2DZ
C
      BX=BX+F(I)*((2.D0*AS+Y*DASDY)*SPSS-XS*DASDZ
     *   +AS*DPSRR*(Y**2*CPSS+Z*ZS))
      BY=BY-F(I)*Y*(AS*DPSRR*XS+DASDZ*CPSS+DASDX*SPSS)
  1   BZ=BZ+F(I)*((2.D0*AS+Y*DASDY)*CPSS+XS*DASDX
     *   -AS*DPSRR*(X*ZS+Y**2*SPSS))
C
       RETURN
       END
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
         SUBROUTINE TAILDISK(X,Y,Z,BX,BY,BZ)
C
c
c       THIS SUBROUTINE COMPUTES THE COMPONENTS OF THE TAIL CURRENT FIELD,
C        SIMILAR TO THAT DESCRIBED BY TSYGANENKO AND PEREDO (1994).  THE
C          DIFFERENCE IS THAT NOW WE USE SPACEWARPING, AS DESCRIBED IN OUR
C           PAPER ON MODELING BIRKELAND CURRENTS (TSYGANENKO AND STERN, 1996)
C            INSTEAD OF SHEARING IT IN THE SPIRIT OF T89 TAIL MODEL.
C
C          IN  ADDITION, INSTEAD OF 8 TERMS FOR THE TAIL CURRENT MODEL, WE USE
C           NOW ONLY 4 TERMS
C
C             FOR DETAILS, SEE NB #3, PAGES 74-
C
         IMPLICIT REAL*8 (A-H,O-Z)
         DIMENSION F(4),BETA(4)
         COMMON /WARP/ CPSS,SPSS,DPSRR,XNEXT(3),XS,ZS,DXSX,DXSY,DXSZ,
     *    OTHER(3),DZETAS,DDZETADX,DDZETADY,DDZETADZ,ZSWW
C
         DATA XSHIFT /4.5d0/
C
         DATA F,BETA
     * / -745796.7338D0,1176470.141D0,-444610.529D0,-57508.01028D0,
     *   7.9250000D0,8.0850000D0,8.4712500D0,27.89500D0/
c
c  here original F(I) are multiplied by BETA(I), to economize
c    calculations
C
           RHOS=DSQRT((XS-XSHIFT)**2+Y**2)
         IF (RHOS.LT.1.D-5) THEN
            DRHOSDX=0.D0
            DRHOSDY=DSIGN(1.D0,Y)
            DRHOSDZ=0.D0
         ELSE
           DRHOSDX=(XS-XSHIFT)*DXSX/RHOS
           DRHOSDY=((XS-XSHIFT)*DXSY+Y)/RHOS
           DRHOSDZ=(XS-XSHIFT)*DXSZ/RHOS
         ENDIF
C
           BX=0.D0
           BY=0.D0
           BZ=0.D0
C
           DO 1 I=1,4
C
           BI=BETA(I)
C
           S1=DSQRT((DZETAS+BI)**2+(RHOS+BI)**2)
           S2=DSQRT((DZETAS+BI)**2+(RHOS-BI)**2)
           DS1DDZ=(DZETAS+BI)/S1
           DS2DDZ=(DZETAS+BI)/S2
           DS1DRHOS=(RHOS+BI)/S1
           DS2DRHOS=(RHOS-BI)/S2
C
           DS1DX=DS1DDZ*DDZETADX+DS1DRHOS*DRHOSDX
           DS1DY=DS1DDZ*DDZETADY+DS1DRHOS*DRHOSDY
           DS1DZ=DS1DDZ*DDZETADZ+DS1DRHOS*DRHOSDZ
C
           DS2DX=DS2DDZ*DDZETADX+DS2DRHOS*DRHOSDX
           DS2DY=DS2DDZ*DDZETADY+DS2DRHOS*DRHOSDY
           DS2DZ=DS2DDZ*DDZETADZ+DS2DRHOS*DRHOSDZ
C
           S1TS2=S1*S2
           S1PS2=S1+S2
           S1PS2SQ=S1PS2**2
           FAC1=DSQRT(S1PS2SQ-(2.D0*BI)**2)
           AS=FAC1/(S1TS2*S1PS2SQ)
           TERM1=1.D0/(S1TS2*S1PS2*FAC1)
           FAC2=AS/S1PS2SQ
           DASDS1=TERM1-FAC2/S1*(S2*S2+S1*(3.D0*S1+4.D0*S2))
           DASDS2=TERM1-FAC2/S2*(S1*S1+S2*(3.D0*S2+4.D0*S1))
C
           DASDX=DASDS1*DS1DX+DASDS2*DS2DX
           DASDY=DASDS1*DS1DY+DASDS2*DS2DY
           DASDZ=DASDS1*DS1DZ+DASDS2*DS2DZ
C
      BX=BX+F(I)*((2.D0*AS+Y*DASDY)*SPSS-(XS-XSHIFT)*DASDZ
     *   +AS*DPSRR*(Y**2*CPSS+Z*ZSWW))
C
      BY=BY-F(I)*Y*(AS*DPSRR*XS+DASDZ*CPSS+DASDX*SPSS)
  1   BZ=BZ+F(I)*((2.D0*AS+Y*DASDY)*CPSS+(XS-XSHIFT)*DASDX
     *   -AS*DPSRR*(X*ZSWW+Y**2*SPSS))

       RETURN
       END

C-------------------------------------------------------------------------
C
      SUBROUTINE TAIL87(X,Z,BX,BZ)

      IMPLICIT REAL*8 (A-H,O-Z)

      COMMON /WARP/ FIRST(3), RPS,WARP,D, OTHER(13)
C
C      'LONG' VERSION OF THE 1987 TAIL MAGNETIC FIELD MODEL
C              (N.A.TSYGANENKO, PLANET. SPACE SCI., V.35, P.1347, 1987)
C
C      D   IS THE Y-DEPENDENT SHEET HALF-THICKNESS (INCREASING TOWARDS FLANKS)
C      RPS  IS THE TILT-DEPENDENT SHIFT OF THE SHEET IN THE Z-DIRECTION,
C           CORRESPONDING TO THE ASYMPTOTIC HINGING DISTANCE, DEFINED IN THE
C           MAIN SUBROUTINE (TAILRC96) FROM THE PARAMETERS RH AND DR OF THE
C           T96-TYPE MODULE, AND
C      WARP  IS THE BENDING OF THE SHEET FLANKS IN THE Z-DIRECTION, DIRECTED
C           OPPOSITE TO RPS, AND INCREASING WITH DIPOLE TILT AND |Y|
C

        DATA DD/3.d0/
C
      DATA HPI,RT,XN,X1,X2,B0,B1,B2,XN21,XNR,ADLN
     * /1.5707963d0,40.d0,-10.d0,
     * -1.261d0,-0.663d0,0.391734d0,5.89715d0,24.6833d0,76.37d0,
     : -0.1071d0,0.13238005d0/
C                !!!   THESE ARE NEW VALUES OF  X1, X2, B0, B1, B2,
C                       CORRESPONDING TO TSCALE=1, INSTEAD OF TSCALE=0.6
C
C  THE ABOVE QUANTITIES WERE DEFINED AS FOLLOWS:------------------------
C       HPI=PI/2
C       RT=40.      !  Z-POSITION OF UPPER AND LOWER ADDITIONAL SHEETS
C       XN=-10.     !  INNER EDGE POSITION
C
C       TSCALE=1  !  SCALING FACTOR, DEFINING THE RATE OF INCREASE OF THE
C                       CURRENT DENSITY TAILWARDS
C
c  ATTENTION !  NOW I HAVE CHANGED TSCALE TO:  TSCALE=1.0, INSTEAD OF 0.6
c                  OF THE PREVIOUS VERSION
c
C       B0=0.391734
C       B1=5.89715 *TSCALE
C       B2=24.6833 *TSCALE**2
C
C    HERE ORIGINAL VALUES OF THE MODE AMPLITUDES (P.77, NB#3) WERE NORMALIZED
C      SO THAT ASYMPTOTIC  BX=1  AT X=-200RE
C
C      X1=(4.589  -5.85) *TSCALE -(TSCALE-1.)*XN ! NONLINEAR PARAMETERS OF THE
C                                                         CURRENT FUNCTION
C      X2=(5.187  -5.85) *TSCALE -(TSCALE-1.)*XN
c
c
C      XN21=(XN-X1)**2
C      XNR=1./(XN-X2)
C      ADLN=-DLOG(XNR**2*XN21)
C
C---------------------------------------------------------------
C
      ZS=Z -RPS +WARP
      ZP=Z-RT
      ZM=Z+RT
C
      XNX=XN-X
      XNX2=XNX**2
      XC1=X-X1
      XC2=X-X2
      XC22=XC2**2
      XR2=XC2*XNR
      XC12=XC1**2
      D2=DD**2    
c!  SQUARE OF THE TOTAL HALFTHICKNESS (DD=3Re for this mode)
      B20=ZS**2+D2
      B2P=ZP**2+D2
      B2M=ZM**2+D2
      B=DSQRT(B20)
      BP=DSQRT(B2P)
      BM=DSQRT(B2M)
      XA1=XC12+B20
      XAP1=XC12+B2P
      XAM1=XC12+B2M
      XA2=1.d0/(XC22+B20)
      XAP2=1.d0/(XC22+B2P)
      XAM2=1.d0/(XC22+B2M)
      XNA=XNX2+B20
      XNAP=XNX2+B2P
      XNAM=XNX2+B2M
      F=B20-XC22
      FP=B2P-XC22
      FM=B2M-XC22
      XLN1=DLOG(XN21/XNA)
      XLNP1=DLOG(XN21/XNAP)
      XLNM1=DLOG(XN21/XNAM)
      XLN2=XLN1+ADLN
      XLNP2=XLNP1+ADLN
      XLNM2=XLNM1+ADLN
      ALN=0.25d0*(XLNP1+XLNM1-2.d0*XLN1)
      S0=(DATAN(XNX/B)+HPI)/B
      S0P=(DATAN(XNX/BP)+HPI)/BP
      S0M=(DATAN(XNX/BM)+HPI)/BM
      S1=(XLN1*.5d0+XC1*S0)/XA1
      S1P=(XLNP1*.5d0+XC1*S0P)/XAP1
      S1M=(XLNM1*.5d0+XC1*S0M)/XAM1
      S2=(XC2*XA2*XLN2-XNR-F*XA2*S0)*XA2
      S2P=(XC2*XAP2*XLNP2-XNR-FP*XAP2*S0P)*XAP2
      S2M=(XC2*XAM2*XLNM2-XNR-FM*XAM2*S0M)*XAM2
      G1=(B20*S0-0.5d0*XC1*XLN1)/XA1
      G1P=(B2P*S0P-0.5d0*XC1*XLNP1)/XAP1
      G1M=(B2M*S0M-0.5d0*XC1*XLNM1)/XAM1
      G2=((0.5d0*F*XLN2+2.d0*S0*B20*XC2)*XA2+XR2)*XA2
      G2P=((0.5d0*FP*XLNP2+2.d0*S0P*B2P*XC2)*XAP2+XR2)*XAP2
      G2M=((0.5d0*FM*XLNM2+2.d0*S0M*B2M*XC2)*XAM2+XR2)*XAM2
      BX=B0*(ZS*S0-0.5d0*(ZP*S0P+ZM*S0M))
     : +B1*(ZS*S1-0.5d0*(ZP*S1P+ZM*S1M))
     : +B2*(ZS*S2-0.5d0*(ZP*S2P+ZM*S2M))
      BZ=B0*ALN+B1*(G1-0.5d0*(G1P+G1M))+B2*(G2-0.5d0*(G2P+G2M))
C
C    CALCULATION OF THE MAGNETOTAIL CURRENT CONTRIBUTION IS FINISHED
C
      RETURN
      END

C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C THIS CODE RETURNS THE SHIELDING FIELD REPRESENTED BY  2x3x3=18 "CARTESIAN"
C    HARMONICS
C
         SUBROUTINE  SHLCAR3X3(A,X,Y,Z,SPS,HX,HY,HZ)
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  The 36 coefficients enter in pairs in the amplitudes of the "cartesian"
c    harmonics (A(1)-A(36).
c  The 12 nonlinear parameters (A(37)-A(48) are the scales Pi,Ri,Qi,and Si
C   entering the arguments of exponents, sines, and cosines in each of the
C   18 "Cartesian" harmonics
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
	 IMPLICIT  REAL * 8  (A - H, O - Z)
C
         DIMENSION A(48)
C
          CPS=DSQRT(1.D0-SPS**2)
          S3PS=4.D0*CPS**2-1.D0   
c!  THIS IS SIN(3*PS)/SIN(PS)
C
           HX=0.D0
           HY=0.D0
           HZ=0.D0
           L=0
C
           DO 1 M=1,2     
c!    M=1 IS FOR THE 1ST SUM ("PERP." SYMMETRY)
C                           AND M=2 IS FOR THE SECOND SUM ("PARALL." SYMMETRY)
             DO 2 I=1,3
                  P=A(36+I)
                  Q=A(42+I)
                  CYPI=DCOS(Y/P)
                  CYQI=DCOS(Y/Q)
                  SYPI=DSIN(Y/P)
                  SYQI=DSIN(Y/Q)
C
              DO 3 K=1,3
                   R=A(39+K)
                   S=A(45+K)
                   SZRK=DSIN(Z/R)
                   CZSK=DCOS(Z/S)
                   CZRK=DCOS(Z/R)
                   SZSK=DSIN(Z/S)
                     SQPR=DSQRT(1.D0/P**2+1.D0/R**2)
                     SQQS=DSQRT(1.D0/Q**2+1.D0/S**2)
                        EPR=DEXP(X*SQPR)
                        EQS=DEXP(X*SQQS)
C
                   DO 4 N=1,2  
c! N=1 IS FOR THE FIRST PART OF EACH COEFFICIENT
C                                  AND N=2 IS FOR THE SECOND ONE
C
                    L=L+1
                     IF (M.EQ.1) THEN
                       IF (N.EQ.1) THEN
                         DX=-SQPR*EPR*CYPI*SZRK
                         DY=EPR/P*SYPI*SZRK
                         DZ=-EPR/R*CYPI*CZRK
                         HX=HX+A(L)*DX
                         HY=HY+A(L)*DY
                         HZ=HZ+A(L)*DZ
                                   ELSE
                         DX=DX*CPS
                         DY=DY*CPS
                         DZ=DZ*CPS
                         HX=HX+A(L)*DX
                         HY=HY+A(L)*DY
                         HZ=HZ+A(L)*DZ
                                   ENDIF
                     ELSE
                       IF (N.EQ.1) THEN
                         DX=-SPS*SQQS*EQS*CYQI*CZSK
                         DY=SPS*EQS/Q*SYQI*CZSK
                         DZ=SPS*EQS/S*CYQI*SZSK
                         HX=HX+A(L)*DX
                         HY=HY+A(L)*DY
                         HZ=HZ+A(L)*DZ
                                   ELSE
                         DX=DX*S3PS
                         DY=DY*S3PS
                         DZ=DZ*S3PS
                         HX=HX+A(L)*DX
                         HY=HY+A(L)*DY
                         HZ=HZ+A(L)*DZ
                       ENDIF
                 ENDIF
c
  4   CONTINUE
  3   CONTINUE
  2   CONTINUE
  1   CONTINUE
C
         RETURN
	 END

C
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C
       SUBROUTINE BIRK1TOT_02(PS,X,Y,Z,BX,BY,BZ)
C
C  THIS IS THE SECOND VERSION OF THE ANALYTICAL MODEL OF THE REGION 1 FIELD
C   BASED ON A SEPARATE REPRESENTATION OF THE POTENTIAL FIELD IN THE INNER AND
C   OUTER SPACE, MAPPED BY MEANS OF A SPHERO-DIPOLAR COORDINATE SYSTEM (NB #3,
C   P.91).   THE DIFFERENCE FROM THE FIRST ONE IS THAT INSTEAD OF OCTAGONAL
C   CURRENT LOOPS, CIRCULAR ONES ARE USED IN THIS VERSION FOR APPROXIMATING THE
C   FIELD IN THE OUTER REGION, WHICH IS FASTER.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION D1(3,26),D2(3,79),XI(4),C1(26),C2(79)

         COMMON /COORD11/ XX1(12),YY1(12)
         COMMON /RHDR/ RH,DR
         COMMON /LOOPDIP1/ TILT,XCENTRE(2),RADIUS(2), DIPX,DIPY
C
         COMMON /COORD21/ XX2(14),YY2(14),ZZ2(14)
         COMMON /DX1/ DX,SCALEIN,SCALEOUT
C
      DATA C1/-0.911582d-03,-0.376654d-02,-0.727423d-02,-0.270084d-02,
     * -0.123899d-02,-0.154387d-02,-0.340040d-02,-0.191858d-01,
     * -0.518979d-01,0.635061d-01,0.440680d0,-0.396570d0,0.561238d-02,
     *  0.160938d-02,-0.451229d-02,-0.251810d-02,-0.151599d-02,
     * -0.133665d-02,-0.962089d-03,-0.272085d-01,-0.524319d-01,
     *  0.717024d-01,0.523439d0,-0.405015d0,-89.5587d0,23.2806d0/

C
      DATA C2/6.04133d0,.305415d0,.606066d-02,.128379d-03,-.179406d-04,
     * 1.41714d0,-27.2586d0,-4.28833d0,-1.30675d0,35.5607d0,8.95792d0,
     : .961617d-03,
     * -.801477d-03,-.782795d-03,-1.65242d0,-16.5242d0,-5.33798d0,
     : .424878d-03,
     * .331787d-03,-.704305d-03,.844342d-03,.953682d-04,.886271d-03,
     * 25.1120d0,20.9299d0,5.14569d0,-44.1670d0,-51.0672d0,-1.87725d0,
     : 20.2998d0,
     * 48.7505d0,-2.97415d0,3.35184d0,-54.2921d0,-.838712d0,-10.5123d0,
     : 70.7594d0,
     * -4.94104d0,.106166d-03,.465791d-03,-.193719d-03,10.8439d0,
     : -29.7968d0,
     *  8.08068d0,.463507d-03,-.224475d-04,.177035d-03,-.317581d-03,
     * -.264487d-03,.102075d-03,7.71390d0,10.1915d0,-4.99797d0,
     : -23.1114d0,
     * -29.2043d0,12.2928d0,10.9542d0,33.6671d0,-9.3851d0,.174615d-03,
     : -.789777d-06,
     * .686047d-03,.460104d-04,-.345216d-02,.221871d-02,.110078d-01,
     * -.661373d-02,.249201d-02,.343978d-01,-.193145d-05,.493963d-05,
     * -.535748d-04,.191833d-04,-.100496d-03,-.210103d-03,-.232195d-02,
     * .315335d-02,-.134320d-01,-.263222d-01/
c
      DATA TILT,XCENTRE,RADIUS,DIPX,DIPY /1.00891d0,2.28397d0,
     : -5.60831d0,
     * 1.86106d0,7.83281d0,1.12541d0,0.945719d0/

      DATA DX,SCALEIN,SCALEOUT /-0.16D0,0.08D0,0.4D0/
      DATA XX1/-11.D0,2*-7.D0,2*-3.D0,3*1.D0,2*5.D0,2*9.D0/
      DATA YY1/2.D0,0.D0,4.D0,2.D0,6.D0,0.D0,4.D0,8.D0,2.D0,6.D0,0.D0,
     *  4.D0/
      DATA XX2/-10.D0,-7.D0,2*-4.D0,0.D0,2*4.D0,7.D0,10.D0,5*0.D0/
      DATA YY2/3.D0,6.D0,3.D0,9.D0,6.D0,3.D0,9.D0,6.D0,3.D0,5*0.D0/
      DATA ZZ2/2*20.D0,4.D0,20.D0,2*4.D0,3*20.D0,2.D0,3.D0,4.5D0,
     *  7.D0,10.D0/
C
      DATA RH,DR /9.D0,4.D0/   
c!  RH IS THE "HINGING DISTANCE" AND DR IS THE
C                                TRANSITION SCALE LENGTH, DEFINING THE
C                                CURVATURE  OF THE WARPING (SEE P.89, NB #2)
C
      DATA XLTDAY,XLTNGHT /78.D0,70.D0/  
c!  THESE ARE LATITUDES OF THE R-1 OVAL
C                                             AT NOON AND AT MIDNIGHT
      DATA DTET0 /0.034906d0/   
c!   THIS IS THE LATITUDINAL HALF-THICKNESS OF THE
C                                  R-1 OVAL (THE INTERPOLATION REGION BETWEEN
C                                    THE HIGH-LAT. AND THE PLASMA SHEET)
C
        TNOONN=(90.D0-XLTDAY)*0.01745329D0
        TNOONS=3.141592654D0-TNOONN     
c! HERE WE ASSUME THAT THE POSITIONS OF
C                                          THE NORTHERN AND SOUTHERN R-1 OVALS
C                                          ARE SYMMETRIC IN THE SM-COORDINATES
        DTETDN=(XLTDAY-XLTNGHT)*0.01745329D0
        DR2=DR**2
C
      SPS=DSIN(PS)
      R2=X**2+Y**2+Z**2
      R=DSQRT(R2)
      R3=R*R2
C
      RMRH=R-RH
      RPRH=R+RH
      SQM=DSQRT(RMRH**2+DR2)
      SQP=DSQRT(RPRH**2+DR2)
      C=SQP-SQM
      Q=DSQRT((RH+1.D0)**2+DR2)-DSQRT((RH-1.D0)**2+DR2)
      SPSAS=SPS/R*C/Q
      CPSAS=DSQRT(1.D0-SPSAS**2)
       XAS = X*CPSAS-Z*SPSAS
       ZAS = X*SPSAS+Z*CPSAS
        IF (XAS.NE.0.D0.OR.Y.NE.0.D0) THEN
          PAS = DATAN2(Y,XAS)
                                      ELSE
          PAS=0.D0
        ENDIF
C
      TAS=DATAN2(DSQRT(XAS**2+Y**2),ZAS)
      STAS=DSIN(TAS)
      F=STAS/(STAS**6*(1.D0-R3)+R3)**0.1666666667D0
C
      TET0=DASIN(F)
      IF (TAS.GT.1.5707963D0) TET0=3.141592654D0-TET0
      DTET=DTETDN*DSIN(PAS*0.5D0)**2
      TETR1N=TNOONN+DTET
      TETR1S=TNOONS-DTET
C
C NOW LET'S DEFINE WHICH OF THE FOUR REGIONS (HIGH-LAT., NORTHERN PSBL,
C   PLASMA SHEET, SOUTHERN PSBL) DOES THE POINT (X,Y,Z) BELONG TO:
C
       IF (TET0.LT.TETR1N-DTET0.OR.TET0.GT.TETR1S+DTET0)  LOC=1 
c! HIGH-LAT.
       IF (TET0.GT.TETR1N+DTET0.AND.TET0.LT.TETR1S-DTET0) LOC=2 
c! PL.SHEET
       IF (TET0.GE.TETR1N-DTET0.AND.TET0.LE.TETR1N+DTET0) LOC=3 
c! NORTH PSBL
       IF (TET0.GE.TETR1S-DTET0.AND.TET0.LE.TETR1S+DTET0) LOC=4 
c! SOUTH PSBL
C
       IF (LOC.EQ.1) THEN   
c! IN THE HIGH-LAT. REGION USE THE SUBROUTINE DIPOCT
C
C      print *, '  LOC=1 (HIGH-LAT)'    
c!  (test printout; disabled now)
         XI(1)=X
         XI(2)=Y
         XI(3)=Z
         XI(4)=PS
         CALL  DIPLOOP1(XI,D1)
          BX=0.D0
          BY=0.D0
          BZ=0.D0
            DO 1 I=1,26
              BX=BX+C1(I)*D1(1,I)
              BY=BY+C1(I)*D1(2,I)
  1           BZ=BZ+C1(I)*D1(3,I)
       ENDIF                                           
c!  END OF THE CASE 1
C
       IF (LOC.EQ.2) THEN
C           print *, '  LOC=2 (PLASMA SHEET)'  
c!  (test printout; disabled now)
C
         XI(1)=X
         XI(2)=Y
         XI(3)=Z
         XI(4)=PS
         CALL  CONDIP1(XI,D2)
          BX=0.D0
          BY=0.D0
          BZ=0.D0
            DO 2 I=1,79
              BX=BX+C2(I)*D2(1,I)
              BY=BY+C2(I)*D2(2,I)
  2           BZ=BZ+C2(I)*D2(3,I)
       ENDIF                                           
c!   END OF THE CASE 2
C
       IF (LOC.EQ.3) THEN
C       print *, '  LOC=3 (north PSBL)'  
c!  (test printout; disabled now)
C
         T01=TETR1N-DTET0
         T02=TETR1N+DTET0
          SQR=DSQRT(R)
          ST01AS=SQR/(R3+1.D0/DSIN(T01)**6-1.D0)**0.1666666667
          ST02AS=SQR/(R3+1.D0/DSIN(T02)**6-1.D0)**0.1666666667
          CT01AS=DSQRT(1.D0-ST01AS**2)
          CT02AS=DSQRT(1.D0-ST02AS**2)
         XAS1=R*ST01AS*DCOS(PAS)
         Y1=  R*ST01AS*DSIN(PAS)
         ZAS1=R*CT01AS
         X1=XAS1*CPSAS+ZAS1*SPSAS
         Z1=-XAS1*SPSAS+ZAS1*CPSAS 
c! X1,Y1,Z1 ARE COORDS OF THE NORTHERN
c                                                      BOUNDARY POINT
         XI(1)=X1
         XI(2)=Y1
         XI(3)=Z1
         XI(4)=PS
         CALL  DIPLOOP1(XI,D1)
          BX1=0.D0
          BY1=0.D0
          BZ1=0.D0
            DO 11 I=1,26
              BX1=BX1+C1(I)*D1(1,I) 
c!   BX1,BY1,BZ1  ARE FIELD COMPONENTS
              BY1=BY1+C1(I)*D1(2,I)  
c!  IN THE NORTHERN BOUNDARY POINT
 11           BZ1=BZ1+C1(I)*D1(3,I)  
c!
C
         XAS2=R*ST02AS*DCOS(PAS)
         Y2=  R*ST02AS*DSIN(PAS)
         ZAS2=R*CT02AS
         X2=XAS2*CPSAS+ZAS2*SPSAS
         Z2=-XAS2*SPSAS+ZAS2*CPSAS 
c! X2,Y2,Z2 ARE COORDS OF THE SOUTHERN
C                                        BOUNDARY POINT
         XI(1)=X2
         XI(2)=Y2
         XI(3)=Z2
         XI(4)=PS
         CALL  CONDIP1(XI,D2)
          BX2=0.D0
          BY2=0.D0
          BZ2=0.D0
            DO 12 I=1,79
              BX2=BX2+C2(I)*D2(1,I)
c!  BX2,BY2,BZ2  ARE FIELD COMPONENTS
              BY2=BY2+C2(I)*D2(2,I) 
c!  IN THE SOUTHERN BOUNDARY POINT
  12          BZ2=BZ2+C2(I)*D2(3,I)
C
C  NOW INTERPOLATE:
C
         SS=DSQRT((X2-X1)**2+(Y2-Y1)**2+(Z2-Z1)**2)
         DS=DSQRT((X-X1)**2+(Y-Y1)**2+(Z-Z1)**2)
         FRAC=DS/SS
         BX=BX1*(1.D0-FRAC)+BX2*FRAC
         BY=BY1*(1.D0-FRAC)+BY2*FRAC
         BZ=BZ1*(1.D0-FRAC)+BZ2*FRAC
C
        ENDIF                                              
c! END OF THE CASE 3
C
        IF (LOC.EQ.4) THEN
C       print *, '  LOC=4 (south PSBL)'  
c!  (test printout; disabled now)
C
         T01=TETR1S-DTET0
         T02=TETR1S+DTET0
          SQR=DSQRT(R)
          ST01AS=SQR/(R3+1.D0/DSIN(T01)**6-1.D0)**0.1666666667
          ST02AS=SQR/(R3+1.D0/DSIN(T02)**6-1.D0)**0.1666666667
          CT01AS=-DSQRT(1.D0-ST01AS**2)
          CT02AS=-DSQRT(1.D0-ST02AS**2)
         XAS1=R*ST01AS*DCOS(PAS)
         Y1=  R*ST01AS*DSIN(PAS)
         ZAS1=R*CT01AS
         X1=XAS1*CPSAS+ZAS1*SPSAS
         Z1=-XAS1*SPSAS+ZAS1*CPSAS 
c! X1,Y1,Z1 ARE COORDS OF THE NORTHERN
C                                               BOUNDARY POINT
         XI(1)=X1
         XI(2)=Y1
         XI(3)=Z1
         XI(4)=PS
         CALL  CONDIP1(XI,D2)
          BX1=0.D0
          BY1=0.D0
          BZ1=0.D0
            DO 21 I=1,79
              BX1=BX1+C2(I)*D2(1,I) 
c!  BX1,BY1,BZ1  ARE FIELD COMPONENTS
              BY1=BY1+C2(I)*D2(2,I)  
c!  IN THE NORTHERN BOUNDARY POINT
 21           BZ1=BZ1+C2(I)*D2(3,I)  
c!
C
         XAS2=R*ST02AS*DCOS(PAS)
         Y2=  R*ST02AS*DSIN(PAS)
         ZAS2=R*CT02AS
         X2=XAS2*CPSAS+ZAS2*SPSAS
         Z2=-XAS2*SPSAS+ZAS2*CPSAS 
c! X2,Y2,Z2 ARE COORDS OF THE SOUTHERN
C                                          BOUNDARY POINT
         XI(1)=X2
         XI(2)=Y2
         XI(3)=Z2
         XI(4)=PS
         CALL  DIPLOOP1(XI,D1)
          BX2=0.D0
          BY2=0.D0
          BZ2=0.D0
            DO 22 I=1,26
              BX2=BX2+C1(I)*D1(1,I) 
c!  BX2,BY2,BZ2  ARE FIELD COMPONENTS
              BY2=BY2+C1(I)*D1(2,I) 
c!     IN THE SOUTHERN BOUNDARY POINT
  22          BZ2=BZ2+C1(I)*D1(3,I)
C
C  NOW INTERPOLATE:
C
         SS=DSQRT((X2-X1)**2+(Y2-Y1)**2+(Z2-Z1)**2)
         DS=DSQRT((X-X1)**2+(Y-Y1)**2+(Z-Z1)**2)
         FRAC=DS/SS
         BX=BX1*(1.D0-FRAC)+BX2*FRAC
         BY=BY1*(1.D0-FRAC)+BY2*FRAC
         BZ=BZ1*(1.D0-FRAC)+BZ2*FRAC
C
        ENDIF                                        
c! END OF THE CASE 4
C
C   NOW, LET US ADD THE SHIELDING FIELD
C
        CALL  BIRK1SHLD(PS,X,Y,Z,BSX,BSY,BSZ)
        BX=BX+BSX
        BY=BY+BSY
        BZ=BZ+BSZ
         RETURN
         END
C
C------------------------------------------------------------------------------
C
C
         SUBROUTINE  DIPLOOP1(XI,D)
C
C
C      Calculates dependent model variables and their deriva-
C  tives for given independent variables and model parame-
C  ters.  Specifies model functions with free parameters which
C  must be determined by means of least squares fits (RMS
C  minimization procedure).
C
C      Description of parameters:
C
C  XI  - input vector containing independent variables;
C  D   - output double precision vector containing
C        calculated values for derivatives of dependent
C        variables with respect to LINEAR model parameters;
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
c  The  26 coefficients are moments (Z- and X-components) of 12 dipoles placed
C    inside the  R1-shell,  PLUS amplitudes of two octagonal double loops.
C     The dipoles with nonzero  Yi appear in pairs with equal moments.
c                  (see the notebook #2, pp.102-103, for details)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
         IMPLICIT  REAL * 8  (A - H, O - Z)
C
         COMMON /COORD11/ XX(12),YY(12)
         COMMON /LOOPDIP1/ TILT,XCENTRE(2),RADIUS(2),  DIPX,DIPY
         COMMON /RHDR/RH,DR
         DIMENSION XI(4),D(3,26)
C
           X = XI(1)
	   Y = XI(2)
	   Z = XI(3)
           PS= XI(4)
           SPS=DSIN(PS)
C
         DO 1 I=1,12
           R2=(XX(I)*DIPX)**2+(YY(I)*DIPY)**2
           R=DSQRT(R2)
             RMRH=R-RH
             RPRH=R+RH
             DR2=DR**2
             SQM=DSQRT(RMRH**2+DR2)
             SQP=DSQRT(RPRH**2+DR2)
             C=SQP-SQM
             Q=DSQRT((RH+1.D0)**2+DR2)-DSQRT((RH-1.D0)**2+DR2)
             SPSAS=SPS/R*C/Q
             CPSAS=DSQRT(1.D0-SPSAS**2)
         XD= (XX(I)*DIPX)*CPSAS
         YD= (YY(I)*DIPY)
         ZD=-(XX(I)*DIPX)*SPSAS
      CALL DIPXYZ(X-XD,Y-YD,Z-ZD,BX1X,BY1X,BZ1X,BX1Y,BY1Y,BZ1Y,
     *  BX1Z,BY1Z,BZ1Z)
        IF (DABS(YD).GT.1.D-10) THEN
      CALL DIPXYZ(X-XD,Y+YD,Z-ZD,BX2X,BY2X,BZ2X,BX2Y,BY2Y,BZ2Y,
     *  BX2Z,BY2Z,BZ2Z)
                                   ELSE
        BX2X=0.D0
        BY2X=0.D0
        BZ2X=0.D0
C
        BX2Z=0.D0
        BY2Z=0.D0
        BZ2Z=0.D0
                                   ENDIF
C
            D(1,I)=BX1Z+BX2Z
            D(2,I)=BY1Z+BY2Z
            D(3,I)=BZ1Z+BZ2Z
            D(1,I+12)=(BX1X+BX2X)*SPS
            D(2,I+12)=(BY1X+BY2X)*SPS
            D(3,I+12)=(BZ1X+BZ2X)*SPS
  1   CONTINUE
c
           R2=(XCENTRE(1)+RADIUS(1))**2
           R=DSQRT(R2)
             RMRH=R-RH
             RPRH=R+RH
             DR2=DR**2
             SQM=DSQRT(RMRH**2+DR2)
             SQP=DSQRT(RPRH**2+DR2)
             C=SQP-SQM
             Q=DSQRT((RH+1.D0)**2+DR2)-DSQRT((RH-1.D0)**2+DR2)
             SPSAS=SPS/R*C/Q
             CPSAS=DSQRT(1.D0-SPSAS**2)
         XOCT1= X*CPSAS-Z*SPSAS
         YOCT1= Y
         ZOCT1= X*SPSAS+Z*CPSAS
C
      CALL CROSSLP(XOCT1,YOCT1,ZOCT1,BXOCT1,BYOCT1,BZOCT1,XCENTRE(1),
     *        RADIUS(1),TILT)
            D(1,25)=BXOCT1*CPSAS+BZOCT1*SPSAS
            D(2,25)=BYOCT1
            D(3,25)=-BXOCT1*SPSAS+BZOCT1*CPSAS
C
           R2=(RADIUS(2)-XCENTRE(2))**2
           R=DSQRT(R2)
             RMRH=R-RH
             RPRH=R+RH
             DR2=DR**2
             SQM=DSQRT(RMRH**2+DR2)
             SQP=DSQRT(RPRH**2+DR2)
             C=SQP-SQM
             Q=DSQRT((RH+1.D0)**2+DR2)-DSQRT((RH-1.D0)**2+DR2)
             SPSAS=SPS/R*C/Q
             CPSAS=DSQRT(1.D0-SPSAS**2)
         XOCT2= X*CPSAS-Z*SPSAS -XCENTRE(2)
         YOCT2= Y
         ZOCT2= X*SPSAS+Z*CPSAS
            CALL CIRCLE(XOCT2,YOCT2,ZOCT2,RADIUS(2),BX,BY,BZ)
            D(1,26) =  BX*CPSAS+BZ*SPSAS
            D(2,26) =  BY
            D(3,26) = -BX*SPSAS+BZ*CPSAS
C
            RETURN
            END
c-------------------------------------------------------------------------
C
        SUBROUTINE CIRCLE(X,Y,Z,RL,BX,BY,BZ)
C
C  RETURNS COMPONENTS OF THE FIELD FROM A CIRCULAR CURRENT LOOP OF RADIUS RL
C  USES THE SECOND (MORE ACCURATE) APPROXIMATION GIVEN IN ABRAMOWITZ AND STEGUN

        IMPLICIT REAL*8 (A-H,O-Z)
        REAL*8 K
cccccccc        DATA PI/3.141592654D0/
        pi=atan(1.0d0)*4
C
        RHO2=X*X+Y*Y
        RHO=DSQRT(RHO2)
        R22=Z*Z+(RHO+RL)**2
        R2=DSQRT(R22)
        R12=R22-4.D0*RHO*RL
        R32=0.5D0*(R12+R22)
        XK2=1.D0-R12/R22
        XK2S=1.D0-XK2
        DL=DLOG(1.D0/XK2S)
        K=1.38629436112d0+XK2S*(0.09666344259D0+XK2S*(0.03590092383d0+
     *     XK2S*(0.03742563713d0+XK2S*0.01451196212d0))) +DL*
     *     (0.5D0+XK2S*(0.12498593597D0+XK2S*(0.06880248576D0+
     *     XK2S*(0.03328355346D0+XK2S*0.00441787012D0))))
        E=1.D0+XK2S*(0.44325141463D0+XK2S*(0.0626060122D0+XK2S*
     *      (0.04757383546D0+XK2S*0.01736506451D0))) +DL*
     *     XK2S*(0.2499836831D0+XK2S*(0.09200180037D0+XK2S*
     *       (0.04069697526D0+XK2S*0.00526449639D0)))

        IF (RHO.GT.1.D-6) THEN
           BRHO=Z/(RHO2*R2)*(R32/R12*E-K) 
c!  THIS IS NOT EXACTLY THE B-RHO COM-
                           ELSE           
c!   PONENT - NOTE THE ADDITIONAL
           BRHO=PI*RL/R2*(RL-RHO)/R12*Z/(R32-RHO2)  
c!      DIVISION BY RHO
        ENDIF

        BX=BRHO*X
        BY=BRHO*Y
        BZ=(K-E*(R32-2.D0*RL*RL)/R12)/R2
        RETURN
        END
C-------------------------------------------------------------
C
        SUBROUTINE CROSSLP(X,Y,Z,BX,BY,BZ,XC,RL,AL)
C
c   RETURNS FIELD COMPONENTS OF A PAIR OF LOOPS WITH A COMMON CENTER AND
C    DIAMETER,  COINCIDING WITH THE X AXIS. THE LOOPS ARE INCLINED TO THE
C    EQUATORIAL PLANE BY THE ANGLE AL (RADIANS) AND SHIFTED IN THE POSITIVE
C     X-DIRECTION BY THE DISTANCE  XC.
c
        IMPLICIT REAL*8 (A-H,O-Z)
C
            CAL=DCOS(AL)
            SAL=DSIN(AL)
C
        Y1=Y*CAL-Z*SAL
        Z1=Y*SAL+Z*CAL
        Y2=Y*CAL+Z*SAL
        Z2=-Y*SAL+Z*CAL
        CALL CIRCLE(X-XC,Y1,Z1,RL,BX1,BY1,BZ1)
        CALL CIRCLE(X-XC,Y2,Z2,RL,BX2,BY2,BZ2)
        BX=BX1+BX2
        BY= (BY1+BY2)*CAL+(BZ1-BZ2)*SAL
        BZ=-(BY1-BY2)*SAL+(BZ1+BZ2)*CAL
C
        RETURN
        END

C*******************************************************************

       SUBROUTINE DIPXYZ(X,Y,Z,BXX,BYX,BZX,BXY,BYY,BZY,BXZ,BYZ,BZZ)
C
C       RETURNS THE FIELD COMPONENTS PRODUCED BY THREE DIPOLES, EACH
C        HAVING M=Me AND ORIENTED PARALLEL TO X,Y, and Z AXIS, RESP.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      X2=X**2
      Y2=Y**2
      Z2=Z**2
      R2=X2+Y2+Z2

      XMR5=30574.D0/(R2*R2*DSQRT(R2))
      XMR53=3.D0*XMR5
      BXX=XMR5*(3.D0*X2-R2)
      BYX=XMR53*X*Y
      BZX=XMR53*X*Z
C
      BXY=BYX
      BYY=XMR5*(3.D0*Y2-R2)
      BZY=XMR53*Y*Z
C
      BXZ=BZX
      BYZ=BZY
      BZZ=XMR5*(3.D0*Z2-R2)
C
      RETURN
      END
C
C------------------------------------------------------------------------------
         SUBROUTINE  CONDIP1(XI,D)
C
C      Calculates dependent model variables and their derivatives for given
C  independent variables and model parameters.  Specifies model functions with
C  free parameters which must be determined by means of least squares fits
C  (RMS minimization procedure).
C
C      Description of parameters:
C
C  XI  - input vector containing independent variables;
C  D   - output double precision vector containing
C        calculated values for derivatives of dependent
C        variables with respect to LINEAR model parameters;
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
c  The  79 coefficients are (1) 5 amplitudes of the conical harmonics, plus
c                           (2) (9x3+5x2)x2=74 components of the dipole moments
c              (see the notebook #2, pp.113-..., for details)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
         IMPLICIT  REAL * 8  (A - H, O - Z)
C
      COMMON /DX1/ DX,SCALEIN,SCALEOUT
      COMMON /COORD21/ XX(14),YY(14),ZZ(14)
c
         DIMENSION XI(4),D(3,79),CF(5),SF(5)
C
           X = XI(1)
	   Y = XI(2)
	   Z = XI(3)
           PS= XI(4)
           SPS=DSIN(PS)
           CPS=DCOS(PS)
C
      XSM=X*CPS-Z*SPS  - DX
      ZSM=Z*CPS+X*SPS
      RO2=XSM**2+Y**2
      RO=SQRT(RO2)
C
      CF(1)=XSM/RO
      SF(1)=Y/RO
C
      CF(2)=CF(1)**2-SF(1)**2
      SF(2)=2.d0*SF(1)*CF(1)
      CF(3)=CF(2)*CF(1)-SF(2)*SF(1)
      SF(3)=SF(2)*CF(1)+CF(2)*SF(1)
      CF(4)=CF(3)*CF(1)-SF(3)*SF(1)
      SF(4)=SF(3)*CF(1)+CF(3)*SF(1)
      CF(5)=CF(4)*CF(1)-SF(4)*SF(1)
      SF(5)=SF(4)*CF(1)+CF(4)*SF(1)
C
      R2=RO2+ZSM**2
      R=DSQRT(R2)
      C=ZSM/R
      S=RO/R
      CH=DSQRT(0.5D0*(1.D0+C))
      SH=DSQRT(0.5D0*(1.D0-C))
      TNH=SH/CH
      CNH=1.D0/TNH
C
      DO 1 M=1,5
       BT=M*CF(M)/(R*S)*(TNH**M+CNH**M)
       BF=-0.5D0*M*SF(M)/R*(TNH**(M-1)/CH**2-CNH**(M-1)/SH**2)
       BXSM=BT*C*CF(1)-BF*SF(1)
       BY=BT*C*SF(1)+BF*CF(1)
       BZSM=-BT*S
C
       D(1,M)=BXSM*CPS+BZSM*SPS
       D(2,M)=BY
  1    D(3,M)=-BXSM*SPS+BZSM*CPS
C
      XSM = X*CPS-Z*SPS
      ZSM = Z*CPS+X*SPS
C
        DO 2 I=1,9
C
        IF (I.EQ.3.OR.I.EQ.5.OR.I.EQ.6) THEN
                XD =  XX(I)*SCALEIN
                YD =  YY(I)*SCALEIN
                                         ELSE
                XD =  XX(I)*SCALEOUT
                YD =  YY(I)*SCALEOUT
        ENDIF
C
         ZD =  ZZ(I)
C
      CALL DIPXYZ(XSM-XD,Y-YD,ZSM-ZD,BX1X,BY1X,BZ1X,BX1Y,BY1Y,BZ1Y,
     *  BX1Z,BY1Z,BZ1Z)
      CALL DIPXYZ(XSM-XD,Y+YD,ZSM-ZD,BX2X,BY2X,BZ2X,BX2Y,BY2Y,BZ2Y,
     *  BX2Z,BY2Z,BZ2Z)
      CALL DIPXYZ(XSM-XD,Y-YD,ZSM+ZD,BX3X,BY3X,BZ3X,BX3Y,BY3Y,BZ3Y,
     *  BX3Z,BY3Z,BZ3Z)
      CALL DIPXYZ(XSM-XD,Y+YD,ZSM+ZD,BX4X,BY4X,BZ4X,BX4Y,BY4Y,BZ4Y,
     *  BX4Z,BY4Z,BZ4Z)
C
      IX=I*3+3
      IY=IX+1
      IZ=IY+1
C
      D(1,IX)=(BX1X+BX2X-BX3X-BX4X)*CPS+(BZ1X+BZ2X-BZ3X-BZ4X)*SPS
      D(2,IX)= BY1X+BY2X-BY3X-BY4X
      D(3,IX)=(BZ1X+BZ2X-BZ3X-BZ4X)*CPS-(BX1X+BX2X-BX3X-BX4X)*SPS
C
      D(1,IY)=(BX1Y-BX2Y-BX3Y+BX4Y)*CPS+(BZ1Y-BZ2Y-BZ3Y+BZ4Y)*SPS
      D(2,IY)= BY1Y-BY2Y-BY3Y+BY4Y
      D(3,IY)=(BZ1Y-BZ2Y-BZ3Y+BZ4Y)*CPS-(BX1Y-BX2Y-BX3Y+BX4Y)*SPS
C
      D(1,IZ)=(BX1Z+BX2Z+BX3Z+BX4Z)*CPS+(BZ1Z+BZ2Z+BZ3Z+BZ4Z)*SPS
      D(2,IZ)= BY1Z+BY2Z+BY3Z+BY4Z
      D(3,IZ)=(BZ1Z+BZ2Z+BZ3Z+BZ4Z)*CPS-(BX1Z+BX2Z+BX3Z+BX4Z)*SPS
C
      IX=IX+27
      IY=IY+27
      IZ=IZ+27
C
      D(1,IX)=SPS*((BX1X+BX2X+BX3X+BX4X)*CPS+(BZ1X+BZ2X+BZ3X+BZ4X)*SPS)
      D(2,IX)=SPS*(BY1X+BY2X+BY3X+BY4X)
      D(3,IX)=SPS*((BZ1X+BZ2X+BZ3X+BZ4X)*CPS-(BX1X+BX2X+BX3X+BX4X)*SPS)
C
      D(1,IY)=SPS*((BX1Y-BX2Y+BX3Y-BX4Y)*CPS+(BZ1Y-BZ2Y+BZ3Y-BZ4Y)*SPS)
      D(2,IY)=SPS*(BY1Y-BY2Y+BY3Y-BY4Y)
      D(3,IY)=SPS*((BZ1Y-BZ2Y+BZ3Y-BZ4Y)*CPS-(BX1Y-BX2Y+BX3Y-BX4Y)*SPS)
C
      D(1,IZ)=SPS*((BX1Z+BX2Z-BX3Z-BX4Z)*CPS+(BZ1Z+BZ2Z-BZ3Z-BZ4Z)*SPS)
      D(2,IZ)=SPS*(BY1Z+BY2Z-BY3Z-BY4Z)
      D(3,IZ)=SPS*((BZ1Z+BZ2Z-BZ3Z-BZ4Z)*CPS-(BX1Z+BX2Z-BX3Z-BX4Z)*SPS)
  2   CONTINUE
C
      DO 3 I=1,5
      ZD=ZZ(I+9)
      CALL DIPXYZ(XSM,Y,ZSM-ZD,BX1X,BY1X,BZ1X,BX1Y,BY1Y,BZ1Y,BX1Z,BY1Z,
     *  BZ1Z)
      CALL DIPXYZ(XSM,Y,ZSM+ZD,BX2X,BY2X,BZ2X,BX2Y,BY2Y,BZ2Y,BX2Z,BY2Z,
     *  BZ2Z)
       IX=58+I*2
       IZ=IX+1
      D(1,IX)=(BX1X-BX2X)*CPS+(BZ1X-BZ2X)*SPS
      D(2,IX)=BY1X-BY2X
      D(3,IX)=(BZ1X-BZ2X)*CPS-(BX1X-BX2X)*SPS
C
      D(1,IZ)=(BX1Z+BX2Z)*CPS+(BZ1Z+BZ2Z)*SPS
      D(2,IZ)=BY1Z+BY2Z
      D(3,IZ)=(BZ1Z+BZ2Z)*CPS-(BX1Z+BX2Z)*SPS
C
      IX=IX+10
      IZ=IZ+10
      D(1,IX)=SPS*((BX1X+BX2X)*CPS+(BZ1X+BZ2X)*SPS)
      D(2,IX)=SPS*(BY1X+BY2X)
      D(3,IX)=SPS*((BZ1X+BZ2X)*CPS-(BX1X+BX2X)*SPS)
C
      D(1,IZ)=SPS*((BX1Z-BX2Z)*CPS+(BZ1Z-BZ2Z)*SPS)
      D(2,IZ)=SPS*(BY1Z-BY2Z)
  3   D(3,IZ)=SPS*((BZ1Z-BZ2Z)*CPS-(BX1Z-BX2Z)*SPS)
C
            RETURN
            END
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
         SUBROUTINE  BIRK1SHLD(PS,X,Y,Z,BX,BY,BZ)
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C  The 64 linear parameters are amplitudes of the "box" harmonics.
c The 16 nonlinear parameters are the scales Pi, and Qk entering the arguments
C  of sines/cosines and exponents in each of  32 cartesian harmonics
c  N.A. Tsyganenko, Spring 1994, adjusted for the Birkeland field Aug.22, 1995
c    Revised  June 12, 1996.
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      IMPLICIT  REAL * 8  (A - H, O - Z)
C
      DIMENSION A(80)
      DIMENSION P1(4),R1(4),Q1(4),S1(4),RP(4),RR(4),RQ(4),RS(4)
C
      EQUIVALENCE (P1(1),A(65)),(R1(1),A(69)),(Q1(1),A(73)),
     * (S1(1),A(77))
C
      DATA A/1.174198045d0,-1.463820502d0,4.840161537d0,-3.674506864d0,
     * 82.18368896d0,-94.94071588d0,-4122.331796d0,4670.278676d0,
     : -21.54975037d0,26.72661293d0,-72.81365728d0,44.09887902d0,
     : 40.08073706d0,-51.23563510d0,1955.348537d0,-1940.971550d0,
     : 794.0496433d0,-982.2441344d0,1889.837171d0,-558.9779727d0,
     : -1260.543238d0,1260.063802d0,-293.5942373d0,344.7250789d0,
     * -773.7002492d0,957.0094135d0,-1824.143669d0,520.7994379d0,
     : 1192.484774d0,-1192.184565d0,89.15537624d0,-98.52042999d0,
     : -0.8168777675d-01,0.4255969908d-01,0.3155237661d0,
     : -0.3841755213d0,2.494553332d0,-0.6571440817d-01,-2.765661310d0,
     : 0.4331001908d0,0.1099181537d0,-0.6154126980d-01,-0.3258649260d0,
     : 0.6698439193d0,-5.542735524d0,0.1604203535d0,5.854456934d0,
     : -0.8323632049d0,3.732608869d0,-3.130002153d0,107.0972607d0,
     : -32.28483411d0,-115.2389298d0,54.45064360d0,-0.5826853320d0,
     * -3.582482231d0,-4.046544561d0,3.311978102d0,-104.0839563d0,
     : 30.26401293d0,97.29109008d0,-50.62370872d0,-296.3734955d0,
     : 127.7872523d0,5.303648988d0,10.40368955d0,69.65230348d0,
     : 466.5099509d0,1.645049286d0,3.825838190d0,11.66675599d0,
     : 558.9781177d0,1.826531343d0,2.066018073d0,25.40971369d0,
     * 990.2795225d0,2.319489258d0,4.555148484d0,9.691185703d0,
     : 591.8280358d0/
C
         BX=0.D0
         BY=0.D0
         BZ=0.D0
         CPS=DCOS(PS)
         SPS=DSIN(PS)
         S3PS=4.D0*CPS**2-1.D0
C
         DO 11 I=1,4
          RP(I)=1.D0/P1(I)
          RR(I)=1.D0/R1(I)
          RQ(I)=1.D0/Q1(I)
 11       RS(I)=1.D0/S1(I)
C
          L=0
C
           DO 1 M=1,2     
c!    M=1 IS FOR THE 1ST SUM ("PERP." SYMMETRY)
C                           AND M=2 IS FOR THE SECOND SUM ("PARALL." SYMMETRY)
             DO 2 I=1,4
                  CYPI=DCOS(Y*RP(I))
                  CYQI=DCOS(Y*RQ(I))
                  SYPI=DSIN(Y*RP(I))
                  SYQI=DSIN(Y*RQ(I))
C
                DO 3 K=1,4
                   SZRK=DSIN(Z*RR(K))
                   CZSK=DCOS(Z*RS(K))
                   CZRK=DCOS(Z*RR(K))
                   SZSK=DSIN(Z*RS(K))
                     SQPR=DSQRT(RP(I)**2+RR(K)**2)
                     SQQS=DSQRT(RQ(I)**2+RS(K)**2)
                        EPR=DEXP(X*SQPR)
                        EQS=DEXP(X*SQQS)
C
                    DO 4 N=1,2  
c! N=1 IS FOR THE FIRST PART OF EACH COEFFICIENT
C                                  AND N=2 IS FOR THE SECOND ONE
                     IF (M.EQ.1) THEN
                       IF (N.EQ.1) THEN
                         HX=-SQPR*EPR*CYPI*SZRK
                         HY=RP(I)*EPR*SYPI*SZRK
                         HZ=-RR(K)*EPR*CYPI*CZRK
                                   ELSE
                         HX=HX*CPS
                         HY=HY*CPS
                         HZ=HZ*CPS
                                   ENDIF
                     ELSE
                       IF (N.EQ.1) THEN
                         HX=-SPS*SQQS*EQS*CYQI*CZSK
                         HY=SPS*RQ(I)*EQS*SYQI*CZSK
                         HZ=SPS*RS(K)*EQS*CYQI*SZSK
                                   ELSE
                         HX=HX*S3PS
                         HY=HY*S3PS
                         HZ=HZ*S3PS
                       ENDIF
                 ENDIF
       L=L+1
c
       BX=BX+A(L)*HX
       BY=BY+A(L)*HY
  4    BZ=BZ+A(L)*HZ
  3   CONTINUE
  2   CONTINUE
  1   CONTINUE
C
         RETURN
	 END
C
C##########################################################################
C
         SUBROUTINE BIRK2TOT_02(PS,X,Y,Z,BX,BY,BZ)
C
          IMPLICIT REAL*8 (A-H,O-Z)
C
          CALL BIRK2SHL(X,Y,Z,PS,WX,WY,WZ)
          CALL R2_BIRK(X,Y,Z,PS,HX,HY,HZ)
         BX=WX+HX
         BY=WY+HY
         BZ=WZ+HZ
         RETURN
         END
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C THIS CODE IS FOR THE FIELD FROM  2x2x2=8 "CARTESIAN" HARMONICS
C
         SUBROUTINE  BIRK2SHL(X,Y,Z,PS,HX,HY,HZ)
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C    The model parameters are provided to this module via common-block /A/.
C  The 16 linear parameters enter in pairs in the amplitudes of the
c       "cartesian" harmonics.
c    The 8 nonlinear parameters are the scales Pi,Ri,Qi,and Si entering the
c  arguments of exponents, sines, and cosines in each of the 8 "Cartesian"
c   harmonics
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
	 IMPLICIT  REAL * 8  (A - H, O - Z)
C
         DIMENSION P(2),R(2),Q(2),S(2)
         DIMENSION A(24)
C
         EQUIVALENCE(P(1),A(17)),(R(1),A(19)),(Q(1),A(21)),(S(1),A(23))
         DATA A/-111.6371348d0,124.5402702d0,110.3735178d0,
     : -122.0095905d0,111.9448247d0,-129.1957743d0,-110.7586562d0,
     : 126.5649012d0,-0.7865034384d0,-0.2483462721d0,0.8026023894d0,
     : 0.2531397188d0,10.72890902d0,0.8483902118d0,-10.96884315d0,
     : -0.8583297219d0,13.85650567d0,14.90554500d0,10.21914434d0,
     * 10.09021632d0,6.340382460d0,14.40432686d0,12.71023437d0,
     : 12.83966657d0/
C
            CPS=DCOS(PS)
            SPS=DSIN(PS)
            S3PS=4.D0*CPS**2-1.D0   
c!  THIS IS SIN(3*PS)/SIN(PS)
C
           HX=0.D0
           HY=0.D0
           HZ=0.D0
           L=0
C
           DO 1 M=1,2     
c!    M=1 IS FOR THE 1ST SUM ("PERP." SYMMETRY)
C                           AND M=2 IS FOR THE SECOND SUM ("PARALL." SYMMETRY)
             DO 2 I=1,2
                  CYPI=DCOS(Y/P(I))
                  CYQI=DCOS(Y/Q(I))
                  SYPI=DSIN(Y/P(I))
                  SYQI=DSIN(Y/Q(I))
C
               DO 3 K=1,2
                   SZRK=DSIN(Z/R(K))
                   CZSK=DCOS(Z/S(K))
                   CZRK=DCOS(Z/R(K))
                   SZSK=DSIN(Z/S(K))
                     SQPR=DSQRT(1.D0/P(I)**2+1.D0/R(K)**2)
                     SQQS=DSQRT(1.D0/Q(I)**2+1.D0/S(K)**2)
                        EPR=DEXP(X*SQPR)
                        EQS=DEXP(X*SQQS)
C
                   DO 4 N=1,2  
c! N=1 IS FOR THE FIRST PART OF EACH COEFFICIENT
C                                  AND N=2 IS FOR THE SECOND ONE
C
                    L=L+1
                     IF (M.EQ.1) THEN
                       IF (N.EQ.1) THEN
                         DX=-SQPR*EPR*CYPI*SZRK
                         DY=EPR/P(I)*SYPI*SZRK
                         DZ=-EPR/R(K)*CYPI*CZRK
                         HX=HX+A(L)*DX
                         HY=HY+A(L)*DY
                         HZ=HZ+A(L)*DZ
                                   ELSE
                         DX=DX*CPS
                         DY=DY*CPS
                         DZ=DZ*CPS
                         HX=HX+A(L)*DX
                         HY=HY+A(L)*DY
                         HZ=HZ+A(L)*DZ
                                   ENDIF
                     ELSE
                       IF (N.EQ.1) THEN
                         DX=-SPS*SQQS*EQS*CYQI*CZSK
                         DY=SPS*EQS/Q(I)*SYQI*CZSK
                         DZ=SPS*EQS/S(K)*CYQI*SZSK
                         HX=HX+A(L)*DX
                         HY=HY+A(L)*DY
                         HZ=HZ+A(L)*DZ
                                   ELSE
                         DX=DX*S3PS
                         DY=DY*S3PS
                         DZ=DZ*S3PS
                         HX=HX+A(L)*DX
                         HY=HY+A(L)*DY
                         HZ=HZ+A(L)*DZ
                       ENDIF
                 ENDIF
c
  4   CONTINUE
  3   CONTINUE
  2   CONTINUE
  1   CONTINUE
C
         RETURN
	 END

c********************************************************************
C
       SUBROUTINE R2_BIRK(X,Y,Z,PS,BX,BY,BZ)
C
C  RETURNS THE MODEL FIELD FOR THE REGION 2 BIRKELAND CURRENT/PARTIAL RC
C    (WITHOUT SHIELDING FIELD)
C
       IMPLICIT REAL*8 (A-H,O-Z)
       SAVE PSI,CPS,SPS
       DATA DELARG/0.030D0/,DELARG1/0.015D0/,PSI/10.D0/
C
       IF (DABS(PSI-PS).GT.1.D-10) THEN
         PSI=PS
         CPS=DCOS(PS)
         SPS=DSIN(PS)
       ENDIF
C
       XSM=X*CPS-Z*SPS
       ZSM=Z*CPS+X*SPS
C
       XKS=XKSI(XSM,Y,ZSM)
      IF (XKS.LT.-(DELARG+DELARG1)) THEN
        CALL R2OUTER(XSM,Y,ZSM,BXSM,BY,BZSM)
         BXSM=-BXSM*0.02d0      
c!  ALL COMPONENTS ARE MULTIPLIED BY THE
	 BY=-BY*0.02d0          
c!  FACTOR -0.02, IN ORDER TO NORMALIZE THE
         BZSM=-BZSM*0.02d0      
c!  FIELD (SO THAT Bz=-1 nT at X=-5.3 RE, Y=Z=0)
      ENDIF
      IF (XKS.GE.-(DELARG+DELARG1).AND.XKS.LT.-DELARG+DELARG1) THEN
        CALL R2OUTER(XSM,Y,ZSM,BXSM1,BY1,BZSM1)
        CALL R2SHEET(XSM,Y,ZSM,BXSM2,BY2,BZSM2)
        F2=-0.02d0*TKSI(XKS,-DELARG,DELARG1)
        F1=-0.02d0-F2
        BXSM=BXSM1*F1+BXSM2*F2
        BY=BY1*F1+BY2*F2
        BZSM=BZSM1*F1+BZSM2*F2
      ENDIF

      IF (XKS.GE.-DELARG+DELARG1.AND.XKS.LT.DELARG-DELARG1) THEN
       CALL R2SHEET(XSM,Y,ZSM,BXSM,BY,BZSM)
         BXSM=-BXSM*0.02d0
         BY=-BY*0.02d0
         BZSM=-BZSM*0.02d0
      ENDIF
      IF (XKS.GE.DELARG-DELARG1.AND.XKS.LT.DELARG+DELARG1) THEN
        CALL R2INNER(XSM,Y,ZSM,BXSM1,BY1,BZSM1)
        CALL R2SHEET(XSM,Y,ZSM,BXSM2,BY2,BZSM2)
        F1=-0.02d0*TKSI(XKS,DELARG,DELARG1)
        F2=-0.02d0-F1
        BXSM=BXSM1*F1+BXSM2*F2
        BY=BY1*F1+BY2*F2
        BZSM=BZSM1*F1+BZSM2*F2
      ENDIF
      IF (XKS.GE.DELARG+DELARG1) THEN
         CALL R2INNER(XSM,Y,ZSM,BXSM,BY,BZSM)
         BXSM=-BXSM*0.02d0
         BY=-BY*0.02d0
         BZSM=-BZSM*0.02d0
      ENDIF
C
        BX=BXSM*CPS+BZSM*SPS
        BZ=BZSM*CPS-BXSM*SPS
C
        RETURN
        END
C
C****************************************************************

c
      SUBROUTINE R2INNER (X,Y,Z,BX,BY,BZ)
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CBX(5),CBY(5),CBZ(5)
C
      DATA PL1,PL2,PL3,PL4,PL5,PL6,PL7,PL8/154.185d0,-2.12446d0,
     : .601735d-01,-.153954d-02,.355077d-04,29.9996d0,262.886d0,
     :  99.9132d0/
      DATA PN1,PN2,PN3,PN4,PN5,PN6,PN7,PN8/-8.1902d0,6.5239d0,5.504d0,
     : 7.7815d0,.8573d0,3.0986d0,.0774d0,-.038d0/
C
      CALL BCONIC(X,Y,Z,CBX,CBY,CBZ,5)
C
C   NOW INTRODUCE  ONE  4-LOOP SYSTEM:
C
       CALL LOOPS4(X,Y,Z,DBX8,DBY8,DBZ8,PN1,PN2,PN3,PN4,PN5,PN6)
C
       CALL DIPDISTR(X-PN7,Y,Z,DBX6,DBY6,DBZ6,0)
       CALL DIPDISTR(X-PN8,Y,Z,DBX7,DBY7,DBZ7,1)

C                           NOW COMPUTE THE FIELD COMPONENTS:

      BX=PL1*CBX(1)+PL2*CBX(2)+PL3*CBX(3)+PL4*CBX(4)+PL5*CBX(5)
     * +PL6*DBX6+PL7*DBX7+PL8*DBX8
      BY=PL1*CBY(1)+PL2*CBY(2)+PL3*CBY(3)+PL4*CBY(4)+PL5*CBY(5)
     * +PL6*DBY6+PL7*DBY7+PL8*DBY8
      BZ=PL1*CBZ(1)+PL2*CBZ(2)+PL3*CBZ(3)+PL4*CBZ(4)+PL5*CBZ(5)
     * +PL6*DBZ6+PL7*DBZ7+PL8*DBZ8
C
      RETURN
      END
C-----------------------------------------------------------------------

      SUBROUTINE BCONIC(X,Y,Z,CBX,CBY,CBZ,NMAX)
C
c   "CONICAL" HARMONICS
c
       IMPLICIT REAL*8 (A-H,O-Z)
C
       DIMENSION CBX(NMAX),CBY(NMAX),CBZ(NMAX)

       RO2=X**2+Y**2
       RO=SQRT(RO2)
C
       CF=X/RO
       SF=Y/RO
       CFM1=1.D0
       SFM1=0.D0
C
      R2=RO2+Z**2
      R=DSQRT(R2)
      C=Z/R
      S=RO/R
      CH=DSQRT(0.5D0*(1.D0+C))
      SH=DSQRT(0.5D0*(1.D0-C))
      TNHM1=1.D0
      CNHM1=1.D0
      TNH=SH/CH
      CNH=1.D0/TNH
C
      DO 1 M=1,NMAX
        CFM=CFM1*CF-SFM1*SF
        SFM=CFM1*SF+SFM1*CF
        CFM1=CFM
        SFM1=SFM
        TNHM=TNHM1*TNH
        CNHM=CNHM1*CNH
       BT=M*CFM/(R*S)*(TNHM+CNHM)
       BF=-0.5D0*M*SFM/R*(TNHM1/CH**2-CNHM1/SH**2)
         TNHM1=TNHM
         CNHM1=CNHM
       CBX(M)=BT*C*CF-BF*SF
       CBY(M)=BT*C*SF+BF*CF
  1    CBZ(M)=-BT*S
C
       RETURN
       END

C-------------------------------------------------------------------
C
       SUBROUTINE DIPDISTR(X,Y,Z,BX,BY,BZ,MODE)
C
C   RETURNS FIELD COMPONENTS FROM A LINEAR DISTRIBUTION OF DIPOLAR SOURCES
C     ON THE Z-AXIS.  THE PARAMETER MODE DEFINES HOW THE DIPOLE STRENGTH
C     VARIES ALONG THE Z-AXIS:  MODE=0 IS FOR A STEP-FUNCTION (Mx=const &gt 0
c         FOR Z &gt 0, AND Mx=-const &lt 0 FOR Z &lt 0)
C      WHILE MODE=1 IS FOR A LINEAR VARIATION OF THE DIPOLE MOMENT DENSITY
C       SEE NB#3, PAGE 53 FOR DETAILS.
C
C
C INPUT: X,Y,Z OF A POINT OF SPACE, AND MODE
C
        IMPLICIT REAL*8 (A-H,O-Z)
        X2=X*X
        RHO2=X2+Y*Y
        R2=RHO2+Z*Z
        R3=R2*DSQRT(R2)

        IF (MODE.EQ.0) THEN
         BX=Z/RHO2**2*(R2*(Y*Y-X2)-RHO2*X2)/R3
         BY=-X*Y*Z/RHO2**2*(2.D0*R2+RHO2)/R3
         BZ=X/R3
        ELSE
         BX=Z/RHO2**2*(Y*Y-X2)
         BY=-2.D0*X*Y*Z/RHO2**2
         BZ=X/RHO2
        ENDIF
         RETURN
         END

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE R2OUTER (X,Y,Z,BX,BY,BZ)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DATA PL1,PL2,PL3,PL4,PL5/-34.105d0,-2.00019d0,628.639d0,
     : 73.4847d0,12.5162d0/
      DATA PN1,PN2,PN3,PN4,PN5,PN6,PN7,PN8,PN9,PN10,PN11,PN12,PN13,PN14,
     *  PN15,PN16,PN17 /.55d0,.694d0,.0031d0,1.55d0,2.8d0,.1375d0,
     : -.7d0,.2d0,.9625d0,-2.994d0,2.925d0,-1.775d0,4.3d0,-.275d0,
     : 2.7d0,.4312d0,1.55d0/
c
C    THREE PAIRS OF CROSSED LOOPS:
C
      CALL CROSSLP(X,Y,Z,DBX1,DBY1,DBZ1,PN1,PN2,PN3)
      CALL CROSSLP(X,Y,Z,DBX2,DBY2,DBZ2,PN4,PN5,PN6)
      CALL CROSSLP(X,Y,Z,DBX3,DBY3,DBZ3,PN7,PN8,PN9)
C
C    NOW AN EQUATORIAL LOOP ON THE NIGHTSIDE
C
      CALL CIRCLE(X-PN10,Y,Z,PN11,DBX4,DBY4,DBZ4)
c
c   NOW A 4-LOOP SYSTEM ON THE NIGHTSIDE
c

      CALL LOOPS4(X,Y,Z,DBX5,DBY5,DBZ5,PN12,PN13,PN14,PN15,PN16,PN17)

C---------------------------------------------------------------------

C                           NOW COMPUTE THE FIELD COMPONENTS:

      BX=PL1*DBX1+PL2*DBX2+PL3*DBX3+PL4*DBX4+PL5*DBX5
      BY=PL1*DBY1+PL2*DBY2+PL3*DBY3+PL4*DBY4+PL5*DBY5
      BZ=PL1*DBZ1+PL2*DBZ2+PL3*DBZ3+PL4*DBZ4+PL5*DBZ5

       RETURN
       END
C
C--------------------------------------------------------------------
C
       SUBROUTINE LOOPS4(X,Y,Z,BX,BY,BZ,XC,YC,ZC,R,THETA,PHI)
C
C   RETURNS FIELD COMPONENTS FROM A SYSTEM OF 4 CURRENT LOOPS, POSITIONED
C     SYMMETRICALLY WITH RESPECT TO NOON-MIDNIGHT MERIDIAN AND EQUATORIAL
C      PLANES.
C  INPUT: X,Y,Z OF A POINT OF SPACE
C        XC,YC,ZC (YC &gt 0 AND ZC &gt 0) - POSITION OF THE CENTER OF THE
C                                         1ST-QUADRANT LOOP
C        R - LOOP RADIUS (THE SAME FOR ALL FOUR)
C        THETA, PHI  -  SPECIFY THE ORIENTATION OF THE NORMAL OF THE 1ST LOOP
c      -----------------------------------------------------------

        IMPLICIT REAL*8 (A-H,O-Z)
C
          CT=DCOS(THETA)
          ST=DSIN(THETA)
          CP=DCOS(PHI)
          SP=DSIN(PHI)
C------------------------------------1ST QUADRANT:
        XS=(X-XC)*CP+(Y-YC)*SP
        YSS=(Y-YC)*CP-(X-XC)*SP
        ZS=Z-ZC
        XSS=XS*CT-ZS*ST
        ZSS=ZS*CT+XS*ST

        CALL CIRCLE(XSS,YSS,ZSS,R,BXSS,BYS,BZSS)
          BXS=BXSS*CT+BZSS*ST
          BZ1=BZSS*CT-BXSS*ST
          BX1=BXS*CP-BYS*SP
          BY1=BXS*SP+BYS*CP
C-------------------------------------2nd QUADRANT:
        XS=(X-XC)*CP-(Y+YC)*SP
        YSS=(Y+YC)*CP+(X-XC)*SP
        ZS=Z-ZC
        XSS=XS*CT-ZS*ST
        ZSS=ZS*CT+XS*ST

        CALL CIRCLE(XSS,YSS,ZSS,R,BXSS,BYS,BZSS)
          BXS=BXSS*CT+BZSS*ST
          BZ2=BZSS*CT-BXSS*ST
          BX2=BXS*CP+BYS*SP
          BY2=-BXS*SP+BYS*CP
C-------------------------------------3RD QUADRANT:
        XS=-(X-XC)*CP+(Y+YC)*SP
        YSS=-(Y+YC)*CP-(X-XC)*SP
        ZS=Z+ZC
        XSS=XS*CT-ZS*ST
        ZSS=ZS*CT+XS*ST

        CALL CIRCLE(XSS,YSS,ZSS,R,BXSS,BYS,BZSS)
          BXS=BXSS*CT+BZSS*ST
          BZ3=BZSS*CT-BXSS*ST
          BX3=-BXS*CP-BYS*SP
          BY3=BXS*SP-BYS*CP
C-------------------------------------4TH QUADRANT:
        XS=-(X-XC)*CP-(Y-YC)*SP
        YSS=-(Y-YC)*CP+(X-XC)*SP
        ZS=Z+ZC
        XSS=XS*CT-ZS*ST
        ZSS=ZS*CT+XS*ST

        CALL CIRCLE(XSS,YSS,ZSS,R,BXSS,BYS,BZSS)
          BXS=BXSS*CT+BZSS*ST
          BZ4=BZSS*CT-BXSS*ST
          BX4=-BXS*CP+BYS*SP
          BY4=-BXS*SP-BYS*CP

        BX=BX1+BX2+BX3+BX4
        BY=BY1+BY2+BY3+BY4
        BZ=BZ1+BZ2+BZ3+BZ4

         RETURN
         END
C
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C
      SUBROUTINE R2SHEET(X,Y,Z,BX,BY,BZ)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DATA PNONX1,PNONX2,PNONX3,PNONX4,PNONX5,PNONX6,PNONX7,PNONX8,
     *     PNONY1,PNONY2,PNONY3,PNONY4,PNONY5,PNONY6,PNONY7,PNONY8,
     *     PNONZ1,PNONZ2,PNONZ3,PNONZ4,PNONZ5,PNONZ6,PNONZ7,PNONZ8
     */-19.0969D0,-9.28828D0,-0.129687D0,5.58594D0,22.5055D0,
     *  0.483750D-01,0.396953D-01,0.579023D-01,-13.6750D0,-6.70625D0,
     *  2.31875D0,11.4062D0,20.4562D0,0.478750D-01,0.363750D-01,
     * 0.567500D-01,-16.7125D0,-16.4625D0,-0.1625D0,5.1D0,23.7125D0,
     * 0.355625D-01,0.318750D-01,0.538750D-01/
C
C
      DATA A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,A15,A16,A17,
     *  A18,A19,A20,A21,A22,A23,A24,A25,A26,A27,A28,A29,A30,A31,A32,A33,
     *  A34,A35,A36,A37,A38,A39,A40,A41,A42,A43,A44,A45,A46,A47,A48,A49,
     *  A50,A51,A52,A53,A54,A55,A56,A57,A58,A59,A60,A61,A62,A63,A64,A65,
     *  A66,A67,A68,A69,A70,A71,A72,A73,A74,A75,A76,A77,A78,A79,A80
     * /8.07190D0,-7.39582D0,-7.62341D0,0.684671D0,-13.5672D0,11.6681D0,
     * 13.1154,-0.890217D0,7.78726D0,-5.38346D0,-8.08738D0,0.609385D0,
     * -2.70410D0, 3.53741D0,3.15549D0,-1.11069D0,-8.47555D0,0.278122D0,
     *  2.73514D0,4.55625D0,13.1134D0,1.15848D0,-3.52648D0,-8.24698D0,
     * -6.85710D0,-2.81369D0, 2.03795D0, 4.64383D0,2.49309D0,-1.22041D0,
     * -1.67432D0,-0.422526D0,-5.39796D0,7.10326D0,5.53730D0,-13.1918D0,
     *  4.67853D0,-7.60329D0,-2.53066D0, 7.76338D0, 5.60165D0,5.34816D0,
     * -4.56441D0,7.05976D0,-2.62723D0,-0.529078D0,1.42019D0,-2.93919D0,
     *  55.6338D0,-1.55181D0,39.8311D0,-80.6561D0,-46.9655D0,32.8925D0,
     * -6.32296D0,19.7841D0,124.731D0,10.4347D0,-30.7581D0,102.680D0,
     * -47.4037D0,-3.31278D0,9.37141D0,-50.0268D0,-533.319D0,110.426D0,
     *  1000.20D0,-1051.40D0, 1619.48D0,589.855D0,-1462.73D0,1087.10D0,
     *  -1994.73D0,-1654.12D0,1263.33D0,-260.210D0,1424.84D0,1255.71D0,
     *  -956.733D0, 219.946D0/
C
C
      DATA B1,B2,B3,B4,B5,B6,B7,B8,B9,B10,B11,B12,B13,B14,B15,B16,B17,
     *  B18,B19,B20,B21,B22,B23,B24,B25,B26,B27,B28,B29,B30,B31,B32,B33,
     *  B34,B35,B36,B37,B38,B39,B40,B41,B42,B43,B44,B45,B46,B47,B48,B49,
     *  B50,B51,B52,B53,B54,B55,B56,B57,B58,B59,B60,B61,B62,B63,B64,B65,
     *  B66,B67,B68,B69,B70,B71,B72,B73,B74,B75,B76,B77,B78,B79,B80
     */-9.08427D0,10.6777D0,10.3288D0,-0.969987D0,6.45257D0,-8.42508D0,
     * -7.97464D0,1.41996D0,-1.92490D0,3.93575D0,2.83283D0,-1.48621D0,
     *0.244033D0,-0.757941D0,-0.386557D0,0.344566D0,9.56674D0,-2.5365D0,
     * -3.32916D0,-5.86712D0,-6.19625D0,1.83879D0,2.52772D0,4.34417D0,
     * 1.87268D0,-2.13213D0,-1.69134D0,-.176379D0,-.261359D0,.566419D0,
     * 0.3138D0,-0.134699D0,-3.83086D0,-8.4154D0,4.77005D0,-9.31479D0,
     * 37.5715D0,19.3992D0,-17.9582D0,36.4604D0,-14.9993D0,-3.1442D0,
     * 6.17409D0,-15.5519D0,2.28621D0,-0.891549D-2,-.462912D0,2.47314D0,
     * 41.7555D0,208.614D0,-45.7861D0,-77.8687D0,239.357D0,-67.9226D0,
     * 66.8743D0,238.534D0,-112.136D0,16.2069D0,-40.4706D0,-134.328D0,
     * 21.56D0,-0.201725D0,2.21D0,32.5855D0,-108.217D0,-1005.98D0,
     * 585.753D0,323.668D0,-817.056D0,235.750D0,-560.965D0,-576.892D0,
     * 684.193D0,85.0275D0,168.394D0,477.776D0,-289.253D0,-123.216D0,
     * 75.6501D0,-178.605D0/
C
      DATA C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15,C16,C17,
     *  C18,C19,C20,C21,C22,C23,C24,C25,C26,C27,C28,C29,C30,C31,C32,C33,
     *  C34,C35,C36,C37,C38,C39,C40,C41,C42,C43,C44,C45,C46,C47,C48,C49,
     *  C50,C51,C52,C53,C54,C55,C56,C57,C58,C59,C60,C61,C62,C63,C64,C65,
     *  C66,C67,C68,C69,C70,C71,C72,C73,C74,C75,C76,C77,C78,C79,C80
     * / 1167.61D0,-917.782D0,-1253.2D0,-274.128D0,-1538.75D0,1257.62D0,
     * 1745.07D0,113.479D0,393.326D0,-426.858D0,-641.1D0,190.833D0,
     * -29.9435D0,-1.04881D0,117.125D0,-25.7663D0,-1168.16D0,910.247D0,
     * 1239.31D0,289.515D0,1540.56D0,-1248.29D0,-1727.61D0,-131.785D0,
     * -394.577D0,426.163D0,637.422D0,-187.965D0,30.0348D0,0.221898D0,
     * -116.68D0,26.0291D0,12.6804D0,4.84091D0,1.18166D0,-2.75946D0,
     * -17.9822D0,-6.80357D0,-1.47134D0,3.02266D0,4.79648D0,0.665255D0,
     * -0.256229D0,-0.857282D-1,-0.588997D0,0.634812D-1,0.164303D0,
     * -0.15285D0,22.2524D0,-22.4376D0,-3.85595D0,6.07625D0,-105.959D0,
     * -41.6698D0,0.378615D0,1.55958D0,44.3981D0,18.8521D0,3.19466D0,
     *  5.89142D0,-8.63227D0,-2.36418D0,-1.027D0,-2.31515D0,1035.38D0,
     *  2040.66D0,-131.881D0,-744.533D0,-3274.93D0,-4845.61D0,482.438D0,
     * 1567.43D0,1354.02D0,2040.47D0,-151.653D0,-845.012D0,-111.723D0,
     * -265.343D0,-26.1171D0,216.632D0/
C
c------------------------------------------------------------------
C
       XKS=XKSI(X,Y,Z)    
c!  variation across the current sheet
       T1X=XKS/DSQRT(XKS**2+PNONX6**2)
       T2X=PNONX7**3/DSQRT(XKS**2+PNONX7**2)**3
       T3X=XKS/DSQRT(XKS**2+PNONX8**2)**5 *3.493856D0*PNONX8**4
C
       T1Y=XKS/DSQRT(XKS**2+PNONY6**2)
       T2Y=PNONY7**3/DSQRT(XKS**2+PNONY7**2)**3
       T3Y=XKS/DSQRT(XKS**2+PNONY8**2)**5 *3.493856D0*PNONY8**4
C
       T1Z=XKS/DSQRT(XKS**2+PNONZ6**2)
       T2Z=PNONZ7**3/DSQRT(XKS**2+PNONZ7**2)**3
       T3Z=XKS/DSQRT(XKS**2+PNONZ8**2)**5 *3.493856D0*PNONZ8**4
C
      RHO2=X*X+Y*Y
      R=DSQRT(RHO2+Z*Z)
      RHO=DSQRT(RHO2)
C
      C1P=X/RHO
      S1P=Y/RHO
      S2P=2.D0*S1P*C1P
      C2P=C1P*C1P-S1P*S1P
      S3P=S2P*C1P+C2P*S1P
      C3P=C2P*C1P-S2P*S1P
      S4P=S3P*C1P+C3P*S1P
      CT=Z/R
      ST=RHO/R
C
      S1=FEXP(CT,PNONX1)
      S2=FEXP(CT,PNONX2)
      S3=FEXP(CT,PNONX3)
      S4=FEXP(CT,PNONX4)
      S5=FEXP(CT,PNONX5)
C
C                   NOW COMPUTE THE GSM FIELD COMPONENTS:
C
C
      BX=S1*((A1+A2*T1X+A3*T2X+A4*T3X)
     *        +C1P*(A5+A6*T1X+A7*T2X+A8*T3X)
     *        +C2P*(A9+A10*T1X+A11*T2X+A12*T3X)
     *        +C3P*(A13+A14*T1X+A15*T2X+A16*T3X))
     *    +S2*((A17+A18*T1X+A19*T2X+A20*T3X)
     *        +C1P*(A21+A22*T1X+A23*T2X+A24*T3X)
     *        +C2P*(A25+A26*T1X+A27*T2X+A28*T3X)
     *        +C3P*(A29+A30*T1X+A31*T2X+A32*T3X))
     *    +S3*((A33+A34*T1X+A35*T2X+A36*T3X)
     *        +C1P*(A37+A38*T1X+A39*T2X+A40*T3X)
     *        +C2P*(A41+A42*T1X+A43*T2X+A44*T3X)
     *        +C3P*(A45+A46*T1X+A47*T2X+A48*T3X))
     *    +S4*((A49+A50*T1X+A51*T2X+A52*T3X)
     *        +C1P*(A53+A54*T1X+A55*T2X+A56*T3X)
     *        +C2P*(A57+A58*T1X+A59*T2X+A60*T3X)
     *        +C3P*(A61+A62*T1X+A63*T2X+A64*T3X))
     *    +S5*((A65+A66*T1X+A67*T2X+A68*T3X)
     *        +C1P*(A69+A70*T1X+A71*T2X+A72*T3X)
     *        +C2P*(A73+A74*T1X+A75*T2X+A76*T3X)
     *        +C3P*(A77+A78*T1X+A79*T2X+A80*T3X))
C
C
      S1=FEXP(CT,PNONY1)
      S2=FEXP(CT,PNONY2)
      S3=FEXP(CT,PNONY3)
      S4=FEXP(CT,PNONY4)
      S5=FEXP(CT,PNONY5)
C
      BY=S1*(S1P*(B1+B2*T1Y+B3*T2Y+B4*T3Y)
     *      +S2P*(B5+B6*T1Y+B7*T2Y+B8*T3Y)
     *      +S3P*(B9+B10*T1Y+B11*T2Y+B12*T3Y)
     *      +S4P*(B13+B14*T1Y+B15*T2Y+B16*T3Y))
     *  +S2*(S1P*(B17+B18*T1Y+B19*T2Y+B20*T3Y)
     *      +S2P*(B21+B22*T1Y+B23*T2Y+B24*T3Y)
     *      +S3P*(B25+B26*T1Y+B27*T2Y+B28*T3Y)
     *      +S4P*(B29+B30*T1Y+B31*T2Y+B32*T3Y))
     *  +S3*(S1P*(B33+B34*T1Y+B35*T2Y+B36*T3Y)
     *      +S2P*(B37+B38*T1Y+B39*T2Y+B40*T3Y)
     *      +S3P*(B41+B42*T1Y+B43*T2Y+B44*T3Y)
     *      +S4P*(B45+B46*T1Y+B47*T2Y+B48*T3Y))
     *  +S4*(S1P*(B49+B50*T1Y+B51*T2Y+B52*T3Y)
     *      +S2P*(B53+B54*T1Y+B55*T2Y+B56*T3Y)
     *      +S3P*(B57+B58*T1Y+B59*T2Y+B60*T3Y)
     *      +S4P*(B61+B62*T1Y+B63*T2Y+B64*T3Y))
     *  +S5*(S1P*(B65+B66*T1Y+B67*T2Y+B68*T3Y)
     *      +S2P*(B69+B70*T1Y+B71*T2Y+B72*T3Y)
     *      +S3P*(B73+B74*T1Y+B75*T2Y+B76*T3Y)
     *      +S4P*(B77+B78*T1Y+B79*T2Y+B80*T3Y))
C
      S1=FEXP1(CT,PNONZ1)
      S2=FEXP1(CT,PNONZ2)
      S3=FEXP1(CT,PNONZ3)
      S4=FEXP1(CT,PNONZ4)
      S5=FEXP1(CT,PNONZ5)
C
      BZ=S1*((C1+C2*T1Z+C3*T2Z+C4*T3Z)
     *      +C1P*(C5+C6*T1Z+C7*T2Z+C8*T3Z)
     *      +C2P*(C9+C10*T1Z+C11*T2Z+C12*T3Z)
     *      +C3P*(C13+C14*T1Z+C15*T2Z+C16*T3Z))
     *   +S2*((C17+C18*T1Z+C19*T2Z+C20*T3Z)
     *      +C1P*(C21+C22*T1Z+C23*T2Z+C24*T3Z)
     *      +C2P*(C25+C26*T1Z+C27*T2Z+C28*T3Z)
     *      +C3P*(C29+C30*T1Z+C31*T2Z+C32*T3Z))
     *   +S3*((C33+C34*T1Z+C35*T2Z+C36*T3Z)
     *      +C1P*(C37+C38*T1Z+C39*T2Z+C40*T3Z)
     *      +C2P*(C41+C42*T1Z+C43*T2Z+C44*T3Z)
     *      +C3P*(C45+C46*T1Z+C47*T2Z+C48*T3Z))
     *   +S4*((C49+C50*T1Z+C51*T2Z+C52*T3Z)
     *      +C1P*(C53+C54*T1Z+C55*T2Z+C56*T3Z)
     *      +C2P*(C57+C58*T1Z+C59*T2Z+C60*T3Z)
     *      +C3P*(C61+C62*T1Z+C63*T2Z+C64*T3Z))
     *   +S5*((C65+C66*T1Z+C67*T2Z+C68*T3Z)
     *      +C1P*(C69+C70*T1Z+C71*T2Z+C72*T3Z)
     *      +C2P*(C73+C74*T1Z+C75*T2Z+C76*T3Z)
     *      +C3P*(C77+C78*T1Z+C79*T2Z+C80*T3Z))
C
       RETURN
       END
C
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

      REAL*8 FUNCTION XKSI(X,Y,Z)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C   A11 - C72, R0, and DR below  ARE STRETCH PARAMETERS (P.26-27, NB# 3),
C
      DATA A11A12,A21A22,A41A42,A51A52,A61A62,B11B12,B21B22,C61C62,
     *  C71C72,R0,DR /0.305662d0,-0.383593d0,0.2677733d0,-0.097656d0,
     :  -0.636034d0,-0.359862d0,0.424706d0,-0.126366d0,0.292578d0,
     :  1.21563d0,7.50937d0/

      DATA TNOON,DTETA/0.3665191d0,0.09599309d0/ 
c! Correspond to noon and midnight
C                                         latitudes 69 and 63.5 degs, resp.
       DR2=DR*DR
C
       X2=X*X
       Y2=Y*Y
       Z2=Z*Z
       XY=X*Y
       XYZ=XY*Z
       R2=X2+Y2+Z2
       R=DSQRT(R2)
       R3=R2*R
       R4=R2*R2
       XR=X/R
       YR=Y/R
       ZR=Z/R
C
       IF (R.LT.R0) THEN
         PR=0.D0
       ELSE
         PR=DSQRT((R-R0)**2+DR2)-DR
       ENDIF
C
      F=X+PR*(A11A12+A21A22*XR+A41A42*XR*XR+A51A52*YR*YR+
     *        A61A62*ZR*ZR)
      G=Y+PR*(B11B12*YR+B21B22*XR*YR)
      H=Z+PR*(C61C62*ZR+C71C72*XR*ZR)
      G2=G*G
C
      FGH=F**2+G2+H**2
      FGH32=DSQRT(FGH)**3
      FCHSG2=F**2+G2

      IF (FCHSG2.LT.1.D-5) THEN
         XKSI=-1.D0               
c!  THIS IS JUST FOR ELIMINATING PROBLEMS
         RETURN                    
c!  ON THE Z-AXIS
      ENDIF

      SQFCHSG2=DSQRT(FCHSG2)
      ALPHA=FCHSG2/FGH32
      THETA=TNOON+0.5D0*DTETA*(1.D0-F/SQFCHSG2)
      PHI=DSIN(THETA)**2
C
      XKSI=ALPHA-PHI
C
      RETURN
      END
C
C--------------------------------------------------------------------
C
        FUNCTION FEXP(S,A)
         IMPLICIT REAL*8 (A-H,O-Z)
          DATA E/2.718281828459D0/
          IF (A.LT.0.D0) FEXP=DSQRT(-2.D0*A*E)*S*DEXP(A*S*S)
          IF (A.GE.0.D0) FEXP=S*DEXP(A*(S*S-1.D0))
         RETURN
         END
C
C-----------------------------------------------------------------------
        FUNCTION FEXP1(S,A)
         IMPLICIT REAL*8 (A-H,O-Z)
         IF (A.LE.0.D0) FEXP1=DEXP(A*S*S)
         IF (A.GT.0.D0) FEXP1=DEXP(A*(S*S-1.D0))
         RETURN
         END
C
C************************************************************************
C
         REAL*8 FUNCTION TKSI(XKSI,XKS0,DXKSI)
         IMPLICIT REAL*8 (A-H,O-Z)
         SAVE M,TDZ3
         DATA M/0/
C
         IF (M.EQ.0) THEN
         TDZ3=2.d0*DXKSI**3
         M=1
         ENDIF
C
         IF (XKSI-XKS0.LT.-DXKSI) TKSII=0.d0
         IF (XKSI-XKS0.GE.DXKSI)  TKSII=1.d0
C
         IF (XKSI.GE.XKS0-DXKSI.AND.XKSI.LT.XKS0) THEN
           BR3=(XKSI-XKS0+DXKSI)**3
           TKSII=1.5d0*BR3/(TDZ3+BR3)
         ENDIF
C
         IF (XKSI.GE.XKS0.AND.XKSI.LT.XKS0+DXKSI) THEN
           BR3=(XKSI-XKS0-DXKSI)**3
           TKSII=1.d0+1.5d0*BR3/(TDZ3-BR3)
         ENDIF
           TKSI=TKSII
         END
C
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c
       SUBROUTINE DIPOLE(PS,X,Y,Z,BX,BY,BZ)
C
C  CALCULATES GSM COMPONENTS OF GEODIPOLE FIELD WITH THE DIPOLE MOMENT
C  CORRESPONDING TO THE EPOCH OF 1980.
C------------INPUT PARAMETERS:
C   PS - GEODIPOLE TILT ANGLE IN RADIANS, X,Y,Z - GSM COORDINATES IN RE
C------------OUTPUT PARAMETERS:
C   BX,BY,BZ - FIELD COMPONENTS IN GSM SYSTEM, IN NANOTESLA.
C
C
C                   AUTHOR: NIKOLAI A. TSYGANENKO
C                           INSTITUTE OF PHYSICS
C                           ST.-PETERSBURG STATE UNIVERSITY
C                           STARY PETERGOF 198904
C                           ST.-PETERSBURG
C                           RUSSIA
C
      IMPLICIT NONE
C
      REAL*8 PS,X,Y,Z,BX,BY,BZ,PSI,SPS,CPS,P,U,V,T,Q
      INTEGER*4 M
      SAVE M,PSI,SPS,CPS

      DATA M,PSI/0,5.d0/
      IF(M.EQ.1.AND.ABS(PS-PSI).LT.1.d-5) GOTO 1
      SPS=SIN(PS)
      CPS=COS(PS)
      PSI=PS
      M=1
  1   P=X**2
      U=Z**2
      V=3.d0*Z*X
      T=Y**2
      Q=30574.d0/SQRT(P+T+U)**5
      BX=Q*((T+U-2.d0*P)*SPS-V*CPS)
      BY=-3.d0*Y*Q*(X*SPS+Z*CPS)
      BZ=Q*((P+T-2.d0*U)*CPS-V*SPS)
      RETURN
      END
c
c
c
c

!***************************************************************************************************
! Copyright 2001 D. Vallado, 2007 S. Bourdarie, T. Guild
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
C       
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SUBROUTINE sgp4_ele
C      Routine to convert from many different types of 
C      orbital elements to the set used by sgp4_orb, the 
C      ONERA orbit propagator.  Then calls the orbit propagator 
C      and rotates the resultant trajectory into whichever 
C      sysaxes is specified.  Output times and trajectory returned 
C      to the calling program.  
C
C     ele_opts (element options) array description:
c      !  first element in ele_opts array corresponds to element type:
c      !  1 = ONERA; requires i (inclination; deg), A_p (altitude of perigee; km), 
c      !      A_a (altitude of apogee; km), Omega (longitude of ascending node; deg), 
c      !      omega (argument of perigee; deg), M0 (mean anomaly at epoch; deg)
c      !  2 = CLASSICAL; requires a (semimajor axis; Re), e (eccentricity), 
c      !      i (inclination; deg), Omega (longitude of ascending node; deg), 
c      !      omega (argument of perigee; deg), tsfe (time of perigee in seconds 
c      !      from epoch; sec)
c      !  3 = RV;  requires vector r (km), v (km/s)
c      !  4 = SOLAR;  requres i (inclination; deg), A_p (altitude of perigee; km), 
c      !      A_a (altitude of apogee; km), H_a (local time of apogee; hrs), 
c      !      H_i (local time of maximum inclination; hrs), 
c      !      tsfe (time of perigee in seconds from epoch; sec)
c      !  5 = MEAN;  requires n (mean motion; rev/day), e (eccentricity), 
c      !      i (inclination; deg), Omega (longitude of ascending node; deg), 
c      !      omega (argument of perigee; deg), M (mean anomaly at epoch; deg)
c      
c      ! second element in the ele_opts array switches between e5=omega and PI
c      !    ele_opts(2)=1 means e5 is omega the argument of perigee (deg)
c      !    ele_opts(2)=2 means e5 is PI the longitude of perigee (deg)
c      !    ele_opts(2) only has effect for ele_opts(1) = 1, 2, 5
c
c      ! third element in the ele_opts array switches among different e6
c      !    ele_opts(3)=1 means e6 is tsfe the time of perigee in seconds from epoch (secs)
c      !    ele_opts(3)=2 means e6 is nu0 the true anomaly at epoch (deg)
c      !    ele_opts(3)=3 means e6 is u0 the argument of latitude at epoch (deg)
c      !    ele_opts(3)=4 means e6 is l0 the true longitude at epoch (deg) 
c      !    ele_opts(3)=5 means e6 is M0 the mean anomaly at epoch
c      !    ele_opts(2) only has effect for ele_opts(1) = 1, 2, 4, 5
C
C      Calling sequence from fortran:
C           
C      CALL  sgp4_ele1(sysaxes,iyr,imon,iday,ihr,imin,sec, 
C     &     e1,e2,e3,e4,e5,e6,options, 
C     &     startsfe,stopsfe,deltasec,
C     &     iaYear,iaDoy,ut,x1,x2,x3)
C
C         with the following types:
C      INTEGER*4 sysaxes
C      INTEGER*4 iyr,imon,iday,ihr,imin
C      REAL*8 sec
C      REAL*8 e1,e2,e3,e4,e5,e6
C      INTEGER*4 ele_opts(5)
C      REAL*8 startsfe, stopsfe, deltasec
C      INTEGER*4 iaYear(ntime_max),iaDoy(ntime_max)
C      REAL*8 ut(ntime_max),x1(ntime_max),x2(ntime_max),x3(ntime_max)
C
C     As with all (most?) onera library calls, the maximum array size
C     is limited to ntime_max elements.  If startsfe/stopsfe/deltasec 
C     are given such that the trajectory exceeds ntime_max positions, 
C     only the first ntime_max will be returned.  Errors will be issued 
C     to STDOUT, but not through IDL/Matlab wrappers.   
C                              Contributed by Timothy Guild, 3.7.07
C                               timothy.guild@aero.org
C     last updated 10.9.07 by tbg
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C

      SUBROUTINE sgp4_ele1(sysaxes,iyr,imon,iday,ihr,imin,sec, 
     +                       e1,e2,e3,e4,e5,e6,ele_opts, 
     +                       startsfe,stopsfe,deltasec,
     +                       iaYear,iaDoy,ut,x1,x2,x3)

      IMPLICIT NONE
      INCLUDE 'ntime_max.inc'

      INTEGER*4 ii,numOutputLines,sysaxes,debug
      INTEGER*4 iyr, imon, iday, ihr, imin,idoy
      INTEGER*4 iaYear(ntime_max),iaDoy(ntime_max)
      REAL*8 ut(ntime_max),x1(ntime_max),x2(ntime_max),x3(ntime_max)
      REAL*8 sec
      REAL*8 e1, e2, e3, e4, e5, e6
      REAL*8 keepe1, keepe2, keepe3, keepe4, keepe5, keepe6
      REAL*8 o1, o2, o3, o4, o5, o6
      REAL*8 a, e, i, BigOmega, omega, tsfe, BigPi
      REAL*8 nu0,u0,l0,M0,P,E0
      REAL*8 startsfe, stopsfe, deltasec,epoch
      INTEGER*4 ele_opts(5)
      EXTERNAL GET_DOY
      INTEGER*4 GET_DOY
      real*8     xGEO(3), MLT
      REAL*8 output(10,ntime_max) ! keeps the trajectory info from SGP4_orb1
      REAL*8 xINV(3,ntime_max),xOUTV(3,ntime_max)
      INTEGER*4 sysaxesFROM,sysaxesTO

      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'

      ! TBG, 10.9.07:  save the initial input elements to pass back, as per 
      ! Sebastien's suggestion.  
      keepe1 = e1
      keepe2 = e2
      keepe3 = e3
      keepe4 = e4
      keepe5 = e5
      keepe6 = e6

      debug = 0
      IF (debug.eq.1) THEN
                                ! check the values coming in
         PRINT*,'SGP4_ELE:  INPUT ARGUMENTS:'
         PRINT*,'iyr,imon,iday,ihr,imin,sec:',iyr,imon,iday,ihr,imin,sec
         PRINT*,'e1,e2,e3,e4,e5,e6:',e1,e2,e3,e4,e5,e6
         PRINT*,'ele_opts:',ele_opts
         PRINT*,'startsfe, stopsfe, deltasec:',startsfe,stopsfe,deltasec
      ENDIF
      
c     compute epoch from inputs.  epoch in Julian Days.  
      CALL JDAY(iyr,imon,iday,ihr,imin,sec,epoch) 


      IF (ele_opts(1) .eq. 1) THEN

         PRINT*, 'Converting these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         call fifthElement(e1,e2,e3,e4,e5,e6,ele_opts)
         call sixthElement(e1,e2,e3,e4,e5,e6,ele_opts)         
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         
      ELSE IF (ele_opts(1) .eq. 2) THEN
         PRINT*, 'Converting these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         CALL classical2onera(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
         call fifthElement(e1,e2,e3,e4,e5,e6,ele_opts)
         call sixthElement(e1,e2,e3,e4,e5,e6,ele_opts) 
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6

      ELSE IF (ele_opts(1) .eq. 3) THEN
         PRINT*, 'Converting these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         CALL rv2classical(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         CALL classical2onera(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         call fifthElement(e1,e2,e3,e4,e5,e6,ele_opts)
         call sixthElement(e1,e2,e3,e4,e5,e6,ele_opts) 
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6            

      ELSE IF (ele_opts(1) .eq. 4) THEN
         PRINT*, 'Converting these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         CALL solar2classical(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         CALL classical2onera(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         call fifthElement(e1,e2,e3,e4,e5,e6,ele_opts)
         call sixthElement(e1,e2,e3,e4,e5,e6,ele_opts) 
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6

      ELSE IF (ele_opts(1) .eq. 5) THEN
         PRINT*, 'Converting these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         CALL mean2classical(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         CALL classical2onera(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6
         call fifthElement(e1,e2,e3,e4,e5,e6,ele_opts)
         call sixthElement(e1,e2,e3,e4,e5,e6,ele_opts) 
         PRINT*, 'to these ele_opts = ',ele_opts
         PRINT*, 'with these elements = ',e1,e2,e3,e4,e5,e6

      ELSE 
         PRINT*,'ele_opts(1) must be 1-5'
      ENDIF

      IF (debug .eq. 1) THEN
         PRINT*, 'elements just before SGP4_ORB1 call---------------'
         PRINT*,'iyr,imon,iday,ihr,imin,sec:',iyr,imon,iday,ihr,imin,sec
         PRINT*,'e1,e2,e3,e4,e5,e6:',e1,e2,e3,e4,e5,e6
         PRINT*,'ele_opts:',ele_opts
         PRINT*,'startsfe, stopsfe, deltasec:',startsfe,stopsfe,deltasec
      ENDIF

c     compute how many lines the output array should have here
      numOutputLines = (stopsfe - startsfe)/deltasec

      IF (numOutputLines .gt. ntime_max) THEN
         PRINT*,'SGP4_ELE:  Given > ntime_max timesteps in the orbit'
         PRINT*,'propagation.  ONERA library requires less than that,'
         PRINT*,' so SGP4_ELE has truncated your request.  '
         stopsfe = startsfe + ntime_max*deltasec ! this forces the stop time to be 
                                ! at most NTIME_MAX times, as required by ONERA lib
      ENDIF

c     Now call the orbit propagator with the epoch and proper 
C     orbital elements computed above.  Trajectory timeseries 
c     returned in the 'output' array.  
      CALL SGP4_ORB1(iyr,imon,iday,ihr,imin,sec, e1,e2,e3,e4,e5,e6, 
     +     startsfe,stopsfe,deltasec,sysaxes,output)
      
c     unpack the 'output' array into arguments make_lstar uses.  
      DO ii = 1,numOutputLines
         iaYear(ii) = INT(output(3,ii))   ! array of years
         iaDoy(ii) = GET_DOY(INT(output(3,ii)),INT(output(2,ii)),
     &        INT(output(1,ii)))   !  array of DOYs
         x1(ii) = output(8,ii)  ! input X coordinate
         x2(ii) = output(9,ii)  ! input Y coordinate
         x3(ii) = output(10,ii) ! input Z coordinate
         ut(ii) = output(4,ii)*3600d0+output(5,ii)*60d0+output(6,ii)
      ENDDO

      ! TBG, 10.9.07: now assign the original elements back to the e1-e6 variables
      e1 = keepe1
      e2 = keepe2
      e3 = keepe3
      e4 = keepe4
      e5 = keepe5
      e6 = keepe6

      END

C********************************************************************************
C Now for the subroutines which convert between element sets, and various 
C supporting subroutines
C********************************************************************************

C********************************************************************************
C     CLASSICAL2ONERA
C********************************************************************************
 
      SUBROUTINE classical2onera(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
      
      IMPLICIT NONE

      INTEGER*4 debug
      INTEGER*4 ele_opts(5)
      REAL*8 e1, e2, e3, e4, e5, e6
      REAL*8 out1, out2, out3, out4, out5, out6
      REAL*8 r_a, r_p,epoch,tsfe,P,a,e,i,A_p,A_a
      REAL*8 nu0,u0,l0,M0,bigomega,bigpi,omega

      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'

      debug = 0

C     need to convert a,   e,   i,   Omega,   omega (or PI), tsfe (or nu0,u0,l0,M0) to 
C     to              i,  A_p, A_a,  Omege,   omega (or PI), M0 (or nu0,u0,l0,tsfe)

C     First, do the first four elements.  

      i = e3  ! inclination is given
      a = e1  !  semimajor axis given
      e = e2  ! eccentricity given
      bigomega = e4  ! longitude of ascending node given

      r_a = a*(1.d0+e)  ! radius of apogee is a(1+e), in Re
      r_p = a*(1.d0-e)  ! radius of perigee is a(1-e), in Re

      A_p = (r_p-1.d0)*rekm  ! perigee altitude in km
      A_a = (r_a-1.d0)*rekm  ! apogee altitude in km  

      e1 = i
      e2 = A_p
      e3 = A_a
c      e4 = bigomega   ! pass these numbers through.  
c      e5 = omega
c      e6 = M0  

      ele_opts(1) = 1   ! save for the last two elements, this is now ONERA elements. 

      END


C********************************************************************************
C     RV2CLASSICAL   
C
C     TBG:  Wait, sgp4ext.f contains a subroutine rv2coe which does this.
C     Just manage the bookkeeping and call it in this subroutine.   
C********************************************************************************

      SUBROUTINE rv2classical(e1,e2,e3,e4,e5,e6,epoch,ele_opts)

      IMPLICIT NONE
      INTEGER*4 ii,debug,ele_opts(5)
      REAL*8 e1, e2, e3, e4, e5, e6,epoch
      REAL*8 nu0,u0,l0,M0,Period,E0,tsfe
      EXTERNAL DOT, MAG, RV2COE
      REAL*8 DOT, MAG

      ! variables for call to rv2coe
      REAL*8 R(3), V(3), P, A, Ecc, Incl, Omega, Argp, Nu, M, ArgLat,
     &         TrueLon, LonPer

      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'

      debug = 1

c     convert RV:  r(1), r(2), r(3), v(1), v(2), v(3) where r (km) and v (km/s)
c     to Classical:  a, e, i, Omega, omega (or PI), tsfe (or nu0,u0,l0,M0)
      
      R(1) = e1
      R(2) = e2
      R(3) = e3
      V(1) = e4
      V(2) = e5
      V(3) = e6

      IF (debug .eq. 1) THEN
         PRINT*, 'R, V = ',R, V
      ENDIF
C just call rv2coe from sgp4ext.f in the ONERA library
      CALL rv2coe ( R, V, P, A, Ecc, Incl, Omega, Argp, Nu,
     &                         M, ArgLat, TrueLon, LonPer )

      IF (debug .eq. 1) THEN 
         PRINT*, 'P,A,Ecc,Incl,Omega,Argp,Nu,M,ArgLat,TrueLon,LonPer',
     &        P,A,Ecc,Incl,Omega,Argp,Nu,M,ArgLat,TrueLon,LonPer
      ENDIF

      e1 = a / (rekm)  ! convert semimajor axis back to RE
      e2 = Ecc
      e3 = Incl*Rad2Deg   ! convert from Rad to degrees
      e4 = Omega*Rad2Deg  ! convert from Rad to degrees
      e5 = argp*Rad2Deg   ! convert from Rad to degrees
      e6 = M*Rad2Deg    ! mean anomaly

      ele_opts(1) = 2    !   now in classical elements
      ele_opts(2) = 1   ! with omega instead of PI
      ele_opts(3) = 5   ! and e6 = mean anomaly calculated from rv2coe

      END


C********************************************************************************
C     SOLAR2CLASSICAL
C********************************************************************************

      SUBROUTINE solar2classical(e1,e2,e3,e4,e5,e6,epoch,ele_opts)

      IMPLICIT NONE
      INTEGER*4 ii,day,epochDay,debug,ele_opts(5)
      REAL*8 e1, e2, e3, e4, e5, e6
      REAL*8 out1, out2, out3, out4, out5, out6
      REAL*8 p, a, i,BigOmega,omega,l0,u0,nu0,epoch
      REAL*8 startDate,hour,A_a, A_p,r_a,r_p,H_e,H_a,H_i
      REAL*8 Theta_a, Theta_i, e, M0, n,tsfe

      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'

      debug = 0

c     convert Solar: i, A_p, A_a, H_a, H_i, tsfe (or nu0, u0, l0, M0)
c     to Classical : a, e, i, Omega, omega, tsfe (or nu0, u0, l0, M0)

      A_a = e3
      A_p = e2
      H_a = e4
      H_i = e5
      i = e1

      CALL JDAY ( 1992,1,1,0,0,0.d0,  startDate )   ! B-3, APEXRAD
      epochDay = epoch
      day = 1 + epochDay - startDate !these are days and hours since startDate
      hour = 24.d0*DMOD(epoch,1.d0)

      r_a = rekm + A_a   ! B-4, B-5, APEXRAD
      r_p = rekm + A_p
      
      e = (r_a - r_p) / (r_a + r_p)    !  B-9, APEXRAD

      a = (r_a + r_p )/2.d0   

      IF (debug .eq. 1) THEN
         PRINT*,'SOLAR2CLASSICAL:  r_a, r_p,H_a,H_i epoch, epochDay= ',
     &        r_a,r_p,H_a,H_i,epoch,epochDay
      ENDIF 

      !  B-6, APEXRAD
c     B-6 in APEXRAD manual might have typo.  Paul thinks last term should 
c     be close to zero, not one, and the difference might be between UT and LT.
c      H_e = 6.594703 + 0.06570982463 * day + 1.00273791 * hour 
      H_e = 6.594703 + 0.06570982463 * day + 0.00273791 * hour 

      IF (debug .eq. 1) THEN
         PRINT*,'SOLAR2CLASSICAL:  day,hour,H_e = ',day,hour,H_e
      ENDIF
      Theta_a = (H_a + 12.d0) * (PI/12.d0) ! radians, B-7, B-8, APEXRAD
      Theta_i = (H_i -6.d0 ) * (PI/12.d0)
      
      IF (debug .eq. 1) THEN
         PRINT*,'S2C:  H_e, Theta_a, Theta_i = ',H_e, Theta_a, Theta_i
      ENDIF 

      IF (debug .eq. 1) THEN
         PRINT*,'S2C:  e, a, P, M0, tsfe = ',e, a, P, M0, tsfe
      ENDIF      
c     Otherwise, assume satellite at apogee at epoch (B-10, APEXRAD)
c      M0 = 180

      IF (debug .eq. 1)  THEN
         PRINT*,'SOLAR2Classical: r_a,r_p,A_a,A_p,e= ',r_a,r_p,A_a,A_p,e
      ENDIF
      n = SQRT((MU*(12.d0*3600.d0/PI)**2)/(a**3d0) ) ! B-11, APEXRAD
      BigOmega = 15.d0*(H_i - 6.d0 + H_e) ! B-12, APEXRAD
      BigOmega = DMOD(DMOD(BigOmega,360d0) + 360d0,360d0)  !  0 to 360
      IF (debug .eq. 1) THEN
         PRINT*,'S2C:  n,BigOmega = ',n, BigOmega
      ENDIF      
c     APEXRAD B-13 gives cos(omega) = cos(Theta_a)*cos(Theta_i) + sin(Theta_a)*sin(Theta_i)
c     Paul claims that the following is equivalent:
      omega = (Theta_a - Theta_i) * (180d0/PI)
      omega = DMOD(DMOD(omega,360d0) + 360d0,360d0)  !  0 to 360

      IF (debug .eq. 1) THEN
         PRINT*,'S2C: omega = ',omega
      ENDIF                     
      ! now take those mean elements and convert them to classical ones
      e1 = n
      e2 = e
      e3 = i
      e4 = BigOmega
      e5 = omega
c      e6 = M0   ! leave whatever e6 came in as.  

      ele_opts(1) = 5   ! elements are now mean elements.
      ele_opts(2) = 1   ! omega specified

      PRINT*, 'S2C: Converting mean ele 
     &     (n,e,i,Omega,omega,(tsfe,nu0,u0,l0,m0):',e1,e2,e3,e4,e5,e6
      CALL mean2classical(e1,e2,e3,e4,e5,e6,epoch,ele_opts)
      PRINT*, 'S2C: to Classical elements: ', e1,e2,e3,e4,e5,e6
      
      END

C********************************************************************************
C     MEAN2CLASSICAL
C********************************************************************************

      SUBROUTINE mean2classical(e1,e2,e3,e4,e5,e6,epoch,ele_opts)

      IMPLICIT NONE
      INTEGER*4 debug,ele_opts(5)
      REAL*8 e1, e2, e3, e4, e5, e6
      REAL*8 out1, out2, out3, out4, out5, out6
      REAL*8 p, a, i,BigOmega,omega,l0,u0,nu0,epoch
      REAL*8 n, acubed,M0,tsfe

      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'

      debug = 0

c     mean elements are n, e, i, BigOmega, omega, M0
c     classical are a, e, i, BigOmega, omega, tsfe  

      ! first convert the mean motion n into semimajor axis a
      n = e1*(TwoPi/86400.d0)  ! mean motion converted from revs/day to rads/s
      acubed = mu / (n**2.d0)  ! Eq. 6-13, SMAD
      a = acubed**(1.d0/3.d0)

      IF (debug .eq. 1) THEN
         PRINT*,'M2C:  in1, n, a = ',e1, n, a
         PRINT*,'M2C:  p, M0, tsfe = ',p, M0, epoch, tsfe
      ENDIF

      e1 = a / rekm  ! convert back to RE
c      e6 = tsfe   ! still undefined 

      ele_opts(1) = 2   ! elements now classical, leave ele_opts(2,3) as they came in.  

      END


C********************************************************************************
C     tsfe2M0:  calculate mean anomaly (M0) given time of perigee
C********************************************************************************
      SUBROUTINE tsfe2M0(tsfe,a,M0)
      
      IMPLICIT NONE
      INTEGER*4 debug
      REAL*8 a,tsfe,M0,P,negM0
c      EXTERNAL REM   ! line commented by S. Bourdarie
c      REAL*8 REM   ! line commented by S. Bourdarie

      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'      
      
      P = twopi*DSQRT(a**3/mu) ! in seconds
      M0 = -360.d0*(tsfe/P)    
      M0 = DMOD(DMOD(M0,360.d0)+360.d0,360.d0) ! DMOD = REM for positive arguments only.  

      PRINT*,'Converting tsfe (',tsfe,') to M0 (',M0,')'

      END

C********************************************************************************
C     fifthElement:  determine which e5 was passed in, convert to omega
C********************************************************************************
      SUBROUTINE fifthElement(e1,e2,e3,e4,e5,e6,ele_opts)
      
      IMPLICIT NONE
      INTEGER*4 debug,ele_opts(5)
      REAL*8 e1,e2,e3,e4,e5,e6
      REAL*8 omega, BigPi
      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'      
      
      IF ((ele_opts(1).eq.1) .or. (ele_opts(1).eq.2) .or. 
     &     (ele_opts(1).eq.5)) THEN
         
         IF (ele_opts(2).eq.1) THEN ! omega
                                ! do nothing, omega is default
         ELSE IF (ele_opts(2).eq.2) THEN ! PI, longitude of perigee
            BigPi = e5
            omega = MOD(e5 - e4 + 360D0, 360D0)
            e5 = omega
            ele_opts(2) = 1
            
            PRINT*,'Converting PI (',BigPi,') to omega (',omega,')'
            
         ELSE 
            PRINT*,'ele_opts(2) must be either 1 (omega) or 2 (PI)'
            
         ENDIF
         
      ELSE
c               ele_opts(1) is 3 or 4, both have different values for e5.           
         PRINT*,'fifthElement: no change to ele_opts(1) = 3,4'   
                                
      ENDIF     
       
      END
      
C********************************************************************************
C     sixthElement:  determine which e6 was passed in, convert to M0
C********************************************************************************
      SUBROUTINE sixthElement(e1,e2,e3,e4,e5,e6,ele_opts)
      
      IMPLICIT NONE
      INTEGER*4 debug,ele_opts(5)
      REAL*8 e1,e2,e3,e4,e5,e6
      REAL*8 M0, e, nu0, u0, l0, r_a, r_p, a,tsfe
      REAL*8 n, acubed
      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'      
      
      IF (ele_opts(1).eq.1) THEN ! ONERA elements
         
         IF (ele_opts(3).eq.1) THEN ! tsfe
            r_p = e2 + rekm ! B-4, B-5, APEXRAD
            r_a = e3 + rekm
            a = (r_a + r_p) / 2.0D0
            CALL tsfe2M0(e6,a, M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.2) THEN !  nu0
            nu0 = e6
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.3) THEN !  u0
            nu0 = MOD(e6 - e5 + 360D0, 360D0)
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.4) THEN !  l0
            nu0 = MOD(e6 - e5 - e4 + 360D0, 360D0)
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.5) THEN !  M0
            ! ONERA element default, MO.  Do nothing.  
         ELSE
            PRINT*,'ele_opts(3) must be 1-5'
         ENDIF
         
      ELSE IF (ele_opts(1).eq.2) THEN ! Classical elements

         IF (ele_opts(3).eq.1) THEN ! tsfe
            r_p = e2 + rekm ! B-4, B-5, APEXRAD
            r_a = e3 + rekm
            a = (r_a + r_p) / 2.0D0
            CALL tsfe2M0(e6, a, M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.2) THEN !  nu0
            nu0 = e6
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            PRINT*,'e,nu0,m0 = ',e,nu0,m0
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.3) THEN !  u0
            nu0 = MOD(e6 - e5 + 360D0, 360D0)
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.4) THEN !  l0
            nu0 = MOD(e6 - e5 - e4 + 360D0, 360D0)
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.5) THEN !  M0
            ! ONERA element default, MO.  Do nothing.  
         ELSE
            PRINT*,'ele_opts(3) must be 1-5'
         ENDIF

         
      ELSE IF (ele_opts(1).eq.3) THEN !  RV elements
         
         PRINT*,'sixthElement:  No effect for RV elements'


      ELSE IF (ele_opts(1).eq.4) THEN ! Solar elements
         
         IF (ele_opts(3).eq.1) THEN ! tsfe
            r_p = e2 + rekm ! B-4, B-5, APEXRAD
            r_a = e3 + rekm
            a = (r_a + r_p) / 2.0D0
            CALL tsfe2M0(e6, a, M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.2) THEN !  nu0
            nu0 = e6
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.3) THEN !  u0
            nu0 = MOD(e6 - e5 + 360D0, 360D0)
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.4) THEN !  l0
            nu0 = MOD(e6 - e5 - e4 + 360D0, 360D0)
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.5) THEN !  M0
            ! ONERA element default, MO.  Do nothing.  
         ELSE
            PRINT*,'ele_opts(3) must be 1-5'
         ENDIF


      ELSE IF (ele_opts(1).eq.5) THEN ! Mean elements
         
         IF (ele_opts(3).eq.1) THEN ! tsfe
            n = e1*(TwoPi/86400.d0) ! mean motion converted from revs/day to rads/s
            acubed = mu / (n**2.d0) ! Eq. 6-13, SMAD
            a = acubed**(1.d0/3.d0)
            CALL tsfe2M0(e6, a, M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.2) THEN !  nu0
            nu0 = e6
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.3) THEN !  u0
            nu0 = MOD(e6 - e5 + 360D0, 360D0)
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.4) THEN !  l0
            nu0 = MOD(e6 - e5 - e4 + 360D0, 360D0)
            CALL computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
            CALL meanAnom(e,nu0,M0)
            e6 = M0
            ele_opts(3) = 5
         ELSE IF (ele_opts(3).eq.5) THEN !  M0
            ! ONERA element default, MO.  Do nothing.  
         ELSE
            PRINT*,'ele_opts(3) must be 1-5'
         ENDIF


      ELSE 
         PRINT*, 'ele_opts(1) betwee 1 and 5'
      ENDIF
      
      END

C********************************************************************************
C     computeE:  calculate eccentricity given ele_opts(1)
C********************************************************************************
      SUBROUTINE computeE(e1,e2,e3,e4,e5,e6,e,ele_opts)
      
      IMPLICIT NONE
      INTEGER*4 debug,ele_opts(5)
      REAL*8 e1,e2,e3,e4,e5,e6,e,r_a,r_p
      ! variables for call to rv2coe
      REAL*8 R(3),V(3),P,A,Ecc,Incl,Omega,Argp,Nu,
     &     M,ArgLat,TrueLon,LonPer
      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'      
      
      IF ((ele_opts(1).eq.1).or.(ele_opts(1).eq.4)) THEN
         r_p = e2 + rekm
         r_a = e3 + rekm
         e = (r_a - r_p) / (r_a + r_p)
      ELSE IF ((ele_opts(1).eq.2).or.(ele_opts(1).eq.5)) THEN
         e = e2
      ELSE IF (ele_opts(1).eq.3) THEN
         R(1) = e1
         R(2) = e2
         R(3) = e3
         V(1) = e4
         V(2) = e5
         V(3) = e6
         PRINT*,'computeE: ', R, V
         CALL rv2coe( R, V, P, A, Ecc, Incl, Omega, Argp, Nu,
     &                         M, ArgLat, TrueLon, LonPer )
         e = Ecc
      ELSE 
         PRINT*,'ele_opts(1) must be 1-5'
      ENDIF   


      END

C********************************************************************************
C     meanAnom:  compute mean anomaly given e, nu0, m0
C     Derived from Kepler library routine xkep_meananom.c
c  http://pds-rings.seti.org/toolkits/kepler_102/xkep_meananom.c
C********************************************************************************
      SUBROUTINE meanAnom(e,nu0,M0)
      
      IMPLICIT NONE
      INTEGER*4 debug
      REAL*8 e,nu0,M0,eRatio,tanhalfPsi,psi
      INCLUDE 'astconst.cmn'
      INCLUDE 'astmath.cmn'      

      ! convert nu0 to radians
      nu0 = nu0 * Deg2Rad

      eRatio = DSQRT( ( 1.D0 + e ) / (1.D0 - e ) )
      tanhalfPsi = DTAN( 0.5D0 * nu0 ) / eRatio
      psi = 2.D0 * DATAN(tanhalfPsi)
      M0 = psi - e * DSIN(psi)
      M0 = M0 * Rad2Deg  ! convert to degrees for consistency 

      END

!***************************************************************************************************
! Copyright 2004 D. Vallado
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
* ---------------------------------------------------------------------
*http://www.centerforspace.com/downloads/files/pubs/AIAA%202006-6753%20Revisiting%20Spacetrack%20Report%203.pdf
*                              TESTFOR.FOR
*
*  this program tests the sgp4 propagator.
*
*                          companion code for
*             fundamentals of astrodynamics and applications
*                                  2004
*                            by david vallado
*
*     (w) 719-573-2600, email dvallado@agi.com
*     *****************************************************************
*  current :
*            08 jan 07  Sebastien Bourdarie
*                       include into onera_desp library
*            15 aug 06  david vallado
*                        update mfe for verification time steps, constants
*  changes :
*            20 jul 05  david vallado
*                         fixes for paper, corrections from paul crawford
*             7 jul 04  david vallado
*                         fix record file and get working
*            14 may 01  david vallado
*                         2nd edition baseline
*                   97  nasa
*                         internet version
*                   80  norad
*                         original baseline
*     *****************************************************************
*
*  Files         :
*    Unit 10     - input elm file  input file for element sets
*    Unit 11     - sgp4test.out    output file
*    Unit 14     - sgp4test.dbg    debug output file
*    Unit 15     - sgp4rec.bak     temporary file of record for 2 line element sets
*
*  Uses object files:
*    Sgp4ext,
*    Sgp4io,
*    Sgp4unit

        SUBROUTINE SGP4_TLE1(runtype,startsfe,stopsfe,deltasec
     &     ,InFileByte,strlenIn,OutFileByte,strlenOut)
        IMPLICIT NONE
	INTEGER*4 runtype
        INTEGER*4 strlenIn,strlenOut
        INTEGER*4 Code, NumSats, TotalNumSats, k, error, whichconst
        INTEGER*4 i,j, Year,yr,mon,day,hr,min,doy,GET_DOY,isec
c
        BYTE      InFileByte(strlenIn),OutFileByte(strlenOut)
c
        Character typerun
        Character*500 InFileName,OutFileName

        Character*3 MonStr,Monthtitle(12)
        Real*8 ro(3),vo(3), startmfe, stopmfe, deltamin
        Real*8 startsfe, stopsfe, deltasec

        REAL*8 p, ecc, incl, node, argp, nu, m,arglat,truelon,lonper

* ----------------------------  Locals  -------------------------------
        REAL*8 J2,TwoPi,Rad,RadiusEarthKm,VKmPerSec, xke,
     &         de2ra, xpdotp, T, sec, JD, pi, j3, j4, j3oj2, tumin
	REAL*8  secs,xGEI(3),xOUT(3),alti,lati,longi,dec_y


        INCLUDE 'SGP4.CMN'

        COMMON /DebugHelp/ Help
        CHARACTER Help
        Help = 'N'

* ------------------------  Implementation   --------------------------
c   Start modif Seb  Dec 12, 2006
c
c        typerun = 'C' ! complete catlog
c        typerun = 'V' ! validation only, header satnum and r and v tsince
c        write(*,*) 'Input typerun - V, C, N, Y'
c        read(*,*) typerun
c changed input times from minute to seconds by SB. The first
c 3 lines change it back to minutes to be compliant with SGP4 code.
        startmfe=startsfe/60.0D0
        stopmfe=stopsfe/60.0D0
        deltamin=deltasec/60.0D0
        if (runtype .eq. 0) typerun='Y'
        if (runtype .eq. 1) then
	   typerun='C'
	   if (stopmfe .LE. startmfe) stopmfe=startmfe+1440.0D0
	endif
	if (deltamin .LE. 0.D0) deltamin=1.D0
c
        DO i=1,strlenIn
	   InFileName(i:i)=char(InFileByte(i))
	ENDDO
        InFileName=InFileName(1:strlenIn) ! added by TPO
        DO i=1,strlenOut
	   OutFileName(i:i)=char(OutFileByte(i))
	ENDDO
        OutFileName=OutFileName(1:strlenOut) ! added by TPO
c
c        write(*,*) 'Input whichconst - 721, 72, 84'
c        read(*,*) whichconst
        whichconst=84
c
c  End modif Seb Dec 12, 2006
c
        TwoPi         =    6.28318530717959D0
        Rad           =   57.29577951308230D0
        DE2RA         =    0.01745329251994330D0
        pi            =    3.14159265358979D0
        xpdotp        =  1440.0 / (2.0 *pi)  ! 229.1831180523293D0

        ! sgp4fix identify constants and allow alternate values
        CALL getgravconst( whichconst, tumin, radiusearthkm, xke, j2,
     &       j3, j4, j3oj2 )
        VKmPerSec     =  RadiusEarthKm * xke/60.0D0

        MonthTitle( 1)= 'Jan'
        MonthTitle( 2)= 'Feb'
        MonthTitle( 3)= 'Mar'
        MonthTitle( 4)= 'Apr'
        MonthTitle( 5)= 'May'
        MonthTitle( 6)= 'Jun'
        MonthTitle( 7)= 'Jul'
        MonthTitle( 8)= 'Aug'
        MonthTitle( 9)= 'Sep'
        MonthTitle(10)= 'Oct'
        MonthTitle(11)= 'Nov'
        MonthTitle(12)= 'Dec'

        ! ---------------- Setup files for operation ------------------
        ! 10 input 2-line element set file
c        Write(*,*) 'Input elset filename '
c        Read(*,*) InFileName
        OPEN(10,FILE = InFileName ,STATUS='OLD',
     &          ACCESS = 'SEQUENTIAL' )

        ! 11 output file
c        IF (typerun.eq.'C') THEN
c            OPEN(11,FILE = 'tforall.out' ,STATUS='UNKNOWN',
c     &              ACCESS = 'SEQUENTIAL' )
c          ELSEIF (typerun.eq.'V') THEN
c                OPEN(11,FILE = 'tforver.out' ,STATUS='UNKNOWN',
c     &              ACCESS = 'SEQUENTIAL' )
c              ELSE
c                OPEN(11,FILE = 'tfor.out' ,STATUS='UNKNOWN',
c     &              ACCESS = 'SEQUENTIAL' )
c              ENDIF
         OPEN(11,FILE = OutFileName ,STATUS='UNKNOWN',
     &           ACCESS = 'SEQUENTIAL' )

c        OPEN(14,FILE = 'sgp4test.dbg' ,STATUS='UNKNOWN',
c     &          ACCESS = 'SEQUENTIAL' )

        ! ----- 15 temporary file of record for 2 line element sets ---
c        OPEN(15,FILE = 'Sgp4Rec.bak', ACCESS = 'DIRECT',
c     &          FORM = 'UNFORMATTED', RECL = 1100, STATUS = 'UNKNOWN' )

        ! ----------------- Test simple propagation -------------------
        NumSats = 0
        DOWHILE (Code.ne.999)
            Numsats = NumSats + 1
            CALL TwoLine2RVSGP4 ( NumSats,typerun,whichconst,startmfe,
     &                            stopmfe,deltamin,Code )

c            Write(11,*) '',SatNum,' xx'
c            Write(*,*) SatNum
            ! write out epoch value
            T = 0.0D0
            CALL SGP4 ( whichconst, T, Ro, Vo, Error )
c            WRITE( 11,800 ) T, ro(1),ro(2),ro(3),vo(1),vo(2),vo(3)

            ! now initialize time variables
            T      = startmfe

            ! check so the first value isn't written twice
            IF ( DABS(T).gt.0.00000001D0 ) THEN
                T = T - DeltaMin
              ENDIF

            DOWHILE ( (T+ DeltaMin.le.stopmfe).and.(Error.eq.0) )
                T = T + DeltaMin
c                IF (T.gt.stopmfe) THEN
c                    T = stopmfe
c                  ENDIF
                CALL SGP4 ( whichconst, T, Ro, Vo, Error )

                IF (Error .gt. 0 ) THEN
                    Write(*,*) '# Error in SGP4 .. ',
     &                     Error
                  ENDIF

                IF ( error .eq. 0) THEN

c                 IF ((typerun.ne.'V').and.(typerun.ne.'C')) THEN
                 IF (typerun.ne.'V') THEN
                     JD = JDSatEpoch + T/1440.0D0
                     CALL INVJDAY( JD, Year,Mon,Day,Hr,Min, Sec )
                     IF (Year.ge.2000) THEN
                         Yr = Year - 2000
                       ELSE
                         Yr = Year - 1900
                       ENDIF
                     MonStr = MonthTitle( Mon )
c
c   Start modif Seb  Dec 12, 2006
c Force output to be Altitude, latitude, longitude rather than ECI (or GEI)
c
		     DOY = GET_DOY(Year,Mon, Day)
		     secs=3600.D0*Hr+60.D0*Min+1.D0*Sec
		     xGEI(1)=ro(1)/6371.2D0
		     xGEI(2)=ro(2)/6371.2D0
		     xGEI(3)=ro(3)/6371.2D0
             call coord_trans1(13,0,Year,DOY,secs,xGEI,xOUT)
             alti=xOUT(1)
             lati=xOUT(2)
             longi=xOUT(3)
c		     call gei2geo1(Year,DOY,secs,xGEI,xGEO)
c		     call geo_gdz(xGEO(1),xGEO(2),xGEO(3),
c     &                    lati,longi,alti)
c                     WRITE( 11,'(F17.8,I4,1x,A3,I3,I3,A1,I2,A1,F9.6,
c     &                         3F17.6,3F17.8)' )
c     &                    JD,Day,MonStr,Yr,Hr,':',Min,':',
c     &                   Sec, ro(1),ro(2),ro(3),vo(1),vo(2),vo(3)
                     isec=INT(sec)
                     CALL DATE_AND_TIME2DECY(Year,Mon, Day,
     &                    hr,min,isec,Dec_y)
                     WRITE( 11,'(I2.2,A1,I2.2,A1,I4,1x,I3,A1,I2,A1,F9.6,
     &                         1x,f13.8,1x,3F17.6)' )
     &                    Day,'/',Mon,'/',Year,Hr,':',Min,':',
     &                   Sec, Dec_y,alti,lati,longi
c
c   End modif Seb  Dec 12, 2006
c
                   ELSE
                     WRITE( 11,800 )
     &                   T,ro(1),ro(2),ro(3),vo(1),vo(2),vo(3)
  800  FORMAT(F17.8,3F17.8,3(1X,F14.9))

c                     call rv2coe(ro, vo, p, a, ecc, incl, node, argp,
c     &                           nu, m, arglat, truelon, lonper )
c
c                     write(11,801) T ,ro(1),ro(2),ro(3),vo(1),vo(2),
c     &                             vo(3),a, ecc, incl*rad, node*rad,
c     &                             argp*rad, nu*rad, m*rad

  801  FORMAT(F17.8,3F17.8,3(1X,F13.9),f15.6,f9.6,f11.5,f11.5,f11.5,
     &          f11.5,f11.5)

                  ENDIF ! typerun

               ENDIF ! if error

             ENDDO ! propagating the case

          ENDDO ! while through file
	  close(11)

      END

!***************************************************************************************************
! Copyright 2008 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
!***************************************************************************************************
c---------------------------------------------------------------------------------------------------
!                              Introduced in version 4.3
c fly_in_meo_gnss.f
c
c DESCRIPTION: MEO-V2 gives differential or integrated electron spectrum 
c              between 280 keV and 2240 keV at GPS navigation orbit
c              as a function of the solar cycle
c
c INPUT    :   - Year of the launch (t=0 is the minimum of the solar cycle)
c
c              - Duration of the mission (in year)
c 
c OUTPUT     : - Year in the solar cycle according to the year of launch
c
c              - Differential or integrated electron fluxes averaged on all 
c		 the duration of the mission from the year of the launch
c                in MeV-1.cm-2.s-1.sr-1 or cm-2.s-1.sr-1 respectively
c		 in 3 cases (lower, mean, upper)
c
c
c CREATION : Sebastien Bourdarie - March 2008
c---------------------------------------------------------------------------------------------------

      SUBROUTINE fly_in_meo_gnss1(launch_year,duration,whichm,
     &                 whatf,nene,
     &                 energy,Lower_flux,Mean_flux,Upper_flux)

      IMPLICIT NONE
      INCLUDE 'variables.inc'

      INTEGER*4 Nenergy
      PARAMETER (Nenergy = 30)
      INTEGER*4 launch_year,year
      INTEGER*4 year_cycle
      INTEGER*4 duration
      INTEGER*4 whichm,whatf
      INTEGER*4 I,J,IE,indE
      INTEGER*4 K,K1
      INTEGER*4 Nene,NsE
      INTEGER*4 indice,flag
      REAL*8 flux_int_mean(Nenergy)
      REAL*8 energy(2,50),energies(Nenergy)
      REAL*8 Ecin,Emin,Emax
      REAL*8 Esmin,Esmax
      REAL*8 Es(100,20)
      REAL*8 Mean_flux(50),Upper_flux(50)
      REAL*8 Lower_flux(50)
      REAL*8 Mean_flux1(50),Upper_flux1(50)
      REAL*8 Lower_flux1(50)
      REAL*8 flux_omn,upper_flux_omn
      REAL*8 lower_flux_omn
      REAL*8 flux_omn1,upper_flux_omn1
      REAL*8 lower_flux_omn1
      REAL*8 flux_tab(Nenergy,11)
      REAL*8 p_1,c_1
      REAL*8 eps
      PARAMETER (eps = 0.01)
      
      COMMON  /Param_meo_gnss/ flux_tab,energies,Emin,Emax

      IF (launch_year .EQ. 0) then
         write(6,*)'*****************************'
         write(6,*)'Launch Year is out of range'
         write(6,*)'*****************************'
         stop
      ENDIF

      CALL calc_year_cycle(launch_year,year_cycle)

      IF (whichm .EQ. 1) 
     &    CALL search_flux_tab_meoV1

      IF (whichm .EQ. 2) 
     &    CALL search_flux_tab_meov2

      IF (whichm .NE. 1 .AND. whichm .NE. 2) then
         write(6,*)'*****************************'
         write(6,*)'Bad Input Parameter: whichm  '
         write(6,*)'Available choices: 1, or 2   '
         write(6,*)'*****************************'
         stop
      ENDIF 
      IF (whatf .NE. 1 .AND. whatf .NE. 2 .AND. whatf .NE. 3) then
         write(6,*)'*****************************'
         write(6,*)'Bad Input Parameter: whatf   '
         write(6,*)'Available choices: 1, 2 or 3 '
         write(6,*)'*****************************'
         stop
      ENDIF 

      DO i=1,Nenergy
         flux_int_mean(i)=0.d0
      ENDDO

      DO I=1,50
         Mean_flux(i)=0.D0
         Upper_flux(i)=0.D0
         Lower_flux(i)=0.D0
         Mean_flux1(i)=0.D0
         Upper_flux1(i)=0.D0
         Lower_flux1(i)=0.D0
      ENDDO

      DO j=1,duration
           year=launch_year+(j-1)
           CALL calc_year_cycle(year,year_cycle)
           IF (year_cycle .LT. -6) year_cycle=-6
           DO i=1,Nenergy
              flux_int_mean(i)=flux_int_mean(i)+
     &           flux_tab(i,year_cycle+7)
           ENDDO
      ENDDO

      DO j=1,Nenergy
         flux_int_mean(j) = flux_int_mean(j)/duration
      ENDDO

      IF (nene .EQ. 0) THEN
         Nene=7
         IF (whatf.EQ.1) THEN
            Nse=2
            DO I=1,Nenergy
               Energy(1,I)= Energies(I)
               Es(I,1) = Energies(I)-Eps
               Es(I,2) = Energies(I)+Eps
               if (Energies(I) .EQ. Emin) Es(I,1) = Energies(I)
               if (Energies(I) .EQ. Emax) Es(I,2) = Energies(I)
            ENDDO
         ENDIF
         IF (whatf.EQ.2) THEN
            Nse=2
            DO indE=1,Nenergy-1
               Energy(1,indE)= Energies(indE)
               Energy(2,indE)= Energies(indE+1)
               Es(indE,1) = Energies(indE)
               Es(indE,2) = Energies(indE+1)
            ENDDO
         ENDIF
         IF (whatf.EQ.3) THEN
             Nse=1
             DO indE=1,Nenergy
                Energy(1,indE)=Energies(indE)
                Es(indE,1) = Energies(indE)
             ENDDO
         ENDIF
      ELSE
         IF (whatf.EQ.1) THEN
            NsE = 2
            DO I=1,Nene
               Es(I,1) = Energy(1,I)-Eps
               Es(I,2) = Energy(1,I)+Eps
               if (Energy(1,I) .EQ. Emin) Es(I,1) = Emin
               if (Energy(1,I) .EQ. Emax) Es(I,2) = Emax
            ENDDO
         ENDIF
         IF (whatf.EQ.2) THEN
            NsE = 2
            DO indE=1,Nene
               Es(indE,1) = Energy(1,indE)
               Es(indE,2) = Energy(2,indE)
            ENDDO
         ENDIF
         IF (whatf.EQ.3) THEN
            NsE = 1
            DO indE=1,Nene
               Es(indE,1) = Energy(1,indE)
            ENDDO
         ENDIF
      ENDIF
            
      DO indE=1,NeNe
         DO  IE=1,NsE
            Ecin=Es(indE,IE)
            flux_omn = 0.D0
            upper_flux_omn=0.D0
            lower_flux_omn=0.D0
            IF (Ecin .GT. Emax) THEN
               Mean_flux1(indE)=baddata
               Upper_flux1(indE)=baddata
               Lower_flux1(indE)=baddata
               GOTO 203
            ENDIF
            IF (Ecin .LT. Emin) THEN
               Mean_flux1(indE)=baddata
               Upper_flux1(indE)=baddata
               Lower_flux1(indE)=baddata
               GOTO 203
            ENDIF
 
            DO K = 2,Nenergy
               IF (energies(K).GE.Ecin.AND.energies(K).NE.Emin) GOTO 60
            ENDDO
60          CONTINUE
            K1 = K
c
            IF (flux_int_mean(K1) .lt. 0.d0 .or.
     &         flux_int_mean(K1-1) .lt. 0.d0 ) goto 203
   
            p_1 = LOG(flux_int_mean(K1)/
     &         flux_int_mean(K1-1))
            p_1 = p_1/ LOG(energies(K1)/energies(K1-1))
            c_1 = LOG(flux_int_mean(K1))
     &         -p_1*LOG(energies(K1)) 
            flux_omn = EXP(p_1*LOG(Ecin)+c_1)
c       
            if (whichm .EQ. 1) then
               upper_flux_omn = flux_omn*(0.002d0*Ecin*1.d3+1.76d0)
               lower_flux_omn = flux_omn/(0.002d0*Ecin*1.d3+1.76d0)
            else
               upper_flux_omn = flux_omn*(0.0016d0*Ecin*1.d3+2.4d0)
               lower_flux_omn = flux_omn/(0.0016d0*Ecin*1.d3+2.4d0)
            endif
c            
            IF (whatf .EQ. 3) THEN
               Mean_flux1(indE) = flux_omn
               Upper_flux1(indE) = upper_flux_omn
               Lower_flux1(indE) = lower_flux_omn
            ELSE
               IF (IE .EQ. 1) THEN
                  Mean_flux1(indE) = flux_omn
                  Upper_flux1(indE) = upper_flux_omn
                  Lower_flux1(indE) = lower_flux_omn
               ELSE
                  if (Mean_flux1(indE) .GT. 0.D0 .AND. 
     &               flux_omn .GT. 0.D0) THEN
                     Mean_flux1(indE)=(flux_omn1-flux_omn)/
     &                  (Es(indE,2)-Es(indE,1))
                     Upper_flux1(indE)=(upper_flux_omn1-upper_flux_omn)/
     &                 (Es(indE,2)-Es(indE,1))
                     Lower_flux1(indE)=(lower_flux_omn1-lower_flux_omn)/
     &                 (Es(indE,2)-Es(indE,1))
                  ENDIF
               ENDIF
            ENDIF
           flux_omn1 = flux_omn
           upper_flux_omn1 = upper_flux_omn
           lower_flux_omn1 = lower_flux_omn
203        CONTINUE
         ENDDO
      ENDDO
c
      DO I=1,Nene
         Mean_flux(i)=Mean_flux1(I)
         Upper_flux(i)=Upper_flux1(I)
         Lower_flux(i)=Lower_flux1(I)
      ENDDO
c
c
      END

c---------------------------------------------------------------------------------------------------
c                              Introduced in version 4.3
c
c CREATION: S. Bourdarie March 2008
c
c DESCRIPTION:  Data for MEO-V2 (energies, flux)
c
c INPUT: none
c OUTPUT: flux_tab,energies
c
c CALLING SEQUENCE: call search_flux_tab_meoV2
c---------------------------------------------------------------------------------------------------

      SUBROUTINE search_flux_tab_meov2

      IMPLICIT NONE

      INTEGER*4      I,J
      INTEGER*4      Nenergy
      PARAMETER (Nenergy = 30)
      REAL*8            energies(Nenergy)
      REAL*8            flux_tab(Nenergy,11)
      REAL*8            tab1(11),tab2(11),tab3(11)
      REAL*8            tab4(11),tab5(11),tab6(11)
      REAL*8            tab7(11)
      REAL*8            Emin,Emax

      COMMON  /Param_meo_gnss/ flux_tab,energies,Emin,Emax
      
      do i=1,Nenergy
         do j=1,11
            flux_tab(i,j)=0.d0
         enddo
      enddo
       
      Emin=280.d-3
      Emax=2240.d-3

      energies(1) =280.d-3
      energies(2) =400.d-3
      energies(3) =560.d-3
      energies(4) =800.d-3
      energies(5) =1120.d-3
      energies(6) =1600.d-3
      energies(7) =2240.d-3
      
c      indice 1 du tableau:annee -6 ... indice 11 du tableau:annee +4

c      280keV
      DATA tab1 /
     &  6.49D+05,5.56D+05,8.28D+05,9.51D+05,1.31D+06,1.10D+06,
     &  9.14D+05,7.89D+05,8.04D+05,6.64D+05,5.65D+05/
     
      DO I=1,11
         flux_tab(1,I)=tab1(I)
      ENDDO
      
c      400keV
      DATA tab2 /
     &  3.79D+05,3.23D+05,5.14D+05,6.18D+05,8.87D+05,7.33D+05,
     &  5.88D+05,5.00D+05,4.99D+05,3.92D+05,3.31D+05/
     
      DO I=1,11
         flux_tab(2,I)=tab2(I)
      ENDDO

c      560keV
      DATA tab3 /
     &  1.64D+05,1.43D+05,2.44D+05,3.03D+05,4.57D+05,3.67D+05,
     &  2.83D+05,2.38D+05,2.33D+05,1.76D+05,1.45D+05/
     
      DO I=1,11
         flux_tab(3,I)=tab3(I)
      ENDDO

c      800keV
      DATA tab4 /
     &  6.00D+04,5.53D+04,1.02D+05,1.29D+05,2.09D+05,1.59D+05,
     &  1.17D+05,9.70D+04,9.40D+04,6.81D+04,5.39D+04/
     
      DO I=1,11
         flux_tab(4,I)=tab4(I)
      ENDDO

c      1120keV
      DATA tab5 /
     &  2.01D+04,2.05D+04,3.98D+04,5.10D+04,8.84D+04,6.34D+04,
     &  4.47D+04,3.64D+04,3.50D+04,2.45D+04,1.86D+04/
     
      DO I=1,11
         flux_tab(5,I)=tab5(I)
      ENDDO

c      1600keV
      DATA tab6 /
     &  4.94D+03,5.65D+03,1.16D+04,1.51D+04,2.82D+04,1.90D+04,
     &  1.27D+04,1.02D+04,9.67D+03,6.53D+03,4.72D+03/
     
      DO I=1,11
         flux_tab(6,I)=tab6(I)
      ENDDO

c      2240keV
      DATA tab7 /
     &  1.12D+03,1.40D+03,3.02D+03,3.97D+03,7.91D+03,5.05D+03,
     &  3.24D+03,2.57D+03,2.41D+03,1.58D+03,1.09D+03/
     
      DO I=1,11
         flux_tab(7,I)=tab7(I)
      ENDDO

c     
      END
c---------------------------------------------------------------------------------------------------
c                              Introduced in version 4.3
c
c CREATION: S. Bourdarie March 2008
c
c DESCRIPTION:  Data for MEO-V1 (energies, flux)
c
c INPUT: none
c OUTPUT: flux_tab,energies
c
c CALLING SEQUENCE: call search_flux_tab_meoV1
c---------------------------------------------------------------------------------------------------

      SUBROUTINE search_flux_tab_meov1

      IMPLICIT NONE

      INTEGER*4      I,J
      INTEGER*4      Nenergy
      PARAMETER (Nenergy = 30)
      REAL*8            energies(Nenergy)
      REAL*8            flux_tab(Nenergy,11)
      REAL*8            tab1(11),tab2(11),tab3(11)
      REAL*8            tab4(11),tab5(11),tab6(11)
      REAL*8            tab7(11)
      REAL*8            Emin,Emax

      COMMON  /Param_meo_gnss/ flux_tab,energies,Emin,Emax
      
      do i=1,Nenergy
         do j=1,11
            flux_tab(i,j)=0.d0
         enddo
      enddo
       
      Emin=280.d-3
      Emax=1120.d-3

      energies(1) =280.d-3
      energies(2) =400.d-3
      energies(3) =560.d-3
      energies(4) =800.d-3
      energies(5) =1120.d-3
      
      
c      indice 1 du tableau:annee -6 ... indice 11 du tableau:annee +4

c      280keV
      DATA tab1 /
     &  9.17D+05,9.17D+05,9.17D+05,9.17D+05,9.17D+05,9.17D+05,
     &  9.17D+05,9.17D+05,9.17D+05,9.17D+05,9.17D+05/
     
      DO I=1,11
         flux_tab(1,I)=tab1(I)
      ENDDO
      
c      400keV
      DATA tab2 /
     &  5.54D+05,5.54D+05,5.54D+05,5.54D+05,5.54D+05,5.54D+05,
     &  5.54D+05,5.54D+05,5.54D+05,5.54D+05,5.54D+05/
     
      DO I=1,11
         flux_tab(2,I)=tab2(I)
      ENDDO

c      560keV
      DATA tab3 /
     &  2.79D+05,2.79D+05,2.79D+05,2.79D+05,2.79D+05,2.79D+05,
     &  2.79D+05,2.79D+05,2.79D+05,2.79D+05,2.79D+05/
     
      DO I=1,11
         flux_tab(3,I)=tab3(I)
      ENDDO

c      800keV
      DATA tab4 /
     &  1.17D+05,1.17D+05,1.17D+05,1.17D+05,1.17D+05,1.17D+05,
     &  1.17D+05,1.17D+05,1.17D+05,1.17D+05,1.17D+05/
     
      DO I=1,11
         flux_tab(4,I)=tab4(I)
      ENDDO

c      1120keV
      DATA tab5 /
     &  5.15D+04,5.15D+04,5.15D+04,5.15D+04,5.15D+04,5.15D+04,
     &  5.15D+04,5.15D+04,5.15D+04,5.15D+04,5.15D+04/
     
      DO I=1,11
         flux_tab(5,I)=tab5(I)
      ENDDO
c
c     
      END

!***************************************************************************************************
! Copyright 2006 S. Bourdarie
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
! CREATION: S. Bourdarie - ONERA-DESP
!
! FILE CONTENT: 
!               SUBROUTINE hae2heeq1: Coordinate transformation from HAE (Heliocentric Aries Ecliptic) to HEEQ (Heliocentric Earth Equatorial)
!               SUBROUTINE HAE_HEEQ: Coordinate transformation from HAE (Heliocentric Aries Ecliptic) to HEEQ (Heliocentric Earth Equatorial)
!               SUBROUTINE heeq2hae1: Coordinate transformation from HEEQ (Heliocentric Earth Equatorial) to HAE (Heliocentric Aries Ecliptic)
!               SUBROUTINE HEEQ_HAE: Coordinate transformation from HEEQ (Heliocentric Earth Equatorial) to HAE (Heliocentric Aries Ecliptic)
!               SUBROUTINE hae2hee1: Coordinate transformation from HAE (Heliocentric Aries Ecliptic) to HEE (Heliocentric Earth Ecliptic)
!               SUBROUTINE HAE_HEE: Coordinate transformation from HAE (Heliocentric Aries Ecliptic) to HEE (Heliocentric Earth Ecliptic)
!               SUBROUTINE hee2hae1: Coordinate transformation from HEE (Heliocentric Earth Ecliptic) to HAE (Heliocentric Aries Ecliptic)
!               SUBROUTINE HEE_HAE: Coordinate transformation from HEE (Heliocentric Earth Ecliptic) to HAE (Heliocentric Aries Ecliptic)
!               SUBROUTINE gse2hee1: Coordinate transformation from GSE to HEE (Heliocentric Earth Ecliptic)
!               SUBROUTINE hee2gse1: Coordinate transformation from HEE to GSE (Heliocentric Earth Ecliptic)
!               SUBROUTINE GSE_HEE: Coordinate transformation from GSE to HEE (Heliocentric Earth Ecliptic)
!               SUBROUTINE SUN2: Calculate sideral time and position of the SUN
!
!***************************************************************************************************
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HAE (Heliocentric Aries Ecliptic) to HEEQ (Heliocentric Earth Equatorial)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xHAE -> position in HAE system in AU (double array(3))
!
! OUTPUT: xHEEQ -> position in HEEQ system in AU (double array(3))
!
! CALLING SEQUENCE: hae2heeq1(iyr,idoy,secs,xHAE,xHEEQ)
!---------------------------------------------------------------------------------------------------
c
        SUBROUTINE hae2heeq1(iyr,idoy,secs,xHAE,xHEEQ)
c
        IMPLICIT NONE
c
	INTEGER*4 iyr,idoy
	REAL*8    secs
	REAL*8    xHAE(3),xHEEQ(3)
	REAL*8    T0,Lamda0,st,ct,sl,cl,so,co
	 
c
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
C
        CALL SUN2(iyr,idoy,secs, T0,  Lamda0,st,ct,sl,cl,so,co)
        CALL HAE_HEEQ(xHAE,xHEEQ)
       	RETURN
	end
!
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HAE (Heliocentric Aries Ecliptic) to HEEQ (Heliocentric Earth Equatorial)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!              CALL SUN2 before calling HAE_HEEQ
!
! INPUT: HAE -> position in HAE system in AU (double array(3))
!
! OUTPUT: xHEEQ -> position in HEEQ system in AU (double array(3))
!
! CALLING SEQUENCE: HAE_HEEQ(xHAE,xHEEQ)
!---------------------------------------------------------------------------------------------------
	SUBROUTINE HAE_HEEQ(xHAE,xHEEQ)
c
        IMPLICIT NONE
c
	REAL*8 xHAE(3),xHEEQ(3)
	REAL*8 T0,Lamda0,st,ct,sl,cl,so,co
c	
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
c
! c	xHEEQ(1) =  (ct*co-st*cl*so)*xHAE(1) + (ct*so+st*cl*co)*xHAE(2)	!old
! 	xHEEQ(1) =  (co*ct-so*cl*st)*xHAE(1) + (-co*st-so*cl*ct)*xHAE(2)
! c	&              + st*sl*xHAE(3)	!old
!      &              + so*sl*xHAE(3)
! c	xHEEQ(2) = (-st*co-ct*cl*so)*xHAE(1) + (ct*cl*co-st*so)*xHAE(2)	!old
! 	xHEEQ(2) = (so*ct+co*cl*st)*xHAE(1) + (-so*st+co*cl*ct)*xHAE(2)
! c    &              + ct*sl*xHAE(3)	!old
!      &              + co*sl*xHAE(3)
! c      xHEEQ(3) =  sl*so*xHAE(1)            - sl*co*xHAE(2)	!old
!        xHEEQ(3) =  sl*st*xHAE(1)            + sl*ct*xHAE(2)
! c    &              + cl*xHAE(3)	!old
!      &              + cl*xHAE(3)
! c

	xHEEQ(1) =  (co*ct-so*cl*st)*xHAE(1) + (so*ct+co*cl*st)*xHAE(2)
     &              + sl*st*xHAE(3)

	xHEEQ(2) = (-co*st-so*cl*ct)*xHAE(1) + (-so*st+co*cl*ct)*xHAE(2)
     &              + sl*ct*xHAE(3)

       xHEEQ(3) =  so*sl*xHAE(1)            - co*sl*xHAE(2)
     &              + cl*xHAE(3)

 
       	RETURN
	END
C
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HEEQ (Heliocentric Earth Equatorial) to HAE (Heliocentric Aries Ecliptic)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xHEEQ -> position in HEEQ system in AU (double array(3))
!
! OUTPUT: xHAE -> position in HAE system in AU (double array(3))
!
! CALLING SEQUENCE: heeq2hae1(iyr,idoy,secs,xHEEQ,xHAE)
!---------------------------------------------------------------------------------------------------
c
        SUBROUTINE heeq2hae1(iyr,idoy,secs,xHEEQ,xHAE)
c
        IMPLICIT NONE
c
	INTEGER*4 iyr,idoy
	REAL*8    secs
	REAL*8    xHAE(3),xHEEQ(3)
	REAL*8    T0,Lamda0,st,ct,sl,cl,so,co
	
c
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
C
        CALL SUN2(iyr,idoy,secs, T0, Lamda0,st,ct,sl,cl,so,co)
        CALL HEEQ_HAE(xHEEQ,xHAE)
       	RETURN
	end
!
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HEEQ (Heliocentric Earth Equatorial) to HAE (Heliocentric Aries Ecliptic)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!              CALL SUN2 before calling HEEQ_HAE
!
! INPUT: HEEQ -> position in HEEQ system in AU (double array(3))
!
! OUTPUT: xHAE -> position in HAE system in AU (double array(3))
!
! CALLING SEQUENCE: HEEQ_HAE(xHEEQ,xHAE)
!---------------------------------------------------------------------------------------------------
	SUBROUTINE HEEQ_HAE(xHEEQ,xHAE)
c
        IMPLICIT NONE
c
	REAL*8 xHAE(3),xHEEQ(3)
	REAL*8 T0,Lamda0,st,ct,sl,cl,so,co
c	
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
c
	xHAE(1) =  (ct*co-st*cl*so)*xHEEQ(1) + (-st*co-ct*cl*so)*xHEEQ(2)
     &              + so*sl*xHEEQ(3)
	xHAE(2) = (ct*so+st*cl*co)*xHEEQ(1) + (ct*cl*co-st*so)*xHEEQ(2)
     &              - co*sl*xHEEQ(3)
        xHAE(3) =  sl*st*xHEEQ(1)            + sl*ct*xHEEQ(2)           
     &              + cl*xHEEQ(3)
c
       	RETURN
	END
c
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HAE (Heliocentric Aries Ecliptic) to HEE (Heliocentric Earth Ecliptic)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xHAE -> position in HAE system in AU (double array(3))
!
! OUTPUT: xHEE -> position in HEE system in AU (double array(3))
!
! CALLING SEQUENCE: hae2hee1(iyr,idoy,secs,xHAE,xHEE)
!---------------------------------------------------------------------------------------------------
c
        SUBROUTINE hae2hee1(iyr,idoy,secs,xHAE,xHEE)
	INTEGER*4 iyr,idoy
	REAL*8    secs
	REAL*8    xHAE(3),xHEE(3)
	REAL*8    T0,Lamda0,st,ct,sl,cl,so,co
	 
c
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
C
        CALL SUN2(iyr,idoy,secs, T0, Lamda0,st,ct,sl,cl,so,co)
        CALL HAE_HEE(xHAE,xHEE)
       	RETURN
	end
!
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HAE (Heliocentric Aries Ecliptic) to HEE (Heliocentric Earth Ecliptic)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!              CALL SUN2 before calling HAE_HEE
!
! INPUT: HAE -> position in HAE system in AU (double array(3))
!
! OUTPUT: xHEE -> position in HEE system in AU (double array(3))
!
! CALLING SEQUENCE: HAE_HEE(xHAE,xHEE)
!---------------------------------------------------------------------------------------------------
	SUBROUTINE HAE_HEE(xHAE,xHEE)
c
        IMPLICIT NONE
c
	REAL*8 xHAE(3),xHEE(3)
	REAL*8 T0,Lamda0,rad,angle,st,ct,sl,cl,so,co
c	
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
	DATA rad /57.29577951308D0/
c
        !angle=(Lamda0+180.0D0)/rad
        angle=(Lamda0+180)/rad		!Kellerman (this angle is simply a rotation for aries (eq point) to earth sun line (not to ecliptic long of sun as stated, checked with position and output of Lamda0
	xHEE(1) = COS(angle)*xHAE(1) + SIN(angle)*xHAE(2)
	xHEE(2) = -SIN(angle)*xHAE(1) + COS(angle)*xHAE(2) 
        xHEE(3) =  xHAE(3)
c
       	RETURN
	END
C
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HEE (Heliocentric Earth Ecliptic) to HAE (Heliocentric Aries Ecliptic)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xHEE -> position in HEE system in AU (double array(3))
!
! OUTPUT: xHAE -> position in HAE system in AU (double array(3))
!
! CALLING SEQUENCE: hee2hae1(iyr,idoy,secs,xHEE,xHAE)
!---------------------------------------------------------------------------------------------------
c
        SUBROUTINE hee2hae1(iyr,idoy,secs,xHEE,xHAE,TT)
	INTEGER*4 iyr,idoy
	REAL*8    secs
	REAL*8    xHAE(3),xHEE(3)
	REAL*8    T0,Lamda0,st,ct,sl,cl,so,co
c
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
C
        CALL SUN2(iyr,idoy,secs, T0, Lamda0,st,ct,sl,cl,so,co)
        CALL HEE_HAE(xHEE,xHAE)
       	RETURN
	end
!
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HEE (Heliocentric Earth Ecliptic) to HAE (Heliocentric Aries Ecliptic) 
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!              CALL SUN2 before calling HEE_HAE
!
! INPUT: xHEE -> position in HEE system in AU (double array(3))
!
! OUTPUT: xHAE -> position in HAE system in AU (double array(3))
!
! CALLING SEQUENCE: HEE_HAE(xHEE,xHAE)
!---------------------------------------------------------------------------------------------------
	SUBROUTINE HEE_HAE(xHEE,xHAE)
c
        IMPLICIT NONE
c
	REAL*8 xHAE(3),xHEE(3)
	REAL*8 T0,Lamda0,rad,angle,st,ct,sl,cl,so,co, ang
	REAL*8 pi
	 
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co        
	DATA rad /57.29577951308D0/
		pi = ACOS(0.0D0)*2.0D0
		angle=-(Lamda0+180)			!Kellerman
		angle=angle/rad		
	xHAE(1) =  COS(angle)*xHEE(1) + SIN(angle)*xHEE(2)
	xHAE(2) =  -SIN(angle)*xHEE(1) + COS(angle)*xHEE(2)
        xHAE(3) =  xHEE(3)
       	RETURN
	END
C
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from GSE to HEE (Heliocentric Earth Ecliptic)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xGSE -> position in GSE system in Re (double array(3))
!
! OUTPUT: xHEE -> position in HEE system in AU (double array(3))
!
! CALLING SEQUENCE: gse2hee1(iyr,idoy,secs,xGSE,xHEE)
!---------------------------------------------------------------------------------------------------
c
        SUBROUTINE gse2hee1(iyr,idoy,secs,xGSE,xHEE)
	INTEGER*4 iyr,idoy
	REAL*8    secs
	REAL*8    xGSE(3),xHEE(3)
        REAL*8    ERA,AQUAD,BQUAD
	REAL*8    T0,Lamda0,st,ct,sl,cl,so,co
	 
c
        COMMON/GENER/ERA,AQUAD,BQUAD
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
C
        CALL INITIZE
	do i=1,3
	   xGSE(i)=xGSE(i)*ERA
	enddo
        CALL SUN2(iyr,idoy,secs, T0, Lamda0,st,ct,sl,cl,so,co)
        CALL GSE_HEE(xGSE,xHEE)
	do i=1,3
	   xHEE(i)=xHEE(i)/1.495985D8
	enddo		
	end
!
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from HEE to GSE (Heliocentric Earth Ecliptic)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!        xHEE -> position in HEE system in AU (double array(3))
!
! OUTPUT: xGSE -> position in GSE system in Re (double array(3))
!
! CALLING SEQUENCE: hee2gse1(iyr,idoy,secs,xHEE,xGSE)
!---------------------------------------------------------------------------------------------------
c
        SUBROUTINE hee2gse1(iyr,idoy,secs,xHEE,xGSE)
	INTEGER*4 iyr,idoy
	REAL*8    secs
	REAL*8    xGSE(3),xHEE(3)
        REAL*8    ERA,AQUAD,BQUAD
	REAL*8    T0,Lamda0,st,ct,sl,cl,so,co
	 
c
        COMMON/GENER/ERA,AQUAD,BQUAD
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
C
	do i=1,3
	   xHEE(i)=xHEE(i)*1.495985D8
	enddo
        CALL SUN2(iyr,idoy,secs, T0, Lamda0,st,ct,sl,cl,so,co)
        CALL GSE_HEE(xHEE,xGSE)
        CALL INITIZE
	do i=1,3
	   xGSE(i)=xGSE(i)/ERA
	enddo
	end
!
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Coordinate transformation from GSE to HEE (Heliocentric Earth Ecliptic)
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!              CALL SUN2 before calling GSE_HEE
!
! INPUT: xGSE -> position in GSE system in km (double array(3))
!
! OUTPUT: xHEE -> position in HEE system in km (double array(3))
!
! CALLING SEQUENCE: GSE_HEE(xGSE,xHEE)
!---------------------------------------------------------------------------------------------------
	SUBROUTINE GSE_HEE(xGSE,xHEE)
c
        IMPLICIT NONE
c
	REAL*8 xGSE(3),xHEE(3)
	REAL*8 T0,Lamda0,rad,st,ct,sl,cl,so,co
	REAL*8 r0,e,nu
	
c	
        COMMON /sunMAH/T0,Lamda0,st,ct,sl,cl,so,co
	DATA rad /57.29577951308D0/
C
c
        r0=1.495985D8   !km 1AU
	e=0.016709D0-0.0000418D0*T0
	nu=(Lamda0-282.94D0-1.72D0*T0)/rad
c
	xHEE(1) =  -xGSE(1) + r0*(1.D0-e*e)/(1.D0+e*COS(nu))
	xHEE(2) = - xGSE(2)
        xHEE(3) =  xGSE(3)
c
        
	RETURN
	END
C
!---------------------------------------------------------------------------------------------------
!                              Introduced in version 3.0
!
! CREATION: S. Bourdarie - May 2006
! MODIFICATION: None
!
! DESCRIPTION: Calculate sideral time and position of the SUN
!              From M.A. Hapgood, Space physics coordinate transformations: a user guide
!              Planet. Space Sci., Vol 40, pp 711-717, 1992
!
! INPUT: iyr -> year (long integer)
!        idoy -> day of year (long integer)
!        secs -> UT in seconds (double)
!
! OUTPUT: T0 -> Time in Julian centuries (36525 days) from 12:00 UT on 1st January 2000 (double)
!         Lamda0 -> The Sun's ecliptic longitude in deg. (double)
!
! CALLING SEQUENCE: SUN2(iyr,idoy,secs,T0,Lamda0)
!---------------------------------------------------------------------------------------------------
	SUBROUTINE SUN2(iyr,idoy,secs,T0, Lamda0,st,ct,sl,cl,so,co)
C
	IMPLICIT NONE
C
C program to calculate sideral, time and position of the Sun
C good for years 1901 through 2099. accuracy 0.006 degree
c
c From M.A. Hapgood, Space physics coordinate transformations: a user guide
c Planet. Space Sci., Vol 40, pp 711-717, 1992
c last change A. C. Kellerman 18/02/2016
c added epoch 2000 functionality and corrected errors in the Hapgood
c formulae, i.e. hours input and errors with deg -> sin,tan functions
C
	REAL*8 QCDFTDB
	INTEGER*4 JULDAY
	INTEGER*4 iyr,idoy, dom, MJD, NST, j
	INTEGER*4    month, day, hour, mt, sc
	REAL*8 secs, T0, TT, dj, dlm, varpi, ggeo, lgeo, rgeo, lon
	REAL*8 M,Lamda,Lamda0,rad,aberr
	REAL*8 omega,l,theta,st,ct,sl,cl,so,co, londif
	REAL*8 dpi, dpi2
	 
	dpi = ACOS(0.0d0)*2.0D0
	dpi2 = 2.0D0*dpi
C
	DATA rad /57.29577951308D0/ !180 /pi
c
	IF (iyr.LT.1901 .OR. iyr.GT.2099) RETURN
C
!         dom=1
! 		month=1
!        MJD=JULDAY(month,dom,iyr)+(idoy-1)-2400001 !2400001=julday(11,17,1858)    old

	CALL DOY_AND_UT2DATE_AND_TIME(iyr,idoy,secs,month,day,hour,mt,sc)  
	TT=QCDFTDB(iyr,month,day,hour,mt,sc,0)
	!T0=(MJD-51544.5D0)/36525.0D0   !equation (3)
	
	T0=TT*1d0/(8.64d6*365.25d0)
	dj=T0*36525d0	
! 	M=357.528D0+35999.05D0*T0+0.04107D0*secs ! this is incorrect 
        !the equation is based on hours (AKellerman ref. Hapgood '92)
! 	Lamda=280.46D0+36000.772D0*T0+0.04107D0*secs	! as above
! 	Lamda0=Lamda+(1.915D0-0.0048D0*T0)*SIN(M/rad)+0.02D0*SIN(2.D0*M/rad)  !equation (5)


	dlm= ((100.4664568d0)+(mod (35999.3728565d0*T0, 360.0d0)))/rad
	varpi=((102.9373481d0)+(0.3225654d0*T0))/rad
	ggeo=dlm-varpi
	lgeo=dlm+(1.915d0*SIN(ggeo)+0.02d0*SIN(2.0d0*ggeo))/rad
	rgeo=(1.00014d0)-0.01617d0*COS(ggeo)-0.00014d0*COS(2.0d0*ggeo)
	lon=lgeo+dpi
	omega=((75.76d0)+1.397d0*T0)/rad
	l=7.25d0/rad

	aberr=20.0d0/3600.0d0/rad
	londif=mod (lon-aberr-omega, dpi2)
  
	Lamda0 = lon*rad
	
! 	omega=(73.6667D0+0.013958D0*(MJD+3242.0D0)/365.25D0)/rad
! 	l=7.25D0/rad
! 	londif=Lamda0/rad-omega
! 	londif=mod (londif, dpi2)					
	IF (londif.gt.dpi) londif=londif-dpi2		
	IF (londif.lt.-dpi) londif=londif+dpi2		
	
	theta=ATAN(COS(l)*TAN(londif))

	IF (theta.gt.dpi) theta=theta-dpi2		!Kellerman
	IF (theta.lt.-dpi) theta=theta+dpi2		!Kellerman

	IF (abs(theta-londif).lt.dpi/2.0D0) theta=theta+dpi			!Kellerman
	!WRITE(*,'((f15.5), i4, 2(f15.5))') Lamda0, idoy, theta*rad, omega*rad

	st=SIN(theta)
	ct=COS(theta)
	sl=SIN(l)
	cl=COS(l)
	so=SIN(omega)
	CO=COS(omega)	
        RETURN
        END
C

c
c --------------------------------------------------------------------
c
        SUBROUTINE geo2dmag1(iyr,xGEO,xDMAG)
	    INTEGER*4 iyr
	    REAL*8    dyear
	    REAL*8    xGEO(3),xDMAG(3)

	    dyear=iyr+0.5d0
        CALL INIT_DTD(dyear)
        CALL GEO_DMAG(xGEO,xDMAG)
        end

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
       SUBROUTINE GEO_DMAG(xGEO,xDMAG)
C
       IMPLICIT NONE
C
       REAL*8    xGEO(3)
       REAL*8    xGEO_DEC(3)
       REAL*8    xDMAG(3)
       REAL*8    xc,yc,zc                  !Re
       REAL*8    ct,st,cp,sp
       REAL*8    Bo
C
       COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
C
       xGEO_DEC(1)= xGEO(1) - xc
       xGEO_DEC(2)= xGEO(2) - yc
       xGEO_DEC(3)= xGEO(3) - zc
C
       xDMAG(1) =  xGEO_DEC(1)*ct*cp + xGEO_DEC(2)*ct*sp
     & - xGEO_DEC(3)*st
       xDMAG(2) = -xGEO_DEC(1)*sp    + xGEO_DEC(2)*cp
       xDMAG(3) =  xGEO_DEC(1)*st*cp + xGEO_DEC(2)*st*sp
     & + xGEO_DEC(3)*ct
C
       RETURN
       END
C

!***************************************************************************************************
! Copyright 2004 D. Vallado
!
! This file is part of IRBEM-LIB.
!
!    IRBEM-LIB is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Lesser General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    IRBEM-LIB is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public License
!    along with IRBEM-LIB.  If not, see <http://www.gnu.org/licenses/>.
!
*     ----------------------------------------------------------------
*
*                               sgp4ext.for
*
*    this file contains extra routines needed for the main test program for sgp4.
*    gst calcualtions are also included. these routines are derived from the astro
*    libraries.
*
*                            companion code for
*               fundamentals of astrodynamics and applications
*                                    2004
*                              by david vallado
*
*       (w) 719-573-2600, email dvallado@agi.com
*
*    current :
*              14 aug 06  david vallado
*                           separate from ast libraries
*    changes :
*              14 aug 06  david vallado
*                           original baseline
*       ----------------------------------------------------------------



* ------------------------------------------------------------------------------
*
*                           SUBROUTINE MAG
*
*  This SUBROUTINE finds the magnitude of a vector.  The tolerance is set to
*    0.00000001D0, thus the 1.0D0E-16 for the squared test of underflows.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    Vec       - Vector
*
*  OutPuts       :
*    Vec       - Answer stored in fourth component
*
*  Locals        :
*    None.
*
*  Coupling      :
*    None.
*
* ------------------------------------------------------------------------------  

      REAL*8 FUNCTION MAG    ( Vec )
        IMPLICIT NONE
        REAL*8 Vec(3)
* -----------------------------  Locals  ------------------------------
        Real*8 Temp

        ! --------------------  Implementation   ----------------------
        Temp= Vec(1)*Vec(1) + Vec(2)*Vec(2) + Vec(3)*Vec(3)

        IF ( DABS( Temp ) .ge. 1.0D-16 ) THEN
            MAG = DSQRT( Temp )
          ELSE
            MAG = 0.0D0
          ENDIF
      RETURN
      END  ! end mag


* ------------------------------------------------------------------------------
*
*                           SUBROUTINE CROSS
*
*  This SUBROUTINE crosses two vectors.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    Vec1        - Vector number 1
*    Vec2        - Vector number 2
*
*  OutPuts       :
*    OutVec      - Vector result of A x B
*
*  Locals        :
*    None.
*
*  Coupling      :
*
*
* ------------------------------------------------------------------------------  

      SUBROUTINE CROSS       ( Vec1,Vec2, OutVec )
        IMPLICIT NONE
        REAL*8 Vec1(3), Vec2(3), OutVec(3)

        ! --------------------  Implementation   ----------------------
        OutVec(1)= Vec1(2)*Vec2(3) - Vec1(3)*Vec2(2)
        OutVec(2)= Vec1(3)*Vec2(1) - Vec1(1)*Vec2(3)
        OutVec(3)= Vec1(1)*Vec2(2) - Vec1(2)*Vec2(1)

      RETURN
      END  ! end cross


* ------------------------------------------------------------------------------
*
*                           FUNCTION DOT
*
*  This FUNCTION finds the DOT product of two vectors.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    Vec1        - Vector number 1
*    Vec2        - Vector number 2
*
*  OutPuts       :
*    DOT         - Result
*
*  Locals        :
*    None.
*
*  Coupling      :
*    None.
*
* ------------------------------------------------------------------------------  

      REAL*8 FUNCTION DOT    ( Vec1,Vec2 )
        IMPLICIT NONE
        REAL*8 Vec1(3), Vec2(3)

        ! --------------------  Implementation   ----------------------
        DOT= Vec1(1)*Vec2(1) + Vec1(2)*Vec2(2) + Vec1(3)*Vec2(3)
      RETURN
      END  ! end dot


* ------------------------------------------------------------------------------
*
*                           SUBROUTINE ANGLE
*
*  This SUBROUTINE calculates the ANGLE between two vectors.  The output is
*    set to 999999.1D0 to indicate an undefined value.  Be SURE to check  
*    this at the output phase.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    Vec1        - Vector number 1
*    Vec2        - Vector number 2
*
*  OutPuts       :
*    Theta       - ANGLE between the two vectors  -Pi to Pi
*
*  Locals        :
*    Temp        - Temporary REAL variable
*
*  Coupling      :
*    DOT           DOT Product of two vectors
*    DACOS        Arc Cosine FUNCTION
*
* ------------------------------------------------------------------------------  

      SUBROUTINE ANGLE       ( Vec1,Vec2, Theta )
        IMPLICIT NONE
        REAL*8 Vec1(3), Vec2(3), Theta, magvec1, magvec2
        EXTERNAL Dot, Mag
* -----------------------------  Locals  ------------------------------
        REAL*8 Temp, Dot, Mag
        INCLUDE 'astmath.cmn'

        ! --------------------  Implementation   ----------------------
        magvec1 = MAG(vec1)
        magvec2 = MAG(vec2)
        IF ( magVec1*magVec2 .gt. Small**2 ) THEN
            Temp= DOT(Vec1,Vec2) / (magVec1*magVec2)
            IF ( DABS( Temp ) .gt. 1.0D0 ) THEN
                Temp= DSIGN(1.0D0, Temp)
              ENDIF
            Theta= DACOS( Temp ) 
          ELSE
            Theta= Undefined
          ENDIF
      RETURN
      END  ! end angle


* ------------------------------------------------------------------------------
*
*                           FUNCTION ASINH
*
*  This FUNCTION evaluates the inverse hyperbolic sine FUNCTION.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    XVal        - ANGLE Value                                  any real
*
*  OutPuts       :
*    ASINH     - Result                                       any real
*
*  Locals        :
*    None.
*
*  Coupling      :
*    None.
*
* ------------------------------------------------------------------------------  

      REAL*8 FUNCTION ASINH( XVal )
        IMPLICIT NONE
        REAL*8 XVal

        ! --------------------  Implementation   ----------------------
        ASINH= DLOG( XVal + DSQRT( XVal*XVal + 1.0D0 ) )

      RETURN
      END  ! end asinh


* ------------------------------------------------------------------------------
*
*                           SUBROUTINE NEWTONNU
*
*  This SUBROUTINE solvoes Keplers equation when the true anomaly is known.
*    The Mean and Eccentric, parabolic, or hyperbolic anomaly is also found.
*    The parabolic limit at 168° is arbitrary. The hyperbolic anomaly is also
*    limited. The hyperbolic sine is used because it's not double valued.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    Ecc         - Eccentricity                   0.0D0 to
*    Nu          - True Anomaly                   -2Pi to 2Pi rad
*
*  Outputs       :
*    E0          - Eccentric Anomaly              0.0D0 to 2Pi rad       153.02D0°
*    M           - Mean Anomaly                   0.0D0 to 2Pi rad       151.7425D0°
*
*  Locals        :
*    E1          - Eccentric Anomaly, next value  rad
*    SinE        - Sine of E
*    CosE        - Cosine of E
*    Ktr         - Index
*
*  Coupling      :
*    ASINH     - Arc hyperbolic sine
*    SINH        - Hyperbolic Sine
*
*  References    :
*    Vallado       2001, 85, Alg 5
*
* ------------------------------------------------------------------------------

      SUBROUTINE NEWTONNU    ( Ecc, Nu, E0, M )
        IMPLICIT NONE
        REAL*8 Ecc, Nu, E0, M
        EXTERNAL ASINH
* -----------------------------  Locals  ------------------------------
        REAL*8 SinE, CosE, ASINH

        INCLUDE 'astmath.cmn'

        ! --------------------  Implementation   ----------------------
        E0= 999999.9D0
        M = 999999.9D0
        ! --------------------------- Circular ------------------------
        IF ( DABS( Ecc ) .lt. 0.000001D0 ) THEN
            M = Nu
            E0= Nu 
          ELSE
            ! ---------------------- Elliptical -----------------------
            IF ( Ecc .lt. 0.999D0 ) THEN
                SinE= ( DSQRT( 1.0D0-Ecc*Ecc ) * DSIN(Nu) ) /
     &                ( 1.0D0+Ecc*DCOS(Nu) )
                CosE= ( Ecc + DCOS(Nu) ) / ( 1.0D0 + Ecc*DCOS(Nu) )
                E0  = DATAN2( SinE, CosE )
                M   = E0 - Ecc*DSIN(E0) 
              ELSE
                ! -------------------- Hyperbolic  --------------------
                IF ( Ecc .gt. 1.0001D0 ) THEN
                    IF ( ((Ecc .gt. 1.0D0) .and. (DABS(Nu)+0.00001D0
     &                     .lt. Pi-DACOS(1.0D0/Ecc)) ) ) THEN
                        SinE= ( DSQRT( Ecc*Ecc-1.0D0 ) * DSIN(Nu) ) /
     &                        ( 1.0D0 + Ecc*DCOS(Nu) )
                        E0  = ASINH( SinE )
                        M   = Ecc*DSINH(E0) - E0
                      ENDIF 
                  ELSE
                    ! ----------------- Parabolic ---------------------
                    IF ( DABS(Nu) .lt. 168.0D0/57.29578D0 ) THEN
                        E0= DTAN( Nu*0.5D0 )
                        M = E0 + (E0*E0*E0)/3.0D0 
                      ENDIF
                  ENDIF
              ENDIF
          ENDIF

        IF ( Ecc .lt. 1.0D0 ) THEN
            M = DMOD( M, 2.0D0*Pi )
            IF ( M .lt. 0.0D0 ) THEN
                M= M + 2.0D0*Pi 
              ENDIF
            E0 = DMOD( E0, 2.0D0*Pi )
          ENDIF 
      RETURN
      END  ! end newtonnu


* ------------------------------------------------------------------------------
*
*                           SUBROUTINE rv2coe
*
*  This SUBROUTINE finds the classical orbital elements given the Geocentric
*    Equatorial Position and Velocity vectors.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    R           - IJK Position vector            km
*    V           - IJK Velocity vector            km / s
*
*  Outputs       :
*    P           - SemiLatus rectum               km
*    A           - semimajor axis                 km
*    Ecc         - Eccentricity
*    Incl        - inclination                    0.0D0 to Pi rad
*    Omaga       - Longitude of Ascending Node    0.0D0 to 2Pi rad
*    Argp        - Argument of Perigee            0.0D0 to 2Pi rad
*    Nu          - True anomaly                   0.0D0 to 2Pi rad
*    M           - Mean anomaly                   0.0D0 to 2Pi rad
*    ArgLat      - Argument of Latitude      (CI) 0.0D0 to 2Pi rad
*    LamTrue     - True Longitude            (CE) 0.0D0 to 2Pi rad
*    LonPer      - Longitude of Periapsis    (EE) 0.0D0 to 2Pi rad
*
*  Locals        :
*    HBar        - Angular Momentum H Vector      km2 / s
*    EBar        - Eccentricity     E Vector
*    NBar        - Line of Nodes    N Vector
*    c1          - V**2 - u/R
*    RDotV       - R DOT V
*    Hk          - Hk norm vector
*    SME         - Specfic Mechanical Energy      km2 / s2
*    i           - index
*    E           - Eccentric, Parabolic,
*                  Hyperbolic Anomaly             rad
*    Temp        - Temporary variable
*    TypeOrbit   - Type of orbit                  EE, EI, CE, CI
*
*  Coupling      :
*    MAG         - Magnitude of a vector
*    CROSS       - CROSS product of two vectors
*    DOT         - DOT product of two vectors
*    ANGLE       - Find the ANGLE between two vectors
*    NEWTONNU    - Find the mean anomaly
*
*  References    :
*    Vallado       2001, 118-122, Alg 9, Ex 2-5
*
* ------------------------------------------------------------------------------

      SUBROUTINE rv2coe      ( R, V, P, A, Ecc, Incl, Omega, Argp, Nu,
     &                         M, ArgLat, TrueLon, LonPer )
        IMPLICIT NONE
        REAL*8 R(3), V(3), P, A, Ecc, Incl, Omega, Argp, Nu, M, ArgLat,
     &         TrueLon, LonPer
        EXTERNAL DOT, MAG
* -----------------------------  Locals  ------------------------------
        REAL*8 c1, RDotV, hk, SME, Hbar(3), Ebar(3), Nbar(3),
     &         Dot, E, Temp, MAG, maghbar, magnbar, magr, magv
        INTEGER*4 i
        CHARACTER*2 TypeOrbit

        INCLUDE 'astmath.cmn'
        INCLUDE 'astconst.cmn'

        ! --------------------  Implementation   ----------------------
        magr = MAG( R )
        magv = MAG( V )
        ! ------------------  Find H N and E vectors   ----------------
        CALL CROSS( R, V, HBar )
        maghbar = MAG(Hbar)
        IF ( maghbar .gt. Small ) THEN
            NBar(1)= -HBar(2)
            NBar(2)=  HBar(1)
            NBar(3)=   0.0D0
            magnbar = MAG( Nbar )
            c1 = magv**2 - mu/magr
            RDotV= DOT( R, V )
            DO i= 1 , 3
                EBar(i)= (c1*R(i) - RDotV*V(i))/mu
              ENDDO

            Ecc = MAG( EBar )

            ! ------------  Find a e and semi-Latus rectum   ----------
            SME= ( magv*magv*0.5D0 ) - ( mu/magr )
            IF ( DABS( SME ) .gt. Small ) THEN
                A= -mu / (2.0D0*SME)
              ELSE
                A= Infinite
              ENDIF
            P = maghbar*maghbar/mu

            ! -----------------  Find inclination   -------------------
            Hk= HBar(3)/maghbar
c            IF ( DABS( DABS(Hk) - 1.0D0 ) .lt. Small ) THEN
c                ! -------------  Equatorial Orbits   ------------------
c                IF ( DABS(HBar(3)) .gt. 0.0D0 ) THEN
c                    Hk= DSIGN(1.0D0, HBar(3))
c                  ENDIF
c              ENDIF
            Incl= DACOS( Hk ) 

            ! --------  Determine type of orbit for Later use  --------
            ! ------ Elliptical, Parabolic, Hyperbolic Inclined -------
            TypeOrbit= 'EI' 
            IF ( Ecc .lt. Small ) THEN
                ! ----------------  Circular Equatorial ---------------
                IF ( (Incl.lt.Small).or.(DABS(Incl-Pi).lt.Small) ) THEN
                    TypeOrbit= 'CE'
                  ELSE
                    ! --------------  Circular Inclined ---------------
                    TypeOrbit= 'CI'
                  ENDIF
              ELSE
                ! - Elliptical, Parabolic, Hyperbolic Equatorial --
                IF ( (Incl.lt.Small).or.(DABS(Incl-Pi).lt.Small) ) THEN
                    TypeOrbit= 'EE'
                  ENDIF
              ENDIF

            ! ----------  Find Longitude of Ascending Node ------------
            IF ( magnbar .gt. Small ) THEN
                Temp= NBar(1) / magnbar
                IF ( DABS(Temp) .gt. 1.0D0 ) THEN
                    Temp= DSIGN(1.0D0, Temp)
                  ENDIF
                Omega= DACOS( Temp ) 
                IF ( NBar(2) .lt. 0.0D0 ) THEN
                    Omega= TwoPi - Omega
                  ENDIF
              ELSE
                Omega= Undefined 
              ENDIF

            ! ---------------- Find Argument of perigee ---------------
            IF ( TypeOrbit .eq. 'EI' ) THEN
                CALL ANGLE( NBar, EBar, Argp )
                IF ( EBar(3) .lt. 0.0D0 ) THEN
                    Argp= TwoPi - Argp 
                  ENDIF
              ELSE
                Argp= Undefined 
              ENDIF

            ! ------------  Find True Anomaly at Epoch    -------------
            IF ( TypeOrbit(1:1) .eq. 'E' ) THEN
                CALL ANGLE( EBar, r, Nu )
                IF ( RDotV .lt. 0.0D0 ) THEN
                    Nu= TwoPi - Nu 
                  ENDIF
              ELSE
                Nu= Undefined 
              ENDIF

            ! ----  Find Argument of Latitude - Circular Inclined -----
            IF ( TypeOrbit .eq. 'CI' ) THEN
                CALL ANGLE( NBar, R, ArgLat )
                IF ( R(3) .lt. 0.0D0 ) THEN
                    ArgLat= TwoPi - ArgLat
                  ENDIF
              ELSE
                ArgLat= Undefined 
              ENDIF

            ! -- Find Longitude of Perigee - Elliptical Equatorial ----
            IF ( ( Ecc.gt.Small ) .and. (TypeOrbit.eq.'EE') ) THEN
                Temp= EBar(1)/Ecc
                IF ( DABS(Temp) .gt. 1.0D0 ) THEN
                    Temp= DSIGN(1.0D0, Temp)
                  ENDIF
                LonPer= DACOS( Temp ) 
                IF ( EBar(2) .lt. 0.0D0 ) THEN
                    LonPer= TwoPi - LonPer 
                  ENDIF
                IF ( Incl .gt. HalfPi ) THEN
                    LonPer= TwoPi - LonPer
                  ENDIF
              ELSE
                LonPer= Undefined
              ENDIF

            ! -------- Find True Longitude - Circular Equatorial ------
            IF ( ( magr.gt.Small ) .and. ( TypeOrbit.eq.'CE' ) ) THEN
                Temp= R(1)/magr
                IF ( DABS(Temp) .gt. 1.0D0 ) THEN
                    Temp= DSIGN(1.0D0, Temp)
                  ENDIF
                TrueLon= DACOS( Temp )
                IF ( R(2) .lt. 0.0D0 ) THEN
                    TrueLon= TwoPi - TrueLon
                  ENDIF
                IF ( Incl .gt. HalfPi ) THEN
                    TrueLon= TwoPi - TrueLon
                  ENDIF
              ELSE
                TrueLon= Undefined
              ENDIF

            ! ------------ Find Mean Anomaly for all orbits -----------
            CALL NEWTONNU(Ecc, Nu, E, M )

         ELSE
           P    = Undefined
           A    = Undefined
           Ecc  = Undefined
           Incl = Undefined
           Omega= Undefined 
           Argp = Undefined 
           Nu   = Undefined 
           M    = Undefined 
           ArgLat  = Undefined 
           TrueLon= Undefined 
           LonPer = Undefined 
         ENDIF 

      RETURN
      END  ! end rv2coe


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE JDay
*
*  This SUBROUTINE finds the Julian date given the Year, Month, Day, and Time.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    Year        - Year                           1900 .. 2100
*    Mon         - Month                          1 .. 12
*    Day         - Day                            1 .. 28,29,30,31
*    Hr          - Universal Time Hour            0 .. 23
*    Min         - Universal Time Min             0 .. 59
*    Sec         - Universal Time Sec             0.0D0 .. 59.999D0
*    WhichType   - Julian .or. Gregorian calender   'J' .or. 'G'
*
*  Outputs       :
*    JD          - Julian Date                    days from 4713 BC
*
*  Locals        :
*    B           - Var to aid Gregorian dates
*
*  Coupling      :
*    None.
*
*  References    :
*    Vallado       2004, 186-188, Alg 14, Ex 3-14
* -----------------------------------------------------------------------------

      SUBROUTINE JDay        ( Year,Mon,Day,Hr,Min, Sec, JD )
        IMPLICIT NONE
        INTEGER*4 Year, Mon, Day, Hr, Min
        REAL*8  Sec, JD

        ! --------------------  Implementation   ----------------------
        JD= 367.0D0 * Year
     &        - INT( (7* (Year+INT ( (Mon+9)/12) ) ) * 0.25D0 )
     &        + INT( 275*Mon / 9 )
     &        + Day + 1721013.5D0
     &        + ( (Sec/60.0D0 + Min ) / 60.0D0 + Hr ) / 24.0D0
*     &      - 0.5D0*DSIGN(1.0D0, 100.0D0*Year + Mon - 190002.5D0) + 0.5D0
      RETURN
      END  ! end jday


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE DAYS2MDHMS
*
*  This SUBROUTINE converts the day of the year, days, to the equivalent month
*    day, hour, Minute and second.
*
*  Algorithm     : Set up array for the Number of days per month
*                  Find Leap Year - be sure to account for the 400 years
*                  Loop through a Temp value for WHILE the value is .lt. the days
*                  Perform INTEGER*4 conversions to the correct day and month
*                  Convert remainder into H M S using type conversions
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    Year        - Year                          +1900 .. 2100+
*    Days        - Julian Day of the year         0.0D0  .. 366.0D0
*
*  OutPuts       :
*    Mon         - Month                          1 .. 12
*    Day         - Day                            1 .. 28,29,30,31
*    Hr          - Hour                           0 .. 23
*    Min         - Minute                         0 .. 59
*    Sec         - Second                         0.0D0 .. 59.999D0
*
*  Locals        :
*    DayofYr     - Day of year
*    Temp        - Temporary REAL*8 values
*    IntTemp     - Temporary INTEGER*4 value
*    i           - Index
*    LMonth[12]  - INTEGER*4 Array containing the Number of days per month
*
*  Coupling      :
*    None.
* -----------------------------------------------------------------------------

      SUBROUTINE DAYS2MDHMS  ( Year,Days,  Mon,Day,Hr,Min,Sec )
        IMPLICIT NONE
        REAL*8 Days,Sec
        INTEGER*4 Year, Mon, Day, Hr, Min
* ----------------------------  Locals  -------------------------------
        INTEGER*4 IntTemp,i,DayofYr, LMonth(12)
        REAL*8 Temp

        ! --------------------  Implementation   ----------------------
        ! -------------- Set up array of days in month  ---------------
        DO i = 1,12
            LMonth(i) = 31
          ENDDO
        LMonth( 2) = 28
        LMonth( 4) = 30
        LMonth( 6) = 30
        LMonth( 9) = 30
        LMonth(11) = 30

        DayofYr= IDINT(Days )

        ! ---------------- Find month and Day of month ----------------
        IF (MOD(Year,4).eq.0) THEN
            LMonth(2)= 29
          ENDIF
        i= 1
        IntTemp= 0
        DO WHILE ( (DayofYr.gt.IntTemp + LMonth(i) ) .and. ( i.lt.12 ))
            IntTemp= IntTemp + LMonth(i)
            i= i+1
          ENDDO
        Mon= i
        Day= DayofYr - IntTemp

        ! ---------------- Find hours Minutes and seconds -------------
        Temp= (Days - DayofYr )*24.0D0
        Hr  = IDINT( Temp )
        Temp= (Temp-Hr) * 60.0D0
        Min = IDINT( Temp )
        Sec = (Temp-Min) * 60.0D0

        ! ---- Check for roundoff errors
c        IF (Sec .ge. 59.9999D0) THEN
c            Sec = 0.0D0
c            Min = Min + 1
c            IF (Min .gt. 59) THEN
c                Min = 0
c                Hr = Hr + 1
c                IF (Hr .gt. 23) THEN
c                    Hr = 0
c                    Day = Day + 1
c                  ENDIF
c              ENDIF
c          ENDIF
      RETURN
      END  ! end days2mdhms


* -----------------------------------------------------------------------------
*
*                           SUBROUTINE INVJDay
*
*  This SUBROUTINE finds the Year, month, day, hour, Minute and second
*  given the Julian date. TU can be UT1, TDT, TDB, etc.
*
*  Author        : David Vallado                  719-573-2600    1 Mar 2001
*
*  Inputs          Description                    Range / Units
*    JD          - Julian Date                    days from 4713 BC
*
*  OutPuts       :
*    Year        - Year                           1900 .. 2100
*    Mon         - Month                          1 .. 12
*    Day         - Day                            1 .. 28,29,30,31
*    Hr          - Hour                           0 .. 23
*    Min         - Minute                         0 .. 59
*    Sec         - Second                         0.0D0 .. 59.999D0
*
*  Locals        :
*    Days        - Day of year plus fractional
*                  portion of a day               days
*    Tu          - Julian Centuries from 0 h
*                  Jan 0, 1900
*    Temp        - Temporary real values
*    LeapYrs     - Number of Leap years from 1900
*
*  Coupling      :
*    DAYS2MDHMS  - Finds MD HMS given Days and Year
*
*  References    :
*    Vallado       2004, 203-205, Alg 22, Ex 3-13
* -----------------------------------------------------------------------------

      SUBROUTINE INVJDay     ( JD, Year,Mon,Day,Hr,Min, Sec )
        IMPLICIT NONE
        INTEGER*4 Year, Mon, Day, Hr, Min
        REAL*8  Sec, JD
* ----------------------------  Locals  -------------------------------
        INTEGER*4 LeapYrs
        REAL*8  Days, Tu, Temp

        ! --------------------  Implementation   ----------------------
        ! ---------------- Find Year and Days of the year -------------
        Temp   = JD-2415019.5D0
        Tu     = Temp / 365.25D0
        Year   = 1900 + IDINT( Tu )
        LeapYrs= IDINT( ( Year-1901 )*0.25D0 )
        Days   = Temp - ((Year-1900)*365.0D0 + LeapYrs )

        ! -------------- Check for case of beginning of a year --------
        IF ( Days .lt. 1.0D0 ) THEN
            Year   = Year - 1
            LeapYrs= IDINT( ( Year-1901 )*0.25D0 )
            Days   = Temp - ((Year-1900)*365.0D0 + LeapYrs )
          ENDIF

        ! ------------------ Find remaing data  -----------------------
        CALL DAYS2MDHMS( Year,Days, Mon,Day,Hr,Min,Sec )

      RETURN
      END

      subroutine myOwnMagField(X,B)
C     User-defined B-field, must pass to/from GEO coordinates
C     This field model is a centred dipole plus a uniform,
C     southward B of 14.474nT [see Chen, Schulz, et al., JGR 1993]
C
       IMPLICIT NONE
C
       REAL*8 x(3)
       REAL*8 B(3)
       REAL*8 Bo
       REAL*8 pi,rad
       REAL*8 rr,tt,pp,Br,Bt,Bp,BxGEO,ByGEO,BzGEO
       common /rconst/rad,pi
C      COMMON /dipigrf/Bo,xc,yc,zc,ct,st,cp,sp
C Uncomment the above line to use the dipole moment
C from the appropriate epoch, otherwise, use the below line
       Bo = 3.05D4
C
       rr = SQRT(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
       tt = ACOS(x(3)/rr)
       pp = ATAN2(x(2),x(1))
C
       Br = -2.D0*Bo*COS(tt)/(rr*rr*rr)
       Bt = -   Bo*SIN(tt)/(rr*rr*rr)
       Bp = 0.D0
C
       BxGEO = Br*SIN(tt)*COS(pp)
     &          + Bt*COS(tt)*COS(pp)
     &          - Bp*SIN(pp)
       ByGEO = Br*SIN(tt)*SIN(pp)
     &          + Bt*COS(tt)*SIN(pp)
     &          + Bp*COS(pp)
       BzGEO = Br*COS(tt) - Bt*SIN(tt) - 14.74
C
       B(1) = BxGEO
       B(2) = ByGEO
       B(3) = BzGEO 
       
       RETURN
       END
